// TJC implementation of procedure compileproc_can_inline_container
package tjc;
import tcl.lang.*;

public class CompileprocCanInlineContainerCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 7, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: global _compileproc _compileproc_ckeys
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 1);
            TJC.makeGlobalLinkVar(interp, "_compileproc_ckeys", "_compileproc_ckeys", 2);
        } // End Invoke: global
        { // Invoke: if ... ...
            // Binary operator: $_compileproc(...) == ""
            TclObject tmp0 = getVarArray(interp, "_compileproc", "options,inline_containers", compiledLocals, 1);
            ExprValue tmp1 = evs0;
            TJC.exprEqualsEmptyString(tmp1, tmp0, false);
            // End Binary operator: ==
            boolean tmp2 = ( tmp1.getIntValue() != 0 );
            if ( tmp2 ) {
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const0);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            // Unary operator: ! [...]
            { // Invoke: info exists "..."
                TclObject[] objv3 = TJC.grabObjv(interp, 3);
                TclObject tmp4;
                try {
                    // Arg 0 constant: info
                    objv3[0] = const1;
                    // Arg 1 constant: exists
                    objv3[1] = const2;
                    // Arg 2 word: "..."
                    StringBuffer sbtmp5 = new StringBuffer(64);
                    sbtmp5.append("_compileproc_ckeys(");
                    tmp4 = getVarScalar(interp, "key", compiledLocals, 0);
                    sbtmp5.append(tmp4.toString());
                    sbtmp5.append(",info_key)");
                    tmp4 = TclString.newInstance(sbtmp5);
                    tmp4.preserve();
                    objv3[2] = tmp4;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv3, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp4 = objv3[2];
                    if ( tmp4 != null ) {
                        tmp4.release();
                    }
                    TJC.releaseObjv(interp, objv3, 3);
                }
            } // End Invoke: info
            TclObject tmp6 = interp.getResult();
            ExprValue tmp7 = evs0;
            if ( tmp6.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp7, tmp6);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp7, tmp6);
            }
            // End Unary operator: !
            boolean tmp8 = ( tmp7.getIntValue() != 0 );
            if ( tmp8 ) {
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const0);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set qcmdname [...]
            TclObject tmp9;
            { // Invoke: lindex $... 1
                TclObject tmp10;
                StringBuffer sbtmp11 = new StringBuffer(64);
                tmp10 = getVarScalar(interp, "key", compiledLocals, 0);
                sbtmp11.append(tmp10.toString());
                sbtmp11.append(",info_key");
                tmp10 = getVarArray(interp, "_compileproc_ckeys", sbtmp11.toString(), compiledLocals, 2);
                tmp10 = TclList.index(interp, tmp10, 1);
                if ( tmp10 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp10);
                }
            } // End Invoke: lindex
            tmp9 = interp.getResult();
            setVarScalar(interp, "qcmdname", tmp9, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: $qcmdname == "_UNKNOWN"
            TclObject tmp12 = getVarScalar(interp, "qcmdname", compiledLocals, 3);
            boolean tmp13 = tmp12.toString().equals("_UNKNOWN");
            ExprValue tmp14 = evs0;
            tmp14.setIntValue(tmp13);
            // End Binary operator: ==
            boolean tmp15 = ( tmp14.getIntValue() != 0 );
            if ( tmp15 ) {
                { // Invoke: error ...
                    TclObject[] objv16 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: error
                        objv16[0] = const3;
                        // Arg 1 constant: ...
                        objv16[1] = const4;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv16, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv16, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set cmdname [...]
            TclObject tmp17;
            { // Invoke: namespace tail $qcmdname
                TclObject[] objv18 = TJC.grabObjv(interp, 3);
                TclObject tmp19;
                try {
                    // Arg 0 constant: namespace
                    objv18[0] = const5;
                    // Arg 1 constant: tail
                    objv18[1] = const6;
                    // Arg 2 variable: $qcmdname
                    tmp19 = getVarScalar(interp, "qcmdname", compiledLocals, 3);
                    tmp19.preserve();
                    objv18[2] = tmp19;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv18, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp19 = objv18[2];
                    if ( tmp19 != null ) {
                        tmp19.release();
                    }
                    TJC.releaseObjv(interp, objv18, 3);
                }
            } // End Invoke: namespace
            tmp17 = interp.getResult();
            setVarScalar(interp, "cmdname", tmp17, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set inline 0
            setVarScalar(interp, "inline", const0, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: $_compileproc(...) == "all"
            TclObject tmp20 = getVarArray(interp, "_compileproc", "options,inline_containers", compiledLocals, 1);
            boolean tmp21 = tmp20.toString().equals("all");
            ExprValue tmp22 = evs0;
            tmp22.setIntValue(tmp21);
            // End Binary operator: ==
            boolean tmp23 = ( tmp22.getIntValue() != 0 );
            if ( tmp23 ) {
                { // Invoke: set inline 1
                    setVarScalar(interp, "inline", const7, compiledLocals, 5);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: if {$inline == 0} ...
            // Binary operator: $inline == 0
            TclObject tmp24 = getVarScalar(interp, "inline", compiledLocals, 5);
            ExprValue tmp25 = evs0;
            TJC.exprInitValue(interp, tmp25, tmp24);
            ExprValue tmp26 = evs1;
            tmp26.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp25, tmp26);
            // End Binary operator: ==
            boolean tmp27 = ( tmp25.getIntValue() != 0 );
            if ( tmp27 ) {
                { // Invoke: set ind [...]
                    TclObject tmp28;
                    { // Invoke: lsearch -exact $... $cmdname
                        TclObject[] objv29 = TJC.grabObjv(interp, 4);
                        TclObject tmp30;
                        try {
                            // Arg 0 constant: lsearch
                            objv29[0] = const8;
                            // Arg 1 constant: -exact
                            objv29[1] = const9;
                            // Arg 2 variable: $...
                            tmp30 = getVarArray(interp, "_compileproc", "options,inline_containers", compiledLocals, 1);
                            tmp30.preserve();
                            objv29[2] = tmp30;
                            // Arg 3 variable: $cmdname
                            tmp30 = getVarScalar(interp, "cmdname", compiledLocals, 4);
                            tmp30.preserve();
                            objv29[3] = tmp30;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                ? cmdcache4.cmd : null), objv29, 0);
                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                updateCmdCache(interp, 4);
                            }
                        } finally {
                            tmp30 = objv29[2];
                            if ( tmp30 != null ) {
                                tmp30.release();
                            }
                            tmp30 = objv29[3];
                            if ( tmp30 != null ) {
                                tmp30.release();
                            }
                            TJC.releaseObjv(interp, objv29, 4);
                        }
                    } // End Invoke: lsearch
                    tmp28 = interp.getResult();
                    setVarScalar(interp, "ind", tmp28, compiledLocals, 6);
                } // End Invoke: set
                { // Invoke: if {$ind == -1} ... else ...
                    // Binary operator: $ind == ()
                    TclObject tmp31 = getVarScalar(interp, "ind", compiledLocals, 6);
                    ExprValue tmp32 = evs0;
                    TJC.exprInitValue(interp, tmp32, tmp31);
                    // Unary operator: - 1
                    ExprValue tmp33 = evs1;
                    tmp33.setIntValue(-1);
                    // End Unary operator: -
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp32, tmp33);
                    // End Binary operator: ==
                    boolean tmp34 = ( tmp32.getIntValue() != 0 );
                    if ( tmp34 ) {
                        { // Invoke: return 0
                            interp.resetResult();
                            interp.setResult(const0);
                            if ( true ) { return; }
                        } // End Invoke: return
                    } else {
                        { // Invoke: set inline 1
                            setVarScalar(interp, "inline", const7, compiledLocals, 5);
                        } // End Invoke: set
                    }
                } // End Invoke: if
            }
        } // End Invoke: if
        { // Invoke: if {$inline == 0} ...
            // Binary operator: $inline == 0
            TclObject tmp35 = getVarScalar(interp, "inline", compiledLocals, 5);
            ExprValue tmp36 = evs0;
            TJC.exprInitValue(interp, tmp36, tmp35);
            ExprValue tmp37 = evs1;
            tmp37.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp36, tmp37);
            // End Binary operator: ==
            boolean tmp38 = ( tmp36.getIntValue() != 0 );
            if ( tmp38 ) {
                { // Invoke: error "..."
                    TclObject[] objv39 = TJC.grabObjv(interp, 2);
                    TclObject tmp40;
                    try {
                        // Arg 0 constant: error
                        objv39[0] = const3;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp41 = new StringBuffer(64);
                        sbtmp41.append("expected inline to be 1, not ");
                        sbtmp41.append("\"");
                        tmp40 = getVarScalar(interp, "inline", compiledLocals, 5);
                        sbtmp41.append(tmp40.toString());
                        sbtmp41.append("\"");
                        tmp40 = TclString.newInstance(sbtmp41);
                        tmp40.preserve();
                        objv39[1] = tmp40;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv39, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp40 = objv39[1];
                        if ( tmp40 != null ) {
                            tmp40.release();
                        }
                        TJC.releaseObjv(interp, objv39, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: if ... ... else ...
            // Binary operator: [...] && [...]
            { // Invoke: ... $key
                TclObject[] objv42 = TJC.grabObjv(interp, 2);
                TclObject tmp43;
                try {
                    // Arg 0 constant: ...
                    objv42[0] = const10;
                    // Arg 1 variable: $key
                    tmp43 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp43.preserve();
                    objv42[1] = tmp43;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                        ? cmdcache5.cmd : null), objv42, 0);
                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                        updateCmdCache(interp, 5);
                    }
                } finally {
                    tmp43 = objv42[1];
                    if ( tmp43 != null ) {
                        tmp43.release();
                    }
                    TJC.releaseObjv(interp, objv42, 2);
                }
            } // End Invoke: ...
            TclObject tmp44 = interp.getResult();
            ExprValue tmp45 = evs0;
            TJC.exprInitValue(interp, tmp45, tmp44);
            if (tmp45.getBooleanValue(interp)) {
            { // Invoke: ... $key
                TclObject[] objv46 = TJC.grabObjv(interp, 2);
                TclObject tmp47;
                try {
                    // Arg 0 constant: ...
                    objv46[0] = const11;
                    // Arg 1 variable: $key
                    tmp47 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp47.preserve();
                    objv46[1] = tmp47;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                        ? cmdcache6.cmd : null), objv46, 0);
                    if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                        updateCmdCache(interp, 6);
                    }
                } finally {
                    tmp47 = objv46[1];
                    if ( tmp47 != null ) {
                        tmp47.release();
                    }
                    TJC.releaseObjv(interp, objv46, 2);
                }
            } // End Invoke: ...
            TclObject tmp48 = interp.getResult();
            ExprValue tmp49 = evs1;
            TJC.exprInitValue(interp, tmp49, tmp48);
            tmp45.setIntValue(tmp49.getBooleanValue(interp));
            } else {
            tmp45.setIntValue(0);
            } // End if: [...]
            // End Binary operator: &&
            boolean tmp50 = ( tmp45.getIntValue() != 0 );
            if ( tmp50 ) {
                { // Invoke: return 1
                    interp.resetResult();
                    interp.setResult(const7);
                    if ( true ) { return; }
                } // End Invoke: return
            } else {
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const0);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_can_inline_container");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclInteger.newInstance(0);
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("info");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("exists");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("error");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("container should not have non-constant name");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("namespace");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("tail");
        const6.preserve(); const6.preserve();
        const7 = TclInteger.newInstance(1);
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("lsearch");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("-exact");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("descend_container_is_valid");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("descend_container_is_static");
        const11.preserve(); const11.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "info";
                break;
            }
            case 2: {
                cmdName = "error";
                break;
            }
            case 3: {
                cmdName = "namespace";
                break;
            }
            case 4: {
                cmdName = "lsearch";
                break;
            }
            case 5: {
                cmdName = "descend_container_is_valid";
                break;
            }
            case 6: {
                cmdName = "descend_container_is_static";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "_compileproc",
        "_compileproc_ckeys",
        "qcmdname",
        "cmdname",
        "inline",
        "ind"
    };
} // end class CompileprocCanInlineContainerCmd

