// TJC implementation of procedure compileproc_emit_container_catch
package tjc;
import tcl.lang.*;

public class CompileprocEmitContainerCatchCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 17, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: global _compileproc
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 1);
        } // End Invoke: global
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: () || ()
            // Unary operator: ! [...]
            { // Invoke: ... $key
                TclObject[] objv0 = TJC.grabObjv(interp, 2);
                TclObject tmp1;
                try {
                    // Arg 0 constant: ...
                    objv0[0] = const1;
                    // Arg 1 variable: $key
                    tmp1 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp1.preserve();
                    objv0[1] = tmp1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv0, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp1 = objv0[1];
                    if ( tmp1 != null ) {
                        tmp1.release();
                    }
                    TJC.releaseObjv(interp, objv0, 2);
                }
            } // End Invoke: ...
            TclObject tmp2 = interp.getResult();
            ExprValue tmp3 = evs0;
            if ( tmp2.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp3, tmp2);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp3, tmp2);
            }
            // End Unary operator: !
            if (!tmp3.getBooleanValue(interp)) {
            // Unary operator: ! [...]
            { // Invoke: ... $key
                TclObject[] objv4 = TJC.grabObjv(interp, 2);
                TclObject tmp5;
                try {
                    // Arg 0 constant: ...
                    objv4[0] = const2;
                    // Arg 1 variable: $key
                    tmp5 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp5.preserve();
                    objv4[1] = tmp5;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv4, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp5 = objv4[1];
                    if ( tmp5 != null ) {
                        tmp5.release();
                    }
                    TJC.releaseObjv(interp, objv4, 2);
                }
            } // End Invoke: ...
            TclObject tmp6 = interp.getResult();
            ExprValue tmp7 = evs1;
            if ( tmp6.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp7, tmp6);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp7, tmp6);
            }
            // End Unary operator: !
            tmp3.setIntValue(tmp7.getBooleanValue(interp));
            } else {
            tmp3.setIntValue(1);
            } // End if: !()
            // End Binary operator: ||
            boolean tmp8 = ( tmp3.getIntValue() != 0 );
            if ( tmp8 ) {
                { // Invoke: error "..."
                    TclObject[] objv9 = TJC.grabObjv(interp, 2);
                    TclObject tmp10;
                    try {
                        // Arg 0 constant: error
                        objv9[0] = const3;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp11 = new StringBuffer(64);
                        sbtmp11.append("NOT valid or NOT static for key ");
                        tmp10 = getVarScalar(interp, "key", compiledLocals, 0);
                        sbtmp11.append(tmp10.toString());
                        tmp10 = TclString.newInstance(sbtmp11);
                        tmp10.preserve();
                        objv9[1] = tmp10;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv9, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        tmp10 = objv9[1];
                        if ( tmp10 != null ) {
                            tmp10.release();
                        }
                        TJC.releaseObjv(interp, objv9, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set body_keys [...]
            TclObject tmp12;
            { // Invoke: descend_commands $key container
                TclObject[] objv13 = TJC.grabObjv(interp, 3);
                TclObject tmp14;
                try {
                    // Arg 0 constant: descend_commands
                    objv13[0] = const4;
                    // Arg 1 variable: $key
                    tmp14 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp14.preserve();
                    objv13[1] = tmp14;
                    // Arg 2 constant: container
                    objv13[2] = const5;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                        ? cmdcache4.cmd : null), objv13, 0);
                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                        updateCmdCache(interp, 4);
                    }
                } finally {
                    tmp14 = objv13[1];
                    if ( tmp14 != null ) {
                        tmp14.release();
                    }
                    TJC.releaseObjv(interp, objv13, 3);
                }
            } // End Invoke: descend_commands
            tmp12 = interp.getResult();
            setVarScalar(interp, "body_keys", tmp12, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: if ... ... else ...
            { // Invoke: ... $key
                TclObject[] objv15 = TJC.grabObjv(interp, 2);
                TclObject tmp16;
                try {
                    // Arg 0 constant: ...
                    objv15[0] = const6;
                    // Arg 1 variable: $key
                    tmp16 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp16.preserve();
                    objv15[1] = tmp16;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                        ? cmdcache5.cmd : null), objv15, 0);
                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                        updateCmdCache(interp, 5);
                    }
                } finally {
                    tmp16 = objv15[1];
                    if ( tmp16 != null ) {
                        tmp16.release();
                    }
                    TJC.releaseObjv(interp, objv15, 2);
                }
            } // End Invoke: ...
            TclObject tmp17 = interp.getResult();
            ExprValue tmp18 = evs0;
            TJC.exprInitValue(interp, tmp18, tmp17);
            boolean tmp19 = tmp18.getBooleanValue(interp);
            if ( tmp19 ) {
                { // Invoke: set has_variable 1
                    setVarScalar(interp, "has_variable", const7, compiledLocals, 4);
                } // End Invoke: set
                { // Invoke: set has_static_varname 0
                    setVarScalar(interp, "has_static_varname", const8, compiledLocals, 5);
                } // End Invoke: set
                { // Invoke: set ... 0
                    setVarScalar(interp, "has_static_array_varname", const8, compiledLocals, 6);
                } // End Invoke: set
                { // Invoke: set vinfo [...]
                    TclObject tmp20;
                    { // Invoke: ... $key
                        TclObject[] objv21 = TJC.grabObjv(interp, 2);
                        TclObject tmp22;
                        try {
                            // Arg 0 constant: ...
                            objv21[0] = const9;
                            // Arg 1 variable: $key
                            tmp22 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp22.preserve();
                            objv21[1] = tmp22;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                ? cmdcache6.cmd : null), objv21, 0);
                            if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                updateCmdCache(interp, 6);
                            }
                        } finally {
                            tmp22 = objv21[1];
                            if ( tmp22 != null ) {
                                tmp22.release();
                            }
                            TJC.releaseObjv(interp, objv21, 2);
                        }
                    } // End Invoke: ...
                    tmp20 = interp.getResult();
                    setVarScalar(interp, "vinfo", tmp20, compiledLocals, 7);
                } // End Invoke: set
                { // Invoke: if {[lindex $vinfo 0]} ... elseif ... ... else ...
                    { // Invoke: lindex $vinfo 0
                        TclObject tmp23 = getVarScalar(interp, "vinfo", compiledLocals, 7);
                        tmp23 = TclList.index(interp, tmp23, 0);
                        if ( tmp23 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp23);
                        }
                    } // End Invoke: lindex
                    TclObject tmp24 = interp.getResult();
                    ExprValue tmp25 = evs0;
                    TJC.exprInitValue(interp, tmp25, tmp24);
                    boolean tmp26 = tmp25.getBooleanValue(interp);
                    if ( tmp26 ) {
                        { // Invoke: set has_static_varname 1
                            setVarScalar(interp, "has_static_varname", const7, compiledLocals, 5);
                        } // End Invoke: set
                        { // Invoke: set static_varname [...]
                            TclObject tmp27;
                            { // Invoke: lindex $vinfo 1
                                TclObject tmp28 = getVarScalar(interp, "vinfo", compiledLocals, 7);
                                tmp28 = TclList.index(interp, tmp28, 1);
                                if ( tmp28 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp28);
                                }
                            } // End Invoke: lindex
                            tmp27 = interp.getResult();
                            setVarScalar(interp, "static_varname", tmp27, compiledLocals, 8);
                        } // End Invoke: set
                    } else {
                        { // Invoke: ... $key 2
                            TclObject[] objv29 = TJC.grabObjv(interp, 3);
                            TclObject tmp30;
                            try {
                                // Arg 0 constant: ...
                                objv29[0] = const10;
                                // Arg 1 variable: $key
                                tmp30 = getVarScalar(interp, "key", compiledLocals, 0);
                                tmp30.preserve();
                                objv29[1] = tmp30;
                                // Arg 2 constant: 2
                                objv29[2] = const11;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                    ? cmdcache7.cmd : null), objv29, 0);
                                if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                    updateCmdCache(interp, 7);
                                }
                            } finally {
                                tmp30 = objv29[1];
                                if ( tmp30 != null ) {
                                    tmp30.release();
                                }
                                TJC.releaseObjv(interp, objv29, 3);
                            }
                        } // End Invoke: ...
                        TclObject tmp31 = interp.getResult();
                        ExprValue tmp32 = evs0;
                        TJC.exprInitValue(interp, tmp32, tmp31);
                        boolean tmp33 = tmp32.getBooleanValue(interp);
                        if ( tmp33 ) {
                            { // Invoke: set ... 1
                                setVarScalar(interp, "has_static_array_varname", const7, compiledLocals, 6);
                            } // End Invoke: set
                        } else {
                            { // Invoke: set tuple [...]
                                TclObject tmp34;
                                { // Invoke: ... $key 2 true
                                    TclObject[] objv35 = TJC.grabObjv(interp, 4);
                                    TclObject tmp36;
                                    try {
                                        // Arg 0 constant: ...
                                        objv35[0] = const12;
                                        // Arg 1 variable: $key
                                        tmp36 = getVarScalar(interp, "key", compiledLocals, 0);
                                        tmp36.preserve();
                                        objv35[1] = tmp36;
                                        // Arg 2 constant: 2
                                        objv35[2] = const11;
                                        // Arg 3 constant: true
                                        objv35[3] = const13;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                            ? cmdcache8.cmd : null), objv35, 0);
                                        if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                            updateCmdCache(interp, 8);
                                        }
                                    } finally {
                                        tmp36 = objv35[1];
                                        if ( tmp36 != null ) {
                                            tmp36.release();
                                        }
                                        TJC.releaseObjv(interp, objv35, 4);
                                    }
                                } // End Invoke: ...
                                tmp34 = interp.getResult();
                                setVarScalar(interp, "tuple", tmp34, compiledLocals, 9);
                            } // End Invoke: set
                            { // Invoke: set tclobject_symbol [...]
                                TclObject tmp37;
                                { // Invoke: lindex $tuple 1
                                    TclObject tmp38 = getVarScalar(interp, "tuple", compiledLocals, 9);
                                    tmp38 = TclList.index(interp, tmp38, 1);
                                    if ( tmp38 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp38);
                                    }
                                } // End Invoke: lindex
                                tmp37 = interp.getResult();
                                setVarScalar(interp, "tclobject_symbol", tmp37, compiledLocals, 10);
                            } // End Invoke: set
                            { // Invoke: append buffer [...]
                                TclObject[] objv39 = TJC.grabObjv(interp, 1);
                                TclObject tmp40;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: lindex $tuple 2
                                        TclObject tmp41 = getVarScalar(interp, "tuple", compiledLocals, 9);
                                        tmp41 = TclList.index(interp, tmp41, 2);
                                        if ( tmp41 == null ) {
                                            interp.resetResult();
                                        } else {
                                            interp.setResult(tmp41);
                                        }
                                    } // End Invoke: lindex
                                    tmp40 = interp.getResult();
                                    tmp40.preserve();
                                    objv39[0] = tmp40;
                                    interp.resetResult();
                                    appendVarScalar(interp, "buffer", objv39, compiledLocals, 2);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv39, 1);
                                }
                            } // End Invoke: append
                            { // Invoke: set varsymbol [...]
                                TclObject tmp42;
                                { // Invoke: ...
                                    TclObject[] objv43 = TJC.grabObjv(interp, 1);
                                    try {
                                        // Arg 0 constant: ...
                                        objv43[0] = const14;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                                            ? cmdcache9.cmd : null), objv43, 0);
                                        if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                                            updateCmdCache(interp, 9);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv43, 1);
                                    }
                                } // End Invoke: ...
                                tmp42 = interp.getResult();
                                setVarScalar(interp, "varsymbol", tmp42, compiledLocals, 11);
                            } // End Invoke: set
                            { // Invoke: append buffer [...]
                                TclObject[] objv44 = TJC.grabObjv(interp, 1);
                                TclObject tmp45;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: emitter_statement "..."
                                        TclObject[] objv46 = TJC.grabObjv(interp, 2);
                                        TclObject tmp47;
                                        try {
                                            // Arg 0 constant: emitter_statement
                                            objv46[0] = const15;
                                            // Arg 1 word: "..."
                                            StringBuffer sbtmp48 = new StringBuffer(64);
                                            sbtmp48.append("String ");
                                            tmp47 = getVarScalar(interp, "varsymbol", compiledLocals, 11);
                                            sbtmp48.append(tmp47.toString());
                                            sbtmp48.append(" = ");
                                            tmp47 = getVarScalar(interp, "tclobject_symbol", compiledLocals, 10);
                                            sbtmp48.append(tmp47.toString());
                                            sbtmp48.append(".toString()");
                                            tmp47 = TclString.newInstance(sbtmp48);
                                            tmp47.preserve();
                                            objv46[1] = tmp47;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                                ? cmdcache10.cmd : null), objv46, 0);
                                            if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                                updateCmdCache(interp, 10);
                                            }
                                        } finally {
                                            tmp47 = objv46[1];
                                            if ( tmp47 != null ) {
                                                tmp47.release();
                                            }
                                            TJC.releaseObjv(interp, objv46, 2);
                                        }
                                    } // End Invoke: emitter_statement
                                    tmp45 = interp.getResult();
                                    tmp45.preserve();
                                    objv44[0] = tmp45;
                                    interp.resetResult();
                                    appendVarScalar(interp, "buffer", objv44, compiledLocals, 2);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv44, 1);
                                }
                            } // End Invoke: append
                        }
                    }
                } // End Invoke: if
            } else {
                { // Invoke: set has_variable 0
                    setVarScalar(interp, "has_variable", const8, compiledLocals, 4);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: if {$body_keys == {}} ... else ...
            // Binary operator: $body_keys == ""
            TclObject tmp49 = getVarScalar(interp, "body_keys", compiledLocals, 3);
            ExprValue tmp50 = evs0;
            TJC.exprEqualsEmptyString(tmp50, tmp49, false);
            // End Binary operator: ==
            boolean tmp51 = ( tmp50.getIntValue() != 0 );
            if ( tmp51 ) {
                { // Invoke: if {$has_variable} ... else ...
                    TclObject tmp52 = getVarScalar(interp, "has_variable", compiledLocals, 4);
                    boolean tmp53 = TJC.getBoolean(interp, tmp52);
                    if ( tmp53 ) {
                        { // Invoke: if ... ... elseif ... ... else ...
                            TclObject tmp54 = getVarScalar(interp, "has_static_varname", compiledLocals, 5);
                            boolean tmp55 = TJC.getBoolean(interp, tmp54);
                            if ( tmp55 ) {
                                { // Invoke: set set_var_buffer ""
                                    setVarScalar(interp, "set_var_buffer", const0, compiledLocals, 12);
                                } // End Invoke: set
                                { // Invoke: emitter_indent_level +1
                                    TclObject[] objv56 = TJC.grabObjv(interp, 2);
                                    try {
                                        // Arg 0 constant: emitter_indent_level
                                        objv56[0] = const16;
                                        // Arg 1 constant: +1
                                        objv56[1] = const17;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache11_cmdEpoch == cmdcache11.cmdEpoch)
                                            ? cmdcache11.cmd : null), objv56, 0);
                                        if ( cmdcache11_cmdEpoch != cmdcache11.cmdEpoch ) {
                                            updateCmdCache(interp, 11);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv56, 2);
                                    }
                                } // End Invoke: emitter_indent_level
                                { // Invoke: append set_var_buffer [...]
                                    TclObject[] objv57 = TJC.grabObjv(interp, 1);
                                    TclObject tmp58;
                                    try {
                                        // Arg 2 command: [...]
                                        { // Invoke: ... {} $static_varname true "" true
                                            TclObject[] objv59 = TJC.grabObjv(interp, 6);
                                            TclObject tmp60;
                                            try {
                                                // Arg 0 constant: ...
                                                objv59[0] = const18;
                                                // Arg 1 constant: {}
                                                objv59[1] = const0;
                                                // Arg 2 variable: $static_varname
                                                tmp60 = getVarScalar(interp, "static_varname", compiledLocals, 8);
                                                tmp60.preserve();
                                                objv59[2] = tmp60;
                                                // Arg 3 constant: true
                                                objv59[3] = const13;
                                                // Arg 4 constant: ""
                                                objv59[4] = const0;
                                                // Arg 5 constant: true
                                                objv59[5] = const13;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache12_cmdEpoch == cmdcache12.cmdEpoch)
                                                    ? cmdcache12.cmd : null), objv59, 0);
                                                if ( cmdcache12_cmdEpoch != cmdcache12.cmdEpoch ) {
                                                    updateCmdCache(interp, 12);
                                                }
                                            } finally {
                                                tmp60 = objv59[2];
                                                if ( tmp60 != null ) {
                                                    tmp60.release();
                                                }
                                                TJC.releaseObjv(interp, objv59, 6);
                                            }
                                        } // End Invoke: ...
                                        tmp58 = interp.getResult();
                                        tmp58.preserve();
                                        objv57[0] = tmp58;
                                        interp.resetResult();
                                        appendVarScalar(interp, "set_var_buffer", objv57, compiledLocals, 12);
                                    } finally {
                                        TJC.releaseObjvElems(interp, objv57, 1);
                                    }
                                } // End Invoke: append
                                { // Invoke: emitter_indent_level -1
                                    TclObject[] objv61 = TJC.grabObjv(interp, 2);
                                    try {
                                        // Arg 0 constant: emitter_indent_level
                                        objv61[0] = const16;
                                        // Arg 1 constant: -1
                                        objv61[1] = const19;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache11_cmdEpoch == cmdcache11.cmdEpoch)
                                            ? cmdcache11.cmd : null), objv61, 0);
                                        if ( cmdcache11_cmdEpoch != cmdcache11.cmdEpoch ) {
                                            updateCmdCache(interp, 11);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv61, 2);
                                    }
                                } // End Invoke: emitter_indent_level
                                { // Invoke: append buffer [...]
                                    TclObject[] objv62 = TJC.grabObjv(interp, 1);
                                    TclObject tmp63;
                                    try {
                                        // Arg 2 command: [...]
                                        { // Invoke: ... {} true $set_var_buffer
                                            TclObject[] objv64 = TJC.grabObjv(interp, 4);
                                            TclObject tmp65;
                                            try {
                                                // Arg 0 constant: ...
                                                objv64[0] = const20;
                                                // Arg 1 constant: {}
                                                objv64[1] = const0;
                                                // Arg 2 constant: true
                                                objv64[2] = const13;
                                                // Arg 3 variable: $set_var_buffer
                                                tmp65 = getVarScalar(interp, "set_var_buffer", compiledLocals, 12);
                                                tmp65.preserve();
                                                objv64[3] = tmp65;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache13_cmdEpoch == cmdcache13.cmdEpoch)
                                                    ? cmdcache13.cmd : null), objv64, 0);
                                                if ( cmdcache13_cmdEpoch != cmdcache13.cmdEpoch ) {
                                                    updateCmdCache(interp, 13);
                                                }
                                            } finally {
                                                tmp65 = objv64[3];
                                                if ( tmp65 != null ) {
                                                    tmp65.release();
                                                }
                                                TJC.releaseObjv(interp, objv64, 4);
                                            }
                                        } // End Invoke: ...
                                        tmp63 = interp.getResult();
                                        tmp63.preserve();
                                        objv62[0] = tmp63;
                                        interp.resetResult();
                                        appendVarScalar(interp, "buffer", objv62, compiledLocals, 2);
                                    } finally {
                                        TJC.releaseObjvElems(interp, objv62, 1);
                                    }
                                } // End Invoke: append
                            } else {
                                TclObject tmp66 = getVarScalar(interp, "has_static_array_varname", compiledLocals, 6);
                                boolean tmp67 = TJC.getBoolean(interp, tmp66);
                                if ( tmp67 ) {
                                    { // Invoke: set gs_buffers [...]
                                        TclObject tmp68;
                                        { // Invoke: ... $key 2 set {} false {""}
                                            TclObject[] objv69 = TJC.grabObjv(interp, 7);
                                            TclObject tmp70;
                                            try {
                                                // Arg 0 constant: ...
                                                objv69[0] = const21;
                                                // Arg 1 variable: $key
                                                tmp70 = getVarScalar(interp, "key", compiledLocals, 0);
                                                tmp70.preserve();
                                                objv69[1] = tmp70;
                                                // Arg 2 constant: 2
                                                objv69[2] = const11;
                                                // Arg 3 constant: set
                                                objv69[3] = const22;
                                                // Arg 4 constant: {}
                                                objv69[4] = const0;
                                                // Arg 5 constant: false
                                                objv69[5] = const23;
                                                // Arg 6 constant: {""}
                                                objv69[6] = const24;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache14_cmdEpoch == cmdcache14.cmdEpoch)
                                                    ? cmdcache14.cmd : null), objv69, 0);
                                                if ( cmdcache14_cmdEpoch != cmdcache14.cmdEpoch ) {
                                                    updateCmdCache(interp, 14);
                                                }
                                            } finally {
                                                tmp70 = objv69[1];
                                                if ( tmp70 != null ) {
                                                    tmp70.release();
                                                }
                                                TJC.releaseObjv(interp, objv69, 7);
                                            }
                                        } // End Invoke: ...
                                        tmp68 = interp.getResult();
                                        setVarScalar(interp, "gs_buffers", tmp68, compiledLocals, 13);
                                    } // End Invoke: set
                                    { // Invoke: append buffer [...]
                                        TclObject[] objv71 = TJC.grabObjv(interp, 1);
                                        TclObject tmp72;
                                        try {
                                            // Arg 2 command: [...]
                                            { // Invoke: lindex $gs_buffers 0
                                                TclObject tmp73 = getVarScalar(interp, "gs_buffers", compiledLocals, 13);
                                                tmp73 = TclList.index(interp, tmp73, 0);
                                                if ( tmp73 == null ) {
                                                    interp.resetResult();
                                                } else {
                                                    interp.setResult(tmp73);
                                                }
                                            } // End Invoke: lindex
                                            tmp72 = interp.getResult();
                                            tmp72.preserve();
                                            objv71[0] = tmp72;
                                            interp.resetResult();
                                            appendVarScalar(interp, "buffer", objv71, compiledLocals, 2);
                                        } finally {
                                            TJC.releaseObjvElems(interp, objv71, 1);
                                        }
                                    } // End Invoke: append
                                    { // Invoke: append buffer [...]
                                        TclObject[] objv74 = TJC.grabObjv(interp, 1);
                                        TclObject tmp75;
                                        try {
                                            // Arg 2 command: [...]
                                            { // Invoke: ... {} true [...]
                                                TclObject[] objv76 = TJC.grabObjv(interp, 4);
                                                TclObject tmp77;
                                                try {
                                                    // Arg 0 constant: ...
                                                    objv76[0] = const20;
                                                    // Arg 1 constant: {}
                                                    objv76[1] = const0;
                                                    // Arg 2 constant: true
                                                    objv76[2] = const13;
                                                    // Arg 3 command: [...]
                                                    { // Invoke: lindex $gs_buffers 1
                                                        TclObject tmp78 = getVarScalar(interp, "gs_buffers", compiledLocals, 13);
                                                        tmp78 = TclList.index(interp, tmp78, 1);
                                                        if ( tmp78 == null ) {
                                                            interp.resetResult();
                                                        } else {
                                                            interp.setResult(tmp78);
                                                        }
                                                    } // End Invoke: lindex
                                                    tmp77 = interp.getResult();
                                                    tmp77.preserve();
                                                    objv76[3] = tmp77;
                                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                        updateCmdCache(interp, 0);
                                                    }
                                                    TJC.invoke(interp, ((cmdcache13_cmdEpoch == cmdcache13.cmdEpoch)
                                                        ? cmdcache13.cmd : null), objv76, 0);
                                                    if ( cmdcache13_cmdEpoch != cmdcache13.cmdEpoch ) {
                                                        updateCmdCache(interp, 13);
                                                    }
                                                } finally {
                                                    tmp77 = objv76[3];
                                                    if ( tmp77 != null ) {
                                                        tmp77.release();
                                                    }
                                                    TJC.releaseObjv(interp, objv76, 4);
                                                }
                                            } // End Invoke: ...
                                            tmp75 = interp.getResult();
                                            tmp75.preserve();
                                            objv74[0] = tmp75;
                                            interp.resetResult();
                                            appendVarScalar(interp, "buffer", objv74, compiledLocals, 2);
                                        } finally {
                                            TJC.releaseObjvElems(interp, objv74, 1);
                                        }
                                    } // End Invoke: append
                                } else {
                                    { // Invoke: set set_var_buffer ""
                                        setVarScalar(interp, "set_var_buffer", const0, compiledLocals, 12);
                                    } // End Invoke: set
                                    { // Invoke: emitter_indent_level +1
                                        TclObject[] objv79 = TJC.grabObjv(interp, 2);
                                        try {
                                            // Arg 0 constant: emitter_indent_level
                                            objv79[0] = const16;
                                            // Arg 1 constant: +1
                                            objv79[1] = const17;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache11_cmdEpoch == cmdcache11.cmdEpoch)
                                                ? cmdcache11.cmd : null), objv79, 0);
                                            if ( cmdcache11_cmdEpoch != cmdcache11.cmdEpoch ) {
                                                updateCmdCache(interp, 11);
                                            }
                                        } finally {
                                            TJC.releaseObjv(interp, objv79, 2);
                                        }
                                    } // End Invoke: emitter_indent_level
                                    { // Invoke: append set_var_buffer [...]
                                        TclObject[] objv80 = TJC.grabObjv(interp, 1);
                                        TclObject tmp81;
                                        try {
                                            // Arg 2 command: [...]
                                            { // Invoke: ... {} $varsymbol false "" true
                                                TclObject[] objv82 = TJC.grabObjv(interp, 6);
                                                TclObject tmp83;
                                                try {
                                                    // Arg 0 constant: ...
                                                    objv82[0] = const18;
                                                    // Arg 1 constant: {}
                                                    objv82[1] = const0;
                                                    // Arg 2 variable: $varsymbol
                                                    tmp83 = getVarScalar(interp, "varsymbol", compiledLocals, 11);
                                                    tmp83.preserve();
                                                    objv82[2] = tmp83;
                                                    // Arg 3 constant: false
                                                    objv82[3] = const23;
                                                    // Arg 4 constant: ""
                                                    objv82[4] = const0;
                                                    // Arg 5 constant: true
                                                    objv82[5] = const13;
                                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                        updateCmdCache(interp, 0);
                                                    }
                                                    TJC.invoke(interp, ((cmdcache12_cmdEpoch == cmdcache12.cmdEpoch)
                                                        ? cmdcache12.cmd : null), objv82, 0);
                                                    if ( cmdcache12_cmdEpoch != cmdcache12.cmdEpoch ) {
                                                        updateCmdCache(interp, 12);
                                                    }
                                                } finally {
                                                    tmp83 = objv82[2];
                                                    if ( tmp83 != null ) {
                                                        tmp83.release();
                                                    }
                                                    TJC.releaseObjv(interp, objv82, 6);
                                                }
                                            } // End Invoke: ...
                                            tmp81 = interp.getResult();
                                            tmp81.preserve();
                                            objv80[0] = tmp81;
                                            interp.resetResult();
                                            appendVarScalar(interp, "set_var_buffer", objv80, compiledLocals, 12);
                                        } finally {
                                            TJC.releaseObjvElems(interp, objv80, 1);
                                        }
                                    } // End Invoke: append
                                    { // Invoke: emitter_indent_level -1
                                        TclObject[] objv84 = TJC.grabObjv(interp, 2);
                                        try {
                                            // Arg 0 constant: emitter_indent_level
                                            objv84[0] = const16;
                                            // Arg 1 constant: -1
                                            objv84[1] = const19;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache11_cmdEpoch == cmdcache11.cmdEpoch)
                                                ? cmdcache11.cmd : null), objv84, 0);
                                            if ( cmdcache11_cmdEpoch != cmdcache11.cmdEpoch ) {
                                                updateCmdCache(interp, 11);
                                            }
                                        } finally {
                                            TJC.releaseObjv(interp, objv84, 2);
                                        }
                                    } // End Invoke: emitter_indent_level
                                    { // Invoke: append buffer [...]
                                        TclObject[] objv85 = TJC.grabObjv(interp, 1);
                                        TclObject tmp86;
                                        try {
                                            // Arg 2 command: [...]
                                            { // Invoke: ... {} true $set_var_buffer
                                                TclObject[] objv87 = TJC.grabObjv(interp, 4);
                                                TclObject tmp88;
                                                try {
                                                    // Arg 0 constant: ...
                                                    objv87[0] = const20;
                                                    // Arg 1 constant: {}
                                                    objv87[1] = const0;
                                                    // Arg 2 constant: true
                                                    objv87[2] = const13;
                                                    // Arg 3 variable: $set_var_buffer
                                                    tmp88 = getVarScalar(interp, "set_var_buffer", compiledLocals, 12);
                                                    tmp88.preserve();
                                                    objv87[3] = tmp88;
                                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                        updateCmdCache(interp, 0);
                                                    }
                                                    TJC.invoke(interp, ((cmdcache13_cmdEpoch == cmdcache13.cmdEpoch)
                                                        ? cmdcache13.cmd : null), objv87, 0);
                                                    if ( cmdcache13_cmdEpoch != cmdcache13.cmdEpoch ) {
                                                        updateCmdCache(interp, 13);
                                                    }
                                                } finally {
                                                    tmp88 = objv87[3];
                                                    if ( tmp88 != null ) {
                                                        tmp88.release();
                                                    }
                                                    TJC.releaseObjv(interp, objv87, 4);
                                                }
                                            } // End Invoke: ...
                                            tmp86 = interp.getResult();
                                            tmp86.preserve();
                                            objv85[0] = tmp86;
                                            interp.resetResult();
                                            appendVarScalar(interp, "buffer", objv85, compiledLocals, 2);
                                        } finally {
                                            TJC.releaseObjvElems(interp, objv85, 1);
                                        }
                                    } // End Invoke: append
                                }
                            }
                        } // End Invoke: if
                    } else {
                        { // Invoke: append buffer [...]
                            TclObject[] objv89 = TJC.grabObjv(interp, 1);
                            TclObject tmp90;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: ... {} true
                                    TclObject[] objv91 = TJC.grabObjv(interp, 3);
                                    try {
                                        // Arg 0 constant: ...
                                        objv91[0] = const25;
                                        // Arg 1 constant: {}
                                        objv91[1] = const0;
                                        // Arg 2 constant: true
                                        objv91[2] = const13;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache15_cmdEpoch == cmdcache15.cmdEpoch)
                                            ? cmdcache15.cmd : null), objv91, 0);
                                        if ( cmdcache15_cmdEpoch != cmdcache15.cmdEpoch ) {
                                            updateCmdCache(interp, 15);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv91, 3);
                                    }
                                } // End Invoke: ...
                                tmp90 = interp.getResult();
                                tmp90.preserve();
                                objv89[0] = tmp90;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv89, compiledLocals, 2);
                            } finally {
                                TJC.releaseObjvElems(interp, objv89, 1);
                            }
                        } // End Invoke: append
                    }
                } // End Invoke: if
            } else {
                { // Invoke: set catch_body_buffer ""
                    setVarScalar(interp, "catch_body_buffer", const0, compiledLocals, 14);
                } // End Invoke: set
                { // Invoke: set code_tmpsymbol [...]
                    TclObject tmp92;
                    { // Invoke: ... code
                        TclObject[] objv93 = TJC.grabObjv(interp, 2);
                        try {
                            // Arg 0 constant: ...
                            objv93[0] = const14;
                            // Arg 1 constant: code
                            objv93[1] = const26;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                                ? cmdcache9.cmd : null), objv93, 0);
                            if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                                updateCmdCache(interp, 9);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv93, 2);
                        }
                    } // End Invoke: ...
                    tmp92 = interp.getResult();
                    setVarScalar(interp, "code_tmpsymbol", tmp92, compiledLocals, 15);
                } // End Invoke: set
                { // Invoke: append catch_body_buffer [...] [...]
                    TclObject[] objv94 = TJC.grabObjv(interp, 2);
                    TclObject tmp95;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: ... $code_tmpsymbol
                            TclObject[] objv96 = TJC.grabObjv(interp, 2);
                            TclObject tmp97;
                            try {
                                // Arg 0 constant: ...
                                objv96[0] = const27;
                                // Arg 1 variable: $code_tmpsymbol
                                tmp97 = getVarScalar(interp, "code_tmpsymbol", compiledLocals, 15);
                                tmp97.preserve();
                                objv96[1] = tmp97;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache16_cmdEpoch == cmdcache16.cmdEpoch)
                                    ? cmdcache16.cmd : null), objv96, 0);
                                if ( cmdcache16_cmdEpoch != cmdcache16.cmdEpoch ) {
                                    updateCmdCache(interp, 16);
                                }
                            } finally {
                                tmp97 = objv96[1];
                                if ( tmp97 != null ) {
                                    tmp97.release();
                                }
                                TJC.releaseObjv(interp, objv96, 2);
                            }
                        } // End Invoke: ...
                        tmp95 = interp.getResult();
                        tmp95.preserve();
                        objv94[0] = tmp95;
                        // Arg 3 command: [...]
                        { // Invoke: ...
                            TclObject[] objv98 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: ...
                                objv98[0] = const28;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache17_cmdEpoch == cmdcache17.cmdEpoch)
                                    ? cmdcache17.cmd : null), objv98, 0);
                                if ( cmdcache17_cmdEpoch != cmdcache17.cmdEpoch ) {
                                    updateCmdCache(interp, 17);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv98, 1);
                            }
                        } // End Invoke: ...
                        tmp95 = interp.getResult();
                        tmp95.preserve();
                        objv94[1] = tmp95;
                        interp.resetResult();
                        appendVarScalar(interp, "catch_body_buffer", objv94, compiledLocals, 14);
                    } finally {
                        TJC.releaseObjvElems(interp, objv94, 2);
                    }
                } // End Invoke: append
                { // Invoke: if ... ...
                    TclObject tmp99 = getVarArray(interp, "_compileproc", "options,inline_controls", compiledLocals, 1);
                    ExprValue tmp100 = evs0;
                    TJC.exprInitValue(interp, tmp100, tmp99);
                    boolean tmp101 = tmp100.getBooleanValue(interp);
                    if ( tmp101 ) {
                        { // Invoke: ... catch 0 0 0
                            TclObject[] objv102 = TJC.grabObjv(interp, 5);
                            try {
                                // Arg 0 constant: ...
                                objv102[0] = const29;
                                // Arg 1 constant: catch
                                objv102[1] = const30;
                                // Arg 2 constant: 0
                                objv102[2] = const8;
                                // Arg 3 constant: 0
                                objv102[3] = const8;
                                // Arg 4 constant: 0
                                objv102[4] = const8;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache18_cmdEpoch == cmdcache18.cmdEpoch)
                                    ? cmdcache18.cmd : null), objv102, 0);
                                if ( cmdcache18_cmdEpoch != cmdcache18.cmdEpoch ) {
                                    updateCmdCache(interp, 18);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv102, 5);
                            }
                        } // End Invoke: ...
                    }
                } // End Invoke: if
                { // Invoke: foreach body_key $body_keys ...
                    TclObject tmp103 = null;
                    try {
                        tmp103 = getVarScalar(interp, "body_keys", compiledLocals, 3);
                        tmp103.preserve();
                        final int tmp103_length = TclList.getLength(interp, tmp103);

                        for ( int index104 = 0 ; index104 < tmp103_length ; index104++ ) {
                            TclObject tmp105 = TclList.index(interp, tmp103, index104);
                            try {
                                setVarScalar(interp, "body_key", tmp105, compiledLocals, 16);
                            } catch (TclException ex) {
                                TJC.foreachVarErr(interp, "body_key");
                            }

                            try {
                            if ( false ) { throw (TclException) null; }
                            { // Invoke: append catch_body_buffer [...]
                                TclObject[] objv106 = TJC.grabObjv(interp, 1);
                                TclObject tmp107;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: ... $body_key
                                        TclObject[] objv108 = TJC.grabObjv(interp, 2);
                                        TclObject tmp109;
                                        try {
                                            // Arg 0 constant: ...
                                            objv108[0] = const31;
                                            // Arg 1 variable: $body_key
                                            tmp109 = getVarScalar(interp, "body_key", compiledLocals, 16);
                                            tmp109.preserve();
                                            objv108[1] = tmp109;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache19_cmdEpoch == cmdcache19.cmdEpoch)
                                                ? cmdcache19.cmd : null), objv108, 0);
                                            if ( cmdcache19_cmdEpoch != cmdcache19.cmdEpoch ) {
                                                updateCmdCache(interp, 19);
                                            }
                                        } finally {
                                            tmp109 = objv108[1];
                                            if ( tmp109 != null ) {
                                                tmp109.release();
                                            }
                                            TJC.releaseObjv(interp, objv108, 2);
                                        }
                                    } // End Invoke: ...
                                    tmp107 = interp.getResult();
                                    tmp107.preserve();
                                    objv106[0] = tmp107;
                                    interp.resetResult();
                                    appendVarScalar(interp, "catch_body_buffer", objv106, compiledLocals, 14);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv106, 1);
                                }
                            } // End Invoke: append
                            } catch (TclException ex) {
                                int type = ex.getCompletionCode();
                                if (type == TCL.BREAK) {
                                    break;
                                } else if (type == TCL.CONTINUE) {
                                    continue;
                                } else {
                                    throw ex;
                                }
                            }
                        }
                    } finally {
                        if ( tmp103 != null ) {
                            tmp103.release();
                        }
                    }
                } // End Invoke: foreach
                { // Invoke: if ... ...
                    TclObject tmp110 = getVarArray(interp, "_compileproc", "options,inline_controls", compiledLocals, 1);
                    ExprValue tmp111 = evs0;
                    TJC.exprInitValue(interp, tmp111, tmp110);
                    boolean tmp112 = tmp111.getBooleanValue(interp);
                    if ( tmp112 ) {
                        { // Invoke: ... catch
                            TclObject[] objv113 = TJC.grabObjv(interp, 2);
                            try {
                                // Arg 0 constant: ...
                                objv113[0] = const32;
                                // Arg 1 constant: catch
                                objv113[1] = const30;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache20_cmdEpoch == cmdcache20.cmdEpoch)
                                    ? cmdcache20.cmd : null), objv113, 0);
                                if ( cmdcache20_cmdEpoch != cmdcache20.cmdEpoch ) {
                                    updateCmdCache(interp, 20);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv113, 2);
                            }
                        } // End Invoke: ...
                    }
                } // End Invoke: if
                { // Invoke: append catch_body_buffer [...]
                    TclObject[] objv114 = TJC.grabObjv(interp, 1);
                    TclObject tmp115;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: ... $code_tmpsymbol
                            TclObject[] objv116 = TJC.grabObjv(interp, 2);
                            TclObject tmp117;
                            try {
                                // Arg 0 constant: ...
                                objv116[0] = const33;
                                // Arg 1 variable: $code_tmpsymbol
                                tmp117 = getVarScalar(interp, "code_tmpsymbol", compiledLocals, 15);
                                tmp117.preserve();
                                objv116[1] = tmp117;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache21_cmdEpoch == cmdcache21.cmdEpoch)
                                    ? cmdcache21.cmd : null), objv116, 0);
                                if ( cmdcache21_cmdEpoch != cmdcache21.cmdEpoch ) {
                                    updateCmdCache(interp, 21);
                                }
                            } finally {
                                tmp117 = objv116[1];
                                if ( tmp117 != null ) {
                                    tmp117.release();
                                }
                                TJC.releaseObjv(interp, objv116, 2);
                            }
                        } // End Invoke: ...
                        tmp115 = interp.getResult();
                        tmp115.preserve();
                        objv114[0] = tmp115;
                        interp.resetResult();
                        appendVarScalar(interp, "catch_body_buffer", objv114, compiledLocals, 14);
                    } finally {
                        TJC.releaseObjvElems(interp, objv114, 1);
                    }
                } // End Invoke: append
                { // Invoke: if {$has_variable} ... else ...
                    TclObject tmp118 = getVarScalar(interp, "has_variable", compiledLocals, 4);
                    boolean tmp119 = TJC.getBoolean(interp, tmp118);
                    if ( tmp119 ) {
                        { // Invoke: if ... ... elseif ... ... else ...
                            TclObject tmp120 = getVarScalar(interp, "has_static_varname", compiledLocals, 5);
                            boolean tmp121 = TJC.getBoolean(interp, tmp120);
                            if ( tmp121 ) {
                                { // Invoke: append buffer $catch_body_buffer
                                    TclObject[] objv122 = TJC.grabObjv(interp, 1);
                                    TclObject tmp123;
                                    try {
                                        // Arg 2 variable: $catch_body_buffer
                                        tmp123 = getVarScalar(interp, "catch_body_buffer", compiledLocals, 14);
                                        tmp123.preserve();
                                        objv122[0] = tmp123;
                                        interp.resetResult();
                                        appendVarScalar(interp, "buffer", objv122, compiledLocals, 2);
                                    } finally {
                                        TJC.releaseObjvElems(interp, objv122, 1);
                                    }
                                } // End Invoke: append
                                { // Invoke: set set_var_buffer ""
                                    setVarScalar(interp, "set_var_buffer", const0, compiledLocals, 12);
                                } // End Invoke: set
                                { // Invoke: emitter_indent_level +1
                                    TclObject[] objv124 = TJC.grabObjv(interp, 2);
                                    try {
                                        // Arg 0 constant: emitter_indent_level
                                        objv124[0] = const16;
                                        // Arg 1 constant: +1
                                        objv124[1] = const17;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache11_cmdEpoch == cmdcache11.cmdEpoch)
                                            ? cmdcache11.cmd : null), objv124, 0);
                                        if ( cmdcache11_cmdEpoch != cmdcache11.cmdEpoch ) {
                                            updateCmdCache(interp, 11);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv124, 2);
                                    }
                                } // End Invoke: emitter_indent_level
                                { // Invoke: append set_var_buffer [...]
                                    TclObject[] objv125 = TJC.grabObjv(interp, 1);
                                    TclObject tmp126;
                                    try {
                                        // Arg 2 command: [...]
                                        { // Invoke: ... {} $static_varname true "result" false
                                            TclObject[] objv127 = TJC.grabObjv(interp, 6);
                                            TclObject tmp128;
                                            try {
                                                // Arg 0 constant: ...
                                                objv127[0] = const18;
                                                // Arg 1 constant: {}
                                                objv127[1] = const0;
                                                // Arg 2 variable: $static_varname
                                                tmp128 = getVarScalar(interp, "static_varname", compiledLocals, 8);
                                                tmp128.preserve();
                                                objv127[2] = tmp128;
                                                // Arg 3 constant: true
                                                objv127[3] = const13;
                                                // Arg 4 constant: "result"
                                                objv127[4] = const34;
                                                // Arg 5 constant: false
                                                objv127[5] = const23;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache12_cmdEpoch == cmdcache12.cmdEpoch)
                                                    ? cmdcache12.cmd : null), objv127, 0);
                                                if ( cmdcache12_cmdEpoch != cmdcache12.cmdEpoch ) {
                                                    updateCmdCache(interp, 12);
                                                }
                                            } finally {
                                                tmp128 = objv127[2];
                                                if ( tmp128 != null ) {
                                                    tmp128.release();
                                                }
                                                TJC.releaseObjv(interp, objv127, 6);
                                            }
                                        } // End Invoke: ...
                                        tmp126 = interp.getResult();
                                        tmp126.preserve();
                                        objv125[0] = tmp126;
                                        interp.resetResult();
                                        appendVarScalar(interp, "set_var_buffer", objv125, compiledLocals, 12);
                                    } finally {
                                        TJC.releaseObjvElems(interp, objv125, 1);
                                    }
                                } // End Invoke: append
                                { // Invoke: emitter_indent_level -1
                                    TclObject[] objv129 = TJC.grabObjv(interp, 2);
                                    try {
                                        // Arg 0 constant: emitter_indent_level
                                        objv129[0] = const16;
                                        // Arg 1 constant: -1
                                        objv129[1] = const19;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache11_cmdEpoch == cmdcache11.cmdEpoch)
                                            ? cmdcache11.cmd : null), objv129, 0);
                                        if ( cmdcache11_cmdEpoch != cmdcache11.cmdEpoch ) {
                                            updateCmdCache(interp, 11);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv129, 2);
                                    }
                                } // End Invoke: emitter_indent_level
                                { // Invoke: append buffer [...]
                                    TclObject[] objv130 = TJC.grabObjv(interp, 1);
                                    TclObject tmp131;
                                    try {
                                        // Arg 2 command: [...]
                                        { // Invoke: ... $code_tmpsymbol false $set_var_buffer
                                            TclObject[] objv132 = TJC.grabObjv(interp, 4);
                                            TclObject tmp133;
                                            try {
                                                // Arg 0 constant: ...
                                                objv132[0] = const20;
                                                // Arg 1 variable: $code_tmpsymbol
                                                tmp133 = getVarScalar(interp, "code_tmpsymbol", compiledLocals, 15);
                                                tmp133.preserve();
                                                objv132[1] = tmp133;
                                                // Arg 2 constant: false
                                                objv132[2] = const23;
                                                // Arg 3 variable: $set_var_buffer
                                                tmp133 = getVarScalar(interp, "set_var_buffer", compiledLocals, 12);
                                                tmp133.preserve();
                                                objv132[3] = tmp133;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache13_cmdEpoch == cmdcache13.cmdEpoch)
                                                    ? cmdcache13.cmd : null), objv132, 0);
                                                if ( cmdcache13_cmdEpoch != cmdcache13.cmdEpoch ) {
                                                    updateCmdCache(interp, 13);
                                                }
                                            } finally {
                                                tmp133 = objv132[1];
                                                if ( tmp133 != null ) {
                                                    tmp133.release();
                                                }
                                                tmp133 = objv132[3];
                                                if ( tmp133 != null ) {
                                                    tmp133.release();
                                                }
                                                TJC.releaseObjv(interp, objv132, 4);
                                            }
                                        } // End Invoke: ...
                                        tmp131 = interp.getResult();
                                        tmp131.preserve();
                                        objv130[0] = tmp131;
                                        interp.resetResult();
                                        appendVarScalar(interp, "buffer", objv130, compiledLocals, 2);
                                    } finally {
                                        TJC.releaseObjvElems(interp, objv130, 1);
                                    }
                                } // End Invoke: append
                            } else {
                                TclObject tmp134 = getVarScalar(interp, "has_static_array_varname", compiledLocals, 6);
                                boolean tmp135 = TJC.getBoolean(interp, tmp134);
                                if ( tmp135 ) {
                                    { // Invoke: set gs_buffers [...]
                                        TclObject tmp136;
                                        { // Invoke: ... $key 2 set {} false "result"
                                            TclObject[] objv137 = TJC.grabObjv(interp, 7);
                                            TclObject tmp138;
                                            try {
                                                // Arg 0 constant: ...
                                                objv137[0] = const21;
                                                // Arg 1 variable: $key
                                                tmp138 = getVarScalar(interp, "key", compiledLocals, 0);
                                                tmp138.preserve();
                                                objv137[1] = tmp138;
                                                // Arg 2 constant: 2
                                                objv137[2] = const11;
                                                // Arg 3 constant: set
                                                objv137[3] = const22;
                                                // Arg 4 constant: {}
                                                objv137[4] = const0;
                                                // Arg 5 constant: false
                                                objv137[5] = const23;
                                                // Arg 6 constant: "result"
                                                objv137[6] = const34;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache14_cmdEpoch == cmdcache14.cmdEpoch)
                                                    ? cmdcache14.cmd : null), objv137, 0);
                                                if ( cmdcache14_cmdEpoch != cmdcache14.cmdEpoch ) {
                                                    updateCmdCache(interp, 14);
                                                }
                                            } finally {
                                                tmp138 = objv137[1];
                                                if ( tmp138 != null ) {
                                                    tmp138.release();
                                                }
                                                TJC.releaseObjv(interp, objv137, 7);
                                            }
                                        } // End Invoke: ...
                                        tmp136 = interp.getResult();
                                        setVarScalar(interp, "gs_buffers", tmp136, compiledLocals, 13);
                                    } // End Invoke: set
                                    { // Invoke: append buffer [...]
                                        TclObject[] objv139 = TJC.grabObjv(interp, 1);
                                        TclObject tmp140;
                                        try {
                                            // Arg 2 command: [...]
                                            { // Invoke: lindex $gs_buffers 0
                                                TclObject tmp141 = getVarScalar(interp, "gs_buffers", compiledLocals, 13);
                                                tmp141 = TclList.index(interp, tmp141, 0);
                                                if ( tmp141 == null ) {
                                                    interp.resetResult();
                                                } else {
                                                    interp.setResult(tmp141);
                                                }
                                            } // End Invoke: lindex
                                            tmp140 = interp.getResult();
                                            tmp140.preserve();
                                            objv139[0] = tmp140;
                                            interp.resetResult();
                                            appendVarScalar(interp, "buffer", objv139, compiledLocals, 2);
                                        } finally {
                                            TJC.releaseObjvElems(interp, objv139, 1);
                                        }
                                    } // End Invoke: append
                                    { // Invoke: append buffer $catch_body_buffer
                                        TclObject[] objv142 = TJC.grabObjv(interp, 1);
                                        TclObject tmp143;
                                        try {
                                            // Arg 2 variable: $catch_body_buffer
                                            tmp143 = getVarScalar(interp, "catch_body_buffer", compiledLocals, 14);
                                            tmp143.preserve();
                                            objv142[0] = tmp143;
                                            interp.resetResult();
                                            appendVarScalar(interp, "buffer", objv142, compiledLocals, 2);
                                        } finally {
                                            TJC.releaseObjvElems(interp, objv142, 1);
                                        }
                                    } // End Invoke: append
                                    { // Invoke: append buffer [...]
                                        TclObject[] objv144 = TJC.grabObjv(interp, 1);
                                        TclObject tmp145;
                                        try {
                                            // Arg 2 command: [...]
                                            { // Invoke: ... $code_tmpsymbol false [...]
                                                TclObject[] objv146 = TJC.grabObjv(interp, 4);
                                                TclObject tmp147;
                                                try {
                                                    // Arg 0 constant: ...
                                                    objv146[0] = const20;
                                                    // Arg 1 variable: $code_tmpsymbol
                                                    tmp147 = getVarScalar(interp, "code_tmpsymbol", compiledLocals, 15);
                                                    tmp147.preserve();
                                                    objv146[1] = tmp147;
                                                    // Arg 2 constant: false
                                                    objv146[2] = const23;
                                                    // Arg 3 command: [...]
                                                    { // Invoke: lindex $gs_buffers 1
                                                        TclObject tmp148 = getVarScalar(interp, "gs_buffers", compiledLocals, 13);
                                                        tmp148 = TclList.index(interp, tmp148, 1);
                                                        if ( tmp148 == null ) {
                                                            interp.resetResult();
                                                        } else {
                                                            interp.setResult(tmp148);
                                                        }
                                                    } // End Invoke: lindex
                                                    tmp147 = interp.getResult();
                                                    tmp147.preserve();
                                                    objv146[3] = tmp147;
                                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                        updateCmdCache(interp, 0);
                                                    }
                                                    TJC.invoke(interp, ((cmdcache13_cmdEpoch == cmdcache13.cmdEpoch)
                                                        ? cmdcache13.cmd : null), objv146, 0);
                                                    if ( cmdcache13_cmdEpoch != cmdcache13.cmdEpoch ) {
                                                        updateCmdCache(interp, 13);
                                                    }
                                                } finally {
                                                    tmp147 = objv146[1];
                                                    if ( tmp147 != null ) {
                                                        tmp147.release();
                                                    }
                                                    tmp147 = objv146[3];
                                                    if ( tmp147 != null ) {
                                                        tmp147.release();
                                                    }
                                                    TJC.releaseObjv(interp, objv146, 4);
                                                }
                                            } // End Invoke: ...
                                            tmp145 = interp.getResult();
                                            tmp145.preserve();
                                            objv144[0] = tmp145;
                                            interp.resetResult();
                                            appendVarScalar(interp, "buffer", objv144, compiledLocals, 2);
                                        } finally {
                                            TJC.releaseObjvElems(interp, objv144, 1);
                                        }
                                    } // End Invoke: append
                                } else {
                                    { // Invoke: append buffer $catch_body_buffer
                                        TclObject[] objv149 = TJC.grabObjv(interp, 1);
                                        TclObject tmp150;
                                        try {
                                            // Arg 2 variable: $catch_body_buffer
                                            tmp150 = getVarScalar(interp, "catch_body_buffer", compiledLocals, 14);
                                            tmp150.preserve();
                                            objv149[0] = tmp150;
                                            interp.resetResult();
                                            appendVarScalar(interp, "buffer", objv149, compiledLocals, 2);
                                        } finally {
                                            TJC.releaseObjvElems(interp, objv149, 1);
                                        }
                                    } // End Invoke: append
                                    { // Invoke: set set_var_buffer ""
                                        setVarScalar(interp, "set_var_buffer", const0, compiledLocals, 12);
                                    } // End Invoke: set
                                    { // Invoke: emitter_indent_level +1
                                        TclObject[] objv151 = TJC.grabObjv(interp, 2);
                                        try {
                                            // Arg 0 constant: emitter_indent_level
                                            objv151[0] = const16;
                                            // Arg 1 constant: +1
                                            objv151[1] = const17;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache11_cmdEpoch == cmdcache11.cmdEpoch)
                                                ? cmdcache11.cmd : null), objv151, 0);
                                            if ( cmdcache11_cmdEpoch != cmdcache11.cmdEpoch ) {
                                                updateCmdCache(interp, 11);
                                            }
                                        } finally {
                                            TJC.releaseObjv(interp, objv151, 2);
                                        }
                                    } // End Invoke: emitter_indent_level
                                    { // Invoke: append set_var_buffer [...]
                                        TclObject[] objv152 = TJC.grabObjv(interp, 1);
                                        TclObject tmp153;
                                        try {
                                            // Arg 2 command: [...]
                                            { // Invoke: ... {} $varsymbol false "result" false
                                                TclObject[] objv154 = TJC.grabObjv(interp, 6);
                                                TclObject tmp155;
                                                try {
                                                    // Arg 0 constant: ...
                                                    objv154[0] = const18;
                                                    // Arg 1 constant: {}
                                                    objv154[1] = const0;
                                                    // Arg 2 variable: $varsymbol
                                                    tmp155 = getVarScalar(interp, "varsymbol", compiledLocals, 11);
                                                    tmp155.preserve();
                                                    objv154[2] = tmp155;
                                                    // Arg 3 constant: false
                                                    objv154[3] = const23;
                                                    // Arg 4 constant: "result"
                                                    objv154[4] = const34;
                                                    // Arg 5 constant: false
                                                    objv154[5] = const23;
                                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                        updateCmdCache(interp, 0);
                                                    }
                                                    TJC.invoke(interp, ((cmdcache12_cmdEpoch == cmdcache12.cmdEpoch)
                                                        ? cmdcache12.cmd : null), objv154, 0);
                                                    if ( cmdcache12_cmdEpoch != cmdcache12.cmdEpoch ) {
                                                        updateCmdCache(interp, 12);
                                                    }
                                                } finally {
                                                    tmp155 = objv154[2];
                                                    if ( tmp155 != null ) {
                                                        tmp155.release();
                                                    }
                                                    TJC.releaseObjv(interp, objv154, 6);
                                                }
                                            } // End Invoke: ...
                                            tmp153 = interp.getResult();
                                            tmp153.preserve();
                                            objv152[0] = tmp153;
                                            interp.resetResult();
                                            appendVarScalar(interp, "set_var_buffer", objv152, compiledLocals, 12);
                                        } finally {
                                            TJC.releaseObjvElems(interp, objv152, 1);
                                        }
                                    } // End Invoke: append
                                    { // Invoke: emitter_indent_level -1
                                        TclObject[] objv156 = TJC.grabObjv(interp, 2);
                                        try {
                                            // Arg 0 constant: emitter_indent_level
                                            objv156[0] = const16;
                                            // Arg 1 constant: -1
                                            objv156[1] = const19;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache11_cmdEpoch == cmdcache11.cmdEpoch)
                                                ? cmdcache11.cmd : null), objv156, 0);
                                            if ( cmdcache11_cmdEpoch != cmdcache11.cmdEpoch ) {
                                                updateCmdCache(interp, 11);
                                            }
                                        } finally {
                                            TJC.releaseObjv(interp, objv156, 2);
                                        }
                                    } // End Invoke: emitter_indent_level
                                    { // Invoke: append buffer [...]
                                        TclObject[] objv157 = TJC.grabObjv(interp, 1);
                                        TclObject tmp158;
                                        try {
                                            // Arg 2 command: [...]
                                            { // Invoke: ... $code_tmpsymbol false $set_var_buffer
                                                TclObject[] objv159 = TJC.grabObjv(interp, 4);
                                                TclObject tmp160;
                                                try {
                                                    // Arg 0 constant: ...
                                                    objv159[0] = const20;
                                                    // Arg 1 variable: $code_tmpsymbol
                                                    tmp160 = getVarScalar(interp, "code_tmpsymbol", compiledLocals, 15);
                                                    tmp160.preserve();
                                                    objv159[1] = tmp160;
                                                    // Arg 2 constant: false
                                                    objv159[2] = const23;
                                                    // Arg 3 variable: $set_var_buffer
                                                    tmp160 = getVarScalar(interp, "set_var_buffer", compiledLocals, 12);
                                                    tmp160.preserve();
                                                    objv159[3] = tmp160;
                                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                        updateCmdCache(interp, 0);
                                                    }
                                                    TJC.invoke(interp, ((cmdcache13_cmdEpoch == cmdcache13.cmdEpoch)
                                                        ? cmdcache13.cmd : null), objv159, 0);
                                                    if ( cmdcache13_cmdEpoch != cmdcache13.cmdEpoch ) {
                                                        updateCmdCache(interp, 13);
                                                    }
                                                } finally {
                                                    tmp160 = objv159[1];
                                                    if ( tmp160 != null ) {
                                                        tmp160.release();
                                                    }
                                                    tmp160 = objv159[3];
                                                    if ( tmp160 != null ) {
                                                        tmp160.release();
                                                    }
                                                    TJC.releaseObjv(interp, objv159, 4);
                                                }
                                            } // End Invoke: ...
                                            tmp158 = interp.getResult();
                                            tmp158.preserve();
                                            objv157[0] = tmp158;
                                            interp.resetResult();
                                            appendVarScalar(interp, "buffer", objv157, compiledLocals, 2);
                                        } finally {
                                            TJC.releaseObjvElems(interp, objv157, 1);
                                        }
                                    } // End Invoke: append
                                }
                            }
                        } // End Invoke: if
                    } else {
                        { // Invoke: append buffer $catch_body_buffer
                            TclObject[] objv161 = TJC.grabObjv(interp, 1);
                            TclObject tmp162;
                            try {
                                // Arg 2 variable: $catch_body_buffer
                                tmp162 = getVarScalar(interp, "catch_body_buffer", compiledLocals, 14);
                                tmp162.preserve();
                                objv161[0] = tmp162;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv161, compiledLocals, 2);
                            } finally {
                                TJC.releaseObjvElems(interp, objv161, 1);
                            }
                        } // End Invoke: append
                        { // Invoke: append buffer [...]
                            TclObject[] objv163 = TJC.grabObjv(interp, 1);
                            TclObject tmp164;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: ... $code_tmpsymbol false
                                    TclObject[] objv165 = TJC.grabObjv(interp, 3);
                                    TclObject tmp166;
                                    try {
                                        // Arg 0 constant: ...
                                        objv165[0] = const25;
                                        // Arg 1 variable: $code_tmpsymbol
                                        tmp166 = getVarScalar(interp, "code_tmpsymbol", compiledLocals, 15);
                                        tmp166.preserve();
                                        objv165[1] = tmp166;
                                        // Arg 2 constant: false
                                        objv165[2] = const23;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache15_cmdEpoch == cmdcache15.cmdEpoch)
                                            ? cmdcache15.cmd : null), objv165, 0);
                                        if ( cmdcache15_cmdEpoch != cmdcache15.cmdEpoch ) {
                                            updateCmdCache(interp, 15);
                                        }
                                    } finally {
                                        tmp166 = objv165[1];
                                        if ( tmp166 != null ) {
                                            tmp166.release();
                                        }
                                        TJC.releaseObjv(interp, objv165, 3);
                                    }
                                } // End Invoke: ...
                                tmp164 = interp.getResult();
                                tmp164.preserve();
                                objv163[0] = tmp164;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv163, compiledLocals, 2);
                            } finally {
                                TJC.releaseObjvElems(interp, objv163, 1);
                            }
                        } // End Invoke: append
                    }
                } // End Invoke: if
            }
        } // End Invoke: if
        { // Invoke: return $buffer
            TclObject tmp167 = getVarScalar(interp, "buffer", compiledLocals, 2);
            interp.resetResult();
            interp.setResult(tmp167);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_emit_container_catch");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;
    TclObject const19;
    TclObject const20;
    TclObject const21;
    TclObject const22;
    TclObject const23;
    TclObject const24;
    TclObject const25;
    TclObject const26;
    TclObject const27;
    TclObject const28;
    TclObject const29;
    TclObject const30;
    TclObject const31;
    TclObject const32;
    TclObject const33;
    TclObject const34;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("descend_container_is_valid");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("descend_container_is_static");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("error");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("descend_commands");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("container");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("descend_container_catch_has_variable");
        const6.preserve(); const6.preserve();
        const7 = TclInteger.newInstance(1);
        const7.preserve(); const7.preserve();
        const8 = TclInteger.newInstance(0);
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("descend_container_catch_variable");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("compileproc_can_inline_variable_access");
        const10.preserve(); const10.preserve();
        const11 = TclInteger.newInstance(2);
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("compileproc_emit_argument");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("true");
        TclBoolean.get(interp, const13);
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("compileproc_tmpvar_next");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("emitter_statement");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("emitter_indent_level");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("+1");
        TclInteger.get(interp, const17);
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance("compileproc_set_variable");
        const18.preserve(); const18.preserve();
        const19 = TclInteger.newInstance(-1);
        const19.preserve(); const19.preserve();
        const20 = TclString.newInstance("compileproc_container_catch_handler_var");
        const20.preserve(); const20.preserve();
        const21 = TclString.newInstance("compileproc_get_set_nonconstant_array_variable");
        const21.preserve(); const21.preserve();
        const22 = TclString.newInstance("set");
        const22.preserve(); const22.preserve();
        const23 = TclString.newInstance("false");
        TclBoolean.get(interp, const23);
        const23.preserve(); const23.preserve();
        const24 = TclString.newInstance("\"\"");
        const24.preserve(); const24.preserve();
        const25 = TclString.newInstance("compileproc_container_catch_handler_novar");
        const25.preserve(); const25.preserve();
        const26 = TclString.newInstance("code");
        const26.preserve(); const26.preserve();
        const27 = TclString.newInstance("emitter_container_catch_try_start");
        const27.preserve(); const27.preserve();
        const28 = TclString.newInstance("emitter_container_fake_tclexception");
        const28.preserve(); const28.preserve();
        const29 = TclString.newInstance("compileproc_push_controls_context");
        const29.preserve(); const29.preserve();
        const30 = TclString.newInstance("catch");
        const30.preserve(); const30.preserve();
        const31 = TclString.newInstance("compileproc_emit_invoke");
        const31.preserve(); const31.preserve();
        const32 = TclString.newInstance("compileproc_pop_controls_context");
        const32.preserve(); const32.preserve();
        const33 = TclString.newInstance("emitter_container_catch_try_end");
        const33.preserve(); const33.preserve();
        const34 = TclString.newInstance("result");
        const34.preserve(); const34.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;
    WrappedCommand cmdcache9;
    int cmdcache9_cmdEpoch;
    WrappedCommand cmdcache10;
    int cmdcache10_cmdEpoch;
    WrappedCommand cmdcache11;
    int cmdcache11_cmdEpoch;
    WrappedCommand cmdcache12;
    int cmdcache12_cmdEpoch;
    WrappedCommand cmdcache13;
    int cmdcache13_cmdEpoch;
    WrappedCommand cmdcache14;
    int cmdcache14_cmdEpoch;
    WrappedCommand cmdcache15;
    int cmdcache15_cmdEpoch;
    WrappedCommand cmdcache16;
    int cmdcache16_cmdEpoch;
    WrappedCommand cmdcache17;
    int cmdcache17_cmdEpoch;
    WrappedCommand cmdcache18;
    int cmdcache18_cmdEpoch;
    WrappedCommand cmdcache19;
    int cmdcache19_cmdEpoch;
    WrappedCommand cmdcache20;
    int cmdcache20_cmdEpoch;
    WrappedCommand cmdcache21;
    int cmdcache21_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                cmdcache9 = TJC.INVALID_COMMAND_CACHE;
                cmdcache9_cmdEpoch = 0;
                cmdcache10 = TJC.INVALID_COMMAND_CACHE;
                cmdcache10_cmdEpoch = 0;
                cmdcache11 = TJC.INVALID_COMMAND_CACHE;
                cmdcache11_cmdEpoch = 0;
                cmdcache12 = TJC.INVALID_COMMAND_CACHE;
                cmdcache12_cmdEpoch = 0;
                cmdcache13 = TJC.INVALID_COMMAND_CACHE;
                cmdcache13_cmdEpoch = 0;
                cmdcache14 = TJC.INVALID_COMMAND_CACHE;
                cmdcache14_cmdEpoch = 0;
                cmdcache15 = TJC.INVALID_COMMAND_CACHE;
                cmdcache15_cmdEpoch = 0;
                cmdcache16 = TJC.INVALID_COMMAND_CACHE;
                cmdcache16_cmdEpoch = 0;
                cmdcache17 = TJC.INVALID_COMMAND_CACHE;
                cmdcache17_cmdEpoch = 0;
                cmdcache18 = TJC.INVALID_COMMAND_CACHE;
                cmdcache18_cmdEpoch = 0;
                cmdcache19 = TJC.INVALID_COMMAND_CACHE;
                cmdcache19_cmdEpoch = 0;
                cmdcache20 = TJC.INVALID_COMMAND_CACHE;
                cmdcache20_cmdEpoch = 0;
                cmdcache21 = TJC.INVALID_COMMAND_CACHE;
                cmdcache21_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "descend_container_is_valid";
                break;
            }
            case 2: {
                cmdName = "descend_container_is_static";
                break;
            }
            case 3: {
                cmdName = "error";
                break;
            }
            case 4: {
                cmdName = "descend_commands";
                break;
            }
            case 5: {
                cmdName = "descend_container_catch_has_variable";
                break;
            }
            case 6: {
                cmdName = "descend_container_catch_variable";
                break;
            }
            case 7: {
                cmdName = "compileproc_can_inline_variable_access";
                break;
            }
            case 8: {
                cmdName = "compileproc_emit_argument";
                break;
            }
            case 9: {
                cmdName = "compileproc_tmpvar_next";
                break;
            }
            case 10: {
                cmdName = "emitter_statement";
                break;
            }
            case 11: {
                cmdName = "emitter_indent_level";
                break;
            }
            case 12: {
                cmdName = "compileproc_set_variable";
                break;
            }
            case 13: {
                cmdName = "compileproc_container_catch_handler_var";
                break;
            }
            case 14: {
                cmdName = "compileproc_get_set_nonconstant_array_variable";
                break;
            }
            case 15: {
                cmdName = "compileproc_container_catch_handler_novar";
                break;
            }
            case 16: {
                cmdName = "emitter_container_catch_try_start";
                break;
            }
            case 17: {
                cmdName = "emitter_container_fake_tclexception";
                break;
            }
            case 18: {
                cmdName = "compileproc_push_controls_context";
                break;
            }
            case 19: {
                cmdName = "compileproc_emit_invoke";
                break;
            }
            case 20: {
                cmdName = "compileproc_pop_controls_context";
                break;
            }
            case 21: {
                cmdName = "emitter_container_catch_try_end";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
            case 9: {
                cmdcache9 = lwcmd;
                cmdcache9_cmdEpoch = cmdEpoch;
                break;
            }
            case 10: {
                cmdcache10 = lwcmd;
                cmdcache10_cmdEpoch = cmdEpoch;
                break;
            }
            case 11: {
                cmdcache11 = lwcmd;
                cmdcache11_cmdEpoch = cmdEpoch;
                break;
            }
            case 12: {
                cmdcache12 = lwcmd;
                cmdcache12_cmdEpoch = cmdEpoch;
                break;
            }
            case 13: {
                cmdcache13 = lwcmd;
                cmdcache13_cmdEpoch = cmdEpoch;
                break;
            }
            case 14: {
                cmdcache14 = lwcmd;
                cmdcache14_cmdEpoch = cmdEpoch;
                break;
            }
            case 15: {
                cmdcache15 = lwcmd;
                cmdcache15_cmdEpoch = cmdEpoch;
                break;
            }
            case 16: {
                cmdcache16 = lwcmd;
                cmdcache16_cmdEpoch = cmdEpoch;
                break;
            }
            case 17: {
                cmdcache17 = lwcmd;
                cmdcache17_cmdEpoch = cmdEpoch;
                break;
            }
            case 18: {
                cmdcache18 = lwcmd;
                cmdcache18_cmdEpoch = cmdEpoch;
                break;
            }
            case 19: {
                cmdcache19 = lwcmd;
                cmdcache19_cmdEpoch = cmdEpoch;
                break;
            }
            case 20: {
                cmdcache20 = lwcmd;
                cmdcache20_cmdEpoch = cmdEpoch;
                break;
            }
            case 21: {
                cmdcache21 = lwcmd;
                cmdcache21_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "_compileproc",
        "buffer",
        "body_keys",
        "has_variable",
        "has_static_varname",
        "has_static_array_varname",
        "vinfo",
        "static_varname",
        "tuple",
        "tclobject_symbol",
        "varsymbol",
        "set_var_buffer",
        "gs_buffers",
        "catch_body_buffer",
        "code_tmpsymbol",
        "body_key"
    };
} // end class CompileprocEmitContainerCatchCmd

