// TJC implementation of procedure compileproc_emit_container_switch_constant
package tjc;
import tcl.lang.*;

public class CompileprocEmitContainerSwitchConstantCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 27, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 3) {
            throw new TclNumArgsException(interp, 1, objv, "key string_tmpsymbol");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        setVarScalar(interp, "string_tmpsymbol", objv[2], compiledLocals, 1);
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set body_keys [...]
            TclObject tmp0;
            { // Invoke: descend_commands $key container
                TclObject[] objv1 = TJC.grabObjv(interp, 3);
                TclObject tmp2;
                try {
                    // Arg 0 constant: descend_commands
                    objv1[0] = const1;
                    // Arg 1 variable: $key
                    tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    // Arg 2 constant: container
                    objv1[2] = const2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 3);
                }
            } // End Invoke: descend_commands
            tmp0 = interp.getResult();
            setVarScalar(interp, "body_keys", tmp0, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set pbIndexes [...]
            TclObject tmp3;
            { // Invoke: ... $key
                TclObject[] objv4 = TJC.grabObjv(interp, 2);
                TclObject tmp5;
                try {
                    // Arg 0 constant: ...
                    objv4[0] = const3;
                    // Arg 1 variable: $key
                    tmp5 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp5.preserve();
                    objv4[1] = tmp5;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv4, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp5 = objv4[1];
                    if ( tmp5 != null ) {
                        tmp5.release();
                    }
                    TJC.releaseObjv(interp, objv4, 2);
                }
            } // End Invoke: ...
            tmp3 = interp.getResult();
            setVarScalar(interp, "pbIndexes", tmp3, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set length "..."
            TclObject tmp6;
            StringBuffer sbtmp7 = new StringBuffer(64);
            tmp6 = getVarScalar(interp, "string_tmpsymbol", compiledLocals, 1);
            sbtmp7.append(tmp6.toString());
            sbtmp7.append("_length");
            tmp6 = TclString.newInstance(sbtmp7);
            setVarScalar(interp, "length", tmp6, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set first "..."
            TclObject tmp8;
            StringBuffer sbtmp9 = new StringBuffer(64);
            tmp8 = getVarScalar(interp, "string_tmpsymbol", compiledLocals, 1);
            sbtmp9.append(tmp8.toString());
            sbtmp9.append("_first");
            tmp8 = TclString.newInstance(sbtmp9);
            setVarScalar(interp, "first", tmp8, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: append buffer [...] "int " $length " = " $string_tmpsymbol ... [...] "char " $first ... [...] [...] $first " = " $string_tmpsymbol ... [...]
            TclObject[] objv10 = TJC.grabObjv(interp, 17);
            TclObject tmp11;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv12 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv12[0] = const4;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv12, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv12, 1);
                    }
                } // End Invoke: emitter_indent
                tmp11 = interp.getResult();
                tmp11.preserve();
                objv10[0] = tmp11;
                // Arg 3 constant: "int "
                objv10[1] = const5;
                // Arg 4 variable: $length
                tmp11 = getVarScalar(interp, "length", compiledLocals, 5);
                tmp11.preserve();
                objv10[2] = tmp11;
                // Arg 5 constant: " = "
                objv10[3] = const6;
                // Arg 6 variable: $string_tmpsymbol
                tmp11 = getVarScalar(interp, "string_tmpsymbol", compiledLocals, 1);
                tmp11.preserve();
                objv10[4] = tmp11;
                // Arg 7 constant: ...
                objv10[5] = const7;
                // Arg 8 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv13 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv13[0] = const4;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv13, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv13, 1);
                    }
                } // End Invoke: emitter_indent
                tmp11 = interp.getResult();
                tmp11.preserve();
                objv10[6] = tmp11;
                // Arg 9 constant: "char "
                objv10[7] = const8;
                // Arg 10 variable: $first
                tmp11 = getVarScalar(interp, "first", compiledLocals, 6);
                tmp11.preserve();
                objv10[8] = tmp11;
                // Arg 11 constant: ...
                objv10[9] = const9;
                // Arg 12 command: [...]
                { // Invoke: ... "$length > 0"
                    TclObject[] objv14 = TJC.grabObjv(interp, 2);
                    TclObject tmp15;
                    try {
                        // Arg 0 constant: ...
                        objv14[0] = const10;
                        // Arg 1 word: "$length > 0"
                        StringBuffer sbtmp16 = new StringBuffer(64);
                        tmp15 = getVarScalar(interp, "length", compiledLocals, 5);
                        sbtmp16.append(tmp15.toString());
                        sbtmp16.append(" > 0");
                        tmp15 = TclString.newInstance(sbtmp16);
                        tmp15.preserve();
                        objv14[1] = tmp15;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                            ? cmdcache4.cmd : null), objv14, 0);
                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                            updateCmdCache(interp, 4);
                        }
                    } finally {
                        tmp15 = objv14[1];
                        if ( tmp15 != null ) {
                            tmp15.release();
                        }
                        TJC.releaseObjv(interp, objv14, 2);
                    }
                } // End Invoke: ...
                tmp11 = interp.getResult();
                tmp11.preserve();
                objv10[10] = tmp11;
                // Arg 13 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv17 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv17[0] = const4;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv17, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv17, 1);
                    }
                } // End Invoke: emitter_indent
                tmp11 = interp.getResult();
                tmp11.preserve();
                objv10[11] = tmp11;
                // Arg 14 variable: $first
                tmp11 = getVarScalar(interp, "first", compiledLocals, 6);
                tmp11.preserve();
                objv10[12] = tmp11;
                // Arg 15 constant: " = "
                objv10[13] = const6;
                // Arg 16 variable: $string_tmpsymbol
                tmp11 = getVarScalar(interp, "string_tmpsymbol", compiledLocals, 1);
                tmp11.preserve();
                objv10[14] = tmp11;
                // Arg 17 constant: ...
                objv10[15] = const11;
                // Arg 18 command: [...]
                { // Invoke: ...
                    TclObject[] objv18 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: ...
                        objv18[0] = const12;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                            ? cmdcache5.cmd : null), objv18, 0);
                        if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                            updateCmdCache(interp, 5);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv18, 1);
                    }
                } // End Invoke: ...
                tmp11 = interp.getResult();
                tmp11.preserve();
                objv10[16] = tmp11;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv10, compiledLocals, 2);
            } finally {
                objv10[1] = null;
                objv10[3] = null;
                objv10[5] = null;
                objv10[7] = null;
                objv10[9] = null;
                objv10[13] = null;
                objv10[15] = null;
                TJC.releaseObjvElems(interp, objv10, 17);
            }
        } // End Invoke: append
        { // Invoke: if ... ...
            // Unary operator: ! [...]
            { // Invoke: ... $key
                TclObject[] objv19 = TJC.grabObjv(interp, 2);
                TclObject tmp20;
                try {
                    // Arg 0 constant: ...
                    objv19[0] = const13;
                    // Arg 1 variable: $key
                    tmp20 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp20.preserve();
                    objv19[1] = tmp20;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                        ? cmdcache6.cmd : null), objv19, 0);
                    if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                        updateCmdCache(interp, 6);
                    }
                } finally {
                    tmp20 = objv19[1];
                    if ( tmp20 != null ) {
                        tmp20.release();
                    }
                    TJC.releaseObjv(interp, objv19, 2);
                }
            } // End Invoke: ...
            TclObject tmp21 = interp.getResult();
            ExprValue tmp22 = evs0;
            if ( tmp21.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp22, tmp21);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp22, tmp21);
            }
            // End Unary operator: !
            boolean tmp23 = ( tmp22.getIntValue() != 0 );
            if ( tmp23 ) {
                { // Invoke: append buffer [...]
                    TclObject[] objv24 = TJC.grabObjv(interp, 1);
                    TclObject tmp25;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: emitter_reset_result
                            TclObject[] objv26 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: emitter_reset_result
                                objv26[0] = const14;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                    ? cmdcache7.cmd : null), objv26, 0);
                                if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                    updateCmdCache(interp, 7);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv26, 1);
                            }
                        } // End Invoke: emitter_reset_result
                        tmp25 = interp.getResult();
                        tmp25.preserve();
                        objv24[0] = tmp25;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv24, compiledLocals, 2);
                    } finally {
                        TJC.releaseObjvElems(interp, objv24, 1);
                    }
                } // End Invoke: append
            }
        } // End Invoke: if
        { // Invoke: emitter_indent_level +2
            TclObject[] objv27 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv27[0] = const15;
                // Arg 1 constant: +2
                objv27[1] = const16;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                    ? cmdcache8.cmd : null), objv27, 0);
                if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                    updateCmdCache(interp, 8);
                }
            } finally {
                TJC.releaseObjv(interp, objv27, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: set spacer2 [...]
            TclObject tmp28;
            { // Invoke: emitter_indent
                TclObject[] objv29 = TJC.grabObjv(interp, 1);
                try {
                    // Arg 0 constant: emitter_indent
                    objv29[0] = const4;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv29, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv29, 1);
                }
            } // End Invoke: emitter_indent
            tmp28 = interp.getResult();
            setVarScalar(interp, "spacer2", tmp28, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: emitter_indent_level -1
            TclObject[] objv30 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv30[0] = const15;
                // Arg 1 constant: -1
                objv30[1] = const17;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                    ? cmdcache8.cmd : null), objv30, 0);
                if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                    updateCmdCache(interp, 8);
                }
            } finally {
                TJC.releaseObjv(interp, objv30, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: set spacer1 [...]
            TclObject tmp31;
            { // Invoke: emitter_indent
                TclObject[] objv32 = TJC.grabObjv(interp, 1);
                try {
                    // Arg 0 constant: emitter_indent
                    objv32[0] = const4;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv32, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv32, 1);
                }
            } // End Invoke: emitter_indent
            tmp31 = interp.getResult();
            setVarScalar(interp, "spacer1", tmp31, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: emitter_indent_level -1
            TclObject[] objv33 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv33[0] = const15;
                // Arg 1 constant: -1
                objv33[1] = const17;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                    ? cmdcache8.cmd : null), objv33, 0);
                if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                    updateCmdCache(interp, 8);
                }
            } finally {
                TJC.releaseObjv(interp, objv33, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: set i 0
            setVarScalar(interp, "i", const18, compiledLocals, 9);
        } // End Invoke: set
        { // Invoke: set last_pattern [...]
            TclObject tmp34;
            { // Invoke: lindex $pbIndexes end-1
                TclObject tmp35 = null;
                TclObject tmp36;
                try {
                    tmp35 = getVarScalar(interp, "pbIndexes", compiledLocals, 4);
                    tmp35.preserve();
                    tmp36 = const19;
                    TJC.lindexNonconst(interp, tmp35, tmp36);
                } finally {
                    if ( tmp35 != null ) {
                        tmp35.release();
                    }
                }
            } // End Invoke: lindex
            tmp34 = interp.getResult();
            setVarScalar(interp, "last_pattern", tmp34, compiledLocals, 10);
        } // End Invoke: set
        { // Invoke: set ifnum 0
            setVarScalar(interp, "ifnum", const18, compiledLocals, 11);
        } // End Invoke: set
        { // Invoke: set ... ""
            setVarScalar(interp, "fallthrough_expression", const0, compiledLocals, 12);
        } // End Invoke: set
        { // Invoke: foreach {patIndex bodyIndex} $pbIndexes ...
            TclObject tmp37 = null;
            try {
                tmp37 = getVarScalar(interp, "pbIndexes", compiledLocals, 4);
                tmp37.preserve();
                final int tmp37_length = TclList.getLength(interp, tmp37);

                for ( int index38 = 0 ; index38 < tmp37_length ; index38 += 2 ) {
                    TclObject tmp39 = null;
                    if ( index38 < tmp37_length ) {
                        tmp39 = TclList.index(interp, tmp37, index38);
                    }
                    TclObject tmp40 = null;
                    if ( index38 + 1 < tmp37_length ) {
                        tmp40 = TclList.index(interp, tmp37, index38 + 1);
                    }
                    try {
                        if ( tmp39 == null ) {
                            setVarScalar(interp, "patIndex", "", compiledLocals, 13);
                        } else {
                            setVarScalar(interp, "patIndex", tmp39, compiledLocals, 13);
                        }
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "patIndex");
                    }
                    try {
                        if ( tmp40 == null ) {
                            setVarScalar(interp, "bodyIndex", "", compiledLocals, 14);
                        } else {
                            setVarScalar(interp, "bodyIndex", tmp40, compiledLocals, 14);
                        }
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "bodyIndex");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: set tuple [...]
                        TclObject tmp41;
                        { // Invoke: ... $key $patIndex
                            TclObject[] objv42 = TJC.grabObjv(interp, 3);
                            TclObject tmp43;
                            try {
                                // Arg 0 constant: ...
                                objv42[0] = const20;
                                // Arg 1 variable: $key
                                tmp43 = getVarScalar(interp, "key", compiledLocals, 0);
                                tmp43.preserve();
                                objv42[1] = tmp43;
                                // Arg 2 variable: $patIndex
                                tmp43 = getVarScalar(interp, "patIndex", compiledLocals, 13);
                                tmp43.preserve();
                                objv42[2] = tmp43;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                                    ? cmdcache9.cmd : null), objv42, 0);
                                if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                                    updateCmdCache(interp, 9);
                                }
                            } finally {
                                tmp43 = objv42[1];
                                if ( tmp43 != null ) {
                                    tmp43.release();
                                }
                                tmp43 = objv42[2];
                                if ( tmp43 != null ) {
                                    tmp43.release();
                                }
                                TJC.releaseObjv(interp, objv42, 3);
                            }
                        } // End Invoke: ...
                        tmp41 = interp.getResult();
                        setVarScalar(interp, "tuple", tmp41, compiledLocals, 15);
                    } // End Invoke: set
                    { // Invoke: set pattern [...]
                        TclObject tmp44;
                        { // Invoke: lindex $tuple 1
                            TclObject tmp45 = getVarScalar(interp, "tuple", compiledLocals, 15);
                            tmp45 = TclList.index(interp, tmp45, 1);
                            if ( tmp45 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp45);
                            }
                        } // End Invoke: lindex
                        tmp44 = interp.getResult();
                        setVarScalar(interp, "pattern", tmp44, compiledLocals, 16);
                    } // End Invoke: set
                    { // Invoke: set cmap [...]
                        TclObject tmp46;
                        { // Invoke: lindex $tuple 3
                            TclObject tmp47 = getVarScalar(interp, "tuple", compiledLocals, 15);
                            tmp47 = TclList.index(interp, tmp47, 3);
                            if ( tmp47 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp47);
                            }
                        } // End Invoke: lindex
                        tmp46 = interp.getResult();
                        setVarScalar(interp, "cmap", tmp46, compiledLocals, 17);
                    } // End Invoke: set
                    { // Invoke: if {$cmap == {}} ... else ...
                        // Binary operator: $cmap == ""
                        TclObject tmp48 = getVarScalar(interp, "cmap", compiledLocals, 17);
                        ExprValue tmp49 = evs0;
                        TJC.exprEqualsEmptyString(tmp49, tmp48, false);
                        // End Binary operator: ==
                        boolean tmp50 = ( tmp49.getIntValue() != 0 );
                        if ( tmp50 ) {
                            { // Invoke: set pattern_first [...]
                                TclObject tmp51;
                                { // Invoke: string index $pattern 0
                                    TclObject tmp52 = getVarScalar(interp, "pattern", compiledLocals, 16);
                                    String tmp53 = tmp52.toString();
                                    TclObject tmp54 = TJC.stringIndex(interp, tmp53, const18);
                                    interp.setResult(tmp54);
                                } // End Invoke: string
                                tmp51 = interp.getResult();
                                setVarScalar(interp, "pattern_first", tmp51, compiledLocals, 18);
                            } // End Invoke: set
                            { // Invoke: set pattern_len [...]
                                TclObject tmp55;
                                { // Invoke: string length $pattern
                                    TclObject tmp56 = getVarScalar(interp, "pattern", compiledLocals, 16);
                                    int tmp57 = tmp56.toString().length();
                                    interp.setResult(tmp57);
                                } // End Invoke: string
                                tmp55 = interp.getResult();
                                setVarScalar(interp, "pattern_len", tmp55, compiledLocals, 19);
                            } // End Invoke: set
                        } else {
                            { // Invoke: set first_num_characters [...]
                                TclObject tmp58;
                                { // Invoke: lindex $cmap 0
                                    TclObject tmp59 = getVarScalar(interp, "cmap", compiledLocals, 17);
                                    tmp59 = TclList.index(interp, tmp59, 0);
                                    if ( tmp59 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp59);
                                    }
                                } // End Invoke: lindex
                                tmp58 = interp.getResult();
                                setVarScalar(interp, "first_num_characters", tmp58, compiledLocals, 20);
                            } // End Invoke: set
                            { // Invoke: set first_end_index [...]
                                TclObject tmp60;
                                { // Invoke: expr ...
                                    // Binary operator: $first_num_characters - 1
                                    TclObject tmp61 = getVarScalar(interp, "first_num_characters", compiledLocals, 20);
                                    ExprValue tmp62 = evs0;
                                    TJC.exprInitValue(interp, tmp62, tmp61);
                                    ExprValue tmp63 = evs1;
                                    tmp63.setIntValue(1);
                                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MINUS, tmp62, tmp63);
                                    // End Binary operator: -
                                    TJC.exprSetResult(interp, tmp62);
                                } // End Invoke: expr
                                tmp60 = interp.getResult();
                                setVarScalar(interp, "first_end_index", tmp60, compiledLocals, 21);
                            } // End Invoke: set
                            { // Invoke: set pattern_first [...]
                                TclObject tmp64;
                                { // Invoke: string range $pattern 0 $first_end_index
                                    TclObject tmp65 = getVarScalar(interp, "pattern", compiledLocals, 16);
                                    String tmp66 = tmp65.toString();
                                    TclObject tmp67 = const18;
                                    tmp67.preserve();
                                    TclObject tmp68 = getVarScalar(interp, "first_end_index", compiledLocals, 21);
                                    TclObject tmp69 = TJC.stringRange(interp, tmp66, tmp67, tmp68);
                                    interp.setResult(tmp69);
                                } // End Invoke: string
                                tmp64 = interp.getResult();
                                setVarScalar(interp, "pattern_first", tmp64, compiledLocals, 18);
                            } // End Invoke: set
                            { // Invoke: set pattern_len [...]
                                TclObject tmp70;
                                { // Invoke: llength $cmap
                                    TclObject tmp71 = getVarScalar(interp, "cmap", compiledLocals, 17);
                                    int tmp72 = TclList.getLength(interp, tmp71);
                                    interp.setResult(tmp72);
                                } // End Invoke: llength
                                tmp70 = interp.getResult();
                                setVarScalar(interp, "pattern_len", tmp70, compiledLocals, 19);
                            } // End Invoke: set
                        }
                    } // End Invoke: if
                    { // Invoke: set pattern_jstr [...]
                        TclObject tmp73;
                        { // Invoke: ... $pattern
                            TclObject[] objv74 = TJC.grabObjv(interp, 2);
                            TclObject tmp75;
                            try {
                                // Arg 0 constant: ...
                                objv74[0] = const21;
                                // Arg 1 variable: $pattern
                                tmp75 = getVarScalar(interp, "pattern", compiledLocals, 16);
                                tmp75.preserve();
                                objv74[1] = tmp75;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                    ? cmdcache10.cmd : null), objv74, 0);
                                if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                    updateCmdCache(interp, 10);
                                }
                            } finally {
                                tmp75 = objv74[1];
                                if ( tmp75 != null ) {
                                    tmp75.release();
                                }
                                TJC.releaseObjv(interp, objv74, 2);
                            }
                        } // End Invoke: ...
                        tmp73 = interp.getResult();
                        setVarScalar(interp, "pattern_jstr", tmp73, compiledLocals, 22);
                    } // End Invoke: set
                    { // Invoke: set pattern_first_jstr [...]
                        TclObject tmp76;
                        { // Invoke: ... $pattern_first
                            TclObject[] objv77 = TJC.grabObjv(interp, 2);
                            TclObject tmp78;
                            try {
                                // Arg 0 constant: ...
                                objv77[0] = const21;
                                // Arg 1 variable: $pattern_first
                                tmp78 = getVarScalar(interp, "pattern_first", compiledLocals, 18);
                                tmp78.preserve();
                                objv77[1] = tmp78;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                    ? cmdcache10.cmd : null), objv77, 0);
                                if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                    updateCmdCache(interp, 10);
                                }
                            } finally {
                                tmp78 = objv77[1];
                                if ( tmp78 != null ) {
                                    tmp78.release();
                                }
                                TJC.releaseObjv(interp, objv77, 2);
                            }
                        } // End Invoke: ...
                        tmp76 = interp.getResult();
                        setVarScalar(interp, "pattern_first_jstr", tmp76, compiledLocals, 23);
                    } // End Invoke: set
                    { // Invoke: set expression ""
                        setVarScalar(interp, "expression", const0, compiledLocals, 24);
                    } // End Invoke: set
                    { // Invoke: if {$pattern_len > 0} ... else ...
                        // Binary operator: $pattern_len > 0
                        TclObject tmp79 = getVarScalar(interp, "pattern_len", compiledLocals, 19);
                        ExprValue tmp80 = evs0;
                        TJC.exprInitValue(interp, tmp80, tmp79);
                        ExprValue tmp81 = evs1;
                        tmp81.setIntValue(0);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GREATER, tmp80, tmp81);
                        // End Binary operator: >
                        boolean tmp82 = ( tmp80.getIntValue() != 0 );
                        if ( tmp82 ) {
                            { // Invoke: append expression $length " == " $pattern_len " && " $first " == '" $pattern_first_jstr "'"
                                TclObject[] objv83 = TJC.grabObjv(interp, 8);
                                TclObject tmp84;
                                try {
                                    // Arg 2 variable: $length
                                    tmp84 = getVarScalar(interp, "length", compiledLocals, 5);
                                    tmp84.preserve();
                                    objv83[0] = tmp84;
                                    // Arg 3 constant: " == "
                                    objv83[1] = const22;
                                    // Arg 4 variable: $pattern_len
                                    tmp84 = getVarScalar(interp, "pattern_len", compiledLocals, 19);
                                    tmp84.preserve();
                                    objv83[2] = tmp84;
                                    // Arg 5 constant: " && "
                                    objv83[3] = const23;
                                    // Arg 6 variable: $first
                                    tmp84 = getVarScalar(interp, "first", compiledLocals, 6);
                                    tmp84.preserve();
                                    objv83[4] = tmp84;
                                    // Arg 7 constant: " == '"
                                    objv83[5] = const24;
                                    // Arg 8 variable: $pattern_first_jstr
                                    tmp84 = getVarScalar(interp, "pattern_first_jstr", compiledLocals, 23);
                                    tmp84.preserve();
                                    objv83[6] = tmp84;
                                    // Arg 9 constant: "'"
                                    objv83[7] = const25;
                                    interp.resetResult();
                                    appendVarScalar(interp, "expression", objv83, compiledLocals, 24);
                                } finally {
                                    tmp84 = objv83[0];
                                    if ( tmp84 != null ) {
                                        tmp84.release();
                                    }
                                    tmp84 = objv83[2];
                                    if ( tmp84 != null ) {
                                        tmp84.release();
                                    }
                                    tmp84 = objv83[4];
                                    if ( tmp84 != null ) {
                                        tmp84.release();
                                    }
                                    tmp84 = objv83[6];
                                    if ( tmp84 != null ) {
                                        tmp84.release();
                                    }
                                    TJC.releaseObjv(interp, objv83, 8);
                                }
                            } // End Invoke: append
                            { // Invoke: if {$pattern_len > 1} ...
                                // Binary operator: $pattern_len > 1
                                TclObject tmp85 = getVarScalar(interp, "pattern_len", compiledLocals, 19);
                                ExprValue tmp86 = evs0;
                                TJC.exprInitValue(interp, tmp86, tmp85);
                                ExprValue tmp87 = evs1;
                                tmp87.setIntValue(1);
                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GREATER, tmp86, tmp87);
                                // End Binary operator: >
                                boolean tmp88 = ( tmp86.getIntValue() != 0 );
                                if ( tmp88 ) {
                                    { // Invoke: append expression ... $spacer2 "&& " $string_tmpsymbol ... $pattern_jstr ...
                                        TclObject[] objv89 = TJC.grabObjv(interp, 7);
                                        TclObject tmp90;
                                        try {
                                            // Arg 2 constant: ...
                                            objv89[0] = const26;
                                            // Arg 3 variable: $spacer2
                                            tmp90 = getVarScalar(interp, "spacer2", compiledLocals, 7);
                                            tmp90.preserve();
                                            objv89[1] = tmp90;
                                            // Arg 4 constant: "&& "
                                            objv89[2] = const27;
                                            // Arg 5 variable: $string_tmpsymbol
                                            tmp90 = getVarScalar(interp, "string_tmpsymbol", compiledLocals, 1);
                                            tmp90.preserve();
                                            objv89[3] = tmp90;
                                            // Arg 6 constant: ...
                                            objv89[4] = const28;
                                            // Arg 7 variable: $pattern_jstr
                                            tmp90 = getVarScalar(interp, "pattern_jstr", compiledLocals, 22);
                                            tmp90.preserve();
                                            objv89[5] = tmp90;
                                            // Arg 8 constant: ...
                                            objv89[6] = const29;
                                            interp.resetResult();
                                            appendVarScalar(interp, "expression", objv89, compiledLocals, 24);
                                        } finally {
                                            tmp90 = objv89[1];
                                            if ( tmp90 != null ) {
                                                tmp90.release();
                                            }
                                            tmp90 = objv89[3];
                                            if ( tmp90 != null ) {
                                                tmp90.release();
                                            }
                                            tmp90 = objv89[5];
                                            if ( tmp90 != null ) {
                                                tmp90.release();
                                            }
                                            TJC.releaseObjv(interp, objv89, 7);
                                        }
                                    } // End Invoke: append
                                }
                            } // End Invoke: if
                        } else {
                            { // Invoke: append expression $length " == 0"
                                TclObject[] objv91 = TJC.grabObjv(interp, 2);
                                TclObject tmp92;
                                try {
                                    // Arg 2 variable: $length
                                    tmp92 = getVarScalar(interp, "length", compiledLocals, 5);
                                    tmp92.preserve();
                                    objv91[0] = tmp92;
                                    // Arg 3 constant: " == 0"
                                    objv91[1] = const30;
                                    interp.resetResult();
                                    appendVarScalar(interp, "expression", objv91, compiledLocals, 24);
                                } finally {
                                    tmp92 = objv91[0];
                                    if ( tmp92 != null ) {
                                        tmp92.release();
                                    }
                                    TJC.releaseObjv(interp, objv91, 2);
                                }
                            } // End Invoke: append
                        }
                    } // End Invoke: if
                    { // Invoke: if ... ...
                        { // Invoke: ... $key $bodyIndex
                            TclObject[] objv93 = TJC.grabObjv(interp, 3);
                            TclObject tmp94;
                            try {
                                // Arg 0 constant: ...
                                objv93[0] = const31;
                                // Arg 1 variable: $key
                                tmp94 = getVarScalar(interp, "key", compiledLocals, 0);
                                tmp94.preserve();
                                objv93[1] = tmp94;
                                // Arg 2 variable: $bodyIndex
                                tmp94 = getVarScalar(interp, "bodyIndex", compiledLocals, 14);
                                tmp94.preserve();
                                objv93[2] = tmp94;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache11_cmdEpoch == cmdcache11.cmdEpoch)
                                    ? cmdcache11.cmd : null), objv93, 0);
                                if ( cmdcache11_cmdEpoch != cmdcache11.cmdEpoch ) {
                                    updateCmdCache(interp, 11);
                                }
                            } finally {
                                tmp94 = objv93[1];
                                if ( tmp94 != null ) {
                                    tmp94.release();
                                }
                                tmp94 = objv93[2];
                                if ( tmp94 != null ) {
                                    tmp94.release();
                                }
                                TJC.releaseObjv(interp, objv93, 3);
                            }
                        } // End Invoke: ...
                        TclObject tmp95 = interp.getResult();
                        ExprValue tmp96 = evs0;
                        TJC.exprInitValue(interp, tmp96, tmp95);
                        boolean tmp97 = tmp96.getBooleanValue(interp);
                        if ( tmp97 ) {
                            { // Invoke: if ... ...
                                // Binary operator: [...] != ""
                                { // Invoke: lindex $body_keys $i
                                    TclObject tmp98 = null;
                                    TclObject tmp99;
                                    try {
                                        tmp98 = getVarScalar(interp, "body_keys", compiledLocals, 3);
                                        tmp98.preserve();
                                        tmp99 = getVarScalar(interp, "i", compiledLocals, 9);
                                        TJC.lindexNonconst(interp, tmp98, tmp99);
                                    } finally {
                                        if ( tmp98 != null ) {
                                            tmp98.release();
                                        }
                                    }
                                } // End Invoke: lindex
                                TclObject tmp100 = interp.getResult();
                                ExprValue tmp101 = evs0;
                                TJC.exprEqualsEmptyString(tmp101, tmp100, true);
                                // End Binary operator: !=
                                boolean tmp102 = ( tmp101.getIntValue() != 0 );
                                if ( tmp102 ) {
                                    { // Invoke: error "..."
                                        TclObject[] objv103 = TJC.grabObjv(interp, 2);
                                        TclObject tmp104;
                                        try {
                                            // Arg 0 constant: error
                                            objv103[0] = const32;
                                            // Arg 1 word: "..."
                                            StringBuffer sbtmp105 = new StringBuffer(64);
                                            sbtmp105.append("expected empty body keys for index ");
                                            tmp104 = getVarScalar(interp, "i", compiledLocals, 9);
                                            sbtmp105.append(tmp104.toString());
                                            sbtmp105.append(", got ");
                                            sbtmp105.append("{");
                                            { // Invoke: lindex $body_keys $i
                                                TclObject tmp106 = null;
                                                TclObject tmp107;
                                                try {
                                                    tmp106 = getVarScalar(interp, "body_keys", compiledLocals, 3);
                                                    tmp106.preserve();
                                                    tmp107 = getVarScalar(interp, "i", compiledLocals, 9);
                                                    TJC.lindexNonconst(interp, tmp106, tmp107);
                                                } finally {
                                                    if ( tmp106 != null ) {
                                                        tmp106.release();
                                                    }
                                                }
                                            } // End Invoke: lindex
                                            tmp104 = interp.getResult();
                                            sbtmp105.append(tmp104.toString());
                                            sbtmp105.append("}");
                                            tmp104 = TclString.newInstance(sbtmp105);
                                            tmp104.preserve();
                                            objv103[1] = tmp104;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache12_cmdEpoch == cmdcache12.cmdEpoch)
                                                ? cmdcache12.cmd : null), objv103, 0);
                                            if ( cmdcache12_cmdEpoch != cmdcache12.cmdEpoch ) {
                                                updateCmdCache(interp, 12);
                                            }
                                        } finally {
                                            tmp104 = objv103[1];
                                            if ( tmp104 != null ) {
                                                tmp104.release();
                                            }
                                            TJC.releaseObjv(interp, objv103, 2);
                                        }
                                    } // End Invoke: error
                                }
                            } // End Invoke: if
                            { // Invoke: if ... ...
                                // Binary operator: $fallthrough_expression != ""
                                TclObject tmp108 = getVarScalar(interp, "fallthrough_expression", compiledLocals, 12);
                                ExprValue tmp109 = evs0;
                                TJC.exprEqualsEmptyString(tmp109, tmp108, true);
                                // End Binary operator: !=
                                boolean tmp110 = ( tmp109.getIntValue() != 0 );
                                if ( tmp110 ) {
                                    { // Invoke: append ... $spacer1
                                        TclObject[] objv111 = TJC.grabObjv(interp, 1);
                                        TclObject tmp112;
                                        try {
                                            // Arg 2 variable: $spacer1
                                            tmp112 = getVarScalar(interp, "spacer1", compiledLocals, 8);
                                            tmp112.preserve();
                                            objv111[0] = tmp112;
                                            interp.resetResult();
                                            appendVarScalar(interp, "fallthrough_expression", objv111, compiledLocals, 12);
                                        } finally {
                                            TJC.releaseObjvElems(interp, objv111, 1);
                                        }
                                    } // End Invoke: append
                                }
                            } // End Invoke: if
                            { // Invoke: append ... "( " $expression ...
                                TclObject[] objv113 = TJC.grabObjv(interp, 3);
                                TclObject tmp114;
                                try {
                                    // Arg 2 constant: "( "
                                    objv113[0] = const33;
                                    // Arg 3 variable: $expression
                                    tmp114 = getVarScalar(interp, "expression", compiledLocals, 24);
                                    tmp114.preserve();
                                    objv113[1] = tmp114;
                                    // Arg 4 constant: ...
                                    objv113[2] = const34;
                                    interp.resetResult();
                                    appendVarScalar(interp, "fallthrough_expression", objv113, compiledLocals, 12);
                                } finally {
                                    tmp114 = objv113[1];
                                    if ( tmp114 != null ) {
                                        tmp114.release();
                                    }
                                    TJC.releaseObjv(interp, objv113, 3);
                                }
                            } // End Invoke: append
                            { // Invoke: incr i
                                interp.resetResult();
                                incrVarScalar(interp, "i", 1, compiledLocals, 9);
                            } // End Invoke: incr
                            { // Invoke: continue
                                if ( true ) { continue; }
                            } // End Invoke: continue
                        }
                    } // End Invoke: if
                    { // Invoke: if ... ...
                        // Binary operator: $fallthrough_expression != ""
                        TclObject tmp115 = getVarScalar(interp, "fallthrough_expression", compiledLocals, 12);
                        ExprValue tmp116 = evs0;
                        TJC.exprEqualsEmptyString(tmp116, tmp115, true);
                        // End Binary operator: !=
                        boolean tmp117 = ( tmp116.getIntValue() != 0 );
                        if ( tmp117 ) {
                            { // Invoke: append ... $spacer1 "( " $expression " )"
                                TclObject[] objv118 = TJC.grabObjv(interp, 4);
                                TclObject tmp119;
                                try {
                                    // Arg 2 variable: $spacer1
                                    tmp119 = getVarScalar(interp, "spacer1", compiledLocals, 8);
                                    tmp119.preserve();
                                    objv118[0] = tmp119;
                                    // Arg 3 constant: "( "
                                    objv118[1] = const33;
                                    // Arg 4 variable: $expression
                                    tmp119 = getVarScalar(interp, "expression", compiledLocals, 24);
                                    tmp119.preserve();
                                    objv118[2] = tmp119;
                                    // Arg 5 constant: " )"
                                    objv118[3] = const35;
                                    interp.resetResult();
                                    appendVarScalar(interp, "fallthrough_expression", objv118, compiledLocals, 12);
                                } finally {
                                    tmp119 = objv118[0];
                                    if ( tmp119 != null ) {
                                        tmp119.release();
                                    }
                                    tmp119 = objv118[2];
                                    if ( tmp119 != null ) {
                                        tmp119.release();
                                    }
                                    TJC.releaseObjv(interp, objv118, 4);
                                }
                            } // End Invoke: append
                            { // Invoke: set expression $...
                                TclObject tmp120;
                                tmp120 = getVarScalar(interp, "fallthrough_expression", compiledLocals, 12);
                                setVarScalar(interp, "expression", tmp120, compiledLocals, 24);
                            } // End Invoke: set
                            { // Invoke: set ... ""
                                setVarScalar(interp, "fallthrough_expression", const0, compiledLocals, 12);
                            } // End Invoke: set
                        }
                    } // End Invoke: if
                    { // Invoke: if ... ... elseif {$ifnum == 0} ... else ...
                        // Binary operator: () && ()
                        // Binary operator: $patIndex == $last_pattern
                        TclObject tmp121 = getVarScalar(interp, "patIndex", compiledLocals, 13);
                        ExprValue tmp122 = evs0;
                        TJC.exprInitValue(interp, tmp122, tmp121);
                        TclObject tmp123 = getVarScalar(interp, "last_pattern", compiledLocals, 10);
                        ExprValue tmp124 = evs1;
                        TJC.exprInitValue(interp, tmp124, tmp123);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp122, tmp124);
                        // End Binary operator: ==
                        if (tmp122.getBooleanValue(interp)) {
                        // Binary operator: $pattern == "default"
                        TclObject tmp125 = getVarScalar(interp, "pattern", compiledLocals, 16);
                        boolean tmp126 = tmp125.toString().equals("default");
                        ExprValue tmp127 = evs1;
                        tmp127.setIntValue(tmp126);
                        // End Binary operator: ==
                        tmp122.setIntValue(tmp127.getBooleanValue(interp));
                        } else {
                        tmp122.setIntValue(0);
                        } // End if: ()
                        // End Binary operator: &&
                        boolean tmp128 = ( tmp122.getIntValue() != 0 );
                        if ( tmp128 ) {
                            { // Invoke: if {$ifnum == 0} ... else ...
                                // Binary operator: $ifnum == 0
                                TclObject tmp129 = getVarScalar(interp, "ifnum", compiledLocals, 11);
                                ExprValue tmp130 = evs0;
                                TJC.exprInitValue(interp, tmp130, tmp129);
                                ExprValue tmp131 = evs1;
                                tmp131.setIntValue(0);
                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp130, tmp131);
                                // End Binary operator: ==
                                boolean tmp132 = ( tmp130.getIntValue() != 0 );
                                if ( tmp132 ) {
                                    { // Invoke: append buffer [...]
                                        TclObject[] objv133 = TJC.grabObjv(interp, 1);
                                        TclObject tmp134;
                                        try {
                                            // Arg 2 command: [...]
                                            { // Invoke: ... true
                                                TclObject[] objv135 = TJC.grabObjv(interp, 2);
                                                try {
                                                    // Arg 0 constant: ...
                                                    objv135[0] = const10;
                                                    // Arg 1 constant: true
                                                    objv135[1] = const36;
                                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                        updateCmdCache(interp, 0);
                                                    }
                                                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                        ? cmdcache4.cmd : null), objv135, 0);
                                                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                        updateCmdCache(interp, 4);
                                                    }
                                                } finally {
                                                    TJC.releaseObjv(interp, objv135, 2);
                                                }
                                            } // End Invoke: ...
                                            tmp134 = interp.getResult();
                                            tmp134.preserve();
                                            objv133[0] = tmp134;
                                            interp.resetResult();
                                            appendVarScalar(interp, "buffer", objv133, compiledLocals, 2);
                                        } finally {
                                            TJC.releaseObjvElems(interp, objv133, 1);
                                        }
                                    } // End Invoke: append
                                } else {
                                    { // Invoke: append buffer [...]
                                        TclObject[] objv136 = TJC.grabObjv(interp, 1);
                                        TclObject tmp137;
                                        try {
                                            // Arg 2 command: [...]
                                            { // Invoke: ...
                                                TclObject[] objv138 = TJC.grabObjv(interp, 1);
                                                try {
                                                    // Arg 0 constant: ...
                                                    objv138[0] = const37;
                                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                        updateCmdCache(interp, 0);
                                                    }
                                                    TJC.invoke(interp, ((cmdcache13_cmdEpoch == cmdcache13.cmdEpoch)
                                                        ? cmdcache13.cmd : null), objv138, 0);
                                                    if ( cmdcache13_cmdEpoch != cmdcache13.cmdEpoch ) {
                                                        updateCmdCache(interp, 13);
                                                    }
                                                } finally {
                                                    TJC.releaseObjv(interp, objv138, 1);
                                                }
                                            } // End Invoke: ...
                                            tmp137 = interp.getResult();
                                            tmp137.preserve();
                                            objv136[0] = tmp137;
                                            interp.resetResult();
                                            appendVarScalar(interp, "buffer", objv136, compiledLocals, 2);
                                        } finally {
                                            TJC.releaseObjvElems(interp, objv136, 1);
                                        }
                                    } // End Invoke: append
                                }
                            } // End Invoke: if
                        } else {
                            // Binary operator: $ifnum == 0
                            TclObject tmp139 = getVarScalar(interp, "ifnum", compiledLocals, 11);
                            ExprValue tmp140 = evs0;
                            TJC.exprInitValue(interp, tmp140, tmp139);
                            ExprValue tmp141 = evs1;
                            tmp141.setIntValue(0);
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp140, tmp141);
                            // End Binary operator: ==
                            boolean tmp142 = ( tmp140.getIntValue() != 0 );
                            if ( tmp142 ) {
                                { // Invoke: append buffer [...]
                                    TclObject[] objv143 = TJC.grabObjv(interp, 1);
                                    TclObject tmp144;
                                    try {
                                        // Arg 2 command: [...]
                                        { // Invoke: ... $expression
                                            TclObject[] objv145 = TJC.grabObjv(interp, 2);
                                            TclObject tmp146;
                                            try {
                                                // Arg 0 constant: ...
                                                objv145[0] = const10;
                                                // Arg 1 variable: $expression
                                                tmp146 = getVarScalar(interp, "expression", compiledLocals, 24);
                                                tmp146.preserve();
                                                objv145[1] = tmp146;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                    ? cmdcache4.cmd : null), objv145, 0);
                                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                    updateCmdCache(interp, 4);
                                                }
                                            } finally {
                                                tmp146 = objv145[1];
                                                if ( tmp146 != null ) {
                                                    tmp146.release();
                                                }
                                                TJC.releaseObjv(interp, objv145, 2);
                                            }
                                        } // End Invoke: ...
                                        tmp144 = interp.getResult();
                                        tmp144.preserve();
                                        objv143[0] = tmp144;
                                        interp.resetResult();
                                        appendVarScalar(interp, "buffer", objv143, compiledLocals, 2);
                                    } finally {
                                        TJC.releaseObjvElems(interp, objv143, 1);
                                    }
                                } // End Invoke: append
                            } else {
                                { // Invoke: append buffer [...]
                                    TclObject[] objv147 = TJC.grabObjv(interp, 1);
                                    TclObject tmp148;
                                    try {
                                        // Arg 2 command: [...]
                                        { // Invoke: ... $expression
                                            TclObject[] objv149 = TJC.grabObjv(interp, 2);
                                            TclObject tmp150;
                                            try {
                                                // Arg 0 constant: ...
                                                objv149[0] = const38;
                                                // Arg 1 variable: $expression
                                                tmp150 = getVarScalar(interp, "expression", compiledLocals, 24);
                                                tmp150.preserve();
                                                objv149[1] = tmp150;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache14_cmdEpoch == cmdcache14.cmdEpoch)
                                                    ? cmdcache14.cmd : null), objv149, 0);
                                                if ( cmdcache14_cmdEpoch != cmdcache14.cmdEpoch ) {
                                                    updateCmdCache(interp, 14);
                                                }
                                            } finally {
                                                tmp150 = objv149[1];
                                                if ( tmp150 != null ) {
                                                    tmp150.release();
                                                }
                                                TJC.releaseObjv(interp, objv149, 2);
                                            }
                                        } // End Invoke: ...
                                        tmp148 = interp.getResult();
                                        tmp148.preserve();
                                        objv147[0] = tmp148;
                                        interp.resetResult();
                                        appendVarScalar(interp, "buffer", objv147, compiledLocals, 2);
                                    } finally {
                                        TJC.releaseObjvElems(interp, objv147, 1);
                                    }
                                } // End Invoke: append
                            }
                        }
                    } // End Invoke: if
                    { // Invoke: incr ifnum
                        interp.resetResult();
                        incrVarScalar(interp, "ifnum", 1, compiledLocals, 11);
                    } // End Invoke: incr
                    { // Invoke: set tuple [...]
                        TclObject tmp151;
                        { // Invoke: ... $key $patIndex
                            TclObject[] objv152 = TJC.grabObjv(interp, 3);
                            TclObject tmp153;
                            try {
                                // Arg 0 constant: ...
                                objv152[0] = const39;
                                // Arg 1 variable: $key
                                tmp153 = getVarScalar(interp, "key", compiledLocals, 0);
                                tmp153.preserve();
                                objv152[1] = tmp153;
                                // Arg 2 variable: $patIndex
                                tmp153 = getVarScalar(interp, "patIndex", compiledLocals, 13);
                                tmp153.preserve();
                                objv152[2] = tmp153;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache15_cmdEpoch == cmdcache15.cmdEpoch)
                                    ? cmdcache15.cmd : null), objv152, 0);
                                if ( cmdcache15_cmdEpoch != cmdcache15.cmdEpoch ) {
                                    updateCmdCache(interp, 15);
                                }
                            } finally {
                                tmp153 = objv152[1];
                                if ( tmp153 != null ) {
                                    tmp153.release();
                                }
                                tmp153 = objv152[2];
                                if ( tmp153 != null ) {
                                    tmp153.release();
                                }
                                TJC.releaseObjv(interp, objv152, 3);
                            }
                        } // End Invoke: ...
                        tmp151 = interp.getResult();
                        setVarScalar(interp, "tuple", tmp151, compiledLocals, 15);
                    } // End Invoke: set
                    { // Invoke: set astr [...]
                        TclObject tmp154;
                        { // Invoke: lindex $tuple 1
                            TclObject tmp155 = getVarScalar(interp, "tuple", compiledLocals, 15);
                            tmp155 = TclList.index(interp, tmp155, 1);
                            if ( tmp155 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp155);
                            }
                        } // End Invoke: lindex
                        tmp154 = interp.getResult();
                        setVarScalar(interp, "astr", tmp154, compiledLocals, 25);
                    } // End Invoke: set
                    { // Invoke: append buffer [...] "// Pattern " $astr ...
                        TclObject[] objv156 = TJC.grabObjv(interp, 4);
                        TclObject tmp157;
                        try {
                            // Arg 2 command: [...]
                            { // Invoke: emitter_indent
                                TclObject[] objv158 = TJC.grabObjv(interp, 1);
                                try {
                                    // Arg 0 constant: emitter_indent
                                    objv158[0] = const4;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                        ? cmdcache3.cmd : null), objv158, 0);
                                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                        updateCmdCache(interp, 3);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv158, 1);
                                }
                            } // End Invoke: emitter_indent
                            tmp157 = interp.getResult();
                            tmp157.preserve();
                            objv156[0] = tmp157;
                            // Arg 3 constant: "// Pattern "
                            objv156[1] = const40;
                            // Arg 4 variable: $astr
                            tmp157 = getVarScalar(interp, "astr", compiledLocals, 25);
                            tmp157.preserve();
                            objv156[2] = tmp157;
                            // Arg 5 constant: ...
                            objv156[3] = const26;
                            interp.resetResult();
                            appendVarScalar(interp, "buffer", objv156, compiledLocals, 2);
                        } finally {
                            tmp157 = objv156[0];
                            if ( tmp157 != null ) {
                                tmp157.release();
                            }
                            tmp157 = objv156[2];
                            if ( tmp157 != null ) {
                                tmp157.release();
                            }
                            TJC.releaseObjv(interp, objv156, 4);
                        }
                    } // End Invoke: append
                    { // Invoke: foreach body_key [...] ...
                        TclObject tmp159 = null;
                        try {
                            { // Invoke: lindex $body_keys $i
                                TclObject tmp160 = null;
                                TclObject tmp161;
                                try {
                                    tmp160 = getVarScalar(interp, "body_keys", compiledLocals, 3);
                                    tmp160.preserve();
                                    tmp161 = getVarScalar(interp, "i", compiledLocals, 9);
                                    TJC.lindexNonconst(interp, tmp160, tmp161);
                                } finally {
                                    if ( tmp160 != null ) {
                                        tmp160.release();
                                    }
                                }
                            } // End Invoke: lindex
                            tmp159 = interp.getResult();
                            tmp159.preserve();
                            final int tmp159_length = TclList.getLength(interp, tmp159);

                            for ( int index162 = 0 ; index162 < tmp159_length ; index162++ ) {
                                TclObject tmp163 = TclList.index(interp, tmp159, index162);
                                try {
                                    setVarScalar(interp, "body_key", tmp163, compiledLocals, 26);
                                } catch (TclException ex) {
                                    TJC.foreachVarErr(interp, "body_key");
                                }

                                try {
                                if ( false ) { throw (TclException) null; }
                                { // Invoke: append buffer [...]
                                    TclObject[] objv164 = TJC.grabObjv(interp, 1);
                                    TclObject tmp165;
                                    try {
                                        // Arg 2 command: [...]
                                        { // Invoke: ... $body_key
                                            TclObject[] objv166 = TJC.grabObjv(interp, 2);
                                            TclObject tmp167;
                                            try {
                                                // Arg 0 constant: ...
                                                objv166[0] = const41;
                                                // Arg 1 variable: $body_key
                                                tmp167 = getVarScalar(interp, "body_key", compiledLocals, 26);
                                                tmp167.preserve();
                                                objv166[1] = tmp167;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache16_cmdEpoch == cmdcache16.cmdEpoch)
                                                    ? cmdcache16.cmd : null), objv166, 0);
                                                if ( cmdcache16_cmdEpoch != cmdcache16.cmdEpoch ) {
                                                    updateCmdCache(interp, 16);
                                                }
                                            } finally {
                                                tmp167 = objv166[1];
                                                if ( tmp167 != null ) {
                                                    tmp167.release();
                                                }
                                                TJC.releaseObjv(interp, objv166, 2);
                                            }
                                        } // End Invoke: ...
                                        tmp165 = interp.getResult();
                                        tmp165.preserve();
                                        objv164[0] = tmp165;
                                        interp.resetResult();
                                        appendVarScalar(interp, "buffer", objv164, compiledLocals, 2);
                                    } finally {
                                        TJC.releaseObjvElems(interp, objv164, 1);
                                    }
                                } // End Invoke: append
                                } catch (TclException ex) {
                                    int type = ex.getCompletionCode();
                                    if (type == TCL.BREAK) {
                                        break;
                                    } else if (type == TCL.CONTINUE) {
                                        continue;
                                    } else {
                                        throw ex;
                                    }
                                }
                            }
                        } finally {
                            if ( tmp159 != null ) {
                                tmp159.release();
                            }
                        }
                    } // End Invoke: foreach
                    { // Invoke: incr i
                        interp.resetResult();
                        incrVarScalar(interp, "i", 1, compiledLocals, 9);
                    } // End Invoke: incr
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp37 != null ) {
                    tmp37.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: if ... ...
            // Binary operator: $fallthrough_expression != ""
            TclObject tmp168 = getVarScalar(interp, "fallthrough_expression", compiledLocals, 12);
            ExprValue tmp169 = evs0;
            TJC.exprEqualsEmptyString(tmp169, tmp168, true);
            // End Binary operator: !=
            boolean tmp170 = ( tmp169.getIntValue() != 0 );
            if ( tmp170 ) {
                { // Invoke: error ...
                    TclObject[] objv171 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: error
                        objv171[0] = const32;
                        // Arg 1 constant: ...
                        objv171[1] = const42;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache12_cmdEpoch == cmdcache12.cmdEpoch)
                            ? cmdcache12.cmd : null), objv171, 0);
                        if ( cmdcache12_cmdEpoch != cmdcache12.cmdEpoch ) {
                            updateCmdCache(interp, 12);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv171, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: append buffer [...]
            TclObject[] objv172 = TJC.grabObjv(interp, 1);
            TclObject tmp173;
            try {
                // Arg 2 command: [...]
                { // Invoke: ...
                    TclObject[] objv174 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: ...
                        objv174[0] = const12;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                            ? cmdcache5.cmd : null), objv174, 0);
                        if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                            updateCmdCache(interp, 5);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv174, 1);
                    }
                } // End Invoke: ...
                tmp173 = interp.getResult();
                tmp173.preserve();
                objv172[0] = tmp173;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv172, compiledLocals, 2);
            } finally {
                TJC.releaseObjvElems(interp, objv172, 1);
            }
        } // End Invoke: append
        { // Invoke: return $buffer
            TclObject tmp175 = getVarScalar(interp, "buffer", compiledLocals, 2);
            interp.resetResult();
            interp.setResult(tmp175);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_emit_container_switch_constant");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;
    TclObject const19;
    TclObject const20;
    TclObject const21;
    TclObject const22;
    TclObject const23;
    TclObject const24;
    TclObject const25;
    TclObject const26;
    TclObject const27;
    TclObject const28;
    TclObject const29;
    TclObject const30;
    TclObject const31;
    TclObject const32;
    TclObject const33;
    TclObject const34;
    TclObject const35;
    TclObject const36;
    TclObject const37;
    TclObject const38;
    TclObject const39;
    TclObject const40;
    TclObject const41;
    TclObject const42;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("descend_commands");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("container");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("descend_container_switch_patbody_indexes");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("emitter_indent");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("int ");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance(" = ");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance(".length();\n");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("char ");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance(" = '\\n';\n");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("emitter_container_if_start");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance(".charAt(0);\n");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("emitter_container_if_end");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("compileproc_omit_set_result");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("emitter_reset_result");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("emitter_indent_level");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("+2");
        TclInteger.get(interp, const16);
        const16.preserve(); const16.preserve();
        const17 = TclInteger.newInstance(-1);
        const17.preserve(); const17.preserve();
        const18 = TclInteger.newInstance(0);
        const18.preserve(); const18.preserve();
        const19 = TclString.newInstance("end-1");
        const19.preserve(); const19.preserve();
        const20 = TclString.newInstance("compileproc_get_argument_tuple");
        const20.preserve(); const20.preserve();
        const21 = TclString.newInstance("emitter_backslash_tcl_string");
        const21.preserve(); const21.preserve();
        const22 = TclString.newInstance(" == ");
        const22.preserve(); const22.preserve();
        const23 = TclString.newInstance(" && ");
        const23.preserve(); const23.preserve();
        const24 = TclString.newInstance(" == '");
        const24.preserve(); const24.preserve();
        const25 = TclString.newInstance("'");
        const25.preserve(); const25.preserve();
        const26 = TclString.newInstance("\n");
        const26.preserve(); const26.preserve();
        const27 = TclString.newInstance("&& ");
        const27.preserve(); const27.preserve();
        const28 = TclString.newInstance(".compareTo(\"");
        const28.preserve(); const28.preserve();
        const29 = TclString.newInstance("\") == 0");
        const29.preserve(); const29.preserve();
        const30 = TclString.newInstance(" == 0");
        const30.preserve(); const30.preserve();
        const31 = TclString.newInstance("descend_container_switch_is_fallthrough");
        const31.preserve(); const31.preserve();
        const32 = TclString.newInstance("error");
        const32.preserve(); const32.preserve();
        const33 = TclString.newInstance("( ");
        const33.preserve(); const33.preserve();
        const34 = TclString.newInstance(" ) ||\n");
        const34.preserve(); const34.preserve();
        const35 = TclString.newInstance(" )");
        const35.preserve(); const35.preserve();
        const36 = TclString.newInstance("true");
        TclBoolean.get(interp, const36);
        const36.preserve(); const36.preserve();
        const37 = TclString.newInstance("emitter_container_if_else");
        const37.preserve(); const37.preserve();
        const38 = TclString.newInstance("emitter_container_if_else_if");
        const38.preserve(); const38.preserve();
        const39 = TclString.newInstance("compileproc_argument_printable");
        const39.preserve(); const39.preserve();
        const40 = TclString.newInstance("// Pattern ");
        const40.preserve(); const40.preserve();
        const41 = TclString.newInstance("compileproc_emit_invoke");
        const41.preserve(); const41.preserve();
        const42 = TclString.newInstance("should not have fallen through past last body");
        const42.preserve(); const42.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;
    WrappedCommand cmdcache9;
    int cmdcache9_cmdEpoch;
    WrappedCommand cmdcache10;
    int cmdcache10_cmdEpoch;
    WrappedCommand cmdcache11;
    int cmdcache11_cmdEpoch;
    WrappedCommand cmdcache12;
    int cmdcache12_cmdEpoch;
    WrappedCommand cmdcache13;
    int cmdcache13_cmdEpoch;
    WrappedCommand cmdcache14;
    int cmdcache14_cmdEpoch;
    WrappedCommand cmdcache15;
    int cmdcache15_cmdEpoch;
    WrappedCommand cmdcache16;
    int cmdcache16_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                cmdcache9 = TJC.INVALID_COMMAND_CACHE;
                cmdcache9_cmdEpoch = 0;
                cmdcache10 = TJC.INVALID_COMMAND_CACHE;
                cmdcache10_cmdEpoch = 0;
                cmdcache11 = TJC.INVALID_COMMAND_CACHE;
                cmdcache11_cmdEpoch = 0;
                cmdcache12 = TJC.INVALID_COMMAND_CACHE;
                cmdcache12_cmdEpoch = 0;
                cmdcache13 = TJC.INVALID_COMMAND_CACHE;
                cmdcache13_cmdEpoch = 0;
                cmdcache14 = TJC.INVALID_COMMAND_CACHE;
                cmdcache14_cmdEpoch = 0;
                cmdcache15 = TJC.INVALID_COMMAND_CACHE;
                cmdcache15_cmdEpoch = 0;
                cmdcache16 = TJC.INVALID_COMMAND_CACHE;
                cmdcache16_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "descend_commands";
                break;
            }
            case 2: {
                cmdName = "descend_container_switch_patbody_indexes";
                break;
            }
            case 3: {
                cmdName = "emitter_indent";
                break;
            }
            case 4: {
                cmdName = "emitter_container_if_start";
                break;
            }
            case 5: {
                cmdName = "emitter_container_if_end";
                break;
            }
            case 6: {
                cmdName = "compileproc_omit_set_result";
                break;
            }
            case 7: {
                cmdName = "emitter_reset_result";
                break;
            }
            case 8: {
                cmdName = "emitter_indent_level";
                break;
            }
            case 9: {
                cmdName = "compileproc_get_argument_tuple";
                break;
            }
            case 10: {
                cmdName = "emitter_backslash_tcl_string";
                break;
            }
            case 11: {
                cmdName = "descend_container_switch_is_fallthrough";
                break;
            }
            case 12: {
                cmdName = "error";
                break;
            }
            case 13: {
                cmdName = "emitter_container_if_else";
                break;
            }
            case 14: {
                cmdName = "emitter_container_if_else_if";
                break;
            }
            case 15: {
                cmdName = "compileproc_argument_printable";
                break;
            }
            case 16: {
                cmdName = "compileproc_emit_invoke";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
            case 9: {
                cmdcache9 = lwcmd;
                cmdcache9_cmdEpoch = cmdEpoch;
                break;
            }
            case 10: {
                cmdcache10 = lwcmd;
                cmdcache10_cmdEpoch = cmdEpoch;
                break;
            }
            case 11: {
                cmdcache11 = lwcmd;
                cmdcache11_cmdEpoch = cmdEpoch;
                break;
            }
            case 12: {
                cmdcache12 = lwcmd;
                cmdcache12_cmdEpoch = cmdEpoch;
                break;
            }
            case 13: {
                cmdcache13 = lwcmd;
                cmdcache13_cmdEpoch = cmdEpoch;
                break;
            }
            case 14: {
                cmdcache14 = lwcmd;
                cmdcache14_cmdEpoch = cmdEpoch;
                break;
            }
            case 15: {
                cmdcache15 = lwcmd;
                cmdcache15_cmdEpoch = cmdEpoch;
                break;
            }
            case 16: {
                cmdcache16 = lwcmd;
                cmdcache16_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "string_tmpsymbol",
        "buffer",
        "body_keys",
        "pbIndexes",
        "length",
        "first",
        "spacer2",
        "spacer1",
        "i",
        "last_pattern",
        "ifnum",
        "fallthrough_expression",
        "patIndex",
        "bodyIndex",
        "tuple",
        "pattern",
        "cmap",
        "pattern_first",
        "pattern_len",
        "first_num_characters",
        "first_end_index",
        "pattern_jstr",
        "pattern_first_jstr",
        "expression",
        "astr",
        "body_key"
    };
} // end class CompileprocEmitContainerSwitchConstantCmd

