// TJC implementation of procedure compileproc_emit_inline_command_string
package tjc;
import tcl.lang.*;

public class CompileprocEmitInlineCommandStringCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 27, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        ExprValue evs2 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const0, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: set tree [...]
            TclObject tmp0;
            { // Invoke: descend_get_data $key tree
                TclObject[] objv1 = TJC.grabObjv(interp, 3);
                TclObject tmp2;
                try {
                    // Arg 0 constant: descend_get_data
                    objv1[0] = const1;
                    // Arg 1 variable: $key
                    tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    // Arg 2 constant: tree
                    objv1[2] = const2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 3);
                }
            } // End Invoke: descend_get_data
            tmp0 = interp.getResult();
            setVarScalar(interp, "tree", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set num_args [...]
            TclObject tmp3;
            { // Invoke: llength $tree
                TclObject tmp4 = getVarScalar(interp, "tree", compiledLocals, 2);
                int tmp5 = TclList.getLength(interp, tmp4);
                interp.setResult(tmp5);
            } // End Invoke: llength
            tmp3 = interp.getResult();
            setVarScalar(interp, "num_args", tmp3, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set tuple [...]
            TclObject tmp6;
            { // Invoke: ... $key 1
                TclObject[] objv7 = TJC.grabObjv(interp, 3);
                TclObject tmp8;
                try {
                    // Arg 0 constant: ...
                    objv7[0] = const3;
                    // Arg 1 variable: $key
                    tmp8 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp8.preserve();
                    objv7[1] = tmp8;
                    // Arg 2 constant: 1
                    objv7[2] = const4;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv7, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp8 = objv7[1];
                    if ( tmp8 != null ) {
                        tmp8.release();
                    }
                    TJC.releaseObjv(interp, objv7, 3);
                }
            } // End Invoke: ...
            tmp6 = interp.getResult();
            setVarScalar(interp, "tuple", tmp6, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set subcmdname [...]
            TclObject tmp9;
            { // Invoke: lindex $tuple 1
                TclObject tmp10 = getVarScalar(interp, "tuple", compiledLocals, 4);
                tmp10 = TclList.index(interp, tmp10, 1);
                if ( tmp10 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp10);
                }
            } // End Invoke: lindex
            tmp9 = interp.getResult();
            setVarScalar(interp, "subcmdname", tmp9, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: switch -exact -- $subcmdname {compare} - {equal} ... {first} ... {index} ... {last} ... {length} ... {range} ... default ...
            TclObject tmp11 = getVarScalar(interp, "subcmdname", compiledLocals, 5);
            String tmp12 = tmp11.toString();
            int tmp12_length = tmp12.length();
            char tmp12_first = '\n';
            if ( tmp12_length > 0 ) {
                tmp12_first = tmp12.charAt(0);
            }
            if ( ( tmp12_length == 7 && tmp12_first == 'c'
                    && tmp12.compareTo("compare") == 0 ) ||
                ( tmp12_length == 5 && tmp12_first == 'e'
                    && tmp12.compareTo("equal") == 0 ) ) {
                // Pattern {equal}
                { // Invoke: set tuple [...]
                    TclObject tmp13;
                    { // Invoke: ... $key 2 true {}
                        TclObject[] objv14 = TJC.grabObjv(interp, 5);
                        TclObject tmp15;
                        try {
                            // Arg 0 constant: ...
                            objv14[0] = const5;
                            // Arg 1 variable: $key
                            tmp15 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp15.preserve();
                            objv14[1] = tmp15;
                            // Arg 2 constant: 2
                            objv14[2] = const6;
                            // Arg 3 constant: true
                            objv14[3] = const7;
                            // Arg 4 constant: {}
                            objv14[4] = const0;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv14, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            tmp15 = objv14[1];
                            if ( tmp15 != null ) {
                                tmp15.release();
                            }
                            TJC.releaseObjv(interp, objv14, 5);
                        }
                    } // End Invoke: ...
                    tmp13 = interp.getResult();
                    setVarScalar(interp, "tuple", tmp13, compiledLocals, 4);
                } // End Invoke: set
                { // Invoke: set value_type [...]
                    TclObject tmp16;
                    { // Invoke: lindex $tuple 0
                        TclObject tmp17 = getVarScalar(interp, "tuple", compiledLocals, 4);
                        tmp17 = TclList.index(interp, tmp17, 0);
                        if ( tmp17 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp17);
                        }
                    } // End Invoke: lindex
                    tmp16 = interp.getResult();
                    setVarScalar(interp, "value_type", tmp16, compiledLocals, 6);
                } // End Invoke: set
                { // Invoke: set value_symbol [...]
                    TclObject tmp18;
                    { // Invoke: lindex $tuple 1
                        TclObject tmp19 = getVarScalar(interp, "tuple", compiledLocals, 4);
                        tmp19 = TclList.index(interp, tmp19, 1);
                        if ( tmp19 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp19);
                        }
                    } // End Invoke: lindex
                    tmp18 = interp.getResult();
                    setVarScalar(interp, "value_symbol", tmp18, compiledLocals, 7);
                } // End Invoke: set
                { // Invoke: set value_buffer [...]
                    TclObject tmp20;
                    { // Invoke: lindex $tuple 2
                        TclObject tmp21 = getVarScalar(interp, "tuple", compiledLocals, 4);
                        tmp21 = TclList.index(interp, tmp21, 2);
                        if ( tmp21 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp21);
                        }
                    } // End Invoke: lindex
                    tmp20 = interp.getResult();
                    setVarScalar(interp, "value_buffer", tmp20, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: set string1_tmpsymbol [...]
                    TclObject tmp22;
                    { // Invoke: ...
                        TclObject[] objv23 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: ...
                            objv23[0] = const8;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                ? cmdcache4.cmd : null), objv23, 0);
                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                updateCmdCache(interp, 4);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv23, 1);
                        }
                    } // End Invoke: ...
                    tmp22 = interp.getResult();
                    setVarScalar(interp, "string1_tmpsymbol", tmp22, compiledLocals, 9);
                } // End Invoke: set
                { // Invoke: append buffer $value_buffer [...]
                    TclObject[] objv24 = TJC.grabObjv(interp, 2);
                    TclObject tmp25;
                    try {
                        // Arg 2 variable: $value_buffer
                        tmp25 = getVarScalar(interp, "value_buffer", compiledLocals, 8);
                        tmp25.preserve();
                        objv24[0] = tmp25;
                        // Arg 3 command: [...]
                        { // Invoke: emitter_statement "..."
                            TclObject[] objv26 = TJC.grabObjv(interp, 2);
                            TclObject tmp27;
                            try {
                                // Arg 0 constant: emitter_statement
                                objv26[0] = const9;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp28 = new StringBuffer(64);
                                sbtmp28.append("String ");
                                tmp27 = getVarScalar(interp, "string1_tmpsymbol", compiledLocals, 9);
                                sbtmp28.append(tmp27.toString());
                                sbtmp28.append(" = ");
                                tmp27 = getVarScalar(interp, "value_symbol", compiledLocals, 7);
                                sbtmp28.append(tmp27.toString());
                                sbtmp28.append(".toString()");
                                tmp27 = TclString.newInstance(sbtmp28);
                                tmp27.preserve();
                                objv26[1] = tmp27;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                    ? cmdcache5.cmd : null), objv26, 0);
                                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                    updateCmdCache(interp, 5);
                                }
                            } finally {
                                tmp27 = objv26[1];
                                if ( tmp27 != null ) {
                                    tmp27.release();
                                }
                                TJC.releaseObjv(interp, objv26, 2);
                            }
                        } // End Invoke: emitter_statement
                        tmp25 = interp.getResult();
                        tmp25.preserve();
                        objv24[1] = tmp25;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv24, compiledLocals, 1);
                    } finally {
                        TJC.releaseObjvElems(interp, objv24, 2);
                    }
                } // End Invoke: append
                { // Invoke: set tuple [...]
                    TclObject tmp29;
                    { // Invoke: ... $key 3 true {}
                        TclObject[] objv30 = TJC.grabObjv(interp, 5);
                        TclObject tmp31;
                        try {
                            // Arg 0 constant: ...
                            objv30[0] = const5;
                            // Arg 1 variable: $key
                            tmp31 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp31.preserve();
                            objv30[1] = tmp31;
                            // Arg 2 constant: 3
                            objv30[2] = const10;
                            // Arg 3 constant: true
                            objv30[3] = const7;
                            // Arg 4 constant: {}
                            objv30[4] = const0;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv30, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            tmp31 = objv30[1];
                            if ( tmp31 != null ) {
                                tmp31.release();
                            }
                            TJC.releaseObjv(interp, objv30, 5);
                        }
                    } // End Invoke: ...
                    tmp29 = interp.getResult();
                    setVarScalar(interp, "tuple", tmp29, compiledLocals, 4);
                } // End Invoke: set
                { // Invoke: set value_type [...]
                    TclObject tmp32;
                    { // Invoke: lindex $tuple 0
                        TclObject tmp33 = getVarScalar(interp, "tuple", compiledLocals, 4);
                        tmp33 = TclList.index(interp, tmp33, 0);
                        if ( tmp33 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp33);
                        }
                    } // End Invoke: lindex
                    tmp32 = interp.getResult();
                    setVarScalar(interp, "value_type", tmp32, compiledLocals, 6);
                } // End Invoke: set
                { // Invoke: set value_symbol [...]
                    TclObject tmp34;
                    { // Invoke: lindex $tuple 1
                        TclObject tmp35 = getVarScalar(interp, "tuple", compiledLocals, 4);
                        tmp35 = TclList.index(interp, tmp35, 1);
                        if ( tmp35 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp35);
                        }
                    } // End Invoke: lindex
                    tmp34 = interp.getResult();
                    setVarScalar(interp, "value_symbol", tmp34, compiledLocals, 7);
                } // End Invoke: set
                { // Invoke: set value_buffer [...]
                    TclObject tmp36;
                    { // Invoke: lindex $tuple 2
                        TclObject tmp37 = getVarScalar(interp, "tuple", compiledLocals, 4);
                        tmp37 = TclList.index(interp, tmp37, 2);
                        if ( tmp37 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp37);
                        }
                    } // End Invoke: lindex
                    tmp36 = interp.getResult();
                    setVarScalar(interp, "value_buffer", tmp36, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: set string2_tmpsymbol [...]
                    TclObject tmp38;
                    { // Invoke: ...
                        TclObject[] objv39 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: ...
                            objv39[0] = const8;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                ? cmdcache4.cmd : null), objv39, 0);
                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                updateCmdCache(interp, 4);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv39, 1);
                        }
                    } // End Invoke: ...
                    tmp38 = interp.getResult();
                    setVarScalar(interp, "string2_tmpsymbol", tmp38, compiledLocals, 10);
                } // End Invoke: set
                { // Invoke: append buffer $value_buffer [...]
                    TclObject[] objv40 = TJC.grabObjv(interp, 2);
                    TclObject tmp41;
                    try {
                        // Arg 2 variable: $value_buffer
                        tmp41 = getVarScalar(interp, "value_buffer", compiledLocals, 8);
                        tmp41.preserve();
                        objv40[0] = tmp41;
                        // Arg 3 command: [...]
                        { // Invoke: emitter_statement "..."
                            TclObject[] objv42 = TJC.grabObjv(interp, 2);
                            TclObject tmp43;
                            try {
                                // Arg 0 constant: emitter_statement
                                objv42[0] = const9;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp44 = new StringBuffer(64);
                                sbtmp44.append("String ");
                                tmp43 = getVarScalar(interp, "string2_tmpsymbol", compiledLocals, 10);
                                sbtmp44.append(tmp43.toString());
                                sbtmp44.append(" = ");
                                tmp43 = getVarScalar(interp, "value_symbol", compiledLocals, 7);
                                sbtmp44.append(tmp43.toString());
                                sbtmp44.append(".toString()");
                                tmp43 = TclString.newInstance(sbtmp44);
                                tmp43.preserve();
                                objv42[1] = tmp43;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                    ? cmdcache5.cmd : null), objv42, 0);
                                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                    updateCmdCache(interp, 5);
                                }
                            } finally {
                                tmp43 = objv42[1];
                                if ( tmp43 != null ) {
                                    tmp43.release();
                                }
                                TJC.releaseObjv(interp, objv42, 2);
                            }
                        } // End Invoke: emitter_statement
                        tmp41 = interp.getResult();
                        tmp41.preserve();
                        objv40[1] = tmp41;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv40, compiledLocals, 1);
                    } finally {
                        TJC.releaseObjvElems(interp, objv40, 2);
                    }
                } // End Invoke: append
                { // Invoke: set result_tmpsymbol [...]
                    TclObject tmp45;
                    { // Invoke: ...
                        TclObject[] objv46 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: ...
                            objv46[0] = const8;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                ? cmdcache4.cmd : null), objv46, 0);
                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                updateCmdCache(interp, 4);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv46, 1);
                        }
                    } // End Invoke: ...
                    tmp45 = interp.getResult();
                    setVarScalar(interp, "result_tmpsymbol", tmp45, compiledLocals, 11);
                } // End Invoke: set
                { // Invoke: if ... ... elseif ... ... else ...
                    // Binary operator: $subcmdname == "compare"
                    TclObject tmp47 = getVarScalar(interp, "subcmdname", compiledLocals, 5);
                    boolean tmp48 = tmp47.toString().equals("compare");
                    ExprValue tmp49 = evs0;
                    tmp49.setIntValue(tmp48);
                    // End Binary operator: ==
                    boolean tmp50 = ( tmp49.getIntValue() != 0 );
                    if ( tmp50 ) {
                        { // Invoke: append buffer [...] [...] [...]
                            TclObject[] objv51 = TJC.grabObjv(interp, 3);
                            TclObject tmp52;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: emitter_statement "..."
                                    TclObject[] objv53 = TJC.grabObjv(interp, 2);
                                    TclObject tmp54;
                                    try {
                                        // Arg 0 constant: emitter_statement
                                        objv53[0] = const9;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp55 = new StringBuffer(64);
                                        sbtmp55.append("int ");
                                        tmp54 = getVarScalar(interp, "result_tmpsymbol", compiledLocals, 11);
                                        sbtmp55.append(tmp54.toString());
                                        sbtmp55.append(" = ");
                                        tmp54 = getVarScalar(interp, "string1_tmpsymbol", compiledLocals, 9);
                                        sbtmp55.append(tmp54.toString());
                                        sbtmp55.append(".compareTo(");
                                        tmp54 = getVarScalar(interp, "string2_tmpsymbol", compiledLocals, 10);
                                        sbtmp55.append(tmp54.toString());
                                        sbtmp55.append(")");
                                        tmp54 = TclString.newInstance(sbtmp55);
                                        tmp54.preserve();
                                        objv53[1] = tmp54;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                            ? cmdcache5.cmd : null), objv53, 0);
                                        if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                            updateCmdCache(interp, 5);
                                        }
                                    } finally {
                                        tmp54 = objv53[1];
                                        if ( tmp54 != null ) {
                                            tmp54.release();
                                        }
                                        TJC.releaseObjv(interp, objv53, 2);
                                    }
                                } // End Invoke: emitter_statement
                                tmp52 = interp.getResult();
                                tmp52.preserve();
                                objv51[0] = tmp52;
                                // Arg 3 command: [...]
                                { // Invoke: emitter_statement "..."
                                    TclObject[] objv56 = TJC.grabObjv(interp, 2);
                                    TclObject tmp57;
                                    try {
                                        // Arg 0 constant: emitter_statement
                                        objv56[0] = const9;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp58 = new StringBuffer(64);
                                        tmp57 = getVarScalar(interp, "result_tmpsymbol", compiledLocals, 11);
                                        sbtmp58.append(tmp57.toString());
                                        sbtmp58.append(" = ((");
                                        tmp57 = getVarScalar(interp, "result_tmpsymbol", compiledLocals, 11);
                                        sbtmp58.append(tmp57.toString());
                                        sbtmp58.append(" > 0) ? 1 : (");
                                        tmp57 = getVarScalar(interp, "result_tmpsymbol", compiledLocals, 11);
                                        sbtmp58.append(tmp57.toString());
                                        sbtmp58.append(" < 0) ? -1 : 0)");
                                        tmp57 = TclString.newInstance(sbtmp58);
                                        tmp57.preserve();
                                        objv56[1] = tmp57;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                            ? cmdcache5.cmd : null), objv56, 0);
                                        if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                            updateCmdCache(interp, 5);
                                        }
                                    } finally {
                                        tmp57 = objv56[1];
                                        if ( tmp57 != null ) {
                                            tmp57.release();
                                        }
                                        TJC.releaseObjv(interp, objv56, 2);
                                    }
                                } // End Invoke: emitter_statement
                                tmp52 = interp.getResult();
                                tmp52.preserve();
                                objv51[1] = tmp52;
                                // Arg 4 command: [...]
                                { // Invoke: emitter_set_result $result_tmpsymbol false
                                    TclObject[] objv59 = TJC.grabObjv(interp, 3);
                                    TclObject tmp60;
                                    try {
                                        // Arg 0 constant: emitter_set_result
                                        objv59[0] = const11;
                                        // Arg 1 variable: $result_tmpsymbol
                                        tmp60 = getVarScalar(interp, "result_tmpsymbol", compiledLocals, 11);
                                        tmp60.preserve();
                                        objv59[1] = tmp60;
                                        // Arg 2 constant: false
                                        objv59[2] = const12;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                            ? cmdcache6.cmd : null), objv59, 0);
                                        if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                            updateCmdCache(interp, 6);
                                        }
                                    } finally {
                                        tmp60 = objv59[1];
                                        if ( tmp60 != null ) {
                                            tmp60.release();
                                        }
                                        TJC.releaseObjv(interp, objv59, 3);
                                    }
                                } // End Invoke: emitter_set_result
                                tmp52 = interp.getResult();
                                tmp52.preserve();
                                objv51[2] = tmp52;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv51, compiledLocals, 1);
                            } finally {
                                TJC.releaseObjvElems(interp, objv51, 3);
                            }
                        } // End Invoke: append
                    } else {
                        // Binary operator: $subcmdname == "equal"
                        TclObject tmp61 = getVarScalar(interp, "subcmdname", compiledLocals, 5);
                        boolean tmp62 = tmp61.toString().equals("equal");
                        ExprValue tmp63 = evs0;
                        tmp63.setIntValue(tmp62);
                        // End Binary operator: ==
                        boolean tmp64 = ( tmp63.getIntValue() != 0 );
                        if ( tmp64 ) {
                            { // Invoke: append buffer [...] [...]
                                TclObject[] objv65 = TJC.grabObjv(interp, 2);
                                TclObject tmp66;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: emitter_statement "..."
                                        TclObject[] objv67 = TJC.grabObjv(interp, 2);
                                        TclObject tmp68;
                                        try {
                                            // Arg 0 constant: emitter_statement
                                            objv67[0] = const9;
                                            // Arg 1 word: "..."
                                            StringBuffer sbtmp69 = new StringBuffer(64);
                                            sbtmp69.append("boolean ");
                                            tmp68 = getVarScalar(interp, "result_tmpsymbol", compiledLocals, 11);
                                            sbtmp69.append(tmp68.toString());
                                            sbtmp69.append(" = ");
                                            tmp68 = getVarScalar(interp, "string1_tmpsymbol", compiledLocals, 9);
                                            sbtmp69.append(tmp68.toString());
                                            sbtmp69.append(".equals(");
                                            tmp68 = getVarScalar(interp, "string2_tmpsymbol", compiledLocals, 10);
                                            sbtmp69.append(tmp68.toString());
                                            sbtmp69.append(")");
                                            tmp68 = TclString.newInstance(sbtmp69);
                                            tmp68.preserve();
                                            objv67[1] = tmp68;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                                ? cmdcache5.cmd : null), objv67, 0);
                                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                                updateCmdCache(interp, 5);
                                            }
                                        } finally {
                                            tmp68 = objv67[1];
                                            if ( tmp68 != null ) {
                                                tmp68.release();
                                            }
                                            TJC.releaseObjv(interp, objv67, 2);
                                        }
                                    } // End Invoke: emitter_statement
                                    tmp66 = interp.getResult();
                                    tmp66.preserve();
                                    objv65[0] = tmp66;
                                    // Arg 3 command: [...]
                                    { // Invoke: emitter_set_result $result_tmpsymbol false
                                        TclObject[] objv70 = TJC.grabObjv(interp, 3);
                                        TclObject tmp71;
                                        try {
                                            // Arg 0 constant: emitter_set_result
                                            objv70[0] = const11;
                                            // Arg 1 variable: $result_tmpsymbol
                                            tmp71 = getVarScalar(interp, "result_tmpsymbol", compiledLocals, 11);
                                            tmp71.preserve();
                                            objv70[1] = tmp71;
                                            // Arg 2 constant: false
                                            objv70[2] = const12;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                                ? cmdcache6.cmd : null), objv70, 0);
                                            if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                                updateCmdCache(interp, 6);
                                            }
                                        } finally {
                                            tmp71 = objv70[1];
                                            if ( tmp71 != null ) {
                                                tmp71.release();
                                            }
                                            TJC.releaseObjv(interp, objv70, 3);
                                        }
                                    } // End Invoke: emitter_set_result
                                    tmp66 = interp.getResult();
                                    tmp66.preserve();
                                    objv65[1] = tmp66;
                                    interp.resetResult();
                                    appendVarScalar(interp, "buffer", objv65, compiledLocals, 1);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv65, 2);
                                }
                            } // End Invoke: append
                        } else {
                            { // Invoke: error "..."
                                TclObject[] objv72 = TJC.grabObjv(interp, 2);
                                TclObject tmp73;
                                try {
                                    // Arg 0 constant: error
                                    objv72[0] = const13;
                                    // Arg 1 word: "..."
                                    StringBuffer sbtmp74 = new StringBuffer(64);
                                    sbtmp74.append("unknown subcommand ");
                                    sbtmp74.append("\"");
                                    tmp73 = getVarScalar(interp, "subcmdname", compiledLocals, 5);
                                    sbtmp74.append(tmp73.toString());
                                    sbtmp74.append("\"");
                                    tmp73 = TclString.newInstance(sbtmp74);
                                    tmp73.preserve();
                                    objv72[1] = tmp73;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                        ? cmdcache7.cmd : null), objv72, 0);
                                    if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                        updateCmdCache(interp, 7);
                                    }
                                } finally {
                                    tmp73 = objv72[1];
                                    if ( tmp73 != null ) {
                                        tmp73.release();
                                    }
                                    TJC.releaseObjv(interp, objv72, 2);
                                }
                            } // End Invoke: error
                        }
                    }
                } // End Invoke: if
            } else if ( tmp12_length == 5 && tmp12_first == 'f'
                    && tmp12.compareTo("first") == 0 ) {
                // Pattern {first}
                { // Invoke: set tuple [...]
                    TclObject tmp75;
                    { // Invoke: ... $key 2
                        TclObject[] objv76 = TJC.grabObjv(interp, 3);
                        TclObject tmp77;
                        try {
                            // Arg 0 constant: ...
                            objv76[0] = const3;
                            // Arg 1 variable: $key
                            tmp77 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp77.preserve();
                            objv76[1] = tmp77;
                            // Arg 2 constant: 2
                            objv76[2] = const6;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv76, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp77 = objv76[1];
                            if ( tmp77 != null ) {
                                tmp77.release();
                            }
                            TJC.releaseObjv(interp, objv76, 3);
                        }
                    } // End Invoke: ...
                    tmp75 = interp.getResult();
                    setVarScalar(interp, "tuple", tmp75, compiledLocals, 4);
                } // End Invoke: set
                { // Invoke: set value_type [...]
                    TclObject tmp78;
                    { // Invoke: lindex $tuple 0
                        TclObject tmp79 = getVarScalar(interp, "tuple", compiledLocals, 4);
                        tmp79 = TclList.index(interp, tmp79, 0);
                        if ( tmp79 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp79);
                        }
                    } // End Invoke: lindex
                    tmp78 = interp.getResult();
                    setVarScalar(interp, "value_type", tmp78, compiledLocals, 6);
                } // End Invoke: set
                { // Invoke: if ... ... else ...
                    // Binary operator: $value_type == "constant"
                    TclObject tmp80 = getVarScalar(interp, "value_type", compiledLocals, 6);
                    boolean tmp81 = tmp80.toString().equals("constant");
                    ExprValue tmp82 = evs0;
                    tmp82.setIntValue(tmp81);
                    // End Binary operator: ==
                    boolean tmp83 = ( tmp82.getIntValue() != 0 );
                    if ( tmp83 ) {
                        { // Invoke: set substr_is_constant 1
                            setVarScalar(interp, "substr_is_constant", const4, compiledLocals, 12);
                        } // End Invoke: set
                        { // Invoke: set ... [...]
                            TclObject tmp84;
                            { // Invoke: lindex $tuple 1
                                TclObject tmp85 = getVarScalar(interp, "tuple", compiledLocals, 4);
                                tmp85 = TclList.index(interp, tmp85, 1);
                                if ( tmp85 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp85);
                                }
                            } // End Invoke: lindex
                            tmp84 = interp.getResult();
                            setVarScalar(interp, "substr_constant_string", tmp84, compiledLocals, 13);
                        } // End Invoke: set
                        { // Invoke: set cmap [...]
                            TclObject tmp86;
                            { // Invoke: lindex $tuple 3
                                TclObject tmp87 = getVarScalar(interp, "tuple", compiledLocals, 4);
                                tmp87 = TclList.index(interp, tmp87, 3);
                                if ( tmp87 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp87);
                                }
                            } // End Invoke: lindex
                            tmp86 = interp.getResult();
                            setVarScalar(interp, "cmap", tmp86, compiledLocals, 14);
                        } // End Invoke: set
                        { // Invoke: if {$cmap == {}} ... else ...
                            // Binary operator: $cmap == ""
                            TclObject tmp88 = getVarScalar(interp, "cmap", compiledLocals, 14);
                            ExprValue tmp89 = evs0;
                            TJC.exprEqualsEmptyString(tmp89, tmp88, false);
                            // End Binary operator: ==
                            boolean tmp90 = ( tmp89.getIntValue() != 0 );
                            if ( tmp90 ) {
                                { // Invoke: set substr_first [...]
                                    TclObject tmp91;
                                    { // Invoke: string index $... 0
                                        TclObject tmp92 = getVarScalar(interp, "substr_constant_string", compiledLocals, 13);
                                        String tmp93 = tmp92.toString();
                                        TclObject tmp94 = TJC.stringIndex(interp, tmp93, const14);
                                        interp.setResult(tmp94);
                                    } // End Invoke: string
                                    tmp91 = interp.getResult();
                                    setVarScalar(interp, "substr_first", tmp91, compiledLocals, 15);
                                } // End Invoke: set
                                { // Invoke: set substr_len [...]
                                    TclObject tmp95;
                                    { // Invoke: string length $...
                                        TclObject tmp96 = getVarScalar(interp, "substr_constant_string", compiledLocals, 13);
                                        int tmp97 = tmp96.toString().length();
                                        interp.setResult(tmp97);
                                    } // End Invoke: string
                                    tmp95 = interp.getResult();
                                    setVarScalar(interp, "substr_len", tmp95, compiledLocals, 16);
                                } // End Invoke: set
                            } else {
                                { // Invoke: set first_num_characters [...]
                                    TclObject tmp98;
                                    { // Invoke: lindex $cmap 0
                                        TclObject tmp99 = getVarScalar(interp, "cmap", compiledLocals, 14);
                                        tmp99 = TclList.index(interp, tmp99, 0);
                                        if ( tmp99 == null ) {
                                            interp.resetResult();
                                        } else {
                                            interp.setResult(tmp99);
                                        }
                                    } // End Invoke: lindex
                                    tmp98 = interp.getResult();
                                    setVarScalar(interp, "first_num_characters", tmp98, compiledLocals, 17);
                                } // End Invoke: set
                                { // Invoke: set first_end_index [...]
                                    TclObject tmp100;
                                    { // Invoke: expr ...
                                        // Binary operator: $first_num_characters - 1
                                        TclObject tmp101 = getVarScalar(interp, "first_num_characters", compiledLocals, 17);
                                        ExprValue tmp102 = evs0;
                                        TJC.exprInitValue(interp, tmp102, tmp101);
                                        ExprValue tmp103 = evs1;
                                        tmp103.setIntValue(1);
                                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MINUS, tmp102, tmp103);
                                        // End Binary operator: -
                                        TJC.exprSetResult(interp, tmp102);
                                    } // End Invoke: expr
                                    tmp100 = interp.getResult();
                                    setVarScalar(interp, "first_end_index", tmp100, compiledLocals, 18);
                                } // End Invoke: set
                                { // Invoke: set substr_first [...]
                                    TclObject tmp104;
                                    { // Invoke: string range $... 0 $first_end_index
                                        TclObject tmp105 = getVarScalar(interp, "substr_constant_string", compiledLocals, 13);
                                        String tmp106 = tmp105.toString();
                                        TclObject tmp107 = const14;
                                        tmp107.preserve();
                                        TclObject tmp108 = getVarScalar(interp, "first_end_index", compiledLocals, 18);
                                        TclObject tmp109 = TJC.stringRange(interp, tmp106, tmp107, tmp108);
                                        interp.setResult(tmp109);
                                    } // End Invoke: string
                                    tmp104 = interp.getResult();
                                    setVarScalar(interp, "substr_first", tmp104, compiledLocals, 15);
                                } // End Invoke: set
                                { // Invoke: set substr_len [...]
                                    TclObject tmp110;
                                    { // Invoke: llength $cmap
                                        TclObject tmp111 = getVarScalar(interp, "cmap", compiledLocals, 14);
                                        int tmp112 = TclList.getLength(interp, tmp111);
                                        interp.setResult(tmp112);
                                    } // End Invoke: llength
                                    tmp110 = interp.getResult();
                                    setVarScalar(interp, "substr_len", tmp110, compiledLocals, 16);
                                } // End Invoke: set
                            }
                        } // End Invoke: if
                        { // Invoke: set substr_tmpsymbol [...]
                            TclObject tmp113;
                            { // Invoke: ...
                                TclObject[] objv114 = TJC.grabObjv(interp, 1);
                                try {
                                    // Arg 0 constant: ...
                                    objv114[0] = const8;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                        ? cmdcache4.cmd : null), objv114, 0);
                                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                        updateCmdCache(interp, 4);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv114, 1);
                                }
                            } // End Invoke: ...
                            tmp113 = interp.getResult();
                            setVarScalar(interp, "substr_tmpsymbol", tmp113, compiledLocals, 19);
                        } // End Invoke: set
                        { // Invoke: if ... ... else ...
                            // Binary operator: () && ()
                            // Binary operator: $substr_len == 1
                            TclObject tmp115 = getVarScalar(interp, "substr_len", compiledLocals, 16);
                            ExprValue tmp116 = evs0;
                            TJC.exprInitValue(interp, tmp116, tmp115);
                            ExprValue tmp117 = evs1;
                            tmp117.setIntValue(1);
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp116, tmp117);
                            // End Binary operator: ==
                            if (tmp116.getBooleanValue(interp)) {
                            // Binary operator: $num_args == 4
                            TclObject tmp118 = getVarScalar(interp, "num_args", compiledLocals, 3);
                            ExprValue tmp119 = evs1;
                            TJC.exprInitValue(interp, tmp119, tmp118);
                            ExprValue tmp120 = evs2;
                            tmp120.setIntValue(4);
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp119, tmp120);
                            // End Binary operator: ==
                            tmp116.setIntValue(tmp119.getBooleanValue(interp));
                            } else {
                            tmp116.setIntValue(0);
                            } // End if: ()
                            // End Binary operator: &&
                            boolean tmp121 = ( tmp116.getIntValue() != 0 );
                            if ( tmp121 ) {
                                { // Invoke: set jstr [...]
                                    TclObject tmp122;
                                    { // Invoke: ... $...
                                        TclObject[] objv123 = TJC.grabObjv(interp, 2);
                                        TclObject tmp124;
                                        try {
                                            // Arg 0 constant: ...
                                            objv123[0] = const15;
                                            // Arg 1 variable: $...
                                            tmp124 = getVarScalar(interp, "substr_constant_string", compiledLocals, 13);
                                            tmp124.preserve();
                                            objv123[1] = tmp124;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                                ? cmdcache8.cmd : null), objv123, 0);
                                            if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                                updateCmdCache(interp, 8);
                                            }
                                        } finally {
                                            tmp124 = objv123[1];
                                            if ( tmp124 != null ) {
                                                tmp124.release();
                                            }
                                            TJC.releaseObjv(interp, objv123, 2);
                                        }
                                    } // End Invoke: ...
                                    tmp122 = interp.getResult();
                                    setVarScalar(interp, "jstr", tmp122, compiledLocals, 20);
                                } // End Invoke: set
                                { // Invoke: append buffer [...]
                                    TclObject[] objv125 = TJC.grabObjv(interp, 1);
                                    TclObject tmp126;
                                    try {
                                        // Arg 2 command: [...]
                                        { // Invoke: emitter_statement "..."
                                            TclObject[] objv127 = TJC.grabObjv(interp, 2);
                                            TclObject tmp128;
                                            try {
                                                // Arg 0 constant: emitter_statement
                                                objv127[0] = const9;
                                                // Arg 1 word: "..."
                                                StringBuffer sbtmp129 = new StringBuffer(64);
                                                sbtmp129.append("char ");
                                                tmp128 = getVarScalar(interp, "substr_tmpsymbol", compiledLocals, 19);
                                                sbtmp129.append(tmp128.toString());
                                                sbtmp129.append(" = '");
                                                tmp128 = getVarScalar(interp, "jstr", compiledLocals, 20);
                                                sbtmp129.append(tmp128.toString());
                                                sbtmp129.append("'");
                                                tmp128 = TclString.newInstance(sbtmp129);
                                                tmp128.preserve();
                                                objv127[1] = tmp128;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                                    ? cmdcache5.cmd : null), objv127, 0);
                                                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                                    updateCmdCache(interp, 5);
                                                }
                                            } finally {
                                                tmp128 = objv127[1];
                                                if ( tmp128 != null ) {
                                                    tmp128.release();
                                                }
                                                TJC.releaseObjv(interp, objv127, 2);
                                            }
                                        } // End Invoke: emitter_statement
                                        tmp126 = interp.getResult();
                                        tmp126.preserve();
                                        objv125[0] = tmp126;
                                        interp.resetResult();
                                        appendVarScalar(interp, "buffer", objv125, compiledLocals, 1);
                                    } finally {
                                        TJC.releaseObjvElems(interp, objv125, 1);
                                    }
                                } // End Invoke: append
                            } else {
                                { // Invoke: if {$substr_len == 0} ...
                                    // Binary operator: $substr_len == 0
                                    TclObject tmp130 = getVarScalar(interp, "substr_len", compiledLocals, 16);
                                    ExprValue tmp131 = evs0;
                                    TJC.exprInitValue(interp, tmp131, tmp130);
                                    ExprValue tmp132 = evs1;
                                    tmp132.setIntValue(0);
                                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp131, tmp132);
                                    // End Binary operator: ==
                                    boolean tmp133 = ( tmp131.getIntValue() != 0 );
                                    if ( tmp133 ) {
                                        { // Invoke: set substr_is_constant 0
                                            setVarScalar(interp, "substr_is_constant", const14, compiledLocals, 12);
                                        } // End Invoke: set
                                    }
                                } // End Invoke: if
                                { // Invoke: set jstr [...]
                                    TclObject tmp134;
                                    { // Invoke: ... $...
                                        TclObject[] objv135 = TJC.grabObjv(interp, 2);
                                        TclObject tmp136;
                                        try {
                                            // Arg 0 constant: ...
                                            objv135[0] = const15;
                                            // Arg 1 variable: $...
                                            tmp136 = getVarScalar(interp, "substr_constant_string", compiledLocals, 13);
                                            tmp136.preserve();
                                            objv135[1] = tmp136;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                                ? cmdcache8.cmd : null), objv135, 0);
                                            if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                                updateCmdCache(interp, 8);
                                            }
                                        } finally {
                                            tmp136 = objv135[1];
                                            if ( tmp136 != null ) {
                                                tmp136.release();
                                            }
                                            TJC.releaseObjv(interp, objv135, 2);
                                        }
                                    } // End Invoke: ...
                                    tmp134 = interp.getResult();
                                    setVarScalar(interp, "jstr", tmp134, compiledLocals, 20);
                                } // End Invoke: set
                                { // Invoke: append buffer [...]
                                    TclObject[] objv137 = TJC.grabObjv(interp, 1);
                                    TclObject tmp138;
                                    try {
                                        // Arg 2 command: [...]
                                        { // Invoke: emitter_statement "..."
                                            TclObject[] objv139 = TJC.grabObjv(interp, 2);
                                            TclObject tmp140;
                                            try {
                                                // Arg 0 constant: emitter_statement
                                                objv139[0] = const9;
                                                // Arg 1 word: "..."
                                                StringBuffer sbtmp141 = new StringBuffer(64);
                                                sbtmp141.append("String ");
                                                tmp140 = getVarScalar(interp, "substr_tmpsymbol", compiledLocals, 19);
                                                sbtmp141.append(tmp140.toString());
                                                sbtmp141.append(" = ");
                                                sbtmp141.append("\"");
                                                tmp140 = getVarScalar(interp, "jstr", compiledLocals, 20);
                                                sbtmp141.append(tmp140.toString());
                                                sbtmp141.append("\"");
                                                tmp140 = TclString.newInstance(sbtmp141);
                                                tmp140.preserve();
                                                objv139[1] = tmp140;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                                    ? cmdcache5.cmd : null), objv139, 0);
                                                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                                    updateCmdCache(interp, 5);
                                                }
                                            } finally {
                                                tmp140 = objv139[1];
                                                if ( tmp140 != null ) {
                                                    tmp140.release();
                                                }
                                                TJC.releaseObjv(interp, objv139, 2);
                                            }
                                        } // End Invoke: emitter_statement
                                        tmp138 = interp.getResult();
                                        tmp138.preserve();
                                        objv137[0] = tmp138;
                                        interp.resetResult();
                                        appendVarScalar(interp, "buffer", objv137, compiledLocals, 1);
                                    } finally {
                                        TJC.releaseObjvElems(interp, objv137, 1);
                                    }
                                } // End Invoke: append
                            }
                        } // End Invoke: if
                    } else {
                        { // Invoke: set substr_is_constant 0
                            setVarScalar(interp, "substr_is_constant", const14, compiledLocals, 12);
                        } // End Invoke: set
                        { // Invoke: set tuple [...]
                            TclObject tmp142;
                            { // Invoke: ... $key 2 true {}
                                TclObject[] objv143 = TJC.grabObjv(interp, 5);
                                TclObject tmp144;
                                try {
                                    // Arg 0 constant: ...
                                    objv143[0] = const5;
                                    // Arg 1 variable: $key
                                    tmp144 = getVarScalar(interp, "key", compiledLocals, 0);
                                    tmp144.preserve();
                                    objv143[1] = tmp144;
                                    // Arg 2 constant: 2
                                    objv143[2] = const6;
                                    // Arg 3 constant: true
                                    objv143[3] = const7;
                                    // Arg 4 constant: {}
                                    objv143[4] = const0;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                        ? cmdcache3.cmd : null), objv143, 0);
                                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                        updateCmdCache(interp, 3);
                                    }
                                } finally {
                                    tmp144 = objv143[1];
                                    if ( tmp144 != null ) {
                                        tmp144.release();
                                    }
                                    TJC.releaseObjv(interp, objv143, 5);
                                }
                            } // End Invoke: ...
                            tmp142 = interp.getResult();
                            setVarScalar(interp, "tuple", tmp142, compiledLocals, 4);
                        } // End Invoke: set
                        { // Invoke: set value_type [...]
                            TclObject tmp145;
                            { // Invoke: lindex $tuple 0
                                TclObject tmp146 = getVarScalar(interp, "tuple", compiledLocals, 4);
                                tmp146 = TclList.index(interp, tmp146, 0);
                                if ( tmp146 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp146);
                                }
                            } // End Invoke: lindex
                            tmp145 = interp.getResult();
                            setVarScalar(interp, "value_type", tmp145, compiledLocals, 6);
                        } // End Invoke: set
                        { // Invoke: set value_symbol [...]
                            TclObject tmp147;
                            { // Invoke: lindex $tuple 1
                                TclObject tmp148 = getVarScalar(interp, "tuple", compiledLocals, 4);
                                tmp148 = TclList.index(interp, tmp148, 1);
                                if ( tmp148 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp148);
                                }
                            } // End Invoke: lindex
                            tmp147 = interp.getResult();
                            setVarScalar(interp, "value_symbol", tmp147, compiledLocals, 7);
                        } // End Invoke: set
                        { // Invoke: set value_buffer [...]
                            TclObject tmp149;
                            { // Invoke: lindex $tuple 2
                                TclObject tmp150 = getVarScalar(interp, "tuple", compiledLocals, 4);
                                tmp150 = TclList.index(interp, tmp150, 2);
                                if ( tmp150 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp150);
                                }
                            } // End Invoke: lindex
                            tmp149 = interp.getResult();
                            setVarScalar(interp, "value_buffer", tmp149, compiledLocals, 8);
                        } // End Invoke: set
                        { // Invoke: set substr_tmpsymbol [...]
                            TclObject tmp151;
                            { // Invoke: ...
                                TclObject[] objv152 = TJC.grabObjv(interp, 1);
                                try {
                                    // Arg 0 constant: ...
                                    objv152[0] = const8;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                        ? cmdcache4.cmd : null), objv152, 0);
                                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                        updateCmdCache(interp, 4);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv152, 1);
                                }
                            } // End Invoke: ...
                            tmp151 = interp.getResult();
                            setVarScalar(interp, "substr_tmpsymbol", tmp151, compiledLocals, 19);
                        } // End Invoke: set
                        { // Invoke: append buffer $value_buffer [...]
                            TclObject[] objv153 = TJC.grabObjv(interp, 2);
                            TclObject tmp154;
                            try {
                                // Arg 2 variable: $value_buffer
                                tmp154 = getVarScalar(interp, "value_buffer", compiledLocals, 8);
                                tmp154.preserve();
                                objv153[0] = tmp154;
                                // Arg 3 command: [...]
                                { // Invoke: emitter_statement "..."
                                    TclObject[] objv155 = TJC.grabObjv(interp, 2);
                                    TclObject tmp156;
                                    try {
                                        // Arg 0 constant: emitter_statement
                                        objv155[0] = const9;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp157 = new StringBuffer(64);
                                        sbtmp157.append("String ");
                                        tmp156 = getVarScalar(interp, "substr_tmpsymbol", compiledLocals, 19);
                                        sbtmp157.append(tmp156.toString());
                                        sbtmp157.append(" = ");
                                        tmp156 = getVarScalar(interp, "value_symbol", compiledLocals, 7);
                                        sbtmp157.append(tmp156.toString());
                                        sbtmp157.append(".toString()");
                                        tmp156 = TclString.newInstance(sbtmp157);
                                        tmp156.preserve();
                                        objv155[1] = tmp156;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                            ? cmdcache5.cmd : null), objv155, 0);
                                        if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                            updateCmdCache(interp, 5);
                                        }
                                    } finally {
                                        tmp156 = objv155[1];
                                        if ( tmp156 != null ) {
                                            tmp156.release();
                                        }
                                        TJC.releaseObjv(interp, objv155, 2);
                                    }
                                } // End Invoke: emitter_statement
                                tmp154 = interp.getResult();
                                tmp154.preserve();
                                objv153[1] = tmp154;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv153, compiledLocals, 1);
                            } finally {
                                TJC.releaseObjvElems(interp, objv153, 2);
                            }
                        } // End Invoke: append
                    }
                } // End Invoke: if
                { // Invoke: set tuple [...]
                    TclObject tmp158;
                    { // Invoke: ... $key 3 true {}
                        TclObject[] objv159 = TJC.grabObjv(interp, 5);
                        TclObject tmp160;
                        try {
                            // Arg 0 constant: ...
                            objv159[0] = const5;
                            // Arg 1 variable: $key
                            tmp160 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp160.preserve();
                            objv159[1] = tmp160;
                            // Arg 2 constant: 3
                            objv159[2] = const10;
                            // Arg 3 constant: true
                            objv159[3] = const7;
                            // Arg 4 constant: {}
                            objv159[4] = const0;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv159, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            tmp160 = objv159[1];
                            if ( tmp160 != null ) {
                                tmp160.release();
                            }
                            TJC.releaseObjv(interp, objv159, 5);
                        }
                    } // End Invoke: ...
                    tmp158 = interp.getResult();
                    setVarScalar(interp, "tuple", tmp158, compiledLocals, 4);
                } // End Invoke: set
                { // Invoke: set value_type [...]
                    TclObject tmp161;
                    { // Invoke: lindex $tuple 0
                        TclObject tmp162 = getVarScalar(interp, "tuple", compiledLocals, 4);
                        tmp162 = TclList.index(interp, tmp162, 0);
                        if ( tmp162 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp162);
                        }
                    } // End Invoke: lindex
                    tmp161 = interp.getResult();
                    setVarScalar(interp, "value_type", tmp161, compiledLocals, 6);
                } // End Invoke: set
                { // Invoke: set value_symbol [...]
                    TclObject tmp163;
                    { // Invoke: lindex $tuple 1
                        TclObject tmp164 = getVarScalar(interp, "tuple", compiledLocals, 4);
                        tmp164 = TclList.index(interp, tmp164, 1);
                        if ( tmp164 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp164);
                        }
                    } // End Invoke: lindex
                    tmp163 = interp.getResult();
                    setVarScalar(interp, "value_symbol", tmp163, compiledLocals, 7);
                } // End Invoke: set
                { // Invoke: set value_buffer [...]
                    TclObject tmp165;
                    { // Invoke: lindex $tuple 2
                        TclObject tmp166 = getVarScalar(interp, "tuple", compiledLocals, 4);
                        tmp166 = TclList.index(interp, tmp166, 2);
                        if ( tmp166 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp166);
                        }
                    } // End Invoke: lindex
                    tmp165 = interp.getResult();
                    setVarScalar(interp, "value_buffer", tmp165, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: set string_tmpsymbol [...]
                    TclObject tmp167;
                    { // Invoke: ...
                        TclObject[] objv168 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: ...
                            objv168[0] = const8;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                ? cmdcache4.cmd : null), objv168, 0);
                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                updateCmdCache(interp, 4);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv168, 1);
                        }
                    } // End Invoke: ...
                    tmp167 = interp.getResult();
                    setVarScalar(interp, "string_tmpsymbol", tmp167, compiledLocals, 21);
                } // End Invoke: set
                { // Invoke: append buffer $value_buffer [...]
                    TclObject[] objv169 = TJC.grabObjv(interp, 2);
                    TclObject tmp170;
                    try {
                        // Arg 2 variable: $value_buffer
                        tmp170 = getVarScalar(interp, "value_buffer", compiledLocals, 8);
                        tmp170.preserve();
                        objv169[0] = tmp170;
                        // Arg 3 command: [...]
                        { // Invoke: emitter_statement "..."
                            TclObject[] objv171 = TJC.grabObjv(interp, 2);
                            TclObject tmp172;
                            try {
                                // Arg 0 constant: emitter_statement
                                objv171[0] = const9;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp173 = new StringBuffer(64);
                                sbtmp173.append("String ");
                                tmp172 = getVarScalar(interp, "string_tmpsymbol", compiledLocals, 21);
                                sbtmp173.append(tmp172.toString());
                                sbtmp173.append(" = ");
                                tmp172 = getVarScalar(interp, "value_symbol", compiledLocals, 7);
                                sbtmp173.append(tmp172.toString());
                                sbtmp173.append(".toString()");
                                tmp172 = TclString.newInstance(sbtmp173);
                                tmp172.preserve();
                                objv171[1] = tmp172;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                    ? cmdcache5.cmd : null), objv171, 0);
                                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                    updateCmdCache(interp, 5);
                                }
                            } finally {
                                tmp172 = objv171[1];
                                if ( tmp172 != null ) {
                                    tmp172.release();
                                }
                                TJC.releaseObjv(interp, objv171, 2);
                            }
                        } // End Invoke: emitter_statement
                        tmp170 = interp.getResult();
                        tmp170.preserve();
                        objv169[1] = tmp170;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv169, compiledLocals, 1);
                    } finally {
                        TJC.releaseObjvElems(interp, objv169, 2);
                    }
                } // End Invoke: append
                { // Invoke: if {$num_args == 5} ... else ...
                    // Binary operator: $num_args == 5
                    TclObject tmp174 = getVarScalar(interp, "num_args", compiledLocals, 3);
                    ExprValue tmp175 = evs0;
                    TJC.exprInitValue(interp, tmp175, tmp174);
                    ExprValue tmp176 = evs1;
                    tmp176.setIntValue(5);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp175, tmp176);
                    // End Binary operator: ==
                    boolean tmp177 = ( tmp175.getIntValue() != 0 );
                    if ( tmp177 ) {
                        { // Invoke: set tuple [...]
                            TclObject tmp178;
                            { // Invoke: ... $key 4 true {}
                                TclObject[] objv179 = TJC.grabObjv(interp, 5);
                                TclObject tmp180;
                                try {
                                    // Arg 0 constant: ...
                                    objv179[0] = const5;
                                    // Arg 1 variable: $key
                                    tmp180 = getVarScalar(interp, "key", compiledLocals, 0);
                                    tmp180.preserve();
                                    objv179[1] = tmp180;
                                    // Arg 2 constant: 4
                                    objv179[2] = const16;
                                    // Arg 3 constant: true
                                    objv179[3] = const7;
                                    // Arg 4 constant: {}
                                    objv179[4] = const0;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                        ? cmdcache3.cmd : null), objv179, 0);
                                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                        updateCmdCache(interp, 3);
                                    }
                                } finally {
                                    tmp180 = objv179[1];
                                    if ( tmp180 != null ) {
                                        tmp180.release();
                                    }
                                    TJC.releaseObjv(interp, objv179, 5);
                                }
                            } // End Invoke: ...
                            tmp178 = interp.getResult();
                            setVarScalar(interp, "tuple", tmp178, compiledLocals, 4);
                        } // End Invoke: set
                        { // Invoke: set value_type [...]
                            TclObject tmp181;
                            { // Invoke: lindex $tuple 0
                                TclObject tmp182 = getVarScalar(interp, "tuple", compiledLocals, 4);
                                tmp182 = TclList.index(interp, tmp182, 0);
                                if ( tmp182 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp182);
                                }
                            } // End Invoke: lindex
                            tmp181 = interp.getResult();
                            setVarScalar(interp, "value_type", tmp181, compiledLocals, 6);
                        } // End Invoke: set
                        { // Invoke: set value_symbol [...]
                            TclObject tmp183;
                            { // Invoke: lindex $tuple 1
                                TclObject tmp184 = getVarScalar(interp, "tuple", compiledLocals, 4);
                                tmp184 = TclList.index(interp, tmp184, 1);
                                if ( tmp184 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp184);
                                }
                            } // End Invoke: lindex
                            tmp183 = interp.getResult();
                            setVarScalar(interp, "value_symbol", tmp183, compiledLocals, 7);
                        } // End Invoke: set
                        { // Invoke: set value_buffer [...]
                            TclObject tmp185;
                            { // Invoke: lindex $tuple 2
                                TclObject tmp186 = getVarScalar(interp, "tuple", compiledLocals, 4);
                                tmp186 = TclList.index(interp, tmp186, 2);
                                if ( tmp186 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp186);
                                }
                            } // End Invoke: lindex
                            tmp185 = interp.getResult();
                            setVarScalar(interp, "value_buffer", tmp185, compiledLocals, 8);
                        } // End Invoke: set
                        { // Invoke: append buffer $value_buffer
                            TclObject[] objv187 = TJC.grabObjv(interp, 1);
                            TclObject tmp188;
                            try {
                                // Arg 2 variable: $value_buffer
                                tmp188 = getVarScalar(interp, "value_buffer", compiledLocals, 8);
                                tmp188.preserve();
                                objv187[0] = tmp188;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv187, compiledLocals, 1);
                            } finally {
                                TJC.releaseObjvElems(interp, objv187, 1);
                            }
                        } // End Invoke: append
                        { // Invoke: set start_symbol $value_symbol
                            TclObject tmp189;
                            tmp189 = getVarScalar(interp, "value_symbol", compiledLocals, 7);
                            setVarScalar(interp, "start_symbol", tmp189, compiledLocals, 22);
                        } // End Invoke: set
                    } else {
                        { // Invoke: set start_symbol null
                            setVarScalar(interp, "start_symbol", const17, compiledLocals, 22);
                        } // End Invoke: set
                    }
                } // End Invoke: if
                { // Invoke: set result_tmpsymbol [...]
                    TclObject tmp190;
                    { // Invoke: ...
                        TclObject[] objv191 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: ...
                            objv191[0] = const8;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                ? cmdcache4.cmd : null), objv191, 0);
                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                updateCmdCache(interp, 4);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv191, 1);
                        }
                    } // End Invoke: ...
                    tmp190 = interp.getResult();
                    setVarScalar(interp, "result_tmpsymbol", tmp190, compiledLocals, 11);
                } // End Invoke: set
                { // Invoke: if ... ... else ...
                    // Binary operator: $substr_is_constant && ()
                    TclObject tmp192 = getVarScalar(interp, "substr_is_constant", compiledLocals, 12);
                    ExprValue tmp193 = evs0;
                    TJC.exprInitValue(interp, tmp193, tmp192);
                    if (tmp193.getBooleanValue(interp)) {
                    // Binary operator: $num_args == 4
                    TclObject tmp194 = getVarScalar(interp, "num_args", compiledLocals, 3);
                    ExprValue tmp195 = evs1;
                    TJC.exprInitValue(interp, tmp195, tmp194);
                    ExprValue tmp196 = evs2;
                    tmp196.setIntValue(4);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp195, tmp196);
                    // End Binary operator: ==
                    tmp193.setIntValue(tmp195.getBooleanValue(interp));
                    } else {
                    tmp193.setIntValue(0);
                    } // End if: $substr_is_constant
                    // End Binary operator: &&
                    boolean tmp197 = ( tmp193.getIntValue() != 0 );
                    if ( tmp197 ) {
                        { // Invoke: append buffer [...]
                            TclObject[] objv198 = TJC.grabObjv(interp, 1);
                            TclObject tmp199;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: emitter_statement "..."
                                    TclObject[] objv200 = TJC.grabObjv(interp, 2);
                                    TclObject tmp201;
                                    try {
                                        // Arg 0 constant: emitter_statement
                                        objv200[0] = const9;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp202 = new StringBuffer(64);
                                        sbtmp202.append("int ");
                                        tmp201 = getVarScalar(interp, "result_tmpsymbol", compiledLocals, 11);
                                        sbtmp202.append(tmp201.toString());
                                        sbtmp202.append(" = ");
                                        tmp201 = getVarScalar(interp, "string_tmpsymbol", compiledLocals, 21);
                                        sbtmp202.append(tmp201.toString());
                                        sbtmp202.append(".indexOf(");
                                        tmp201 = getVarScalar(interp, "substr_tmpsymbol", compiledLocals, 19);
                                        sbtmp202.append(tmp201.toString());
                                        sbtmp202.append(")");
                                        tmp201 = TclString.newInstance(sbtmp202);
                                        tmp201.preserve();
                                        objv200[1] = tmp201;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                            ? cmdcache5.cmd : null), objv200, 0);
                                        if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                            updateCmdCache(interp, 5);
                                        }
                                    } finally {
                                        tmp201 = objv200[1];
                                        if ( tmp201 != null ) {
                                            tmp201.release();
                                        }
                                        TJC.releaseObjv(interp, objv200, 2);
                                    }
                                } // End Invoke: emitter_statement
                                tmp199 = interp.getResult();
                                tmp199.preserve();
                                objv198[0] = tmp199;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv198, compiledLocals, 1);
                            } finally {
                                TJC.releaseObjvElems(interp, objv198, 1);
                            }
                        } // End Invoke: append
                    } else {
                        { // Invoke: append buffer [...]
                            TclObject[] objv203 = TJC.grabObjv(interp, 1);
                            TclObject tmp204;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: emitter_statement "..."
                                    TclObject[] objv205 = TJC.grabObjv(interp, 2);
                                    TclObject tmp206;
                                    try {
                                        // Arg 0 constant: emitter_statement
                                        objv205[0] = const9;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp207 = new StringBuffer(64);
                                        sbtmp207.append("TclObject ");
                                        tmp206 = getVarScalar(interp, "result_tmpsymbol", compiledLocals, 11);
                                        sbtmp207.append(tmp206.toString());
                                        sbtmp207.append(" = TJC.stringFirst(interp, ");
                                        tmp206 = getVarScalar(interp, "substr_tmpsymbol", compiledLocals, 19);
                                        sbtmp207.append(tmp206.toString());
                                        sbtmp207.append(", ");
                                        tmp206 = getVarScalar(interp, "string_tmpsymbol", compiledLocals, 21);
                                        sbtmp207.append(tmp206.toString());
                                        sbtmp207.append(", ");
                                        tmp206 = getVarScalar(interp, "start_symbol", compiledLocals, 22);
                                        sbtmp207.append(tmp206.toString());
                                        sbtmp207.append(")");
                                        tmp206 = TclString.newInstance(sbtmp207);
                                        tmp206.preserve();
                                        objv205[1] = tmp206;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                            ? cmdcache5.cmd : null), objv205, 0);
                                        if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                            updateCmdCache(interp, 5);
                                        }
                                    } finally {
                                        tmp206 = objv205[1];
                                        if ( tmp206 != null ) {
                                            tmp206.release();
                                        }
                                        TJC.releaseObjv(interp, objv205, 2);
                                    }
                                } // End Invoke: emitter_statement
                                tmp204 = interp.getResult();
                                tmp204.preserve();
                                objv203[0] = tmp204;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv203, compiledLocals, 1);
                            } finally {
                                TJC.releaseObjvElems(interp, objv203, 1);
                            }
                        } // End Invoke: append
                    }
                } // End Invoke: if
                { // Invoke: append buffer [...]
                    TclObject[] objv208 = TJC.grabObjv(interp, 1);
                    TclObject tmp209;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: emitter_set_result $result_tmpsymbol false
                            TclObject[] objv210 = TJC.grabObjv(interp, 3);
                            TclObject tmp211;
                            try {
                                // Arg 0 constant: emitter_set_result
                                objv210[0] = const11;
                                // Arg 1 variable: $result_tmpsymbol
                                tmp211 = getVarScalar(interp, "result_tmpsymbol", compiledLocals, 11);
                                tmp211.preserve();
                                objv210[1] = tmp211;
                                // Arg 2 constant: false
                                objv210[2] = const12;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                    ? cmdcache6.cmd : null), objv210, 0);
                                if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                    updateCmdCache(interp, 6);
                                }
                            } finally {
                                tmp211 = objv210[1];
                                if ( tmp211 != null ) {
                                    tmp211.release();
                                }
                                TJC.releaseObjv(interp, objv210, 3);
                            }
                        } // End Invoke: emitter_set_result
                        tmp209 = interp.getResult();
                        tmp209.preserve();
                        objv208[0] = tmp209;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv208, compiledLocals, 1);
                    } finally {
                        TJC.releaseObjvElems(interp, objv208, 1);
                    }
                } // End Invoke: append
            } else if ( tmp12_length == 5 && tmp12_first == 'i'
                    && tmp12.compareTo("index") == 0 ) {
                // Pattern {index}
                { // Invoke: set tuple [...]
                    TclObject tmp212;
                    { // Invoke: ... $key 2 true {}
                        TclObject[] objv213 = TJC.grabObjv(interp, 5);
                        TclObject tmp214;
                        try {
                            // Arg 0 constant: ...
                            objv213[0] = const5;
                            // Arg 1 variable: $key
                            tmp214 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp214.preserve();
                            objv213[1] = tmp214;
                            // Arg 2 constant: 2
                            objv213[2] = const6;
                            // Arg 3 constant: true
                            objv213[3] = const7;
                            // Arg 4 constant: {}
                            objv213[4] = const0;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv213, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            tmp214 = objv213[1];
                            if ( tmp214 != null ) {
                                tmp214.release();
                            }
                            TJC.releaseObjv(interp, objv213, 5);
                        }
                    } // End Invoke: ...
                    tmp212 = interp.getResult();
                    setVarScalar(interp, "tuple", tmp212, compiledLocals, 4);
                } // End Invoke: set
                { // Invoke: set value_type [...]
                    TclObject tmp215;
                    { // Invoke: lindex $tuple 0
                        TclObject tmp216 = getVarScalar(interp, "tuple", compiledLocals, 4);
                        tmp216 = TclList.index(interp, tmp216, 0);
                        if ( tmp216 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp216);
                        }
                    } // End Invoke: lindex
                    tmp215 = interp.getResult();
                    setVarScalar(interp, "value_type", tmp215, compiledLocals, 6);
                } // End Invoke: set
                { // Invoke: set value_symbol [...]
                    TclObject tmp217;
                    { // Invoke: lindex $tuple 1
                        TclObject tmp218 = getVarScalar(interp, "tuple", compiledLocals, 4);
                        tmp218 = TclList.index(interp, tmp218, 1);
                        if ( tmp218 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp218);
                        }
                    } // End Invoke: lindex
                    tmp217 = interp.getResult();
                    setVarScalar(interp, "value_symbol", tmp217, compiledLocals, 7);
                } // End Invoke: set
                { // Invoke: set value_buffer [...]
                    TclObject tmp219;
                    { // Invoke: lindex $tuple 2
                        TclObject tmp220 = getVarScalar(interp, "tuple", compiledLocals, 4);
                        tmp220 = TclList.index(interp, tmp220, 2);
                        if ( tmp220 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp220);
                        }
                    } // End Invoke: lindex
                    tmp219 = interp.getResult();
                    setVarScalar(interp, "value_buffer", tmp219, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: set string_tmpsymbol [...]
                    TclObject tmp221;
                    { // Invoke: ...
                        TclObject[] objv222 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: ...
                            objv222[0] = const8;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                ? cmdcache4.cmd : null), objv222, 0);
                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                updateCmdCache(interp, 4);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv222, 1);
                        }
                    } // End Invoke: ...
                    tmp221 = interp.getResult();
                    setVarScalar(interp, "string_tmpsymbol", tmp221, compiledLocals, 21);
                } // End Invoke: set
                { // Invoke: append buffer $value_buffer [...]
                    TclObject[] objv223 = TJC.grabObjv(interp, 2);
                    TclObject tmp224;
                    try {
                        // Arg 2 variable: $value_buffer
                        tmp224 = getVarScalar(interp, "value_buffer", compiledLocals, 8);
                        tmp224.preserve();
                        objv223[0] = tmp224;
                        // Arg 3 command: [...]
                        { // Invoke: emitter_statement "..."
                            TclObject[] objv225 = TJC.grabObjv(interp, 2);
                            TclObject tmp226;
                            try {
                                // Arg 0 constant: emitter_statement
                                objv225[0] = const9;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp227 = new StringBuffer(64);
                                sbtmp227.append("String ");
                                tmp226 = getVarScalar(interp, "string_tmpsymbol", compiledLocals, 21);
                                sbtmp227.append(tmp226.toString());
                                sbtmp227.append(" = ");
                                tmp226 = getVarScalar(interp, "value_symbol", compiledLocals, 7);
                                sbtmp227.append(tmp226.toString());
                                sbtmp227.append(".toString()");
                                tmp226 = TclString.newInstance(sbtmp227);
                                tmp226.preserve();
                                objv225[1] = tmp226;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                    ? cmdcache5.cmd : null), objv225, 0);
                                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                    updateCmdCache(interp, 5);
                                }
                            } finally {
                                tmp226 = objv225[1];
                                if ( tmp226 != null ) {
                                    tmp226.release();
                                }
                                TJC.releaseObjv(interp, objv225, 2);
                            }
                        } // End Invoke: emitter_statement
                        tmp224 = interp.getResult();
                        tmp224.preserve();
                        objv223[1] = tmp224;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv223, compiledLocals, 1);
                    } finally {
                        TJC.releaseObjvElems(interp, objv223, 2);
                    }
                } // End Invoke: append
                { // Invoke: set tuple [...]
                    TclObject tmp228;
                    { // Invoke: ... $key 3 true {}
                        TclObject[] objv229 = TJC.grabObjv(interp, 5);
                        TclObject tmp230;
                        try {
                            // Arg 0 constant: ...
                            objv229[0] = const5;
                            // Arg 1 variable: $key
                            tmp230 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp230.preserve();
                            objv229[1] = tmp230;
                            // Arg 2 constant: 3
                            objv229[2] = const10;
                            // Arg 3 constant: true
                            objv229[3] = const7;
                            // Arg 4 constant: {}
                            objv229[4] = const0;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv229, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            tmp230 = objv229[1];
                            if ( tmp230 != null ) {
                                tmp230.release();
                            }
                            TJC.releaseObjv(interp, objv229, 5);
                        }
                    } // End Invoke: ...
                    tmp228 = interp.getResult();
                    setVarScalar(interp, "tuple", tmp228, compiledLocals, 4);
                } // End Invoke: set
                { // Invoke: set value_type [...]
                    TclObject tmp231;
                    { // Invoke: lindex $tuple 0
                        TclObject tmp232 = getVarScalar(interp, "tuple", compiledLocals, 4);
                        tmp232 = TclList.index(interp, tmp232, 0);
                        if ( tmp232 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp232);
                        }
                    } // End Invoke: lindex
                    tmp231 = interp.getResult();
                    setVarScalar(interp, "value_type", tmp231, compiledLocals, 6);
                } // End Invoke: set
                { // Invoke: set value_symbol [...]
                    TclObject tmp233;
                    { // Invoke: lindex $tuple 1
                        TclObject tmp234 = getVarScalar(interp, "tuple", compiledLocals, 4);
                        tmp234 = TclList.index(interp, tmp234, 1);
                        if ( tmp234 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp234);
                        }
                    } // End Invoke: lindex
                    tmp233 = interp.getResult();
                    setVarScalar(interp, "value_symbol", tmp233, compiledLocals, 7);
                } // End Invoke: set
                { // Invoke: set value_buffer [...]
                    TclObject tmp235;
                    { // Invoke: lindex $tuple 2
                        TclObject tmp236 = getVarScalar(interp, "tuple", compiledLocals, 4);
                        tmp236 = TclList.index(interp, tmp236, 2);
                        if ( tmp236 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp236);
                        }
                    } // End Invoke: lindex
                    tmp235 = interp.getResult();
                    setVarScalar(interp, "value_buffer", tmp235, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: set result_tmpsymbol [...]
                    TclObject tmp237;
                    { // Invoke: ...
                        TclObject[] objv238 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: ...
                            objv238[0] = const8;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                ? cmdcache4.cmd : null), objv238, 0);
                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                updateCmdCache(interp, 4);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv238, 1);
                        }
                    } // End Invoke: ...
                    tmp237 = interp.getResult();
                    setVarScalar(interp, "result_tmpsymbol", tmp237, compiledLocals, 11);
                } // End Invoke: set
                { // Invoke: append buffer $value_buffer [...] [...]
                    TclObject[] objv239 = TJC.grabObjv(interp, 3);
                    TclObject tmp240;
                    try {
                        // Arg 2 variable: $value_buffer
                        tmp240 = getVarScalar(interp, "value_buffer", compiledLocals, 8);
                        tmp240.preserve();
                        objv239[0] = tmp240;
                        // Arg 3 command: [...]
                        { // Invoke: emitter_statement "..."
                            TclObject[] objv241 = TJC.grabObjv(interp, 2);
                            TclObject tmp242;
                            try {
                                // Arg 0 constant: emitter_statement
                                objv241[0] = const9;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp243 = new StringBuffer(64);
                                sbtmp243.append("TclObject ");
                                tmp242 = getVarScalar(interp, "result_tmpsymbol", compiledLocals, 11);
                                sbtmp243.append(tmp242.toString());
                                sbtmp243.append(" = TJC.stringIndex(interp, ");
                                tmp242 = getVarScalar(interp, "string_tmpsymbol", compiledLocals, 21);
                                sbtmp243.append(tmp242.toString());
                                sbtmp243.append(", ");
                                tmp242 = getVarScalar(interp, "value_symbol", compiledLocals, 7);
                                sbtmp243.append(tmp242.toString());
                                sbtmp243.append(")");
                                tmp242 = TclString.newInstance(sbtmp243);
                                tmp242.preserve();
                                objv241[1] = tmp242;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                    ? cmdcache5.cmd : null), objv241, 0);
                                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                    updateCmdCache(interp, 5);
                                }
                            } finally {
                                tmp242 = objv241[1];
                                if ( tmp242 != null ) {
                                    tmp242.release();
                                }
                                TJC.releaseObjv(interp, objv241, 2);
                            }
                        } // End Invoke: emitter_statement
                        tmp240 = interp.getResult();
                        tmp240.preserve();
                        objv239[1] = tmp240;
                        // Arg 4 command: [...]
                        { // Invoke: emitter_set_result $result_tmpsymbol false
                            TclObject[] objv244 = TJC.grabObjv(interp, 3);
                            TclObject tmp245;
                            try {
                                // Arg 0 constant: emitter_set_result
                                objv244[0] = const11;
                                // Arg 1 variable: $result_tmpsymbol
                                tmp245 = getVarScalar(interp, "result_tmpsymbol", compiledLocals, 11);
                                tmp245.preserve();
                                objv244[1] = tmp245;
                                // Arg 2 constant: false
                                objv244[2] = const12;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                    ? cmdcache6.cmd : null), objv244, 0);
                                if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                    updateCmdCache(interp, 6);
                                }
                            } finally {
                                tmp245 = objv244[1];
                                if ( tmp245 != null ) {
                                    tmp245.release();
                                }
                                TJC.releaseObjv(interp, objv244, 3);
                            }
                        } // End Invoke: emitter_set_result
                        tmp240 = interp.getResult();
                        tmp240.preserve();
                        objv239[2] = tmp240;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv239, compiledLocals, 1);
                    } finally {
                        TJC.releaseObjvElems(interp, objv239, 3);
                    }
                } // End Invoke: append
            } else if ( tmp12_length == 4 && tmp12_first == 'l'
                    && tmp12.compareTo("last") == 0 ) {
                // Pattern {last}
                { // Invoke: set tuple [...]
                    TclObject tmp246;
                    { // Invoke: ... $key 2
                        TclObject[] objv247 = TJC.grabObjv(interp, 3);
                        TclObject tmp248;
                        try {
                            // Arg 0 constant: ...
                            objv247[0] = const3;
                            // Arg 1 variable: $key
                            tmp248 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp248.preserve();
                            objv247[1] = tmp248;
                            // Arg 2 constant: 2
                            objv247[2] = const6;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv247, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp248 = objv247[1];
                            if ( tmp248 != null ) {
                                tmp248.release();
                            }
                            TJC.releaseObjv(interp, objv247, 3);
                        }
                    } // End Invoke: ...
                    tmp246 = interp.getResult();
                    setVarScalar(interp, "tuple", tmp246, compiledLocals, 4);
                } // End Invoke: set
                { // Invoke: set tuple [...]
                    TclObject tmp249;
                    { // Invoke: ... $key 2 true {}
                        TclObject[] objv250 = TJC.grabObjv(interp, 5);
                        TclObject tmp251;
                        try {
                            // Arg 0 constant: ...
                            objv250[0] = const5;
                            // Arg 1 variable: $key
                            tmp251 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp251.preserve();
                            objv250[1] = tmp251;
                            // Arg 2 constant: 2
                            objv250[2] = const6;
                            // Arg 3 constant: true
                            objv250[3] = const7;
                            // Arg 4 constant: {}
                            objv250[4] = const0;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv250, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            tmp251 = objv250[1];
                            if ( tmp251 != null ) {
                                tmp251.release();
                            }
                            TJC.releaseObjv(interp, objv250, 5);
                        }
                    } // End Invoke: ...
                    tmp249 = interp.getResult();
                    setVarScalar(interp, "tuple", tmp249, compiledLocals, 4);
                } // End Invoke: set
                { // Invoke: set value_type [...]
                    TclObject tmp252;
                    { // Invoke: lindex $tuple 0
                        TclObject tmp253 = getVarScalar(interp, "tuple", compiledLocals, 4);
                        tmp253 = TclList.index(interp, tmp253, 0);
                        if ( tmp253 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp253);
                        }
                    } // End Invoke: lindex
                    tmp252 = interp.getResult();
                    setVarScalar(interp, "value_type", tmp252, compiledLocals, 6);
                } // End Invoke: set
                { // Invoke: set value_symbol [...]
                    TclObject tmp254;
                    { // Invoke: lindex $tuple 1
                        TclObject tmp255 = getVarScalar(interp, "tuple", compiledLocals, 4);
                        tmp255 = TclList.index(interp, tmp255, 1);
                        if ( tmp255 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp255);
                        }
                    } // End Invoke: lindex
                    tmp254 = interp.getResult();
                    setVarScalar(interp, "value_symbol", tmp254, compiledLocals, 7);
                } // End Invoke: set
                { // Invoke: set value_buffer [...]
                    TclObject tmp256;
                    { // Invoke: lindex $tuple 2
                        TclObject tmp257 = getVarScalar(interp, "tuple", compiledLocals, 4);
                        tmp257 = TclList.index(interp, tmp257, 2);
                        if ( tmp257 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp257);
                        }
                    } // End Invoke: lindex
                    tmp256 = interp.getResult();
                    setVarScalar(interp, "value_buffer", tmp256, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: set substr_tmpsymbol [...]
                    TclObject tmp258;
                    { // Invoke: ...
                        TclObject[] objv259 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: ...
                            objv259[0] = const8;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                ? cmdcache4.cmd : null), objv259, 0);
                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                updateCmdCache(interp, 4);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv259, 1);
                        }
                    } // End Invoke: ...
                    tmp258 = interp.getResult();
                    setVarScalar(interp, "substr_tmpsymbol", tmp258, compiledLocals, 19);
                } // End Invoke: set
                { // Invoke: append buffer $value_buffer [...]
                    TclObject[] objv260 = TJC.grabObjv(interp, 2);
                    TclObject tmp261;
                    try {
                        // Arg 2 variable: $value_buffer
                        tmp261 = getVarScalar(interp, "value_buffer", compiledLocals, 8);
                        tmp261.preserve();
                        objv260[0] = tmp261;
                        // Arg 3 command: [...]
                        { // Invoke: emitter_statement "..."
                            TclObject[] objv262 = TJC.grabObjv(interp, 2);
                            TclObject tmp263;
                            try {
                                // Arg 0 constant: emitter_statement
                                objv262[0] = const9;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp264 = new StringBuffer(64);
                                sbtmp264.append("String ");
                                tmp263 = getVarScalar(interp, "substr_tmpsymbol", compiledLocals, 19);
                                sbtmp264.append(tmp263.toString());
                                sbtmp264.append(" = ");
                                tmp263 = getVarScalar(interp, "value_symbol", compiledLocals, 7);
                                sbtmp264.append(tmp263.toString());
                                sbtmp264.append(".toString()");
                                tmp263 = TclString.newInstance(sbtmp264);
                                tmp263.preserve();
                                objv262[1] = tmp263;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                    ? cmdcache5.cmd : null), objv262, 0);
                                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                    updateCmdCache(interp, 5);
                                }
                            } finally {
                                tmp263 = objv262[1];
                                if ( tmp263 != null ) {
                                    tmp263.release();
                                }
                                TJC.releaseObjv(interp, objv262, 2);
                            }
                        } // End Invoke: emitter_statement
                        tmp261 = interp.getResult();
                        tmp261.preserve();
                        objv260[1] = tmp261;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv260, compiledLocals, 1);
                    } finally {
                        TJC.releaseObjvElems(interp, objv260, 2);
                    }
                } // End Invoke: append
                { // Invoke: set tuple [...]
                    TclObject tmp265;
                    { // Invoke: ... $key 3 true {}
                        TclObject[] objv266 = TJC.grabObjv(interp, 5);
                        TclObject tmp267;
                        try {
                            // Arg 0 constant: ...
                            objv266[0] = const5;
                            // Arg 1 variable: $key
                            tmp267 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp267.preserve();
                            objv266[1] = tmp267;
                            // Arg 2 constant: 3
                            objv266[2] = const10;
                            // Arg 3 constant: true
                            objv266[3] = const7;
                            // Arg 4 constant: {}
                            objv266[4] = const0;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv266, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            tmp267 = objv266[1];
                            if ( tmp267 != null ) {
                                tmp267.release();
                            }
                            TJC.releaseObjv(interp, objv266, 5);
                        }
                    } // End Invoke: ...
                    tmp265 = interp.getResult();
                    setVarScalar(interp, "tuple", tmp265, compiledLocals, 4);
                } // End Invoke: set
                { // Invoke: set value_type [...]
                    TclObject tmp268;
                    { // Invoke: lindex $tuple 0
                        TclObject tmp269 = getVarScalar(interp, "tuple", compiledLocals, 4);
                        tmp269 = TclList.index(interp, tmp269, 0);
                        if ( tmp269 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp269);
                        }
                    } // End Invoke: lindex
                    tmp268 = interp.getResult();
                    setVarScalar(interp, "value_type", tmp268, compiledLocals, 6);
                } // End Invoke: set
                { // Invoke: set value_symbol [...]
                    TclObject tmp270;
                    { // Invoke: lindex $tuple 1
                        TclObject tmp271 = getVarScalar(interp, "tuple", compiledLocals, 4);
                        tmp271 = TclList.index(interp, tmp271, 1);
                        if ( tmp271 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp271);
                        }
                    } // End Invoke: lindex
                    tmp270 = interp.getResult();
                    setVarScalar(interp, "value_symbol", tmp270, compiledLocals, 7);
                } // End Invoke: set
                { // Invoke: set value_buffer [...]
                    TclObject tmp272;
                    { // Invoke: lindex $tuple 2
                        TclObject tmp273 = getVarScalar(interp, "tuple", compiledLocals, 4);
                        tmp273 = TclList.index(interp, tmp273, 2);
                        if ( tmp273 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp273);
                        }
                    } // End Invoke: lindex
                    tmp272 = interp.getResult();
                    setVarScalar(interp, "value_buffer", tmp272, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: set string_tmpsymbol [...]
                    TclObject tmp274;
                    { // Invoke: ...
                        TclObject[] objv275 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: ...
                            objv275[0] = const8;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                ? cmdcache4.cmd : null), objv275, 0);
                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                updateCmdCache(interp, 4);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv275, 1);
                        }
                    } // End Invoke: ...
                    tmp274 = interp.getResult();
                    setVarScalar(interp, "string_tmpsymbol", tmp274, compiledLocals, 21);
                } // End Invoke: set
                { // Invoke: append buffer $value_buffer [...]
                    TclObject[] objv276 = TJC.grabObjv(interp, 2);
                    TclObject tmp277;
                    try {
                        // Arg 2 variable: $value_buffer
                        tmp277 = getVarScalar(interp, "value_buffer", compiledLocals, 8);
                        tmp277.preserve();
                        objv276[0] = tmp277;
                        // Arg 3 command: [...]
                        { // Invoke: emitter_statement "..."
                            TclObject[] objv278 = TJC.grabObjv(interp, 2);
                            TclObject tmp279;
                            try {
                                // Arg 0 constant: emitter_statement
                                objv278[0] = const9;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp280 = new StringBuffer(64);
                                sbtmp280.append("String ");
                                tmp279 = getVarScalar(interp, "string_tmpsymbol", compiledLocals, 21);
                                sbtmp280.append(tmp279.toString());
                                sbtmp280.append(" = ");
                                tmp279 = getVarScalar(interp, "value_symbol", compiledLocals, 7);
                                sbtmp280.append(tmp279.toString());
                                sbtmp280.append(".toString()");
                                tmp279 = TclString.newInstance(sbtmp280);
                                tmp279.preserve();
                                objv278[1] = tmp279;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                    ? cmdcache5.cmd : null), objv278, 0);
                                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                    updateCmdCache(interp, 5);
                                }
                            } finally {
                                tmp279 = objv278[1];
                                if ( tmp279 != null ) {
                                    tmp279.release();
                                }
                                TJC.releaseObjv(interp, objv278, 2);
                            }
                        } // End Invoke: emitter_statement
                        tmp277 = interp.getResult();
                        tmp277.preserve();
                        objv276[1] = tmp277;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv276, compiledLocals, 1);
                    } finally {
                        TJC.releaseObjvElems(interp, objv276, 2);
                    }
                } // End Invoke: append
                { // Invoke: if {$num_args == 5} ... else ...
                    // Binary operator: $num_args == 5
                    TclObject tmp281 = getVarScalar(interp, "num_args", compiledLocals, 3);
                    ExprValue tmp282 = evs0;
                    TJC.exprInitValue(interp, tmp282, tmp281);
                    ExprValue tmp283 = evs1;
                    tmp283.setIntValue(5);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp282, tmp283);
                    // End Binary operator: ==
                    boolean tmp284 = ( tmp282.getIntValue() != 0 );
                    if ( tmp284 ) {
                        { // Invoke: set tuple [...]
                            TclObject tmp285;
                            { // Invoke: ... $key 4 true {}
                                TclObject[] objv286 = TJC.grabObjv(interp, 5);
                                TclObject tmp287;
                                try {
                                    // Arg 0 constant: ...
                                    objv286[0] = const5;
                                    // Arg 1 variable: $key
                                    tmp287 = getVarScalar(interp, "key", compiledLocals, 0);
                                    tmp287.preserve();
                                    objv286[1] = tmp287;
                                    // Arg 2 constant: 4
                                    objv286[2] = const16;
                                    // Arg 3 constant: true
                                    objv286[3] = const7;
                                    // Arg 4 constant: {}
                                    objv286[4] = const0;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                        ? cmdcache3.cmd : null), objv286, 0);
                                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                        updateCmdCache(interp, 3);
                                    }
                                } finally {
                                    tmp287 = objv286[1];
                                    if ( tmp287 != null ) {
                                        tmp287.release();
                                    }
                                    TJC.releaseObjv(interp, objv286, 5);
                                }
                            } // End Invoke: ...
                            tmp285 = interp.getResult();
                            setVarScalar(interp, "tuple", tmp285, compiledLocals, 4);
                        } // End Invoke: set
                        { // Invoke: set value_type [...]
                            TclObject tmp288;
                            { // Invoke: lindex $tuple 0
                                TclObject tmp289 = getVarScalar(interp, "tuple", compiledLocals, 4);
                                tmp289 = TclList.index(interp, tmp289, 0);
                                if ( tmp289 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp289);
                                }
                            } // End Invoke: lindex
                            tmp288 = interp.getResult();
                            setVarScalar(interp, "value_type", tmp288, compiledLocals, 6);
                        } // End Invoke: set
                        { // Invoke: set value_symbol [...]
                            TclObject tmp290;
                            { // Invoke: lindex $tuple 1
                                TclObject tmp291 = getVarScalar(interp, "tuple", compiledLocals, 4);
                                tmp291 = TclList.index(interp, tmp291, 1);
                                if ( tmp291 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp291);
                                }
                            } // End Invoke: lindex
                            tmp290 = interp.getResult();
                            setVarScalar(interp, "value_symbol", tmp290, compiledLocals, 7);
                        } // End Invoke: set
                        { // Invoke: set value_buffer [...]
                            TclObject tmp292;
                            { // Invoke: lindex $tuple 2
                                TclObject tmp293 = getVarScalar(interp, "tuple", compiledLocals, 4);
                                tmp293 = TclList.index(interp, tmp293, 2);
                                if ( tmp293 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp293);
                                }
                            } // End Invoke: lindex
                            tmp292 = interp.getResult();
                            setVarScalar(interp, "value_buffer", tmp292, compiledLocals, 8);
                        } // End Invoke: set
                        { // Invoke: append buffer $value_buffer
                            TclObject[] objv294 = TJC.grabObjv(interp, 1);
                            TclObject tmp295;
                            try {
                                // Arg 2 variable: $value_buffer
                                tmp295 = getVarScalar(interp, "value_buffer", compiledLocals, 8);
                                tmp295.preserve();
                                objv294[0] = tmp295;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv294, compiledLocals, 1);
                            } finally {
                                TJC.releaseObjvElems(interp, objv294, 1);
                            }
                        } // End Invoke: append
                        { // Invoke: set last_symbol $value_symbol
                            TclObject tmp296;
                            tmp296 = getVarScalar(interp, "value_symbol", compiledLocals, 7);
                            setVarScalar(interp, "last_symbol", tmp296, compiledLocals, 23);
                        } // End Invoke: set
                    } else {
                        { // Invoke: set last_symbol null
                            setVarScalar(interp, "last_symbol", const17, compiledLocals, 23);
                        } // End Invoke: set
                    }
                } // End Invoke: if
                { // Invoke: set result_tmpsymbol [...]
                    TclObject tmp297;
                    { // Invoke: ...
                        TclObject[] objv298 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: ...
                            objv298[0] = const8;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                ? cmdcache4.cmd : null), objv298, 0);
                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                updateCmdCache(interp, 4);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv298, 1);
                        }
                    } // End Invoke: ...
                    tmp297 = interp.getResult();
                    setVarScalar(interp, "result_tmpsymbol", tmp297, compiledLocals, 11);
                } // End Invoke: set
                { // Invoke: append buffer [...] [...]
                    TclObject[] objv299 = TJC.grabObjv(interp, 2);
                    TclObject tmp300;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: emitter_statement "..."
                            TclObject[] objv301 = TJC.grabObjv(interp, 2);
                            TclObject tmp302;
                            try {
                                // Arg 0 constant: emitter_statement
                                objv301[0] = const9;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp303 = new StringBuffer(64);
                                sbtmp303.append("TclObject ");
                                tmp302 = getVarScalar(interp, "result_tmpsymbol", compiledLocals, 11);
                                sbtmp303.append(tmp302.toString());
                                sbtmp303.append(" = TJC.stringLast(interp, ");
                                tmp302 = getVarScalar(interp, "substr_tmpsymbol", compiledLocals, 19);
                                sbtmp303.append(tmp302.toString());
                                sbtmp303.append(", ");
                                tmp302 = getVarScalar(interp, "string_tmpsymbol", compiledLocals, 21);
                                sbtmp303.append(tmp302.toString());
                                sbtmp303.append(", ");
                                tmp302 = getVarScalar(interp, "last_symbol", compiledLocals, 23);
                                sbtmp303.append(tmp302.toString());
                                sbtmp303.append(")");
                                tmp302 = TclString.newInstance(sbtmp303);
                                tmp302.preserve();
                                objv301[1] = tmp302;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                    ? cmdcache5.cmd : null), objv301, 0);
                                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                    updateCmdCache(interp, 5);
                                }
                            } finally {
                                tmp302 = objv301[1];
                                if ( tmp302 != null ) {
                                    tmp302.release();
                                }
                                TJC.releaseObjv(interp, objv301, 2);
                            }
                        } // End Invoke: emitter_statement
                        tmp300 = interp.getResult();
                        tmp300.preserve();
                        objv299[0] = tmp300;
                        // Arg 3 command: [...]
                        { // Invoke: emitter_set_result $result_tmpsymbol false
                            TclObject[] objv304 = TJC.grabObjv(interp, 3);
                            TclObject tmp305;
                            try {
                                // Arg 0 constant: emitter_set_result
                                objv304[0] = const11;
                                // Arg 1 variable: $result_tmpsymbol
                                tmp305 = getVarScalar(interp, "result_tmpsymbol", compiledLocals, 11);
                                tmp305.preserve();
                                objv304[1] = tmp305;
                                // Arg 2 constant: false
                                objv304[2] = const12;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                    ? cmdcache6.cmd : null), objv304, 0);
                                if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                    updateCmdCache(interp, 6);
                                }
                            } finally {
                                tmp305 = objv304[1];
                                if ( tmp305 != null ) {
                                    tmp305.release();
                                }
                                TJC.releaseObjv(interp, objv304, 3);
                            }
                        } // End Invoke: emitter_set_result
                        tmp300 = interp.getResult();
                        tmp300.preserve();
                        objv299[1] = tmp300;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv299, compiledLocals, 1);
                    } finally {
                        TJC.releaseObjvElems(interp, objv299, 2);
                    }
                } // End Invoke: append
            } else if ( tmp12_length == 6 && tmp12_first == 'l'
                    && tmp12.compareTo("length") == 0 ) {
                // Pattern {length}
                { // Invoke: set tuple [...]
                    TclObject tmp306;
                    { // Invoke: ... $key 2 true {}
                        TclObject[] objv307 = TJC.grabObjv(interp, 5);
                        TclObject tmp308;
                        try {
                            // Arg 0 constant: ...
                            objv307[0] = const5;
                            // Arg 1 variable: $key
                            tmp308 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp308.preserve();
                            objv307[1] = tmp308;
                            // Arg 2 constant: 2
                            objv307[2] = const6;
                            // Arg 3 constant: true
                            objv307[3] = const7;
                            // Arg 4 constant: {}
                            objv307[4] = const0;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv307, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            tmp308 = objv307[1];
                            if ( tmp308 != null ) {
                                tmp308.release();
                            }
                            TJC.releaseObjv(interp, objv307, 5);
                        }
                    } // End Invoke: ...
                    tmp306 = interp.getResult();
                    setVarScalar(interp, "tuple", tmp306, compiledLocals, 4);
                } // End Invoke: set
                { // Invoke: set value_type [...]
                    TclObject tmp309;
                    { // Invoke: lindex $tuple 0
                        TclObject tmp310 = getVarScalar(interp, "tuple", compiledLocals, 4);
                        tmp310 = TclList.index(interp, tmp310, 0);
                        if ( tmp310 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp310);
                        }
                    } // End Invoke: lindex
                    tmp309 = interp.getResult();
                    setVarScalar(interp, "value_type", tmp309, compiledLocals, 6);
                } // End Invoke: set
                { // Invoke: set value_symbol [...]
                    TclObject tmp311;
                    { // Invoke: lindex $tuple 1
                        TclObject tmp312 = getVarScalar(interp, "tuple", compiledLocals, 4);
                        tmp312 = TclList.index(interp, tmp312, 1);
                        if ( tmp312 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp312);
                        }
                    } // End Invoke: lindex
                    tmp311 = interp.getResult();
                    setVarScalar(interp, "value_symbol", tmp311, compiledLocals, 7);
                } // End Invoke: set
                { // Invoke: set value_buffer [...]
                    TclObject tmp313;
                    { // Invoke: lindex $tuple 2
                        TclObject tmp314 = getVarScalar(interp, "tuple", compiledLocals, 4);
                        tmp314 = TclList.index(interp, tmp314, 2);
                        if ( tmp314 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp314);
                        }
                    } // End Invoke: lindex
                    tmp313 = interp.getResult();
                    setVarScalar(interp, "value_buffer", tmp313, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: set int_tmpsymbol [...]
                    TclObject tmp315;
                    { // Invoke: ...
                        TclObject[] objv316 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: ...
                            objv316[0] = const8;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                ? cmdcache4.cmd : null), objv316, 0);
                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                updateCmdCache(interp, 4);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv316, 1);
                        }
                    } // End Invoke: ...
                    tmp315 = interp.getResult();
                    setVarScalar(interp, "int_tmpsymbol", tmp315, compiledLocals, 24);
                } // End Invoke: set
                { // Invoke: append buffer $value_buffer [...] [...]
                    TclObject[] objv317 = TJC.grabObjv(interp, 3);
                    TclObject tmp318;
                    try {
                        // Arg 2 variable: $value_buffer
                        tmp318 = getVarScalar(interp, "value_buffer", compiledLocals, 8);
                        tmp318.preserve();
                        objv317[0] = tmp318;
                        // Arg 3 command: [...]
                        { // Invoke: emitter_statement "..."
                            TclObject[] objv319 = TJC.grabObjv(interp, 2);
                            TclObject tmp320;
                            try {
                                // Arg 0 constant: emitter_statement
                                objv319[0] = const9;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp321 = new StringBuffer(64);
                                sbtmp321.append("int ");
                                tmp320 = getVarScalar(interp, "int_tmpsymbol", compiledLocals, 24);
                                sbtmp321.append(tmp320.toString());
                                sbtmp321.append(" = ");
                                tmp320 = getVarScalar(interp, "value_symbol", compiledLocals, 7);
                                sbtmp321.append(tmp320.toString());
                                sbtmp321.append(".toString().length()");
                                tmp320 = TclString.newInstance(sbtmp321);
                                tmp320.preserve();
                                objv319[1] = tmp320;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                    ? cmdcache5.cmd : null), objv319, 0);
                                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                    updateCmdCache(interp, 5);
                                }
                            } finally {
                                tmp320 = objv319[1];
                                if ( tmp320 != null ) {
                                    tmp320.release();
                                }
                                TJC.releaseObjv(interp, objv319, 2);
                            }
                        } // End Invoke: emitter_statement
                        tmp318 = interp.getResult();
                        tmp318.preserve();
                        objv317[1] = tmp318;
                        // Arg 4 command: [...]
                        { // Invoke: emitter_set_result $int_tmpsymbol false
                            TclObject[] objv322 = TJC.grabObjv(interp, 3);
                            TclObject tmp323;
                            try {
                                // Arg 0 constant: emitter_set_result
                                objv322[0] = const11;
                                // Arg 1 variable: $int_tmpsymbol
                                tmp323 = getVarScalar(interp, "int_tmpsymbol", compiledLocals, 24);
                                tmp323.preserve();
                                objv322[1] = tmp323;
                                // Arg 2 constant: false
                                objv322[2] = const12;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                    ? cmdcache6.cmd : null), objv322, 0);
                                if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                    updateCmdCache(interp, 6);
                                }
                            } finally {
                                tmp323 = objv322[1];
                                if ( tmp323 != null ) {
                                    tmp323.release();
                                }
                                TJC.releaseObjv(interp, objv322, 3);
                            }
                        } // End Invoke: emitter_set_result
                        tmp318 = interp.getResult();
                        tmp318.preserve();
                        objv317[2] = tmp318;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv317, compiledLocals, 1);
                    } finally {
                        TJC.releaseObjvElems(interp, objv317, 3);
                    }
                } // End Invoke: append
            } else if ( tmp12_length == 5 && tmp12_first == 'r'
                    && tmp12.compareTo("range") == 0 ) {
                // Pattern {range}
                { // Invoke: set tuple [...]
                    TclObject tmp324;
                    { // Invoke: ... $key 2 true {}
                        TclObject[] objv325 = TJC.grabObjv(interp, 5);
                        TclObject tmp326;
                        try {
                            // Arg 0 constant: ...
                            objv325[0] = const5;
                            // Arg 1 variable: $key
                            tmp326 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp326.preserve();
                            objv325[1] = tmp326;
                            // Arg 2 constant: 2
                            objv325[2] = const6;
                            // Arg 3 constant: true
                            objv325[3] = const7;
                            // Arg 4 constant: {}
                            objv325[4] = const0;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv325, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            tmp326 = objv325[1];
                            if ( tmp326 != null ) {
                                tmp326.release();
                            }
                            TJC.releaseObjv(interp, objv325, 5);
                        }
                    } // End Invoke: ...
                    tmp324 = interp.getResult();
                    setVarScalar(interp, "tuple", tmp324, compiledLocals, 4);
                } // End Invoke: set
                { // Invoke: set value_type [...]
                    TclObject tmp327;
                    { // Invoke: lindex $tuple 0
                        TclObject tmp328 = getVarScalar(interp, "tuple", compiledLocals, 4);
                        tmp328 = TclList.index(interp, tmp328, 0);
                        if ( tmp328 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp328);
                        }
                    } // End Invoke: lindex
                    tmp327 = interp.getResult();
                    setVarScalar(interp, "value_type", tmp327, compiledLocals, 6);
                } // End Invoke: set
                { // Invoke: set value_symbol [...]
                    TclObject tmp329;
                    { // Invoke: lindex $tuple 1
                        TclObject tmp330 = getVarScalar(interp, "tuple", compiledLocals, 4);
                        tmp330 = TclList.index(interp, tmp330, 1);
                        if ( tmp330 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp330);
                        }
                    } // End Invoke: lindex
                    tmp329 = interp.getResult();
                    setVarScalar(interp, "value_symbol", tmp329, compiledLocals, 7);
                } // End Invoke: set
                { // Invoke: set value_buffer [...]
                    TclObject tmp331;
                    { // Invoke: lindex $tuple 2
                        TclObject tmp332 = getVarScalar(interp, "tuple", compiledLocals, 4);
                        tmp332 = TclList.index(interp, tmp332, 2);
                        if ( tmp332 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp332);
                        }
                    } // End Invoke: lindex
                    tmp331 = interp.getResult();
                    setVarScalar(interp, "value_buffer", tmp331, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: set string_tmpsymbol [...]
                    TclObject tmp333;
                    { // Invoke: ...
                        TclObject[] objv334 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: ...
                            objv334[0] = const8;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                ? cmdcache4.cmd : null), objv334, 0);
                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                updateCmdCache(interp, 4);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv334, 1);
                        }
                    } // End Invoke: ...
                    tmp333 = interp.getResult();
                    setVarScalar(interp, "string_tmpsymbol", tmp333, compiledLocals, 21);
                } // End Invoke: set
                { // Invoke: append buffer $value_buffer [...]
                    TclObject[] objv335 = TJC.grabObjv(interp, 2);
                    TclObject tmp336;
                    try {
                        // Arg 2 variable: $value_buffer
                        tmp336 = getVarScalar(interp, "value_buffer", compiledLocals, 8);
                        tmp336.preserve();
                        objv335[0] = tmp336;
                        // Arg 3 command: [...]
                        { // Invoke: emitter_statement "..."
                            TclObject[] objv337 = TJC.grabObjv(interp, 2);
                            TclObject tmp338;
                            try {
                                // Arg 0 constant: emitter_statement
                                objv337[0] = const9;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp339 = new StringBuffer(64);
                                sbtmp339.append("String ");
                                tmp338 = getVarScalar(interp, "string_tmpsymbol", compiledLocals, 21);
                                sbtmp339.append(tmp338.toString());
                                sbtmp339.append(" = ");
                                tmp338 = getVarScalar(interp, "value_symbol", compiledLocals, 7);
                                sbtmp339.append(tmp338.toString());
                                sbtmp339.append(".toString()");
                                tmp338 = TclString.newInstance(sbtmp339);
                                tmp338.preserve();
                                objv337[1] = tmp338;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                    ? cmdcache5.cmd : null), objv337, 0);
                                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                    updateCmdCache(interp, 5);
                                }
                            } finally {
                                tmp338 = objv337[1];
                                if ( tmp338 != null ) {
                                    tmp338.release();
                                }
                                TJC.releaseObjv(interp, objv337, 2);
                            }
                        } // End Invoke: emitter_statement
                        tmp336 = interp.getResult();
                        tmp336.preserve();
                        objv335[1] = tmp336;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv335, compiledLocals, 1);
                    } finally {
                        TJC.releaseObjvElems(interp, objv335, 2);
                    }
                } // End Invoke: append
                { // Invoke: set tuple [...]
                    TclObject tmp340;
                    { // Invoke: ... $key 3 true {}
                        TclObject[] objv341 = TJC.grabObjv(interp, 5);
                        TclObject tmp342;
                        try {
                            // Arg 0 constant: ...
                            objv341[0] = const5;
                            // Arg 1 variable: $key
                            tmp342 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp342.preserve();
                            objv341[1] = tmp342;
                            // Arg 2 constant: 3
                            objv341[2] = const10;
                            // Arg 3 constant: true
                            objv341[3] = const7;
                            // Arg 4 constant: {}
                            objv341[4] = const0;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv341, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            tmp342 = objv341[1];
                            if ( tmp342 != null ) {
                                tmp342.release();
                            }
                            TJC.releaseObjv(interp, objv341, 5);
                        }
                    } // End Invoke: ...
                    tmp340 = interp.getResult();
                    setVarScalar(interp, "tuple", tmp340, compiledLocals, 4);
                } // End Invoke: set
                { // Invoke: set value_type [...]
                    TclObject tmp343;
                    { // Invoke: lindex $tuple 0
                        TclObject tmp344 = getVarScalar(interp, "tuple", compiledLocals, 4);
                        tmp344 = TclList.index(interp, tmp344, 0);
                        if ( tmp344 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp344);
                        }
                    } // End Invoke: lindex
                    tmp343 = interp.getResult();
                    setVarScalar(interp, "value_type", tmp343, compiledLocals, 6);
                } // End Invoke: set
                { // Invoke: set value_symbol [...]
                    TclObject tmp345;
                    { // Invoke: lindex $tuple 1
                        TclObject tmp346 = getVarScalar(interp, "tuple", compiledLocals, 4);
                        tmp346 = TclList.index(interp, tmp346, 1);
                        if ( tmp346 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp346);
                        }
                    } // End Invoke: lindex
                    tmp345 = interp.getResult();
                    setVarScalar(interp, "value_symbol", tmp345, compiledLocals, 7);
                } // End Invoke: set
                { // Invoke: set value_buffer [...]
                    TclObject tmp347;
                    { // Invoke: lindex $tuple 2
                        TclObject tmp348 = getVarScalar(interp, "tuple", compiledLocals, 4);
                        tmp348 = TclList.index(interp, tmp348, 2);
                        if ( tmp348 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp348);
                        }
                    } // End Invoke: lindex
                    tmp347 = interp.getResult();
                    setVarScalar(interp, "value_buffer", tmp347, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: if ... ... else ...
                    // Binary operator: $value_type == "constant"
                    TclObject tmp349 = getVarScalar(interp, "value_type", compiledLocals, 6);
                    boolean tmp350 = tmp349.toString().equals("constant");
                    ExprValue tmp351 = evs0;
                    tmp351.setIntValue(tmp350);
                    // End Binary operator: ==
                    boolean tmp352 = ( tmp351.getIntValue() != 0 );
                    if ( tmp352 ) {
                        { // Invoke: set first_tmpsymbol [...]
                            TclObject tmp353;
                            { // Invoke: ...
                                TclObject[] objv354 = TJC.grabObjv(interp, 1);
                                try {
                                    // Arg 0 constant: ...
                                    objv354[0] = const8;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                        ? cmdcache4.cmd : null), objv354, 0);
                                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                        updateCmdCache(interp, 4);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv354, 1);
                                }
                            } // End Invoke: ...
                            tmp353 = interp.getResult();
                            setVarScalar(interp, "first_tmpsymbol", tmp353, compiledLocals, 25);
                        } // End Invoke: set
                        { // Invoke: append buffer [...]
                            TclObject[] objv355 = TJC.grabObjv(interp, 1);
                            TclObject tmp356;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: emitter_statement "..."
                                    TclObject[] objv357 = TJC.grabObjv(interp, 2);
                                    TclObject tmp358;
                                    try {
                                        // Arg 0 constant: emitter_statement
                                        objv357[0] = const9;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp359 = new StringBuffer(64);
                                        sbtmp359.append("TclObject ");
                                        tmp358 = getVarScalar(interp, "first_tmpsymbol", compiledLocals, 25);
                                        sbtmp359.append(tmp358.toString());
                                        sbtmp359.append(" = ");
                                        tmp358 = getVarScalar(interp, "value_symbol", compiledLocals, 7);
                                        sbtmp359.append(tmp358.toString());
                                        tmp358 = TclString.newInstance(sbtmp359);
                                        tmp358.preserve();
                                        objv357[1] = tmp358;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                            ? cmdcache5.cmd : null), objv357, 0);
                                        if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                            updateCmdCache(interp, 5);
                                        }
                                    } finally {
                                        tmp358 = objv357[1];
                                        if ( tmp358 != null ) {
                                            tmp358.release();
                                        }
                                        TJC.releaseObjv(interp, objv357, 2);
                                    }
                                } // End Invoke: emitter_statement
                                tmp356 = interp.getResult();
                                tmp356.preserve();
                                objv355[0] = tmp356;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv355, compiledLocals, 1);
                            } finally {
                                TJC.releaseObjvElems(interp, objv355, 1);
                            }
                        } // End Invoke: append
                    } else {
                        { // Invoke: set first_tmpsymbol $value_symbol
                            TclObject tmp360;
                            tmp360 = getVarScalar(interp, "value_symbol", compiledLocals, 7);
                            setVarScalar(interp, "first_tmpsymbol", tmp360, compiledLocals, 25);
                        } // End Invoke: set
                        { // Invoke: append buffer $value_buffer
                            TclObject[] objv361 = TJC.grabObjv(interp, 1);
                            TclObject tmp362;
                            try {
                                // Arg 2 variable: $value_buffer
                                tmp362 = getVarScalar(interp, "value_buffer", compiledLocals, 8);
                                tmp362.preserve();
                                objv361[0] = tmp362;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv361, compiledLocals, 1);
                            } finally {
                                TJC.releaseObjvElems(interp, objv361, 1);
                            }
                        } // End Invoke: append
                    }
                } // End Invoke: if
                { // Invoke: append buffer [...]
                    TclObject[] objv363 = TJC.grabObjv(interp, 1);
                    TclObject tmp364;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: ... $first_tmpsymbol
                            TclObject[] objv365 = TJC.grabObjv(interp, 2);
                            TclObject tmp366;
                            try {
                                // Arg 0 constant: ...
                                objv365[0] = const18;
                                // Arg 1 variable: $first_tmpsymbol
                                tmp366 = getVarScalar(interp, "first_tmpsymbol", compiledLocals, 25);
                                tmp366.preserve();
                                objv365[1] = tmp366;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                                    ? cmdcache9.cmd : null), objv365, 0);
                                if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                                    updateCmdCache(interp, 9);
                                }
                            } finally {
                                tmp366 = objv365[1];
                                if ( tmp366 != null ) {
                                    tmp366.release();
                                }
                                TJC.releaseObjv(interp, objv365, 2);
                            }
                        } // End Invoke: ...
                        tmp364 = interp.getResult();
                        tmp364.preserve();
                        objv363[0] = tmp364;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv363, compiledLocals, 1);
                    } finally {
                        TJC.releaseObjvElems(interp, objv363, 1);
                    }
                } // End Invoke: append
                { // Invoke: set tuple [...]
                    TclObject tmp367;
                    { // Invoke: ... $key 4 true {}
                        TclObject[] objv368 = TJC.grabObjv(interp, 5);
                        TclObject tmp369;
                        try {
                            // Arg 0 constant: ...
                            objv368[0] = const5;
                            // Arg 1 variable: $key
                            tmp369 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp369.preserve();
                            objv368[1] = tmp369;
                            // Arg 2 constant: 4
                            objv368[2] = const16;
                            // Arg 3 constant: true
                            objv368[3] = const7;
                            // Arg 4 constant: {}
                            objv368[4] = const0;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv368, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            tmp369 = objv368[1];
                            if ( tmp369 != null ) {
                                tmp369.release();
                            }
                            TJC.releaseObjv(interp, objv368, 5);
                        }
                    } // End Invoke: ...
                    tmp367 = interp.getResult();
                    setVarScalar(interp, "tuple", tmp367, compiledLocals, 4);
                } // End Invoke: set
                { // Invoke: set value_type [...]
                    TclObject tmp370;
                    { // Invoke: lindex $tuple 0
                        TclObject tmp371 = getVarScalar(interp, "tuple", compiledLocals, 4);
                        tmp371 = TclList.index(interp, tmp371, 0);
                        if ( tmp371 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp371);
                        }
                    } // End Invoke: lindex
                    tmp370 = interp.getResult();
                    setVarScalar(interp, "value_type", tmp370, compiledLocals, 6);
                } // End Invoke: set
                { // Invoke: set value_symbol [...]
                    TclObject tmp372;
                    { // Invoke: lindex $tuple 1
                        TclObject tmp373 = getVarScalar(interp, "tuple", compiledLocals, 4);
                        tmp373 = TclList.index(interp, tmp373, 1);
                        if ( tmp373 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp373);
                        }
                    } // End Invoke: lindex
                    tmp372 = interp.getResult();
                    setVarScalar(interp, "value_symbol", tmp372, compiledLocals, 7);
                } // End Invoke: set
                { // Invoke: set value_buffer [...]
                    TclObject tmp374;
                    { // Invoke: lindex $tuple 2
                        TclObject tmp375 = getVarScalar(interp, "tuple", compiledLocals, 4);
                        tmp375 = TclList.index(interp, tmp375, 2);
                        if ( tmp375 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp375);
                        }
                    } // End Invoke: lindex
                    tmp374 = interp.getResult();
                    setVarScalar(interp, "value_buffer", tmp374, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: if ... ... else ...
                    // Binary operator: $value_type == "constant"
                    TclObject tmp376 = getVarScalar(interp, "value_type", compiledLocals, 6);
                    boolean tmp377 = tmp376.toString().equals("constant");
                    ExprValue tmp378 = evs0;
                    tmp378.setIntValue(tmp377);
                    // End Binary operator: ==
                    boolean tmp379 = ( tmp378.getIntValue() != 0 );
                    if ( tmp379 ) {
                        { // Invoke: set last_tmpsymbol [...]
                            TclObject tmp380;
                            { // Invoke: ...
                                TclObject[] objv381 = TJC.grabObjv(interp, 1);
                                try {
                                    // Arg 0 constant: ...
                                    objv381[0] = const8;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                        ? cmdcache4.cmd : null), objv381, 0);
                                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                        updateCmdCache(interp, 4);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv381, 1);
                                }
                            } // End Invoke: ...
                            tmp380 = interp.getResult();
                            setVarScalar(interp, "last_tmpsymbol", tmp380, compiledLocals, 26);
                        } // End Invoke: set
                        { // Invoke: append buffer [...]
                            TclObject[] objv382 = TJC.grabObjv(interp, 1);
                            TclObject tmp383;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: emitter_statement "..."
                                    TclObject[] objv384 = TJC.grabObjv(interp, 2);
                                    TclObject tmp385;
                                    try {
                                        // Arg 0 constant: emitter_statement
                                        objv384[0] = const9;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp386 = new StringBuffer(64);
                                        sbtmp386.append("TclObject ");
                                        tmp385 = getVarScalar(interp, "last_tmpsymbol", compiledLocals, 26);
                                        sbtmp386.append(tmp385.toString());
                                        sbtmp386.append(" = ");
                                        tmp385 = getVarScalar(interp, "value_symbol", compiledLocals, 7);
                                        sbtmp386.append(tmp385.toString());
                                        tmp385 = TclString.newInstance(sbtmp386);
                                        tmp385.preserve();
                                        objv384[1] = tmp385;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                            ? cmdcache5.cmd : null), objv384, 0);
                                        if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                            updateCmdCache(interp, 5);
                                        }
                                    } finally {
                                        tmp385 = objv384[1];
                                        if ( tmp385 != null ) {
                                            tmp385.release();
                                        }
                                        TJC.releaseObjv(interp, objv384, 2);
                                    }
                                } // End Invoke: emitter_statement
                                tmp383 = interp.getResult();
                                tmp383.preserve();
                                objv382[0] = tmp383;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv382, compiledLocals, 1);
                            } finally {
                                TJC.releaseObjvElems(interp, objv382, 1);
                            }
                        } // End Invoke: append
                    } else {
                        { // Invoke: set last_tmpsymbol $value_symbol
                            TclObject tmp387;
                            tmp387 = getVarScalar(interp, "value_symbol", compiledLocals, 7);
                            setVarScalar(interp, "last_tmpsymbol", tmp387, compiledLocals, 26);
                        } // End Invoke: set
                        { // Invoke: append buffer $value_buffer
                            TclObject[] objv388 = TJC.grabObjv(interp, 1);
                            TclObject tmp389;
                            try {
                                // Arg 2 variable: $value_buffer
                                tmp389 = getVarScalar(interp, "value_buffer", compiledLocals, 8);
                                tmp389.preserve();
                                objv388[0] = tmp389;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv388, compiledLocals, 1);
                            } finally {
                                TJC.releaseObjvElems(interp, objv388, 1);
                            }
                        } // End Invoke: append
                    }
                } // End Invoke: if
                { // Invoke: set result_tmpsymbol [...]
                    TclObject tmp390;
                    { // Invoke: ...
                        TclObject[] objv391 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: ...
                            objv391[0] = const8;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                ? cmdcache4.cmd : null), objv391, 0);
                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                updateCmdCache(interp, 4);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv391, 1);
                        }
                    } // End Invoke: ...
                    tmp390 = interp.getResult();
                    setVarScalar(interp, "result_tmpsymbol", tmp390, compiledLocals, 11);
                } // End Invoke: set
                { // Invoke: append buffer [...] [...]
                    TclObject[] objv392 = TJC.grabObjv(interp, 2);
                    TclObject tmp393;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: emitter_statement "..."
                            TclObject[] objv394 = TJC.grabObjv(interp, 2);
                            TclObject tmp395;
                            try {
                                // Arg 0 constant: emitter_statement
                                objv394[0] = const9;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp396 = new StringBuffer(64);
                                sbtmp396.append("TclObject ");
                                tmp395 = getVarScalar(interp, "result_tmpsymbol", compiledLocals, 11);
                                sbtmp396.append(tmp395.toString());
                                sbtmp396.append(" = TJC.stringRange(interp, ");
                                tmp395 = getVarScalar(interp, "string_tmpsymbol", compiledLocals, 21);
                                sbtmp396.append(tmp395.toString());
                                sbtmp396.append(", ");
                                tmp395 = getVarScalar(interp, "first_tmpsymbol", compiledLocals, 25);
                                sbtmp396.append(tmp395.toString());
                                sbtmp396.append(", ");
                                tmp395 = getVarScalar(interp, "last_tmpsymbol", compiledLocals, 26);
                                sbtmp396.append(tmp395.toString());
                                sbtmp396.append(")");
                                tmp395 = TclString.newInstance(sbtmp396);
                                tmp395.preserve();
                                objv394[1] = tmp395;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                    ? cmdcache5.cmd : null), objv394, 0);
                                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                    updateCmdCache(interp, 5);
                                }
                            } finally {
                                tmp395 = objv394[1];
                                if ( tmp395 != null ) {
                                    tmp395.release();
                                }
                                TJC.releaseObjv(interp, objv394, 2);
                            }
                        } // End Invoke: emitter_statement
                        tmp393 = interp.getResult();
                        tmp393.preserve();
                        objv392[0] = tmp393;
                        // Arg 3 command: [...]
                        { // Invoke: emitter_set_result $result_tmpsymbol false
                            TclObject[] objv397 = TJC.grabObjv(interp, 3);
                            TclObject tmp398;
                            try {
                                // Arg 0 constant: emitter_set_result
                                objv397[0] = const11;
                                // Arg 1 variable: $result_tmpsymbol
                                tmp398 = getVarScalar(interp, "result_tmpsymbol", compiledLocals, 11);
                                tmp398.preserve();
                                objv397[1] = tmp398;
                                // Arg 2 constant: false
                                objv397[2] = const12;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                    ? cmdcache6.cmd : null), objv397, 0);
                                if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                    updateCmdCache(interp, 6);
                                }
                            } finally {
                                tmp398 = objv397[1];
                                if ( tmp398 != null ) {
                                    tmp398.release();
                                }
                                TJC.releaseObjv(interp, objv397, 3);
                            }
                        } // End Invoke: emitter_set_result
                        tmp393 = interp.getResult();
                        tmp393.preserve();
                        objv392[1] = tmp393;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv392, compiledLocals, 1);
                    } finally {
                        TJC.releaseObjvElems(interp, objv392, 2);
                    }
                } // End Invoke: append
            } else {
                // Pattern default
                { // Invoke: error "..."
                    TclObject[] objv399 = TJC.grabObjv(interp, 2);
                    TclObject tmp400;
                    try {
                        // Arg 0 constant: error
                        objv399[0] = const13;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp401 = new StringBuffer(64);
                        sbtmp401.append("unsupported subcommand ");
                        tmp400 = getVarScalar(interp, "subcmdname", compiledLocals, 5);
                        sbtmp401.append(tmp400.toString());
                        tmp400 = TclString.newInstance(sbtmp401);
                        tmp400.preserve();
                        objv399[1] = tmp400;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                            ? cmdcache7.cmd : null), objv399, 0);
                        if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                            updateCmdCache(interp, 7);
                        }
                    } finally {
                        tmp400 = objv399[1];
                        if ( tmp400 != null ) {
                            tmp400.release();
                        }
                        TJC.releaseObjv(interp, objv399, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: switch
        { // Invoke: return $buffer
            TclObject tmp402 = getVarScalar(interp, "buffer", compiledLocals, 1);
            interp.resetResult();
            interp.setResult(tmp402);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_emit_inline_command_string");
        } finally {
            TJC.exprReleaseValue(interp, evs2);
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("descend_get_data");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("tree");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("compileproc_get_argument_tuple");
        const3.preserve(); const3.preserve();
        const4 = TclInteger.newInstance(1);
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("compileproc_emit_argument");
        const5.preserve(); const5.preserve();
        const6 = TclInteger.newInstance(2);
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("true");
        TclBoolean.get(interp, const7);
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("compileproc_tmpvar_next");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("emitter_statement");
        const9.preserve(); const9.preserve();
        const10 = TclInteger.newInstance(3);
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("emitter_set_result");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("false");
        TclBoolean.get(interp, const12);
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("error");
        const13.preserve(); const13.preserve();
        const14 = TclInteger.newInstance(0);
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("emitter_backslash_tcl_string");
        const15.preserve(); const15.preserve();
        const16 = TclInteger.newInstance(4);
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("null");
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance("emitter_tclobject_preserve");
        const18.preserve(); const18.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;
    WrappedCommand cmdcache9;
    int cmdcache9_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                cmdcache9 = TJC.INVALID_COMMAND_CACHE;
                cmdcache9_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "descend_get_data";
                break;
            }
            case 2: {
                cmdName = "compileproc_get_argument_tuple";
                break;
            }
            case 3: {
                cmdName = "compileproc_emit_argument";
                break;
            }
            case 4: {
                cmdName = "compileproc_tmpvar_next";
                break;
            }
            case 5: {
                cmdName = "emitter_statement";
                break;
            }
            case 6: {
                cmdName = "emitter_set_result";
                break;
            }
            case 7: {
                cmdName = "error";
                break;
            }
            case 8: {
                cmdName = "emitter_backslash_tcl_string";
                break;
            }
            case 9: {
                cmdName = "emitter_tclobject_preserve";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
            case 9: {
                cmdcache9 = lwcmd;
                cmdcache9_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "buffer",
        "tree",
        "num_args",
        "tuple",
        "subcmdname",
        "value_type",
        "value_symbol",
        "value_buffer",
        "string1_tmpsymbol",
        "string2_tmpsymbol",
        "result_tmpsymbol",
        "substr_is_constant",
        "substr_constant_string",
        "cmap",
        "substr_first",
        "substr_len",
        "first_num_characters",
        "first_end_index",
        "substr_tmpsymbol",
        "jstr",
        "string_tmpsymbol",
        "start_symbol",
        "last_symbol",
        "int_tmpsymbol",
        "first_tmpsymbol",
        "last_tmpsymbol"
    };
} // end class CompileprocEmitInlineCommandStringCmd

