// TJC implementation of procedure compileproc_emit_invoke
package tjc;
import tcl.lang.*;

public class CompileprocEmitInvokeCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 10, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        ExprValue evs2 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: global ...
            TJC.makeGlobalLinkVar(interp, "_compileproc_key_info", "_compileproc_key_info", 1);
        } // End Invoke: global
        { // Invoke: set num_args $...
            TclObject tmp0;
            StringBuffer sbtmp1 = new StringBuffer(64);
            tmp0 = getVarScalar(interp, "key", compiledLocals, 0);
            sbtmp1.append(tmp0.toString());
            sbtmp1.append(",num_args");
            tmp0 = getVarArray(interp, "_compileproc_key_info", sbtmp1.toString(), compiledLocals, 1);
            setVarScalar(interp, "num_args", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set cmdstr ""
            setVarScalar(interp, "cmdstr", const0, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set cmdname "..."
            setVarScalar(interp, "cmdname", const1, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: for {set i 0} {$i < $num_args} {incr i} ...
            { // Invoke: set i 0
                setVarScalar(interp, "i", const2, compiledLocals, 5);
            } // End Invoke: set
            for ( boolean skip7 = true ; true ; ) {
                if ( skip7 ) {
                    skip7 = false;
                } else {
                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: incr i
                        interp.resetResult();
                        incrVarScalar(interp, "i", 1, compiledLocals, 5);
                    } // End Invoke: incr
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else {
                            throw ex;
                        }
                    }
                }

                // Binary operator: $i < $num_args
                TclObject tmp2 = getVarScalar(interp, "i", compiledLocals, 5);
                ExprValue tmp3 = evs0;
                TJC.exprInitValue(interp, tmp3, tmp2);
                TclObject tmp4 = getVarScalar(interp, "num_args", compiledLocals, 2);
                ExprValue tmp5 = evs1;
                TJC.exprInitValue(interp, tmp5, tmp4);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp3, tmp5);
                // End Binary operator: <
                boolean tmp6 = ( tmp3.getIntValue() != 0 );
                if ( ! tmp6 ) { break; }

                try {
                if ( false ) { throw (TclException) null; }
                { // Invoke: set tuple [...]
                    TclObject tmp8;
                    { // Invoke: ... $key $i
                        TclObject[] objv9 = TJC.grabObjv(interp, 3);
                        TclObject tmp10;
                        try {
                            // Arg 0 constant: ...
                            objv9[0] = const3;
                            // Arg 1 variable: $key
                            tmp10 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp10.preserve();
                            objv9[1] = tmp10;
                            // Arg 2 variable: $i
                            tmp10 = getVarScalar(interp, "i", compiledLocals, 5);
                            tmp10.preserve();
                            objv9[2] = tmp10;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv9, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            tmp10 = objv9[1];
                            if ( tmp10 != null ) {
                                tmp10.release();
                            }
                            tmp10 = objv9[2];
                            if ( tmp10 != null ) {
                                tmp10.release();
                            }
                            TJC.releaseObjv(interp, objv9, 3);
                        }
                    } // End Invoke: ...
                    tmp8 = interp.getResult();
                    setVarScalar(interp, "tuple", tmp8, compiledLocals, 6);
                } // End Invoke: set
                { // Invoke: set type [...]
                    TclObject tmp11;
                    { // Invoke: lindex $tuple 0
                        TclObject tmp12 = getVarScalar(interp, "tuple", compiledLocals, 6);
                        tmp12 = TclList.index(interp, tmp12, 0);
                        if ( tmp12 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp12);
                        }
                    } // End Invoke: lindex
                    tmp11 = interp.getResult();
                    setVarScalar(interp, "type", tmp11, compiledLocals, 7);
                } // End Invoke: set
                { // Invoke: set str [...]
                    TclObject tmp13;
                    { // Invoke: lindex $tuple 1
                        TclObject tmp14 = getVarScalar(interp, "tuple", compiledLocals, 6);
                        tmp14 = TclList.index(interp, tmp14, 1);
                        if ( tmp14 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp14);
                        }
                    } // End Invoke: lindex
                    tmp13 = interp.getResult();
                    setVarScalar(interp, "str", tmp13, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: if ... ...
                    // Binary operator: () && ()
                    // Binary operator: $i == 0
                    TclObject tmp15 = getVarScalar(interp, "i", compiledLocals, 5);
                    ExprValue tmp16 = evs0;
                    TJC.exprInitValue(interp, tmp16, tmp15);
                    ExprValue tmp17 = evs1;
                    tmp17.setIntValue(0);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp16, tmp17);
                    // End Binary operator: ==
                    if (tmp16.getBooleanValue(interp)) {
                    // Binary operator: $type == "constant"
                    TclObject tmp18 = getVarScalar(interp, "type", compiledLocals, 7);
                    boolean tmp19 = tmp18.toString().equals("constant");
                    ExprValue tmp20 = evs1;
                    tmp20.setIntValue(tmp19);
                    // End Binary operator: ==
                    tmp16.setIntValue(tmp20.getBooleanValue(interp));
                    } else {
                    tmp16.setIntValue(0);
                    } // End if: ()
                    // End Binary operator: &&
                    boolean tmp21 = ( tmp16.getIntValue() != 0 );
                    if ( tmp21 ) {
                        { // Invoke: set cmdname $str
                            TclObject tmp22;
                            tmp22 = getVarScalar(interp, "str", compiledLocals, 8);
                            setVarScalar(interp, "cmdname", tmp22, compiledLocals, 4);
                        } // End Invoke: set
                    }
                } // End Invoke: if
                { // Invoke: if ... ... else ...
                    // Binary operator: $i < ()
                    TclObject tmp23 = getVarScalar(interp, "i", compiledLocals, 5);
                    ExprValue tmp24 = evs0;
                    TJC.exprInitValue(interp, tmp24, tmp23);
                    // Binary operator: $num_args - 1
                    TclObject tmp25 = getVarScalar(interp, "num_args", compiledLocals, 2);
                    ExprValue tmp26 = evs1;
                    TJC.exprInitValue(interp, tmp26, tmp25);
                    ExprValue tmp27 = evs2;
                    tmp27.setIntValue(1);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MINUS, tmp26, tmp27);
                    // End Binary operator: -
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp24, tmp26);
                    // End Binary operator: <
                    boolean tmp28 = ( tmp24.getIntValue() != 0 );
                    if ( tmp28 ) {
                        { // Invoke: append cmdstr $str " "
                            TclObject[] objv29 = TJC.grabObjv(interp, 2);
                            TclObject tmp30;
                            try {
                                // Arg 2 variable: $str
                                tmp30 = getVarScalar(interp, "str", compiledLocals, 8);
                                tmp30.preserve();
                                objv29[0] = tmp30;
                                // Arg 3 constant: " "
                                objv29[1] = const4;
                                interp.resetResult();
                                appendVarScalar(interp, "cmdstr", objv29, compiledLocals, 3);
                            } finally {
                                tmp30 = objv29[0];
                                if ( tmp30 != null ) {
                                    tmp30.release();
                                }
                                TJC.releaseObjv(interp, objv29, 2);
                            }
                        } // End Invoke: append
                    } else {
                        { // Invoke: append cmdstr $str
                            TclObject[] objv31 = TJC.grabObjv(interp, 1);
                            TclObject tmp32;
                            try {
                                // Arg 2 variable: $str
                                tmp32 = getVarScalar(interp, "str", compiledLocals, 8);
                                tmp32.preserve();
                                objv31[0] = tmp32;
                                interp.resetResult();
                                appendVarScalar(interp, "cmdstr", objv31, compiledLocals, 3);
                            } finally {
                                TJC.releaseObjvElems(interp, objv31, 1);
                            }
                        } // End Invoke: append
                    }
                } // End Invoke: if
                } catch (TclException ex) {
                    int type = ex.getCompletionCode();
                    if (type == TCL.BREAK) {
                        break;
                    } else if (type == TCL.CONTINUE) {
                        continue;
                    } else {
                        throw ex;
                    }
                }
            }
        } // End Invoke: for
        { // Invoke: append buffer [...]
            TclObject[] objv33 = TJC.grabObjv(interp, 1);
            TclObject tmp34;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_invoke_start $cmdstr
                    TclObject[] objv35 = TJC.grabObjv(interp, 2);
                    TclObject tmp36;
                    try {
                        // Arg 0 constant: emitter_invoke_start
                        objv35[0] = const5;
                        // Arg 1 variable: $cmdstr
                        tmp36 = getVarScalar(interp, "cmdstr", compiledLocals, 3);
                        tmp36.preserve();
                        objv35[1] = tmp36;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv35, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp36 = objv35[1];
                        if ( tmp36 != null ) {
                            tmp36.release();
                        }
                        TJC.releaseObjv(interp, objv35, 2);
                    }
                } // End Invoke: emitter_invoke_start
                tmp34 = interp.getResult();
                tmp34.preserve();
                objv33[0] = tmp34;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv33, compiledLocals, 9);
            } finally {
                TJC.releaseObjvElems(interp, objv33, 1);
            }
        } // End Invoke: append
        { // Invoke: if ... ... elseif ... ... elseif ... ... else ...
            // Binary operator: [...] && [...]
            { // Invoke: ... $key
                TclObject[] objv37 = TJC.grabObjv(interp, 2);
                TclObject tmp38;
                try {
                    // Arg 0 constant: ...
                    objv37[0] = const6;
                    // Arg 1 variable: $key
                    tmp38 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp38.preserve();
                    objv37[1] = tmp38;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv37, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp38 = objv37[1];
                    if ( tmp38 != null ) {
                        tmp38.release();
                    }
                    TJC.releaseObjv(interp, objv37, 2);
                }
            } // End Invoke: ...
            TclObject tmp39 = interp.getResult();
            ExprValue tmp40 = evs0;
            TJC.exprInitValue(interp, tmp40, tmp39);
            if (tmp40.getBooleanValue(interp)) {
            { // Invoke: ... $key
                TclObject[] objv41 = TJC.grabObjv(interp, 2);
                TclObject tmp42;
                try {
                    // Arg 0 constant: ...
                    objv41[0] = const7;
                    // Arg 1 variable: $key
                    tmp42 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp42.preserve();
                    objv41[1] = tmp42;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                        ? cmdcache4.cmd : null), objv41, 0);
                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                        updateCmdCache(interp, 4);
                    }
                } finally {
                    tmp42 = objv41[1];
                    if ( tmp42 != null ) {
                        tmp42.release();
                    }
                    TJC.releaseObjv(interp, objv41, 2);
                }
            } // End Invoke: ...
            TclObject tmp43 = interp.getResult();
            ExprValue tmp44 = evs1;
            TJC.exprInitValue(interp, tmp44, tmp43);
            tmp40.setIntValue(tmp44.getBooleanValue(interp));
            } else {
            tmp40.setIntValue(0);
            } // End if: [...]
            // End Binary operator: &&
            boolean tmp45 = ( tmp40.getIntValue() != 0 );
            if ( tmp45 ) {
                { // Invoke: append buffer [...]
                    TclObject[] objv46 = TJC.grabObjv(interp, 1);
                    TclObject tmp47;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: ... $key
                            TclObject[] objv48 = TJC.grabObjv(interp, 2);
                            TclObject tmp49;
                            try {
                                // Arg 0 constant: ...
                                objv48[0] = const8;
                                // Arg 1 variable: $key
                                tmp49 = getVarScalar(interp, "key", compiledLocals, 0);
                                tmp49.preserve();
                                objv48[1] = tmp49;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                    ? cmdcache5.cmd : null), objv48, 0);
                                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                    updateCmdCache(interp, 5);
                                }
                            } finally {
                                tmp49 = objv48[1];
                                if ( tmp49 != null ) {
                                    tmp49.release();
                                }
                                TJC.releaseObjv(interp, objv48, 2);
                            }
                        } // End Invoke: ...
                        tmp47 = interp.getResult();
                        tmp47.preserve();
                        objv46[0] = tmp47;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv46, compiledLocals, 9);
                    } finally {
                        TJC.releaseObjvElems(interp, objv46, 1);
                    }
                } // End Invoke: append
            } else {
                { // Invoke: ... $key
                    TclObject[] objv50 = TJC.grabObjv(interp, 2);
                    TclObject tmp51;
                    try {
                        // Arg 0 constant: ...
                        objv50[0] = const9;
                        // Arg 1 variable: $key
                        tmp51 = getVarScalar(interp, "key", compiledLocals, 0);
                        tmp51.preserve();
                        objv50[1] = tmp51;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                            ? cmdcache6.cmd : null), objv50, 0);
                        if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                            updateCmdCache(interp, 6);
                        }
                    } finally {
                        tmp51 = objv50[1];
                        if ( tmp51 != null ) {
                            tmp51.release();
                        }
                        TJC.releaseObjv(interp, objv50, 2);
                    }
                } // End Invoke: ...
                TclObject tmp52 = interp.getResult();
                ExprValue tmp53 = evs0;
                TJC.exprInitValue(interp, tmp53, tmp52);
                boolean tmp54 = tmp53.getBooleanValue(interp);
                if ( tmp54 ) {
                    { // Invoke: append buffer [...]
                        TclObject[] objv55 = TJC.grabObjv(interp, 1);
                        TclObject tmp56;
                        try {
                            // Arg 2 command: [...]
                            { // Invoke: ... $key
                                TclObject[] objv57 = TJC.grabObjv(interp, 2);
                                TclObject tmp58;
                                try {
                                    // Arg 0 constant: ...
                                    objv57[0] = const10;
                                    // Arg 1 variable: $key
                                    tmp58 = getVarScalar(interp, "key", compiledLocals, 0);
                                    tmp58.preserve();
                                    objv57[1] = tmp58;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                        ? cmdcache7.cmd : null), objv57, 0);
                                    if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                        updateCmdCache(interp, 7);
                                    }
                                } finally {
                                    tmp58 = objv57[1];
                                    if ( tmp58 != null ) {
                                        tmp58.release();
                                    }
                                    TJC.releaseObjv(interp, objv57, 2);
                                }
                            } // End Invoke: ...
                            tmp56 = interp.getResult();
                            tmp56.preserve();
                            objv55[0] = tmp56;
                            interp.resetResult();
                            appendVarScalar(interp, "buffer", objv55, compiledLocals, 9);
                        } finally {
                            TJC.releaseObjvElems(interp, objv55, 1);
                        }
                    } // End Invoke: append
                } else {
                    { // Invoke: ... $key
                        TclObject[] objv59 = TJC.grabObjv(interp, 2);
                        TclObject tmp60;
                        try {
                            // Arg 0 constant: ...
                            objv59[0] = const11;
                            // Arg 1 variable: $key
                            tmp60 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp60.preserve();
                            objv59[1] = tmp60;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                ? cmdcache8.cmd : null), objv59, 0);
                            if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                updateCmdCache(interp, 8);
                            }
                        } finally {
                            tmp60 = objv59[1];
                            if ( tmp60 != null ) {
                                tmp60.release();
                            }
                            TJC.releaseObjv(interp, objv59, 2);
                        }
                    } // End Invoke: ...
                    TclObject tmp61 = interp.getResult();
                    ExprValue tmp62 = evs0;
                    TJC.exprInitValue(interp, tmp62, tmp61);
                    boolean tmp63 = tmp62.getBooleanValue(interp);
                    if ( tmp63 ) {
                        { // Invoke: append buffer [...]
                            TclObject[] objv64 = TJC.grabObjv(interp, 1);
                            TclObject tmp65;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: ... $key
                                    TclObject[] objv66 = TJC.grabObjv(interp, 2);
                                    TclObject tmp67;
                                    try {
                                        // Arg 0 constant: ...
                                        objv66[0] = const12;
                                        // Arg 1 variable: $key
                                        tmp67 = getVarScalar(interp, "key", compiledLocals, 0);
                                        tmp67.preserve();
                                        objv66[1] = tmp67;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                                            ? cmdcache9.cmd : null), objv66, 0);
                                        if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                                            updateCmdCache(interp, 9);
                                        }
                                    } finally {
                                        tmp67 = objv66[1];
                                        if ( tmp67 != null ) {
                                            tmp67.release();
                                        }
                                        TJC.releaseObjv(interp, objv66, 2);
                                    }
                                } // End Invoke: ...
                                tmp65 = interp.getResult();
                                tmp65.preserve();
                                objv64[0] = tmp65;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv64, compiledLocals, 9);
                            } finally {
                                TJC.releaseObjvElems(interp, objv64, 1);
                            }
                        } // End Invoke: append
                    } else {
                        { // Invoke: append buffer [...]
                            TclObject[] objv68 = TJC.grabObjv(interp, 1);
                            TclObject tmp69;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: ... $key
                                    TclObject[] objv70 = TJC.grabObjv(interp, 2);
                                    TclObject tmp71;
                                    try {
                                        // Arg 0 constant: ...
                                        objv70[0] = const13;
                                        // Arg 1 variable: $key
                                        tmp71 = getVarScalar(interp, "key", compiledLocals, 0);
                                        tmp71.preserve();
                                        objv70[1] = tmp71;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                            ? cmdcache10.cmd : null), objv70, 0);
                                        if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                            updateCmdCache(interp, 10);
                                        }
                                    } finally {
                                        tmp71 = objv70[1];
                                        if ( tmp71 != null ) {
                                            tmp71.release();
                                        }
                                        TJC.releaseObjv(interp, objv70, 2);
                                    }
                                } // End Invoke: ...
                                tmp69 = interp.getResult();
                                tmp69.preserve();
                                objv68[0] = tmp69;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv68, compiledLocals, 9);
                            } finally {
                                TJC.releaseObjvElems(interp, objv68, 1);
                            }
                        } // End Invoke: append
                    }
                }
            }
        } // End Invoke: if
        { // Invoke: append buffer [...]
            TclObject[] objv72 = TJC.grabObjv(interp, 1);
            TclObject tmp73;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_invoke_end $cmdname
                    TclObject[] objv74 = TJC.grabObjv(interp, 2);
                    TclObject tmp75;
                    try {
                        // Arg 0 constant: emitter_invoke_end
                        objv74[0] = const14;
                        // Arg 1 variable: $cmdname
                        tmp75 = getVarScalar(interp, "cmdname", compiledLocals, 4);
                        tmp75.preserve();
                        objv74[1] = tmp75;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache11_cmdEpoch == cmdcache11.cmdEpoch)
                            ? cmdcache11.cmd : null), objv74, 0);
                        if ( cmdcache11_cmdEpoch != cmdcache11.cmdEpoch ) {
                            updateCmdCache(interp, 11);
                        }
                    } finally {
                        tmp75 = objv74[1];
                        if ( tmp75 != null ) {
                            tmp75.release();
                        }
                        TJC.releaseObjv(interp, objv74, 2);
                    }
                } // End Invoke: emitter_invoke_end
                tmp73 = interp.getResult();
                tmp73.preserve();
                objv72[0] = tmp73;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv72, compiledLocals, 9);
            } finally {
                TJC.releaseObjvElems(interp, objv72, 1);
            }
        } // End Invoke: append
        { // Invoke: return $buffer
            TclObject tmp76 = getVarScalar(interp, "buffer", compiledLocals, 9);
            interp.resetResult();
            interp.setResult(tmp76);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_emit_invoke");
        } finally {
            TJC.exprReleaseValue(interp, evs2);
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("...");
        const1.preserve(); const1.preserve();
        const2 = TclInteger.newInstance(0);
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("compileproc_argument_printable");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance(" ");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("emitter_invoke_start");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("compileproc_is_container_command");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("compileproc_can_inline_container");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("compileproc_emit_container");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("compileproc_can_inline_control");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("compileproc_emit_control");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("compileproc_can_inline_command");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("compileproc_emit_inline_command");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("compileproc_emit_invoke_call");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("emitter_invoke_end");
        const14.preserve(); const14.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;
    WrappedCommand cmdcache9;
    int cmdcache9_cmdEpoch;
    WrappedCommand cmdcache10;
    int cmdcache10_cmdEpoch;
    WrappedCommand cmdcache11;
    int cmdcache11_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                cmdcache9 = TJC.INVALID_COMMAND_CACHE;
                cmdcache9_cmdEpoch = 0;
                cmdcache10 = TJC.INVALID_COMMAND_CACHE;
                cmdcache10_cmdEpoch = 0;
                cmdcache11 = TJC.INVALID_COMMAND_CACHE;
                cmdcache11_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "compileproc_argument_printable";
                break;
            }
            case 2: {
                cmdName = "emitter_invoke_start";
                break;
            }
            case 3: {
                cmdName = "compileproc_is_container_command";
                break;
            }
            case 4: {
                cmdName = "compileproc_can_inline_container";
                break;
            }
            case 5: {
                cmdName = "compileproc_emit_container";
                break;
            }
            case 6: {
                cmdName = "compileproc_can_inline_control";
                break;
            }
            case 7: {
                cmdName = "compileproc_emit_control";
                break;
            }
            case 8: {
                cmdName = "compileproc_can_inline_command";
                break;
            }
            case 9: {
                cmdName = "compileproc_emit_inline_command";
                break;
            }
            case 10: {
                cmdName = "compileproc_emit_invoke_call";
                break;
            }
            case 11: {
                cmdName = "emitter_invoke_end";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
            case 9: {
                cmdcache9 = lwcmd;
                cmdcache9_cmdEpoch = cmdEpoch;
                break;
            }
            case 10: {
                cmdcache10 = lwcmd;
                cmdcache10_cmdEpoch = cmdEpoch;
                break;
            }
            case 11: {
                cmdcache11 = lwcmd;
                cmdcache11_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "_compileproc_key_info",
        "num_args",
        "cmdstr",
        "cmdname",
        "i",
        "tuple",
        "type",
        "str",
        "buffer"
    };
} // end class CompileprocEmitInvokeCmd

