// TJC implementation of procedure compileproc_emit_word
package tjc;
import tcl.lang.*;

public class CompileprocEmitWordCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 9, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length < 3 || objv.length > 5) {
            throw new TclNumArgsException(interp, 1, objv, "tmpsymbol winfo ?declare_flag? ?string_symbol?");
        }
        setVarScalar(interp, "tmpsymbol", objv[1], compiledLocals, 0);
        setVarScalar(interp, "winfo", objv[2], compiledLocals, 1);
        setVarScalar(interp, "declare_flag", 
            ((objv.length <= 3) ? const0 : objv[3]), compiledLocals, 2);
        setVarScalar(interp, "string_symbol", 
            ((objv.length <= 4) ? const1 : objv[4]), compiledLocals, 3);
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const1, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: if {$declare_flag} ... else ...
            TclObject tmp0 = getVarScalar(interp, "declare_flag", compiledLocals, 2);
            boolean tmp1 = TJC.getBoolean(interp, tmp0);
            if ( tmp1 ) {
                { // Invoke: set declare "TclObject "
                    setVarScalar(interp, "declare", const2, compiledLocals, 5);
                } // End Invoke: set
            } else {
                { // Invoke: set declare ""
                    setVarScalar(interp, "declare", const1, compiledLocals, 5);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: set len [...]
            TclObject tmp2;
            { // Invoke: llength $winfo
                TclObject tmp3 = getVarScalar(interp, "winfo", compiledLocals, 1);
                int tmp4 = TclList.getLength(interp, tmp3);
                interp.setResult(tmp4);
            } // End Invoke: llength
            tmp2 = interp.getResult();
            setVarScalar(interp, "len", tmp2, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: if {$len == 0} ... elseif {$len == 1} ... else ...
            // Binary operator: $len == 0
            TclObject tmp5 = getVarScalar(interp, "len", compiledLocals, 6);
            ExprValue tmp6 = evs0;
            TJC.exprInitValue(interp, tmp6, tmp5);
            ExprValue tmp7 = evs1;
            tmp7.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp6, tmp7);
            // End Binary operator: ==
            boolean tmp8 = ( tmp6.getIntValue() != 0 );
            if ( tmp8 ) {
                { // Invoke: error "empty winfo"
                    TclObject[] objv9 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: error
                        objv9[0] = const3;
                        // Arg 1 constant: "empty winfo"
                        objv9[1] = const4;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv9, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv9, 2);
                    }
                } // End Invoke: error
            } else {
                // Binary operator: $len == 1
                TclObject tmp10 = getVarScalar(interp, "len", compiledLocals, 6);
                ExprValue tmp11 = evs0;
                TJC.exprInitValue(interp, tmp11, tmp10);
                ExprValue tmp12 = evs1;
                tmp12.setIntValue(1);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp11, tmp12);
                // End Binary operator: ==
                boolean tmp13 = ( tmp11.getIntValue() != 0 );
                if ( tmp13 ) {
                    { // Invoke: set wi [...]
                        TclObject tmp14;
                        { // Invoke: lindex $winfo 0
                            TclObject tmp15 = getVarScalar(interp, "winfo", compiledLocals, 1);
                            tmp15 = TclList.index(interp, tmp15, 0);
                            if ( tmp15 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp15);
                            }
                        } // End Invoke: lindex
                        tmp14 = interp.getResult();
                        setVarScalar(interp, "wi", tmp14, compiledLocals, 7);
                    } // End Invoke: set
                    { // Invoke: append buffer [...]
                        TclObject[] objv16 = TJC.grabObjv(interp, 1);
                        TclObject tmp17;
                        try {
                            // Arg 2 command: [...]
                            { // Invoke: ... $wi $tmpsymbol false {} $declare_flag
                                TclObject[] objv18 = TJC.grabObjv(interp, 6);
                                TclObject tmp19;
                                try {
                                    // Arg 0 constant: ...
                                    objv18[0] = const5;
                                    // Arg 1 variable: $wi
                                    tmp19 = getVarScalar(interp, "wi", compiledLocals, 7);
                                    tmp19.preserve();
                                    objv18[1] = tmp19;
                                    // Arg 2 variable: $tmpsymbol
                                    tmp19 = getVarScalar(interp, "tmpsymbol", compiledLocals, 0);
                                    tmp19.preserve();
                                    objv18[2] = tmp19;
                                    // Arg 3 constant: false
                                    objv18[3] = const6;
                                    // Arg 4 constant: {}
                                    objv18[4] = const1;
                                    // Arg 5 variable: $declare_flag
                                    tmp19 = getVarScalar(interp, "declare_flag", compiledLocals, 2);
                                    tmp19.preserve();
                                    objv18[5] = tmp19;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                        ? cmdcache2.cmd : null), objv18, 0);
                                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                        updateCmdCache(interp, 2);
                                    }
                                } finally {
                                    tmp19 = objv18[1];
                                    if ( tmp19 != null ) {
                                        tmp19.release();
                                    }
                                    tmp19 = objv18[2];
                                    if ( tmp19 != null ) {
                                        tmp19.release();
                                    }
                                    tmp19 = objv18[5];
                                    if ( tmp19 != null ) {
                                        tmp19.release();
                                    }
                                    TJC.releaseObjv(interp, objv18, 6);
                                }
                            } // End Invoke: ...
                            tmp17 = interp.getResult();
                            tmp17.preserve();
                            objv16[0] = tmp17;
                            interp.resetResult();
                            appendVarScalar(interp, "buffer", objv16, compiledLocals, 4);
                        } finally {
                            TJC.releaseObjvElems(interp, objv16, 1);
                        }
                    } // End Invoke: append
                    { // Invoke: if ... ...
                        // Binary operator: $string_symbol != ""
                        TclObject tmp20 = getVarScalar(interp, "string_symbol", compiledLocals, 3);
                        ExprValue tmp21 = evs0;
                        TJC.exprEqualsEmptyString(tmp21, tmp20, true);
                        // End Binary operator: !=
                        boolean tmp22 = ( tmp21.getIntValue() != 0 );
                        if ( tmp22 ) {
                            { // Invoke: append buffer [...] "String " $string_symbol " = " $tmpsymbol ...
                                TclObject[] objv23 = TJC.grabObjv(interp, 6);
                                TclObject tmp24;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: emitter_indent
                                        TclObject[] objv25 = TJC.grabObjv(interp, 1);
                                        try {
                                            // Arg 0 constant: emitter_indent
                                            objv25[0] = const7;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                                ? cmdcache3.cmd : null), objv25, 0);
                                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                                updateCmdCache(interp, 3);
                                            }
                                        } finally {
                                            TJC.releaseObjv(interp, objv25, 1);
                                        }
                                    } // End Invoke: emitter_indent
                                    tmp24 = interp.getResult();
                                    tmp24.preserve();
                                    objv23[0] = tmp24;
                                    // Arg 3 constant: "String "
                                    objv23[1] = const8;
                                    // Arg 4 variable: $string_symbol
                                    tmp24 = getVarScalar(interp, "string_symbol", compiledLocals, 3);
                                    tmp24.preserve();
                                    objv23[2] = tmp24;
                                    // Arg 5 constant: " = "
                                    objv23[3] = const9;
                                    // Arg 6 variable: $tmpsymbol
                                    tmp24 = getVarScalar(interp, "tmpsymbol", compiledLocals, 0);
                                    tmp24.preserve();
                                    objv23[4] = tmp24;
                                    // Arg 7 constant: ...
                                    objv23[5] = const10;
                                    interp.resetResult();
                                    appendVarScalar(interp, "buffer", objv23, compiledLocals, 4);
                                } finally {
                                    tmp24 = objv23[0];
                                    if ( tmp24 != null ) {
                                        tmp24.release();
                                    }
                                    tmp24 = objv23[2];
                                    if ( tmp24 != null ) {
                                        tmp24.release();
                                    }
                                    tmp24 = objv23[4];
                                    if ( tmp24 != null ) {
                                        tmp24.release();
                                    }
                                    TJC.releaseObjv(interp, objv23, 6);
                                }
                            } // End Invoke: append
                        }
                    } // End Invoke: if
                } else {
                    { // Invoke: set sbtmp [...]
                        TclObject tmp26;
                        { // Invoke: ... sbtmp
                            TclObject[] objv27 = TJC.grabObjv(interp, 2);
                            try {
                                // Arg 0 constant: ...
                                objv27[0] = const11;
                                // Arg 1 constant: sbtmp
                                objv27[1] = const12;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                    ? cmdcache4.cmd : null), objv27, 0);
                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                    updateCmdCache(interp, 4);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv27, 2);
                            }
                        } // End Invoke: ...
                        tmp26 = interp.getResult();
                        setVarScalar(interp, "sbtmp", tmp26, compiledLocals, 8);
                    } // End Invoke: set
                    { // Invoke: if {$declare_flag} ...
                        TclObject tmp28 = getVarScalar(interp, "declare_flag", compiledLocals, 2);
                        boolean tmp29 = TJC.getBoolean(interp, tmp28);
                        if ( tmp29 ) {
                            { // Invoke: append buffer [...] $declare $tmpsymbol ...
                                TclObject[] objv30 = TJC.grabObjv(interp, 4);
                                TclObject tmp31;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: emitter_indent
                                        TclObject[] objv32 = TJC.grabObjv(interp, 1);
                                        try {
                                            // Arg 0 constant: emitter_indent
                                            objv32[0] = const7;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                                ? cmdcache3.cmd : null), objv32, 0);
                                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                                updateCmdCache(interp, 3);
                                            }
                                        } finally {
                                            TJC.releaseObjv(interp, objv32, 1);
                                        }
                                    } // End Invoke: emitter_indent
                                    tmp31 = interp.getResult();
                                    tmp31.preserve();
                                    objv30[0] = tmp31;
                                    // Arg 3 variable: $declare
                                    tmp31 = getVarScalar(interp, "declare", compiledLocals, 5);
                                    tmp31.preserve();
                                    objv30[1] = tmp31;
                                    // Arg 4 variable: $tmpsymbol
                                    tmp31 = getVarScalar(interp, "tmpsymbol", compiledLocals, 0);
                                    tmp31.preserve();
                                    objv30[2] = tmp31;
                                    // Arg 5 constant: ...
                                    objv30[3] = const13;
                                    interp.resetResult();
                                    appendVarScalar(interp, "buffer", objv30, compiledLocals, 4);
                                } finally {
                                    tmp31 = objv30[0];
                                    if ( tmp31 != null ) {
                                        tmp31.release();
                                    }
                                    tmp31 = objv30[1];
                                    if ( tmp31 != null ) {
                                        tmp31.release();
                                    }
                                    tmp31 = objv30[2];
                                    if ( tmp31 != null ) {
                                        tmp31.release();
                                    }
                                    TJC.releaseObjv(interp, objv30, 4);
                                }
                            } // End Invoke: append
                        }
                    } // End Invoke: if
                    { // Invoke: if ... ...
                        // Binary operator: $string_symbol != ""
                        TclObject tmp33 = getVarScalar(interp, "string_symbol", compiledLocals, 3);
                        ExprValue tmp34 = evs0;
                        TJC.exprEqualsEmptyString(tmp34, tmp33, true);
                        // End Binary operator: !=
                        boolean tmp35 = ( tmp34.getIntValue() != 0 );
                        if ( tmp35 ) {
                            { // Invoke: append buffer [...] "String " $string_symbol ...
                                TclObject[] objv36 = TJC.grabObjv(interp, 4);
                                TclObject tmp37;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: emitter_indent
                                        TclObject[] objv38 = TJC.grabObjv(interp, 1);
                                        try {
                                            // Arg 0 constant: emitter_indent
                                            objv38[0] = const7;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                                ? cmdcache3.cmd : null), objv38, 0);
                                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                                updateCmdCache(interp, 3);
                                            }
                                        } finally {
                                            TJC.releaseObjv(interp, objv38, 1);
                                        }
                                    } // End Invoke: emitter_indent
                                    tmp37 = interp.getResult();
                                    tmp37.preserve();
                                    objv36[0] = tmp37;
                                    // Arg 3 constant: "String "
                                    objv36[1] = const8;
                                    // Arg 4 variable: $string_symbol
                                    tmp37 = getVarScalar(interp, "string_symbol", compiledLocals, 3);
                                    tmp37.preserve();
                                    objv36[2] = tmp37;
                                    // Arg 5 constant: ...
                                    objv36[3] = const13;
                                    interp.resetResult();
                                    appendVarScalar(interp, "buffer", objv36, compiledLocals, 4);
                                } finally {
                                    tmp37 = objv36[0];
                                    if ( tmp37 != null ) {
                                        tmp37.release();
                                    }
                                    tmp37 = objv36[2];
                                    if ( tmp37 != null ) {
                                        tmp37.release();
                                    }
                                    TJC.releaseObjv(interp, objv36, 4);
                                }
                            } // End Invoke: append
                        }
                    } // End Invoke: if
                    { // Invoke: append buffer [...] "StringBuffer " $sbtmp ...
                        TclObject[] objv39 = TJC.grabObjv(interp, 4);
                        TclObject tmp40;
                        try {
                            // Arg 2 command: [...]
                            { // Invoke: emitter_indent
                                TclObject[] objv41 = TJC.grabObjv(interp, 1);
                                try {
                                    // Arg 0 constant: emitter_indent
                                    objv41[0] = const7;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                        ? cmdcache3.cmd : null), objv41, 0);
                                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                        updateCmdCache(interp, 3);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv41, 1);
                                }
                            } // End Invoke: emitter_indent
                            tmp40 = interp.getResult();
                            tmp40.preserve();
                            objv39[0] = tmp40;
                            // Arg 3 constant: "StringBuffer "
                            objv39[1] = const14;
                            // Arg 4 variable: $sbtmp
                            tmp40 = getVarScalar(interp, "sbtmp", compiledLocals, 8);
                            tmp40.preserve();
                            objv39[2] = tmp40;
                            // Arg 5 constant: ...
                            objv39[3] = const15;
                            interp.resetResult();
                            appendVarScalar(interp, "buffer", objv39, compiledLocals, 4);
                        } finally {
                            tmp40 = objv39[0];
                            if ( tmp40 != null ) {
                                tmp40.release();
                            }
                            tmp40 = objv39[2];
                            if ( tmp40 != null ) {
                                tmp40.release();
                            }
                            TJC.releaseObjv(interp, objv39, 4);
                        }
                    } // End Invoke: append
                    { // Invoke: foreach wi $winfo ...
                        TclObject tmp42 = null;
                        try {
                            tmp42 = getVarScalar(interp, "winfo", compiledLocals, 1);
                            tmp42.preserve();
                            final int tmp42_length = TclList.getLength(interp, tmp42);

                            for ( int index43 = 0 ; index43 < tmp42_length ; index43++ ) {
                                TclObject tmp44 = TclList.index(interp, tmp42, index43);
                                try {
                                    setVarScalar(interp, "wi", tmp44, compiledLocals, 7);
                                } catch (TclException ex) {
                                    TJC.foreachVarErr(interp, "wi");
                                }

                                try {
                                if ( false ) { throw (TclException) null; }
                                { // Invoke: append buffer [...]
                                    TclObject[] objv45 = TJC.grabObjv(interp, 1);
                                    TclObject tmp46;
                                    try {
                                        // Arg 2 command: [...]
                                        { // Invoke: ... $wi $tmpsymbol true $sbtmp $declare_flag
                                            TclObject[] objv47 = TJC.grabObjv(interp, 6);
                                            TclObject tmp48;
                                            try {
                                                // Arg 0 constant: ...
                                                objv47[0] = const5;
                                                // Arg 1 variable: $wi
                                                tmp48 = getVarScalar(interp, "wi", compiledLocals, 7);
                                                tmp48.preserve();
                                                objv47[1] = tmp48;
                                                // Arg 2 variable: $tmpsymbol
                                                tmp48 = getVarScalar(interp, "tmpsymbol", compiledLocals, 0);
                                                tmp48.preserve();
                                                objv47[2] = tmp48;
                                                // Arg 3 constant: true
                                                objv47[3] = const0;
                                                // Arg 4 variable: $sbtmp
                                                tmp48 = getVarScalar(interp, "sbtmp", compiledLocals, 8);
                                                tmp48.preserve();
                                                objv47[4] = tmp48;
                                                // Arg 5 variable: $declare_flag
                                                tmp48 = getVarScalar(interp, "declare_flag", compiledLocals, 2);
                                                tmp48.preserve();
                                                objv47[5] = tmp48;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                                    ? cmdcache2.cmd : null), objv47, 0);
                                                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                                    updateCmdCache(interp, 2);
                                                }
                                            } finally {
                                                tmp48 = objv47[1];
                                                if ( tmp48 != null ) {
                                                    tmp48.release();
                                                }
                                                tmp48 = objv47[2];
                                                if ( tmp48 != null ) {
                                                    tmp48.release();
                                                }
                                                tmp48 = objv47[4];
                                                if ( tmp48 != null ) {
                                                    tmp48.release();
                                                }
                                                tmp48 = objv47[5];
                                                if ( tmp48 != null ) {
                                                    tmp48.release();
                                                }
                                                TJC.releaseObjv(interp, objv47, 6);
                                            }
                                        } // End Invoke: ...
                                        tmp46 = interp.getResult();
                                        tmp46.preserve();
                                        objv45[0] = tmp46;
                                        interp.resetResult();
                                        appendVarScalar(interp, "buffer", objv45, compiledLocals, 4);
                                    } finally {
                                        TJC.releaseObjvElems(interp, objv45, 1);
                                    }
                                } // End Invoke: append
                                } catch (TclException ex) {
                                    int type = ex.getCompletionCode();
                                    if (type == TCL.BREAK) {
                                        break;
                                    } else if (type == TCL.CONTINUE) {
                                        continue;
                                    } else {
                                        throw ex;
                                    }
                                }
                            }
                        } finally {
                            if ( tmp42 != null ) {
                                tmp42.release();
                            }
                        }
                    } // End Invoke: foreach
                    { // Invoke: if ... ... else ...
                        // Binary operator: $string_symbol != ""
                        TclObject tmp49 = getVarScalar(interp, "string_symbol", compiledLocals, 3);
                        ExprValue tmp50 = evs0;
                        TJC.exprEqualsEmptyString(tmp50, tmp49, true);
                        // End Binary operator: !=
                        boolean tmp51 = ( tmp50.getIntValue() != 0 );
                        if ( tmp51 ) {
                            { // Invoke: append buffer [...] $string_symbol " = " $sbtmp ...
                                TclObject[] objv52 = TJC.grabObjv(interp, 5);
                                TclObject tmp53;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: emitter_indent
                                        TclObject[] objv54 = TJC.grabObjv(interp, 1);
                                        try {
                                            // Arg 0 constant: emitter_indent
                                            objv54[0] = const7;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                                ? cmdcache3.cmd : null), objv54, 0);
                                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                                updateCmdCache(interp, 3);
                                            }
                                        } finally {
                                            TJC.releaseObjv(interp, objv54, 1);
                                        }
                                    } // End Invoke: emitter_indent
                                    tmp53 = interp.getResult();
                                    tmp53.preserve();
                                    objv52[0] = tmp53;
                                    // Arg 3 variable: $string_symbol
                                    tmp53 = getVarScalar(interp, "string_symbol", compiledLocals, 3);
                                    tmp53.preserve();
                                    objv52[1] = tmp53;
                                    // Arg 4 constant: " = "
                                    objv52[2] = const9;
                                    // Arg 5 variable: $sbtmp
                                    tmp53 = getVarScalar(interp, "sbtmp", compiledLocals, 8);
                                    tmp53.preserve();
                                    objv52[3] = tmp53;
                                    // Arg 6 constant: ...
                                    objv52[4] = const10;
                                    interp.resetResult();
                                    appendVarScalar(interp, "buffer", objv52, compiledLocals, 4);
                                } finally {
                                    tmp53 = objv52[0];
                                    if ( tmp53 != null ) {
                                        tmp53.release();
                                    }
                                    tmp53 = objv52[1];
                                    if ( tmp53 != null ) {
                                        tmp53.release();
                                    }
                                    tmp53 = objv52[3];
                                    if ( tmp53 != null ) {
                                        tmp53.release();
                                    }
                                    TJC.releaseObjv(interp, objv52, 5);
                                }
                            } // End Invoke: append
                        } else {
                            { // Invoke: append buffer [...] $tmpsymbol ... $sbtmp ...
                                TclObject[] objv55 = TJC.grabObjv(interp, 5);
                                TclObject tmp56;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: emitter_indent
                                        TclObject[] objv57 = TJC.grabObjv(interp, 1);
                                        try {
                                            // Arg 0 constant: emitter_indent
                                            objv57[0] = const7;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                                ? cmdcache3.cmd : null), objv57, 0);
                                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                                updateCmdCache(interp, 3);
                                            }
                                        } finally {
                                            TJC.releaseObjv(interp, objv57, 1);
                                        }
                                    } // End Invoke: emitter_indent
                                    tmp56 = interp.getResult();
                                    tmp56.preserve();
                                    objv55[0] = tmp56;
                                    // Arg 3 variable: $tmpsymbol
                                    tmp56 = getVarScalar(interp, "tmpsymbol", compiledLocals, 0);
                                    tmp56.preserve();
                                    objv55[1] = tmp56;
                                    // Arg 4 constant: ...
                                    objv55[2] = const16;
                                    // Arg 5 variable: $sbtmp
                                    tmp56 = getVarScalar(interp, "sbtmp", compiledLocals, 8);
                                    tmp56.preserve();
                                    objv55[3] = tmp56;
                                    // Arg 6 constant: ...
                                    objv55[4] = const17;
                                    interp.resetResult();
                                    appendVarScalar(interp, "buffer", objv55, compiledLocals, 4);
                                } finally {
                                    tmp56 = objv55[0];
                                    if ( tmp56 != null ) {
                                        tmp56.release();
                                    }
                                    tmp56 = objv55[1];
                                    if ( tmp56 != null ) {
                                        tmp56.release();
                                    }
                                    tmp56 = objv55[3];
                                    if ( tmp56 != null ) {
                                        tmp56.release();
                                    }
                                    TJC.releaseObjv(interp, objv55, 5);
                                }
                            } // End Invoke: append
                        }
                    } // End Invoke: if
                }
            }
        } // End Invoke: if
        { // Invoke: return $buffer
            TclObject tmp58 = getVarScalar(interp, "buffer", compiledLocals, 4);
            interp.resetResult();
            interp.setResult(tmp58);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_emit_word");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("true");
        TclBoolean.get(interp, const0);
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("TclObject ");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("error");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("empty winfo");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("compileproc_emit_word_element");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("false");
        TclBoolean.get(interp, const6);
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("emitter_indent");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("String ");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance(" = ");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance(".toString();\n");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("compileproc_tmpvar_next");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("sbtmp");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance(";\n");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("StringBuffer ");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance(" = new StringBuffer(64);\n");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance(" = TclString.newInstance(");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance(");\n");
        const17.preserve(); const17.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "error";
                break;
            }
            case 2: {
                cmdName = "compileproc_emit_word_element";
                break;
            }
            case 3: {
                cmdName = "emitter_indent";
                break;
            }
            case 4: {
                cmdName = "compileproc_tmpvar_next";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "tmpsymbol",
        "winfo",
        "declare_flag",
        "string_symbol",
        "buffer",
        "declare",
        "len",
        "wi",
        "sbtmp"
    };
} // end class CompileprocEmitWordCmd

