// TJC implementation of procedure compileproc_emit_word_element
package tjc;
import tcl.lang.*;

public class CompileprocEmitWordElementCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 14, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length < 5 || objv.length > 6) {
            throw new TclNumArgsException(interp, 1, objv, "winfo_element tmpsymbol append sbtmp ?declare_flag?");
        }
        setVarScalar(interp, "winfo_element", objv[1], compiledLocals, 0);
        setVarScalar(interp, "tmpsymbol", objv[2], compiledLocals, 1);
        setVarScalar(interp, "append", objv[3], compiledLocals, 2);
        setVarScalar(interp, "sbtmp", objv[4], compiledLocals, 3);
        setVarScalar(interp, "declare_flag", 
            ((objv.length <= 5) ? const0 : objv[5]), compiledLocals, 4);
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const1, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: if {$declare_flag} ... else ...
            TclObject tmp0 = getVarScalar(interp, "declare_flag", compiledLocals, 4);
            boolean tmp1 = TJC.getBoolean(interp, tmp0);
            if ( tmp1 ) {
                { // Invoke: set declare "TclObject "
                    setVarScalar(interp, "declare", const2, compiledLocals, 6);
                } // End Invoke: set
            } else {
                { // Invoke: set declare ""
                    setVarScalar(interp, "declare", const1, compiledLocals, 6);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: set type [...]
            TclObject tmp2;
            { // Invoke: lindex $winfo_element 0
                TclObject tmp3 = getVarScalar(interp, "winfo_element", compiledLocals, 0);
                tmp3 = TclList.index(interp, tmp3, 0);
                if ( tmp3 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp3);
                }
            } // End Invoke: lindex
            tmp2 = interp.getResult();
            setVarScalar(interp, "type", tmp2, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: if {$type == "text"} ... elseif ... ... elseif {$type == "command"} ... else ...
            // Binary operator: $type == "text"
            TclObject tmp4 = getVarScalar(interp, "type", compiledLocals, 7);
            boolean tmp5 = tmp4.toString().equals("text");
            ExprValue tmp6 = evs0;
            tmp6.setIntValue(tmp5);
            // End Binary operator: ==
            boolean tmp7 = ( tmp6.getIntValue() != 0 );
            if ( tmp7 ) {
                { // Invoke: set str [...]
                    TclObject tmp8;
                    { // Invoke: ... [...]
                        TclObject[] objv9 = TJC.grabObjv(interp, 2);
                        TclObject tmp10;
                        try {
                            // Arg 0 constant: ...
                            objv9[0] = const3;
                            // Arg 1 command: [...]
                            { // Invoke: lindex $winfo_element 1
                                TclObject tmp11 = getVarScalar(interp, "winfo_element", compiledLocals, 0);
                                tmp11 = TclList.index(interp, tmp11, 1);
                                if ( tmp11 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp11);
                                }
                            } // End Invoke: lindex
                            tmp10 = interp.getResult();
                            tmp10.preserve();
                            objv9[1] = tmp10;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv9, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            tmp10 = objv9[1];
                            if ( tmp10 != null ) {
                                tmp10.release();
                            }
                            TJC.releaseObjv(interp, objv9, 2);
                        }
                    } // End Invoke: ...
                    tmp8 = interp.getResult();
                    setVarScalar(interp, "str", tmp8, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: if {$append} ... else ...
                    TclObject tmp12 = getVarScalar(interp, "append", compiledLocals, 2);
                    boolean tmp13 = TJC.getBoolean(interp, tmp12);
                    if ( tmp13 ) {
                        { // Invoke: append buffer [...] $sbtmp ... $str ...
                            TclObject[] objv14 = TJC.grabObjv(interp, 5);
                            TclObject tmp15;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: emitter_indent
                                    TclObject[] objv16 = TJC.grabObjv(interp, 1);
                                    try {
                                        // Arg 0 constant: emitter_indent
                                        objv16[0] = const4;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                            ? cmdcache2.cmd : null), objv16, 0);
                                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                            updateCmdCache(interp, 2);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv16, 1);
                                    }
                                } // End Invoke: emitter_indent
                                tmp15 = interp.getResult();
                                tmp15.preserve();
                                objv14[0] = tmp15;
                                // Arg 3 variable: $sbtmp
                                tmp15 = getVarScalar(interp, "sbtmp", compiledLocals, 3);
                                tmp15.preserve();
                                objv14[1] = tmp15;
                                // Arg 4 constant: ...
                                objv14[2] = const5;
                                // Arg 5 variable: $str
                                tmp15 = getVarScalar(interp, "str", compiledLocals, 8);
                                tmp15.preserve();
                                objv14[3] = tmp15;
                                // Arg 6 constant: ...
                                objv14[4] = const6;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv14, compiledLocals, 5);
                            } finally {
                                tmp15 = objv14[0];
                                if ( tmp15 != null ) {
                                    tmp15.release();
                                }
                                tmp15 = objv14[1];
                                if ( tmp15 != null ) {
                                    tmp15.release();
                                }
                                tmp15 = objv14[3];
                                if ( tmp15 != null ) {
                                    tmp15.release();
                                }
                                TJC.releaseObjv(interp, objv14, 5);
                            }
                        } // End Invoke: append
                    } else {
                        { // Invoke: error ...
                            TclObject[] objv17 = TJC.grabObjv(interp, 2);
                            try {
                                // Arg 0 constant: error
                                objv17[0] = const7;
                                // Arg 1 constant: ...
                                objv17[1] = const8;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                    ? cmdcache3.cmd : null), objv17, 0);
                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                    updateCmdCache(interp, 3);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv17, 2);
                            }
                        } // End Invoke: error
                    }
                } // End Invoke: if
            } else {
                // Binary operator: $type == "variable"
                TclObject tmp18 = getVarScalar(interp, "type", compiledLocals, 7);
                boolean tmp19 = tmp18.toString().equals("variable");
                ExprValue tmp20 = evs0;
                tmp20.setIntValue(tmp19);
                // End Binary operator: ==
                boolean tmp21 = ( tmp20.getIntValue() != 0 );
                if ( tmp21 ) {
                    { // Invoke: set vinfo [...]
                        TclObject tmp22;
                        { // Invoke: lindex $winfo_element 1
                            TclObject tmp23 = getVarScalar(interp, "winfo_element", compiledLocals, 0);
                            tmp23 = TclList.index(interp, tmp23, 1);
                            if ( tmp23 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp23);
                            }
                        } // End Invoke: lindex
                        tmp22 = interp.getResult();
                        setVarScalar(interp, "vinfo", tmp22, compiledLocals, 9);
                    } // End Invoke: set
                    { // Invoke: set decl $declare_flag
                        TclObject tmp24;
                        tmp24 = getVarScalar(interp, "declare_flag", compiledLocals, 4);
                        setVarScalar(interp, "decl", tmp24, compiledLocals, 10);
                    } // End Invoke: set
                    { // Invoke: if {$append} ...
                        TclObject tmp25 = getVarScalar(interp, "append", compiledLocals, 2);
                        boolean tmp26 = TJC.getBoolean(interp, tmp25);
                        if ( tmp26 ) {
                            { // Invoke: set decl 0
                                setVarScalar(interp, "decl", const9, compiledLocals, 10);
                            } // End Invoke: set
                        }
                    } // End Invoke: if
                    { // Invoke: append buffer [...]
                        TclObject[] objv27 = TJC.grabObjv(interp, 1);
                        TclObject tmp28;
                        try {
                            // Arg 2 command: [...]
                            { // Invoke: ... $tmpsymbol $vinfo $decl
                                TclObject[] objv29 = TJC.grabObjv(interp, 4);
                                TclObject tmp30;
                                try {
                                    // Arg 0 constant: ...
                                    objv29[0] = const10;
                                    // Arg 1 variable: $tmpsymbol
                                    tmp30 = getVarScalar(interp, "tmpsymbol", compiledLocals, 1);
                                    tmp30.preserve();
                                    objv29[1] = tmp30;
                                    // Arg 2 variable: $vinfo
                                    tmp30 = getVarScalar(interp, "vinfo", compiledLocals, 9);
                                    tmp30.preserve();
                                    objv29[2] = tmp30;
                                    // Arg 3 variable: $decl
                                    tmp30 = getVarScalar(interp, "decl", compiledLocals, 10);
                                    tmp30.preserve();
                                    objv29[3] = tmp30;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                        ? cmdcache4.cmd : null), objv29, 0);
                                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                        updateCmdCache(interp, 4);
                                    }
                                } finally {
                                    tmp30 = objv29[1];
                                    if ( tmp30 != null ) {
                                        tmp30.release();
                                    }
                                    tmp30 = objv29[2];
                                    if ( tmp30 != null ) {
                                        tmp30.release();
                                    }
                                    tmp30 = objv29[3];
                                    if ( tmp30 != null ) {
                                        tmp30.release();
                                    }
                                    TJC.releaseObjv(interp, objv29, 4);
                                }
                            } // End Invoke: ...
                            tmp28 = interp.getResult();
                            tmp28.preserve();
                            objv27[0] = tmp28;
                            interp.resetResult();
                            appendVarScalar(interp, "buffer", objv27, compiledLocals, 5);
                        } finally {
                            TJC.releaseObjvElems(interp, objv27, 1);
                        }
                    } // End Invoke: append
                    { // Invoke: if {$append} ...
                        TclObject tmp31 = getVarScalar(interp, "append", compiledLocals, 2);
                        boolean tmp32 = TJC.getBoolean(interp, tmp31);
                        if ( tmp32 ) {
                            { // Invoke: append buffer [...] $sbtmp ".append(" $tmpsymbol ".toString())" ...
                                TclObject[] objv33 = TJC.grabObjv(interp, 6);
                                TclObject tmp34;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: emitter_indent
                                        TclObject[] objv35 = TJC.grabObjv(interp, 1);
                                        try {
                                            // Arg 0 constant: emitter_indent
                                            objv35[0] = const4;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                                ? cmdcache2.cmd : null), objv35, 0);
                                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                                updateCmdCache(interp, 2);
                                            }
                                        } finally {
                                            TJC.releaseObjv(interp, objv35, 1);
                                        }
                                    } // End Invoke: emitter_indent
                                    tmp34 = interp.getResult();
                                    tmp34.preserve();
                                    objv33[0] = tmp34;
                                    // Arg 3 variable: $sbtmp
                                    tmp34 = getVarScalar(interp, "sbtmp", compiledLocals, 3);
                                    tmp34.preserve();
                                    objv33[1] = tmp34;
                                    // Arg 4 constant: ".append("
                                    objv33[2] = const11;
                                    // Arg 5 variable: $tmpsymbol
                                    tmp34 = getVarScalar(interp, "tmpsymbol", compiledLocals, 1);
                                    tmp34.preserve();
                                    objv33[3] = tmp34;
                                    // Arg 6 constant: ".toString())"
                                    objv33[4] = const12;
                                    // Arg 7 constant: ...
                                    objv33[5] = const13;
                                    interp.resetResult();
                                    appendVarScalar(interp, "buffer", objv33, compiledLocals, 5);
                                } finally {
                                    tmp34 = objv33[0];
                                    if ( tmp34 != null ) {
                                        tmp34.release();
                                    }
                                    tmp34 = objv33[1];
                                    if ( tmp34 != null ) {
                                        tmp34.release();
                                    }
                                    tmp34 = objv33[3];
                                    if ( tmp34 != null ) {
                                        tmp34.release();
                                    }
                                    TJC.releaseObjv(interp, objv33, 6);
                                }
                            } // End Invoke: append
                        }
                    } // End Invoke: if
                } else {
                    // Binary operator: $type == "command"
                    TclObject tmp36 = getVarScalar(interp, "type", compiledLocals, 7);
                    boolean tmp37 = tmp36.toString().equals("command");
                    ExprValue tmp38 = evs0;
                    tmp38.setIntValue(tmp37);
                    // End Binary operator: ==
                    boolean tmp39 = ( tmp38.getIntValue() != 0 );
                    if ( tmp39 ) {
                        { // Invoke: set ckeys [...]
                            TclObject tmp40;
                            { // Invoke: lindex $winfo_element 1
                                TclObject tmp41 = getVarScalar(interp, "winfo_element", compiledLocals, 0);
                                tmp41 = TclList.index(interp, tmp41, 1);
                                if ( tmp41 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp41);
                                }
                            } // End Invoke: lindex
                            tmp40 = interp.getResult();
                            setVarScalar(interp, "ckeys", tmp40, compiledLocals, 11);
                        } // End Invoke: set
                        { // Invoke: if ... ... else ...
                            { // Invoke: ... $ckeys
                                TclObject[] objv42 = TJC.grabObjv(interp, 2);
                                TclObject tmp43;
                                try {
                                    // Arg 0 constant: ...
                                    objv42[0] = const14;
                                    // Arg 1 variable: $ckeys
                                    tmp43 = getVarScalar(interp, "ckeys", compiledLocals, 11);
                                    tmp43.preserve();
                                    objv42[1] = tmp43;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                        ? cmdcache5.cmd : null), objv42, 0);
                                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                        updateCmdCache(interp, 5);
                                    }
                                } finally {
                                    tmp43 = objv42[1];
                                    if ( tmp43 != null ) {
                                        tmp43.release();
                                    }
                                    TJC.releaseObjv(interp, objv42, 2);
                                }
                            } // End Invoke: ...
                            TclObject tmp44 = interp.getResult();
                            ExprValue tmp45 = evs0;
                            TJC.exprInitValue(interp, tmp45, tmp44);
                            boolean tmp46 = tmp45.getBooleanValue(interp);
                            if ( tmp46 ) {
                                { // Invoke: set esym [...]
                                    TclObject tmp47;
                                    { // Invoke: ... {}
                                        TclObject[] objv48 = TJC.grabObjv(interp, 2);
                                        try {
                                            // Arg 0 constant: ...
                                            objv48[0] = const15;
                                            // Arg 1 constant: {}
                                            objv48[1] = const1;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                                ? cmdcache6.cmd : null), objv48, 0);
                                            if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                                updateCmdCache(interp, 6);
                                            }
                                        } finally {
                                            TJC.releaseObjv(interp, objv48, 2);
                                        }
                                    } // End Invoke: ...
                                    tmp47 = interp.getResult();
                                    setVarScalar(interp, "esym", tmp47, compiledLocals, 12);
                                } // End Invoke: set
                                { // Invoke: if {$append} ... else ...
                                    TclObject tmp49 = getVarScalar(interp, "append", compiledLocals, 2);
                                    boolean tmp50 = TJC.getBoolean(interp, tmp49);
                                    if ( tmp50 ) {
                                        { // Invoke: append buffer [...] $sbtmp ".append(" $esym ".toString())" ...
                                            TclObject[] objv51 = TJC.grabObjv(interp, 6);
                                            TclObject tmp52;
                                            try {
                                                // Arg 2 command: [...]
                                                { // Invoke: emitter_indent
                                                    TclObject[] objv53 = TJC.grabObjv(interp, 1);
                                                    try {
                                                        // Arg 0 constant: emitter_indent
                                                        objv53[0] = const4;
                                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                            updateCmdCache(interp, 0);
                                                        }
                                                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                                            ? cmdcache2.cmd : null), objv53, 0);
                                                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                                            updateCmdCache(interp, 2);
                                                        }
                                                    } finally {
                                                        TJC.releaseObjv(interp, objv53, 1);
                                                    }
                                                } // End Invoke: emitter_indent
                                                tmp52 = interp.getResult();
                                                tmp52.preserve();
                                                objv51[0] = tmp52;
                                                // Arg 3 variable: $sbtmp
                                                tmp52 = getVarScalar(interp, "sbtmp", compiledLocals, 3);
                                                tmp52.preserve();
                                                objv51[1] = tmp52;
                                                // Arg 4 constant: ".append("
                                                objv51[2] = const11;
                                                // Arg 5 variable: $esym
                                                tmp52 = getVarScalar(interp, "esym", compiledLocals, 12);
                                                tmp52.preserve();
                                                objv51[3] = tmp52;
                                                // Arg 6 constant: ".toString())"
                                                objv51[4] = const12;
                                                // Arg 7 constant: ...
                                                objv51[5] = const13;
                                                interp.resetResult();
                                                appendVarScalar(interp, "buffer", objv51, compiledLocals, 5);
                                            } finally {
                                                tmp52 = objv51[0];
                                                if ( tmp52 != null ) {
                                                    tmp52.release();
                                                }
                                                tmp52 = objv51[1];
                                                if ( tmp52 != null ) {
                                                    tmp52.release();
                                                }
                                                tmp52 = objv51[3];
                                                if ( tmp52 != null ) {
                                                    tmp52.release();
                                                }
                                                TJC.releaseObjv(interp, objv51, 6);
                                            }
                                        } // End Invoke: append
                                    } else {
                                        { // Invoke: append buffer [...] $declare $tmpsymbol ...
                                            TclObject[] objv54 = TJC.grabObjv(interp, 4);
                                            TclObject tmp55;
                                            try {
                                                // Arg 2 command: [...]
                                                { // Invoke: emitter_indent
                                                    TclObject[] objv56 = TJC.grabObjv(interp, 1);
                                                    try {
                                                        // Arg 0 constant: emitter_indent
                                                        objv56[0] = const4;
                                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                            updateCmdCache(interp, 0);
                                                        }
                                                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                                            ? cmdcache2.cmd : null), objv56, 0);
                                                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                                            updateCmdCache(interp, 2);
                                                        }
                                                    } finally {
                                                        TJC.releaseObjv(interp, objv56, 1);
                                                    }
                                                } // End Invoke: emitter_indent
                                                tmp55 = interp.getResult();
                                                tmp55.preserve();
                                                objv54[0] = tmp55;
                                                // Arg 3 variable: $declare
                                                tmp55 = getVarScalar(interp, "declare", compiledLocals, 6);
                                                tmp55.preserve();
                                                objv54[1] = tmp55;
                                                // Arg 4 variable: $tmpsymbol
                                                tmp55 = getVarScalar(interp, "tmpsymbol", compiledLocals, 1);
                                                tmp55.preserve();
                                                objv54[2] = tmp55;
                                                // Arg 5 word: ...
                                                StringBuffer sbtmp57 = new StringBuffer(64);
                                                sbtmp57.append(" = ");
                                                tmp55 = getVarScalar(interp, "esym", compiledLocals, 12);
                                                sbtmp57.append(tmp55.toString());
                                                sbtmp57.append(";");
                                                sbtmp57.append("\n");
                                                tmp55 = TclString.newInstance(sbtmp57);
                                                tmp55.preserve();
                                                objv54[3] = tmp55;
                                                interp.resetResult();
                                                appendVarScalar(interp, "buffer", objv54, compiledLocals, 5);
                                            } finally {
                                                TJC.releaseObjvElems(interp, objv54, 4);
                                            }
                                        } // End Invoke: append
                                    }
                                } // End Invoke: if
                            } else {
                                { // Invoke: foreach ckey $ckeys ...
                                    TclObject tmp58 = null;
                                    try {
                                        tmp58 = getVarScalar(interp, "ckeys", compiledLocals, 11);
                                        tmp58.preserve();
                                        final int tmp58_length = TclList.getLength(interp, tmp58);

                                        for ( int index59 = 0 ; index59 < tmp58_length ; index59++ ) {
                                            TclObject tmp60 = TclList.index(interp, tmp58, index59);
                                            try {
                                                setVarScalar(interp, "ckey", tmp60, compiledLocals, 13);
                                            } catch (TclException ex) {
                                                TJC.foreachVarErr(interp, "ckey");
                                            }

                                            try {
                                            if ( false ) { throw (TclException) null; }
                                            { // Invoke: if {$ckey == {}} {continue}
                                                // Binary operator: $ckey == ""
                                                TclObject tmp61 = getVarScalar(interp, "ckey", compiledLocals, 13);
                                                ExprValue tmp62 = evs0;
                                                TJC.exprEqualsEmptyString(tmp62, tmp61, false);
                                                // End Binary operator: ==
                                                boolean tmp63 = ( tmp62.getIntValue() != 0 );
                                                if ( tmp63 ) {
                                                    { // Invoke: continue
                                                        if ( true ) { continue; }
                                                    } // End Invoke: continue
                                                }
                                            } // End Invoke: if
                                            { // Invoke: append buffer [...]
                                                TclObject[] objv64 = TJC.grabObjv(interp, 1);
                                                TclObject tmp65;
                                                try {
                                                    // Arg 2 command: [...]
                                                    { // Invoke: ... $ckey
                                                        TclObject[] objv66 = TJC.grabObjv(interp, 2);
                                                        TclObject tmp67;
                                                        try {
                                                            // Arg 0 constant: ...
                                                            objv66[0] = const16;
                                                            // Arg 1 variable: $ckey
                                                            tmp67 = getVarScalar(interp, "ckey", compiledLocals, 13);
                                                            tmp67.preserve();
                                                            objv66[1] = tmp67;
                                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                                updateCmdCache(interp, 0);
                                                            }
                                                            TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                                                ? cmdcache7.cmd : null), objv66, 0);
                                                            if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                                                updateCmdCache(interp, 7);
                                                            }
                                                        } finally {
                                                            tmp67 = objv66[1];
                                                            if ( tmp67 != null ) {
                                                                tmp67.release();
                                                            }
                                                            TJC.releaseObjv(interp, objv66, 2);
                                                        }
                                                    } // End Invoke: ...
                                                    tmp65 = interp.getResult();
                                                    tmp65.preserve();
                                                    objv64[0] = tmp65;
                                                    interp.resetResult();
                                                    appendVarScalar(interp, "buffer", objv64, compiledLocals, 5);
                                                } finally {
                                                    TJC.releaseObjvElems(interp, objv64, 1);
                                                }
                                            } // End Invoke: append
                                            } catch (TclException ex) {
                                                int type = ex.getCompletionCode();
                                                if (type == TCL.BREAK) {
                                                    break;
                                                } else if (type == TCL.CONTINUE) {
                                                    continue;
                                                } else {
                                                    throw ex;
                                                }
                                            }
                                        }
                                    } finally {
                                        if ( tmp58 != null ) {
                                            tmp58.release();
                                        }
                                    }
                                } // End Invoke: foreach
                                { // Invoke: if {$append} ... else ...
                                    TclObject tmp68 = getVarScalar(interp, "append", compiledLocals, 2);
                                    boolean tmp69 = TJC.getBoolean(interp, tmp68);
                                    if ( tmp69 ) {
                                        { // Invoke: append buffer [...] $tmpsymbol ... ... [...] $sbtmp ".append(" $tmpsymbol ".toString())" ...
                                            TclObject[] objv70 = TJC.grabObjv(interp, 10);
                                            TclObject tmp71;
                                            try {
                                                // Arg 2 command: [...]
                                                { // Invoke: emitter_indent
                                                    TclObject[] objv72 = TJC.grabObjv(interp, 1);
                                                    try {
                                                        // Arg 0 constant: emitter_indent
                                                        objv72[0] = const4;
                                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                            updateCmdCache(interp, 0);
                                                        }
                                                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                                            ? cmdcache2.cmd : null), objv72, 0);
                                                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                                            updateCmdCache(interp, 2);
                                                        }
                                                    } finally {
                                                        TJC.releaseObjv(interp, objv72, 1);
                                                    }
                                                } // End Invoke: emitter_indent
                                                tmp71 = interp.getResult();
                                                tmp71.preserve();
                                                objv70[0] = tmp71;
                                                // Arg 3 variable: $tmpsymbol
                                                tmp71 = getVarScalar(interp, "tmpsymbol", compiledLocals, 1);
                                                tmp71.preserve();
                                                objv70[1] = tmp71;
                                                // Arg 4 constant: ...
                                                objv70[2] = const17;
                                                // Arg 5 constant: ...
                                                objv70[3] = const13;
                                                // Arg 6 command: [...]
                                                { // Invoke: emitter_indent
                                                    TclObject[] objv73 = TJC.grabObjv(interp, 1);
                                                    try {
                                                        // Arg 0 constant: emitter_indent
                                                        objv73[0] = const4;
                                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                            updateCmdCache(interp, 0);
                                                        }
                                                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                                            ? cmdcache2.cmd : null), objv73, 0);
                                                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                                            updateCmdCache(interp, 2);
                                                        }
                                                    } finally {
                                                        TJC.releaseObjv(interp, objv73, 1);
                                                    }
                                                } // End Invoke: emitter_indent
                                                tmp71 = interp.getResult();
                                                tmp71.preserve();
                                                objv70[4] = tmp71;
                                                // Arg 7 variable: $sbtmp
                                                tmp71 = getVarScalar(interp, "sbtmp", compiledLocals, 3);
                                                tmp71.preserve();
                                                objv70[5] = tmp71;
                                                // Arg 8 constant: ".append("
                                                objv70[6] = const11;
                                                // Arg 9 variable: $tmpsymbol
                                                tmp71 = getVarScalar(interp, "tmpsymbol", compiledLocals, 1);
                                                tmp71.preserve();
                                                objv70[7] = tmp71;
                                                // Arg 10 constant: ".toString())"
                                                objv70[8] = const12;
                                                // Arg 11 constant: ...
                                                objv70[9] = const13;
                                                interp.resetResult();
                                                appendVarScalar(interp, "buffer", objv70, compiledLocals, 5);
                                            } finally {
                                                objv70[2] = null;
                                                objv70[3] = null;
                                                objv70[6] = null;
                                                objv70[8] = null;
                                                objv70[9] = null;
                                                TJC.releaseObjvElems(interp, objv70, 10);
                                            }
                                        } // End Invoke: append
                                    } else {
                                        { // Invoke: append buffer [...] $declare $tmpsymbol ... ...
                                            TclObject[] objv74 = TJC.grabObjv(interp, 5);
                                            TclObject tmp75;
                                            try {
                                                // Arg 2 command: [...]
                                                { // Invoke: emitter_indent
                                                    TclObject[] objv76 = TJC.grabObjv(interp, 1);
                                                    try {
                                                        // Arg 0 constant: emitter_indent
                                                        objv76[0] = const4;
                                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                            updateCmdCache(interp, 0);
                                                        }
                                                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                                            ? cmdcache2.cmd : null), objv76, 0);
                                                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                                            updateCmdCache(interp, 2);
                                                        }
                                                    } finally {
                                                        TJC.releaseObjv(interp, objv76, 1);
                                                    }
                                                } // End Invoke: emitter_indent
                                                tmp75 = interp.getResult();
                                                tmp75.preserve();
                                                objv74[0] = tmp75;
                                                // Arg 3 variable: $declare
                                                tmp75 = getVarScalar(interp, "declare", compiledLocals, 6);
                                                tmp75.preserve();
                                                objv74[1] = tmp75;
                                                // Arg 4 variable: $tmpsymbol
                                                tmp75 = getVarScalar(interp, "tmpsymbol", compiledLocals, 1);
                                                tmp75.preserve();
                                                objv74[2] = tmp75;
                                                // Arg 5 constant: ...
                                                objv74[3] = const17;
                                                // Arg 6 constant: ...
                                                objv74[4] = const13;
                                                interp.resetResult();
                                                appendVarScalar(interp, "buffer", objv74, compiledLocals, 5);
                                            } finally {
                                                tmp75 = objv74[0];
                                                if ( tmp75 != null ) {
                                                    tmp75.release();
                                                }
                                                tmp75 = objv74[1];
                                                if ( tmp75 != null ) {
                                                    tmp75.release();
                                                }
                                                tmp75 = objv74[2];
                                                if ( tmp75 != null ) {
                                                    tmp75.release();
                                                }
                                                TJC.releaseObjv(interp, objv74, 5);
                                            }
                                        } // End Invoke: append
                                    }
                                } // End Invoke: if
                            }
                        } // End Invoke: if
                    } else {
                        { // Invoke: error "..."
                            TclObject[] objv77 = TJC.grabObjv(interp, 2);
                            TclObject tmp78;
                            try {
                                // Arg 0 constant: error
                                objv77[0] = const7;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp79 = new StringBuffer(64);
                                sbtmp79.append("unknown word info element type ");
                                sbtmp79.append("\"");
                                tmp78 = getVarScalar(interp, "type", compiledLocals, 7);
                                sbtmp79.append(tmp78.toString());
                                sbtmp79.append("\"");
                                sbtmp79.append(" in winfo_element ");
                                sbtmp79.append("{");
                                tmp78 = getVarScalar(interp, "winfo_element", compiledLocals, 0);
                                sbtmp79.append(tmp78.toString());
                                sbtmp79.append("}");
                                tmp78 = TclString.newInstance(sbtmp79);
                                tmp78.preserve();
                                objv77[1] = tmp78;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                    ? cmdcache3.cmd : null), objv77, 0);
                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                    updateCmdCache(interp, 3);
                                }
                            } finally {
                                tmp78 = objv77[1];
                                if ( tmp78 != null ) {
                                    tmp78.release();
                                }
                                TJC.releaseObjv(interp, objv77, 2);
                            }
                        } // End Invoke: error
                    }
                }
            }
        } // End Invoke: if
        { // Invoke: return $buffer
            TclObject tmp80 = getVarScalar(interp, "buffer", compiledLocals, 5);
            interp.resetResult();
            interp.setResult(tmp80);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_emit_word_element");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclInteger.newInstance(1);
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("TclObject ");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("emitter_backslash_tcl_string");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("emitter_indent");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance(".append(\"");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("\");\n");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("error");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("constant text can't be assigned");
        const8.preserve(); const8.preserve();
        const9 = TclInteger.newInstance(0);
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("compileproc_emit_variable");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance(".append(");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance(".toString())");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance(";\n");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("compileproc_is_empty_command");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("compileproc_constant_cache_get");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("compileproc_emit_invoke");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance(" = interp.getResult()");
        const17.preserve(); const17.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "emitter_backslash_tcl_string";
                break;
            }
            case 2: {
                cmdName = "emitter_indent";
                break;
            }
            case 3: {
                cmdName = "error";
                break;
            }
            case 4: {
                cmdName = "compileproc_emit_variable";
                break;
            }
            case 5: {
                cmdName = "compileproc_is_empty_command";
                break;
            }
            case 6: {
                cmdName = "compileproc_constant_cache_get";
                break;
            }
            case 7: {
                cmdName = "compileproc_emit_invoke";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "winfo_element",
        "tmpsymbol",
        "append",
        "sbtmp",
        "declare_flag",
        "buffer",
        "declare",
        "type",
        "str",
        "vinfo",
        "decl",
        "ckeys",
        "esym",
        "ckey"
    };
} // end class CompileprocEmitWordElementCmd

