// TJC implementation of procedure compileproc_get_variable
package tjc;
import tcl.lang.*;

public class CompileprocGetVariableCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 6, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 4) {
            throw new TclNumArgsException(interp, 1, objv, "tmpsymbol varname varname_is_string");
        }
        setVarScalar(interp, "tmpsymbol", objv[1], compiledLocals, 0);
        setVarScalar(interp, "varname", objv[2], compiledLocals, 1);
        setVarScalar(interp, "varname_is_string", objv[3], compiledLocals, 2);
        { // Invoke: if {$varname_is_string} ... else ...
            TclObject tmp0 = getVarScalar(interp, "varname_is_string", compiledLocals, 2);
            boolean tmp1 = TJC.getBoolean(interp, tmp0);
            if ( tmp1 ) {
                { // Invoke: set vinfo [...]
                    TclObject tmp2;
                    { // Invoke: ... $varname
                        TclObject[] objv3 = TJC.grabObjv(interp, 2);
                        TclObject tmp4;
                        try {
                            // Arg 0 constant: ...
                            objv3[0] = const0;
                            // Arg 1 variable: $varname
                            tmp4 = getVarScalar(interp, "varname", compiledLocals, 1);
                            tmp4.preserve();
                            objv3[1] = tmp4;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv3, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            tmp4 = objv3[1];
                            if ( tmp4 != null ) {
                                tmp4.release();
                            }
                            TJC.releaseObjv(interp, objv3, 2);
                        }
                    } // End Invoke: ...
                    tmp2 = interp.getResult();
                    setVarScalar(interp, "vinfo", tmp2, compiledLocals, 3);
                } // End Invoke: set
                { // Invoke: if ... ... elseif ... ... else ...
                    // Binary operator: [...] == "array"
                    { // Invoke: lindex $vinfo 0
                        TclObject tmp5 = getVarScalar(interp, "vinfo", compiledLocals, 3);
                        tmp5 = TclList.index(interp, tmp5, 0);
                        if ( tmp5 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp5);
                        }
                    } // End Invoke: lindex
                    TclObject tmp6 = interp.getResult();
                    boolean tmp7 = tmp6.toString().equals("array");
                    ExprValue tmp8 = evs0;
                    tmp8.setIntValue(tmp7);
                    // End Binary operator: ==
                    boolean tmp9 = ( tmp8.getIntValue() != 0 );
                    if ( tmp9 ) {
                        { // Invoke: set p1 [...]
                            TclObject tmp10;
                            { // Invoke: lindex $vinfo 1
                                TclObject tmp11 = getVarScalar(interp, "vinfo", compiledLocals, 3);
                                tmp11 = TclList.index(interp, tmp11, 1);
                                if ( tmp11 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp11);
                                }
                            } // End Invoke: lindex
                            tmp10 = interp.getResult();
                            setVarScalar(interp, "p1", tmp10, compiledLocals, 4);
                        } // End Invoke: set
                        { // Invoke: set p2 [...]
                            TclObject tmp12;
                            { // Invoke: lindex $vinfo 2
                                TclObject tmp13 = getVarScalar(interp, "vinfo", compiledLocals, 3);
                                tmp13 = TclList.index(interp, tmp13, 2);
                                if ( tmp13 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp13);
                                }
                            } // End Invoke: lindex
                            tmp12 = interp.getResult();
                            setVarScalar(interp, "p2", tmp12, compiledLocals, 5);
                        } // End Invoke: set
                        { // Invoke: return [...]
                            { // Invoke: ... $tmpsymbol $p1 $p2 true
                                TclObject[] objv14 = TJC.grabObjv(interp, 5);
                                TclObject tmp15;
                                try {
                                    // Arg 0 constant: ...
                                    objv14[0] = const1;
                                    // Arg 1 variable: $tmpsymbol
                                    tmp15 = getVarScalar(interp, "tmpsymbol", compiledLocals, 0);
                                    tmp15.preserve();
                                    objv14[1] = tmp15;
                                    // Arg 2 variable: $p1
                                    tmp15 = getVarScalar(interp, "p1", compiledLocals, 4);
                                    tmp15.preserve();
                                    objv14[2] = tmp15;
                                    // Arg 3 variable: $p2
                                    tmp15 = getVarScalar(interp, "p2", compiledLocals, 5);
                                    tmp15.preserve();
                                    objv14[3] = tmp15;
                                    // Arg 4 constant: true
                                    objv14[4] = const2;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                        ? cmdcache2.cmd : null), objv14, 0);
                                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                        updateCmdCache(interp, 2);
                                    }
                                } finally {
                                    tmp15 = objv14[1];
                                    if ( tmp15 != null ) {
                                        tmp15.release();
                                    }
                                    tmp15 = objv14[2];
                                    if ( tmp15 != null ) {
                                        tmp15.release();
                                    }
                                    tmp15 = objv14[3];
                                    if ( tmp15 != null ) {
                                        tmp15.release();
                                    }
                                    TJC.releaseObjv(interp, objv14, 5);
                                }
                            } // End Invoke: ...
                            if ( true ) { return; }
                        } // End Invoke: return
                    } else {
                        // Binary operator: [...] == "scalar"
                        { // Invoke: lindex $vinfo 0
                            TclObject tmp16 = getVarScalar(interp, "vinfo", compiledLocals, 3);
                            tmp16 = TclList.index(interp, tmp16, 0);
                            if ( tmp16 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp16);
                            }
                        } // End Invoke: lindex
                        TclObject tmp17 = interp.getResult();
                        boolean tmp18 = tmp17.toString().equals("scalar");
                        ExprValue tmp19 = evs0;
                        tmp19.setIntValue(tmp18);
                        // End Binary operator: ==
                        boolean tmp20 = ( tmp19.getIntValue() != 0 );
                        if ( tmp20 ) {
                            { // Invoke: return [...]
                                { // Invoke: ... $tmpsymbol $varname
                                    TclObject[] objv21 = TJC.grabObjv(interp, 3);
                                    TclObject tmp22;
                                    try {
                                        // Arg 0 constant: ...
                                        objv21[0] = const3;
                                        // Arg 1 variable: $tmpsymbol
                                        tmp22 = getVarScalar(interp, "tmpsymbol", compiledLocals, 0);
                                        tmp22.preserve();
                                        objv21[1] = tmp22;
                                        // Arg 2 variable: $varname
                                        tmp22 = getVarScalar(interp, "varname", compiledLocals, 1);
                                        tmp22.preserve();
                                        objv21[2] = tmp22;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                            ? cmdcache3.cmd : null), objv21, 0);
                                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                            updateCmdCache(interp, 3);
                                        }
                                    } finally {
                                        tmp22 = objv21[1];
                                        if ( tmp22 != null ) {
                                            tmp22.release();
                                        }
                                        tmp22 = objv21[2];
                                        if ( tmp22 != null ) {
                                            tmp22.release();
                                        }
                                        TJC.releaseObjv(interp, objv21, 3);
                                    }
                                } // End Invoke: ...
                                if ( true ) { return; }
                            } // End Invoke: return
                        } else {
                            { // Invoke: error "..."
                                TclObject[] objv23 = TJC.grabObjv(interp, 2);
                                TclObject tmp24;
                                try {
                                    // Arg 0 constant: error
                                    objv23[0] = const4;
                                    // Arg 1 word: "..."
                                    StringBuffer sbtmp25 = new StringBuffer(64);
                                    sbtmp25.append("unexpected result ");
                                    sbtmp25.append("{");
                                    tmp24 = getVarScalar(interp, "vinfo", compiledLocals, 3);
                                    sbtmp25.append(tmp24.toString());
                                    sbtmp25.append("}");
                                    sbtmp25.append(" from descend_simple_variable");
                                    tmp24 = TclString.newInstance(sbtmp25);
                                    tmp24.preserve();
                                    objv23[1] = tmp24;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                        ? cmdcache4.cmd : null), objv23, 0);
                                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                        updateCmdCache(interp, 4);
                                    }
                                } finally {
                                    tmp24 = objv23[1];
                                    if ( tmp24 != null ) {
                                        tmp24.release();
                                    }
                                    TJC.releaseObjv(interp, objv23, 2);
                                }
                            } // End Invoke: error
                        }
                    }
                } // End Invoke: if
            } else {
                { // Invoke: return [...]
                    { // Invoke: emitter_get_var $tmpsymbol $varname false null false 0
                        TclObject[] objv26 = TJC.grabObjv(interp, 7);
                        TclObject tmp27;
                        try {
                            // Arg 0 constant: emitter_get_var
                            objv26[0] = const5;
                            // Arg 1 variable: $tmpsymbol
                            tmp27 = getVarScalar(interp, "tmpsymbol", compiledLocals, 0);
                            tmp27.preserve();
                            objv26[1] = tmp27;
                            // Arg 2 variable: $varname
                            tmp27 = getVarScalar(interp, "varname", compiledLocals, 1);
                            tmp27.preserve();
                            objv26[2] = tmp27;
                            // Arg 3 constant: false
                            objv26[3] = const6;
                            // Arg 4 constant: null
                            objv26[4] = const7;
                            // Arg 5 constant: false
                            objv26[5] = const6;
                            // Arg 6 constant: 0
                            objv26[6] = const8;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                ? cmdcache5.cmd : null), objv26, 0);
                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                updateCmdCache(interp, 5);
                            }
                        } finally {
                            tmp27 = objv26[1];
                            if ( tmp27 != null ) {
                                tmp27.release();
                            }
                            tmp27 = objv26[2];
                            if ( tmp27 != null ) {
                                tmp27.release();
                            }
                            TJC.releaseObjv(interp, objv26, 7);
                        }
                    } // End Invoke: emitter_get_var
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_get_variable");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("descend_simple_variable");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("compileproc_emit_array_variable_get");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("true");
        TclBoolean.get(interp, const2);
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("compileproc_emit_scalar_variable_get");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("error");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("emitter_get_var");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("false");
        TclBoolean.get(interp, const6);
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("null");
        const7.preserve(); const7.preserve();
        const8 = TclInteger.newInstance(0);
        const8.preserve(); const8.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "descend_simple_variable";
                break;
            }
            case 2: {
                cmdName = "compileproc_emit_array_variable_get";
                break;
            }
            case 3: {
                cmdName = "compileproc_emit_scalar_variable_get";
                break;
            }
            case 4: {
                cmdName = "error";
                break;
            }
            case 5: {
                cmdName = "emitter_get_var";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "tmpsymbol",
        "varname",
        "varname_is_string",
        "vinfo",
        "p1",
        "p2"
    };
} // end class CompileprocGetVariableCmd

