// TJC implementation of procedure compileproc_parse_value
package tjc;
import tcl.lang.*;

public class CompileprocParseValueCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 14, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        ExprValue evs2 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "value");
        }
        setVarScalar(interp, "value", objv[1], compiledLocals, 0);
        { // Invoke: set is_integer [...]
            TclObject tmp0;
            { // Invoke: ... $value
                TclObject[] objv1 = TJC.grabObjv(interp, 2);
                TclObject tmp2;
                try {
                    // Arg 0 constant: ...
                    objv1[0] = const0;
                    // Arg 1 variable: $value
                    tmp2 = getVarScalar(interp, "value", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 2);
                }
            } // End Invoke: ...
            tmp0 = interp.getResult();
            setVarScalar(interp, "is_integer", tmp0, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: if {!$is_integer} ... else ...
            // Unary operator: ! $is_integer
            TclObject tmp3 = getVarScalar(interp, "is_integer", compiledLocals, 1);
            ExprValue tmp4 = evs0;
            if ( tmp3.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp4, tmp3);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp4, tmp3);
            }
            // End Unary operator: !
            boolean tmp5 = ( tmp4.getIntValue() != 0 );
            if ( tmp5 ) {
                { // Invoke: set is_double [...]
                    TclObject tmp6;
                    { // Invoke: ... $value
                        TclObject[] objv7 = TJC.grabObjv(interp, 2);
                        TclObject tmp8;
                        try {
                            // Arg 0 constant: ...
                            objv7[0] = const1;
                            // Arg 1 variable: $value
                            tmp8 = getVarScalar(interp, "value", compiledLocals, 0);
                            tmp8.preserve();
                            objv7[1] = tmp8;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv7, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp8 = objv7[1];
                            if ( tmp8 != null ) {
                                tmp8.release();
                            }
                            TJC.releaseObjv(interp, objv7, 2);
                        }
                    } // End Invoke: ...
                    tmp6 = interp.getResult();
                    setVarScalar(interp, "is_double", tmp6, compiledLocals, 2);
                } // End Invoke: set
            } else {
                { // Invoke: set is_double 0
                    setVarScalar(interp, "is_double", const2, compiledLocals, 2);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            // Binary operator: () && ()
            // Unary operator: ! $is_integer
            TclObject tmp9 = getVarScalar(interp, "is_integer", compiledLocals, 1);
            ExprValue tmp10 = evs0;
            if ( tmp9.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp10, tmp9);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp10, tmp9);
            }
            // End Unary operator: !
            if (tmp10.getBooleanValue(interp)) {
            // Unary operator: ! $is_double
            TclObject tmp11 = getVarScalar(interp, "is_double", compiledLocals, 2);
            ExprValue tmp12 = evs1;
            if ( tmp11.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp12, tmp11);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp12, tmp11);
            }
            // End Unary operator: !
            tmp10.setIntValue(tmp12.getBooleanValue(interp));
            } else {
            tmp10.setIntValue(0);
            } // End if: ()
            // End Binary operator: &&
            boolean tmp13 = ( tmp10.getIntValue() != 0 );
            if ( tmp13 ) {
                { // Invoke: error "..."
                    TclObject[] objv14 = TJC.grabObjv(interp, 2);
                    TclObject tmp15;
                    try {
                        // Arg 0 constant: error
                        objv14[0] = const3;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp16 = new StringBuffer(64);
                        sbtmp16.append("value ");
                        sbtmp16.append("\"");
                        tmp15 = getVarScalar(interp, "value", compiledLocals, 0);
                        sbtmp16.append(tmp15.toString());
                        sbtmp16.append("\"");
                        sbtmp16.append(" is not a valid Java integer or double");
                        tmp15 = TclString.newInstance(sbtmp16);
                        tmp15.preserve();
                        objv14[1] = tmp15;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv14, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        tmp15 = objv14[1];
                        if ( tmp15 != null ) {
                            tmp15.release();
                        }
                        TJC.releaseObjv(interp, objv14, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set parsed [...]
            TclObject tmp17;
            { // Invoke: expr {$value}
                TclObject tmp18 = getVarScalar(interp, "value", compiledLocals, 0);
                ExprValue tmp19 = evs0;
                TJC.exprInitValue(interp, tmp19, tmp18);
                TJC.exprSetResult(interp, tmp19);
            } // End Invoke: expr
            tmp17 = interp.getResult();
            setVarScalar(interp, "parsed", tmp17, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set matching_strrep [...]
            TclObject tmp20;
            { // Invoke: expr {$parsed eq $value}
                // Binary operator: $parsed eq $value
                TclObject tmp21 = getVarScalar(interp, "parsed", compiledLocals, 3);
                String tmp22 = tmp21.toString();
                TclObject tmp23 = getVarScalar(interp, "value", compiledLocals, 0);
                String tmp24 = tmp23.toString();
                boolean tmp25 = tmp22.equals(tmp24);
                ExprValue tmp26 = evs0;
                tmp26.setIntValue(tmp25);
                // End Binary operator: eq
                interp.setResult( tmp26.getIntValue() != 0 );
            } // End Invoke: expr
            tmp20 = interp.getResult();
            setVarScalar(interp, "matching_strrep", tmp20, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set compare [...]
            TclObject tmp27;
            { // Invoke: string compare $parsed $value
                TclObject tmp28 = getVarScalar(interp, "parsed", compiledLocals, 3);
                String tmp29 = tmp28.toString();
                TclObject tmp30 = getVarScalar(interp, "value", compiledLocals, 0);
                String tmp31 = tmp30.toString();
                int tmp32 = tmp29.compareTo(tmp31);
                tmp32 = ((tmp32 > 0) ? 1 : (tmp32 < 0) ? -1 : 0);
                interp.setResult(tmp32);
            } // End Invoke: string
            tmp27 = interp.getResult();
            setVarScalar(interp, "compare", tmp27, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: $matching_strrep && ()
            TclObject tmp33 = getVarScalar(interp, "matching_strrep", compiledLocals, 4);
            ExprValue tmp34 = evs0;
            TJC.exprInitValue(interp, tmp34, tmp33);
            if (tmp34.getBooleanValue(interp)) {
            // Binary operator: $compare != 0
            TclObject tmp35 = getVarScalar(interp, "compare", compiledLocals, 5);
            ExprValue tmp36 = evs1;
            TJC.exprInitValue(interp, tmp36, tmp35);
            ExprValue tmp37 = evs2;
            tmp37.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp36, tmp37);
            // End Binary operator: !=
            tmp34.setIntValue(tmp36.getBooleanValue(interp));
            } else {
            tmp34.setIntValue(0);
            } // End if: $matching_strrep
            // End Binary operator: &&
            boolean tmp38 = ( tmp34.getIntValue() != 0 );
            if ( tmp38 ) {
                { // Invoke: error "..."
                    TclObject[] objv39 = TJC.grabObjv(interp, 2);
                    TclObject tmp40;
                    try {
                        // Arg 0 constant: error
                        objv39[0] = const3;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp41 = new StringBuffer(64);
                        sbtmp41.append("matching_strrep is true but compare is ");
                        tmp40 = getVarScalar(interp, "compare", compiledLocals, 5);
                        sbtmp41.append(tmp40.toString());
                        tmp40 = TclString.newInstance(sbtmp41);
                        tmp40.preserve();
                        objv39[1] = tmp40;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv39, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        tmp40 = objv39[1];
                        if ( tmp40 != null ) {
                            tmp40.release();
                        }
                        TJC.releaseObjv(interp, objv39, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            // Binary operator: () && ()
            // Unary operator: ! $matching_strrep
            TclObject tmp42 = getVarScalar(interp, "matching_strrep", compiledLocals, 4);
            ExprValue tmp43 = evs0;
            if ( tmp42.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp43, tmp42);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp43, tmp42);
            }
            // End Unary operator: !
            if (tmp43.getBooleanValue(interp)) {
            // Binary operator: $compare == 0
            TclObject tmp44 = getVarScalar(interp, "compare", compiledLocals, 5);
            ExprValue tmp45 = evs1;
            TJC.exprInitValue(interp, tmp45, tmp44);
            ExprValue tmp46 = evs2;
            tmp46.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp45, tmp46);
            // End Binary operator: ==
            tmp43.setIntValue(tmp45.getBooleanValue(interp));
            } else {
            tmp43.setIntValue(0);
            } // End if: ()
            // End Binary operator: &&
            boolean tmp47 = ( tmp43.getIntValue() != 0 );
            if ( tmp47 ) {
                { // Invoke: error "..."
                    TclObject[] objv48 = TJC.grabObjv(interp, 2);
                    TclObject tmp49;
                    try {
                        // Arg 0 constant: error
                        objv48[0] = const3;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp50 = new StringBuffer(64);
                        sbtmp50.append("matching_strrep is false but compare is ");
                        tmp49 = getVarScalar(interp, "compare", compiledLocals, 5);
                        sbtmp50.append(tmp49.toString());
                        tmp49 = TclString.newInstance(sbtmp50);
                        tmp49.preserve();
                        objv48[1] = tmp49;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv48, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        tmp49 = objv48[1];
                        if ( tmp49 != null ) {
                            tmp49.release();
                        }
                        TJC.releaseObjv(interp, objv48, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set printed $parsed
            TclObject tmp51;
            tmp51 = getVarScalar(interp, "parsed", compiledLocals, 3);
            setVarScalar(interp, "printed", tmp51, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: if {$is_double} ...
            TclObject tmp52 = getVarScalar(interp, "is_double", compiledLocals, 2);
            boolean tmp53 = TJC.getBoolean(interp, tmp52);
            if ( tmp53 ) {
                { // Invoke: set estr [...]
                    TclObject tmp54;
                    { // Invoke: format %g $value
                        TclObject[] objv55 = TJC.grabObjv(interp, 3);
                        TclObject tmp56;
                        try {
                            // Arg 0 constant: format
                            objv55[0] = const4;
                            // Arg 1 constant: %g
                            objv55[1] = const5;
                            // Arg 2 variable: $value
                            tmp56 = getVarScalar(interp, "value", compiledLocals, 0);
                            tmp56.preserve();
                            objv55[2] = tmp56;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                ? cmdcache4.cmd : null), objv55, 0);
                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                updateCmdCache(interp, 4);
                            }
                        } finally {
                            tmp56 = objv55[2];
                            if ( tmp56 != null ) {
                                tmp56.release();
                            }
                            TJC.releaseObjv(interp, objv55, 3);
                        }
                    } // End Invoke: format
                    tmp54 = interp.getResult();
                    setVarScalar(interp, "estr", tmp54, compiledLocals, 7);
                } // End Invoke: set
                { // Invoke: if ... ...
                    { // Invoke: regexp ... $estr whole npart epart
                        TclObject[] objv57 = TJC.grabObjv(interp, 6);
                        TclObject tmp58;
                        try {
                            // Arg 0 constant: regexp
                            objv57[0] = const6;
                            // Arg 1 constant: ...
                            objv57[1] = const7;
                            // Arg 2 variable: $estr
                            tmp58 = getVarScalar(interp, "estr", compiledLocals, 7);
                            tmp58.preserve();
                            objv57[2] = tmp58;
                            // Arg 3 constant: whole
                            objv57[3] = const8;
                            // Arg 4 constant: npart
                            objv57[4] = const9;
                            // Arg 5 constant: epart
                            objv57[5] = const10;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                ? cmdcache5.cmd : null), objv57, 0);
                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                updateCmdCache(interp, 5);
                            }
                        } finally {
                            tmp58 = objv57[2];
                            if ( tmp58 != null ) {
                                tmp58.release();
                            }
                            TJC.releaseObjv(interp, objv57, 6);
                        }
                    } // End Invoke: regexp
                    TclObject tmp59 = interp.getResult();
                    ExprValue tmp60 = evs0;
                    TJC.exprInitValue(interp, tmp60, tmp59);
                    boolean tmp61 = tmp60.getBooleanValue(interp);
                    if ( tmp61 ) {
                        { // Invoke: set printed $npart
                            TclObject tmp62;
                            tmp62 = getVarScalar(interp, "npart", compiledLocals, 8);
                            setVarScalar(interp, "printed", tmp62, compiledLocals, 6);
                        } // End Invoke: set
                        { // Invoke: append printed "e"
                            TclObject[] objv63 = TJC.grabObjv(interp, 1);
                            TclObject tmp64;
                            try {
                                // Arg 2 constant: "e"
                                objv63[0] = const11;
                                interp.resetResult();
                                appendVarScalar(interp, "printed", objv63, compiledLocals, 6);
                            } finally {
                                TJC.releaseObjv(interp, objv63, 1);
                            }
                        } // End Invoke: append
                        { // Invoke: set sign [...]
                            TclObject tmp65;
                            { // Invoke: string index $epart 0
                                TclObject tmp66 = getVarScalar(interp, "epart", compiledLocals, 9);
                                String tmp67 = tmp66.toString();
                                TclObject tmp68 = TJC.stringIndex(interp, tmp67, const2);
                                interp.setResult(tmp68);
                            } // End Invoke: string
                            tmp65 = interp.getResult();
                            setVarScalar(interp, "sign", tmp65, compiledLocals, 10);
                        } // End Invoke: set
                        { // Invoke: if {$sign == "-"} ...
                            // Binary operator: $sign == "-"
                            TclObject tmp69 = getVarScalar(interp, "sign", compiledLocals, 10);
                            boolean tmp70 = tmp69.toString().equals("-");
                            ExprValue tmp71 = evs0;
                            tmp71.setIntValue(tmp70);
                            // End Binary operator: ==
                            boolean tmp72 = ( tmp71.getIntValue() != 0 );
                            if ( tmp72 ) {
                                { // Invoke: append printed "-"
                                    TclObject[] objv73 = TJC.grabObjv(interp, 1);
                                    TclObject tmp74;
                                    try {
                                        // Arg 2 constant: "-"
                                        objv73[0] = const12;
                                        interp.resetResult();
                                        appendVarScalar(interp, "printed", objv73, compiledLocals, 6);
                                    } finally {
                                        TJC.releaseObjv(interp, objv73, 1);
                                    }
                                } // End Invoke: append
                            }
                        } // End Invoke: if
                        { // Invoke: set d1 [...]
                            TclObject tmp75;
                            { // Invoke: string index $epart 1
                                TclObject tmp76 = getVarScalar(interp, "epart", compiledLocals, 9);
                                String tmp77 = tmp76.toString();
                                TclObject tmp78 = TJC.stringIndex(interp, tmp77, const13);
                                interp.setResult(tmp78);
                            } // End Invoke: string
                            tmp75 = interp.getResult();
                            setVarScalar(interp, "d1", tmp75, compiledLocals, 11);
                        } // End Invoke: set
                        { // Invoke: if {$d1 != 0} ...
                            // Binary operator: $d1 != 0
                            TclObject tmp79 = getVarScalar(interp, "d1", compiledLocals, 11);
                            ExprValue tmp80 = evs0;
                            TJC.exprInitValue(interp, tmp80, tmp79);
                            ExprValue tmp81 = evs1;
                            tmp81.setIntValue(0);
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp80, tmp81);
                            // End Binary operator: !=
                            boolean tmp82 = ( tmp80.getIntValue() != 0 );
                            if ( tmp82 ) {
                                { // Invoke: append printed $d1
                                    TclObject[] objv83 = TJC.grabObjv(interp, 1);
                                    TclObject tmp84;
                                    try {
                                        // Arg 2 variable: $d1
                                        tmp84 = getVarScalar(interp, "d1", compiledLocals, 11);
                                        tmp84.preserve();
                                        objv83[0] = tmp84;
                                        interp.resetResult();
                                        appendVarScalar(interp, "printed", objv83, compiledLocals, 6);
                                    } finally {
                                        TJC.releaseObjvElems(interp, objv83, 1);
                                    }
                                } // End Invoke: append
                            }
                        } // End Invoke: if
                        { // Invoke: set d2 [...]
                            TclObject tmp85;
                            { // Invoke: string index $epart 2
                                TclObject tmp86 = getVarScalar(interp, "epart", compiledLocals, 9);
                                String tmp87 = tmp86.toString();
                                TclObject tmp88 = TJC.stringIndex(interp, tmp87, const14);
                                interp.setResult(tmp88);
                            } // End Invoke: string
                            tmp85 = interp.getResult();
                            setVarScalar(interp, "d2", tmp85, compiledLocals, 12);
                        } // End Invoke: set
                        { // Invoke: if {$d2 != 0} ...
                            // Binary operator: $d2 != 0
                            TclObject tmp89 = getVarScalar(interp, "d2", compiledLocals, 12);
                            ExprValue tmp90 = evs0;
                            TJC.exprInitValue(interp, tmp90, tmp89);
                            ExprValue tmp91 = evs1;
                            tmp91.setIntValue(0);
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp90, tmp91);
                            // End Binary operator: !=
                            boolean tmp92 = ( tmp90.getIntValue() != 0 );
                            if ( tmp92 ) {
                                { // Invoke: append printed $d2
                                    TclObject[] objv93 = TJC.grabObjv(interp, 1);
                                    TclObject tmp94;
                                    try {
                                        // Arg 2 variable: $d2
                                        tmp94 = getVarScalar(interp, "d2", compiledLocals, 12);
                                        tmp94.preserve();
                                        objv93[0] = tmp94;
                                        interp.resetResult();
                                        appendVarScalar(interp, "printed", objv93, compiledLocals, 6);
                                    } finally {
                                        TJC.releaseObjvElems(interp, objv93, 1);
                                    }
                                } // End Invoke: append
                            }
                        } // End Invoke: if
                        { // Invoke: set d3 [...]
                            TclObject tmp95;
                            { // Invoke: string index $epart 3
                                TclObject tmp96 = getVarScalar(interp, "epart", compiledLocals, 9);
                                String tmp97 = tmp96.toString();
                                TclObject tmp98 = TJC.stringIndex(interp, tmp97, const15);
                                interp.setResult(tmp98);
                            } // End Invoke: string
                            tmp95 = interp.getResult();
                            setVarScalar(interp, "d3", tmp95, compiledLocals, 13);
                        } // End Invoke: set
                        { // Invoke: append printed $d3
                            TclObject[] objv99 = TJC.grabObjv(interp, 1);
                            TclObject tmp100;
                            try {
                                // Arg 2 variable: $d3
                                tmp100 = getVarScalar(interp, "d3", compiledLocals, 13);
                                tmp100.preserve();
                                objv99[0] = tmp100;
                                interp.resetResult();
                                appendVarScalar(interp, "printed", objv99, compiledLocals, 6);
                            } finally {
                                TJC.releaseObjvElems(interp, objv99, 1);
                            }
                        } // End Invoke: append
                    }
                } // End Invoke: if
            }
        } // End Invoke: if
        { // Invoke: return [...]
            { // Invoke: list $matching_strrep $parsed $printed
                TclObject tmp101 = TclList.newInstance();
                TclObject tmp102;
                try {
                    tmp102 = getVarScalar(interp, "matching_strrep", compiledLocals, 4);
                    TclList.append(interp, tmp101, tmp102);
                    tmp102 = getVarScalar(interp, "parsed", compiledLocals, 3);
                    TclList.append(interp, tmp101, tmp102);
                    tmp102 = getVarScalar(interp, "printed", compiledLocals, 6);
                    TclList.append(interp, tmp101, tmp102);
                } catch (TclException ex) {
                    tmp101.release();
                    throw ex;
                }
                interp.setResult(tmp101);
            } // End Invoke: list
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_parse_value");
        } finally {
            TJC.exprReleaseValue(interp, evs2);
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("compileproc_string_is_java_integer");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("compileproc_string_is_java_double");
        const1.preserve(); const1.preserve();
        const2 = TclInteger.newInstance(0);
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("error");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("format");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("%g");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("regexp");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("^([0-9|.]+)e([\\+|\\-][0-9][0-9][0-9])$");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("whole");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("npart");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("epart");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("e");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("-");
        const12.preserve(); const12.preserve();
        const13 = TclInteger.newInstance(1);
        const13.preserve(); const13.preserve();
        const14 = TclInteger.newInstance(2);
        const14.preserve(); const14.preserve();
        const15 = TclInteger.newInstance(3);
        const15.preserve(); const15.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "compileproc_string_is_java_integer";
                break;
            }
            case 2: {
                cmdName = "compileproc_string_is_java_double";
                break;
            }
            case 3: {
                cmdName = "error";
                break;
            }
            case 4: {
                cmdName = "format";
                break;
            }
            case 5: {
                cmdName = "regexp";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "value",
        "is_integer",
        "is_double",
        "parsed",
        "matching_strrep",
        "compare",
        "printed",
        "estr",
        "npart",
        "epart",
        "sign",
        "d1",
        "d2",
        "d3"
    };
} // end class CompileprocParseValueCmd

