// TJC implementation of procedure _compileproc_scan_word_iterate
package tjc;
import tcl.lang.*;

public class CompileprocScanWordIterateCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 14, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 6) {
            throw new TclNumArgsException(interp, 1, objv, "script stree type values ranges");
        }
        setVarScalar(interp, "script", objv[1], compiledLocals, 0);
        setVarScalar(interp, "stree", objv[2], compiledLocals, 1);
        setVarScalar(interp, "type", objv[3], compiledLocals, 2);
        setVarScalar(interp, "values", objv[4], compiledLocals, 3);
        setVarScalar(interp, "ranges", objv[5], compiledLocals, 4);
        { // Invoke: global _compileproc
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 5);
        } // End Invoke: global
        { // Invoke: upvar #0 ... results
            TclObject[] objv0 = TJC.grabObjv(interp, 4);
            try {
                // Arg 0 constant: upvar
                objv0[0] = const0;
                // Arg 1 constant: #0
                objv0[1] = const1;
                // Arg 2 constant: ...
                objv0[2] = const2;
                // Arg 3 constant: results
                objv0[3] = const3;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                    ? cmdcache1.cmd : null), objv0, 0);
                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                    updateCmdCache(interp, 1);
                }
            } finally {
                TJC.releaseObjv(interp, objv0, 4);
            }
        } // End Invoke: upvar
        { // Invoke: set key $...
            TclObject tmp1;
            tmp1 = getVarArray(interp, "_compileproc", "word_scan_key", compiledLocals, 5);
            setVarScalar(interp, "key", tmp1, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: switch -exact -- $type {backslash} ... {command} ... {text} ... {variable} ... {word begin} ... {word end} ... {word} ... default ...
            TclObject tmp2 = getVarScalar(interp, "type", compiledLocals, 2);
            String tmp3 = tmp2.toString();
            int tmp3_length = tmp3.length();
            char tmp3_first = '\n';
            if ( tmp3_length > 0 ) {
                tmp3_first = tmp3.charAt(0);
            }
            interp.resetResult();
            if ( tmp3_length == 9 && tmp3_first == 'b'
                    && tmp3.compareTo("backslash") == 0 ) {
                // Pattern {backslash}
                { // Invoke: set elem "..."
                    TclObject tmp4;
                    StringBuffer sbtmp5 = new StringBuffer(64);
                    sbtmp5.append("\\");
                    { // Invoke: lindex $values 0
                        TclObject tmp6 = getVarScalar(interp, "values", compiledLocals, 3);
                        tmp6 = TclList.index(interp, tmp6, 0);
                        if ( tmp6 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp6);
                        }
                    } // End Invoke: lindex
                    tmp4 = interp.getResult();
                    sbtmp5.append(tmp4.toString());
                    tmp4 = TclString.newInstance(sbtmp5);
                    setVarScalar(interp, "elem", tmp4, compiledLocals, 7);
                } // End Invoke: set
                { // Invoke: set jelem [...]
                    TclObject tmp7;
                    { // Invoke: ... $elem
                        TclObject[] objv8 = TJC.grabObjv(interp, 2);
                        TclObject tmp9;
                        try {
                            // Arg 0 constant: ...
                            objv8[0] = const4;
                            // Arg 1 variable: $elem
                            tmp9 = getVarScalar(interp, "elem", compiledLocals, 7);
                            tmp9.preserve();
                            objv8[1] = tmp9;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv8, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp9 = objv8[1];
                            if ( tmp9 != null ) {
                                tmp9.release();
                            }
                            TJC.releaseObjv(interp, objv8, 2);
                        }
                    } // End Invoke: ...
                    tmp7 = interp.getResult();
                    setVarScalar(interp, "jelem", tmp7, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: set word [...]
                    TclObject tmp10;
                    { // Invoke: ...
                        TclObject[] objv11 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: ...
                            objv11[0] = const5;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv11, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv11, 1);
                        }
                    } // End Invoke: ...
                    tmp10 = interp.getResult();
                    setVarScalar(interp, "word", tmp10, compiledLocals, 9);
                } // End Invoke: set
                { // Invoke: lappend word [...]
                    TclObject[] objv12 = TJC.grabObjv(interp, 1);
                    TclObject tmp13;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: list {text} $jelem
                            TclObject tmp14 = TclList.newInstance();
                            TclObject tmp15;
                            try {
                                TclList.append(interp, tmp14, const6);
                                tmp15 = getVarScalar(interp, "jelem", compiledLocals, 8);
                                TclList.append(interp, tmp14, tmp15);
                            } catch (TclException ex) {
                                tmp14.release();
                                throw ex;
                            }
                            interp.setResult(tmp14);
                        } // End Invoke: list
                        tmp13 = interp.getResult();
                        tmp13.preserve();
                        objv12[0] = tmp13;
                        interp.resetResult();
                        lappendVarScalar(interp, "word", objv12, compiledLocals, 9);
                    } finally {
                        TJC.releaseObjvElems(interp, objv12, 1);
                    }
                } // End Invoke: lappend
                { // Invoke: ... $word
                    TclObject[] objv16 = TJC.grabObjv(interp, 2);
                    TclObject tmp17;
                    try {
                        // Arg 0 constant: ...
                        objv16[0] = const5;
                        // Arg 1 variable: $word
                        tmp17 = getVarScalar(interp, "word", compiledLocals, 9);
                        tmp17.preserve();
                        objv16[1] = tmp17;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv16, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        tmp17 = objv16[1];
                        if ( tmp17 != null ) {
                            tmp17.release();
                        }
                        TJC.releaseObjv(interp, objv16, 2);
                    }
                } // End Invoke: ...
            } else if ( tmp3_length == 7 && tmp3_first == 'c'
                    && tmp3.compareTo("command") == 0 ) {
                // Pattern {command}
                { // Invoke: set ckeys [...]
                    TclObject tmp18;
                    { // Invoke: ... $key
                        TclObject[] objv19 = TJC.grabObjv(interp, 2);
                        TclObject tmp20;
                        try {
                            // Arg 0 constant: ...
                            objv19[0] = const7;
                            // Arg 1 variable: $key
                            tmp20 = getVarScalar(interp, "key", compiledLocals, 6);
                            tmp20.preserve();
                            objv19[1] = tmp20;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                ? cmdcache4.cmd : null), objv19, 0);
                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                updateCmdCache(interp, 4);
                            }
                        } finally {
                            tmp20 = objv19[1];
                            if ( tmp20 != null ) {
                                tmp20.release();
                            }
                            TJC.releaseObjv(interp, objv19, 2);
                        }
                    } // End Invoke: ...
                    tmp18 = interp.getResult();
                    setVarScalar(interp, "ckeys", tmp18, compiledLocals, 10);
                } // End Invoke: set
                { // Invoke: if ... ... else ...
                    { // Invoke: ... $ckeys
                        TclObject[] objv21 = TJC.grabObjv(interp, 2);
                        TclObject tmp22;
                        try {
                            // Arg 0 constant: ...
                            objv21[0] = const8;
                            // Arg 1 variable: $ckeys
                            tmp22 = getVarScalar(interp, "ckeys", compiledLocals, 10);
                            tmp22.preserve();
                            objv21[1] = tmp22;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                ? cmdcache5.cmd : null), objv21, 0);
                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                updateCmdCache(interp, 5);
                            }
                        } finally {
                            tmp22 = objv21[1];
                            if ( tmp22 != null ) {
                                tmp22.release();
                            }
                            TJC.releaseObjv(interp, objv21, 2);
                        }
                    } // End Invoke: ...
                    TclObject tmp23 = interp.getResult();
                    ExprValue tmp24 = evs0;
                    TJC.exprInitValue(interp, tmp24, tmp23);
                    boolean tmp25 = tmp24.getBooleanValue(interp);
                    if ( tmp25 ) {
                        { // Invoke: set ckeys {}
                            setVarScalar(interp, "ckeys", const9, compiledLocals, 10);
                        } // End Invoke: set
                        { // Invoke: ... {}
                            TclObject[] objv26 = TJC.grabObjv(interp, 2);
                            try {
                                // Arg 0 constant: ...
                                objv26[0] = const10;
                                // Arg 1 constant: {}
                                objv26[1] = const9;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                    ? cmdcache6.cmd : null), objv26, 0);
                                if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                    updateCmdCache(interp, 6);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv26, 2);
                            }
                        } // End Invoke: ...
                    } else {
                        { // Invoke: ... $ckeys
                            TclObject[] objv27 = TJC.grabObjv(interp, 2);
                            TclObject tmp28;
                            try {
                                // Arg 0 constant: ...
                                objv27[0] = const11;
                                // Arg 1 variable: $ckeys
                                tmp28 = getVarScalar(interp, "ckeys", compiledLocals, 10);
                                tmp28.preserve();
                                objv27[1] = tmp28;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                    ? cmdcache7.cmd : null), objv27, 0);
                                if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                    updateCmdCache(interp, 7);
                                }
                            } finally {
                                tmp28 = objv27[1];
                                if ( tmp28 != null ) {
                                    tmp28.release();
                                }
                                TJC.releaseObjv(interp, objv27, 2);
                            }
                        } // End Invoke: ...
                    }
                } // End Invoke: if
                { // Invoke: set word [...]
                    TclObject tmp29;
                    { // Invoke: ...
                        TclObject[] objv30 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: ...
                            objv30[0] = const5;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv30, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv30, 1);
                        }
                    } // End Invoke: ...
                    tmp29 = interp.getResult();
                    setVarScalar(interp, "word", tmp29, compiledLocals, 9);
                } // End Invoke: set
                { // Invoke: lappend word [...]
                    TclObject[] objv31 = TJC.grabObjv(interp, 1);
                    TclObject tmp32;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: list $type $ckeys
                            TclObject tmp33 = TclList.newInstance();
                            TclObject tmp34;
                            try {
                                tmp34 = getVarScalar(interp, "type", compiledLocals, 2);
                                TclList.append(interp, tmp33, tmp34);
                                tmp34 = getVarScalar(interp, "ckeys", compiledLocals, 10);
                                TclList.append(interp, tmp33, tmp34);
                            } catch (TclException ex) {
                                tmp33.release();
                                throw ex;
                            }
                            interp.setResult(tmp33);
                        } // End Invoke: list
                        tmp32 = interp.getResult();
                        tmp32.preserve();
                        objv31[0] = tmp32;
                        interp.resetResult();
                        lappendVarScalar(interp, "word", objv31, compiledLocals, 9);
                    } finally {
                        TJC.releaseObjvElems(interp, objv31, 1);
                    }
                } // End Invoke: lappend
                { // Invoke: ... $word
                    TclObject[] objv35 = TJC.grabObjv(interp, 2);
                    TclObject tmp36;
                    try {
                        // Arg 0 constant: ...
                        objv35[0] = const5;
                        // Arg 1 variable: $word
                        tmp36 = getVarScalar(interp, "word", compiledLocals, 9);
                        tmp36.preserve();
                        objv35[1] = tmp36;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv35, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        tmp36 = objv35[1];
                        if ( tmp36 != null ) {
                            tmp36.release();
                        }
                        TJC.releaseObjv(interp, objv35, 2);
                    }
                } // End Invoke: ...
            } else if ( tmp3_length == 4 && tmp3_first == 't'
                    && tmp3.compareTo("text") == 0 ) {
                // Pattern {text}
                { // Invoke: set word [...]
                    TclObject tmp37;
                    { // Invoke: ...
                        TclObject[] objv38 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: ...
                            objv38[0] = const5;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv38, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv38, 1);
                        }
                    } // End Invoke: ...
                    tmp37 = interp.getResult();
                    setVarScalar(interp, "word", tmp37, compiledLocals, 9);
                } // End Invoke: set
                { // Invoke: lappend word [...]
                    TclObject[] objv39 = TJC.grabObjv(interp, 1);
                    TclObject tmp40;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: list $type [...]
                            TclObject tmp41 = TclList.newInstance();
                            TclObject tmp42;
                            try {
                                tmp42 = getVarScalar(interp, "type", compiledLocals, 2);
                                TclList.append(interp, tmp41, tmp42);
                                { // Invoke: lindex $values 0
                                    TclObject tmp43 = getVarScalar(interp, "values", compiledLocals, 3);
                                    tmp43 = TclList.index(interp, tmp43, 0);
                                    if ( tmp43 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp43);
                                    }
                                } // End Invoke: lindex
                                tmp42 = interp.getResult();
                                TclList.append(interp, tmp41, tmp42);
                            } catch (TclException ex) {
                                tmp41.release();
                                throw ex;
                            }
                            interp.setResult(tmp41);
                        } // End Invoke: list
                        tmp40 = interp.getResult();
                        tmp40.preserve();
                        objv39[0] = tmp40;
                        interp.resetResult();
                        lappendVarScalar(interp, "word", objv39, compiledLocals, 9);
                    } finally {
                        TJC.releaseObjvElems(interp, objv39, 1);
                    }
                } // End Invoke: lappend
                { // Invoke: ... $word
                    TclObject[] objv44 = TJC.grabObjv(interp, 2);
                    TclObject tmp45;
                    try {
                        // Arg 0 constant: ...
                        objv44[0] = const5;
                        // Arg 1 variable: $word
                        tmp45 = getVarScalar(interp, "word", compiledLocals, 9);
                        tmp45.preserve();
                        objv44[1] = tmp45;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv44, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        tmp45 = objv44[1];
                        if ( tmp45 != null ) {
                            tmp45.release();
                        }
                        TJC.releaseObjv(interp, objv44, 2);
                    }
                } // End Invoke: ...
            } else if ( tmp3_length == 8 && tmp3_first == 'v'
                    && tmp3.compareTo("variable") == 0 ) {
                // Pattern {variable}
                { // Invoke: set vstree $stree
                    TclObject tmp46;
                    tmp46 = getVarScalar(interp, "stree", compiledLocals, 1);
                    setVarScalar(interp, "vstree", tmp46, compiledLocals, 11);
                } // End Invoke: set
                { // Invoke: set vinfo [...]
                    TclObject tmp47;
                    { // Invoke: ... $key $script $vstree
                        TclObject[] objv48 = TJC.grabObjv(interp, 4);
                        TclObject tmp49;
                        try {
                            // Arg 0 constant: ...
                            objv48[0] = const12;
                            // Arg 1 variable: $key
                            tmp49 = getVarScalar(interp, "key", compiledLocals, 6);
                            tmp49.preserve();
                            objv48[1] = tmp49;
                            // Arg 2 variable: $script
                            tmp49 = getVarScalar(interp, "script", compiledLocals, 0);
                            tmp49.preserve();
                            objv48[2] = tmp49;
                            // Arg 3 variable: $vstree
                            tmp49 = getVarScalar(interp, "vstree", compiledLocals, 11);
                            tmp49.preserve();
                            objv48[3] = tmp49;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                ? cmdcache8.cmd : null), objv48, 0);
                            if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                updateCmdCache(interp, 8);
                            }
                        } finally {
                            tmp49 = objv48[1];
                            if ( tmp49 != null ) {
                                tmp49.release();
                            }
                            tmp49 = objv48[2];
                            if ( tmp49 != null ) {
                                tmp49.release();
                            }
                            tmp49 = objv48[3];
                            if ( tmp49 != null ) {
                                tmp49.release();
                            }
                            TJC.releaseObjv(interp, objv48, 4);
                        }
                    } // End Invoke: ...
                    tmp47 = interp.getResult();
                    setVarScalar(interp, "vinfo", tmp47, compiledLocals, 12);
                } // End Invoke: set
                { // Invoke: set word [...]
                    TclObject tmp50;
                    { // Invoke: ...
                        TclObject[] objv51 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: ...
                            objv51[0] = const5;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv51, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv51, 1);
                        }
                    } // End Invoke: ...
                    tmp50 = interp.getResult();
                    setVarScalar(interp, "word", tmp50, compiledLocals, 9);
                } // End Invoke: set
                { // Invoke: lappend word [...]
                    TclObject[] objv52 = TJC.grabObjv(interp, 1);
                    TclObject tmp53;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: list $type $vinfo
                            TclObject tmp54 = TclList.newInstance();
                            TclObject tmp55;
                            try {
                                tmp55 = getVarScalar(interp, "type", compiledLocals, 2);
                                TclList.append(interp, tmp54, tmp55);
                                tmp55 = getVarScalar(interp, "vinfo", compiledLocals, 12);
                                TclList.append(interp, tmp54, tmp55);
                            } catch (TclException ex) {
                                tmp54.release();
                                throw ex;
                            }
                            interp.setResult(tmp54);
                        } // End Invoke: list
                        tmp53 = interp.getResult();
                        tmp53.preserve();
                        objv52[0] = tmp53;
                        interp.resetResult();
                        lappendVarScalar(interp, "word", objv52, compiledLocals, 9);
                    } finally {
                        TJC.releaseObjvElems(interp, objv52, 1);
                    }
                } // End Invoke: lappend
                { // Invoke: ... $word
                    TclObject[] objv56 = TJC.grabObjv(interp, 2);
                    TclObject tmp57;
                    try {
                        // Arg 0 constant: ...
                        objv56[0] = const5;
                        // Arg 1 variable: $word
                        tmp57 = getVarScalar(interp, "word", compiledLocals, 9);
                        tmp57.preserve();
                        objv56[1] = tmp57;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv56, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        tmp57 = objv56[1];
                        if ( tmp57 != null ) {
                            tmp57.release();
                        }
                        TJC.releaseObjv(interp, objv56, 2);
                    }
                } // End Invoke: ...
            } else if ( tmp3_length == 10 && tmp3_first == 'w'
                    && tmp3.compareTo("word begin") == 0 ) {
                // Pattern {word begin}
            } else if ( tmp3_length == 8 && tmp3_first == 'w'
                    && tmp3.compareTo("word end") == 0 ) {
                // Pattern {word end}
            } else if ( tmp3_length == 4 && tmp3_first == 'w'
                    && tmp3.compareTo("word") == 0 ) {
                // Pattern {word}
                { // Invoke: set results $values
                    TclObject tmp58;
                    tmp58 = getVarScalar(interp, "values", compiledLocals, 3);
                    tmp58 = setVarScalar(interp, "results", tmp58, compiledLocals, 13);
                    interp.setResult(tmp58);
                } // End Invoke: set
            } else {
                // Pattern default
                { // Invoke: error "..."
                    TclObject[] objv59 = TJC.grabObjv(interp, 2);
                    TclObject tmp60;
                    try {
                        // Arg 0 constant: error
                        objv59[0] = const13;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp61 = new StringBuffer(64);
                        sbtmp61.append("unknown type ");
                        sbtmp61.append("\"");
                        tmp60 = getVarScalar(interp, "type", compiledLocals, 2);
                        sbtmp61.append(tmp60.toString());
                        sbtmp61.append("\"");
                        tmp60 = TclString.newInstance(sbtmp61);
                        tmp60.preserve();
                        objv59[1] = tmp60;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                            ? cmdcache9.cmd : null), objv59, 0);
                        if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                            updateCmdCache(interp, 9);
                        }
                    } finally {
                        tmp60 = objv59[1];
                        if ( tmp60 != null ) {
                            tmp60.release();
                        }
                        TJC.releaseObjv(interp, objv59, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: switch
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "_compileproc_scan_word_iterate");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("upvar");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("#0");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("_compileproc(word_scan_results)");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("results");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("emitter_backslash_tcl_elem");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("parse_word_iterate_word_value");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("text");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("compileproc_childkey_next");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("compileproc_is_empty_command");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("compileproc_constant_cache_add");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("compileproc_scan_keys");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("compileproc_scan_variable");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("error");
        const13.preserve(); const13.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;
    WrappedCommand cmdcache9;
    int cmdcache9_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                cmdcache9 = TJC.INVALID_COMMAND_CACHE;
                cmdcache9_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "upvar";
                break;
            }
            case 2: {
                cmdName = "emitter_backslash_tcl_elem";
                break;
            }
            case 3: {
                cmdName = "parse_word_iterate_word_value";
                break;
            }
            case 4: {
                cmdName = "compileproc_childkey_next";
                break;
            }
            case 5: {
                cmdName = "compileproc_is_empty_command";
                break;
            }
            case 6: {
                cmdName = "compileproc_constant_cache_add";
                break;
            }
            case 7: {
                cmdName = "compileproc_scan_keys";
                break;
            }
            case 8: {
                cmdName = "compileproc_scan_variable";
                break;
            }
            case 9: {
                cmdName = "error";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
            case 9: {
                cmdcache9 = lwcmd;
                cmdcache9_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "script",
        "stree",
        "type",
        "values",
        "ranges",
        "_compileproc",
        "key",
        "elem",
        "jelem",
        "word",
        "ckeys",
        "vstree",
        "vinfo",
        "results"
    };
} // end class CompileprocScanWordIterateCmd

