// TJC implementation of procedure compileproc_script_to_proc_list
package tjc;
import tcl.lang.*;

public class CompileprocScriptToProcListCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 2, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "script");
        }
        setVarScalar(interp, "script", objv[1], compiledLocals, 0);
        { // Invoke: set len [...]
            TclObject tmp0;
            { // Invoke: llength $script
                TclObject tmp1 = getVarScalar(interp, "script", compiledLocals, 0);
                int tmp2 = TclList.getLength(interp, tmp1);
                interp.setResult(tmp2);
            } // End Invoke: llength
            tmp0 = interp.getResult();
            setVarScalar(interp, "len", tmp0, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: if {$len != 4} ...
            // Binary operator: $len != 4
            TclObject tmp3 = getVarScalar(interp, "len", compiledLocals, 1);
            ExprValue tmp4 = evs0;
            TJC.exprInitValue(interp, tmp4, tmp3);
            ExprValue tmp5 = evs1;
            tmp5.setIntValue(4);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp4, tmp5);
            // End Binary operator: !=
            boolean tmp6 = ( tmp4.getIntValue() != 0 );
            if ( tmp6 ) {
                { // Invoke: error "..."
                    TclObject[] objv7 = TJC.grabObjv(interp, 2);
                    TclObject tmp8;
                    try {
                        // Arg 0 constant: error
                        objv7[0] = const0;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp9 = new StringBuffer(64);
                        sbtmp9.append("expected proc name args body: got ");
                        tmp8 = getVarScalar(interp, "len", compiledLocals, 1);
                        sbtmp9.append(tmp8.toString());
                        sbtmp9.append(" args");
                        tmp8 = TclString.newInstance(sbtmp9);
                        tmp8.preserve();
                        objv7[1] = tmp8;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv7, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp8 = objv7[1];
                        if ( tmp8 != null ) {
                            tmp8.release();
                        }
                        TJC.releaseObjv(interp, objv7, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            // Binary operator: [...] != "proc"
            { // Invoke: lindex $script 0
                TclObject tmp10 = getVarScalar(interp, "script", compiledLocals, 0);
                tmp10 = TclList.index(interp, tmp10, 0);
                if ( tmp10 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp10);
                }
            } // End Invoke: lindex
            TclObject tmp11 = interp.getResult();
            boolean tmp12 = ! tmp11.toString().equals("proc");
            ExprValue tmp13 = evs0;
            tmp13.setIntValue(tmp12);
            // End Binary operator: !=
            boolean tmp14 = ( tmp13.getIntValue() != 0 );
            if ( tmp14 ) {
                { // Invoke: error "..."
                    TclObject[] objv15 = TJC.grabObjv(interp, 2);
                    TclObject tmp16;
                    try {
                        // Arg 0 constant: error
                        objv15[0] = const0;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp17 = new StringBuffer(64);
                        sbtmp17.append("expected proc at index 0, got ");
                        sbtmp17.append("\"");
                        { // Invoke: lindex $script 0
                            TclObject tmp18 = getVarScalar(interp, "script", compiledLocals, 0);
                            tmp18 = TclList.index(interp, tmp18, 0);
                            if ( tmp18 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp18);
                            }
                        } // End Invoke: lindex
                        tmp16 = interp.getResult();
                        sbtmp17.append(tmp16.toString());
                        sbtmp17.append("\"");
                        tmp16 = TclString.newInstance(sbtmp17);
                        tmp16.preserve();
                        objv15[1] = tmp16;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv15, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp16 = objv15[1];
                        if ( tmp16 != null ) {
                            tmp16.release();
                        }
                        TJC.releaseObjv(interp, objv15, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: return [...]
            { // Invoke: lrange $script 1 end
                TclObject[] objv19 = TJC.grabObjv(interp, 4);
                TclObject tmp20;
                try {
                    // Arg 0 constant: lrange
                    objv19[0] = const1;
                    // Arg 1 variable: $script
                    tmp20 = getVarScalar(interp, "script", compiledLocals, 0);
                    tmp20.preserve();
                    objv19[1] = tmp20;
                    // Arg 2 constant: 1
                    objv19[2] = const2;
                    // Arg 3 constant: end
                    objv19[3] = const3;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv19, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp20 = objv19[1];
                    if ( tmp20 != null ) {
                        tmp20.release();
                    }
                    TJC.releaseObjv(interp, objv19, 4);
                }
            } // End Invoke: lrange
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_script_to_proc_list");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("error");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("lrange");
        const1.preserve(); const1.preserve();
        const2 = TclInteger.newInstance(1);
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("end");
        const3.preserve(); const3.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "error";
                break;
            }
            case 2: {
                cmdName = "lrange";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "script",
        "len"
    };
} // end class CompileprocScriptToProcListCmd

