// TJC implementation of procedure compileproc_start
package tjc;
import tcl.lang.*;

public class CompileprocStartCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 5, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "proc_list");
        }
        setVarScalar(interp, "proc_list", objv[1], compiledLocals, 0);
        { // Invoke: global _compileproc
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 1);
        } // End Invoke: global
        { // Invoke: if ... ...
            // Binary operator: [...] != 3
            { // Invoke: llength $proc_list
                TclObject tmp0 = getVarScalar(interp, "proc_list", compiledLocals, 0);
                int tmp1 = TclList.getLength(interp, tmp0);
                interp.setResult(tmp1);
            } // End Invoke: llength
            TclObject tmp2 = interp.getResult();
            ExprValue tmp3 = evs0;
            TJC.exprInitValue(interp, tmp3, tmp2);
            ExprValue tmp4 = evs1;
            tmp4.setIntValue(3);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp3, tmp4);
            // End Binary operator: !=
            boolean tmp5 = ( tmp3.getIntValue() != 0 );
            if ( tmp5 ) {
                { // Invoke: error "..."
                    TclObject[] objv6 = TJC.grabObjv(interp, 2);
                    TclObject tmp7;
                    try {
                        // Arg 0 constant: error
                        objv6[0] = const0;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp8 = new StringBuffer(64);
                        sbtmp8.append("expected ");
                        sbtmp8.append("{");
                        sbtmp8.append("PROC_NAME PROC_ARGS PROC_BODY");
                        sbtmp8.append("}");
                        sbtmp8.append(" : passed ");
                        { // Invoke: llength $proc_list
                            TclObject tmp9 = getVarScalar(interp, "proc_list", compiledLocals, 0);
                            int tmp10 = TclList.getLength(interp, tmp9);
                            interp.setResult(tmp10);
                        } // End Invoke: llength
                        tmp7 = interp.getResult();
                        sbtmp8.append(tmp7.toString());
                        sbtmp8.append(" args");
                        tmp7 = TclString.newInstance(sbtmp8);
                        tmp7.preserve();
                        objv6[1] = tmp7;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv6, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp7 = objv6[1];
                        if ( tmp7 != null ) {
                            tmp7.release();
                        }
                        TJC.releaseObjv(interp, objv6, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set name [...]
            TclObject tmp11;
            { // Invoke: lindex $proc_list 0
                TclObject tmp12 = getVarScalar(interp, "proc_list", compiledLocals, 0);
                tmp12 = TclList.index(interp, tmp12, 0);
                if ( tmp12 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp12);
                }
            } // End Invoke: lindex
            tmp11 = interp.getResult();
            setVarScalar(interp, "name", tmp11, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set args [...]
            TclObject tmp13;
            { // Invoke: lindex $proc_list 1
                TclObject tmp14 = getVarScalar(interp, "proc_list", compiledLocals, 0);
                tmp14 = TclList.index(interp, tmp14, 1);
                if ( tmp14 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp14);
                }
            } // End Invoke: lindex
            tmp13 = interp.getResult();
            setVarScalar(interp, "args", tmp13, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set body [...]
            TclObject tmp15;
            { // Invoke: lindex $proc_list 2
                TclObject tmp16 = getVarScalar(interp, "proc_list", compiledLocals, 0);
                tmp16 = TclList.index(interp, tmp16, 2);
                if ( tmp16 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp16);
                }
            } // End Invoke: lindex
            tmp15 = interp.getResult();
            setVarScalar(interp, "body", tmp15, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set _compileproc(name) $name
            TclObject tmp17;
            tmp17 = getVarScalar(interp, "name", compiledLocals, 2);
            setVarArray(interp, "_compileproc", "name", tmp17, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: set _compileproc(args) $args
            TclObject tmp18;
            tmp18 = getVarScalar(interp, "args", compiledLocals, 3);
            setVarArray(interp, "_compileproc", "args", tmp18, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: set _compileproc(body) $body
            TclObject tmp19;
            tmp19 = getVarScalar(interp, "body", compiledLocals, 4);
            setVarArray(interp, "_compileproc", "body", tmp19, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: set _compileproc(keys) [...]
            TclObject tmp20;
            { // Invoke: list
                TclObject tmp21 = TclList.newInstance();
                interp.setResult(tmp21);
            } // End Invoke: list
            tmp20 = interp.getResult();
            setVarArray(interp, "_compileproc", "keys", tmp20, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: ... ... start
            TclObject[] objv22 = TJC.grabObjv(interp, 3);
            try {
                // Arg 0 constant: ...
                objv22[0] = const1;
                // Arg 1 constant: ...
                objv22[1] = const2;
                // Arg 2 constant: start
                objv22[2] = const3;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                    ? cmdcache2.cmd : null), objv22, 0);
                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                    updateCmdCache(interp, 2);
                }
            } finally {
                TJC.releaseObjv(interp, objv22, 3);
            }
        } // End Invoke: ...
        { // Invoke: ... ... finish
            TclObject[] objv23 = TJC.grabObjv(interp, 3);
            try {
                // Arg 0 constant: ...
                objv23[0] = const1;
                // Arg 1 constant: ...
                objv23[1] = const4;
                // Arg 2 constant: finish
                objv23[2] = const5;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                    ? cmdcache2.cmd : null), objv23, 0);
                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                    updateCmdCache(interp, 2);
                }
            } finally {
                TJC.releaseObjv(interp, objv23, 3);
            }
        } // End Invoke: ...
        { // Invoke: return [...]
            { // Invoke: descend_start $body
                TclObject[] objv24 = TJC.grabObjv(interp, 2);
                TclObject tmp25;
                try {
                    // Arg 0 constant: descend_start
                    objv24[0] = const6;
                    // Arg 1 variable: $body
                    tmp25 = getVarScalar(interp, "body", compiledLocals, 4);
                    tmp25.preserve();
                    objv24[1] = tmp25;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv24, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp25 = objv24[1];
                    if ( tmp25 != null ) {
                        tmp25.release();
                    }
                    TJC.releaseObjv(interp, objv24, 2);
                }
            } // End Invoke: descend_start
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_start");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("error");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("descend_report_command_callback");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("compileproc_command_start_callback");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("start");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("compileproc_command_finish_callback");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("finish");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("descend_start");
        const6.preserve(); const6.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "error";
                break;
            }
            case 2: {
                cmdName = "descend_report_command_callback";
                break;
            }
            case 3: {
                cmdName = "descend_start";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "proc_list",
        "_compileproc",
        "name",
        "args",
        "body"
    };
} // end class CompileprocStartCmd

