// TJC implementation of procedure descend_container_body_argument
package tjc;
import tcl.lang.*;

public class DescendContainerBodyArgumentCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 14, compiledLocalsNames);
        try {
        if (objv.length < 5 || objv.length > 6) {
            throw new TclNumArgsException(interp, 1, objv, "key script tree body_index ?undetermined?");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        setVarScalar(interp, "script", objv[2], compiledLocals, 1);
        setVarScalar(interp, "tree", objv[3], compiledLocals, 2);
        setVarScalar(interp, "body_index", objv[4], compiledLocals, 3);
        setVarScalar(interp, "undetermined", 
            ((objv.length <= 5) ? const0 : objv[5]), compiledLocals, 4);
        { // Invoke: set nested [...]
            TclObject tmp0;
            { // Invoke: descend_get_data $key nested
                TclObject[] objv1 = TJC.grabObjv(interp, 3);
                TclObject tmp2;
                try {
                    // Arg 0 constant: descend_get_data
                    objv1[0] = const1;
                    // Arg 1 variable: $key
                    tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    // Arg 2 constant: nested
                    objv1[2] = const2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 3);
                }
            } // End Invoke: descend_get_data
            tmp0 = interp.getResult();
            setVarScalar(interp, "nested", tmp0, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set body_subtree [...]
            TclObject tmp3;
            { // Invoke: lindex $tree $body_index
                TclObject tmp4 = null;
                TclObject tmp5;
                try {
                    tmp4 = getVarScalar(interp, "tree", compiledLocals, 2);
                    tmp4.preserve();
                    tmp5 = getVarScalar(interp, "body_index", compiledLocals, 3);
                    TJC.lindexNonconst(interp, tmp4, tmp5);
                } finally {
                    if ( tmp4 != null ) {
                        tmp4.release();
                    }
                }
            } // End Invoke: lindex
            tmp3 = interp.getResult();
            setVarScalar(interp, "body_subtree", tmp3, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set body_range [...]
            TclObject tmp6;
            { // Invoke: lindex $body_subtree 1
                TclObject tmp7 = getVarScalar(interp, "body_subtree", compiledLocals, 6);
                tmp7 = TclList.index(interp, tmp7, 1);
                if ( tmp7 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp7);
                }
            } // End Invoke: lindex
            tmp6 = interp.getResult();
            setVarScalar(interp, "body_range", tmp6, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: set body_text [...]
            TclObject tmp8;
            { // Invoke: parse getstring $script $body_range
                TclObject[] objv9 = TJC.grabObjv(interp, 4);
                TclObject tmp10;
                try {
                    // Arg 0 constant: parse
                    objv9[0] = const3;
                    // Arg 1 constant: getstring
                    objv9[1] = const4;
                    // Arg 2 variable: $script
                    tmp10 = getVarScalar(interp, "script", compiledLocals, 1);
                    tmp10.preserve();
                    objv9[2] = tmp10;
                    // Arg 3 variable: $body_range
                    tmp10 = getVarScalar(interp, "body_range", compiledLocals, 7);
                    tmp10.preserve();
                    objv9[3] = tmp10;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv9, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp10 = objv9[2];
                    if ( tmp10 != null ) {
                        tmp10.release();
                    }
                    tmp10 = objv9[3];
                    if ( tmp10 != null ) {
                        tmp10.release();
                    }
                    TJC.releaseObjv(interp, objv9, 4);
                }
            } // End Invoke: parse
            tmp8 = interp.getResult();
            setVarScalar(interp, "body_text", tmp8, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: set result [...]
            TclObject tmp11;
            { // Invoke: descend_range_quoted $script $body_subtree $body_range
                TclObject[] objv12 = TJC.grabObjv(interp, 4);
                TclObject tmp13;
                try {
                    // Arg 0 constant: descend_range_quoted
                    objv12[0] = const5;
                    // Arg 1 variable: $script
                    tmp13 = getVarScalar(interp, "script", compiledLocals, 1);
                    tmp13.preserve();
                    objv12[1] = tmp13;
                    // Arg 2 variable: $body_subtree
                    tmp13 = getVarScalar(interp, "body_subtree", compiledLocals, 6);
                    tmp13.preserve();
                    objv12[2] = tmp13;
                    // Arg 3 variable: $body_range
                    tmp13 = getVarScalar(interp, "body_range", compiledLocals, 7);
                    tmp13.preserve();
                    objv12[3] = tmp13;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv12, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp13 = objv12[1];
                    if ( tmp13 != null ) {
                        tmp13.release();
                    }
                    tmp13 = objv12[2];
                    if ( tmp13 != null ) {
                        tmp13.release();
                    }
                    tmp13 = objv12[3];
                    if ( tmp13 != null ) {
                        tmp13.release();
                    }
                    TJC.releaseObjv(interp, objv12, 4);
                }
            } // End Invoke: descend_range_quoted
            tmp11 = interp.getResult();
            setVarScalar(interp, "result", tmp11, compiledLocals, 9);
        } // End Invoke: set
        { // Invoke: set unquoted_body_range [...]
            TclObject tmp14;
            { // Invoke: lindex $result 0
                TclObject tmp15 = getVarScalar(interp, "result", compiledLocals, 9);
                tmp15 = TclList.index(interp, tmp15, 0);
                if ( tmp15 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp15);
                }
            } // End Invoke: lindex
            tmp14 = interp.getResult();
            setVarScalar(interp, "unquoted_body_range", tmp14, compiledLocals, 10);
        } // End Invoke: set
        { // Invoke: set isbraced [...]
            TclObject tmp16;
            { // Invoke: lindex $result 1
                TclObject tmp17 = getVarScalar(interp, "result", compiledLocals, 9);
                tmp17 = TclList.index(interp, tmp17, 1);
                if ( tmp17 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp17);
                }
            } // End Invoke: lindex
            tmp16 = interp.getResult();
            setVarScalar(interp, "isbraced", tmp16, compiledLocals, 11);
        } // End Invoke: set
        { // Invoke: set chknested $isbraced
            TclObject tmp18;
            tmp18 = getVarScalar(interp, "isbraced", compiledLocals, 11);
            setVarScalar(interp, "chknested", tmp18, compiledLocals, 12);
        } // End Invoke: set
        { // Invoke: set outermost 0
            setVarScalar(interp, "outermost", const0, compiledLocals, 13);
        } // End Invoke: set
        { // Invoke: return [...]
            { // Invoke: descend_start $script $unquoted_body_range $nested $chknested $undetermined $outermost
                TclObject[] objv19 = TJC.grabObjv(interp, 7);
                TclObject tmp20;
                try {
                    // Arg 0 constant: descend_start
                    objv19[0] = const6;
                    // Arg 1 variable: $script
                    tmp20 = getVarScalar(interp, "script", compiledLocals, 1);
                    tmp20.preserve();
                    objv19[1] = tmp20;
                    // Arg 2 variable: $unquoted_body_range
                    tmp20 = getVarScalar(interp, "unquoted_body_range", compiledLocals, 10);
                    tmp20.preserve();
                    objv19[2] = tmp20;
                    // Arg 3 variable: $nested
                    tmp20 = getVarScalar(interp, "nested", compiledLocals, 5);
                    tmp20.preserve();
                    objv19[3] = tmp20;
                    // Arg 4 variable: $chknested
                    tmp20 = getVarScalar(interp, "chknested", compiledLocals, 12);
                    tmp20.preserve();
                    objv19[4] = tmp20;
                    // Arg 5 variable: $undetermined
                    tmp20 = getVarScalar(interp, "undetermined", compiledLocals, 4);
                    tmp20.preserve();
                    objv19[5] = tmp20;
                    // Arg 6 variable: $outermost
                    tmp20 = getVarScalar(interp, "outermost", compiledLocals, 13);
                    tmp20.preserve();
                    objv19[6] = tmp20;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                        ? cmdcache4.cmd : null), objv19, 0);
                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                        updateCmdCache(interp, 4);
                    }
                } finally {
                    objv19[0] = null;
                    TJC.releaseObjvElems(interp, objv19, 7);
                }
            } // End Invoke: descend_start
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "descend_container_body_argument");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclInteger.newInstance(0);
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("descend_get_data");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("nested");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("parse");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("getstring");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("descend_range_quoted");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("descend_start");
        const6.preserve(); const6.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "descend_get_data";
                break;
            }
            case 2: {
                cmdName = "parse";
                break;
            }
            case 3: {
                cmdName = "descend_range_quoted";
                break;
            }
            case 4: {
                cmdName = "descend_start";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "script",
        "tree",
        "body_index",
        "undetermined",
        "nested",
        "body_subtree",
        "body_range",
        "body_text",
        "result",
        "unquoted_body_range",
        "isbraced",
        "chknested",
        "outermost"
    };
} // end class DescendContainerBodyArgumentCmd

