// TJC implementation of procedure descend_container_expr_argument
package tjc;
import tcl.lang.*;

public class DescendContainerExprArgumentCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 7, compiledLocalsNames);
        try {
        if (objv.length != 3) {
            throw new TclNumArgsException(interp, 1, objv, "key argindex");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        setVarScalar(interp, "argindex", objv[2], compiledLocals, 1);
        { // Invoke: set script [...]
            TclObject tmp0;
            { // Invoke: descend_get_data $key script
                TclObject[] objv1 = TJC.grabObjv(interp, 3);
                TclObject tmp2;
                try {
                    // Arg 0 constant: descend_get_data
                    objv1[0] = const0;
                    // Arg 1 variable: $key
                    tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    // Arg 2 constant: script
                    objv1[2] = const1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 3);
                }
            } // End Invoke: descend_get_data
            tmp0 = interp.getResult();
            setVarScalar(interp, "script", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set tree [...]
            TclObject tmp3;
            { // Invoke: descend_get_data $key tree
                TclObject[] objv4 = TJC.grabObjv(interp, 3);
                TclObject tmp5;
                try {
                    // Arg 0 constant: descend_get_data
                    objv4[0] = const0;
                    // Arg 1 variable: $key
                    tmp5 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp5.preserve();
                    objv4[1] = tmp5;
                    // Arg 2 constant: tree
                    objv4[2] = const2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv4, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp5 = objv4[1];
                    if ( tmp5 != null ) {
                        tmp5.release();
                    }
                    TJC.releaseObjv(interp, objv4, 3);
                }
            } // End Invoke: descend_get_data
            tmp3 = interp.getResult();
            setVarScalar(interp, "tree", tmp3, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set stree [...]
            TclObject tmp6;
            { // Invoke: lindex $tree $argindex
                TclObject tmp7 = null;
                TclObject tmp8;
                try {
                    tmp7 = getVarScalar(interp, "tree", compiledLocals, 3);
                    tmp7.preserve();
                    tmp8 = getVarScalar(interp, "argindex", compiledLocals, 1);
                    TJC.lindexNonconst(interp, tmp7, tmp8);
                } finally {
                    if ( tmp7 != null ) {
                        tmp7.release();
                    }
                }
            } // End Invoke: lindex
            tmp6 = interp.getResult();
            setVarScalar(interp, "stree", tmp6, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set range [...]
            TclObject tmp9;
            { // Invoke: ... $stree text
                TclObject[] objv10 = TJC.grabObjv(interp, 3);
                TclObject tmp11;
                try {
                    // Arg 0 constant: ...
                    objv10[0] = const3;
                    // Arg 1 variable: $stree
                    tmp11 = getVarScalar(interp, "stree", compiledLocals, 4);
                    tmp11.preserve();
                    objv10[1] = tmp11;
                    // Arg 2 constant: text
                    objv10[2] = const4;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv10, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp11 = objv10[1];
                    if ( tmp11 != null ) {
                        tmp11.release();
                    }
                    TJC.releaseObjv(interp, objv10, 3);
                }
            } // End Invoke: ...
            tmp9 = interp.getResult();
            setVarScalar(interp, "range", tmp9, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set etree [...]
            TclObject tmp12;
            { // Invoke: parse expr $script $range
                TclObject[] objv13 = TJC.grabObjv(interp, 4);
                TclObject tmp14;
                try {
                    // Arg 0 constant: parse
                    objv13[0] = const5;
                    // Arg 1 constant: expr
                    objv13[1] = const6;
                    // Arg 2 variable: $script
                    tmp14 = getVarScalar(interp, "script", compiledLocals, 2);
                    tmp14.preserve();
                    objv13[2] = tmp14;
                    // Arg 3 variable: $range
                    tmp14 = getVarScalar(interp, "range", compiledLocals, 5);
                    tmp14.preserve();
                    objv13[3] = tmp14;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv13, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp14 = objv13[2];
                    if ( tmp14 != null ) {
                        tmp14.release();
                    }
                    tmp14 = objv13[3];
                    if ( tmp14 != null ) {
                        tmp14.release();
                    }
                    TJC.releaseObjv(interp, objv13, 4);
                }
            } // End Invoke: parse
            tmp12 = interp.getResult();
            setVarScalar(interp, "etree", tmp12, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: parse_expr_iterate $script $etree ...
            TclObject[] objv15 = TJC.grabObjv(interp, 4);
            TclObject tmp16;
            try {
                // Arg 0 constant: parse_expr_iterate
                objv15[0] = const7;
                // Arg 1 variable: $script
                tmp16 = getVarScalar(interp, "script", compiledLocals, 2);
                tmp16.preserve();
                objv15[1] = tmp16;
                // Arg 2 variable: $etree
                tmp16 = getVarScalar(interp, "etree", compiledLocals, 6);
                tmp16.preserve();
                objv15[2] = tmp16;
                // Arg 3 constant: ...
                objv15[3] = const8;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                    ? cmdcache4.cmd : null), objv15, 0);
                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                    updateCmdCache(interp, 4);
                }
            } finally {
                tmp16 = objv15[1];
                if ( tmp16 != null ) {
                    tmp16.release();
                }
                tmp16 = objv15[2];
                if ( tmp16 != null ) {
                    tmp16.release();
                }
                TJC.releaseObjv(interp, objv15, 4);
            }
        } // End Invoke: parse_expr_iterate
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "descend_container_expr_argument");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("descend_get_data");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("script");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("tree");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("parse_get_simple_text_range");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("text");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("parse");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("expr");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("parse_expr_iterate");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("descend_container_expr_argument_iterate_callback");
        const8.preserve(); const8.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "descend_get_data";
                break;
            }
            case 2: {
                cmdName = "parse_get_simple_text_range";
                break;
            }
            case 3: {
                cmdName = "parse";
                break;
            }
            case 4: {
                cmdName = "parse_expr_iterate";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "argindex",
        "script",
        "tree",
        "stree",
        "range",
        "etree"
    };
} // end class DescendContainerExprArgumentCmd

