// TJC implementation of procedure descend_container_switch_is_fallthrough
package tjc;
import tcl.lang.*;

public class DescendContainerSwitchIsFallthroughCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 7, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 3) {
            throw new TclNumArgsException(interp, 1, objv, "key bodyindex");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        setVarScalar(interp, "bodyindex", objv[2], compiledLocals, 1);
        { // Invoke: set script [...]
            TclObject tmp0;
            { // Invoke: descend_get_data $key script
                TclObject[] objv1 = TJC.grabObjv(interp, 3);
                TclObject tmp2;
                try {
                    // Arg 0 constant: descend_get_data
                    objv1[0] = const0;
                    // Arg 1 variable: $key
                    tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    // Arg 2 constant: script
                    objv1[2] = const1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 3);
                }
            } // End Invoke: descend_get_data
            tmp0 = interp.getResult();
            setVarScalar(interp, "script", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set tree [...]
            TclObject tmp3;
            { // Invoke: descend_get_data $key tree
                TclObject[] objv4 = TJC.grabObjv(interp, 3);
                TclObject tmp5;
                try {
                    // Arg 0 constant: descend_get_data
                    objv4[0] = const0;
                    // Arg 1 variable: $key
                    tmp5 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp5.preserve();
                    objv4[1] = tmp5;
                    // Arg 2 constant: tree
                    objv4[2] = const2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv4, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp5 = objv4[1];
                    if ( tmp5 != null ) {
                        tmp5.release();
                    }
                    TJC.releaseObjv(interp, objv4, 3);
                }
            } // End Invoke: descend_get_data
            tmp3 = interp.getResult();
            setVarScalar(interp, "tree", tmp3, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set validated [...]
            TclObject tmp6;
            { // Invoke: descend_get_data $key validated
                TclObject[] objv7 = TJC.grabObjv(interp, 3);
                TclObject tmp8;
                try {
                    // Arg 0 constant: descend_get_data
                    objv7[0] = const0;
                    // Arg 1 variable: $key
                    tmp8 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp8.preserve();
                    objv7[1] = tmp8;
                    // Arg 2 constant: validated
                    objv7[2] = const3;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv7, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp8 = objv7[1];
                    if ( tmp8 != null ) {
                        tmp8.release();
                    }
                    TJC.releaseObjv(interp, objv7, 3);
                }
            } // End Invoke: descend_get_data
            tmp6 = interp.getResult();
            setVarScalar(interp, "validated", tmp6, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: if {$validated == {}} ...
            // Binary operator: $validated == ""
            TclObject tmp9 = getVarScalar(interp, "validated", compiledLocals, 4);
            ExprValue tmp10 = evs0;
            TJC.exprEqualsEmptyString(tmp10, tmp9, false);
            // End Binary operator: ==
            boolean tmp11 = ( tmp10.getIntValue() != 0 );
            if ( tmp11 ) {
                { // Invoke: error "not validated"
                    TclObject[] objv12 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: error
                        objv12[0] = const4;
                        // Arg 1 constant: "not validated"
                        objv12[1] = const5;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv12, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv12, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set subtree [...]
            TclObject tmp13;
            { // Invoke: lindex $tree $bodyindex
                TclObject tmp14 = null;
                TclObject tmp15;
                try {
                    tmp14 = getVarScalar(interp, "tree", compiledLocals, 3);
                    tmp14.preserve();
                    tmp15 = getVarScalar(interp, "bodyindex", compiledLocals, 1);
                    TJC.lindexNonconst(interp, tmp14, tmp15);
                } finally {
                    if ( tmp14 != null ) {
                        tmp14.release();
                    }
                }
            } // End Invoke: lindex
            tmp13 = interp.getResult();
            setVarScalar(interp, "subtree", tmp13, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: if ... ...
            { // Invoke: parse_is_simple_text $subtree
                TclObject[] objv16 = TJC.grabObjv(interp, 2);
                TclObject tmp17;
                try {
                    // Arg 0 constant: parse_is_simple_text
                    objv16[0] = const6;
                    // Arg 1 variable: $subtree
                    tmp17 = getVarScalar(interp, "subtree", compiledLocals, 5);
                    tmp17.preserve();
                    objv16[1] = tmp17;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv16, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp17 = objv16[1];
                    if ( tmp17 != null ) {
                        tmp17.release();
                    }
                    TJC.releaseObjv(interp, objv16, 2);
                }
            } // End Invoke: parse_is_simple_text
            TclObject tmp18 = interp.getResult();
            ExprValue tmp19 = evs0;
            TJC.exprInitValue(interp, tmp19, tmp18);
            boolean tmp20 = tmp19.getBooleanValue(interp);
            if ( tmp20 ) {
                { // Invoke: set text [...]
                    TclObject tmp21;
                    { // Invoke: ... $script $subtree text
                        TclObject[] objv22 = TJC.grabObjv(interp, 4);
                        TclObject tmp23;
                        try {
                            // Arg 0 constant: ...
                            objv22[0] = const7;
                            // Arg 1 variable: $script
                            tmp23 = getVarScalar(interp, "script", compiledLocals, 2);
                            tmp23.preserve();
                            objv22[1] = tmp23;
                            // Arg 2 variable: $subtree
                            tmp23 = getVarScalar(interp, "subtree", compiledLocals, 5);
                            tmp23.preserve();
                            objv22[2] = tmp23;
                            // Arg 3 constant: text
                            objv22[3] = const8;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                ? cmdcache4.cmd : null), objv22, 0);
                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                updateCmdCache(interp, 4);
                            }
                        } finally {
                            tmp23 = objv22[1];
                            if ( tmp23 != null ) {
                                tmp23.release();
                            }
                            tmp23 = objv22[2];
                            if ( tmp23 != null ) {
                                tmp23.release();
                            }
                            TJC.releaseObjv(interp, objv22, 4);
                        }
                    } // End Invoke: ...
                    tmp21 = interp.getResult();
                    setVarScalar(interp, "text", tmp21, compiledLocals, 6);
                } // End Invoke: set
                { // Invoke: if {$text == "-"} ...
                    // Binary operator: $text == "-"
                    TclObject tmp24 = getVarScalar(interp, "text", compiledLocals, 6);
                    boolean tmp25 = tmp24.toString().equals("-");
                    ExprValue tmp26 = evs0;
                    tmp26.setIntValue(tmp25);
                    // End Binary operator: ==
                    boolean tmp27 = ( tmp26.getIntValue() != 0 );
                    if ( tmp27 ) {
                        { // Invoke: return 1
                            interp.resetResult();
                            interp.setResult(const9);
                            if ( true ) { return; }
                        } // End Invoke: return
                    }
                } // End Invoke: if
            }
        } // End Invoke: if
        { // Invoke: return 0
            interp.resetResult();
            interp.setResult(const10);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "descend_container_switch_is_fallthrough");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("descend_get_data");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("script");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("tree");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("validated");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("error");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("not validated");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("parse_is_simple_text");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("parse_get_simple_text");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("text");
        const8.preserve(); const8.preserve();
        const9 = TclInteger.newInstance(1);
        const9.preserve(); const9.preserve();
        const10 = TclInteger.newInstance(0);
        const10.preserve(); const10.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "descend_get_data";
                break;
            }
            case 2: {
                cmdName = "error";
                break;
            }
            case 3: {
                cmdName = "parse_is_simple_text";
                break;
            }
            case 4: {
                cmdName = "parse_get_simple_text";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "bodyindex",
        "script",
        "tree",
        "validated",
        "subtree",
        "text"
    };
} // end class DescendContainerSwitchIsFallthroughCmd

