// TJC implementation of procedure descend_container_switch_validate
package tjc;
import tcl.lang.*;

public class DescendContainerSwitchValidateCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 51, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        ExprValue evs2 = TJC.exprGetValue(interp);
        ExprValue evs3 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: global _descend
            TJC.makeGlobalLinkVar(interp, "_descend", "_descend", 1);
        } // End Invoke: global
        { // Invoke: set script [...]
            TclObject tmp0;
            { // Invoke: descend_get_data $key script
                TclObject[] objv1 = TJC.grabObjv(interp, 3);
                TclObject tmp2;
                try {
                    // Arg 0 constant: descend_get_data
                    objv1[0] = const0;
                    // Arg 1 variable: $key
                    tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    // Arg 2 constant: script
                    objv1[2] = const1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 3);
                }
            } // End Invoke: descend_get_data
            tmp0 = interp.getResult();
            setVarScalar(interp, "script", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set tree [...]
            TclObject tmp3;
            { // Invoke: descend_get_data $key tree
                TclObject[] objv4 = TJC.grabObjv(interp, 3);
                TclObject tmp5;
                try {
                    // Arg 0 constant: descend_get_data
                    objv4[0] = const0;
                    // Arg 1 variable: $key
                    tmp5 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp5.preserve();
                    objv4[1] = tmp5;
                    // Arg 2 constant: tree
                    objv4[2] = const2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv4, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp5 = objv4[1];
                    if ( tmp5 != null ) {
                        tmp5.release();
                    }
                    TJC.releaseObjv(interp, objv4, 3);
                }
            } // End Invoke: descend_get_data
            tmp3 = interp.getResult();
            setVarScalar(interp, "tree", tmp3, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set nested [...]
            TclObject tmp6;
            { // Invoke: descend_get_data $key nested
                TclObject[] objv7 = TJC.grabObjv(interp, 3);
                TclObject tmp8;
                try {
                    // Arg 0 constant: descend_get_data
                    objv7[0] = const0;
                    // Arg 1 variable: $key
                    tmp8 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp8.preserve();
                    objv7[1] = tmp8;
                    // Arg 2 constant: nested
                    objv7[2] = const3;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv7, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp8 = objv7[1];
                    if ( tmp8 != null ) {
                        tmp8.release();
                    }
                    TJC.releaseObjv(interp, objv7, 3);
                }
            } // End Invoke: descend_get_data
            tmp6 = interp.getResult();
            setVarScalar(interp, "nested", tmp6, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set parse_range [...]
            TclObject tmp9;
            { // Invoke: descend_get_data $key range
                TclObject[] objv10 = TJC.grabObjv(interp, 3);
                TclObject tmp11;
                try {
                    // Arg 0 constant: descend_get_data
                    objv10[0] = const0;
                    // Arg 1 variable: $key
                    tmp11 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp11.preserve();
                    objv10[1] = tmp11;
                    // Arg 2 constant: range
                    objv10[2] = const4;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv10, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp11 = objv10[1];
                    if ( tmp11 != null ) {
                        tmp11.release();
                    }
                    TJC.releaseObjv(interp, objv10, 3);
                }
            } // End Invoke: descend_get_data
            tmp9 = interp.getResult();
            setVarScalar(interp, "parse_range", tmp9, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set undetermined 0
            setVarScalar(interp, "undetermined", const5, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set ... [...]
            TclObject tmp12;
            { // Invoke: descend_get_data $key command
                TclObject[] objv13 = TJC.grabObjv(interp, 3);
                TclObject tmp14;
                try {
                    // Arg 0 constant: descend_get_data
                    objv13[0] = const0;
                    // Arg 1 variable: $key
                    tmp14 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp14.preserve();
                    objv13[1] = tmp14;
                    // Arg 2 constant: command
                    objv13[2] = const6;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv13, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp14 = objv13[1];
                    if ( tmp14 != null ) {
                        tmp14.release();
                    }
                    TJC.releaseObjv(interp, objv13, 3);
                }
            } // End Invoke: descend_get_data
            tmp12 = interp.getResult();
            setVarScalar(interp, "original_command_range", tmp12, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: set original_rest_range [...]
            TclObject tmp15;
            { // Invoke: descend_get_data $key rest
                TclObject[] objv16 = TJC.grabObjv(interp, 3);
                TclObject tmp17;
                try {
                    // Arg 0 constant: descend_get_data
                    objv16[0] = const0;
                    // Arg 1 variable: $key
                    tmp17 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp17.preserve();
                    objv16[1] = tmp17;
                    // Arg 2 constant: rest
                    objv16[2] = const7;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv16, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp17 = objv16[1];
                    if ( tmp17 != null ) {
                        tmp17.release();
                    }
                    TJC.releaseObjv(interp, objv16, 3);
                }
            } // End Invoke: descend_get_data
            tmp15 = interp.getResult();
            setVarScalar(interp, "original_rest_range", tmp15, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: set num_args [...]
            TclObject tmp18;
            { // Invoke: llength $tree
                TclObject tmp19 = getVarScalar(interp, "tree", compiledLocals, 3);
                int tmp20 = TclList.getLength(interp, tmp19);
                interp.setResult(tmp20);
            } // End Invoke: llength
            tmp18 = interp.getResult();
            setVarScalar(interp, "num_args", tmp18, compiledLocals, 9);
        } // End Invoke: set
        { // Invoke: set original_num_args $num_args
            TclObject tmp21;
            tmp21 = getVarScalar(interp, "num_args", compiledLocals, 9);
            setVarScalar(interp, "original_num_args", tmp21, compiledLocals, 10);
        } // End Invoke: set
        { // Invoke: set original_commands [...]
            TclObject tmp22;
            { // Invoke: descend_get_data $key commands
                TclObject[] objv23 = TJC.grabObjv(interp, 3);
                TclObject tmp24;
                try {
                    // Arg 0 constant: descend_get_data
                    objv23[0] = const0;
                    // Arg 1 variable: $key
                    tmp24 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp24.preserve();
                    objv23[1] = tmp24;
                    // Arg 2 constant: commands
                    objv23[2] = const8;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv23, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp24 = objv23[1];
                    if ( tmp24 != null ) {
                        tmp24.release();
                    }
                    TJC.releaseObjv(interp, objv23, 3);
                }
            } // End Invoke: descend_get_data
            tmp22 = interp.getResult();
            setVarScalar(interp, "original_commands", tmp22, compiledLocals, 11);
        } // End Invoke: set
        { // Invoke: if {$num_args < 3} ...
            // Binary operator: $num_args < 3
            TclObject tmp25 = getVarScalar(interp, "num_args", compiledLocals, 9);
            ExprValue tmp26 = evs0;
            TJC.exprInitValue(interp, tmp26, tmp25);
            ExprValue tmp27 = evs1;
            tmp27.setIntValue(3);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp26, tmp27);
            // End Binary operator: <
            boolean tmp28 = ( tmp26.getIntValue() != 0 );
            if ( tmp28 ) {
                { // Invoke: set _descend($key,usage) 1
                    TclObject tmp29;
                    String tmp30;
                    StringBuffer sbtmp31 = new StringBuffer(64);
                    tmp29 = getVarScalar(interp, "key", compiledLocals, 0);
                    sbtmp31.append(tmp29.toString());
                    sbtmp31.append(",usage");
                    tmp30 = sbtmp31.toString();
                    setVarArray(interp, "_descend", tmp30, const9, compiledLocals, 1);
                } // End Invoke: set
                { // Invoke: return [...]
                    { // Invoke: list numArgs switch $num_args
                        TclObject tmp32 = TclList.newInstance();
                        TclObject tmp33;
                        try {
                            TclList.append(interp, tmp32, const10);
                            TclList.append(interp, tmp32, const11);
                            tmp33 = getVarScalar(interp, "num_args", compiledLocals, 9);
                            TclList.append(interp, tmp32, tmp33);
                        } catch (TclException ex) {
                            tmp32.release();
                            throw ex;
                        }
                        interp.setResult(tmp32);
                    } // End Invoke: list
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set is_static 1
            setVarScalar(interp, "is_static", const9, compiledLocals, 12);
        } // End Invoke: set
        { // Invoke: set option "default"
            setVarScalar(interp, "option", const12, compiledLocals, 13);
        } // End Invoke: set
        { // Invoke: set option_str ""
            setVarScalar(interp, "option_str", const13, compiledLocals, 14);
        } // End Invoke: set
        { // Invoke: set ... 0
            setVarScalar(interp, "found_option_terminator", const5, compiledLocals, 15);
        } // End Invoke: set
        { // Invoke: set ... -1
            setVarScalar(interp, "string_argument_index", const14, compiledLocals, 16);
        } // End Invoke: set
        { // Invoke: set patlist [...]
            TclObject tmp34;
            { // Invoke: list
                TclObject tmp35 = TclList.newInstance();
                interp.setResult(tmp35);
            } // End Invoke: list
            tmp34 = interp.getResult();
            setVarScalar(interp, "patlist", tmp34, compiledLocals, 17);
        } // End Invoke: set
        { // Invoke: set tIndex ""
            setVarScalar(interp, "tIndex", const13, compiledLocals, 18);
        } // End Invoke: set
        { // Invoke: set sIndex ""
            setVarScalar(interp, "sIndex", const13, compiledLocals, 19);
        } // End Invoke: set
        { // Invoke: set arg1_undetermined 0
            setVarScalar(interp, "arg1_undetermined", const5, compiledLocals, 20);
        } // End Invoke: set
        { // Invoke: set arg2_undetermined 0
            setVarScalar(interp, "arg2_undetermined", const5, compiledLocals, 21);
        } // End Invoke: set
        { // Invoke: set subtree [...]
            TclObject tmp36;
            { // Invoke: lindex $tree 1
                TclObject tmp37 = getVarScalar(interp, "tree", compiledLocals, 3);
                tmp37 = TclList.index(interp, tmp37, 1);
                if ( tmp37 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp37);
                }
            } // End Invoke: lindex
            tmp36 = interp.getResult();
            setVarScalar(interp, "subtree", tmp36, compiledLocals, 22);
        } // End Invoke: set
        { // Invoke: if ... ... else ...
            { // Invoke: parse_is_simple_text $subtree
                TclObject[] objv38 = TJC.grabObjv(interp, 2);
                TclObject tmp39;
                try {
                    // Arg 0 constant: parse_is_simple_text
                    objv38[0] = const15;
                    // Arg 1 variable: $subtree
                    tmp39 = getVarScalar(interp, "subtree", compiledLocals, 22);
                    tmp39.preserve();
                    objv38[1] = tmp39;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv38, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp39 = objv38[1];
                    if ( tmp39 != null ) {
                        tmp39.release();
                    }
                    TJC.releaseObjv(interp, objv38, 2);
                }
            } // End Invoke: parse_is_simple_text
            TclObject tmp40 = interp.getResult();
            ExprValue tmp41 = evs0;
            TJC.exprInitValue(interp, tmp41, tmp40);
            boolean tmp42 = tmp41.getBooleanValue(interp);
            if ( tmp42 ) {
                { // Invoke: set option_str [...]
                    TclObject tmp43;
                    { // Invoke: ... $script $subtree "text"
                        TclObject[] objv44 = TJC.grabObjv(interp, 4);
                        TclObject tmp45;
                        try {
                            // Arg 0 constant: ...
                            objv44[0] = const16;
                            // Arg 1 variable: $script
                            tmp45 = getVarScalar(interp, "script", compiledLocals, 2);
                            tmp45.preserve();
                            objv44[1] = tmp45;
                            // Arg 2 variable: $subtree
                            tmp45 = getVarScalar(interp, "subtree", compiledLocals, 22);
                            tmp45.preserve();
                            objv44[2] = tmp45;
                            // Arg 3 constant: "text"
                            objv44[3] = const17;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv44, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            tmp45 = objv44[1];
                            if ( tmp45 != null ) {
                                tmp45.release();
                            }
                            tmp45 = objv44[2];
                            if ( tmp45 != null ) {
                                tmp45.release();
                            }
                            TJC.releaseObjv(interp, objv44, 4);
                        }
                    } // End Invoke: ...
                    tmp43 = interp.getResult();
                    setVarScalar(interp, "option_str", tmp43, compiledLocals, 14);
                } // End Invoke: set
                { // Invoke: set mode_str [...]
                    TclObject tmp46;
                    { // Invoke: ... $option_str
                        TclObject[] objv47 = TJC.grabObjv(interp, 2);
                        TclObject tmp48;
                        try {
                            // Arg 0 constant: ...
                            objv47[0] = const18;
                            // Arg 1 variable: $option_str
                            tmp48 = getVarScalar(interp, "option_str", compiledLocals, 14);
                            tmp48.preserve();
                            objv47[1] = tmp48;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                ? cmdcache4.cmd : null), objv47, 0);
                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                updateCmdCache(interp, 4);
                            }
                        } finally {
                            tmp48 = objv47[1];
                            if ( tmp48 != null ) {
                                tmp48.release();
                            }
                            TJC.releaseObjv(interp, objv47, 2);
                        }
                    } // End Invoke: ...
                    tmp46 = interp.getResult();
                    setVarScalar(interp, "mode_str", tmp46, compiledLocals, 23);
                } // End Invoke: set
                { // Invoke: if {$mode_str != ""} ... else ...
                    // Binary operator: $mode_str != ""
                    TclObject tmp49 = getVarScalar(interp, "mode_str", compiledLocals, 23);
                    ExprValue tmp50 = evs0;
                    TJC.exprEqualsEmptyString(tmp50, tmp49, true);
                    // End Binary operator: !=
                    boolean tmp51 = ( tmp50.getIntValue() != 0 );
                    if ( tmp51 ) {
                        { // Invoke: set option $mode_str
                            TclObject tmp52;
                            tmp52 = getVarScalar(interp, "mode_str", compiledLocals, 23);
                            setVarScalar(interp, "option", tmp52, compiledLocals, 13);
                        } // End Invoke: set
                    } else {
                        { // Invoke: if ... ... elseif ... ...
                            // Binary operator: $option_str == "--"
                            TclObject tmp53 = getVarScalar(interp, "option_str", compiledLocals, 14);
                            boolean tmp54 = tmp53.toString().equals("--");
                            ExprValue tmp55 = evs0;
                            tmp55.setIntValue(tmp54);
                            // End Binary operator: ==
                            boolean tmp56 = ( tmp55.getIntValue() != 0 );
                            if ( tmp56 ) {
                                { // Invoke: set ... 1
                                    setVarScalar(interp, "found_option_terminator", const9, compiledLocals, 15);
                                } // End Invoke: set
                                { // Invoke: set tIndex 1
                                    setVarScalar(interp, "tIndex", const9, compiledLocals, 18);
                                } // End Invoke: set
                            } else {
                                // Binary operator: [...] == "-"
                                { // Invoke: string index $option_str 0
                                    TclObject tmp57 = getVarScalar(interp, "option_str", compiledLocals, 14);
                                    String tmp58 = tmp57.toString();
                                    TclObject tmp59 = TJC.stringIndex(interp, tmp58, const5);
                                    interp.setResult(tmp59);
                                } // End Invoke: string
                                TclObject tmp60 = interp.getResult();
                                boolean tmp61 = tmp60.toString().equals("-");
                                ExprValue tmp62 = evs0;
                                tmp62.setIntValue(tmp61);
                                // End Binary operator: ==
                                boolean tmp63 = ( tmp62.getIntValue() != 0 );
                                if ( tmp63 ) {
                                    { // Invoke: set _descend($key,usage) 1
                                        TclObject tmp64;
                                        String tmp65;
                                        StringBuffer sbtmp66 = new StringBuffer(64);
                                        tmp64 = getVarScalar(interp, "key", compiledLocals, 0);
                                        sbtmp66.append(tmp64.toString());
                                        sbtmp66.append(",usage");
                                        tmp65 = sbtmp66.toString();
                                        setVarArray(interp, "_descend", tmp65, const9, compiledLocals, 1);
                                    } // End Invoke: set
                                    { // Invoke: return [...]
                                        { // Invoke: list badOption switch 1 $option_str
                                            TclObject tmp67 = TclList.newInstance();
                                            TclObject tmp68;
                                            try {
                                                TclList.append(interp, tmp67, const19);
                                                TclList.append(interp, tmp67, const11);
                                                TclList.append(interp, tmp67, const9);
                                                tmp68 = getVarScalar(interp, "option_str", compiledLocals, 14);
                                                TclList.append(interp, tmp67, tmp68);
                                            } catch (TclException ex) {
                                                tmp67.release();
                                                throw ex;
                                            }
                                            interp.setResult(tmp67);
                                        } // End Invoke: list
                                        if ( true ) { return; }
                                    } // End Invoke: return
                                }
                            }
                        } // End Invoke: if
                    }
                } // End Invoke: if
            } else {
                { // Invoke: set arg1_undetermined 1
                    setVarScalar(interp, "arg1_undetermined", const9, compiledLocals, 20);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: set subtree [...]
            TclObject tmp69;
            { // Invoke: lindex $tree 2
                TclObject tmp70 = getVarScalar(interp, "tree", compiledLocals, 3);
                tmp70 = TclList.index(interp, tmp70, 2);
                if ( tmp70 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp70);
                }
            } // End Invoke: lindex
            tmp69 = interp.getResult();
            setVarScalar(interp, "subtree", tmp69, compiledLocals, 22);
        } // End Invoke: set
        { // Invoke: if ... ... else ...
            { // Invoke: parse_is_simple_text $subtree
                TclObject[] objv71 = TJC.grabObjv(interp, 2);
                TclObject tmp72;
                try {
                    // Arg 0 constant: parse_is_simple_text
                    objv71[0] = const15;
                    // Arg 1 variable: $subtree
                    tmp72 = getVarScalar(interp, "subtree", compiledLocals, 22);
                    tmp72.preserve();
                    objv71[1] = tmp72;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv71, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp72 = objv71[1];
                    if ( tmp72 != null ) {
                        tmp72.release();
                    }
                    TJC.releaseObjv(interp, objv71, 2);
                }
            } // End Invoke: parse_is_simple_text
            TclObject tmp73 = interp.getResult();
            ExprValue tmp74 = evs0;
            TJC.exprInitValue(interp, tmp74, tmp73);
            boolean tmp75 = tmp74.getBooleanValue(interp);
            if ( tmp75 ) {
                { // Invoke: set option_str [...]
                    TclObject tmp76;
                    { // Invoke: ... $script $subtree "text"
                        TclObject[] objv77 = TJC.grabObjv(interp, 4);
                        TclObject tmp78;
                        try {
                            // Arg 0 constant: ...
                            objv77[0] = const16;
                            // Arg 1 variable: $script
                            tmp78 = getVarScalar(interp, "script", compiledLocals, 2);
                            tmp78.preserve();
                            objv77[1] = tmp78;
                            // Arg 2 variable: $subtree
                            tmp78 = getVarScalar(interp, "subtree", compiledLocals, 22);
                            tmp78.preserve();
                            objv77[2] = tmp78;
                            // Arg 3 constant: "text"
                            objv77[3] = const17;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv77, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            tmp78 = objv77[1];
                            if ( tmp78 != null ) {
                                tmp78.release();
                            }
                            tmp78 = objv77[2];
                            if ( tmp78 != null ) {
                                tmp78.release();
                            }
                            TJC.releaseObjv(interp, objv77, 4);
                        }
                    } // End Invoke: ...
                    tmp76 = interp.getResult();
                    setVarScalar(interp, "option_str", tmp76, compiledLocals, 14);
                } // End Invoke: set
                { // Invoke: if ... ... elseif ... ...
                    // Binary operator: $option_str == "--"
                    TclObject tmp79 = getVarScalar(interp, "option_str", compiledLocals, 14);
                    boolean tmp80 = tmp79.toString().equals("--");
                    ExprValue tmp81 = evs0;
                    tmp81.setIntValue(tmp80);
                    // End Binary operator: ==
                    boolean tmp82 = ( tmp81.getIntValue() != 0 );
                    if ( tmp82 ) {
                        { // Invoke: if ... ...
                            TclObject tmp83 = getVarScalar(interp, "found_option_terminator", compiledLocals, 15);
                            boolean tmp84 = TJC.getBoolean(interp, tmp83);
                            if ( tmp84 ) {
                                { // Invoke: set _descend($key,usage) 1
                                    TclObject tmp85;
                                    String tmp86;
                                    StringBuffer sbtmp87 = new StringBuffer(64);
                                    tmp85 = getVarScalar(interp, "key", compiledLocals, 0);
                                    sbtmp87.append(tmp85.toString());
                                    sbtmp87.append(",usage");
                                    tmp86 = sbtmp87.toString();
                                    setVarArray(interp, "_descend", tmp86, const9, compiledLocals, 1);
                                } // End Invoke: set
                                { // Invoke: return [...]
                                    { // Invoke: list badOption switch 2 $option_str
                                        TclObject tmp88 = TclList.newInstance();
                                        TclObject tmp89;
                                        try {
                                            TclList.append(interp, tmp88, const19);
                                            TclList.append(interp, tmp88, const11);
                                            TclList.append(interp, tmp88, const20);
                                            tmp89 = getVarScalar(interp, "option_str", compiledLocals, 14);
                                            TclList.append(interp, tmp88, tmp89);
                                        } catch (TclException ex) {
                                            tmp88.release();
                                            throw ex;
                                        }
                                        interp.setResult(tmp88);
                                    } // End Invoke: list
                                    if ( true ) { return; }
                                } // End Invoke: return
                            }
                        } // End Invoke: if
                        { // Invoke: set ... 1
                            setVarScalar(interp, "found_option_terminator", const9, compiledLocals, 15);
                        } // End Invoke: set
                        { // Invoke: set tIndex 2
                            setVarScalar(interp, "tIndex", const20, compiledLocals, 18);
                        } // End Invoke: set
                    } else {
                        // Binary operator: () && ()
                        // Unary operator: ! $found_option_terminator
                        TclObject tmp90 = getVarScalar(interp, "found_option_terminator", compiledLocals, 15);
                        ExprValue tmp91 = evs0;
                        if ( tmp90.isIntType() ) {
                            TJC.exprUnaryNotOperatorKnownInt(tmp91, tmp90);
                        } else {
                            TJC.exprUnaryNotOperator(interp, tmp91, tmp90);
                        }
                        // End Unary operator: !
                        if (tmp91.getBooleanValue(interp)) {
                        // Binary operator: [...] != ""
                        { // Invoke: ... $option_str
                            TclObject[] objv92 = TJC.grabObjv(interp, 2);
                            TclObject tmp93;
                            try {
                                // Arg 0 constant: ...
                                objv92[0] = const18;
                                // Arg 1 variable: $option_str
                                tmp93 = getVarScalar(interp, "option_str", compiledLocals, 14);
                                tmp93.preserve();
                                objv92[1] = tmp93;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                    ? cmdcache4.cmd : null), objv92, 0);
                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                    updateCmdCache(interp, 4);
                                }
                            } finally {
                                tmp93 = objv92[1];
                                if ( tmp93 != null ) {
                                    tmp93.release();
                                }
                                TJC.releaseObjv(interp, objv92, 2);
                            }
                        } // End Invoke: ...
                        TclObject tmp94 = interp.getResult();
                        ExprValue tmp95 = evs1;
                        TJC.exprEqualsEmptyString(tmp95, tmp94, true);
                        // End Binary operator: !=
                        tmp91.setIntValue(tmp95.getBooleanValue(interp));
                        } else {
                        tmp91.setIntValue(0);
                        } // End if: ()
                        // End Binary operator: &&
                        boolean tmp96 = ( tmp91.getIntValue() != 0 );
                        if ( tmp96 ) {
                            { // Invoke: set _descend($key,usage) 1
                                TclObject tmp97;
                                String tmp98;
                                StringBuffer sbtmp99 = new StringBuffer(64);
                                tmp97 = getVarScalar(interp, "key", compiledLocals, 0);
                                sbtmp99.append(tmp97.toString());
                                sbtmp99.append(",usage");
                                tmp98 = sbtmp99.toString();
                                setVarArray(interp, "_descend", tmp98, const9, compiledLocals, 1);
                            } // End Invoke: set
                            { // Invoke: return [...]
                                { // Invoke: list badOption switch 2 $option_str
                                    TclObject tmp100 = TclList.newInstance();
                                    TclObject tmp101;
                                    try {
                                        TclList.append(interp, tmp100, const19);
                                        TclList.append(interp, tmp100, const11);
                                        TclList.append(interp, tmp100, const20);
                                        tmp101 = getVarScalar(interp, "option_str", compiledLocals, 14);
                                        TclList.append(interp, tmp100, tmp101);
                                    } catch (TclException ex) {
                                        tmp100.release();
                                        throw ex;
                                    }
                                    interp.setResult(tmp100);
                                } // End Invoke: list
                                if ( true ) { return; }
                            } // End Invoke: return
                        }
                    }
                } // End Invoke: if
            } else {
                { // Invoke: set arg2_undetermined 1
                    setVarScalar(interp, "arg2_undetermined", const9, compiledLocals, 21);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: if {$num_args == 3} ... elseif {$num_args == 4} ... elseif {$num_args == 5} ... elseif {$num_args >= 6} ...
            // Binary operator: $num_args == 3
            TclObject tmp102 = getVarScalar(interp, "num_args", compiledLocals, 9);
            ExprValue tmp103 = evs0;
            TJC.exprInitValue(interp, tmp103, tmp102);
            ExprValue tmp104 = evs1;
            tmp104.setIntValue(3);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp103, tmp104);
            // End Binary operator: ==
            boolean tmp105 = ( tmp103.getIntValue() != 0 );
            if ( tmp105 ) {
                { // Invoke: if ... ...
                    // Binary operator: () || $found_option_terminator
                    // Binary operator: $option != "default"
                    TclObject tmp106 = getVarScalar(interp, "option", compiledLocals, 13);
                    boolean tmp107 = ! tmp106.toString().equals("default");
                    ExprValue tmp108 = evs0;
                    tmp108.setIntValue(tmp107);
                    // End Binary operator: !=
                    if (!tmp108.getBooleanValue(interp)) {
                    TclObject tmp109 = getVarScalar(interp, "found_option_terminator", compiledLocals, 15);
                    ExprValue tmp110 = evs1;
                    TJC.exprInitValue(interp, tmp110, tmp109);
                    tmp108.setIntValue(tmp110.getBooleanValue(interp));
                    } else {
                    tmp108.setIntValue(1);
                    } // End if: !()
                    // End Binary operator: ||
                    boolean tmp111 = ( tmp108.getIntValue() != 0 );
                    if ( tmp111 ) {
                        { // Invoke: set _descend($key,usage) 1
                            TclObject tmp112;
                            String tmp113;
                            StringBuffer sbtmp114 = new StringBuffer(64);
                            tmp112 = getVarScalar(interp, "key", compiledLocals, 0);
                            sbtmp114.append(tmp112.toString());
                            sbtmp114.append(",usage");
                            tmp113 = sbtmp114.toString();
                            setVarArray(interp, "_descend", tmp113, const9, compiledLocals, 1);
                        } // End Invoke: set
                        { // Invoke: return [...]
                            { // Invoke: list badOption switch 2
                                TclObject tmp115 = TclList.newInstance();
                                try {
                                    TclList.append(interp, tmp115, const19);
                                    TclList.append(interp, tmp115, const11);
                                    TclList.append(interp, tmp115, const20);
                                } catch (TclException ex) {
                                    tmp115.release();
                                    throw ex;
                                }
                                interp.setResult(tmp115);
                            } // End Invoke: list
                            if ( true ) { return; }
                        } // End Invoke: return
                    }
                } // End Invoke: if
                { // Invoke: if {$arg2_undetermined} ...
                    TclObject tmp116 = getVarScalar(interp, "arg2_undetermined", compiledLocals, 21);
                    boolean tmp117 = TJC.getBoolean(interp, tmp116);
                    if ( tmp117 ) {
                        { // Invoke: return [...]
                            { // Invoke: list nonStatic switch 2
                                TclObject tmp118 = TclList.newInstance();
                                try {
                                    TclList.append(interp, tmp118, const21);
                                    TclList.append(interp, tmp118, const11);
                                    TclList.append(interp, tmp118, const20);
                                } catch (TclException ex) {
                                    tmp118.release();
                                    throw ex;
                                }
                                interp.setResult(tmp118);
                            } // End Invoke: list
                            if ( true ) { return; }
                        } // End Invoke: return
                    }
                } // End Invoke: if
                { // Invoke: set sIndex 1
                    setVarScalar(interp, "sIndex", const9, compiledLocals, 19);
                } // End Invoke: set
                { // Invoke: lappend patlist 2
                    TclObject[] objv119 = TJC.grabObjv(interp, 1);
                    TclObject tmp120;
                    try {
                        // Arg 2 constant: 2
                        objv119[0] = const20;
                        interp.resetResult();
                        lappendVarScalar(interp, "patlist", objv119, compiledLocals, 17);
                    } finally {
                        TJC.releaseObjv(interp, objv119, 1);
                    }
                } // End Invoke: lappend
            } else {
                // Binary operator: $num_args == 4
                TclObject tmp121 = getVarScalar(interp, "num_args", compiledLocals, 9);
                ExprValue tmp122 = evs0;
                TJC.exprInitValue(interp, tmp122, tmp121);
                ExprValue tmp123 = evs1;
                tmp123.setIntValue(4);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp122, tmp123);
                // End Binary operator: ==
                boolean tmp124 = ( tmp122.getIntValue() != 0 );
                if ( tmp124 ) {
                    { // Invoke: if ... ... elseif ... ... elseif ... ... else ...
                        // Binary operator: () && ()
                        // Binary operator: () && $found_option_terminator
                        // Binary operator: $option == "default"
                        TclObject tmp125 = getVarScalar(interp, "option", compiledLocals, 13);
                        boolean tmp126 = tmp125.toString().equals("default");
                        ExprValue tmp127 = evs0;
                        tmp127.setIntValue(tmp126);
                        // End Binary operator: ==
                        if (tmp127.getBooleanValue(interp)) {
                        TclObject tmp128 = getVarScalar(interp, "found_option_terminator", compiledLocals, 15);
                        ExprValue tmp129 = evs1;
                        TJC.exprInitValue(interp, tmp129, tmp128);
                        tmp127.setIntValue(tmp129.getBooleanValue(interp));
                        } else {
                        tmp127.setIntValue(0);
                        } // End if: ()
                        // End Binary operator: &&
                        if (tmp127.getBooleanValue(interp)) {
                        // Binary operator: $tIndex == 1
                        TclObject tmp130 = getVarScalar(interp, "tIndex", compiledLocals, 18);
                        ExprValue tmp131 = evs1;
                        TJC.exprInitValue(interp, tmp131, tmp130);
                        ExprValue tmp132 = evs2;
                        tmp132.setIntValue(1);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp131, tmp132);
                        // End Binary operator: ==
                        tmp127.setIntValue(tmp131.getBooleanValue(interp));
                        } else {
                        tmp127.setIntValue(0);
                        } // End if: ()
                        // End Binary operator: &&
                        boolean tmp133 = ( tmp127.getIntValue() != 0 );
                        if ( tmp133 ) {
                            { // Invoke: set sIndex 2
                                setVarScalar(interp, "sIndex", const20, compiledLocals, 19);
                            } // End Invoke: set
                            { // Invoke: lappend patlist 3
                                TclObject[] objv134 = TJC.grabObjv(interp, 1);
                                TclObject tmp135;
                                try {
                                    // Arg 2 constant: 3
                                    objv134[0] = const22;
                                    interp.resetResult();
                                    lappendVarScalar(interp, "patlist", objv134, compiledLocals, 17);
                                } finally {
                                    TJC.releaseObjv(interp, objv134, 1);
                                }
                            } // End Invoke: lappend
                        } else {
                            // Binary operator: () && ()
                            // Binary operator: $option != "default"
                            TclObject tmp136 = getVarScalar(interp, "option", compiledLocals, 13);
                            boolean tmp137 = ! tmp136.toString().equals("default");
                            ExprValue tmp138 = evs0;
                            tmp138.setIntValue(tmp137);
                            // End Binary operator: !=
                            if (tmp138.getBooleanValue(interp)) {
                            // Unary operator: ! $found_option_terminator
                            TclObject tmp139 = getVarScalar(interp, "found_option_terminator", compiledLocals, 15);
                            ExprValue tmp140 = evs1;
                            if ( tmp139.isIntType() ) {
                                TJC.exprUnaryNotOperatorKnownInt(tmp140, tmp139);
                            } else {
                                TJC.exprUnaryNotOperator(interp, tmp140, tmp139);
                            }
                            // End Unary operator: !
                            tmp138.setIntValue(tmp140.getBooleanValue(interp));
                            } else {
                            tmp138.setIntValue(0);
                            } // End if: ()
                            // End Binary operator: &&
                            boolean tmp141 = ( tmp138.getIntValue() != 0 );
                            if ( tmp141 ) {
                                { // Invoke: set sIndex 2
                                    setVarScalar(interp, "sIndex", const20, compiledLocals, 19);
                                } // End Invoke: set
                                { // Invoke: lappend patlist 3
                                    TclObject[] objv142 = TJC.grabObjv(interp, 1);
                                    TclObject tmp143;
                                    try {
                                        // Arg 2 constant: 3
                                        objv142[0] = const22;
                                        interp.resetResult();
                                        lappendVarScalar(interp, "patlist", objv142, compiledLocals, 17);
                                    } finally {
                                        TJC.releaseObjv(interp, objv142, 1);
                                    }
                                } // End Invoke: lappend
                            } else {
                                // Binary operator: () && ()
                                // Binary operator: () && ()
                                // Binary operator: $option == "default"
                                TclObject tmp144 = getVarScalar(interp, "option", compiledLocals, 13);
                                boolean tmp145 = tmp144.toString().equals("default");
                                ExprValue tmp146 = evs0;
                                tmp146.setIntValue(tmp145);
                                // End Binary operator: ==
                                if (tmp146.getBooleanValue(interp)) {
                                // Unary operator: ! $found_option_terminator
                                TclObject tmp147 = getVarScalar(interp, "found_option_terminator", compiledLocals, 15);
                                ExprValue tmp148 = evs1;
                                if ( tmp147.isIntType() ) {
                                    TJC.exprUnaryNotOperatorKnownInt(tmp148, tmp147);
                                } else {
                                    TJC.exprUnaryNotOperator(interp, tmp148, tmp147);
                                }
                                // End Unary operator: !
                                tmp146.setIntValue(tmp148.getBooleanValue(interp));
                                } else {
                                tmp146.setIntValue(0);
                                } // End if: ()
                                // End Binary operator: &&
                                if (tmp146.getBooleanValue(interp)) {
                                // Unary operator: ! $arg1_undetermined
                                TclObject tmp149 = getVarScalar(interp, "arg1_undetermined", compiledLocals, 20);
                                ExprValue tmp150 = evs1;
                                if ( tmp149.isIntType() ) {
                                    TJC.exprUnaryNotOperatorKnownInt(tmp150, tmp149);
                                } else {
                                    TJC.exprUnaryNotOperator(interp, tmp150, tmp149);
                                }
                                // End Unary operator: !
                                tmp146.setIntValue(tmp150.getBooleanValue(interp));
                                } else {
                                tmp146.setIntValue(0);
                                } // End if: ()
                                // End Binary operator: &&
                                boolean tmp151 = ( tmp146.getIntValue() != 0 );
                                if ( tmp151 ) {
                                    { // Invoke: set sIndex 1
                                        setVarScalar(interp, "sIndex", const9, compiledLocals, 19);
                                    } // End Invoke: set
                                    { // Invoke: lappend patlist 2 3
                                        TclObject[] objv152 = TJC.grabObjv(interp, 2);
                                        TclObject tmp153;
                                        try {
                                            // Arg 2 constant: 2
                                            objv152[0] = const20;
                                            // Arg 3 constant: 3
                                            objv152[1] = const22;
                                            interp.resetResult();
                                            lappendVarScalar(interp, "patlist", objv152, compiledLocals, 17);
                                        } finally {
                                            TJC.releaseObjv(interp, objv152, 2);
                                        }
                                    } // End Invoke: lappend
                                } else {
                                    { // Invoke: return [...]
                                        { // Invoke: list nonStatic switch
                                            TclObject tmp154 = TclList.newInstance();
                                            try {
                                                TclList.append(interp, tmp154, const21);
                                                TclList.append(interp, tmp154, const11);
                                            } catch (TclException ex) {
                                                tmp154.release();
                                                throw ex;
                                            }
                                            interp.setResult(tmp154);
                                        } // End Invoke: list
                                        if ( true ) { return; }
                                    } // End Invoke: return
                                }
                            }
                        }
                    } // End Invoke: if
                } else {
                    // Binary operator: $num_args == 5
                    TclObject tmp155 = getVarScalar(interp, "num_args", compiledLocals, 9);
                    ExprValue tmp156 = evs0;
                    TJC.exprInitValue(interp, tmp156, tmp155);
                    ExprValue tmp157 = evs1;
                    tmp157.setIntValue(5);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp156, tmp157);
                    // End Binary operator: ==
                    boolean tmp158 = ( tmp156.getIntValue() != 0 );
                    if ( tmp158 ) {
                        { // Invoke: set subtree [...]
                            TclObject tmp159;
                            { // Invoke: lindex $tree 3
                                TclObject tmp160 = getVarScalar(interp, "tree", compiledLocals, 3);
                                tmp160 = TclList.index(interp, tmp160, 3);
                                if ( tmp160 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp160);
                                }
                            } // End Invoke: lindex
                            tmp159 = interp.getResult();
                            setVarScalar(interp, "subtree", tmp159, compiledLocals, 22);
                        } // End Invoke: set
                        { // Invoke: if ... ... else ...
                            { // Invoke: parse_is_simple_text $subtree
                                TclObject[] objv161 = TJC.grabObjv(interp, 2);
                                TclObject tmp162;
                                try {
                                    // Arg 0 constant: parse_is_simple_text
                                    objv161[0] = const15;
                                    // Arg 1 variable: $subtree
                                    tmp162 = getVarScalar(interp, "subtree", compiledLocals, 22);
                                    tmp162.preserve();
                                    objv161[1] = tmp162;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                        ? cmdcache2.cmd : null), objv161, 0);
                                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                        updateCmdCache(interp, 2);
                                    }
                                } finally {
                                    tmp162 = objv161[1];
                                    if ( tmp162 != null ) {
                                        tmp162.release();
                                    }
                                    TJC.releaseObjv(interp, objv161, 2);
                                }
                            } // End Invoke: parse_is_simple_text
                            TclObject tmp163 = interp.getResult();
                            ExprValue tmp164 = evs0;
                            TJC.exprInitValue(interp, tmp164, tmp163);
                            boolean tmp165 = tmp164.getBooleanValue(interp);
                            if ( tmp165 ) {
                                { // Invoke: set arg3_undetermined 0
                                    setVarScalar(interp, "arg3_undetermined", const5, compiledLocals, 24);
                                } // End Invoke: set
                            } else {
                                { // Invoke: set arg3_undetermined 1
                                    setVarScalar(interp, "arg3_undetermined", const9, compiledLocals, 24);
                                } // End Invoke: set
                            }
                        } // End Invoke: if
                        { // Invoke: if ... ... elseif ... ... elseif ... ... else ...
                            // Binary operator: () && ()
                            // Binary operator: () && $found_option_terminator
                            // Binary operator: $option != "default"
                            TclObject tmp166 = getVarScalar(interp, "option", compiledLocals, 13);
                            boolean tmp167 = ! tmp166.toString().equals("default");
                            ExprValue tmp168 = evs0;
                            tmp168.setIntValue(tmp167);
                            // End Binary operator: !=
                            if (tmp168.getBooleanValue(interp)) {
                            TclObject tmp169 = getVarScalar(interp, "found_option_terminator", compiledLocals, 15);
                            ExprValue tmp170 = evs1;
                            TJC.exprInitValue(interp, tmp170, tmp169);
                            tmp168.setIntValue(tmp170.getBooleanValue(interp));
                            } else {
                            tmp168.setIntValue(0);
                            } // End if: ()
                            // End Binary operator: &&
                            if (tmp168.getBooleanValue(interp)) {
                            // Binary operator: $tIndex == 2
                            TclObject tmp171 = getVarScalar(interp, "tIndex", compiledLocals, 18);
                            ExprValue tmp172 = evs1;
                            TJC.exprInitValue(interp, tmp172, tmp171);
                            ExprValue tmp173 = evs2;
                            tmp173.setIntValue(2);
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp172, tmp173);
                            // End Binary operator: ==
                            tmp168.setIntValue(tmp172.getBooleanValue(interp));
                            } else {
                            tmp168.setIntValue(0);
                            } // End if: ()
                            // End Binary operator: &&
                            boolean tmp174 = ( tmp168.getIntValue() != 0 );
                            if ( tmp174 ) {
                                { // Invoke: set sIndex 3
                                    setVarScalar(interp, "sIndex", const22, compiledLocals, 19);
                                } // End Invoke: set
                                { // Invoke: lappend patlist 4
                                    TclObject[] objv175 = TJC.grabObjv(interp, 1);
                                    TclObject tmp176;
                                    try {
                                        // Arg 2 constant: 4
                                        objv175[0] = const23;
                                        interp.resetResult();
                                        lappendVarScalar(interp, "patlist", objv175, compiledLocals, 17);
                                    } finally {
                                        TJC.releaseObjv(interp, objv175, 1);
                                    }
                                } // End Invoke: lappend
                            } else {
                                // Binary operator: () && ()
                                // Binary operator: () && ()
                                // Binary operator: $option != "default"
                                TclObject tmp177 = getVarScalar(interp, "option", compiledLocals, 13);
                                boolean tmp178 = ! tmp177.toString().equals("default");
                                ExprValue tmp179 = evs0;
                                tmp179.setIntValue(tmp178);
                                // End Binary operator: !=
                                if (tmp179.getBooleanValue(interp)) {
                                // Unary operator: ! $found_option_terminator
                                TclObject tmp180 = getVarScalar(interp, "found_option_terminator", compiledLocals, 15);
                                ExprValue tmp181 = evs1;
                                if ( tmp180.isIntType() ) {
                                    TJC.exprUnaryNotOperatorKnownInt(tmp181, tmp180);
                                } else {
                                    TJC.exprUnaryNotOperator(interp, tmp181, tmp180);
                                }
                                // End Unary operator: !
                                tmp179.setIntValue(tmp181.getBooleanValue(interp));
                                } else {
                                tmp179.setIntValue(0);
                                } // End if: ()
                                // End Binary operator: &&
                                if (tmp179.getBooleanValue(interp)) {
                                // Unary operator: ! $arg3_undetermined
                                TclObject tmp182 = getVarScalar(interp, "arg3_undetermined", compiledLocals, 24);
                                ExprValue tmp183 = evs1;
                                if ( tmp182.isIntType() ) {
                                    TJC.exprUnaryNotOperatorKnownInt(tmp183, tmp182);
                                } else {
                                    TJC.exprUnaryNotOperator(interp, tmp183, tmp182);
                                }
                                // End Unary operator: !
                                tmp179.setIntValue(tmp183.getBooleanValue(interp));
                                } else {
                                tmp179.setIntValue(0);
                                } // End if: ()
                                // End Binary operator: &&
                                boolean tmp184 = ( tmp179.getIntValue() != 0 );
                                if ( tmp184 ) {
                                    { // Invoke: set sIndex 2
                                        setVarScalar(interp, "sIndex", const20, compiledLocals, 19);
                                    } // End Invoke: set
                                    { // Invoke: lappend patlist 3 4
                                        TclObject[] objv185 = TJC.grabObjv(interp, 2);
                                        TclObject tmp186;
                                        try {
                                            // Arg 2 constant: 3
                                            objv185[0] = const22;
                                            // Arg 3 constant: 4
                                            objv185[1] = const23;
                                            interp.resetResult();
                                            lappendVarScalar(interp, "patlist", objv185, compiledLocals, 17);
                                        } finally {
                                            TJC.releaseObjv(interp, objv185, 2);
                                        }
                                    } // End Invoke: lappend
                                } else {
                                    // Binary operator: () && ()
                                    // Binary operator: () && $found_option_terminator
                                    // Binary operator: $option == "default"
                                    TclObject tmp187 = getVarScalar(interp, "option", compiledLocals, 13);
                                    boolean tmp188 = tmp187.toString().equals("default");
                                    ExprValue tmp189 = evs0;
                                    tmp189.setIntValue(tmp188);
                                    // End Binary operator: ==
                                    if (tmp189.getBooleanValue(interp)) {
                                    TclObject tmp190 = getVarScalar(interp, "found_option_terminator", compiledLocals, 15);
                                    ExprValue tmp191 = evs1;
                                    TJC.exprInitValue(interp, tmp191, tmp190);
                                    tmp189.setIntValue(tmp191.getBooleanValue(interp));
                                    } else {
                                    tmp189.setIntValue(0);
                                    } // End if: ()
                                    // End Binary operator: &&
                                    if (tmp189.getBooleanValue(interp)) {
                                    // Binary operator: $tIndex == 1
                                    TclObject tmp192 = getVarScalar(interp, "tIndex", compiledLocals, 18);
                                    ExprValue tmp193 = evs1;
                                    TJC.exprInitValue(interp, tmp193, tmp192);
                                    ExprValue tmp194 = evs2;
                                    tmp194.setIntValue(1);
                                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp193, tmp194);
                                    // End Binary operator: ==
                                    tmp189.setIntValue(tmp193.getBooleanValue(interp));
                                    } else {
                                    tmp189.setIntValue(0);
                                    } // End if: ()
                                    // End Binary operator: &&
                                    boolean tmp195 = ( tmp189.getIntValue() != 0 );
                                    if ( tmp195 ) {
                                        { // Invoke: set sIndex 2
                                            setVarScalar(interp, "sIndex", const20, compiledLocals, 19);
                                        } // End Invoke: set
                                        { // Invoke: lappend patlist 3 4
                                            TclObject[] objv196 = TJC.grabObjv(interp, 2);
                                            TclObject tmp197;
                                            try {
                                                // Arg 2 constant: 3
                                                objv196[0] = const22;
                                                // Arg 3 constant: 4
                                                objv196[1] = const23;
                                                interp.resetResult();
                                                lappendVarScalar(interp, "patlist", objv196, compiledLocals, 17);
                                            } finally {
                                                TJC.releaseObjv(interp, objv196, 2);
                                            }
                                        } // End Invoke: lappend
                                    } else {
                                        { // Invoke: return [...]
                                            { // Invoke: list nonStatic switch
                                                TclObject tmp198 = TclList.newInstance();
                                                try {
                                                    TclList.append(interp, tmp198, const21);
                                                    TclList.append(interp, tmp198, const11);
                                                } catch (TclException ex) {
                                                    tmp198.release();
                                                    throw ex;
                                                }
                                                interp.setResult(tmp198);
                                            } // End Invoke: list
                                            if ( true ) { return; }
                                        } // End Invoke: return
                                    }
                                }
                            }
                        } // End Invoke: if
                    } else {
                        // Binary operator: $num_args >= 6
                        TclObject tmp199 = getVarScalar(interp, "num_args", compiledLocals, 9);
                        ExprValue tmp200 = evs0;
                        TJC.exprInitValue(interp, tmp200, tmp199);
                        ExprValue tmp201 = evs1;
                        tmp201.setIntValue(6);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GEQ, tmp200, tmp201);
                        // End Binary operator: >=
                        boolean tmp202 = ( tmp200.getIntValue() != 0 );
                        if ( tmp202 ) {
                            { // Invoke: if ... ... elseif ... ... elseif ... ...
                                // Binary operator: () || ()
                                // Binary operator: () && ()
                                // Binary operator: $option == "default"
                                TclObject tmp203 = getVarScalar(interp, "option", compiledLocals, 13);
                                boolean tmp204 = tmp203.toString().equals("default");
                                ExprValue tmp205 = evs0;
                                tmp205.setIntValue(tmp204);
                                // End Binary operator: ==
                                if (tmp205.getBooleanValue(interp)) {
                                // Binary operator: () || ()
                                // Binary operator: $found_option_terminator && $arg1_undetermined
                                TclObject tmp206 = getVarScalar(interp, "found_option_terminator", compiledLocals, 15);
                                ExprValue tmp207 = evs1;
                                TJC.exprInitValue(interp, tmp207, tmp206);
                                if (tmp207.getBooleanValue(interp)) {
                                TclObject tmp208 = getVarScalar(interp, "arg1_undetermined", compiledLocals, 20);
                                ExprValue tmp209 = evs2;
                                TJC.exprInitValue(interp, tmp209, tmp208);
                                tmp207.setIntValue(tmp209.getBooleanValue(interp));
                                } else {
                                tmp207.setIntValue(0);
                                } // End if: $found_option_terminator
                                // End Binary operator: &&
                                if (!tmp207.getBooleanValue(interp)) {
                                // Binary operator: $arg1_undetermined && $arg2_undetermined
                                TclObject tmp210 = getVarScalar(interp, "arg1_undetermined", compiledLocals, 20);
                                ExprValue tmp211 = evs2;
                                TJC.exprInitValue(interp, tmp211, tmp210);
                                if (tmp211.getBooleanValue(interp)) {
                                TclObject tmp212 = getVarScalar(interp, "arg2_undetermined", compiledLocals, 21);
                                ExprValue tmp213 = evs3;
                                TJC.exprInitValue(interp, tmp213, tmp212);
                                tmp211.setIntValue(tmp213.getBooleanValue(interp));
                                } else {
                                tmp211.setIntValue(0);
                                } // End if: $arg1_undetermined
                                // End Binary operator: &&
                                tmp207.setIntValue(tmp211.getBooleanValue(interp));
                                } else {
                                tmp207.setIntValue(1);
                                } // End if: !()
                                // End Binary operator: ||
                                tmp205.setIntValue(tmp207.getBooleanValue(interp));
                                } else {
                                tmp205.setIntValue(0);
                                } // End if: ()
                                // End Binary operator: &&
                                if (!tmp205.getBooleanValue(interp)) {
                                // Binary operator: () && $arg2_undetermined
                                // Binary operator: $option != "default"
                                TclObject tmp214 = getVarScalar(interp, "option", compiledLocals, 13);
                                boolean tmp215 = ! tmp214.toString().equals("default");
                                ExprValue tmp216 = evs1;
                                tmp216.setIntValue(tmp215);
                                // End Binary operator: !=
                                if (tmp216.getBooleanValue(interp)) {
                                TclObject tmp217 = getVarScalar(interp, "arg2_undetermined", compiledLocals, 21);
                                ExprValue tmp218 = evs2;
                                TJC.exprInitValue(interp, tmp218, tmp217);
                                tmp216.setIntValue(tmp218.getBooleanValue(interp));
                                } else {
                                tmp216.setIntValue(0);
                                } // End if: ()
                                // End Binary operator: &&
                                tmp205.setIntValue(tmp216.getBooleanValue(interp));
                                } else {
                                tmp205.setIntValue(1);
                                } // End if: !()
                                // End Binary operator: ||
                                boolean tmp219 = ( tmp205.getIntValue() != 0 );
                                if ( tmp219 ) {
                                    { // Invoke: return [...]
                                        { // Invoke: list nonStatic switch
                                            TclObject tmp220 = TclList.newInstance();
                                            try {
                                                TclList.append(interp, tmp220, const21);
                                                TclList.append(interp, tmp220, const11);
                                            } catch (TclException ex) {
                                                tmp220.release();
                                                throw ex;
                                            }
                                            interp.setResult(tmp220);
                                        } // End Invoke: list
                                        if ( true ) { return; }
                                    } // End Invoke: return
                                } else {
                                    // Binary operator: () && $found_option_terminator
                                    // Binary operator: $option != "default"
                                    TclObject tmp221 = getVarScalar(interp, "option", compiledLocals, 13);
                                    boolean tmp222 = ! tmp221.toString().equals("default");
                                    ExprValue tmp223 = evs0;
                                    tmp223.setIntValue(tmp222);
                                    // End Binary operator: !=
                                    if (tmp223.getBooleanValue(interp)) {
                                    TclObject tmp224 = getVarScalar(interp, "found_option_terminator", compiledLocals, 15);
                                    ExprValue tmp225 = evs1;
                                    TJC.exprInitValue(interp, tmp225, tmp224);
                                    tmp223.setIntValue(tmp225.getBooleanValue(interp));
                                    } else {
                                    tmp223.setIntValue(0);
                                    } // End if: ()
                                    // End Binary operator: &&
                                    boolean tmp226 = ( tmp223.getIntValue() != 0 );
                                    if ( tmp226 ) {
                                        { // Invoke: set sIndex 3
                                            setVarScalar(interp, "sIndex", const22, compiledLocals, 19);
                                        } // End Invoke: set
                                        { // Invoke: if {$num_args == 6} ... else ...
                                            // Binary operator: $num_args == 6
                                            TclObject tmp227 = getVarScalar(interp, "num_args", compiledLocals, 9);
                                            ExprValue tmp228 = evs0;
                                            TJC.exprInitValue(interp, tmp228, tmp227);
                                            ExprValue tmp229 = evs1;
                                            tmp229.setIntValue(6);
                                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp228, tmp229);
                                            // End Binary operator: ==
                                            boolean tmp230 = ( tmp228.getIntValue() != 0 );
                                            if ( tmp230 ) {
                                                { // Invoke: lappend patlist 4 5
                                                    TclObject[] objv231 = TJC.grabObjv(interp, 2);
                                                    TclObject tmp232;
                                                    try {
                                                        // Arg 2 constant: 4
                                                        objv231[0] = const23;
                                                        // Arg 3 constant: 5
                                                        objv231[1] = const24;
                                                        interp.resetResult();
                                                        lappendVarScalar(interp, "patlist", objv231, compiledLocals, 17);
                                                    } finally {
                                                        TJC.releaseObjv(interp, objv231, 2);
                                                    }
                                                } // End Invoke: lappend
                                            } else {
                                                { // Invoke: if ... ... else ...
                                                    // Binary operator: () != 0
                                                    // Binary operator: () % 2
                                                    // Binary operator: $num_args - 6
                                                    TclObject tmp233 = getVarScalar(interp, "num_args", compiledLocals, 9);
                                                    ExprValue tmp234 = evs0;
                                                    TJC.exprInitValue(interp, tmp234, tmp233);
                                                    ExprValue tmp235 = evs1;
                                                    tmp235.setIntValue(6);
                                                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MINUS, tmp234, tmp235);
                                                    // End Binary operator: -
                                                    ExprValue tmp236 = evs1;
                                                    tmp236.setIntValue(2);
                                                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MOD, tmp234, tmp236);
                                                    // End Binary operator: %
                                                    ExprValue tmp237 = evs1;
                                                    tmp237.setIntValue(0);
                                                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp234, tmp237);
                                                    // End Binary operator: !=
                                                    boolean tmp238 = ( tmp234.getIntValue() != 0 );
                                                    if ( tmp238 ) {
                                                        { // Invoke: set _descend($key,usage) 1
                                                            TclObject tmp239;
                                                            String tmp240;
                                                            StringBuffer sbtmp241 = new StringBuffer(64);
                                                            tmp239 = getVarScalar(interp, "key", compiledLocals, 0);
                                                            sbtmp241.append(tmp239.toString());
                                                            sbtmp241.append(",usage");
                                                            tmp240 = sbtmp241.toString();
                                                            setVarArray(interp, "_descend", tmp240, const9, compiledLocals, 1);
                                                        } // End Invoke: set
                                                        { // Invoke: return [...]
                                                            { // Invoke: list numArgs switch $num_args
                                                                TclObject tmp242 = TclList.newInstance();
                                                                TclObject tmp243;
                                                                try {
                                                                    TclList.append(interp, tmp242, const10);
                                                                    TclList.append(interp, tmp242, const11);
                                                                    tmp243 = getVarScalar(interp, "num_args", compiledLocals, 9);
                                                                    TclList.append(interp, tmp242, tmp243);
                                                                } catch (TclException ex) {
                                                                    tmp242.release();
                                                                    throw ex;
                                                                }
                                                                interp.setResult(tmp242);
                                                            } // End Invoke: list
                                                            if ( true ) { return; }
                                                        } // End Invoke: return
                                                    } else {
                                                        { // Invoke: lappend patlist 4 5
                                                            TclObject[] objv244 = TJC.grabObjv(interp, 2);
                                                            TclObject tmp245;
                                                            try {
                                                                // Arg 2 constant: 4
                                                                objv244[0] = const23;
                                                                // Arg 3 constant: 5
                                                                objv244[1] = const24;
                                                                interp.resetResult();
                                                                lappendVarScalar(interp, "patlist", objv244, compiledLocals, 17);
                                                            } finally {
                                                                TJC.releaseObjv(interp, objv244, 2);
                                                            }
                                                        } // End Invoke: lappend
                                                        { // Invoke: for {set i 6} {$i < $num_args} {incr i 2} ...
                                                            { // Invoke: set i 6
                                                                setVarScalar(interp, "i", const25, compiledLocals, 25);
                                                            } // End Invoke: set
                                                            for ( boolean skip251 = true ; true ; ) {
                                                                if ( skip251 ) {
                                                                    skip251 = false;
                                                                } else {
                                                                    try {
                                                                    if ( false ) { throw (TclException) null; }
                                                                    { // Invoke: incr i 2
                                                                        interp.resetResult();
                                                                        incrVarScalar(interp, "i", 2, compiledLocals, 25);
                                                                    } // End Invoke: incr
                                                                    } catch (TclException ex) {
                                                                        int type = ex.getCompletionCode();
                                                                        if (type == TCL.BREAK) {
                                                                            break;
                                                                        } else {
                                                                            throw ex;
                                                                        }
                                                                    }
                                                                }

                                                                // Binary operator: $i < $num_args
                                                                TclObject tmp246 = getVarScalar(interp, "i", compiledLocals, 25);
                                                                ExprValue tmp247 = evs0;
                                                                TJC.exprInitValue(interp, tmp247, tmp246);
                                                                TclObject tmp248 = getVarScalar(interp, "num_args", compiledLocals, 9);
                                                                ExprValue tmp249 = evs1;
                                                                TJC.exprInitValue(interp, tmp249, tmp248);
                                                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp247, tmp249);
                                                                // End Binary operator: <
                                                                boolean tmp250 = ( tmp247.getIntValue() != 0 );
                                                                if ( ! tmp250 ) { break; }

                                                                try {
                                                                if ( false ) { throw (TclException) null; }
                                                                { // Invoke: lappend patlist $i [...]
                                                                    TclObject[] objv252 = TJC.grabObjv(interp, 2);
                                                                    TclObject tmp253;
                                                                    try {
                                                                        // Arg 2 variable: $i
                                                                        tmp253 = getVarScalar(interp, "i", compiledLocals, 25);
                                                                        tmp253.preserve();
                                                                        objv252[0] = tmp253;
                                                                        // Arg 3 command: [...]
                                                                        { // Invoke: expr {$i + 1}
                                                                            // Binary operator: $i + 1
                                                                            TclObject tmp254 = getVarScalar(interp, "i", compiledLocals, 25);
                                                                            ExprValue tmp255 = evs0;
                                                                            TJC.exprInitValue(interp, tmp255, tmp254);
                                                                            ExprValue tmp256 = evs1;
                                                                            tmp256.setIntValue(1);
                                                                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_PLUS, tmp255, tmp256);
                                                                            // End Binary operator: +
                                                                            TJC.exprSetResult(interp, tmp255);
                                                                        } // End Invoke: expr
                                                                        tmp253 = interp.getResult();
                                                                        tmp253.preserve();
                                                                        objv252[1] = tmp253;
                                                                        interp.resetResult();
                                                                        lappendVarScalar(interp, "patlist", objv252, compiledLocals, 17);
                                                                    } finally {
                                                                        TJC.releaseObjvElems(interp, objv252, 2);
                                                                    }
                                                                } // End Invoke: lappend
                                                                } catch (TclException ex) {
                                                                    int type = ex.getCompletionCode();
                                                                    if (type == TCL.BREAK) {
                                                                        break;
                                                                    } else if (type == TCL.CONTINUE) {
                                                                        continue;
                                                                    } else {
                                                                        throw ex;
                                                                    }
                                                                }
                                                            }
                                                        } // End Invoke: for
                                                    }
                                                } // End Invoke: if
                                            }
                                        } // End Invoke: if
                                    } else {
                                        // Binary operator: () && ()
                                        // Binary operator: $option == "default"
                                        TclObject tmp257 = getVarScalar(interp, "option", compiledLocals, 13);
                                        boolean tmp258 = tmp257.toString().equals("default");
                                        ExprValue tmp259 = evs0;
                                        tmp259.setIntValue(tmp258);
                                        // End Binary operator: ==
                                        if (tmp259.getBooleanValue(interp)) {
                                        // Unary operator: ! $found_option_terminator
                                        TclObject tmp260 = getVarScalar(interp, "found_option_terminator", compiledLocals, 15);
                                        ExprValue tmp261 = evs1;
                                        if ( tmp260.isIntType() ) {
                                            TJC.exprUnaryNotOperatorKnownInt(tmp261, tmp260);
                                        } else {
                                            TJC.exprUnaryNotOperator(interp, tmp261, tmp260);
                                        }
                                        // End Unary operator: !
                                        tmp259.setIntValue(tmp261.getBooleanValue(interp));
                                        } else {
                                        tmp259.setIntValue(0);
                                        } // End if: ()
                                        // End Binary operator: &&
                                        boolean tmp262 = ( tmp259.getIntValue() != 0 );
                                        if ( tmp262 ) {
                                            { // Invoke: set sIndex 1
                                                setVarScalar(interp, "sIndex", const9, compiledLocals, 19);
                                            } // End Invoke: set
                                            { // Invoke: if {$num_args == 6} ... else ...
                                                // Binary operator: $num_args == 6
                                                TclObject tmp263 = getVarScalar(interp, "num_args", compiledLocals, 9);
                                                ExprValue tmp264 = evs0;
                                                TJC.exprInitValue(interp, tmp264, tmp263);
                                                ExprValue tmp265 = evs1;
                                                tmp265.setIntValue(6);
                                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp264, tmp265);
                                                // End Binary operator: ==
                                                boolean tmp266 = ( tmp264.getIntValue() != 0 );
                                                if ( tmp266 ) {
                                                    { // Invoke: lappend patlist 2 3 4 5
                                                        TclObject[] objv267 = TJC.grabObjv(interp, 4);
                                                        TclObject tmp268;
                                                        try {
                                                            // Arg 2 constant: 2
                                                            objv267[0] = const20;
                                                            // Arg 3 constant: 3
                                                            objv267[1] = const22;
                                                            // Arg 4 constant: 4
                                                            objv267[2] = const23;
                                                            // Arg 5 constant: 5
                                                            objv267[3] = const24;
                                                            interp.resetResult();
                                                            lappendVarScalar(interp, "patlist", objv267, compiledLocals, 17);
                                                        } finally {
                                                            TJC.releaseObjv(interp, objv267, 4);
                                                        }
                                                    } // End Invoke: lappend
                                                } else {
                                                    { // Invoke: if ... ... else ...
                                                        // Binary operator: () != 0
                                                        // Binary operator: () % 2
                                                        // Binary operator: $num_args - 6
                                                        TclObject tmp269 = getVarScalar(interp, "num_args", compiledLocals, 9);
                                                        ExprValue tmp270 = evs0;
                                                        TJC.exprInitValue(interp, tmp270, tmp269);
                                                        ExprValue tmp271 = evs1;
                                                        tmp271.setIntValue(6);
                                                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MINUS, tmp270, tmp271);
                                                        // End Binary operator: -
                                                        ExprValue tmp272 = evs1;
                                                        tmp272.setIntValue(2);
                                                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MOD, tmp270, tmp272);
                                                        // End Binary operator: %
                                                        ExprValue tmp273 = evs1;
                                                        tmp273.setIntValue(0);
                                                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp270, tmp273);
                                                        // End Binary operator: !=
                                                        boolean tmp274 = ( tmp270.getIntValue() != 0 );
                                                        if ( tmp274 ) {
                                                            { // Invoke: set _descend($key,usage) 1
                                                                TclObject tmp275;
                                                                String tmp276;
                                                                StringBuffer sbtmp277 = new StringBuffer(64);
                                                                tmp275 = getVarScalar(interp, "key", compiledLocals, 0);
                                                                sbtmp277.append(tmp275.toString());
                                                                sbtmp277.append(",usage");
                                                                tmp276 = sbtmp277.toString();
                                                                setVarArray(interp, "_descend", tmp276, const9, compiledLocals, 1);
                                                            } // End Invoke: set
                                                            { // Invoke: return [...]
                                                                { // Invoke: list numArgs switch $num_args
                                                                    TclObject tmp278 = TclList.newInstance();
                                                                    TclObject tmp279;
                                                                    try {
                                                                        TclList.append(interp, tmp278, const10);
                                                                        TclList.append(interp, tmp278, const11);
                                                                        tmp279 = getVarScalar(interp, "num_args", compiledLocals, 9);
                                                                        TclList.append(interp, tmp278, tmp279);
                                                                    } catch (TclException ex) {
                                                                        tmp278.release();
                                                                        throw ex;
                                                                    }
                                                                    interp.setResult(tmp278);
                                                                } // End Invoke: list
                                                                if ( true ) { return; }
                                                            } // End Invoke: return
                                                        } else {
                                                            { // Invoke: lappend patlist 2 3 4 5
                                                                TclObject[] objv280 = TJC.grabObjv(interp, 4);
                                                                TclObject tmp281;
                                                                try {
                                                                    // Arg 2 constant: 2
                                                                    objv280[0] = const20;
                                                                    // Arg 3 constant: 3
                                                                    objv280[1] = const22;
                                                                    // Arg 4 constant: 4
                                                                    objv280[2] = const23;
                                                                    // Arg 5 constant: 5
                                                                    objv280[3] = const24;
                                                                    interp.resetResult();
                                                                    lappendVarScalar(interp, "patlist", objv280, compiledLocals, 17);
                                                                } finally {
                                                                    TJC.releaseObjv(interp, objv280, 4);
                                                                }
                                                            } // End Invoke: lappend
                                                            { // Invoke: for {set i 6} {$i < $num_args} {incr i 2} ...
                                                                { // Invoke: set i 6
                                                                    setVarScalar(interp, "i", const25, compiledLocals, 25);
                                                                } // End Invoke: set
                                                                for ( boolean skip287 = true ; true ; ) {
                                                                    if ( skip287 ) {
                                                                        skip287 = false;
                                                                    } else {
                                                                        try {
                                                                        if ( false ) { throw (TclException) null; }
                                                                        { // Invoke: incr i 2
                                                                            interp.resetResult();
                                                                            incrVarScalar(interp, "i", 2, compiledLocals, 25);
                                                                        } // End Invoke: incr
                                                                        } catch (TclException ex) {
                                                                            int type = ex.getCompletionCode();
                                                                            if (type == TCL.BREAK) {
                                                                                break;
                                                                            } else {
                                                                                throw ex;
                                                                            }
                                                                        }
                                                                    }

                                                                    // Binary operator: $i < $num_args
                                                                    TclObject tmp282 = getVarScalar(interp, "i", compiledLocals, 25);
                                                                    ExprValue tmp283 = evs0;
                                                                    TJC.exprInitValue(interp, tmp283, tmp282);
                                                                    TclObject tmp284 = getVarScalar(interp, "num_args", compiledLocals, 9);
                                                                    ExprValue tmp285 = evs1;
                                                                    TJC.exprInitValue(interp, tmp285, tmp284);
                                                                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp283, tmp285);
                                                                    // End Binary operator: <
                                                                    boolean tmp286 = ( tmp283.getIntValue() != 0 );
                                                                    if ( ! tmp286 ) { break; }

                                                                    try {
                                                                    if ( false ) { throw (TclException) null; }
                                                                    { // Invoke: lappend patlist $i [...]
                                                                        TclObject[] objv288 = TJC.grabObjv(interp, 2);
                                                                        TclObject tmp289;
                                                                        try {
                                                                            // Arg 2 variable: $i
                                                                            tmp289 = getVarScalar(interp, "i", compiledLocals, 25);
                                                                            tmp289.preserve();
                                                                            objv288[0] = tmp289;
                                                                            // Arg 3 command: [...]
                                                                            { // Invoke: expr {$i + 1}
                                                                                // Binary operator: $i + 1
                                                                                TclObject tmp290 = getVarScalar(interp, "i", compiledLocals, 25);
                                                                                ExprValue tmp291 = evs0;
                                                                                TJC.exprInitValue(interp, tmp291, tmp290);
                                                                                ExprValue tmp292 = evs1;
                                                                                tmp292.setIntValue(1);
                                                                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_PLUS, tmp291, tmp292);
                                                                                // End Binary operator: +
                                                                                TJC.exprSetResult(interp, tmp291);
                                                                            } // End Invoke: expr
                                                                            tmp289 = interp.getResult();
                                                                            tmp289.preserve();
                                                                            objv288[1] = tmp289;
                                                                            interp.resetResult();
                                                                            lappendVarScalar(interp, "patlist", objv288, compiledLocals, 17);
                                                                        } finally {
                                                                            TJC.releaseObjvElems(interp, objv288, 2);
                                                                        }
                                                                    } // End Invoke: lappend
                                                                    } catch (TclException ex) {
                                                                        int type = ex.getCompletionCode();
                                                                        if (type == TCL.BREAK) {
                                                                            break;
                                                                        } else if (type == TCL.CONTINUE) {
                                                                            continue;
                                                                        } else {
                                                                            throw ex;
                                                                        }
                                                                    }
                                                                }
                                                            } // End Invoke: for
                                                        }
                                                    } // End Invoke: if
                                                }
                                            } // End Invoke: if
                                        }
                                    }
                                }
                            } // End Invoke: if
                        }
                    }
                }
            }
        } // End Invoke: if
        { // Invoke: if ... ... elseif ... ... else ...
            // Binary operator: [...] == 0
            { // Invoke: llength $patlist
                TclObject tmp293 = getVarScalar(interp, "patlist", compiledLocals, 17);
                int tmp294 = TclList.getLength(interp, tmp293);
                interp.setResult(tmp294);
            } // End Invoke: llength
            TclObject tmp295 = interp.getResult();
            ExprValue tmp296 = evs0;
            TJC.exprInitValue(interp, tmp296, tmp295);
            ExprValue tmp297 = evs1;
            tmp297.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp296, tmp297);
            // End Binary operator: ==
            boolean tmp298 = ( tmp296.getIntValue() != 0 );
            if ( tmp298 ) {
                { // Invoke: error ...
                    TclObject[] objv299 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: error
                        objv299[0] = const26;
                        // Arg 1 constant: ...
                        objv299[1] = const27;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                            ? cmdcache5.cmd : null), objv299, 0);
                        if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                            updateCmdCache(interp, 5);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv299, 2);
                    }
                } // End Invoke: error
            } else {
                // Binary operator: [...] == 1
                { // Invoke: llength $patlist
                    TclObject tmp300 = getVarScalar(interp, "patlist", compiledLocals, 17);
                    int tmp301 = TclList.getLength(interp, tmp300);
                    interp.setResult(tmp301);
                } // End Invoke: llength
                TclObject tmp302 = interp.getResult();
                ExprValue tmp303 = evs0;
                TJC.exprInitValue(interp, tmp303, tmp302);
                ExprValue tmp304 = evs1;
                tmp304.setIntValue(1);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp303, tmp304);
                // End Binary operator: ==
                boolean tmp305 = ( tmp303.getIntValue() != 0 );
                if ( tmp305 ) {
                    { // Invoke: set pindex [...]
                        TclObject tmp306;
                        { // Invoke: lindex $patlist 0
                            TclObject tmp307 = getVarScalar(interp, "patlist", compiledLocals, 17);
                            tmp307 = TclList.index(interp, tmp307, 0);
                            if ( tmp307 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp307);
                            }
                        } // End Invoke: lindex
                        tmp306 = interp.getResult();
                        setVarScalar(interp, "pindex", tmp306, compiledLocals, 26);
                    } // End Invoke: set
                    { // Invoke: set subtree [...]
                        TclObject tmp308;
                        { // Invoke: lindex $tree $pindex
                            TclObject tmp309 = null;
                            TclObject tmp310;
                            try {
                                tmp309 = getVarScalar(interp, "tree", compiledLocals, 3);
                                tmp309.preserve();
                                tmp310 = getVarScalar(interp, "pindex", compiledLocals, 26);
                                TJC.lindexNonconst(interp, tmp309, tmp310);
                            } finally {
                                if ( tmp309 != null ) {
                                    tmp309.release();
                                }
                            }
                        } // End Invoke: lindex
                        tmp308 = interp.getResult();
                        setVarScalar(interp, "subtree", tmp308, compiledLocals, 22);
                    } // End Invoke: set
                    { // Invoke: if ... ...
                        // Unary operator: ! [...]
                        { // Invoke: parse_is_simple_text $subtree
                            TclObject[] objv311 = TJC.grabObjv(interp, 2);
                            TclObject tmp312;
                            try {
                                // Arg 0 constant: parse_is_simple_text
                                objv311[0] = const15;
                                // Arg 1 variable: $subtree
                                tmp312 = getVarScalar(interp, "subtree", compiledLocals, 22);
                                tmp312.preserve();
                                objv311[1] = tmp312;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                    ? cmdcache2.cmd : null), objv311, 0);
                                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                    updateCmdCache(interp, 2);
                                }
                            } finally {
                                tmp312 = objv311[1];
                                if ( tmp312 != null ) {
                                    tmp312.release();
                                }
                                TJC.releaseObjv(interp, objv311, 2);
                            }
                        } // End Invoke: parse_is_simple_text
                        TclObject tmp313 = interp.getResult();
                        ExprValue tmp314 = evs0;
                        if ( tmp313.isIntType() ) {
                            TJC.exprUnaryNotOperatorKnownInt(tmp314, tmp313);
                        } else {
                            TJC.exprUnaryNotOperator(interp, tmp314, tmp313);
                        }
                        // End Unary operator: !
                        boolean tmp315 = ( tmp314.getIntValue() != 0 );
                        if ( tmp315 ) {
                            { // Invoke: return [...]
                                { // Invoke: list nonStatic switch $pindex
                                    TclObject tmp316 = TclList.newInstance();
                                    TclObject tmp317;
                                    try {
                                        TclList.append(interp, tmp316, const21);
                                        TclList.append(interp, tmp316, const11);
                                        tmp317 = getVarScalar(interp, "pindex", compiledLocals, 26);
                                        TclList.append(interp, tmp316, tmp317);
                                    } catch (TclException ex) {
                                        tmp316.release();
                                        throw ex;
                                    }
                                    interp.setResult(tmp316);
                                } // End Invoke: list
                                if ( true ) { return; }
                            } // End Invoke: return
                        }
                    } // End Invoke: if
                    { // Invoke: set braced_range [...]
                        TclObject tmp318;
                        { // Invoke: lindex $subtree 1
                            TclObject tmp319 = getVarScalar(interp, "subtree", compiledLocals, 22);
                            tmp319 = TclList.index(interp, tmp319, 1);
                            if ( tmp319 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp319);
                            }
                        } // End Invoke: lindex
                        tmp318 = interp.getResult();
                        setVarScalar(interp, "braced_range", tmp318, compiledLocals, 27);
                    } // End Invoke: set
                    { // Invoke: set braced_range_string [...]
                        TclObject tmp320;
                        { // Invoke: parse getstring $script $braced_range
                            TclObject[] objv321 = TJC.grabObjv(interp, 4);
                            TclObject tmp322;
                            try {
                                // Arg 0 constant: parse
                                objv321[0] = const28;
                                // Arg 1 constant: getstring
                                objv321[1] = const29;
                                // Arg 2 variable: $script
                                tmp322 = getVarScalar(interp, "script", compiledLocals, 2);
                                tmp322.preserve();
                                objv321[2] = tmp322;
                                // Arg 3 variable: $braced_range
                                tmp322 = getVarScalar(interp, "braced_range", compiledLocals, 27);
                                tmp322.preserve();
                                objv321[3] = tmp322;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                    ? cmdcache6.cmd : null), objv321, 0);
                                if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                    updateCmdCache(interp, 6);
                                }
                            } finally {
                                tmp322 = objv321[2];
                                if ( tmp322 != null ) {
                                    tmp322.release();
                                }
                                tmp322 = objv321[3];
                                if ( tmp322 != null ) {
                                    tmp322.release();
                                }
                                TJC.releaseObjv(interp, objv321, 4);
                            }
                        } // End Invoke: parse
                        tmp320 = interp.getResult();
                        setVarScalar(interp, "braced_range_string", tmp320, compiledLocals, 28);
                    } // End Invoke: set
                    { // Invoke: if ... ...
                        // Binary operator: () || ()
                        // Binary operator: [...] != "{"
                        { // Invoke: string index $braced_range_string 0
                            TclObject tmp323 = getVarScalar(interp, "braced_range_string", compiledLocals, 28);
                            String tmp324 = tmp323.toString();
                            TclObject tmp325 = TJC.stringIndex(interp, tmp324, const5);
                            interp.setResult(tmp325);
                        } // End Invoke: string
                        TclObject tmp326 = interp.getResult();
                        boolean tmp327 = ! tmp326.toString().equals("{");
                        ExprValue tmp328 = evs0;
                        tmp328.setIntValue(tmp327);
                        // End Binary operator: !=
                        if (!tmp328.getBooleanValue(interp)) {
                        // Binary operator: [...] != "}"
                        { // Invoke: string index $braced_range_string end
                            TclObject tmp329 = getVarScalar(interp, "braced_range_string", compiledLocals, 28);
                            String tmp330 = tmp329.toString();
                            TclObject tmp331 = TJC.stringIndex(interp, tmp330, const30);
                            interp.setResult(tmp331);
                        } // End Invoke: string
                        TclObject tmp332 = interp.getResult();
                        boolean tmp333 = ! tmp332.toString().equals("}");
                        ExprValue tmp334 = evs1;
                        tmp334.setIntValue(tmp333);
                        // End Binary operator: !=
                        tmp328.setIntValue(tmp334.getBooleanValue(interp));
                        } else {
                        tmp328.setIntValue(1);
                        } // End if: !()
                        // End Binary operator: ||
                        boolean tmp335 = ( tmp328.getIntValue() != 0 );
                        if ( tmp335 ) {
                            { // Invoke: return [...]
                                { // Invoke: list nonStatic switch $pindex
                                    TclObject tmp336 = TclList.newInstance();
                                    TclObject tmp337;
                                    try {
                                        TclList.append(interp, tmp336, const21);
                                        TclList.append(interp, tmp336, const11);
                                        tmp337 = getVarScalar(interp, "pindex", compiledLocals, 26);
                                        TclList.append(interp, tmp336, tmp337);
                                    } catch (TclException ex) {
                                        tmp336.release();
                                        throw ex;
                                    }
                                    interp.setResult(tmp336);
                                } // End Invoke: list
                                if ( true ) { return; }
                            } // End Invoke: return
                        }
                    } // End Invoke: if
                    { // Invoke: set text_range [...]
                        TclObject tmp338;
                        { // Invoke: lindex $subtree 2 0 1
                            TclObject[] objv339 = TJC.grabObjv(interp, 5);
                            TclObject tmp340;
                            try {
                                // Arg 0 constant: lindex
                                objv339[0] = const31;
                                // Arg 1 variable: $subtree
                                tmp340 = getVarScalar(interp, "subtree", compiledLocals, 22);
                                tmp340.preserve();
                                objv339[1] = tmp340;
                                // Arg 2 constant: 2
                                objv339[2] = const20;
                                // Arg 3 constant: 0
                                objv339[3] = const5;
                                // Arg 4 constant: 1
                                objv339[4] = const9;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                    ? cmdcache7.cmd : null), objv339, 0);
                                if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                    updateCmdCache(interp, 7);
                                }
                            } finally {
                                tmp340 = objv339[1];
                                if ( tmp340 != null ) {
                                    tmp340.release();
                                }
                                TJC.releaseObjv(interp, objv339, 5);
                            }
                        } // End Invoke: lindex
                        tmp338 = interp.getResult();
                        setVarScalar(interp, "text_range", tmp338, compiledLocals, 29);
                    } // End Invoke: set
                    { // Invoke: if ... ...
                        { // Invoke: catch ... result
                            int code341 = TCL.OK;
                            try {
                            if ( false ) { throw (TclException) null; }
                            { // Invoke: parse list $script $text_range
                                TclObject[] objv342 = TJC.grabObjv(interp, 4);
                                TclObject tmp343;
                                try {
                                    // Arg 0 constant: parse
                                    objv342[0] = const28;
                                    // Arg 1 constant: list
                                    objv342[1] = const32;
                                    // Arg 2 variable: $script
                                    tmp343 = getVarScalar(interp, "script", compiledLocals, 2);
                                    tmp343.preserve();
                                    objv342[2] = tmp343;
                                    // Arg 3 variable: $text_range
                                    tmp343 = getVarScalar(interp, "text_range", compiledLocals, 29);
                                    tmp343.preserve();
                                    objv342[3] = tmp343;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                        ? cmdcache6.cmd : null), objv342, 0);
                                    if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                        updateCmdCache(interp, 6);
                                    }
                                } finally {
                                    tmp343 = objv342[2];
                                    if ( tmp343 != null ) {
                                        tmp343.release();
                                    }
                                    tmp343 = objv342[3];
                                    if ( tmp343 != null ) {
                                        tmp343.release();
                                    }
                                    TJC.releaseObjv(interp, objv342, 4);
                                }
                            } // End Invoke: parse
                            } catch (TclException ex) {
                                code341 = ex.getCompletionCode();
                            }
                            TclObject result = interp.getResult();
                            try {
                                setVarScalar(interp, "result", result, compiledLocals, 30);
                            } catch (TclException ex) {
                                TJC.catchVarErr(interp);
                            }
                            interp.resetResult();
                            interp.setResult(code341);
                        } // End Invoke: catch
                        TclObject tmp344 = interp.getResult();
                        ExprValue tmp345 = evs0;
                        TJC.exprInitValue(interp, tmp345, tmp344);
                        boolean tmp346 = tmp345.getBooleanValue(interp);
                        if ( tmp346 ) {
                            { // Invoke: set _descend($key,usage) 1
                                TclObject tmp347;
                                String tmp348;
                                StringBuffer sbtmp349 = new StringBuffer(64);
                                tmp347 = getVarScalar(interp, "key", compiledLocals, 0);
                                sbtmp349.append(tmp347.toString());
                                sbtmp349.append(",usage");
                                tmp348 = sbtmp349.toString();
                                setVarArray(interp, "_descend", tmp348, const9, compiledLocals, 1);
                            } // End Invoke: set
                            { // Invoke: return [...]
                                { // Invoke: list invalidBody switch $pindex ...
                                    TclObject tmp350 = TclList.newInstance();
                                    TclObject tmp351;
                                    try {
                                        TclList.append(interp, tmp350, const33);
                                        TclList.append(interp, tmp350, const11);
                                        tmp351 = getVarScalar(interp, "pindex", compiledLocals, 26);
                                        TclList.append(interp, tmp350, tmp351);
                                        TclList.append(interp, tmp350, const34);
                                    } catch (TclException ex) {
                                        tmp350.release();
                                        throw ex;
                                    }
                                    interp.setResult(tmp350);
                                } // End Invoke: list
                                if ( true ) { return; }
                            } // End Invoke: return
                        }
                    } // End Invoke: if
                    { // Invoke: set list_ranges $result
                        TclObject tmp352;
                        tmp352 = getVarScalar(interp, "result", compiledLocals, 30);
                        setVarScalar(interp, "list_ranges", tmp352, compiledLocals, 31);
                    } // End Invoke: set
                    { // Invoke: if ... ...
                        // Binary operator: [...] == 0
                        { // Invoke: llength $list_ranges
                            TclObject tmp353 = getVarScalar(interp, "list_ranges", compiledLocals, 31);
                            int tmp354 = TclList.getLength(interp, tmp353);
                            interp.setResult(tmp354);
                        } // End Invoke: llength
                        TclObject tmp355 = interp.getResult();
                        ExprValue tmp356 = evs0;
                        TJC.exprInitValue(interp, tmp356, tmp355);
                        ExprValue tmp357 = evs1;
                        tmp357.setIntValue(0);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp356, tmp357);
                        // End Binary operator: ==
                        boolean tmp358 = ( tmp356.getIntValue() != 0 );
                        if ( tmp358 ) {
                            { // Invoke: set _descend($key,usage) 1
                                TclObject tmp359;
                                String tmp360;
                                StringBuffer sbtmp361 = new StringBuffer(64);
                                tmp359 = getVarScalar(interp, "key", compiledLocals, 0);
                                sbtmp361.append(tmp359.toString());
                                sbtmp361.append(",usage");
                                tmp360 = sbtmp361.toString();
                                setVarArray(interp, "_descend", tmp360, const9, compiledLocals, 1);
                            } // End Invoke: set
                            { // Invoke: return [...]
                                { // Invoke: list invalidBody switch $pindex ...
                                    TclObject tmp362 = TclList.newInstance();
                                    TclObject tmp363;
                                    try {
                                        TclList.append(interp, tmp362, const33);
                                        TclList.append(interp, tmp362, const11);
                                        tmp363 = getVarScalar(interp, "pindex", compiledLocals, 26);
                                        TclList.append(interp, tmp362, tmp363);
                                        TclList.append(interp, tmp362, const34);
                                    } catch (TclException ex) {
                                        tmp362.release();
                                        throw ex;
                                    }
                                    interp.setResult(tmp362);
                                } // End Invoke: list
                                if ( true ) { return; }
                            } // End Invoke: return
                        }
                    } // End Invoke: if
                    { // Invoke: if ... ...
                        // Binary operator: () != 0
                        // Binary operator: [...] % 2
                        { // Invoke: llength $list_ranges
                            TclObject tmp364 = getVarScalar(interp, "list_ranges", compiledLocals, 31);
                            int tmp365 = TclList.getLength(interp, tmp364);
                            interp.setResult(tmp365);
                        } // End Invoke: llength
                        TclObject tmp366 = interp.getResult();
                        ExprValue tmp367 = evs0;
                        TJC.exprInitValue(interp, tmp367, tmp366);
                        ExprValue tmp368 = evs1;
                        tmp368.setIntValue(2);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MOD, tmp367, tmp368);
                        // End Binary operator: %
                        ExprValue tmp369 = evs1;
                        tmp369.setIntValue(0);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp367, tmp369);
                        // End Binary operator: !=
                        boolean tmp370 = ( tmp367.getIntValue() != 0 );
                        if ( tmp370 ) {
                            { // Invoke: set _descend($key,usage) 1
                                TclObject tmp371;
                                String tmp372;
                                StringBuffer sbtmp373 = new StringBuffer(64);
                                tmp371 = getVarScalar(interp, "key", compiledLocals, 0);
                                sbtmp373.append(tmp371.toString());
                                sbtmp373.append(",usage");
                                tmp372 = sbtmp373.toString();
                                setVarArray(interp, "_descend", tmp372, const9, compiledLocals, 1);
                            } // End Invoke: set
                            { // Invoke: return [...]
                                { // Invoke: list invalidBody switch $pindex ...
                                    TclObject tmp374 = TclList.newInstance();
                                    TclObject tmp375;
                                    try {
                                        TclList.append(interp, tmp374, const33);
                                        TclList.append(interp, tmp374, const11);
                                        tmp375 = getVarScalar(interp, "pindex", compiledLocals, 26);
                                        TclList.append(interp, tmp374, tmp375);
                                        TclList.append(interp, tmp374, const35);
                                    } catch (TclException ex) {
                                        tmp374.release();
                                        throw ex;
                                    }
                                    interp.setResult(tmp374);
                                } // End Invoke: list
                                if ( true ) { return; }
                            } // End Invoke: return
                        }
                    } // End Invoke: if
                    { // Invoke: set is_pattern 1
                        setVarScalar(interp, "is_pattern", const9, compiledLocals, 32);
                    } // End Invoke: set
                    { // Invoke: foreach list_range $list_ranges ...
                        TclObject tmp376 = null;
                        try {
                            tmp376 = getVarScalar(interp, "list_ranges", compiledLocals, 31);
                            tmp376.preserve();
                            final int tmp376_length = TclList.getLength(interp, tmp376);

                            for ( int index377 = 0 ; index377 < tmp376_length ; index377++ ) {
                                TclObject tmp378 = TclList.index(interp, tmp376, index377);
                                try {
                                    setVarScalar(interp, "list_range", tmp378, compiledLocals, 33);
                                } catch (TclException ex) {
                                    TJC.foreachVarErr(interp, "list_range");
                                }

                                try {
                                if ( false ) { throw (TclException) null; }
                                { // Invoke: set str [...]
                                    TclObject tmp379;
                                    { // Invoke: parse getstring $script $list_range
                                        TclObject[] objv380 = TJC.grabObjv(interp, 4);
                                        TclObject tmp381;
                                        try {
                                            // Arg 0 constant: parse
                                            objv380[0] = const28;
                                            // Arg 1 constant: getstring
                                            objv380[1] = const29;
                                            // Arg 2 variable: $script
                                            tmp381 = getVarScalar(interp, "script", compiledLocals, 2);
                                            tmp381.preserve();
                                            objv380[2] = tmp381;
                                            // Arg 3 variable: $list_range
                                            tmp381 = getVarScalar(interp, "list_range", compiledLocals, 33);
                                            tmp381.preserve();
                                            objv380[3] = tmp381;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                                ? cmdcache6.cmd : null), objv380, 0);
                                            if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                                updateCmdCache(interp, 6);
                                            }
                                        } finally {
                                            tmp381 = objv380[2];
                                            if ( tmp381 != null ) {
                                                tmp381.release();
                                            }
                                            tmp381 = objv380[3];
                                            if ( tmp381 != null ) {
                                                tmp381.release();
                                            }
                                            TJC.releaseObjv(interp, objv380, 4);
                                        }
                                    } // End Invoke: parse
                                    tmp379 = interp.getResult();
                                    setVarScalar(interp, "str", tmp379, compiledLocals, 34);
                                } // End Invoke: set
                                { // Invoke: if ... ...
                                    // Binary operator: [...] == "#"
                                    { // Invoke: string index $str 0
                                        TclObject tmp382 = getVarScalar(interp, "str", compiledLocals, 34);
                                        String tmp383 = tmp382.toString();
                                        TclObject tmp384 = TJC.stringIndex(interp, tmp383, const5);
                                        interp.setResult(tmp384);
                                    } // End Invoke: string
                                    TclObject tmp385 = interp.getResult();
                                    boolean tmp386 = tmp385.toString().equals("#");
                                    ExprValue tmp387 = evs0;
                                    tmp387.setIntValue(tmp386);
                                    // End Binary operator: ==
                                    boolean tmp388 = ( tmp387.getIntValue() != 0 );
                                    if ( tmp388 ) {
                                        { // Invoke: set _descend($key,usage) 1
                                            TclObject tmp389;
                                            String tmp390;
                                            StringBuffer sbtmp391 = new StringBuffer(64);
                                            tmp389 = getVarScalar(interp, "key", compiledLocals, 0);
                                            sbtmp391.append(tmp389.toString());
                                            sbtmp391.append(",usage");
                                            tmp390 = sbtmp391.toString();
                                            setVarArray(interp, "_descend", tmp390, const9, compiledLocals, 1);
                                        } // End Invoke: set
                                        { // Invoke: return [...]
                                            { // Invoke: list invalidBody switch $pindex ...
                                                TclObject tmp392 = TclList.newInstance();
                                                TclObject tmp393;
                                                try {
                                                    TclList.append(interp, tmp392, const33);
                                                    TclList.append(interp, tmp392, const11);
                                                    tmp393 = getVarScalar(interp, "pindex", compiledLocals, 26);
                                                    TclList.append(interp, tmp392, tmp393);
                                                    TclList.append(interp, tmp392, const36);
                                                } catch (TclException ex) {
                                                    tmp392.release();
                                                    throw ex;
                                                }
                                                interp.setResult(tmp392);
                                            } // End Invoke: list
                                            if ( true ) { return; }
                                        } // End Invoke: return
                                    }
                                } // End Invoke: if
                                { // Invoke: set is_pattern [...]
                                    TclObject tmp394;
                                    { // Invoke: expr {!$is_pattern}
                                        // Unary operator: ! $is_pattern
                                        TclObject tmp395 = getVarScalar(interp, "is_pattern", compiledLocals, 32);
                                        ExprValue tmp396 = evs0;
                                        if ( tmp395.isIntType() ) {
                                            TJC.exprUnaryNotOperatorKnownInt(tmp396, tmp395);
                                        } else {
                                            TJC.exprUnaryNotOperator(interp, tmp396, tmp395);
                                        }
                                        // End Unary operator: !
                                        interp.setResult( tmp396.getIntValue() != 0 );
                                    } // End Invoke: expr
                                    tmp394 = interp.getResult();
                                    setVarScalar(interp, "is_pattern", tmp394, compiledLocals, 32);
                                } // End Invoke: set
                                } catch (TclException ex) {
                                    int type = ex.getCompletionCode();
                                    if (type == TCL.BREAK) {
                                        break;
                                    } else if (type == TCL.CONTINUE) {
                                        continue;
                                    } else {
                                        throw ex;
                                    }
                                }
                            }
                        } finally {
                            if ( tmp376 != null ) {
                                tmp376.release();
                            }
                        }
                    } // End Invoke: foreach
                    { // Invoke: if {!$is_pattern} ...
                        // Unary operator: ! $is_pattern
                        TclObject tmp397 = getVarScalar(interp, "is_pattern", compiledLocals, 32);
                        ExprValue tmp398 = evs0;
                        if ( tmp397.isIntType() ) {
                            TJC.exprUnaryNotOperatorKnownInt(tmp398, tmp397);
                        } else {
                            TJC.exprUnaryNotOperator(interp, tmp398, tmp397);
                        }
                        // End Unary operator: !
                        boolean tmp399 = ( tmp398.getIntValue() != 0 );
                        if ( tmp399 ) {
                            { // Invoke: error ...
                                TclObject[] objv400 = TJC.grabObjv(interp, 2);
                                try {
                                    // Arg 0 constant: error
                                    objv400[0] = const26;
                                    // Arg 1 constant: ...
                                    objv400[1] = const37;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                        ? cmdcache5.cmd : null), objv400, 0);
                                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                        updateCmdCache(interp, 5);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv400, 2);
                                }
                            } // End Invoke: error
                        }
                    } // End Invoke: if
                    { // Invoke: if {$str == "-"} ...
                        // Binary operator: $str == "-"
                        TclObject tmp401 = getVarScalar(interp, "str", compiledLocals, 34);
                        boolean tmp402 = tmp401.toString().equals("-");
                        ExprValue tmp403 = evs0;
                        tmp403.setIntValue(tmp402);
                        // End Binary operator: ==
                        boolean tmp404 = ( tmp403.getIntValue() != 0 );
                        if ( tmp404 ) {
                            { // Invoke: set _descend($key,usage) 1
                                TclObject tmp405;
                                String tmp406;
                                StringBuffer sbtmp407 = new StringBuffer(64);
                                tmp405 = getVarScalar(interp, "key", compiledLocals, 0);
                                sbtmp407.append(tmp405.toString());
                                sbtmp407.append(",usage");
                                tmp406 = sbtmp407.toString();
                                setVarArray(interp, "_descend", tmp406, const9, compiledLocals, 1);
                            } // End Invoke: set
                            { // Invoke: return [...]
                                { // Invoke: list invalidBody switch $pindex ...
                                    TclObject tmp408 = TclList.newInstance();
                                    TclObject tmp409;
                                    try {
                                        TclList.append(interp, tmp408, const33);
                                        TclList.append(interp, tmp408, const11);
                                        tmp409 = getVarScalar(interp, "pindex", compiledLocals, 26);
                                        TclList.append(interp, tmp408, tmp409);
                                        TclList.append(interp, tmp408, const38);
                                    } catch (TclException ex) {
                                        tmp408.release();
                                        throw ex;
                                    }
                                    interp.setResult(tmp408);
                                } // End Invoke: list
                                if ( true ) { return; }
                            } // End Invoke: return
                        }
                    } // End Invoke: if
                    { // Invoke: set unbraced_script [...]
                        TclObject tmp410;
                        { // Invoke: ... $script $text_range
                            TclObject[] objv411 = TJC.grabObjv(interp, 3);
                            TclObject tmp412;
                            try {
                                // Arg 0 constant: ...
                                objv411[0] = const39;
                                // Arg 1 variable: $script
                                tmp412 = getVarScalar(interp, "script", compiledLocals, 2);
                                tmp412.preserve();
                                objv411[1] = tmp412;
                                // Arg 2 variable: $text_range
                                tmp412 = getVarScalar(interp, "text_range", compiledLocals, 29);
                                tmp412.preserve();
                                objv411[2] = tmp412;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                    ? cmdcache8.cmd : null), objv411, 0);
                                if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                    updateCmdCache(interp, 8);
                                }
                            } finally {
                                tmp412 = objv411[1];
                                if ( tmp412 != null ) {
                                    tmp412.release();
                                }
                                tmp412 = objv411[2];
                                if ( tmp412 != null ) {
                                    tmp412.release();
                                }
                                TJC.releaseObjv(interp, objv411, 3);
                            }
                        } // End Invoke: ...
                        tmp410 = interp.getResult();
                        setVarScalar(interp, "unbraced_script", tmp410, compiledLocals, 35);
                    } // End Invoke: set
                    { // Invoke: foreach akey [...] ...
                        TclObject tmp413 = null;
                        try {
                            { // Invoke: array names _descend ${key},*
                                TclObject[] objv414 = TJC.grabObjv(interp, 4);
                                TclObject tmp415;
                                try {
                                    // Arg 0 constant: array
                                    objv414[0] = const40;
                                    // Arg 1 constant: names
                                    objv414[1] = const41;
                                    // Arg 2 constant: _descend
                                    objv414[2] = const42;
                                    // Arg 3 word: ${key},*
                                    StringBuffer sbtmp416 = new StringBuffer(64);
                                    tmp415 = getVarScalar(interp, "key", compiledLocals, 0);
                                    sbtmp416.append(tmp415.toString());
                                    sbtmp416.append(",*");
                                    tmp415 = TclString.newInstance(sbtmp416);
                                    tmp415.preserve();
                                    objv414[3] = tmp415;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                                        ? cmdcache9.cmd : null), objv414, 0);
                                    if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                                        updateCmdCache(interp, 9);
                                    }
                                } finally {
                                    tmp415 = objv414[3];
                                    if ( tmp415 != null ) {
                                        tmp415.release();
                                    }
                                    TJC.releaseObjv(interp, objv414, 4);
                                }
                            } // End Invoke: array
                            tmp413 = interp.getResult();
                            tmp413.preserve();
                            final int tmp413_length = TclList.getLength(interp, tmp413);

                            for ( int index417 = 0 ; index417 < tmp413_length ; index417++ ) {
                                TclObject tmp418 = TclList.index(interp, tmp413, index417);
                                try {
                                    setVarScalar(interp, "akey", tmp418, compiledLocals, 36);
                                } catch (TclException ex) {
                                    TJC.foreachVarErr(interp, "akey");
                                }

                                try {
                                if ( false ) { throw (TclException) null; }
                                { // Invoke: unset _descend($akey)
                                    TclObject[] objv419 = TJC.grabObjv(interp, 2);
                                    TclObject tmp420;
                                    try {
                                        // Arg 0 constant: unset
                                        objv419[0] = const43;
                                        // Arg 1 word: _descend($akey)
                                        StringBuffer sbtmp421 = new StringBuffer(64);
                                        sbtmp421.append("_descend(");
                                        tmp420 = getVarScalar(interp, "akey", compiledLocals, 36);
                                        sbtmp421.append(tmp420.toString());
                                        sbtmp421.append(")");
                                        tmp420 = TclString.newInstance(sbtmp421);
                                        tmp420.preserve();
                                        objv419[1] = tmp420;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                            ? cmdcache10.cmd : null), objv419, 0);
                                        if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                            updateCmdCache(interp, 10);
                                        }
                                    } finally {
                                        tmp420 = objv419[1];
                                        if ( tmp420 != null ) {
                                            tmp420.release();
                                        }
                                        TJC.releaseObjv(interp, objv419, 2);
                                    }
                                } // End Invoke: unset
                                } catch (TclException ex) {
                                    int type = ex.getCompletionCode();
                                    if (type == TCL.BREAK) {
                                        break;
                                    } else if (type == TCL.CONTINUE) {
                                        continue;
                                    } else {
                                        throw ex;
                                    }
                                }
                            }
                        } finally {
                            if ( tmp413 != null ) {
                                tmp413.release();
                            }
                        }
                    } // End Invoke: foreach
                    { // Invoke: unset akey
                        TclObject[] objv422 = TJC.grabObjv(interp, 2);
                        try {
                            // Arg 0 constant: unset
                            objv422[0] = const43;
                            // Arg 1 constant: akey
                            objv422[1] = const44;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                ? cmdcache10.cmd : null), objv422, 0);
                            if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                updateCmdCache(interp, 10);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv422, 2);
                        }
                    } // End Invoke: unset
                    { // Invoke: set prev_key $key
                        TclObject tmp423;
                        tmp423 = getVarScalar(interp, "key", compiledLocals, 0);
                        setVarScalar(interp, "prev_key", tmp423, compiledLocals, 37);
                    } // End Invoke: set
                    { // Invoke: set saved_key $_descend(key)
                        TclObject tmp424;
                        tmp424 = getVarArray(interp, "_descend", "key", compiledLocals, 1);
                        setVarScalar(interp, "saved_key", tmp424, compiledLocals, 38);
                    } // End Invoke: set
                    { // Invoke: if ... ...
                        // Unary operator: ! [...]
                        { // Invoke: regexp {dkey([0-9]+)} $key whole sub1
                            TclObject[] objv425 = TJC.grabObjv(interp, 5);
                            TclObject tmp426;
                            try {
                                // Arg 0 constant: regexp
                                objv425[0] = const45;
                                // Arg 1 constant: {dkey([0-9]+)}
                                objv425[1] = const46;
                                // Arg 2 variable: $key
                                tmp426 = getVarScalar(interp, "key", compiledLocals, 0);
                                tmp426.preserve();
                                objv425[2] = tmp426;
                                // Arg 3 constant: whole
                                objv425[3] = const47;
                                // Arg 4 constant: sub1
                                objv425[4] = const48;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache11_cmdEpoch == cmdcache11.cmdEpoch)
                                    ? cmdcache11.cmd : null), objv425, 0);
                                if ( cmdcache11_cmdEpoch != cmdcache11.cmdEpoch ) {
                                    updateCmdCache(interp, 11);
                                }
                            } finally {
                                tmp426 = objv425[2];
                                if ( tmp426 != null ) {
                                    tmp426.release();
                                }
                                TJC.releaseObjv(interp, objv425, 5);
                            }
                        } // End Invoke: regexp
                        TclObject tmp427 = interp.getResult();
                        ExprValue tmp428 = evs0;
                        if ( tmp427.isIntType() ) {
                            TJC.exprUnaryNotOperatorKnownInt(tmp428, tmp427);
                        } else {
                            TJC.exprUnaryNotOperator(interp, tmp428, tmp427);
                        }
                        // End Unary operator: !
                        boolean tmp429 = ( tmp428.getIntValue() != 0 );
                        if ( tmp429 ) {
                            { // Invoke: error "..."
                                TclObject[] objv430 = TJC.grabObjv(interp, 2);
                                TclObject tmp431;
                                try {
                                    // Arg 0 constant: error
                                    objv430[0] = const26;
                                    // Arg 1 word: "..."
                                    StringBuffer sbtmp432 = new StringBuffer(64);
                                    sbtmp432.append("key ");
                                    sbtmp432.append("\"");
                                    tmp431 = getVarScalar(interp, "key", compiledLocals, 0);
                                    sbtmp432.append(tmp431.toString());
                                    sbtmp432.append("\"");
                                    sbtmp432.append(" does not match regexp pattern");
                                    tmp431 = TclString.newInstance(sbtmp432);
                                    tmp431.preserve();
                                    objv430[1] = tmp431;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                        ? cmdcache5.cmd : null), objv430, 0);
                                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                        updateCmdCache(interp, 5);
                                    }
                                } finally {
                                    tmp431 = objv430[1];
                                    if ( tmp431 != null ) {
                                        tmp431.release();
                                    }
                                    TJC.releaseObjv(interp, objv430, 2);
                                }
                            } // End Invoke: error
                        }
                    } // End Invoke: if
                    { // Invoke: set _descend(key) $sub1
                        TclObject tmp433;
                        tmp433 = getVarScalar(interp, "sub1", compiledLocals, 39);
                        setVarArray(interp, "_descend", "key", tmp433, compiledLocals, 1);
                    } // End Invoke: set
                    { // Invoke: set original_range [...]
                        TclObject tmp434;
                        { // Invoke: parse getrange $script
                            TclObject[] objv435 = TJC.grabObjv(interp, 3);
                            TclObject tmp436;
                            try {
                                // Arg 0 constant: parse
                                objv435[0] = const28;
                                // Arg 1 constant: getrange
                                objv435[1] = const49;
                                // Arg 2 variable: $script
                                tmp436 = getVarScalar(interp, "script", compiledLocals, 2);
                                tmp436.preserve();
                                objv435[2] = tmp436;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                    ? cmdcache6.cmd : null), objv435, 0);
                                if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                    updateCmdCache(interp, 6);
                                }
                            } finally {
                                tmp436 = objv435[2];
                                if ( tmp436 != null ) {
                                    tmp436.release();
                                }
                                TJC.releaseObjv(interp, objv435, 3);
                            }
                        } // End Invoke: parse
                        tmp434 = interp.getResult();
                        setVarScalar(interp, "original_range", tmp434, compiledLocals, 40);
                    } // End Invoke: set
                    { // Invoke: set unbraced_range [...]
                        TclObject tmp437;
                        { // Invoke: parse getrange $unbraced_script
                            TclObject[] objv438 = TJC.grabObjv(interp, 3);
                            TclObject tmp439;
                            try {
                                // Arg 0 constant: parse
                                objv438[0] = const28;
                                // Arg 1 constant: getrange
                                objv438[1] = const49;
                                // Arg 2 variable: $unbraced_script
                                tmp439 = getVarScalar(interp, "unbraced_script", compiledLocals, 35);
                                tmp439.preserve();
                                objv438[2] = tmp439;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                    ? cmdcache6.cmd : null), objv438, 0);
                                if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                    updateCmdCache(interp, 6);
                                }
                            } finally {
                                tmp439 = objv438[2];
                                if ( tmp439 != null ) {
                                    tmp439.release();
                                }
                                TJC.releaseObjv(interp, objv438, 3);
                            }
                        } // End Invoke: parse
                        tmp437 = interp.getResult();
                        setVarScalar(interp, "unbraced_range", tmp437, compiledLocals, 41);
                    } // End Invoke: set
                    { // Invoke: set original_range_len [...]
                        TclObject tmp440;
                        { // Invoke: lindex $original_range 1
                            TclObject tmp441 = getVarScalar(interp, "original_range", compiledLocals, 40);
                            tmp441 = TclList.index(interp, tmp441, 1);
                            if ( tmp441 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp441);
                            }
                        } // End Invoke: lindex
                        tmp440 = interp.getResult();
                        setVarScalar(interp, "original_range_len", tmp440, compiledLocals, 42);
                    } // End Invoke: set
                    { // Invoke: set mod_range_len [...]
                        TclObject tmp442;
                        { // Invoke: lindex $unbraced_range 1
                            TclObject tmp443 = getVarScalar(interp, "unbraced_range", compiledLocals, 41);
                            tmp443 = TclList.index(interp, tmp443, 1);
                            if ( tmp443 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp443);
                            }
                        } // End Invoke: lindex
                        tmp442 = interp.getResult();
                        setVarScalar(interp, "mod_range_len", tmp442, compiledLocals, 43);
                    } // End Invoke: set
                    { // Invoke: set delta_len [...]
                        TclObject tmp444;
                        { // Invoke: expr ...
                            // Binary operator: () * ()
                            // Binary operator: $original_range_len - $mod_range_len
                            TclObject tmp445 = getVarScalar(interp, "original_range_len", compiledLocals, 42);
                            ExprValue tmp446 = evs0;
                            TJC.exprInitValue(interp, tmp446, tmp445);
                            TclObject tmp447 = getVarScalar(interp, "mod_range_len", compiledLocals, 43);
                            ExprValue tmp448 = evs1;
                            TJC.exprInitValue(interp, tmp448, tmp447);
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MINUS, tmp446, tmp448);
                            // End Binary operator: -
                            // Unary operator: - 1
                            ExprValue tmp449 = evs1;
                            tmp449.setIntValue(-1);
                            // End Unary operator: -
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MULT, tmp446, tmp449);
                            // End Binary operator: *
                            TJC.exprSetResult(interp, tmp446);
                        } // End Invoke: expr
                        tmp444 = interp.getResult();
                        setVarScalar(interp, "delta_len", tmp444, compiledLocals, 44);
                    } // End Invoke: set
                    { // Invoke: set unbraced_parse_range [...]
                        TclObject tmp450;
                        { // Invoke: list [...] [...]
                            TclObject tmp451 = TclList.newInstance();
                            TclObject tmp452;
                            try {
                                { // Invoke: lindex $parse_range 0
                                    TclObject tmp453 = getVarScalar(interp, "parse_range", compiledLocals, 5);
                                    tmp453 = TclList.index(interp, tmp453, 0);
                                    if ( tmp453 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp453);
                                    }
                                } // End Invoke: lindex
                                tmp452 = interp.getResult();
                                TclList.append(interp, tmp451, tmp452);
                                { // Invoke: expr ...
                                    // Binary operator: [...] + $delta_len
                                    { // Invoke: lindex $parse_range 1
                                        TclObject tmp454 = getVarScalar(interp, "parse_range", compiledLocals, 5);
                                        tmp454 = TclList.index(interp, tmp454, 1);
                                        if ( tmp454 == null ) {
                                            interp.resetResult();
                                        } else {
                                            interp.setResult(tmp454);
                                        }
                                    } // End Invoke: lindex
                                    TclObject tmp455 = interp.getResult();
                                    ExprValue tmp456 = evs0;
                                    TJC.exprInitValue(interp, tmp456, tmp455);
                                    TclObject tmp457 = getVarScalar(interp, "delta_len", compiledLocals, 44);
                                    ExprValue tmp458 = evs1;
                                    TJC.exprInitValue(interp, tmp458, tmp457);
                                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_PLUS, tmp456, tmp458);
                                    // End Binary operator: +
                                    TJC.exprSetResult(interp, tmp456);
                                } // End Invoke: expr
                                tmp452 = interp.getResult();
                                TclList.append(interp, tmp451, tmp452);
                            } catch (TclException ex) {
                                tmp451.release();
                                throw ex;
                            }
                            interp.setResult(tmp451);
                        } // End Invoke: list
                        tmp450 = interp.getResult();
                        setVarScalar(interp, "unbraced_parse_range", tmp450, compiledLocals, 45);
                    } // End Invoke: set
                    { // Invoke: set key [...]
                        TclObject tmp459;
                        { // Invoke: descend_next_command $unbraced_script $... $nested $undetermined
                            TclObject[] objv460 = TJC.grabObjv(interp, 5);
                            TclObject tmp461;
                            try {
                                // Arg 0 constant: descend_next_command
                                objv460[0] = const50;
                                // Arg 1 variable: $unbraced_script
                                tmp461 = getVarScalar(interp, "unbraced_script", compiledLocals, 35);
                                tmp461.preserve();
                                objv460[1] = tmp461;
                                // Arg 2 variable: $...
                                tmp461 = getVarScalar(interp, "unbraced_parse_range", compiledLocals, 45);
                                tmp461.preserve();
                                objv460[2] = tmp461;
                                // Arg 3 variable: $nested
                                tmp461 = getVarScalar(interp, "nested", compiledLocals, 4);
                                tmp461.preserve();
                                objv460[3] = tmp461;
                                // Arg 4 variable: $undetermined
                                tmp461 = getVarScalar(interp, "undetermined", compiledLocals, 6);
                                tmp461.preserve();
                                objv460[4] = tmp461;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache12_cmdEpoch == cmdcache12.cmdEpoch)
                                    ? cmdcache12.cmd : null), objv460, 0);
                                if ( cmdcache12_cmdEpoch != cmdcache12.cmdEpoch ) {
                                    updateCmdCache(interp, 12);
                                }
                            } finally {
                                tmp461 = objv460[1];
                                if ( tmp461 != null ) {
                                    tmp461.release();
                                }
                                tmp461 = objv460[2];
                                if ( tmp461 != null ) {
                                    tmp461.release();
                                }
                                tmp461 = objv460[3];
                                if ( tmp461 != null ) {
                                    tmp461.release();
                                }
                                tmp461 = objv460[4];
                                if ( tmp461 != null ) {
                                    tmp461.release();
                                }
                                TJC.releaseObjv(interp, objv460, 5);
                            }
                        } // End Invoke: descend_next_command
                        tmp459 = interp.getResult();
                        setVarScalar(interp, "key", tmp459, compiledLocals, 0);
                    } // End Invoke: set
                    { // Invoke: if {$key == ""} ... elseif ... ... elseif {$key != $prev_key} ...
                        // Binary operator: $key == ""
                        TclObject tmp462 = getVarScalar(interp, "key", compiledLocals, 0);
                        ExprValue tmp463 = evs0;
                        TJC.exprEqualsEmptyString(tmp463, tmp462, false);
                        // End Binary operator: ==
                        boolean tmp464 = ( tmp463.getIntValue() != 0 );
                        if ( tmp464 ) {
                            { // Invoke: error ...
                                TclObject[] objv465 = TJC.grabObjv(interp, 2);
                                try {
                                    // Arg 0 constant: error
                                    objv465[0] = const26;
                                    // Arg 1 constant: ...
                                    objv465[1] = const51;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                        ? cmdcache5.cmd : null), objv465, 0);
                                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                        updateCmdCache(interp, 5);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv465, 2);
                                }
                            } // End Invoke: error
                        } else {
                            // Binary operator: () && ()
                            // Binary operator: [...] == 2
                            { // Invoke: llength $key
                                TclObject tmp466 = getVarScalar(interp, "key", compiledLocals, 0);
                                int tmp467 = TclList.getLength(interp, tmp466);
                                interp.setResult(tmp467);
                            } // End Invoke: llength
                            TclObject tmp468 = interp.getResult();
                            ExprValue tmp469 = evs0;
                            TJC.exprInitValue(interp, tmp469, tmp468);
                            ExprValue tmp470 = evs1;
                            tmp470.setIntValue(2);
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp469, tmp470);
                            // End Binary operator: ==
                            if (tmp469.getBooleanValue(interp)) {
                            // Binary operator: [...] == "continue"
                            { // Invoke: lindex $key 0
                                TclObject tmp471 = getVarScalar(interp, "key", compiledLocals, 0);
                                tmp471 = TclList.index(interp, tmp471, 0);
                                if ( tmp471 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp471);
                                }
                            } // End Invoke: lindex
                            TclObject tmp472 = interp.getResult();
                            boolean tmp473 = tmp472.toString().equals("continue");
                            ExprValue tmp474 = evs1;
                            tmp474.setIntValue(tmp473);
                            // End Binary operator: ==
                            tmp469.setIntValue(tmp474.getBooleanValue(interp));
                            } else {
                            tmp469.setIntValue(0);
                            } // End if: ()
                            // End Binary operator: &&
                            boolean tmp475 = ( tmp469.getIntValue() != 0 );
                            if ( tmp475 ) {
                                { // Invoke: error ...
                                    TclObject[] objv476 = TJC.grabObjv(interp, 2);
                                    try {
                                        // Arg 0 constant: error
                                        objv476[0] = const26;
                                        // Arg 1 constant: ...
                                        objv476[1] = const52;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                            ? cmdcache5.cmd : null), objv476, 0);
                                        if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                            updateCmdCache(interp, 5);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv476, 2);
                                    }
                                } // End Invoke: error
                            } else {
                                // Binary operator: $key != $prev_key
                                TclObject tmp477 = getVarScalar(interp, "key", compiledLocals, 0);
                                ExprValue tmp478 = evs0;
                                TJC.exprInitValue(interp, tmp478, tmp477);
                                TclObject tmp479 = getVarScalar(interp, "prev_key", compiledLocals, 37);
                                ExprValue tmp480 = evs1;
                                TJC.exprInitValue(interp, tmp480, tmp479);
                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp478, tmp480);
                                // End Binary operator: !=
                                boolean tmp481 = ( tmp478.getIntValue() != 0 );
                                if ( tmp481 ) {
                                    { // Invoke: error "..."
                                        TclObject[] objv482 = TJC.grabObjv(interp, 2);
                                        TclObject tmp483;
                                        try {
                                            // Arg 0 constant: error
                                            objv482[0] = const26;
                                            // Arg 1 word: "..."
                                            StringBuffer sbtmp484 = new StringBuffer(64);
                                            sbtmp484.append("prev_key ");
                                            sbtmp484.append("\"");
                                            tmp483 = getVarScalar(interp, "prev_key", compiledLocals, 37);
                                            sbtmp484.append(tmp483.toString());
                                            sbtmp484.append("\"");
                                            sbtmp484.append(" does not match new key ");
                                            sbtmp484.append("\"");
                                            tmp483 = getVarScalar(interp, "key", compiledLocals, 0);
                                            sbtmp484.append(tmp483.toString());
                                            sbtmp484.append("\"");
                                            tmp483 = TclString.newInstance(sbtmp484);
                                            tmp483.preserve();
                                            objv482[1] = tmp483;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                                ? cmdcache5.cmd : null), objv482, 0);
                                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                                updateCmdCache(interp, 5);
                                            }
                                        } finally {
                                            tmp483 = objv482[1];
                                            if ( tmp483 != null ) {
                                                tmp483.release();
                                            }
                                            TJC.releaseObjv(interp, objv482, 2);
                                        }
                                    } // End Invoke: error
                                }
                            }
                        }
                    } // End Invoke: if
                    { // Invoke: set _descend(key) $saved_key
                        TclObject tmp485;
                        tmp485 = getVarScalar(interp, "saved_key", compiledLocals, 38);
                        setVarArray(interp, "_descend", "key", tmp485, compiledLocals, 1);
                    } // End Invoke: set
                    { // Invoke: set _descend($key,rest) $original_rest_range
                        TclObject tmp486;
                        String tmp487;
                        StringBuffer sbtmp488 = new StringBuffer(64);
                        tmp486 = getVarScalar(interp, "key", compiledLocals, 0);
                        sbtmp488.append(tmp486.toString());
                        sbtmp488.append(",rest");
                        tmp487 = sbtmp488.toString();
                        tmp486 = getVarScalar(interp, "original_rest_range", compiledLocals, 8);
                        tmp486 = setVarArray(interp, "_descend", tmp487, tmp486, compiledLocals, 1);
                    } // End Invoke: set
                    { // Invoke: set tree [...]
                        TclObject tmp489;
                        { // Invoke: descend_get_data $key tree
                            TclObject[] objv490 = TJC.grabObjv(interp, 3);
                            TclObject tmp491;
                            try {
                                // Arg 0 constant: descend_get_data
                                objv490[0] = const0;
                                // Arg 1 variable: $key
                                tmp491 = getVarScalar(interp, "key", compiledLocals, 0);
                                tmp491.preserve();
                                objv490[1] = tmp491;
                                // Arg 2 constant: tree
                                objv490[2] = const2;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv490, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                tmp491 = objv490[1];
                                if ( tmp491 != null ) {
                                    tmp491.release();
                                }
                                TJC.releaseObjv(interp, objv490, 3);
                            }
                        } // End Invoke: descend_get_data
                        tmp489 = interp.getResult();
                        setVarScalar(interp, "tree", tmp489, compiledLocals, 3);
                    } // End Invoke: set
                    { // Invoke: set num_args [...]
                        TclObject tmp492;
                        { // Invoke: llength $tree
                            TclObject tmp493 = getVarScalar(interp, "tree", compiledLocals, 3);
                            int tmp494 = TclList.getLength(interp, tmp493);
                            interp.setResult(tmp494);
                        } // End Invoke: llength
                        tmp492 = interp.getResult();
                        setVarScalar(interp, "num_args", tmp492, compiledLocals, 9);
                    } // End Invoke: set
                    { // Invoke: set "..." [...]
                        TclObject tmp495;
                        String tmp498;
                        StringBuffer sbtmp499 = new StringBuffer(64);
                        tmp495 = getVarScalar(interp, "key", compiledLocals, 0);
                        sbtmp499.append(tmp495.toString());
                        sbtmp499.append(",pre_validated");
                        tmp498 = sbtmp499.toString();
                        { // Invoke: list $option $tIndex $sIndex $patlist
                            TclObject tmp496 = TclList.newInstance();
                            TclObject tmp497;
                            try {
                                tmp497 = getVarScalar(interp, "option", compiledLocals, 13);
                                TclList.append(interp, tmp496, tmp497);
                                tmp497 = getVarScalar(interp, "tIndex", compiledLocals, 18);
                                TclList.append(interp, tmp496, tmp497);
                                tmp497 = getVarScalar(interp, "sIndex", compiledLocals, 19);
                                TclList.append(interp, tmp496, tmp497);
                                tmp497 = getVarScalar(interp, "patlist", compiledLocals, 17);
                                TclList.append(interp, tmp496, tmp497);
                            } catch (TclException ex) {
                                tmp496.release();
                                throw ex;
                            }
                            interp.setResult(tmp496);
                        } // End Invoke: list
                        tmp495 = interp.getResult();
                        tmp495 = setVarArray(interp, "_descend", tmp498, tmp495, compiledLocals, 1);
                    } // End Invoke: set
                    { // Invoke: for ... {$i < $num_args} {incr i} ...
                        { // Invoke: set i [...]
                            TclObject tmp500;
                            { // Invoke: expr {$pindex + 1}
                                // Binary operator: $pindex + 1
                                TclObject tmp501 = getVarScalar(interp, "pindex", compiledLocals, 26);
                                ExprValue tmp502 = evs0;
                                TJC.exprInitValue(interp, tmp502, tmp501);
                                ExprValue tmp503 = evs1;
                                tmp503.setIntValue(1);
                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_PLUS, tmp502, tmp503);
                                // End Binary operator: +
                                TJC.exprSetResult(interp, tmp502);
                            } // End Invoke: expr
                            tmp500 = interp.getResult();
                            setVarScalar(interp, "i", tmp500, compiledLocals, 25);
                        } // End Invoke: set
                        for ( boolean skip509 = true ; true ; ) {
                            if ( skip509 ) {
                                skip509 = false;
                            } else {
                                try {
                                if ( false ) { throw (TclException) null; }
                                { // Invoke: incr i
                                    interp.resetResult();
                                    incrVarScalar(interp, "i", 1, compiledLocals, 25);
                                } // End Invoke: incr
                                } catch (TclException ex) {
                                    int type = ex.getCompletionCode();
                                    if (type == TCL.BREAK) {
                                        break;
                                    } else {
                                        throw ex;
                                    }
                                }
                            }

                            // Binary operator: $i < $num_args
                            TclObject tmp504 = getVarScalar(interp, "i", compiledLocals, 25);
                            ExprValue tmp505 = evs0;
                            TJC.exprInitValue(interp, tmp505, tmp504);
                            TclObject tmp506 = getVarScalar(interp, "num_args", compiledLocals, 9);
                            ExprValue tmp507 = evs1;
                            TJC.exprInitValue(interp, tmp507, tmp506);
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp505, tmp507);
                            // End Binary operator: <
                            boolean tmp508 = ( tmp505.getIntValue() != 0 );
                            if ( ! tmp508 ) { break; }

                            try {
                            if ( false ) { throw (TclException) null; }
                            { // Invoke: lappend patlist $i
                                TclObject[] objv510 = TJC.grabObjv(interp, 1);
                                TclObject tmp511;
                                try {
                                    // Arg 2 variable: $i
                                    tmp511 = getVarScalar(interp, "i", compiledLocals, 25);
                                    tmp511.preserve();
                                    objv510[0] = tmp511;
                                    interp.resetResult();
                                    lappendVarScalar(interp, "patlist", objv510, compiledLocals, 17);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv510, 1);
                                }
                            } // End Invoke: lappend
                            } catch (TclException ex) {
                                int type = ex.getCompletionCode();
                                if (type == TCL.BREAK) {
                                    break;
                                } else if (type == TCL.CONTINUE) {
                                    continue;
                                } else {
                                    throw ex;
                                }
                            }
                        }
                    } // End Invoke: for
                    { // Invoke: set commands [...]
                        TclObject tmp512;
                        { // Invoke: list
                            TclObject tmp513 = TclList.newInstance();
                            interp.setResult(tmp513);
                        } // End Invoke: list
                        tmp512 = interp.getResult();
                        setVarScalar(interp, "commands", tmp512, compiledLocals, 46);
                    } // End Invoke: set
                    { // Invoke: for {set i 0} {$i < $num_args} {incr i} ...
                        { // Invoke: set i 0
                            setVarScalar(interp, "i", const5, compiledLocals, 25);
                        } // End Invoke: set
                        for ( boolean skip519 = true ; true ; ) {
                            if ( skip519 ) {
                                skip519 = false;
                            } else {
                                try {
                                if ( false ) { throw (TclException) null; }
                                { // Invoke: incr i
                                    interp.resetResult();
                                    incrVarScalar(interp, "i", 1, compiledLocals, 25);
                                } // End Invoke: incr
                                } catch (TclException ex) {
                                    int type = ex.getCompletionCode();
                                    if (type == TCL.BREAK) {
                                        break;
                                    } else {
                                        throw ex;
                                    }
                                }
                            }

                            // Binary operator: $i < $num_args
                            TclObject tmp514 = getVarScalar(interp, "i", compiledLocals, 25);
                            ExprValue tmp515 = evs0;
                            TJC.exprInitValue(interp, tmp515, tmp514);
                            TclObject tmp516 = getVarScalar(interp, "num_args", compiledLocals, 9);
                            ExprValue tmp517 = evs1;
                            TJC.exprInitValue(interp, tmp517, tmp516);
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp515, tmp517);
                            // End Binary operator: <
                            boolean tmp518 = ( tmp515.getIntValue() != 0 );
                            if ( ! tmp518 ) { break; }

                            try {
                            if ( false ) { throw (TclException) null; }
                            { // Invoke: lappend commands {}
                                TclObject[] objv520 = TJC.grabObjv(interp, 1);
                                TclObject tmp521;
                                try {
                                    // Arg 2 constant: {}
                                    objv520[0] = const13;
                                    interp.resetResult();
                                    lappendVarScalar(interp, "commands", objv520, compiledLocals, 46);
                                } finally {
                                    TJC.releaseObjv(interp, objv520, 1);
                                }
                            } // End Invoke: lappend
                            } catch (TclException ex) {
                                int type = ex.getCompletionCode();
                                if (type == TCL.BREAK) {
                                    break;
                                } else if (type == TCL.CONTINUE) {
                                    continue;
                                } else {
                                    throw ex;
                                }
                            }
                        }
                    } // End Invoke: for
                    { // Invoke: for {set i 0} ... {incr i} ...
                        { // Invoke: set i 0
                            setVarScalar(interp, "i", const5, compiledLocals, 25);
                        } // End Invoke: set
                        for ( boolean skip529 = true ; true ; ) {
                            if ( skip529 ) {
                                skip529 = false;
                            } else {
                                try {
                                if ( false ) { throw (TclException) null; }
                                { // Invoke: incr i
                                    interp.resetResult();
                                    incrVarScalar(interp, "i", 1, compiledLocals, 25);
                                } // End Invoke: incr
                                } catch (TclException ex) {
                                    int type = ex.getCompletionCode();
                                    if (type == TCL.BREAK) {
                                        break;
                                    } else {
                                        throw ex;
                                    }
                                }
                            }

                            // Binary operator: $i < [...]
                            TclObject tmp522 = getVarScalar(interp, "i", compiledLocals, 25);
                            ExprValue tmp523 = evs0;
                            TJC.exprInitValue(interp, tmp523, tmp522);
                            { // Invoke: llength $original_commands
                                TclObject tmp524 = getVarScalar(interp, "original_commands", compiledLocals, 11);
                                int tmp525 = TclList.getLength(interp, tmp524);
                                interp.setResult(tmp525);
                            } // End Invoke: llength
                            TclObject tmp526 = interp.getResult();
                            ExprValue tmp527 = evs1;
                            TJC.exprInitValue(interp, tmp527, tmp526);
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp523, tmp527);
                            // End Binary operator: <
                            boolean tmp528 = ( tmp523.getIntValue() != 0 );
                            if ( ! tmp528 ) { break; }

                            try {
                            if ( false ) { throw (TclException) null; }
                            { // Invoke: set oc [...]
                                TclObject tmp530;
                                { // Invoke: lindex $original_commands $i
                                    TclObject tmp531 = null;
                                    TclObject tmp532;
                                    try {
                                        tmp531 = getVarScalar(interp, "original_commands", compiledLocals, 11);
                                        tmp531.preserve();
                                        tmp532 = getVarScalar(interp, "i", compiledLocals, 25);
                                        TJC.lindexNonconst(interp, tmp531, tmp532);
                                    } finally {
                                        if ( tmp531 != null ) {
                                            tmp531.release();
                                        }
                                    }
                                } // End Invoke: lindex
                                tmp530 = interp.getResult();
                                setVarScalar(interp, "oc", tmp530, compiledLocals, 47);
                            } // End Invoke: set
                            { // Invoke: if {[llength $oc] > 0} ...
                                // Binary operator: [...] > 0
                                { // Invoke: llength $oc
                                    TclObject tmp533 = getVarScalar(interp, "oc", compiledLocals, 47);
                                    int tmp534 = TclList.getLength(interp, tmp533);
                                    interp.setResult(tmp534);
                                } // End Invoke: llength
                                TclObject tmp535 = interp.getResult();
                                ExprValue tmp536 = evs0;
                                TJC.exprInitValue(interp, tmp536, tmp535);
                                ExprValue tmp537 = evs1;
                                tmp537.setIntValue(0);
                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GREATER, tmp536, tmp537);
                                // End Binary operator: >
                                boolean tmp538 = ( tmp536.getIntValue() != 0 );
                                if ( tmp538 ) {
                                    { // Invoke: set commands [...]
                                        TclObject tmp539;
                                        { // Invoke: lreplace $commands $i $i $oc
                                            TclObject[] objv540 = TJC.grabObjv(interp, 5);
                                            TclObject tmp541;
                                            try {
                                                // Arg 0 constant: lreplace
                                                objv540[0] = const53;
                                                // Arg 1 variable: $commands
                                                tmp541 = getVarScalar(interp, "commands", compiledLocals, 46);
                                                tmp541.preserve();
                                                objv540[1] = tmp541;
                                                // Arg 2 variable: $i
                                                tmp541 = getVarScalar(interp, "i", compiledLocals, 25);
                                                tmp541.preserve();
                                                objv540[2] = tmp541;
                                                // Arg 3 variable: $i
                                                tmp541 = getVarScalar(interp, "i", compiledLocals, 25);
                                                tmp541.preserve();
                                                objv540[3] = tmp541;
                                                // Arg 4 variable: $oc
                                                tmp541 = getVarScalar(interp, "oc", compiledLocals, 47);
                                                tmp541.preserve();
                                                objv540[4] = tmp541;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache13_cmdEpoch == cmdcache13.cmdEpoch)
                                                    ? cmdcache13.cmd : null), objv540, 0);
                                                if ( cmdcache13_cmdEpoch != cmdcache13.cmdEpoch ) {
                                                    updateCmdCache(interp, 13);
                                                }
                                            } finally {
                                                tmp541 = objv540[1];
                                                if ( tmp541 != null ) {
                                                    tmp541.release();
                                                }
                                                tmp541 = objv540[2];
                                                if ( tmp541 != null ) {
                                                    tmp541.release();
                                                }
                                                tmp541 = objv540[3];
                                                if ( tmp541 != null ) {
                                                    tmp541.release();
                                                }
                                                tmp541 = objv540[4];
                                                if ( tmp541 != null ) {
                                                    tmp541.release();
                                                }
                                                TJC.releaseObjv(interp, objv540, 5);
                                            }
                                        } // End Invoke: lreplace
                                        tmp539 = interp.getResult();
                                        setVarScalar(interp, "commands", tmp539, compiledLocals, 46);
                                    } // End Invoke: set
                                }
                            } // End Invoke: if
                            } catch (TclException ex) {
                                int type = ex.getCompletionCode();
                                if (type == TCL.BREAK) {
                                    break;
                                } else if (type == TCL.CONTINUE) {
                                    continue;
                                } else {
                                    throw ex;
                                }
                            }
                        }
                    } // End Invoke: for
                    { // Invoke: set "..." $commands
                        TclObject tmp542;
                        String tmp543;
                        StringBuffer sbtmp544 = new StringBuffer(64);
                        tmp542 = getVarScalar(interp, "key", compiledLocals, 0);
                        sbtmp544.append(tmp542.toString());
                        sbtmp544.append(",commands");
                        tmp543 = sbtmp544.toString();
                        tmp542 = getVarScalar(interp, "commands", compiledLocals, 46);
                        tmp542 = setVarArray(interp, "_descend", tmp543, tmp542, compiledLocals, 1);
                    } // End Invoke: set
                    { // Invoke: set "..." [...]
                        TclObject tmp545;
                        String tmp548;
                        StringBuffer sbtmp549 = new StringBuffer(64);
                        tmp545 = getVarScalar(interp, "key", compiledLocals, 0);
                        sbtmp549.append(tmp545.toString());
                        sbtmp549.append(",validated");
                        tmp548 = sbtmp549.toString();
                        { // Invoke: list $option $tIndex $sIndex $patlist
                            TclObject tmp546 = TclList.newInstance();
                            TclObject tmp547;
                            try {
                                tmp547 = getVarScalar(interp, "option", compiledLocals, 13);
                                TclList.append(interp, tmp546, tmp547);
                                tmp547 = getVarScalar(interp, "tIndex", compiledLocals, 18);
                                TclList.append(interp, tmp546, tmp547);
                                tmp547 = getVarScalar(interp, "sIndex", compiledLocals, 19);
                                TclList.append(interp, tmp546, tmp547);
                                tmp547 = getVarScalar(interp, "patlist", compiledLocals, 17);
                                TclList.append(interp, tmp546, tmp547);
                            } catch (TclException ex) {
                                tmp546.release();
                                throw ex;
                            }
                            interp.setResult(tmp546);
                        } // End Invoke: list
                        tmp545 = interp.getResult();
                        tmp545 = setVarArray(interp, "_descend", tmp548, tmp545, compiledLocals, 1);
                    } // End Invoke: set
                } else {
                    { // Invoke: set last_index [...]
                        TclObject tmp550;
                        { // Invoke: lindex $patlist end
                            TclObject tmp551 = null;
                            TclObject tmp552;
                            try {
                                tmp551 = getVarScalar(interp, "patlist", compiledLocals, 17);
                                tmp551.preserve();
                                tmp552 = const30;
                                TJC.lindexNonconst(interp, tmp551, tmp552);
                            } finally {
                                if ( tmp551 != null ) {
                                    tmp551.release();
                                }
                            }
                        } // End Invoke: lindex
                        tmp550 = interp.getResult();
                        setVarScalar(interp, "last_index", tmp550, compiledLocals, 48);
                    } // End Invoke: set
                    { // Invoke: if ... ...
                        { // Invoke: ... $key $last_index
                            TclObject[] objv553 = TJC.grabObjv(interp, 3);
                            TclObject tmp554;
                            try {
                                // Arg 0 constant: ...
                                objv553[0] = const54;
                                // Arg 1 variable: $key
                                tmp554 = getVarScalar(interp, "key", compiledLocals, 0);
                                tmp554.preserve();
                                objv553[1] = tmp554;
                                // Arg 2 variable: $last_index
                                tmp554 = getVarScalar(interp, "last_index", compiledLocals, 48);
                                tmp554.preserve();
                                objv553[2] = tmp554;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache14_cmdEpoch == cmdcache14.cmdEpoch)
                                    ? cmdcache14.cmd : null), objv553, 0);
                                if ( cmdcache14_cmdEpoch != cmdcache14.cmdEpoch ) {
                                    updateCmdCache(interp, 14);
                                }
                            } finally {
                                tmp554 = objv553[1];
                                if ( tmp554 != null ) {
                                    tmp554.release();
                                }
                                tmp554 = objv553[2];
                                if ( tmp554 != null ) {
                                    tmp554.release();
                                }
                                TJC.releaseObjv(interp, objv553, 3);
                            }
                        } // End Invoke: ...
                        TclObject tmp555 = interp.getResult();
                        ExprValue tmp556 = evs0;
                        TJC.exprInitValue(interp, tmp556, tmp555);
                        boolean tmp557 = tmp556.getBooleanValue(interp);
                        if ( tmp557 ) {
                            { // Invoke: set subtree [...]
                                TclObject tmp558;
                                { // Invoke: lindex $tree $last_index
                                    TclObject tmp559 = null;
                                    TclObject tmp560;
                                    try {
                                        tmp559 = getVarScalar(interp, "tree", compiledLocals, 3);
                                        tmp559.preserve();
                                        tmp560 = getVarScalar(interp, "last_index", compiledLocals, 48);
                                        TJC.lindexNonconst(interp, tmp559, tmp560);
                                    } finally {
                                        if ( tmp559 != null ) {
                                            tmp559.release();
                                        }
                                    }
                                } // End Invoke: lindex
                                tmp558 = interp.getResult();
                                setVarScalar(interp, "subtree", tmp558, compiledLocals, 22);
                            } // End Invoke: set
                            { // Invoke: set str [...]
                                TclObject tmp561;
                                { // Invoke: ... $script $subtree "text"
                                    TclObject[] objv562 = TJC.grabObjv(interp, 4);
                                    TclObject tmp563;
                                    try {
                                        // Arg 0 constant: ...
                                        objv562[0] = const16;
                                        // Arg 1 variable: $script
                                        tmp563 = getVarScalar(interp, "script", compiledLocals, 2);
                                        tmp563.preserve();
                                        objv562[1] = tmp563;
                                        // Arg 2 variable: $subtree
                                        tmp563 = getVarScalar(interp, "subtree", compiledLocals, 22);
                                        tmp563.preserve();
                                        objv562[2] = tmp563;
                                        // Arg 3 constant: "text"
                                        objv562[3] = const17;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                            ? cmdcache3.cmd : null), objv562, 0);
                                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                            updateCmdCache(interp, 3);
                                        }
                                    } finally {
                                        tmp563 = objv562[1];
                                        if ( tmp563 != null ) {
                                            tmp563.release();
                                        }
                                        tmp563 = objv562[2];
                                        if ( tmp563 != null ) {
                                            tmp563.release();
                                        }
                                        TJC.releaseObjv(interp, objv562, 4);
                                    }
                                } // End Invoke: ...
                                tmp561 = interp.getResult();
                                setVarScalar(interp, "str", tmp561, compiledLocals, 34);
                            } // End Invoke: set
                            { // Invoke: if {$str == "-"} ...
                                // Binary operator: $str == "-"
                                TclObject tmp564 = getVarScalar(interp, "str", compiledLocals, 34);
                                boolean tmp565 = tmp564.toString().equals("-");
                                ExprValue tmp566 = evs0;
                                tmp566.setIntValue(tmp565);
                                // End Binary operator: ==
                                boolean tmp567 = ( tmp566.getIntValue() != 0 );
                                if ( tmp567 ) {
                                    { // Invoke: set _descend($key,usage) 1
                                        TclObject tmp568;
                                        String tmp569;
                                        StringBuffer sbtmp570 = new StringBuffer(64);
                                        tmp568 = getVarScalar(interp, "key", compiledLocals, 0);
                                        sbtmp570.append(tmp568.toString());
                                        sbtmp570.append(",usage");
                                        tmp569 = sbtmp570.toString();
                                        setVarArray(interp, "_descend", tmp569, const9, compiledLocals, 1);
                                    } // End Invoke: set
                                    { // Invoke: return [...]
                                        { // Invoke: list invalidBody switch $last_index ...
                                            TclObject tmp571 = TclList.newInstance();
                                            TclObject tmp572;
                                            try {
                                                TclList.append(interp, tmp571, const33);
                                                TclList.append(interp, tmp571, const11);
                                                tmp572 = getVarScalar(interp, "last_index", compiledLocals, 48);
                                                TclList.append(interp, tmp571, tmp572);
                                                TclList.append(interp, tmp571, const38);
                                            } catch (TclException ex) {
                                                tmp571.release();
                                                throw ex;
                                            }
                                            interp.setResult(tmp571);
                                        } // End Invoke: list
                                        if ( true ) { return; }
                                    } // End Invoke: return
                                }
                            } // End Invoke: if
                        }
                    } // End Invoke: if
                    { // Invoke: set "..." [...]
                        TclObject tmp573;
                        String tmp576;
                        StringBuffer sbtmp577 = new StringBuffer(64);
                        tmp573 = getVarScalar(interp, "key", compiledLocals, 0);
                        sbtmp577.append(tmp573.toString());
                        sbtmp577.append(",validated");
                        tmp576 = sbtmp577.toString();
                        { // Invoke: list $option $tIndex $sIndex $patlist
                            TclObject tmp574 = TclList.newInstance();
                            TclObject tmp575;
                            try {
                                tmp575 = getVarScalar(interp, "option", compiledLocals, 13);
                                TclList.append(interp, tmp574, tmp575);
                                tmp575 = getVarScalar(interp, "tIndex", compiledLocals, 18);
                                TclList.append(interp, tmp574, tmp575);
                                tmp575 = getVarScalar(interp, "sIndex", compiledLocals, 19);
                                TclList.append(interp, tmp574, tmp575);
                                tmp575 = getVarScalar(interp, "patlist", compiledLocals, 17);
                                TclList.append(interp, tmp574, tmp575);
                            } catch (TclException ex) {
                                tmp574.release();
                                throw ex;
                            }
                            interp.setResult(tmp574);
                        } // End Invoke: list
                        tmp573 = interp.getResult();
                        tmp573 = setVarArray(interp, "_descend", tmp576, tmp573, compiledLocals, 1);
                    } // End Invoke: set
                    { // Invoke: set "..." $...
                        TclObject tmp578;
                        String tmp580;
                        StringBuffer sbtmp581 = new StringBuffer(64);
                        tmp578 = getVarScalar(interp, "key", compiledLocals, 0);
                        sbtmp581.append(tmp578.toString());
                        sbtmp581.append(",pre_validated");
                        tmp580 = sbtmp581.toString();
                        StringBuffer sbtmp579 = new StringBuffer(64);
                        tmp578 = getVarScalar(interp, "key", compiledLocals, 0);
                        sbtmp579.append(tmp578.toString());
                        sbtmp579.append(",validated");
                        tmp578 = getVarArray(interp, "_descend", sbtmp579.toString(), compiledLocals, 1);
                        tmp578 = setVarArray(interp, "_descend", tmp580, tmp578, compiledLocals, 1);
                    } // End Invoke: set
                }
            }
        } // End Invoke: if
        { // Invoke: foreach {pIndex bIndex} $patlist ...
            TclObject tmp582 = null;
            try {
                tmp582 = getVarScalar(interp, "patlist", compiledLocals, 17);
                tmp582.preserve();
                final int tmp582_length = TclList.getLength(interp, tmp582);

                for ( int index583 = 0 ; index583 < tmp582_length ; index583 += 2 ) {
                    TclObject tmp584 = null;
                    if ( index583 < tmp582_length ) {
                        tmp584 = TclList.index(interp, tmp582, index583);
                    }
                    TclObject tmp585 = null;
                    if ( index583 + 1 < tmp582_length ) {
                        tmp585 = TclList.index(interp, tmp582, index583 + 1);
                    }
                    try {
                        if ( tmp584 == null ) {
                            setVarScalar(interp, "pIndex", "", compiledLocals, 49);
                        } else {
                            setVarScalar(interp, "pIndex", tmp584, compiledLocals, 49);
                        }
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "pIndex");
                    }
                    try {
                        if ( tmp585 == null ) {
                            setVarScalar(interp, "bIndex", "", compiledLocals, 50);
                        } else {
                            setVarScalar(interp, "bIndex", tmp585, compiledLocals, 50);
                        }
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "bIndex");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: if ... ...
                        // Unary operator: ! [...]
                        { // Invoke: ... $key $bIndex
                            TclObject[] objv586 = TJC.grabObjv(interp, 3);
                            TclObject tmp587;
                            try {
                                // Arg 0 constant: ...
                                objv586[0] = const54;
                                // Arg 1 variable: $key
                                tmp587 = getVarScalar(interp, "key", compiledLocals, 0);
                                tmp587.preserve();
                                objv586[1] = tmp587;
                                // Arg 2 variable: $bIndex
                                tmp587 = getVarScalar(interp, "bIndex", compiledLocals, 50);
                                tmp587.preserve();
                                objv586[2] = tmp587;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache14_cmdEpoch == cmdcache14.cmdEpoch)
                                    ? cmdcache14.cmd : null), objv586, 0);
                                if ( cmdcache14_cmdEpoch != cmdcache14.cmdEpoch ) {
                                    updateCmdCache(interp, 14);
                                }
                            } finally {
                                tmp587 = objv586[1];
                                if ( tmp587 != null ) {
                                    tmp587.release();
                                }
                                tmp587 = objv586[2];
                                if ( tmp587 != null ) {
                                    tmp587.release();
                                }
                                TJC.releaseObjv(interp, objv586, 3);
                            }
                        } // End Invoke: ...
                        TclObject tmp588 = interp.getResult();
                        ExprValue tmp589 = evs0;
                        if ( tmp588.isIntType() ) {
                            TJC.exprUnaryNotOperatorKnownInt(tmp589, tmp588);
                        } else {
                            TJC.exprUnaryNotOperator(interp, tmp589, tmp588);
                        }
                        // End Unary operator: !
                        boolean tmp590 = ( tmp589.getIntValue() != 0 );
                        if ( tmp590 ) {
                            { // Invoke: set is_static 0
                                setVarScalar(interp, "is_static", const5, compiledLocals, 12);
                            } // End Invoke: set
                        }
                    } // End Invoke: if
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp582 != null ) {
                    tmp582.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: if {$is_static} ...
            TclObject tmp591 = getVarScalar(interp, "is_static", compiledLocals, 12);
            boolean tmp592 = TJC.getBoolean(interp, tmp591);
            if ( tmp592 ) {
                { // Invoke: set "..." $is_static
                    TclObject tmp593;
                    String tmp594;
                    StringBuffer sbtmp595 = new StringBuffer(64);
                    tmp593 = getVarScalar(interp, "key", compiledLocals, 0);
                    sbtmp595.append(tmp593.toString());
                    sbtmp595.append(",static_container");
                    tmp594 = sbtmp595.toString();
                    tmp593 = getVarScalar(interp, "is_static", compiledLocals, 12);
                    tmp593 = setVarArray(interp, "_descend", tmp594, tmp593, compiledLocals, 1);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: set "..." $...
            TclObject tmp596;
            String tmp597;
            StringBuffer sbtmp598 = new StringBuffer(64);
            tmp596 = getVarScalar(interp, "key", compiledLocals, 0);
            sbtmp598.append(tmp596.toString());
            sbtmp598.append(",original_command");
            tmp597 = sbtmp598.toString();
            tmp596 = getVarScalar(interp, "original_command_range", compiledLocals, 7);
            tmp596 = setVarArray(interp, "_descend", tmp597, tmp596, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: return "OK"
            interp.resetResult();
            interp.setResult(const55);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "descend_container_switch_validate");
        } finally {
            TJC.exprReleaseValue(interp, evs3);
            TJC.exprReleaseValue(interp, evs2);
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;
    TclObject const19;
    TclObject const20;
    TclObject const21;
    TclObject const22;
    TclObject const23;
    TclObject const24;
    TclObject const25;
    TclObject const26;
    TclObject const27;
    TclObject const28;
    TclObject const29;
    TclObject const30;
    TclObject const31;
    TclObject const32;
    TclObject const33;
    TclObject const34;
    TclObject const35;
    TclObject const36;
    TclObject const37;
    TclObject const38;
    TclObject const39;
    TclObject const40;
    TclObject const41;
    TclObject const42;
    TclObject const43;
    TclObject const44;
    TclObject const45;
    TclObject const46;
    TclObject const47;
    TclObject const48;
    TclObject const49;
    TclObject const50;
    TclObject const51;
    TclObject const52;
    TclObject const53;
    TclObject const54;
    TclObject const55;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("descend_get_data");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("script");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("tree");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("nested");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("range");
        const4.preserve(); const4.preserve();
        const5 = TclInteger.newInstance(0);
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("command");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("rest");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("commands");
        const8.preserve(); const8.preserve();
        const9 = TclInteger.newInstance(1);
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("numArgs");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("switch");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("default");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("");
        const13.preserve(); const13.preserve();
        const14 = TclInteger.newInstance(-1);
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("parse_is_simple_text");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("parse_get_simple_text");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("text");
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance("descend_container_switch_is_switch_mode");
        const18.preserve(); const18.preserve();
        const19 = TclString.newInstance("badOption");
        const19.preserve(); const19.preserve();
        const20 = TclInteger.newInstance(2);
        const20.preserve(); const20.preserve();
        const21 = TclString.newInstance("nonStatic");
        const21.preserve(); const21.preserve();
        const22 = TclInteger.newInstance(3);
        const22.preserve(); const22.preserve();
        const23 = TclInteger.newInstance(4);
        const23.preserve(); const23.preserve();
        const24 = TclInteger.newInstance(5);
        const24.preserve(); const24.preserve();
        const25 = TclInteger.newInstance(6);
        const25.preserve(); const25.preserve();
        const26 = TclString.newInstance("error");
        const26.preserve(); const26.preserve();
        const27 = TclString.newInstance("patlist length can't be zero");
        const27.preserve(); const27.preserve();
        const28 = TclString.newInstance("parse");
        const28.preserve(); const28.preserve();
        const29 = TclString.newInstance("getstring");
        const29.preserve(); const29.preserve();
        const30 = TclString.newInstance("end");
        const30.preserve(); const30.preserve();
        const31 = TclString.newInstance("lindex");
        const31.preserve(); const31.preserve();
        const32 = TclString.newInstance("list");
        const32.preserve(); const32.preserve();
        const33 = TclString.newInstance("invalidBody");
        const33.preserve(); const33.preserve();
        const34 = TclString.newInstance("invalid pat/body argument");
        const34.preserve(); const34.preserve();
        const35 = TclString.newInstance("uneven pat/body args");
        const35.preserve(); const35.preserve();
        const36 = TclString.newInstance("comment in pat/body argument");
        const36.preserve(); const36.preserve();
        const37 = TclString.newInstance("expected to end on a body element");
        const37.preserve(); const37.preserve();
        const38 = TclString.newInstance("no body for last pattern");
        const38.preserve(); const38.preserve();
        const39 = TclString.newInstance("descend_container_switch_script_recreate");
        const39.preserve(); const39.preserve();
        const40 = TclString.newInstance("array");
        const40.preserve(); const40.preserve();
        const41 = TclString.newInstance("names");
        const41.preserve(); const41.preserve();
        const42 = TclString.newInstance("_descend");
        const42.preserve(); const42.preserve();
        const43 = TclString.newInstance("unset");
        const43.preserve(); const43.preserve();
        const44 = TclString.newInstance("akey");
        const44.preserve(); const44.preserve();
        const45 = TclString.newInstance("regexp");
        const45.preserve(); const45.preserve();
        const46 = TclString.newInstance("dkey([0-9]+)");
        const46.preserve(); const46.preserve();
        const47 = TclString.newInstance("whole");
        const47.preserve(); const47.preserve();
        const48 = TclString.newInstance("sub1");
        const48.preserve(); const48.preserve();
        const49 = TclString.newInstance("getrange");
        const49.preserve(); const49.preserve();
        const50 = TclString.newInstance("descend_next_command");
        const50.preserve(); const50.preserve();
        const51 = TclString.newInstance("descend_next_command reported empty commmand");
        const51.preserve(); const51.preserve();
        const52 = TclString.newInstance("descend_next_command reported empty/continue commmand");
        const52.preserve(); const52.preserve();
        const53 = TclString.newInstance("lreplace");
        const53.preserve(); const53.preserve();
        const54 = TclString.newInstance("descend_container_argument_body_is_static");
        const54.preserve(); const54.preserve();
        const55 = TclString.newInstance("OK");
        const55.preserve(); const55.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;
    WrappedCommand cmdcache9;
    int cmdcache9_cmdEpoch;
    WrappedCommand cmdcache10;
    int cmdcache10_cmdEpoch;
    WrappedCommand cmdcache11;
    int cmdcache11_cmdEpoch;
    WrappedCommand cmdcache12;
    int cmdcache12_cmdEpoch;
    WrappedCommand cmdcache13;
    int cmdcache13_cmdEpoch;
    WrappedCommand cmdcache14;
    int cmdcache14_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                cmdcache9 = TJC.INVALID_COMMAND_CACHE;
                cmdcache9_cmdEpoch = 0;
                cmdcache10 = TJC.INVALID_COMMAND_CACHE;
                cmdcache10_cmdEpoch = 0;
                cmdcache11 = TJC.INVALID_COMMAND_CACHE;
                cmdcache11_cmdEpoch = 0;
                cmdcache12 = TJC.INVALID_COMMAND_CACHE;
                cmdcache12_cmdEpoch = 0;
                cmdcache13 = TJC.INVALID_COMMAND_CACHE;
                cmdcache13_cmdEpoch = 0;
                cmdcache14 = TJC.INVALID_COMMAND_CACHE;
                cmdcache14_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "descend_get_data";
                break;
            }
            case 2: {
                cmdName = "parse_is_simple_text";
                break;
            }
            case 3: {
                cmdName = "parse_get_simple_text";
                break;
            }
            case 4: {
                cmdName = "descend_container_switch_is_switch_mode";
                break;
            }
            case 5: {
                cmdName = "error";
                break;
            }
            case 6: {
                cmdName = "parse";
                break;
            }
            case 7: {
                cmdName = "lindex";
                break;
            }
            case 8: {
                cmdName = "descend_container_switch_script_recreate";
                break;
            }
            case 9: {
                cmdName = "array";
                break;
            }
            case 10: {
                cmdName = "unset";
                break;
            }
            case 11: {
                cmdName = "regexp";
                break;
            }
            case 12: {
                cmdName = "descend_next_command";
                break;
            }
            case 13: {
                cmdName = "lreplace";
                break;
            }
            case 14: {
                cmdName = "descend_container_argument_body_is_static";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
            case 9: {
                cmdcache9 = lwcmd;
                cmdcache9_cmdEpoch = cmdEpoch;
                break;
            }
            case 10: {
                cmdcache10 = lwcmd;
                cmdcache10_cmdEpoch = cmdEpoch;
                break;
            }
            case 11: {
                cmdcache11 = lwcmd;
                cmdcache11_cmdEpoch = cmdEpoch;
                break;
            }
            case 12: {
                cmdcache12 = lwcmd;
                cmdcache12_cmdEpoch = cmdEpoch;
                break;
            }
            case 13: {
                cmdcache13 = lwcmd;
                cmdcache13_cmdEpoch = cmdEpoch;
                break;
            }
            case 14: {
                cmdcache14 = lwcmd;
                cmdcache14_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "_descend",
        "script",
        "tree",
        "nested",
        "parse_range",
        "undetermined",
        "original_command_range",
        "original_rest_range",
        "num_args",
        "original_num_args",
        "original_commands",
        "is_static",
        "option",
        "option_str",
        "found_option_terminator",
        "string_argument_index",
        "patlist",
        "tIndex",
        "sIndex",
        "arg1_undetermined",
        "arg2_undetermined",
        "subtree",
        "mode_str",
        "arg3_undetermined",
        "i",
        "pindex",
        "braced_range",
        "braced_range_string",
        "text_range",
        "result",
        "list_ranges",
        "is_pattern",
        "list_range",
        "str",
        "unbraced_script",
        "akey",
        "prev_key",
        "saved_key",
        "sub1",
        "original_range",
        "unbraced_range",
        "original_range_len",
        "mod_range_len",
        "delta_len",
        "unbraced_parse_range",
        "commands",
        "oc",
        "last_index",
        "pIndex",
        "bIndex"
    };
} // end class DescendContainerSwitchValidateCmd

