// TJC implementation of procedure descend_tree_get
package tjc;
import tcl.lang.*;

public class DescendTreeGetCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 5, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 4) {
            throw new TclNumArgsException(interp, 1, objv, "script tree index");
        }
        setVarScalar(interp, "script", objv[1], compiledLocals, 0);
        setVarScalar(interp, "tree", objv[2], compiledLocals, 1);
        setVarScalar(interp, "index", objv[3], compiledLocals, 2);
        { // Invoke: set stree [...]
            TclObject tmp0;
            { // Invoke: lindex $tree $index
                TclObject tmp1 = null;
                TclObject tmp2;
                try {
                    tmp1 = getVarScalar(interp, "tree", compiledLocals, 1);
                    tmp1.preserve();
                    tmp2 = getVarScalar(interp, "index", compiledLocals, 2);
                    TJC.lindexNonconst(interp, tmp1, tmp2);
                } finally {
                    if ( tmp1 != null ) {
                        tmp1.release();
                    }
                }
            } // End Invoke: lindex
            tmp0 = interp.getResult();
            setVarScalar(interp, "stree", tmp0, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: if ... ...
            { // Invoke: parse_is_simple_text $stree
                TclObject[] objv3 = TJC.grabObjv(interp, 2);
                TclObject tmp4;
                try {
                    // Arg 0 constant: parse_is_simple_text
                    objv3[0] = const0;
                    // Arg 1 variable: $stree
                    tmp4 = getVarScalar(interp, "stree", compiledLocals, 3);
                    tmp4.preserve();
                    objv3[1] = tmp4;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv3, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp4 = objv3[1];
                    if ( tmp4 != null ) {
                        tmp4.release();
                    }
                    TJC.releaseObjv(interp, objv3, 2);
                }
            } // End Invoke: parse_is_simple_text
            TclObject tmp5 = interp.getResult();
            ExprValue tmp6 = evs0;
            TJC.exprInitValue(interp, tmp6, tmp5);
            boolean tmp7 = tmp6.getBooleanValue(interp);
            if ( tmp7 ) {
                { // Invoke: return [...]
                    { // Invoke: list 1 [...]
                        TclObject tmp8 = TclList.newInstance();
                        TclObject tmp9;
                        try {
                            TclList.append(interp, tmp8, const1);
                            { // Invoke: ... $script $stree
                                TclObject[] objv10 = TJC.grabObjv(interp, 3);
                                TclObject tmp11;
                                try {
                                    // Arg 0 constant: ...
                                    objv10[0] = const2;
                                    // Arg 1 variable: $script
                                    tmp11 = getVarScalar(interp, "script", compiledLocals, 0);
                                    tmp11.preserve();
                                    objv10[1] = tmp11;
                                    // Arg 2 variable: $stree
                                    tmp11 = getVarScalar(interp, "stree", compiledLocals, 3);
                                    tmp11.preserve();
                                    objv10[2] = tmp11;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                        ? cmdcache2.cmd : null), objv10, 0);
                                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                        updateCmdCache(interp, 2);
                                    }
                                } finally {
                                    tmp11 = objv10[1];
                                    if ( tmp11 != null ) {
                                        tmp11.release();
                                    }
                                    tmp11 = objv10[2];
                                    if ( tmp11 != null ) {
                                        tmp11.release();
                                    }
                                    TJC.releaseObjv(interp, objv10, 3);
                                }
                            } // End Invoke: ...
                            tmp9 = interp.getResult();
                            TclList.append(interp, tmp8, tmp9);
                        } catch (TclException ex) {
                            tmp8.release();
                            throw ex;
                        }
                        interp.setResult(tmp8);
                    } // End Invoke: list
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            { // Invoke: parse_is_word $stree
                TclObject[] objv12 = TJC.grabObjv(interp, 2);
                TclObject tmp13;
                try {
                    // Arg 0 constant: parse_is_word
                    objv12[0] = const3;
                    // Arg 1 variable: $stree
                    tmp13 = getVarScalar(interp, "stree", compiledLocals, 3);
                    tmp13.preserve();
                    objv12[1] = tmp13;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv12, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp13 = objv12[1];
                    if ( tmp13 != null ) {
                        tmp13.release();
                    }
                    TJC.releaseObjv(interp, objv12, 2);
                }
            } // End Invoke: parse_is_word
            TclObject tmp14 = interp.getResult();
            ExprValue tmp15 = evs0;
            TJC.exprInitValue(interp, tmp15, tmp14);
            boolean tmp16 = tmp15.getBooleanValue(interp);
            if ( tmp16 ) {
                { // Invoke: if ... ...
                    { // Invoke: ... $stree
                        TclObject[] objv17 = TJC.grabObjv(interp, 2);
                        TclObject tmp18;
                        try {
                            // Arg 0 constant: ...
                            objv17[0] = const4;
                            // Arg 1 variable: $stree
                            tmp18 = getVarScalar(interp, "stree", compiledLocals, 3);
                            tmp18.preserve();
                            objv17[1] = tmp18;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                ? cmdcache4.cmd : null), objv17, 0);
                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                updateCmdCache(interp, 4);
                            }
                        } finally {
                            tmp18 = objv17[1];
                            if ( tmp18 != null ) {
                                tmp18.release();
                            }
                            TJC.releaseObjv(interp, objv17, 2);
                        }
                    } // End Invoke: ...
                    TclObject tmp19 = interp.getResult();
                    ExprValue tmp20 = evs0;
                    TJC.exprInitValue(interp, tmp20, tmp19);
                    boolean tmp21 = tmp20.getBooleanValue(interp);
                    if ( tmp21 ) {
                        { // Invoke: return [...]
                            { // Invoke: list 1 [...]
                                TclObject tmp22 = TclList.newInstance();
                                TclObject tmp23;
                                try {
                                    TclList.append(interp, tmp22, const1);
                                    { // Invoke: ... $script $stree
                                        TclObject[] objv24 = TJC.grabObjv(interp, 3);
                                        TclObject tmp25;
                                        try {
                                            // Arg 0 constant: ...
                                            objv24[0] = const5;
                                            // Arg 1 variable: $script
                                            tmp25 = getVarScalar(interp, "script", compiledLocals, 0);
                                            tmp25.preserve();
                                            objv24[1] = tmp25;
                                            // Arg 2 variable: $stree
                                            tmp25 = getVarScalar(interp, "stree", compiledLocals, 3);
                                            tmp25.preserve();
                                            objv24[2] = tmp25;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                                ? cmdcache5.cmd : null), objv24, 0);
                                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                                updateCmdCache(interp, 5);
                                            }
                                        } finally {
                                            tmp25 = objv24[1];
                                            if ( tmp25 != null ) {
                                                tmp25.release();
                                            }
                                            tmp25 = objv24[2];
                                            if ( tmp25 != null ) {
                                                tmp25.release();
                                            }
                                            TJC.releaseObjv(interp, objv24, 3);
                                        }
                                    } // End Invoke: ...
                                    tmp23 = interp.getResult();
                                    TclList.append(interp, tmp22, tmp23);
                                } catch (TclException ex) {
                                    tmp22.release();
                                    throw ex;
                                }
                                interp.setResult(tmp22);
                            } // End Invoke: list
                            if ( true ) { return; }
                        } // End Invoke: return
                    }
                } // End Invoke: if
                { // Invoke: if ... ...
                    { // Invoke: ... $stree
                        TclObject[] objv26 = TJC.grabObjv(interp, 2);
                        TclObject tmp27;
                        try {
                            // Arg 0 constant: ...
                            objv26[0] = const6;
                            // Arg 1 variable: $stree
                            tmp27 = getVarScalar(interp, "stree", compiledLocals, 3);
                            tmp27.preserve();
                            objv26[1] = tmp27;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                ? cmdcache6.cmd : null), objv26, 0);
                            if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                updateCmdCache(interp, 6);
                            }
                        } finally {
                            tmp27 = objv26[1];
                            if ( tmp27 != null ) {
                                tmp27.release();
                            }
                            TJC.releaseObjv(interp, objv26, 2);
                        }
                    } // End Invoke: ...
                    TclObject tmp28 = interp.getResult();
                    ExprValue tmp29 = evs0;
                    TJC.exprInitValue(interp, tmp29, tmp28);
                    boolean tmp30 = tmp29.getBooleanValue(interp);
                    if ( tmp30 ) {
                        { // Invoke: return [...]
                            { // Invoke: list 1 [...]
                                TclObject tmp31 = TclList.newInstance();
                                TclObject tmp32;
                                try {
                                    TclList.append(interp, tmp31, const1);
                                    { // Invoke: ... $script $stree
                                        TclObject[] objv33 = TJC.grabObjv(interp, 3);
                                        TclObject tmp34;
                                        try {
                                            // Arg 0 constant: ...
                                            objv33[0] = const7;
                                            // Arg 1 variable: $script
                                            tmp34 = getVarScalar(interp, "script", compiledLocals, 0);
                                            tmp34.preserve();
                                            objv33[1] = tmp34;
                                            // Arg 2 variable: $stree
                                            tmp34 = getVarScalar(interp, "stree", compiledLocals, 3);
                                            tmp34.preserve();
                                            objv33[2] = tmp34;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                                ? cmdcache7.cmd : null), objv33, 0);
                                            if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                                updateCmdCache(interp, 7);
                                            }
                                        } finally {
                                            tmp34 = objv33[1];
                                            if ( tmp34 != null ) {
                                                tmp34.release();
                                            }
                                            tmp34 = objv33[2];
                                            if ( tmp34 != null ) {
                                                tmp34.release();
                                            }
                                            TJC.releaseObjv(interp, objv33, 3);
                                        }
                                    } // End Invoke: ...
                                    tmp32 = interp.getResult();
                                    TclList.append(interp, tmp31, tmp32);
                                } catch (TclException ex) {
                                    tmp31.release();
                                    throw ex;
                                }
                                interp.setResult(tmp31);
                            } // End Invoke: list
                            if ( true ) { return; }
                        } // End Invoke: return
                    }
                } // End Invoke: if
                { // Invoke: set range [...]
                    TclObject tmp35;
                    { // Invoke: lindex $stree 1
                        TclObject tmp36 = getVarScalar(interp, "stree", compiledLocals, 3);
                        tmp36 = TclList.index(interp, tmp36, 1);
                        if ( tmp36 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp36);
                        }
                    } // End Invoke: lindex
                    tmp35 = interp.getResult();
                    setVarScalar(interp, "range", tmp35, compiledLocals, 4);
                } // End Invoke: set
                { // Invoke: return [...]
                    { // Invoke: list 1 [...]
                        TclObject tmp37 = TclList.newInstance();
                        TclObject tmp38;
                        try {
                            TclList.append(interp, tmp37, const1);
                            { // Invoke: parse getstring $script $range
                                TclObject[] objv39 = TJC.grabObjv(interp, 4);
                                TclObject tmp40;
                                try {
                                    // Arg 0 constant: parse
                                    objv39[0] = const8;
                                    // Arg 1 constant: getstring
                                    objv39[1] = const9;
                                    // Arg 2 variable: $script
                                    tmp40 = getVarScalar(interp, "script", compiledLocals, 0);
                                    tmp40.preserve();
                                    objv39[2] = tmp40;
                                    // Arg 3 variable: $range
                                    tmp40 = getVarScalar(interp, "range", compiledLocals, 4);
                                    tmp40.preserve();
                                    objv39[3] = tmp40;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                        ? cmdcache8.cmd : null), objv39, 0);
                                    if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                        updateCmdCache(interp, 8);
                                    }
                                } finally {
                                    tmp40 = objv39[2];
                                    if ( tmp40 != null ) {
                                        tmp40.release();
                                    }
                                    tmp40 = objv39[3];
                                    if ( tmp40 != null ) {
                                        tmp40.release();
                                    }
                                    TJC.releaseObjv(interp, objv39, 4);
                                }
                            } // End Invoke: parse
                            tmp38 = interp.getResult();
                            TclList.append(interp, tmp37, tmp38);
                        } catch (TclException ex) {
                            tmp37.release();
                            throw ex;
                        }
                        interp.setResult(tmp37);
                    } // End Invoke: list
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: return {0 {}}
            interp.resetResult();
            interp.setResult(const10);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "descend_tree_get");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("parse_is_simple_text");
        const0.preserve(); const0.preserve();
        const1 = TclInteger.newInstance(1);
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("parse_get_simple_text");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("parse_is_word");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("parse_is_word_command");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("parse_get_word_command");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("parse_is_word_variable");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("parse_get_word_variable");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("parse");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("getstring");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("0 {}");
        const10.preserve(); const10.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "parse_is_simple_text";
                break;
            }
            case 2: {
                cmdName = "parse_get_simple_text";
                break;
            }
            case 3: {
                cmdName = "parse_is_word";
                break;
            }
            case 4: {
                cmdName = "parse_is_word_command";
                break;
            }
            case 5: {
                cmdName = "parse_get_word_command";
                break;
            }
            case 6: {
                cmdName = "parse_is_word_variable";
                break;
            }
            case 7: {
                cmdName = "parse_get_word_variable";
                break;
            }
            case 8: {
                cmdName = "parse";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "script",
        "tree",
        "index",
        "stree",
        "range"
    };
} // end class DescendTreeGetCmd

