// TJC implementation of procedure emitter_array_assign
package tjc;
import tcl.lang.*;

public class EmitterArrayAssignCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 3, compiledLocalsNames);
        try {
        if (objv.length != 4) {
            throw new TclNumArgsException(interp, 1, objv, "arraysym index valsym");
        }
        setVarScalar(interp, "arraysym", objv[1], compiledLocals, 0);
        setVarScalar(interp, "index", objv[2], compiledLocals, 1);
        setVarScalar(interp, "valsym", objv[3], compiledLocals, 2);
        { // Invoke: return "..."
            TclObject tmp0;
            StringBuffer sbtmp1 = new StringBuffer(64);
            { // Invoke: emitter_indent
                TclObject[] objv2 = TJC.grabObjv(interp, 1);
                try {
                    // Arg 0 constant: emitter_indent
                    objv2[0] = const0;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv2, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv2, 1);
                }
            } // End Invoke: emitter_indent
            tmp0 = interp.getResult();
            sbtmp1.append(tmp0.toString());
            tmp0 = getVarScalar(interp, "arraysym", compiledLocals, 0);
            sbtmp1.append(tmp0.toString());
            sbtmp1.append("[");
            tmp0 = getVarScalar(interp, "index", compiledLocals, 1);
            sbtmp1.append(tmp0.toString());
            sbtmp1.append("]");
            sbtmp1.append(" = ");
            tmp0 = getVarScalar(interp, "valsym", compiledLocals, 2);
            sbtmp1.append(tmp0.toString());
            sbtmp1.append(";");
            sbtmp1.append("\n");
            tmp0 = TclString.newInstance(sbtmp1);
            interp.resetResult();
            interp.setResult(tmp0);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "emitter_array_assign");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("emitter_indent");
        const0.preserve(); const0.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "emitter_indent";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "arraysym",
        "index",
        "valsym"
    };
} // end class EmitterArrayAssignCmd

