// TJC implementation of procedure emitter_backslash_tcl_elem
package tjc;
import tcl.lang.*;

public class EmitterBackslashTclElemCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 9, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        ExprValue evs2 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "elem");
        }
        setVarScalar(interp, "elem", objv[1], compiledLocals, 0);
        { // Invoke: set elen [...]
            TclObject tmp0;
            { // Invoke: string length $elem
                TclObject tmp1 = getVarScalar(interp, "elem", compiledLocals, 0);
                int tmp2 = tmp1.toString().length();
                interp.setResult(tmp2);
            } // End Invoke: string
            tmp0 = interp.getResult();
            setVarScalar(interp, "elen", tmp0, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: () || ()
            // Binary operator: $elen == 0
            TclObject tmp3 = getVarScalar(interp, "elen", compiledLocals, 1);
            ExprValue tmp4 = evs0;
            TJC.exprInitValue(interp, tmp4, tmp3);
            ExprValue tmp5 = evs1;
            tmp5.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp4, tmp5);
            // End Binary operator: ==
            if (!tmp4.getBooleanValue(interp)) {
            // Binary operator: $elen == 1
            TclObject tmp6 = getVarScalar(interp, "elen", compiledLocals, 1);
            ExprValue tmp7 = evs1;
            TJC.exprInitValue(interp, tmp7, tmp6);
            ExprValue tmp8 = evs2;
            tmp8.setIntValue(1);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp7, tmp8);
            // End Binary operator: ==
            tmp4.setIntValue(tmp7.getBooleanValue(interp));
            } else {
            tmp4.setIntValue(1);
            } // End if: !()
            // End Binary operator: ||
            boolean tmp9 = ( tmp4.getIntValue() != 0 );
            if ( tmp9 ) {
                { // Invoke: error "..."
                    TclObject[] objv10 = TJC.grabObjv(interp, 2);
                    TclObject tmp11;
                    try {
                        // Arg 0 constant: error
                        objv10[0] = const0;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp12 = new StringBuffer(64);
                        sbtmp12.append("elem ");
                        sbtmp12.append("\"");
                        tmp11 = getVarScalar(interp, "elem", compiledLocals, 0);
                        sbtmp12.append(tmp11.toString());
                        sbtmp12.append("\"");
                        sbtmp12.append(" is invalid");
                        tmp11 = TclString.newInstance(sbtmp12);
                        tmp11.preserve();
                        objv10[1] = tmp11;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv10, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp11 = objv10[1];
                        if ( tmp11 != null ) {
                            tmp11.release();
                        }
                        TJC.releaseObjv(interp, objv10, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            // Binary operator: [...] != "\\"
            { // Invoke: string index $elem 0
                TclObject tmp13 = getVarScalar(interp, "elem", compiledLocals, 0);
                String tmp14 = tmp13.toString();
                TclObject tmp15 = TJC.stringIndex(interp, tmp14, const1);
                interp.setResult(tmp15);
            } // End Invoke: string
            TclObject tmp16 = interp.getResult();
            boolean tmp17 = ! tmp16.toString().equals("\\");
            ExprValue tmp18 = evs0;
            tmp18.setIntValue(tmp17);
            // End Binary operator: !=
            boolean tmp19 = ( tmp18.getIntValue() != 0 );
            if ( tmp19 ) {
                { // Invoke: error "..."
                    TclObject[] objv20 = TJC.grabObjv(interp, 2);
                    TclObject tmp21;
                    try {
                        // Arg 0 constant: error
                        objv20[0] = const0;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp22 = new StringBuffer(64);
                        sbtmp22.append("elem ");
                        sbtmp22.append("\"");
                        tmp21 = getVarScalar(interp, "elem", compiledLocals, 0);
                        sbtmp22.append(tmp21.toString());
                        sbtmp22.append("\"");
                        sbtmp22.append(" is invalid");
                        tmp21 = TclString.newInstance(sbtmp22);
                        tmp21.preserve();
                        objv20[1] = tmp21;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv20, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp21 = objv20[1];
                        if ( tmp21 != null ) {
                            tmp21.release();
                        }
                        TJC.releaseObjv(interp, objv20, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: incr elen -1
            interp.resetResult();
            incrVarScalar(interp, "elen", -1, compiledLocals, 1);
        } // End Invoke: incr
        { // Invoke: if ... ... else ...
            // Binary operator: () && [...]
            // Binary operator: $elen == 1
            TclObject tmp23 = getVarScalar(interp, "elen", compiledLocals, 1);
            ExprValue tmp24 = evs0;
            TJC.exprInitValue(interp, tmp24, tmp23);
            ExprValue tmp25 = evs1;
            tmp25.setIntValue(1);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp24, tmp25);
            // End Binary operator: ==
            if (tmp24.getBooleanValue(interp)) {
            { // Invoke: regexp ... $elem
                TclObject[] objv26 = TJC.grabObjv(interp, 3);
                TclObject tmp27;
                try {
                    // Arg 0 constant: regexp
                    objv26[0] = const2;
                    // Arg 1 constant: ...
                    objv26[1] = const3;
                    // Arg 2 variable: $elem
                    tmp27 = getVarScalar(interp, "elem", compiledLocals, 0);
                    tmp27.preserve();
                    objv26[2] = tmp27;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv26, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp27 = objv26[2];
                    if ( tmp27 != null ) {
                        tmp27.release();
                    }
                    TJC.releaseObjv(interp, objv26, 3);
                }
            } // End Invoke: regexp
            TclObject tmp28 = interp.getResult();
            ExprValue tmp29 = evs1;
            TJC.exprInitValue(interp, tmp29, tmp28);
            tmp24.setIntValue(tmp29.getBooleanValue(interp));
            } else {
            tmp24.setIntValue(0);
            } // End if: ()
            // End Binary operator: &&
            boolean tmp30 = ( tmp24.getIntValue() != 0 );
            if ( tmp30 ) {
                { // Invoke: set is_octal 1
                    setVarScalar(interp, "is_octal", const4, compiledLocals, 2);
                } // End Invoke: set
            } else {
                { // Invoke: set is_octal 0
                    setVarScalar(interp, "is_octal", const1, compiledLocals, 2);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: if ... ... else ...
            // Binary operator: () && ()
            // Binary operator: $elen == 1
            TclObject tmp31 = getVarScalar(interp, "elen", compiledLocals, 1);
            ExprValue tmp32 = evs0;
            TJC.exprInitValue(interp, tmp32, tmp31);
            ExprValue tmp33 = evs1;
            tmp33.setIntValue(1);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp32, tmp33);
            // End Binary operator: ==
            if (tmp32.getBooleanValue(interp)) {
            // Unary operator: ! $is_octal
            TclObject tmp34 = getVarScalar(interp, "is_octal", compiledLocals, 2);
            ExprValue tmp35 = evs1;
            if ( tmp34.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp35, tmp34);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp35, tmp34);
            }
            // End Unary operator: !
            tmp32.setIntValue(tmp35.getBooleanValue(interp));
            } else {
            tmp32.setIntValue(0);
            } // End if: ()
            // End Binary operator: &&
            boolean tmp36 = ( tmp32.getIntValue() != 0 );
            if ( tmp36 ) {
                { // Invoke: switch -exact -- $elem ... - ... - ... - ... - ... - ... - ... - ... ... ... ... default ...
                    TclObject tmp37 = getVarScalar(interp, "elem", compiledLocals, 0);
                    String tmp38 = tmp37.toString();
                    int tmp38_length = tmp38.length();
                    char tmp38_first = '\n';
                    if ( tmp38_length > 0 ) {
                        tmp38_first = tmp38.charAt(0);
                    }
                    interp.resetResult();
                    if ( ( tmp38_length == 2 && tmp38_first == '\\'
                            && tmp38.compareTo("\\a") == 0 ) ||
                        ( tmp38_length == 2 && tmp38_first == '\\'
                            && tmp38.compareTo("\\b") == 0 ) ||
                        ( tmp38_length == 2 && tmp38_first == '\\'
                            && tmp38.compareTo("\\f") == 0 ) ||
                        ( tmp38_length == 2 && tmp38_first == '\\'
                            && tmp38.compareTo("\\n") == 0 ) ||
                        ( tmp38_length == 2 && tmp38_first == '\\'
                            && tmp38.compareTo("\\r") == 0 ) ||
                        ( tmp38_length == 2 && tmp38_first == '\\'
                            && tmp38.compareTo("\\t") == 0 ) ||
                        ( tmp38_length == 2 && tmp38_first == '\\'
                            && tmp38.compareTo("\\v") == 0 ) ||
                        ( tmp38_length == 2 && tmp38_first == '\\'
                            && tmp38.compareTo("\\\\") == 0 ) ) {
                        // Pattern ...
                        { // Invoke: return $elem
                            TclObject tmp39 = getVarScalar(interp, "elem", compiledLocals, 0);
                            interp.resetResult();
                            interp.setResult(tmp39);
                            if ( true ) { return; }
                        } // End Invoke: return
                    } else if ( tmp38_length == 2 && tmp38_first == '\\'
                            && tmp38.compareTo("\\\n") == 0 ) {
                        // Pattern ...
                        { // Invoke: return " "
                            interp.resetResult();
                            interp.setResult(const5);
                            if ( true ) { return; }
                        } // End Invoke: return
                    } else {
                        // Pattern default
                        { // Invoke: return [...]
                            { // Invoke: string range $elem 1 end
                                TclObject tmp40 = getVarScalar(interp, "elem", compiledLocals, 0);
                                String tmp41 = tmp40.toString();
                                TclObject tmp42 = const4;
                                tmp42.preserve();
                                TclObject tmp43 = const6;
                                TclObject tmp44 = TJC.stringRange(interp, tmp41, tmp42, tmp43);
                                interp.setResult(tmp44);
                            } // End Invoke: string
                            if ( true ) { return; }
                        } // End Invoke: return
                    }
                } // End Invoke: switch
            } else {
                { // Invoke: set first [...]
                    TclObject tmp45;
                    { // Invoke: string index $elem 1
                        TclObject tmp46 = getVarScalar(interp, "elem", compiledLocals, 0);
                        String tmp47 = tmp46.toString();
                        TclObject tmp48 = TJC.stringIndex(interp, tmp47, const4);
                        interp.setResult(tmp48);
                    } // End Invoke: string
                    tmp45 = interp.getResult();
                    setVarScalar(interp, "first", tmp45, compiledLocals, 3);
                } // End Invoke: set
                { // Invoke: set rest [...]
                    TclObject tmp49;
                    { // Invoke: string range $elem 1 end
                        TclObject tmp50 = getVarScalar(interp, "elem", compiledLocals, 0);
                        String tmp51 = tmp50.toString();
                        TclObject tmp52 = const4;
                        tmp52.preserve();
                        TclObject tmp53 = const6;
                        TclObject tmp54 = TJC.stringRange(interp, tmp51, tmp52, tmp53);
                        interp.setResult(tmp54);
                    } // End Invoke: string
                    tmp49 = interp.getResult();
                    setVarScalar(interp, "rest", tmp49, compiledLocals, 4);
                } // End Invoke: set
                { // Invoke: switch -exact -- $first {u} ... {x} ... default ...
                    TclObject tmp55 = getVarScalar(interp, "first", compiledLocals, 3);
                    String tmp56 = tmp55.toString();
                    int tmp56_length = tmp56.length();
                    char tmp56_first = '\n';
                    if ( tmp56_length > 0 ) {
                        tmp56_first = tmp56.charAt(0);
                    }
                    interp.resetResult();
                    if ( tmp56_length == 1 && tmp56_first == 'u' ) {
                        // Pattern {u}
                        { // Invoke: set p {[0-9|a-f|A-F]}
                            setVarScalar(interp, "p", const7, compiledLocals, 5);
                        } // End Invoke: set
                        { // Invoke: set wp "..."
                            TclObject tmp57;
                            StringBuffer sbtmp58 = new StringBuffer(64);
                            sbtmp58.append("^u(");
                            tmp57 = getVarScalar(interp, "p", compiledLocals, 5);
                            sbtmp58.append(tmp57.toString());
                            sbtmp58.append("|");
                            tmp57 = getVarScalar(interp, "p", compiledLocals, 5);
                            sbtmp58.append(tmp57.toString());
                            tmp57 = getVarScalar(interp, "p", compiledLocals, 5);
                            sbtmp58.append(tmp57.toString());
                            sbtmp58.append("|");
                            tmp57 = getVarScalar(interp, "p", compiledLocals, 5);
                            sbtmp58.append(tmp57.toString());
                            tmp57 = getVarScalar(interp, "p", compiledLocals, 5);
                            sbtmp58.append(tmp57.toString());
                            tmp57 = getVarScalar(interp, "p", compiledLocals, 5);
                            sbtmp58.append(tmp57.toString());
                            sbtmp58.append("|");
                            tmp57 = getVarScalar(interp, "p", compiledLocals, 5);
                            sbtmp58.append(tmp57.toString());
                            tmp57 = getVarScalar(interp, "p", compiledLocals, 5);
                            sbtmp58.append(tmp57.toString());
                            tmp57 = getVarScalar(interp, "p", compiledLocals, 5);
                            sbtmp58.append(tmp57.toString());
                            tmp57 = getVarScalar(interp, "p", compiledLocals, 5);
                            sbtmp58.append(tmp57.toString());
                            sbtmp58.append(")");
                            sbtmp58.append("$");
                            tmp57 = TclString.newInstance(sbtmp58);
                            setVarScalar(interp, "wp", tmp57, compiledLocals, 6);
                        } // End Invoke: set
                        { // Invoke: if ... ...
                            // Unary operator: ! [...]
                            { // Invoke: regexp $wp $rest
                                TclObject[] objv59 = TJC.grabObjv(interp, 3);
                                TclObject tmp60;
                                try {
                                    // Arg 0 constant: regexp
                                    objv59[0] = const2;
                                    // Arg 1 variable: $wp
                                    tmp60 = getVarScalar(interp, "wp", compiledLocals, 6);
                                    tmp60.preserve();
                                    objv59[1] = tmp60;
                                    // Arg 2 variable: $rest
                                    tmp60 = getVarScalar(interp, "rest", compiledLocals, 4);
                                    tmp60.preserve();
                                    objv59[2] = tmp60;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                        ? cmdcache2.cmd : null), objv59, 0);
                                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                        updateCmdCache(interp, 2);
                                    }
                                } finally {
                                    tmp60 = objv59[1];
                                    if ( tmp60 != null ) {
                                        tmp60.release();
                                    }
                                    tmp60 = objv59[2];
                                    if ( tmp60 != null ) {
                                        tmp60.release();
                                    }
                                    TJC.releaseObjv(interp, objv59, 3);
                                }
                            } // End Invoke: regexp
                            TclObject tmp61 = interp.getResult();
                            ExprValue tmp62 = evs0;
                            if ( tmp61.isIntType() ) {
                                TJC.exprUnaryNotOperatorKnownInt(tmp62, tmp61);
                            } else {
                                TJC.exprUnaryNotOperator(interp, tmp62, tmp61);
                            }
                            // End Unary operator: !
                            boolean tmp63 = ( tmp62.getIntValue() != 0 );
                            if ( tmp63 ) {
                                { // Invoke: error "..."
                                    TclObject[] objv64 = TJC.grabObjv(interp, 2);
                                    TclObject tmp65;
                                    try {
                                        // Arg 0 constant: error
                                        objv64[0] = const0;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp66 = new StringBuffer(64);
                                        sbtmp66.append("unicode escape ");
                                        sbtmp66.append("\"");
                                        tmp65 = getVarScalar(interp, "elem", compiledLocals, 0);
                                        sbtmp66.append(tmp65.toString());
                                        sbtmp66.append("\"");
                                        sbtmp66.append(" is not valid, should match ");
                                        sbtmp66.append("\"");
                                        sbtmp66.append("\\");
                                        sbtmp66.append("uXXXX");
                                        sbtmp66.append("\"");
                                        tmp65 = TclString.newInstance(sbtmp66);
                                        tmp65.preserve();
                                        objv64[1] = tmp65;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                            ? cmdcache1.cmd : null), objv64, 0);
                                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                            updateCmdCache(interp, 1);
                                        }
                                    } finally {
                                        tmp65 = objv64[1];
                                        if ( tmp65 != null ) {
                                            tmp65.release();
                                        }
                                        TJC.releaseObjv(interp, objv64, 2);
                                    }
                                } // End Invoke: error
                            }
                        } // End Invoke: if
                        { // Invoke: set digits [...]
                            TclObject tmp67;
                            { // Invoke: string range $rest 1 end
                                TclObject tmp68 = getVarScalar(interp, "rest", compiledLocals, 4);
                                String tmp69 = tmp68.toString();
                                TclObject tmp70 = const4;
                                tmp70.preserve();
                                TclObject tmp71 = const6;
                                TclObject tmp72 = TJC.stringRange(interp, tmp69, tmp70, tmp71);
                                interp.setResult(tmp72);
                            } // End Invoke: string
                            tmp67 = interp.getResult();
                            setVarScalar(interp, "digits", tmp67, compiledLocals, 7);
                        } // End Invoke: set
                        { // Invoke: set digits [...]
                            TclObject tmp73;
                            { // Invoke: string toupper $digits
                                TclObject[] objv74 = TJC.grabObjv(interp, 3);
                                TclObject tmp75;
                                try {
                                    // Arg 0 constant: string
                                    objv74[0] = const8;
                                    // Arg 1 constant: toupper
                                    objv74[1] = const9;
                                    // Arg 2 variable: $digits
                                    tmp75 = getVarScalar(interp, "digits", compiledLocals, 7);
                                    tmp75.preserve();
                                    objv74[2] = tmp75;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                        ? cmdcache3.cmd : null), objv74, 0);
                                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                        updateCmdCache(interp, 3);
                                    }
                                } finally {
                                    tmp75 = objv74[2];
                                    if ( tmp75 != null ) {
                                        tmp75.release();
                                    }
                                    TJC.releaseObjv(interp, objv74, 3);
                                }
                            } // End Invoke: string
                            tmp73 = interp.getResult();
                            setVarScalar(interp, "digits", tmp73, compiledLocals, 7);
                        } // End Invoke: set
                        { // Invoke: set dlen [...]
                            TclObject tmp76;
                            { // Invoke: string length $digits
                                TclObject tmp77 = getVarScalar(interp, "digits", compiledLocals, 7);
                                int tmp78 = tmp77.toString().length();
                                interp.setResult(tmp78);
                            } // End Invoke: string
                            tmp76 = interp.getResult();
                            setVarScalar(interp, "dlen", tmp76, compiledLocals, 8);
                        } // End Invoke: set
                        { // Invoke: if {$dlen == 0} ... else ...
                            // Binary operator: $dlen == 0
                            TclObject tmp79 = getVarScalar(interp, "dlen", compiledLocals, 8);
                            ExprValue tmp80 = evs0;
                            TJC.exprInitValue(interp, tmp80, tmp79);
                            ExprValue tmp81 = evs1;
                            tmp81.setIntValue(0);
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp80, tmp81);
                            // End Binary operator: ==
                            boolean tmp82 = ( tmp80.getIntValue() != 0 );
                            if ( tmp82 ) {
                                { // Invoke: error "..."
                                    TclObject[] objv83 = TJC.grabObjv(interp, 2);
                                    TclObject tmp84;
                                    try {
                                        // Arg 0 constant: error
                                        objv83[0] = const0;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp85 = new StringBuffer(64);
                                        sbtmp85.append("unexpected empty digits for elem ");
                                        sbtmp85.append("\"");
                                        tmp84 = getVarScalar(interp, "elem", compiledLocals, 0);
                                        sbtmp85.append(tmp84.toString());
                                        sbtmp85.append("\"");
                                        tmp84 = TclString.newInstance(sbtmp85);
                                        tmp84.preserve();
                                        objv83[1] = tmp84;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                            ? cmdcache1.cmd : null), objv83, 0);
                                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                            updateCmdCache(interp, 1);
                                        }
                                    } finally {
                                        tmp84 = objv83[1];
                                        if ( tmp84 != null ) {
                                            tmp84.release();
                                        }
                                        TJC.releaseObjv(interp, objv83, 2);
                                    }
                                } // End Invoke: error
                            } else {
                                { // Invoke: return [...]
                                    { // Invoke: format ... $digits
                                        TclObject[] objv86 = TJC.grabObjv(interp, 3);
                                        TclObject tmp87;
                                        try {
                                            // Arg 0 constant: format
                                            objv86[0] = const10;
                                            // Arg 1 constant: ...
                                            objv86[1] = const11;
                                            // Arg 2 variable: $digits
                                            tmp87 = getVarScalar(interp, "digits", compiledLocals, 7);
                                            tmp87.preserve();
                                            objv86[2] = tmp87;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                ? cmdcache4.cmd : null), objv86, 0);
                                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                updateCmdCache(interp, 4);
                                            }
                                        } finally {
                                            tmp87 = objv86[2];
                                            if ( tmp87 != null ) {
                                                tmp87.release();
                                            }
                                            TJC.releaseObjv(interp, objv86, 3);
                                        }
                                    } // End Invoke: format
                                    if ( true ) { return; }
                                } // End Invoke: return
                            }
                        } // End Invoke: if
                    } else if ( tmp56_length == 1 && tmp56_first == 'x' ) {
                        // Pattern {x}
                        { // Invoke: if ... ...
                            // Unary operator: ! [...]
                            { // Invoke: regexp {^x[0-F]+$} $rest
                                TclObject[] objv88 = TJC.grabObjv(interp, 3);
                                TclObject tmp89;
                                try {
                                    // Arg 0 constant: regexp
                                    objv88[0] = const2;
                                    // Arg 1 constant: {^x[0-F]+$}
                                    objv88[1] = const12;
                                    // Arg 2 variable: $rest
                                    tmp89 = getVarScalar(interp, "rest", compiledLocals, 4);
                                    tmp89.preserve();
                                    objv88[2] = tmp89;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                        ? cmdcache2.cmd : null), objv88, 0);
                                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                        updateCmdCache(interp, 2);
                                    }
                                } finally {
                                    tmp89 = objv88[2];
                                    if ( tmp89 != null ) {
                                        tmp89.release();
                                    }
                                    TJC.releaseObjv(interp, objv88, 3);
                                }
                            } // End Invoke: regexp
                            TclObject tmp90 = interp.getResult();
                            ExprValue tmp91 = evs0;
                            if ( tmp90.isIntType() ) {
                                TJC.exprUnaryNotOperatorKnownInt(tmp91, tmp90);
                            } else {
                                TJC.exprUnaryNotOperator(interp, tmp91, tmp90);
                            }
                            // End Unary operator: !
                            boolean tmp92 = ( tmp91.getIntValue() != 0 );
                            if ( tmp92 ) {
                                { // Invoke: error "..."
                                    TclObject[] objv93 = TJC.grabObjv(interp, 2);
                                    TclObject tmp94;
                                    try {
                                        // Arg 0 constant: error
                                        objv93[0] = const0;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp95 = new StringBuffer(64);
                                        sbtmp95.append("hex escape ");
                                        sbtmp95.append("\"");
                                        tmp94 = getVarScalar(interp, "elem", compiledLocals, 0);
                                        sbtmp95.append(tmp94.toString());
                                        sbtmp95.append("\"");
                                        sbtmp95.append(" is not valid, should match ");
                                        sbtmp95.append("\"");
                                        sbtmp95.append("\\");
                                        sbtmp95.append("xXX");
                                        sbtmp95.append("\"");
                                        tmp94 = TclString.newInstance(sbtmp95);
                                        tmp94.preserve();
                                        objv93[1] = tmp94;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                            ? cmdcache1.cmd : null), objv93, 0);
                                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                            updateCmdCache(interp, 1);
                                        }
                                    } finally {
                                        tmp94 = objv93[1];
                                        if ( tmp94 != null ) {
                                            tmp94.release();
                                        }
                                        TJC.releaseObjv(interp, objv93, 2);
                                    }
                                } // End Invoke: error
                            }
                        } // End Invoke: if
                        { // Invoke: set digits [...]
                            TclObject tmp96;
                            { // Invoke: string range $rest 1 end
                                TclObject tmp97 = getVarScalar(interp, "rest", compiledLocals, 4);
                                String tmp98 = tmp97.toString();
                                TclObject tmp99 = const4;
                                tmp99.preserve();
                                TclObject tmp100 = const6;
                                TclObject tmp101 = TJC.stringRange(interp, tmp98, tmp99, tmp100);
                                interp.setResult(tmp101);
                            } // End Invoke: string
                            tmp96 = interp.getResult();
                            setVarScalar(interp, "digits", tmp96, compiledLocals, 7);
                        } // End Invoke: set
                        { // Invoke: set dlen [...]
                            TclObject tmp102;
                            { // Invoke: string length $digits
                                TclObject tmp103 = getVarScalar(interp, "digits", compiledLocals, 7);
                                int tmp104 = tmp103.toString().length();
                                interp.setResult(tmp104);
                            } // End Invoke: string
                            tmp102 = interp.getResult();
                            setVarScalar(interp, "dlen", tmp102, compiledLocals, 8);
                        } // End Invoke: set
                        { // Invoke: if {$dlen == 0} ... elseif {$dlen == 1} ... else ...
                            // Binary operator: $dlen == 0
                            TclObject tmp105 = getVarScalar(interp, "dlen", compiledLocals, 8);
                            ExprValue tmp106 = evs0;
                            TJC.exprInitValue(interp, tmp106, tmp105);
                            ExprValue tmp107 = evs1;
                            tmp107.setIntValue(0);
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp106, tmp107);
                            // End Binary operator: ==
                            boolean tmp108 = ( tmp106.getIntValue() != 0 );
                            if ( tmp108 ) {
                                { // Invoke: error "..."
                                    TclObject[] objv109 = TJC.grabObjv(interp, 2);
                                    TclObject tmp110;
                                    try {
                                        // Arg 0 constant: error
                                        objv109[0] = const0;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp111 = new StringBuffer(64);
                                        sbtmp111.append("unexpected empty digits for elem ");
                                        sbtmp111.append("\"");
                                        tmp110 = getVarScalar(interp, "elem", compiledLocals, 0);
                                        sbtmp111.append(tmp110.toString());
                                        sbtmp111.append("\"");
                                        tmp110 = TclString.newInstance(sbtmp111);
                                        tmp110.preserve();
                                        objv109[1] = tmp110;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                            ? cmdcache1.cmd : null), objv109, 0);
                                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                            updateCmdCache(interp, 1);
                                        }
                                    } finally {
                                        tmp110 = objv109[1];
                                        if ( tmp110 != null ) {
                                            tmp110.release();
                                        }
                                        TJC.releaseObjv(interp, objv109, 2);
                                    }
                                } // End Invoke: error
                            } else {
                                // Binary operator: $dlen == 1
                                TclObject tmp112 = getVarScalar(interp, "dlen", compiledLocals, 8);
                                ExprValue tmp113 = evs0;
                                TJC.exprInitValue(interp, tmp113, tmp112);
                                ExprValue tmp114 = evs1;
                                tmp114.setIntValue(1);
                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp113, tmp114);
                                // End Binary operator: ==
                                boolean tmp115 = ( tmp113.getIntValue() != 0 );
                                if ( tmp115 ) {
                                    { // Invoke: return "..."
                                        TclObject tmp116;
                                        StringBuffer sbtmp117 = new StringBuffer(64);
                                        sbtmp117.append("\\");
                                        sbtmp117.append("x0");
                                        { // Invoke: string index $digits 0
                                            TclObject tmp118 = getVarScalar(interp, "digits", compiledLocals, 7);
                                            String tmp119 = tmp118.toString();
                                            TclObject tmp120 = TJC.stringIndex(interp, tmp119, const1);
                                            interp.setResult(tmp120);
                                        } // End Invoke: string
                                        tmp116 = interp.getResult();
                                        sbtmp117.append(tmp116.toString());
                                        tmp116 = TclString.newInstance(sbtmp117);
                                        interp.resetResult();
                                        interp.setResult(tmp116);
                                        if ( true ) { return; }
                                    } // End Invoke: return
                                } else {
                                    { // Invoke: return "..."
                                        TclObject tmp121;
                                        StringBuffer sbtmp122 = new StringBuffer(64);
                                        sbtmp122.append("\\");
                                        sbtmp122.append("x");
                                        { // Invoke: string range $digits end-1 end
                                            TclObject tmp123 = getVarScalar(interp, "digits", compiledLocals, 7);
                                            String tmp124 = tmp123.toString();
                                            TclObject tmp125 = const13;
                                            tmp125.preserve();
                                            TclObject tmp126 = const6;
                                            TclObject tmp127 = TJC.stringRange(interp, tmp124, tmp125, tmp126);
                                            interp.setResult(tmp127);
                                        } // End Invoke: string
                                        tmp121 = interp.getResult();
                                        sbtmp122.append(tmp121.toString());
                                        tmp121 = TclString.newInstance(sbtmp122);
                                        interp.resetResult();
                                        interp.setResult(tmp121);
                                        if ( true ) { return; }
                                    } // End Invoke: return
                                }
                            }
                        } // End Invoke: if
                    } else {
                        // Pattern default
                        { // Invoke: set p {[0-7]}
                            setVarScalar(interp, "p", const14, compiledLocals, 5);
                        } // End Invoke: set
                        { // Invoke: set wp "..."
                            TclObject tmp128;
                            StringBuffer sbtmp129 = new StringBuffer(64);
                            sbtmp129.append("^(");
                            tmp128 = getVarScalar(interp, "p", compiledLocals, 5);
                            sbtmp129.append(tmp128.toString());
                            sbtmp129.append("|");
                            tmp128 = getVarScalar(interp, "p", compiledLocals, 5);
                            sbtmp129.append(tmp128.toString());
                            tmp128 = getVarScalar(interp, "p", compiledLocals, 5);
                            sbtmp129.append(tmp128.toString());
                            sbtmp129.append("|");
                            tmp128 = getVarScalar(interp, "p", compiledLocals, 5);
                            sbtmp129.append(tmp128.toString());
                            tmp128 = getVarScalar(interp, "p", compiledLocals, 5);
                            sbtmp129.append(tmp128.toString());
                            tmp128 = getVarScalar(interp, "p", compiledLocals, 5);
                            sbtmp129.append(tmp128.toString());
                            sbtmp129.append(")");
                            sbtmp129.append("$");
                            tmp128 = TclString.newInstance(sbtmp129);
                            setVarScalar(interp, "wp", tmp128, compiledLocals, 6);
                        } // End Invoke: set
                        { // Invoke: if {[regexp $wp $rest]} ... elseif ... ... else ...
                            { // Invoke: regexp $wp $rest
                                TclObject[] objv130 = TJC.grabObjv(interp, 3);
                                TclObject tmp131;
                                try {
                                    // Arg 0 constant: regexp
                                    objv130[0] = const2;
                                    // Arg 1 variable: $wp
                                    tmp131 = getVarScalar(interp, "wp", compiledLocals, 6);
                                    tmp131.preserve();
                                    objv130[1] = tmp131;
                                    // Arg 2 variable: $rest
                                    tmp131 = getVarScalar(interp, "rest", compiledLocals, 4);
                                    tmp131.preserve();
                                    objv130[2] = tmp131;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                        ? cmdcache2.cmd : null), objv130, 0);
                                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                        updateCmdCache(interp, 2);
                                    }
                                } finally {
                                    tmp131 = objv130[1];
                                    if ( tmp131 != null ) {
                                        tmp131.release();
                                    }
                                    tmp131 = objv130[2];
                                    if ( tmp131 != null ) {
                                        tmp131.release();
                                    }
                                    TJC.releaseObjv(interp, objv130, 3);
                                }
                            } // End Invoke: regexp
                            TclObject tmp132 = interp.getResult();
                            ExprValue tmp133 = evs0;
                            TJC.exprInitValue(interp, tmp133, tmp132);
                            boolean tmp134 = tmp133.getBooleanValue(interp);
                            if ( tmp134 ) {
                                { // Invoke: set digits [...]
                                    TclObject tmp135;
                                    { // Invoke: string range $rest 0 end
                                        TclObject tmp136 = getVarScalar(interp, "rest", compiledLocals, 4);
                                        String tmp137 = tmp136.toString();
                                        TclObject tmp138 = const1;
                                        tmp138.preserve();
                                        TclObject tmp139 = const6;
                                        TclObject tmp140 = TJC.stringRange(interp, tmp137, tmp138, tmp139);
                                        interp.setResult(tmp140);
                                    } // End Invoke: string
                                    tmp135 = interp.getResult();
                                    setVarScalar(interp, "digits", tmp135, compiledLocals, 7);
                                } // End Invoke: set
                                { // Invoke: set dlen [...]
                                    TclObject tmp141;
                                    { // Invoke: string length $digits
                                        TclObject tmp142 = getVarScalar(interp, "digits", compiledLocals, 7);
                                        int tmp143 = tmp142.toString().length();
                                        interp.setResult(tmp143);
                                    } // End Invoke: string
                                    tmp141 = interp.getResult();
                                    setVarScalar(interp, "dlen", tmp141, compiledLocals, 8);
                                } // End Invoke: set
                                { // Invoke: if {$dlen == 0} ... else ...
                                    // Binary operator: $dlen == 0
                                    TclObject tmp144 = getVarScalar(interp, "dlen", compiledLocals, 8);
                                    ExprValue tmp145 = evs0;
                                    TJC.exprInitValue(interp, tmp145, tmp144);
                                    ExprValue tmp146 = evs1;
                                    tmp146.setIntValue(0);
                                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp145, tmp146);
                                    // End Binary operator: ==
                                    boolean tmp147 = ( tmp145.getIntValue() != 0 );
                                    if ( tmp147 ) {
                                        { // Invoke: error "..."
                                            TclObject[] objv148 = TJC.grabObjv(interp, 2);
                                            TclObject tmp149;
                                            try {
                                                // Arg 0 constant: error
                                                objv148[0] = const0;
                                                // Arg 1 word: "..."
                                                StringBuffer sbtmp150 = new StringBuffer(64);
                                                sbtmp150.append("unexpected empty digits for elem ");
                                                sbtmp150.append("\"");
                                                tmp149 = getVarScalar(interp, "elem", compiledLocals, 0);
                                                sbtmp150.append(tmp149.toString());
                                                sbtmp150.append("\"");
                                                tmp149 = TclString.newInstance(sbtmp150);
                                                tmp149.preserve();
                                                objv148[1] = tmp149;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                                    ? cmdcache1.cmd : null), objv148, 0);
                                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                                    updateCmdCache(interp, 1);
                                                }
                                            } finally {
                                                tmp149 = objv148[1];
                                                if ( tmp149 != null ) {
                                                    tmp149.release();
                                                }
                                                TJC.releaseObjv(interp, objv148, 2);
                                            }
                                        } // End Invoke: error
                                    } else {
                                        { // Invoke: return [...]
                                            { // Invoke: format ... $digits
                                                TclObject[] objv151 = TJC.grabObjv(interp, 3);
                                                TclObject tmp152;
                                                try {
                                                    // Arg 0 constant: format
                                                    objv151[0] = const10;
                                                    // Arg 1 constant: ...
                                                    objv151[1] = const15;
                                                    // Arg 2 variable: $digits
                                                    tmp152 = getVarScalar(interp, "digits", compiledLocals, 7);
                                                    tmp152.preserve();
                                                    objv151[2] = tmp152;
                                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                        updateCmdCache(interp, 0);
                                                    }
                                                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                        ? cmdcache4.cmd : null), objv151, 0);
                                                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                        updateCmdCache(interp, 4);
                                                    }
                                                } finally {
                                                    tmp152 = objv151[2];
                                                    if ( tmp152 != null ) {
                                                        tmp152.release();
                                                    }
                                                    TJC.releaseObjv(interp, objv151, 3);
                                                }
                                            } // End Invoke: format
                                            if ( true ) { return; }
                                        } // End Invoke: return
                                    }
                                } // End Invoke: if
                            } else {
                                { // Invoke: regexp ... $rest
                                    TclObject[] objv153 = TJC.grabObjv(interp, 3);
                                    TclObject tmp154;
                                    try {
                                        // Arg 0 constant: regexp
                                        objv153[0] = const2;
                                        // Arg 1 constant: ...
                                        objv153[1] = const16;
                                        // Arg 2 variable: $rest
                                        tmp154 = getVarScalar(interp, "rest", compiledLocals, 4);
                                        tmp154.preserve();
                                        objv153[2] = tmp154;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                            ? cmdcache2.cmd : null), objv153, 0);
                                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                            updateCmdCache(interp, 2);
                                        }
                                    } finally {
                                        tmp154 = objv153[2];
                                        if ( tmp154 != null ) {
                                            tmp154.release();
                                        }
                                        TJC.releaseObjv(interp, objv153, 3);
                                    }
                                } // End Invoke: regexp
                                TclObject tmp155 = interp.getResult();
                                ExprValue tmp156 = evs0;
                                TJC.exprInitValue(interp, tmp156, tmp155);
                                boolean tmp157 = tmp156.getBooleanValue(interp);
                                if ( tmp157 ) {
                                    { // Invoke: return " "
                                        interp.resetResult();
                                        interp.setResult(const5);
                                        if ( true ) { return; }
                                    } // End Invoke: return
                                } else {
                                    { // Invoke: error "..."
                                        TclObject[] objv158 = TJC.grabObjv(interp, 2);
                                        TclObject tmp159;
                                        try {
                                            // Arg 0 constant: error
                                            objv158[0] = const0;
                                            // Arg 1 word: "..."
                                            StringBuffer sbtmp160 = new StringBuffer(64);
                                            sbtmp160.append("unknown escape sequence ");
                                            sbtmp160.append("\"");
                                            sbtmp160.append("\\");
                                            tmp159 = getVarScalar(interp, "elem", compiledLocals, 0);
                                            sbtmp160.append(tmp159.toString());
                                            sbtmp160.append("\"");
                                            tmp159 = TclString.newInstance(sbtmp160);
                                            tmp159.preserve();
                                            objv158[1] = tmp159;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                                ? cmdcache1.cmd : null), objv158, 0);
                                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                                updateCmdCache(interp, 1);
                                            }
                                        } finally {
                                            tmp159 = objv158[1];
                                            if ( tmp159 != null ) {
                                                tmp159.release();
                                            }
                                            TJC.releaseObjv(interp, objv158, 2);
                                        }
                                    } // End Invoke: error
                                }
                            }
                        } // End Invoke: if
                    }
                } // End Invoke: switch
            }
        } // End Invoke: if
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "emitter_backslash_tcl_elem");
        } finally {
            TJC.exprReleaseValue(interp, evs2);
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("error");
        const0.preserve(); const0.preserve();
        const1 = TclInteger.newInstance(0);
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("regexp");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("^\\\\[0-7]$");
        const3.preserve(); const3.preserve();
        const4 = TclInteger.newInstance(1);
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance(" ");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("end");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("[0-9|a-f|A-F]");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("string");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("toupper");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("format");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("\\u%04s");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("^x[0-F]+$");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("end-1");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("[0-7]");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("\\%03s");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("^\n[ |\t]+$");
        const16.preserve(); const16.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "error";
                break;
            }
            case 2: {
                cmdName = "regexp";
                break;
            }
            case 3: {
                cmdName = "string";
                break;
            }
            case 4: {
                cmdName = "format";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "elem",
        "elen",
        "is_octal",
        "first",
        "rest",
        "p",
        "wp",
        "digits",
        "dlen"
    };
} // end class EmitterBackslashTclElemCmd

