// TJC implementation of procedure emitter_backslash_tcl_string
package tjc;
import tcl.lang.*;

public class EmitterBackslashTclStringCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 12, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "tstr");
        }
        setVarScalar(interp, "tstr", objv[1], compiledLocals, 0);
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const0, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: set tlen [...]
            TclObject tmp0;
            { // Invoke: string length $tstr
                TclObject tmp1 = getVarScalar(interp, "tstr", compiledLocals, 0);
                int tmp2 = tmp1.toString().length();
                interp.setResult(tmp2);
            } // End Invoke: string
            tmp0 = interp.getResult();
            setVarScalar(interp, "tlen", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: for {set i 0} {$i < $tlen} {incr i} ...
            { // Invoke: set i 0
                setVarScalar(interp, "i", const1, compiledLocals, 3);
            } // End Invoke: set
            for ( boolean skip8 = true ; true ; ) {
                if ( skip8 ) {
                    skip8 = false;
                } else {
                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: incr i
                        interp.resetResult();
                        incrVarScalar(interp, "i", 1, compiledLocals, 3);
                    } // End Invoke: incr
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else {
                            throw ex;
                        }
                    }
                }

                // Binary operator: $i < $tlen
                TclObject tmp3 = getVarScalar(interp, "i", compiledLocals, 3);
                ExprValue tmp4 = evs0;
                TJC.exprInitValue(interp, tmp4, tmp3);
                TclObject tmp5 = getVarScalar(interp, "tlen", compiledLocals, 2);
                ExprValue tmp6 = evs1;
                TJC.exprInitValue(interp, tmp6, tmp5);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp4, tmp6);
                // End Binary operator: <
                boolean tmp7 = ( tmp4.getIntValue() != 0 );
                if ( ! tmp7 ) { break; }

                try {
                if ( false ) { throw (TclException) null; }
                { // Invoke: set c [...]
                    TclObject tmp9;
                    { // Invoke: string index $tstr $i
                        TclObject tmp10 = getVarScalar(interp, "tstr", compiledLocals, 0);
                        String tmp11 = tmp10.toString();
                        TclObject tmp12 = getVarScalar(interp, "i", compiledLocals, 3);
                        TclObject tmp13 = TJC.stringIndex(interp, tmp11, tmp12);
                        interp.setResult(tmp13);
                    } // End Invoke: string
                    tmp9 = interp.getResult();
                    setVarScalar(interp, "c", tmp9, compiledLocals, 4);
                } // End Invoke: set
                { // Invoke: switch -exact -- $c ... ... ... ... ... ... ... ... ... ... ... ... ... ... ... ... ... ... default ...
                    TclObject tmp14 = getVarScalar(interp, "c", compiledLocals, 4);
                    String tmp15 = tmp14.toString();
                    int tmp15_length = tmp15.length();
                    char tmp15_first = '\n';
                    if ( tmp15_length > 0 ) {
                        tmp15_first = tmp15.charAt(0);
                    }
                    if ( tmp15_length == 1 && tmp15_first == '\u0007' ) {
                        // Pattern ...
                        { // Invoke: append buffer ...
                            TclObject[] objv16 = TJC.grabObjv(interp, 1);
                            TclObject tmp17;
                            try {
                                // Arg 2 constant: ...
                                objv16[0] = const2;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv16, compiledLocals, 1);
                            } finally {
                                TJC.releaseObjv(interp, objv16, 1);
                            }
                        } // End Invoke: append
                    } else if ( tmp15_length == 1 && tmp15_first == '\b' ) {
                        // Pattern ...
                        { // Invoke: append buffer ...
                            TclObject[] objv18 = TJC.grabObjv(interp, 1);
                            TclObject tmp19;
                            try {
                                // Arg 2 constant: ...
                                objv18[0] = const3;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv18, compiledLocals, 1);
                            } finally {
                                TJC.releaseObjv(interp, objv18, 1);
                            }
                        } // End Invoke: append
                    } else if ( tmp15_length == 1 && tmp15_first == '\f' ) {
                        // Pattern ...
                        { // Invoke: append buffer ...
                            TclObject[] objv20 = TJC.grabObjv(interp, 1);
                            TclObject tmp21;
                            try {
                                // Arg 2 constant: ...
                                objv20[0] = const4;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv20, compiledLocals, 1);
                            } finally {
                                TJC.releaseObjv(interp, objv20, 1);
                            }
                        } // End Invoke: append
                    } else if ( tmp15_length == 1 && tmp15_first == '\n' ) {
                        // Pattern ...
                        { // Invoke: append buffer ...
                            TclObject[] objv22 = TJC.grabObjv(interp, 1);
                            TclObject tmp23;
                            try {
                                // Arg 2 constant: ...
                                objv22[0] = const5;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv22, compiledLocals, 1);
                            } finally {
                                TJC.releaseObjv(interp, objv22, 1);
                            }
                        } // End Invoke: append
                    } else if ( tmp15_length == 1 && tmp15_first == '\r' ) {
                        // Pattern ...
                        { // Invoke: append buffer ...
                            TclObject[] objv24 = TJC.grabObjv(interp, 1);
                            TclObject tmp25;
                            try {
                                // Arg 2 constant: ...
                                objv24[0] = const6;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv24, compiledLocals, 1);
                            } finally {
                                TJC.releaseObjv(interp, objv24, 1);
                            }
                        } // End Invoke: append
                    } else if ( tmp15_length == 1 && tmp15_first == '\t' ) {
                        // Pattern ...
                        { // Invoke: append buffer ...
                            TclObject[] objv26 = TJC.grabObjv(interp, 1);
                            TclObject tmp27;
                            try {
                                // Arg 2 constant: ...
                                objv26[0] = const7;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv26, compiledLocals, 1);
                            } finally {
                                TJC.releaseObjv(interp, objv26, 1);
                            }
                        } // End Invoke: append
                    } else if ( tmp15_length == 1 && tmp15_first == '\u000B' ) {
                        // Pattern ...
                        { // Invoke: append buffer ...
                            TclObject[] objv28 = TJC.grabObjv(interp, 1);
                            TclObject tmp29;
                            try {
                                // Arg 2 constant: ...
                                objv28[0] = const8;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv28, compiledLocals, 1);
                            } finally {
                                TJC.releaseObjv(interp, objv28, 1);
                            }
                        } // End Invoke: append
                    } else if ( tmp15_length == 1 && tmp15_first == '\"' ) {
                        // Pattern ...
                        { // Invoke: append buffer ...
                            TclObject[] objv30 = TJC.grabObjv(interp, 1);
                            TclObject tmp31;
                            try {
                                // Arg 2 constant: ...
                                objv30[0] = const9;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv30, compiledLocals, 1);
                            } finally {
                                TJC.releaseObjv(interp, objv30, 1);
                            }
                        } // End Invoke: append
                    } else if ( tmp15_length == 1 && tmp15_first == '\\' ) {
                        // Pattern ...
                        { // Invoke: if ... ...
                            // Binary operator: [...] == "\\"
                            { // Invoke: string index $tstr [...]
                                TclObject tmp32 = getVarScalar(interp, "tstr", compiledLocals, 0);
                                String tmp33 = tmp32.toString();
                                { // Invoke: expr {$i + 1}
                                    // Binary operator: $i + 1
                                    TclObject tmp35 = getVarScalar(interp, "i", compiledLocals, 3);
                                    ExprValue tmp36 = evs0;
                                    TJC.exprInitValue(interp, tmp36, tmp35);
                                    ExprValue tmp37 = evs1;
                                    tmp37.setIntValue(1);
                                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_PLUS, tmp36, tmp37);
                                    // End Binary operator: +
                                    TJC.exprSetResult(interp, tmp36);
                                } // End Invoke: expr
                                TclObject tmp34 = interp.getResult();
                                TclObject tmp38 = TJC.stringIndex(interp, tmp33, tmp34);
                                interp.setResult(tmp38);
                            } // End Invoke: string
                            TclObject tmp39 = interp.getResult();
                            boolean tmp40 = tmp39.toString().equals("\\");
                            ExprValue tmp41 = evs0;
                            tmp41.setIntValue(tmp40);
                            // End Binary operator: ==
                            boolean tmp42 = ( tmp41.getIntValue() != 0 );
                            if ( tmp42 ) {
                                { // Invoke: append buffer ...
                                    TclObject[] objv43 = TJC.grabObjv(interp, 1);
                                    TclObject tmp44;
                                    try {
                                        // Arg 2 constant: ...
                                        objv43[0] = const10;
                                        interp.resetResult();
                                        appendVarScalar(interp, "buffer", objv43, compiledLocals, 1);
                                    } finally {
                                        TJC.releaseObjv(interp, objv43, 1);
                                    }
                                } // End Invoke: append
                                { // Invoke: incr i
                                    interp.resetResult();
                                    incrVarScalar(interp, "i", 1, compiledLocals, 3);
                                } // End Invoke: incr
                                { // Invoke: continue
                                    if ( true ) { continue; }
                                } // End Invoke: continue
                            }
                        } // End Invoke: if
                        { // Invoke: set rest [...]
                            TclObject tmp45;
                            { // Invoke: string range $tstr $i end
                                TclObject tmp46 = getVarScalar(interp, "tstr", compiledLocals, 0);
                                String tmp47 = tmp46.toString();
                                TclObject tmp48 = getVarScalar(interp, "i", compiledLocals, 3);
                                tmp48.preserve();
                                TclObject tmp49 = const11;
                                TclObject tmp50 = TJC.stringRange(interp, tmp47, tmp48, tmp49);
                                interp.setResult(tmp50);
                            } // End Invoke: string
                            tmp45 = interp.getResult();
                            setVarScalar(interp, "rest", tmp45, compiledLocals, 5);
                        } // End Invoke: set
                        { // Invoke: switch -regexp -- $rest ... ... ... - ... - ... - ... - ... ... ... ... ... ... ... ... ... ... default ...
                            TclObject tmp51 = getVarScalar(interp, "rest", compiledLocals, 5);
                            String tmp52 = tmp51.toString();
                            int tmp53;
                            TclObject[] objv54 = TJC.grabObjv(interp, 22);
                            try {
                                TclObject tmp55;
                                // Pattern ...
                                tmp55 = const12;
                                tmp55.preserve();
                                objv54[0] = tmp55;
                                // Pattern ...
                                tmp55 = const13;
                                tmp55.preserve();
                                objv54[2] = tmp55;
                                // - fallthrough
                                tmp55 = const14;
                                tmp55.preserve();
                                objv54[3] = tmp55;
                                // Pattern ...
                                tmp55 = const15;
                                tmp55.preserve();
                                objv54[4] = tmp55;
                                // - fallthrough
                                tmp55 = const14;
                                tmp55.preserve();
                                objv54[5] = tmp55;
                                // Pattern ...
                                tmp55 = const16;
                                tmp55.preserve();
                                objv54[6] = tmp55;
                                // - fallthrough
                                tmp55 = const14;
                                tmp55.preserve();
                                objv54[7] = tmp55;
                                // Pattern ...
                                tmp55 = const17;
                                tmp55.preserve();
                                objv54[8] = tmp55;
                                // - fallthrough
                                tmp55 = const14;
                                tmp55.preserve();
                                objv54[9] = tmp55;
                                // Pattern ...
                                tmp55 = const18;
                                tmp55.preserve();
                                objv54[10] = tmp55;
                                // Pattern ...
                                tmp55 = const19;
                                tmp55.preserve();
                                objv54[12] = tmp55;
                                // Pattern ...
                                tmp55 = const20;
                                tmp55.preserve();
                                objv54[14] = tmp55;
                                // Pattern ...
                                tmp55 = const21;
                                tmp55.preserve();
                                objv54[16] = tmp55;
                                // Pattern ...
                                tmp55 = const22;
                                tmp55.preserve();
                                objv54[18] = tmp55;
                                // Pattern default
                                tmp55 = const23;
                                tmp55.preserve();
                                objv54[20] = tmp55;
                                tmp53 = TJC.invokeSwitch(interp, objv54, 0,
                                    tmp52, TJC.SWITCH_MODE_REGEXP);
                            } finally {
                                TJC.releaseObjvElems(interp, objv54, 22);
                            }
                            interp.resetResult();
                            if ( tmp53 == -1 ) {
                                // No match
                            } else if ( tmp53 == 1 ) {
                                // Pattern ...
                                { // Invoke: set supported 0
                                    setVarScalar(interp, "supported", const1, compiledLocals, 6);
                                } // End Invoke: set
                                { // Invoke: set len 2
                                    setVarScalar(interp, "len", const24, compiledLocals, 7);
                                } // End Invoke: set
                                { // Invoke: set subst ...
                                    setVarScalar(interp, "subst", const2, compiledLocals, 8);
                                } // End Invoke: set
                            } else if ( tmp53 == 11 ) {
                                // Pattern ...
                                { // Invoke: set supported 1
                                    setVarScalar(interp, "supported", const25, compiledLocals, 6);
                                } // End Invoke: set
                                { // Invoke: set len 2
                                    setVarScalar(interp, "len", const24, compiledLocals, 7);
                                } // End Invoke: set
                            } else if ( tmp53 == 13 ) {
                                // Pattern ...
                                { // Invoke: set supported 0
                                    setVarScalar(interp, "supported", const1, compiledLocals, 6);
                                } // End Invoke: set
                                { // Invoke: set len 2
                                    setVarScalar(interp, "len", const24, compiledLocals, 7);
                                } // End Invoke: set
                                { // Invoke: set subst ...
                                    setVarScalar(interp, "subst", const8, compiledLocals, 8);
                                } // End Invoke: set
                            } else if ( tmp53 == 15 ) {
                                // Pattern ...
                                { // Invoke: set supported 0
                                    setVarScalar(interp, "supported", const1, compiledLocals, 6);
                                } // End Invoke: set
                                { // Invoke: set len 4
                                    setVarScalar(interp, "len", const26, compiledLocals, 7);
                                } // End Invoke: set
                                { // Invoke: set subst "..."
                                    TclObject tmp56;
                                    StringBuffer sbtmp57 = new StringBuffer(64);
                                    sbtmp57.append("\\");
                                    sbtmp57.append("u00");
                                    { // Invoke: string range $rest 2 3
                                        TclObject tmp58 = getVarScalar(interp, "rest", compiledLocals, 5);
                                        String tmp59 = tmp58.toString();
                                        TclObject tmp60 = const24;
                                        tmp60.preserve();
                                        TclObject tmp61 = const27;
                                        TclObject tmp62 = TJC.stringRange(interp, tmp59, tmp60, tmp61);
                                        interp.setResult(tmp62);
                                    } // End Invoke: string
                                    tmp56 = interp.getResult();
                                    sbtmp57.append(tmp56.toString());
                                    tmp56 = TclString.newInstance(sbtmp57);
                                    setVarScalar(interp, "subst", tmp56, compiledLocals, 8);
                                } // End Invoke: set
                            } else if ( tmp53 == 17 ) {
                                // Pattern ...
                                { // Invoke: set supported 0
                                    setVarScalar(interp, "supported", const1, compiledLocals, 6);
                                } // End Invoke: set
                                { // Invoke: set len 4
                                    setVarScalar(interp, "len", const26, compiledLocals, 7);
                                } // End Invoke: set
                                { // Invoke: set esc [...]
                                    TclObject tmp63;
                                    { // Invoke: string range $rest 0 3
                                        TclObject tmp64 = getVarScalar(interp, "rest", compiledLocals, 5);
                                        String tmp65 = tmp64.toString();
                                        TclObject tmp66 = const1;
                                        tmp66.preserve();
                                        TclObject tmp67 = const27;
                                        TclObject tmp68 = TJC.stringRange(interp, tmp65, tmp66, tmp67);
                                        interp.setResult(tmp68);
                                    } // End Invoke: string
                                    tmp63 = interp.getResult();
                                    setVarScalar(interp, "esc", tmp63, compiledLocals, 9);
                                } // End Invoke: set
                                { // Invoke: set esc [...]
                                    TclObject tmp69;
                                    { // Invoke: subst -nocommands -novariables $esc
                                        TclObject[] objv70 = TJC.grabObjv(interp, 4);
                                        TclObject tmp71;
                                        try {
                                            // Arg 0 constant: subst
                                            objv70[0] = const28;
                                            // Arg 1 constant: -nocommands
                                            objv70[1] = const29;
                                            // Arg 2 constant: -novariables
                                            objv70[2] = const30;
                                            // Arg 3 variable: $esc
                                            tmp71 = getVarScalar(interp, "esc", compiledLocals, 9);
                                            tmp71.preserve();
                                            objv70[3] = tmp71;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                                ? cmdcache1.cmd : null), objv70, 0);
                                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                                updateCmdCache(interp, 1);
                                            }
                                        } finally {
                                            tmp71 = objv70[3];
                                            if ( tmp71 != null ) {
                                                tmp71.release();
                                            }
                                            TJC.releaseObjv(interp, objv70, 4);
                                        }
                                    } // End Invoke: subst
                                    tmp69 = interp.getResult();
                                    setVarScalar(interp, "esc", tmp69, compiledLocals, 9);
                                } // End Invoke: set
                                { // Invoke: if ... ...
                                    // Binary operator: [...] == 0
                                    { // Invoke: scan $esc %c decimal
                                        TclObject[] objv72 = TJC.grabObjv(interp, 4);
                                        TclObject tmp73;
                                        try {
                                            // Arg 0 constant: scan
                                            objv72[0] = const31;
                                            // Arg 1 variable: $esc
                                            tmp73 = getVarScalar(interp, "esc", compiledLocals, 9);
                                            tmp73.preserve();
                                            objv72[1] = tmp73;
                                            // Arg 2 constant: %c
                                            objv72[2] = const32;
                                            // Arg 3 constant: decimal
                                            objv72[3] = const33;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                                ? cmdcache2.cmd : null), objv72, 0);
                                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                                updateCmdCache(interp, 2);
                                            }
                                        } finally {
                                            tmp73 = objv72[1];
                                            if ( tmp73 != null ) {
                                                tmp73.release();
                                            }
                                            TJC.releaseObjv(interp, objv72, 4);
                                        }
                                    } // End Invoke: scan
                                    TclObject tmp74 = interp.getResult();
                                    ExprValue tmp75 = evs0;
                                    TJC.exprInitValue(interp, tmp75, tmp74);
                                    ExprValue tmp76 = evs1;
                                    tmp76.setIntValue(0);
                                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp75, tmp76);
                                    // End Binary operator: ==
                                    boolean tmp77 = ( tmp75.getIntValue() != 0 );
                                    if ( tmp77 ) {
                                        { // Invoke: error "..."
                                            TclObject[] objv78 = TJC.grabObjv(interp, 2);
                                            TclObject tmp79;
                                            try {
                                                // Arg 0 constant: error
                                                objv78[0] = const34;
                                                // Arg 1 word: "..."
                                                StringBuffer sbtmp80 = new StringBuffer(64);
                                                sbtmp80.append("scan for escape character failed, esc was ");
                                                sbtmp80.append("\"");
                                                tmp79 = getVarScalar(interp, "esc", compiledLocals, 9);
                                                sbtmp80.append(tmp79.toString());
                                                sbtmp80.append("\"");
                                                tmp79 = TclString.newInstance(sbtmp80);
                                                tmp79.preserve();
                                                objv78[1] = tmp79;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                                    ? cmdcache3.cmd : null), objv78, 0);
                                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                                    updateCmdCache(interp, 3);
                                                }
                                            } finally {
                                                tmp79 = objv78[1];
                                                if ( tmp79 != null ) {
                                                    tmp79.release();
                                                }
                                                TJC.releaseObjv(interp, objv78, 2);
                                            }
                                        } // End Invoke: error
                                    }
                                } // End Invoke: if
                                { // Invoke: set subst [...]
                                    TclObject tmp81;
                                    { // Invoke: format ... $decimal
                                        TclObject[] objv82 = TJC.grabObjv(interp, 3);
                                        TclObject tmp83;
                                        try {
                                            // Arg 0 constant: format
                                            objv82[0] = const35;
                                            // Arg 1 constant: ...
                                            objv82[1] = const36;
                                            // Arg 2 variable: $decimal
                                            tmp83 = getVarScalar(interp, "decimal", compiledLocals, 10);
                                            tmp83.preserve();
                                            objv82[2] = tmp83;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                ? cmdcache4.cmd : null), objv82, 0);
                                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                updateCmdCache(interp, 4);
                                            }
                                        } finally {
                                            tmp83 = objv82[2];
                                            if ( tmp83 != null ) {
                                                tmp83.release();
                                            }
                                            TJC.releaseObjv(interp, objv82, 3);
                                        }
                                    } // End Invoke: format
                                    tmp81 = interp.getResult();
                                    setVarScalar(interp, "subst", tmp81, compiledLocals, 8);
                                } // End Invoke: set
                            } else if ( tmp53 == 19 ) {
                                // Pattern ...
                                { // Invoke: set supported 1
                                    setVarScalar(interp, "supported", const25, compiledLocals, 6);
                                } // End Invoke: set
                                { // Invoke: set len 6
                                    setVarScalar(interp, "len", const37, compiledLocals, 7);
                                } // End Invoke: set
                            } else if ( tmp53 == 21 ) {
                                // Pattern default
                                { // Invoke: append buffer $c
                                    TclObject[] objv84 = TJC.grabObjv(interp, 1);
                                    TclObject tmp85;
                                    try {
                                        // Arg 2 variable: $c
                                        tmp85 = getVarScalar(interp, "c", compiledLocals, 4);
                                        tmp85.preserve();
                                        objv84[0] = tmp85;
                                        interp.resetResult();
                                        appendVarScalar(interp, "buffer", objv84, compiledLocals, 1);
                                    } finally {
                                        TJC.releaseObjvElems(interp, objv84, 1);
                                    }
                                } // End Invoke: append
                                { // Invoke: continue
                                    if ( true ) { continue; }
                                } // End Invoke: continue
                            } else {
                                throw new TclRuntimeError("bad switch body offset " +
                                    String.valueOf(tmp53));
                            }
                        } // End Invoke: switch
                        { // Invoke: if {$supported} ... else ...
                            TclObject tmp86 = getVarScalar(interp, "supported", compiledLocals, 6);
                            boolean tmp87 = TJC.getBoolean(interp, tmp86);
                            if ( tmp87 ) {
                                { // Invoke: set bs [...]
                                    TclObject tmp88;
                                    { // Invoke: string range $tstr $i [...]
                                        TclObject tmp89 = getVarScalar(interp, "tstr", compiledLocals, 0);
                                        String tmp90 = tmp89.toString();
                                        TclObject tmp91 = getVarScalar(interp, "i", compiledLocals, 3);
                                        tmp91.preserve();
                                        { // Invoke: expr {$i + $len - 1}
                                            // Binary operator: () - 1
                                            // Binary operator: $i + $len
                                            TclObject tmp93 = getVarScalar(interp, "i", compiledLocals, 3);
                                            ExprValue tmp94 = evs0;
                                            TJC.exprInitValue(interp, tmp94, tmp93);
                                            TclObject tmp95 = getVarScalar(interp, "len", compiledLocals, 7);
                                            ExprValue tmp96 = evs1;
                                            TJC.exprInitValue(interp, tmp96, tmp95);
                                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_PLUS, tmp94, tmp96);
                                            // End Binary operator: +
                                            ExprValue tmp97 = evs1;
                                            tmp97.setIntValue(1);
                                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MINUS, tmp94, tmp97);
                                            // End Binary operator: -
                                            TJC.exprSetResult(interp, tmp94);
                                        } // End Invoke: expr
                                        TclObject tmp92 = interp.getResult();
                                        TclObject tmp98 = TJC.stringRange(interp, tmp90, tmp91, tmp92);
                                        interp.setResult(tmp98);
                                    } // End Invoke: string
                                    tmp88 = interp.getResult();
                                    setVarScalar(interp, "bs", tmp88, compiledLocals, 11);
                                } // End Invoke: set
                                { // Invoke: append buffer $bs
                                    TclObject[] objv99 = TJC.grabObjv(interp, 1);
                                    TclObject tmp100;
                                    try {
                                        // Arg 2 variable: $bs
                                        tmp100 = getVarScalar(interp, "bs", compiledLocals, 11);
                                        tmp100.preserve();
                                        objv99[0] = tmp100;
                                        interp.resetResult();
                                        appendVarScalar(interp, "buffer", objv99, compiledLocals, 1);
                                    } finally {
                                        TJC.releaseObjvElems(interp, objv99, 1);
                                    }
                                } // End Invoke: append
                                { // Invoke: incr i [...]
                                    { // Invoke: expr ...
                                        // Binary operator: [...] - 1
                                        { // Invoke: string length $bs
                                            TclObject tmp102 = getVarScalar(interp, "bs", compiledLocals, 11);
                                            int tmp103 = tmp102.toString().length();
                                            interp.setResult(tmp103);
                                        } // End Invoke: string
                                        TclObject tmp104 = interp.getResult();
                                        ExprValue tmp105 = evs0;
                                        TJC.exprInitValue(interp, tmp105, tmp104);
                                        ExprValue tmp106 = evs1;
                                        tmp106.setIntValue(1);
                                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MINUS, tmp105, tmp106);
                                        // End Binary operator: -
                                        TJC.exprSetResult(interp, tmp105);
                                    } // End Invoke: expr
                                    TclObject tmp101 = interp.getResult();
                                    int tmp107 = TclInteger.get(interp, tmp101);
                                    interp.resetResult();
                                    incrVarScalar(interp, "i", tmp107, compiledLocals, 3);
                                } // End Invoke: incr
                            } else {
                                { // Invoke: append buffer $subst
                                    TclObject[] objv108 = TJC.grabObjv(interp, 1);
                                    TclObject tmp109;
                                    try {
                                        // Arg 2 variable: $subst
                                        tmp109 = getVarScalar(interp, "subst", compiledLocals, 8);
                                        tmp109.preserve();
                                        objv108[0] = tmp109;
                                        interp.resetResult();
                                        appendVarScalar(interp, "buffer", objv108, compiledLocals, 1);
                                    } finally {
                                        TJC.releaseObjvElems(interp, objv108, 1);
                                    }
                                } // End Invoke: append
                                { // Invoke: incr i [...]
                                    { // Invoke: expr {$len - 1}
                                        // Binary operator: $len - 1
                                        TclObject tmp111 = getVarScalar(interp, "len", compiledLocals, 7);
                                        ExprValue tmp112 = evs0;
                                        TJC.exprInitValue(interp, tmp112, tmp111);
                                        ExprValue tmp113 = evs1;
                                        tmp113.setIntValue(1);
                                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MINUS, tmp112, tmp113);
                                        // End Binary operator: -
                                        TJC.exprSetResult(interp, tmp112);
                                    } // End Invoke: expr
                                    TclObject tmp110 = interp.getResult();
                                    int tmp114 = TclInteger.get(interp, tmp110);
                                    interp.resetResult();
                                    incrVarScalar(interp, "i", tmp114, compiledLocals, 3);
                                } // End Invoke: incr
                            }
                        } // End Invoke: if
                    } else {
                        // Pattern default
                        { // Invoke: append buffer $c
                            TclObject[] objv115 = TJC.grabObjv(interp, 1);
                            TclObject tmp116;
                            try {
                                // Arg 2 variable: $c
                                tmp116 = getVarScalar(interp, "c", compiledLocals, 4);
                                tmp116.preserve();
                                objv115[0] = tmp116;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv115, compiledLocals, 1);
                            } finally {
                                TJC.releaseObjvElems(interp, objv115, 1);
                            }
                        } // End Invoke: append
                    }
                } // End Invoke: switch
                } catch (TclException ex) {
                    int type = ex.getCompletionCode();
                    if (type == TCL.BREAK) {
                        break;
                    } else if (type == TCL.CONTINUE) {
                        continue;
                    } else {
                        throw ex;
                    }
                }
            }
        } // End Invoke: for
        { // Invoke: return $buffer
            TclObject tmp117 = getVarScalar(interp, "buffer", compiledLocals, 1);
            interp.resetResult();
            interp.setResult(tmp117);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "emitter_backslash_tcl_string");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;
    TclObject const19;
    TclObject const20;
    TclObject const21;
    TclObject const22;
    TclObject const23;
    TclObject const24;
    TclObject const25;
    TclObject const26;
    TclObject const27;
    TclObject const28;
    TclObject const29;
    TclObject const30;
    TclObject const31;
    TclObject const32;
    TclObject const33;
    TclObject const34;
    TclObject const35;
    TclObject const36;
    TclObject const37;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclInteger.newInstance(0);
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("\\u0007");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("\\b");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("\\f");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("\\n");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("\\r");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("\\t");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("\\u000B");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("\\\"");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("\\\\");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("end");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("^\\\\a");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("^\\\\b");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("-");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("^\\\\f");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("^\\\\n");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("^\\\\r");
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance("^\\\\t");
        const18.preserve(); const18.preserve();
        const19 = TclString.newInstance("^\\\\v");
        const19.preserve(); const19.preserve();
        const20 = TclString.newInstance("^\\\\x[0-9|A-F][0-9|A-F]");
        const20.preserve(); const20.preserve();
        const21 = TclString.newInstance("^\\\\[0-7][0-7][0-7]");
        const21.preserve(); const21.preserve();
        const22 = TclString.newInstance("^\\\\u[0-9|A-F][0-9|A-F][0-9|A-F][0-9|A-F]");
        const22.preserve(); const22.preserve();
        const23 = TclString.newInstance("default");
        const23.preserve(); const23.preserve();
        const24 = TclInteger.newInstance(2);
        const24.preserve(); const24.preserve();
        const25 = TclInteger.newInstance(1);
        const25.preserve(); const25.preserve();
        const26 = TclInteger.newInstance(4);
        const26.preserve(); const26.preserve();
        const27 = TclInteger.newInstance(3);
        const27.preserve(); const27.preserve();
        const28 = TclString.newInstance("subst");
        const28.preserve(); const28.preserve();
        const29 = TclString.newInstance("-nocommands");
        const29.preserve(); const29.preserve();
        const30 = TclString.newInstance("-novariables");
        const30.preserve(); const30.preserve();
        const31 = TclString.newInstance("scan");
        const31.preserve(); const31.preserve();
        const32 = TclString.newInstance("%c");
        const32.preserve(); const32.preserve();
        const33 = TclString.newInstance("decimal");
        const33.preserve(); const33.preserve();
        const34 = TclString.newInstance("error");
        const34.preserve(); const34.preserve();
        const35 = TclString.newInstance("format");
        const35.preserve(); const35.preserve();
        const36 = TclString.newInstance("\\u%04X");
        const36.preserve(); const36.preserve();
        const37 = TclInteger.newInstance(6);
        const37.preserve(); const37.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "subst";
                break;
            }
            case 2: {
                cmdName = "scan";
                break;
            }
            case 3: {
                cmdName = "error";
                break;
            }
            case 4: {
                cmdName = "format";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "tstr",
        "buffer",
        "tlen",
        "i",
        "c",
        "rest",
        "supported",
        "len",
        "subst",
        "esc",
        "decimal",
        "bs"
    };
} // end class EmitterBackslashTclStringCmd

