// TJC implementation of procedure emitter_cmd_proc_end
package tjc;
import tcl.lang.*;

public class EmitterCmdProcEndCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 1, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 1) {
            throw new TclNumArgsException(interp, 1, objv, "");
        }
        { // Invoke: if ... ...
            // Binary operator: [...] != 2
            { // Invoke: emitter_indent_level
                TclObject[] objv0 = TJC.grabObjv(interp, 1);
                try {
                    // Arg 0 constant: emitter_indent_level
                    objv0[0] = const0;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv0, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv0, 1);
                }
            } // End Invoke: emitter_indent_level
            TclObject tmp1 = interp.getResult();
            ExprValue tmp2 = evs0;
            TJC.exprInitValue(interp, tmp2, tmp1);
            ExprValue tmp3 = evs1;
            tmp3.setIntValue(2);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp2, tmp3);
            // End Binary operator: !=
            boolean tmp4 = ( tmp2.getIntValue() != 0 );
            if ( tmp4 ) {
                { // Invoke: error "..."
                    TclObject[] objv5 = TJC.grabObjv(interp, 2);
                    TclObject tmp6;
                    try {
                        // Arg 0 constant: error
                        objv5[0] = const1;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp7 = new StringBuffer(64);
                        sbtmp7.append("expected indent level of 2, got ");
                        { // Invoke: emitter_indent_level
                            TclObject[] objv8 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: emitter_indent_level
                                objv8[0] = const0;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv8, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv8, 1);
                            }
                        } // End Invoke: emitter_indent_level
                        tmp6 = interp.getResult();
                        sbtmp7.append(tmp6.toString());
                        tmp6 = TclString.newInstance(sbtmp7);
                        tmp6.preserve();
                        objv5[1] = tmp6;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv5, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp6 = objv5[1];
                        if ( tmp6 != null ) {
                            tmp6.release();
                        }
                        TJC.releaseObjv(interp, objv5, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: emitter_indent_level -1
            TclObject[] objv9 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv9[0] = const0;
                // Arg 1 constant: -1
                objv9[1] = const2;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                    ? cmdcache1.cmd : null), objv9, 0);
                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                    updateCmdCache(interp, 1);
                }
            } finally {
                TJC.releaseObjv(interp, objv9, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const3, compiledLocals, 0);
        } // End Invoke: set
        { // Invoke: append buffer [...] ...
            TclObject[] objv10 = TJC.grabObjv(interp, 2);
            TclObject tmp11;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv12 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv12[0] = const4;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv12, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv12, 1);
                    }
                } // End Invoke: emitter_indent
                tmp11 = interp.getResult();
                tmp11.preserve();
                objv10[0] = tmp11;
                // Arg 3 constant: ...
                objv10[1] = const5;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv10, compiledLocals, 0);
            } finally {
                tmp11 = objv10[0];
                if ( tmp11 != null ) {
                    tmp11.release();
                }
                TJC.releaseObjv(interp, objv10, 2);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level -1
            TclObject[] objv13 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv13[0] = const0;
                // Arg 1 constant: -1
                objv13[1] = const2;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                    ? cmdcache1.cmd : null), objv13, 0);
                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                    updateCmdCache(interp, 1);
                }
            } finally {
                TJC.releaseObjv(interp, objv13, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: return $buffer
            TclObject tmp14 = getVarScalar(interp, "buffer", compiledLocals, 0);
            interp.resetResult();
            interp.setResult(tmp14);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "emitter_cmd_proc_end");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("emitter_indent_level");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("error");
        const1.preserve(); const1.preserve();
        const2 = TclInteger.newInstance(-1);
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("emitter_indent");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("}\n");
        const5.preserve(); const5.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "emitter_indent_level";
                break;
            }
            case 2: {
                cmdName = "error";
                break;
            }
            case 3: {
                cmdName = "emitter_indent";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "buffer"
    };
} // end class EmitterCmdProcEndCmd

