// TJC implementation of procedure emitter_get_var
package tjc;
import tcl.lang.*;

public class EmitterGetVarCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 9, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 7) {
            throw new TclNumArgsException(interp, 1, objv, "tmpsymbol p1 is_p1_string p2 is_p2_string iflags");
        }
        setVarScalar(interp, "tmpsymbol", objv[1], compiledLocals, 0);
        setVarScalar(interp, "p1", objv[2], compiledLocals, 1);
        setVarScalar(interp, "is_p1_string", objv[3], compiledLocals, 2);
        setVarScalar(interp, "p2", objv[4], compiledLocals, 3);
        setVarScalar(interp, "is_p2_string", objv[5], compiledLocals, 4);
        setVarScalar(interp, "iflags", objv[6], compiledLocals, 5);
        { // Invoke: if ... ...
            // Binary operator: () && ()
            // Binary operator: $p1 == ""
            TclObject tmp0 = getVarScalar(interp, "p1", compiledLocals, 1);
            ExprValue tmp1 = evs0;
            TJC.exprEqualsEmptyString(tmp1, tmp0, false);
            // End Binary operator: ==
            if (tmp1.getBooleanValue(interp)) {
            // Unary operator: ! $is_p1_string
            TclObject tmp2 = getVarScalar(interp, "is_p1_string", compiledLocals, 2);
            ExprValue tmp3 = evs1;
            if ( tmp2.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp3, tmp2);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp3, tmp2);
            }
            // End Unary operator: !
            tmp1.setIntValue(tmp3.getBooleanValue(interp));
            } else {
            tmp1.setIntValue(0);
            } // End if: ()
            // End Binary operator: &&
            boolean tmp4 = ( tmp1.getIntValue() != 0 );
            if ( tmp4 ) {
                { // Invoke: error ...
                    TclObject[] objv5 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: error
                        objv5[0] = const0;
                        // Arg 1 constant: ...
                        objv5[1] = const1;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv5, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv5, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            // Binary operator: () && ()
            // Binary operator: $p2 == ""
            TclObject tmp6 = getVarScalar(interp, "p2", compiledLocals, 3);
            ExprValue tmp7 = evs0;
            TJC.exprEqualsEmptyString(tmp7, tmp6, false);
            // End Binary operator: ==
            if (tmp7.getBooleanValue(interp)) {
            // Unary operator: ! $is_p2_string
            TclObject tmp8 = getVarScalar(interp, "is_p2_string", compiledLocals, 4);
            ExprValue tmp9 = evs1;
            if ( tmp8.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp9, tmp8);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp9, tmp8);
            }
            // End Unary operator: !
            tmp7.setIntValue(tmp9.getBooleanValue(interp));
            } else {
            tmp7.setIntValue(0);
            } // End if: ()
            // End Binary operator: &&
            boolean tmp10 = ( tmp7.getIntValue() != 0 );
            if ( tmp10 ) {
                { // Invoke: error ...
                    TclObject[] objv11 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: error
                        objv11[0] = const0;
                        // Arg 1 constant: ...
                        objv11[1] = const1;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv11, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv11, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: if {$is_p1_string} ... else ...
            TclObject tmp12 = getVarScalar(interp, "is_p1_string", compiledLocals, 2);
            boolean tmp13 = TJC.getBoolean(interp, tmp12);
            if ( tmp13 ) {
                { // Invoke: set p1sym "..."
                    TclObject tmp14;
                    StringBuffer sbtmp15 = new StringBuffer(64);
                    sbtmp15.append("\"");
                    { // Invoke: ... $p1
                        TclObject[] objv16 = TJC.grabObjv(interp, 2);
                        TclObject tmp17;
                        try {
                            // Arg 0 constant: ...
                            objv16[0] = const2;
                            // Arg 1 variable: $p1
                            tmp17 = getVarScalar(interp, "p1", compiledLocals, 1);
                            tmp17.preserve();
                            objv16[1] = tmp17;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv16, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp17 = objv16[1];
                            if ( tmp17 != null ) {
                                tmp17.release();
                            }
                            TJC.releaseObjv(interp, objv16, 2);
                        }
                    } // End Invoke: ...
                    tmp14 = interp.getResult();
                    sbtmp15.append(tmp14.toString());
                    sbtmp15.append("\"");
                    tmp14 = TclString.newInstance(sbtmp15);
                    setVarScalar(interp, "p1sym", tmp14, compiledLocals, 6);
                } // End Invoke: set
            } else {
                { // Invoke: set p1sym $p1
                    TclObject tmp18;
                    tmp18 = getVarScalar(interp, "p1", compiledLocals, 1);
                    setVarScalar(interp, "p1sym", tmp18, compiledLocals, 6);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: if {$is_p2_string} ... else ...
            TclObject tmp19 = getVarScalar(interp, "is_p2_string", compiledLocals, 4);
            boolean tmp20 = TJC.getBoolean(interp, tmp19);
            if ( tmp20 ) {
                { // Invoke: set p2sym "..."
                    TclObject tmp21;
                    StringBuffer sbtmp22 = new StringBuffer(64);
                    sbtmp22.append("\"");
                    { // Invoke: ... $p2
                        TclObject[] objv23 = TJC.grabObjv(interp, 2);
                        TclObject tmp24;
                        try {
                            // Arg 0 constant: ...
                            objv23[0] = const2;
                            // Arg 1 variable: $p2
                            tmp24 = getVarScalar(interp, "p2", compiledLocals, 3);
                            tmp24.preserve();
                            objv23[1] = tmp24;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv23, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp24 = objv23[1];
                            if ( tmp24 != null ) {
                                tmp24.release();
                            }
                            TJC.releaseObjv(interp, objv23, 2);
                        }
                    } // End Invoke: ...
                    tmp21 = interp.getResult();
                    sbtmp22.append(tmp21.toString());
                    sbtmp22.append("\"");
                    tmp21 = TclString.newInstance(sbtmp22);
                    setVarScalar(interp, "p2sym", tmp21, compiledLocals, 7);
                } // End Invoke: set
            } else {
                { // Invoke: set p2sym $p2
                    TclObject tmp25;
                    tmp25 = getVarScalar(interp, "p2", compiledLocals, 3);
                    setVarScalar(interp, "p2sym", tmp25, compiledLocals, 7);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: if {$tmpsymbol == {}} ... else ...
            // Binary operator: $tmpsymbol == ""
            TclObject tmp26 = getVarScalar(interp, "tmpsymbol", compiledLocals, 0);
            ExprValue tmp27 = evs0;
            TJC.exprEqualsEmptyString(tmp27, tmp26, false);
            // End Binary operator: ==
            boolean tmp28 = ( tmp27.getIntValue() != 0 );
            if ( tmp28 ) {
                { // Invoke: set assign ""
                    setVarScalar(interp, "assign", const3, compiledLocals, 8);
                } // End Invoke: set
            } else {
                { // Invoke: set assign "$tmpsymbol = "
                    TclObject tmp29;
                    StringBuffer sbtmp30 = new StringBuffer(64);
                    tmp29 = getVarScalar(interp, "tmpsymbol", compiledLocals, 0);
                    sbtmp30.append(tmp29.toString());
                    sbtmp30.append(" = ");
                    tmp29 = TclString.newInstance(sbtmp30);
                    setVarScalar(interp, "assign", tmp29, compiledLocals, 8);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: return "..."
            TclObject tmp31;
            StringBuffer sbtmp32 = new StringBuffer(64);
            { // Invoke: emitter_indent
                TclObject[] objv33 = TJC.grabObjv(interp, 1);
                try {
                    // Arg 0 constant: emitter_indent
                    objv33[0] = const4;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv33, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv33, 1);
                }
            } // End Invoke: emitter_indent
            tmp31 = interp.getResult();
            sbtmp32.append(tmp31.toString());
            tmp31 = getVarScalar(interp, "assign", compiledLocals, 8);
            sbtmp32.append(tmp31.toString());
            sbtmp32.append("interp.getVar(");
            tmp31 = getVarScalar(interp, "p1sym", compiledLocals, 6);
            sbtmp32.append(tmp31.toString());
            sbtmp32.append(", ");
            tmp31 = getVarScalar(interp, "p2sym", compiledLocals, 7);
            sbtmp32.append(tmp31.toString());
            sbtmp32.append(", ");
            tmp31 = getVarScalar(interp, "iflags", compiledLocals, 5);
            sbtmp32.append(tmp31.toString());
            sbtmp32.append(")");
            sbtmp32.append(";");
            sbtmp32.append("\n");
            tmp31 = TclString.newInstance(sbtmp32);
            interp.resetResult();
            interp.setResult(tmp31);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "emitter_get_var");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("error");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("empty string can't be a symbol");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("emitter_backslash_tcl_string");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("emitter_indent");
        const4.preserve(); const4.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "error";
                break;
            }
            case 2: {
                cmdName = "emitter_backslash_tcl_string";
                break;
            }
            case 3: {
                cmdName = "emitter_indent";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "tmpsymbol",
        "p1",
        "is_p1_string",
        "p2",
        "is_p2_string",
        "iflags",
        "p1sym",
        "p2sym",
        "assign"
    };
} // end class EmitterGetVarCmd

