// TJC implementation of procedure emitter_invoke_command_call
package tjc;
import tcl.lang.*;

public class EmitterInvokeCommandCallCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 4, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 4) {
            throw new TclNumArgsException(interp, 1, objv, "arraysym cmdref isglobal");
        }
        setVarScalar(interp, "arraysym", objv[1], compiledLocals, 0);
        setVarScalar(interp, "cmdref", objv[2], compiledLocals, 1);
        setVarScalar(interp, "isglobal", objv[3], compiledLocals, 2);
        { // Invoke: if {$cmdref == {}} ...
            // Binary operator: $cmdref == ""
            TclObject tmp0 = getVarScalar(interp, "cmdref", compiledLocals, 1);
            ExprValue tmp1 = evs0;
            TJC.exprEqualsEmptyString(tmp1, tmp0, false);
            // End Binary operator: ==
            boolean tmp2 = ( tmp1.getIntValue() != 0 );
            if ( tmp2 ) {
                { // Invoke: set cmdref null
                    setVarScalar(interp, "cmdref", const0, compiledLocals, 1);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: if {$isglobal} ... else ...
            TclObject tmp3 = getVarScalar(interp, "isglobal", compiledLocals, 2);
            boolean tmp4 = TJC.getBoolean(interp, tmp3);
            if ( tmp4 ) {
                { // Invoke: set gflag TCL.EVAL_GLOBAL
                    setVarScalar(interp, "gflag", const1, compiledLocals, 3);
                } // End Invoke: set
            } else {
                { // Invoke: set gflag 0
                    setVarScalar(interp, "gflag", const2, compiledLocals, 3);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: return "..."
            TclObject tmp5;
            StringBuffer sbtmp6 = new StringBuffer(64);
            { // Invoke: emitter_indent
                TclObject[] objv7 = TJC.grabObjv(interp, 1);
                try {
                    // Arg 0 constant: emitter_indent
                    objv7[0] = const3;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv7, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv7, 1);
                }
            } // End Invoke: emitter_indent
            tmp5 = interp.getResult();
            sbtmp6.append(tmp5.toString());
            sbtmp6.append("TJC.invoke(interp, ");
            tmp5 = getVarScalar(interp, "cmdref", compiledLocals, 1);
            sbtmp6.append(tmp5.toString());
            sbtmp6.append(", ");
            tmp5 = getVarScalar(interp, "arraysym", compiledLocals, 0);
            sbtmp6.append(tmp5.toString());
            sbtmp6.append(", ");
            tmp5 = getVarScalar(interp, "gflag", compiledLocals, 3);
            sbtmp6.append(tmp5.toString());
            sbtmp6.append(")");
            sbtmp6.append(";");
            sbtmp6.append("\n");
            tmp5 = TclString.newInstance(sbtmp6);
            interp.resetResult();
            interp.setResult(tmp5);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "emitter_invoke_command_call");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("null");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("TCL.EVAL_GLOBAL");
        const1.preserve(); const1.preserve();
        const2 = TclInteger.newInstance(0);
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("emitter_indent");
        const3.preserve(); const3.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "emitter_indent";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "arraysym",
        "cmdref",
        "isglobal",
        "gflag"
    };
} // end class EmitterInvokeCommandCallCmd

