// TJC implementation of procedure emitter_invoke_command_end
package tjc;
import tcl.lang.*;

public class EmitterInvokeCommandEndCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 4, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 4) {
            throw new TclNumArgsException(interp, 1, objv, "arraysym size none");
        }
        setVarScalar(interp, "arraysym", objv[1], compiledLocals, 0);
        setVarScalar(interp, "size", objv[2], compiledLocals, 1);
        setVarScalar(interp, "none", objv[3], compiledLocals, 2);
        { // Invoke: set buffer [...]
            TclObject tmp0;
            { // Invoke: emitter_indent
                TclObject[] objv1 = TJC.grabObjv(interp, 1);
                try {
                    // Arg 0 constant: emitter_indent
                    objv1[0] = const0;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv1, 1);
                }
            } // End Invoke: emitter_indent
            tmp0 = interp.getResult();
            setVarScalar(interp, "buffer", tmp0, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: if {$size <= 0} ...
            // Binary operator: $size <= 0
            TclObject tmp2 = getVarScalar(interp, "size", compiledLocals, 1);
            ExprValue tmp3 = evs0;
            TJC.exprInitValue(interp, tmp3, tmp2);
            ExprValue tmp4 = evs1;
            tmp4.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LEQ, tmp3, tmp4);
            // End Binary operator: <=
            boolean tmp5 = ( tmp3.getIntValue() != 0 );
            if ( tmp5 ) {
                { // Invoke: error ...
                    TclObject[] objv6 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: error
                        objv6[0] = const1;
                        // Arg 1 constant: ...
                        objv6[1] = const2;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv6, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv6, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: if {$none} ... else ...
            TclObject tmp7 = getVarScalar(interp, "none", compiledLocals, 2);
            boolean tmp8 = TJC.getBoolean(interp, tmp7);
            if ( tmp8 ) {
                { // Invoke: append buffer ... $arraysym ", " $size ")" ...
                    TclObject[] objv9 = TJC.grabObjv(interp, 6);
                    TclObject tmp10;
                    try {
                        // Arg 2 constant: ...
                        objv9[0] = const3;
                        // Arg 3 variable: $arraysym
                        tmp10 = getVarScalar(interp, "arraysym", compiledLocals, 0);
                        tmp10.preserve();
                        objv9[1] = tmp10;
                        // Arg 4 constant: ", "
                        objv9[2] = const4;
                        // Arg 5 variable: $size
                        tmp10 = getVarScalar(interp, "size", compiledLocals, 1);
                        tmp10.preserve();
                        objv9[3] = tmp10;
                        // Arg 6 constant: ")"
                        objv9[4] = const5;
                        // Arg 7 constant: ...
                        objv9[5] = const6;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv9, compiledLocals, 3);
                    } finally {
                        tmp10 = objv9[1];
                        if ( tmp10 != null ) {
                            tmp10.release();
                        }
                        tmp10 = objv9[3];
                        if ( tmp10 != null ) {
                            tmp10.release();
                        }
                        TJC.releaseObjv(interp, objv9, 6);
                    }
                } // End Invoke: append
            } else {
                { // Invoke: append buffer ... $arraysym ", " $size ")" ...
                    TclObject[] objv11 = TJC.grabObjv(interp, 6);
                    TclObject tmp12;
                    try {
                        // Arg 2 constant: ...
                        objv11[0] = const7;
                        // Arg 3 variable: $arraysym
                        tmp12 = getVarScalar(interp, "arraysym", compiledLocals, 0);
                        tmp12.preserve();
                        objv11[1] = tmp12;
                        // Arg 4 constant: ", "
                        objv11[2] = const4;
                        // Arg 5 variable: $size
                        tmp12 = getVarScalar(interp, "size", compiledLocals, 1);
                        tmp12.preserve();
                        objv11[3] = tmp12;
                        // Arg 6 constant: ")"
                        objv11[4] = const5;
                        // Arg 7 constant: ...
                        objv11[5] = const6;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv11, compiledLocals, 3);
                    } finally {
                        tmp12 = objv11[1];
                        if ( tmp12 != null ) {
                            tmp12.release();
                        }
                        tmp12 = objv11[3];
                        if ( tmp12 != null ) {
                            tmp12.release();
                        }
                        TJC.releaseObjv(interp, objv11, 6);
                    }
                } // End Invoke: append
            }
        } // End Invoke: if
        { // Invoke: append buffer [...]
            TclObject[] objv13 = TJC.grabObjv(interp, 1);
            TclObject tmp14;
            try {
                // Arg 2 command: [...]
                { // Invoke: ...
                    TclObject[] objv15 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: ...
                        objv15[0] = const8;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv15, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv15, 1);
                    }
                } // End Invoke: ...
                tmp14 = interp.getResult();
                tmp14.preserve();
                objv13[0] = tmp14;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv13, compiledLocals, 3);
            } finally {
                TJC.releaseObjvElems(interp, objv13, 1);
            }
        } // End Invoke: append
        { // Invoke: return $buffer
            TclObject tmp16 = getVarScalar(interp, "buffer", compiledLocals, 3);
            interp.resetResult();
            interp.setResult(tmp16);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "emitter_invoke_command_end");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("emitter_indent");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("error");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("size can't be zero or negative");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("TJC.releaseObjv(interp, ");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance(", ");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance(")");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance(";\n");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("TJC.releaseObjvElems(interp, ");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("emitter_container_try_end");
        const8.preserve(); const8.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "emitter_indent";
                break;
            }
            case 2: {
                cmdName = "error";
                break;
            }
            case 3: {
                cmdName = "emitter_container_try_end";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "arraysym",
        "size",
        "none",
        "buffer"
    };
} // end class EmitterInvokeCommandEndCmd

