// TJC implementation of procedure emitter_invoke_command_start
package tjc;
import tcl.lang.*;

public class EmitterInvokeCommandStartCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 3, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        ExprValue evs2 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 3) {
            throw new TclNumArgsException(interp, 1, objv, "arraysym size");
        }
        setVarScalar(interp, "arraysym", objv[1], compiledLocals, 0);
        setVarScalar(interp, "size", objv[2], compiledLocals, 1);
        { // Invoke: if ... ...
            // Binary operator: () || ()
            // Binary operator: () || ()
            // Binary operator: $size == ""
            TclObject tmp0 = getVarScalar(interp, "size", compiledLocals, 1);
            ExprValue tmp1 = evs0;
            TJC.exprEqualsEmptyString(tmp1, tmp0, false);
            // End Binary operator: ==
            if (!tmp1.getBooleanValue(interp)) {
            // Unary operator: ! [...]
            { // Invoke: string is integer $size
                TclObject[] objv2 = TJC.grabObjv(interp, 4);
                TclObject tmp3;
                try {
                    // Arg 0 constant: string
                    objv2[0] = const0;
                    // Arg 1 constant: is
                    objv2[1] = const1;
                    // Arg 2 constant: integer
                    objv2[2] = const2;
                    // Arg 3 variable: $size
                    tmp3 = getVarScalar(interp, "size", compiledLocals, 1);
                    tmp3.preserve();
                    objv2[3] = tmp3;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv2, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp3 = objv2[3];
                    if ( tmp3 != null ) {
                        tmp3.release();
                    }
                    TJC.releaseObjv(interp, objv2, 4);
                }
            } // End Invoke: string
            TclObject tmp4 = interp.getResult();
            ExprValue tmp5 = evs1;
            if ( tmp4.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp5, tmp4);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp5, tmp4);
            }
            // End Unary operator: !
            tmp1.setIntValue(tmp5.getBooleanValue(interp));
            } else {
            tmp1.setIntValue(1);
            } // End if: !()
            // End Binary operator: ||
            if (!tmp1.getBooleanValue(interp)) {
            // Binary operator: $size <= 0
            TclObject tmp6 = getVarScalar(interp, "size", compiledLocals, 1);
            ExprValue tmp7 = evs1;
            TJC.exprInitValue(interp, tmp7, tmp6);
            ExprValue tmp8 = evs2;
            tmp8.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LEQ, tmp7, tmp8);
            // End Binary operator: <=
            tmp1.setIntValue(tmp7.getBooleanValue(interp));
            } else {
            tmp1.setIntValue(1);
            } // End if: !()
            // End Binary operator: ||
            boolean tmp9 = ( tmp1.getIntValue() != 0 );
            if ( tmp9 ) {
                { // Invoke: error "..."
                    TclObject[] objv10 = TJC.grabObjv(interp, 2);
                    TclObject tmp11;
                    try {
                        // Arg 0 constant: error
                        objv10[0] = const3;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp12 = new StringBuffer(64);
                        sbtmp12.append("size ");
                        sbtmp12.append("\"");
                        tmp11 = getVarScalar(interp, "size", compiledLocals, 1);
                        sbtmp12.append(tmp11.toString());
                        sbtmp12.append("\"");
                        sbtmp12.append(" must be a positive integer");
                        tmp11 = TclString.newInstance(sbtmp12);
                        tmp11.preserve();
                        objv10[1] = tmp11;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv10, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp11 = objv10[1];
                        if ( tmp11 != null ) {
                            tmp11.release();
                        }
                        TJC.releaseObjv(interp, objv10, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const4, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: append buffer [...] ... $arraysym ... $size ")" ...
            TclObject[] objv13 = TJC.grabObjv(interp, 7);
            TclObject tmp14;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv15 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv15[0] = const5;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv15, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv15, 1);
                    }
                } // End Invoke: emitter_indent
                tmp14 = interp.getResult();
                tmp14.preserve();
                objv13[0] = tmp14;
                // Arg 3 constant: ...
                objv13[1] = const6;
                // Arg 4 variable: $arraysym
                tmp14 = getVarScalar(interp, "arraysym", compiledLocals, 0);
                tmp14.preserve();
                objv13[2] = tmp14;
                // Arg 5 constant: ...
                objv13[3] = const7;
                // Arg 6 variable: $size
                tmp14 = getVarScalar(interp, "size", compiledLocals, 1);
                tmp14.preserve();
                objv13[4] = tmp14;
                // Arg 7 constant: ")"
                objv13[5] = const8;
                // Arg 8 constant: ...
                objv13[6] = const9;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv13, compiledLocals, 2);
            } finally {
                tmp14 = objv13[0];
                if ( tmp14 != null ) {
                    tmp14.release();
                }
                tmp14 = objv13[2];
                if ( tmp14 != null ) {
                    tmp14.release();
                }
                tmp14 = objv13[4];
                if ( tmp14 != null ) {
                    tmp14.release();
                }
                TJC.releaseObjv(interp, objv13, 7);
            }
        } // End Invoke: append
        { // Invoke: return $buffer
            TclObject tmp16 = getVarScalar(interp, "buffer", compiledLocals, 2);
            interp.resetResult();
            interp.setResult(tmp16);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "emitter_invoke_command_start");
        } finally {
            TJC.exprReleaseValue(interp, evs2);
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("string");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("is");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("integer");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("error");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("emitter_indent");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("TclObject[] ");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance(" = TJC.grabObjv(interp, ");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance(")");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance(";\n");
        const9.preserve(); const9.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "string";
                break;
            }
            case 2: {
                cmdName = "error";
                break;
            }
            case 3: {
                cmdName = "emitter_indent";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "arraysym",
        "size",
        "buffer"
    };
} // end class EmitterInvokeCommandStartCmd

