// TJC implementation of procedure emitter_is_java_keyword
package tjc;
import tcl.lang.*;

public class EmitterIsJavaKeywordCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 1, compiledLocalsNames);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "str");
        }
        setVarScalar(interp, "str", objv[1], compiledLocals, 0);
        { // Invoke: switch -exact -- $str {abstract} - {boolean} - {break} - {byte} - {case} - {catch} - {char} - {class} - {const} - {continue} - default - {double} - {do} - {else} - {extends} - {finally} - {final} - {float} - {for} - {goto} - {if} - {implements} - {import} - {instanceof} - {interface} - {int} - {long} - {native} - {new} - {package} - {private} - {protected} - {public} - {return} - {short} - {static} - {strictfp} - {super} - {switch} - {synchronized} - {this} - {throws} - {throw} - {transient} - {try} - {void} - {volatile} - {while} ... default ...
            TclObject tmp0 = getVarScalar(interp, "str", compiledLocals, 0);
            String tmp1 = tmp0.toString();
            int tmp1_length = tmp1.length();
            char tmp1_first = '\n';
            if ( tmp1_length > 0 ) {
                tmp1_first = tmp1.charAt(0);
            }
            interp.resetResult();
            if ( ( tmp1_length == 8 && tmp1_first == 'a'
                    && tmp1.compareTo("abstract") == 0 ) ||
                ( tmp1_length == 7 && tmp1_first == 'b'
                    && tmp1.compareTo("boolean") == 0 ) ||
                ( tmp1_length == 5 && tmp1_first == 'b'
                    && tmp1.compareTo("break") == 0 ) ||
                ( tmp1_length == 4 && tmp1_first == 'b'
                    && tmp1.compareTo("byte") == 0 ) ||
                ( tmp1_length == 4 && tmp1_first == 'c'
                    && tmp1.compareTo("case") == 0 ) ||
                ( tmp1_length == 5 && tmp1_first == 'c'
                    && tmp1.compareTo("catch") == 0 ) ||
                ( tmp1_length == 4 && tmp1_first == 'c'
                    && tmp1.compareTo("char") == 0 ) ||
                ( tmp1_length == 5 && tmp1_first == 'c'
                    && tmp1.compareTo("class") == 0 ) ||
                ( tmp1_length == 5 && tmp1_first == 'c'
                    && tmp1.compareTo("const") == 0 ) ||
                ( tmp1_length == 8 && tmp1_first == 'c'
                    && tmp1.compareTo("continue") == 0 ) ||
                ( tmp1_length == 7 && tmp1_first == 'd'
                    && tmp1.compareTo("default") == 0 ) ||
                ( tmp1_length == 6 && tmp1_first == 'd'
                    && tmp1.compareTo("double") == 0 ) ||
                ( tmp1_length == 2 && tmp1_first == 'd'
                    && tmp1.compareTo("do") == 0 ) ||
                ( tmp1_length == 4 && tmp1_first == 'e'
                    && tmp1.compareTo("else") == 0 ) ||
                ( tmp1_length == 7 && tmp1_first == 'e'
                    && tmp1.compareTo("extends") == 0 ) ||
                ( tmp1_length == 7 && tmp1_first == 'f'
                    && tmp1.compareTo("finally") == 0 ) ||
                ( tmp1_length == 5 && tmp1_first == 'f'
                    && tmp1.compareTo("final") == 0 ) ||
                ( tmp1_length == 5 && tmp1_first == 'f'
                    && tmp1.compareTo("float") == 0 ) ||
                ( tmp1_length == 3 && tmp1_first == 'f'
                    && tmp1.compareTo("for") == 0 ) ||
                ( tmp1_length == 4 && tmp1_first == 'g'
                    && tmp1.compareTo("goto") == 0 ) ||
                ( tmp1_length == 2 && tmp1_first == 'i'
                    && tmp1.compareTo("if") == 0 ) ||
                ( tmp1_length == 10 && tmp1_first == 'i'
                    && tmp1.compareTo("implements") == 0 ) ||
                ( tmp1_length == 6 && tmp1_first == 'i'
                    && tmp1.compareTo("import") == 0 ) ||
                ( tmp1_length == 10 && tmp1_first == 'i'
                    && tmp1.compareTo("instanceof") == 0 ) ||
                ( tmp1_length == 9 && tmp1_first == 'i'
                    && tmp1.compareTo("interface") == 0 ) ||
                ( tmp1_length == 3 && tmp1_first == 'i'
                    && tmp1.compareTo("int") == 0 ) ||
                ( tmp1_length == 4 && tmp1_first == 'l'
                    && tmp1.compareTo("long") == 0 ) ||
                ( tmp1_length == 6 && tmp1_first == 'n'
                    && tmp1.compareTo("native") == 0 ) ||
                ( tmp1_length == 3 && tmp1_first == 'n'
                    && tmp1.compareTo("new") == 0 ) ||
                ( tmp1_length == 7 && tmp1_first == 'p'
                    && tmp1.compareTo("package") == 0 ) ||
                ( tmp1_length == 7 && tmp1_first == 'p'
                    && tmp1.compareTo("private") == 0 ) ||
                ( tmp1_length == 9 && tmp1_first == 'p'
                    && tmp1.compareTo("protected") == 0 ) ||
                ( tmp1_length == 6 && tmp1_first == 'p'
                    && tmp1.compareTo("public") == 0 ) ||
                ( tmp1_length == 6 && tmp1_first == 'r'
                    && tmp1.compareTo("return") == 0 ) ||
                ( tmp1_length == 5 && tmp1_first == 's'
                    && tmp1.compareTo("short") == 0 ) ||
                ( tmp1_length == 6 && tmp1_first == 's'
                    && tmp1.compareTo("static") == 0 ) ||
                ( tmp1_length == 8 && tmp1_first == 's'
                    && tmp1.compareTo("strictfp") == 0 ) ||
                ( tmp1_length == 5 && tmp1_first == 's'
                    && tmp1.compareTo("super") == 0 ) ||
                ( tmp1_length == 6 && tmp1_first == 's'
                    && tmp1.compareTo("switch") == 0 ) ||
                ( tmp1_length == 12 && tmp1_first == 's'
                    && tmp1.compareTo("synchronized") == 0 ) ||
                ( tmp1_length == 4 && tmp1_first == 't'
                    && tmp1.compareTo("this") == 0 ) ||
                ( tmp1_length == 6 && tmp1_first == 't'
                    && tmp1.compareTo("throws") == 0 ) ||
                ( tmp1_length == 5 && tmp1_first == 't'
                    && tmp1.compareTo("throw") == 0 ) ||
                ( tmp1_length == 9 && tmp1_first == 't'
                    && tmp1.compareTo("transient") == 0 ) ||
                ( tmp1_length == 3 && tmp1_first == 't'
                    && tmp1.compareTo("try") == 0 ) ||
                ( tmp1_length == 4 && tmp1_first == 'v'
                    && tmp1.compareTo("void") == 0 ) ||
                ( tmp1_length == 8 && tmp1_first == 'v'
                    && tmp1.compareTo("volatile") == 0 ) ||
                ( tmp1_length == 5 && tmp1_first == 'w'
                    && tmp1.compareTo("while") == 0 ) ) {
                // Pattern {while}
                { // Invoke: return 1
                    interp.resetResult();
                    interp.setResult(const0);
                    if ( true ) { return; }
                } // End Invoke: return
            } else {
                // Pattern default
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const1);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: switch
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "emitter_is_java_keyword");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclInteger.newInstance(1);
        const0.preserve(); const0.preserve();
        const1 = TclInteger.newInstance(0);
        const1.preserve(); const1.preserve();
    }

    String[] compiledLocalsNames = {
        "str"
    };
} // end class EmitterIsJavaKeywordCmd

