// TJC implementation of procedure emitter_make_global_link_var
package tjc;
import tcl.lang.*;

public class EmitterMakeGlobalLinkVarCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 5, compiledLocalsNames);
        try {
        if (objv.length != 4) {
            throw new TclNumArgsException(interp, 1, objv, "varname tail localIndex");
        }
        setVarScalar(interp, "varname", objv[1], compiledLocals, 0);
        setVarScalar(interp, "tail", objv[2], compiledLocals, 1);
        setVarScalar(interp, "localIndex", objv[3], compiledLocals, 2);
        { // Invoke: set jstr1 [...]
            TclObject tmp0;
            { // Invoke: ... $varname
                TclObject[] objv1 = TJC.grabObjv(interp, 2);
                TclObject tmp2;
                try {
                    // Arg 0 constant: ...
                    objv1[0] = const0;
                    // Arg 1 variable: $varname
                    tmp2 = getVarScalar(interp, "varname", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 2);
                }
            } // End Invoke: ...
            tmp0 = interp.getResult();
            setVarScalar(interp, "jstr1", tmp0, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set jstr2 [...]
            TclObject tmp3;
            { // Invoke: ... $tail
                TclObject[] objv4 = TJC.grabObjv(interp, 2);
                TclObject tmp5;
                try {
                    // Arg 0 constant: ...
                    objv4[0] = const0;
                    // Arg 1 variable: $tail
                    tmp5 = getVarScalar(interp, "tail", compiledLocals, 1);
                    tmp5.preserve();
                    objv4[1] = tmp5;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv4, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp5 = objv4[1];
                    if ( tmp5 != null ) {
                        tmp5.release();
                    }
                    TJC.releaseObjv(interp, objv4, 2);
                }
            } // End Invoke: ...
            tmp3 = interp.getResult();
            setVarScalar(interp, "jstr2", tmp3, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: return "..."
            TclObject tmp6;
            StringBuffer sbtmp7 = new StringBuffer(64);
            { // Invoke: emitter_indent
                TclObject[] objv8 = TJC.grabObjv(interp, 1);
                try {
                    // Arg 0 constant: emitter_indent
                    objv8[0] = const1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv8, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv8, 1);
                }
            } // End Invoke: emitter_indent
            tmp6 = interp.getResult();
            sbtmp7.append(tmp6.toString());
            sbtmp7.append("TJC.makeGlobalLinkVar(interp, ");
            tmp6 = getVarScalar(interp, "jstr1", compiledLocals, 3);
            sbtmp7.append(tmp6.toString());
            sbtmp7.append(", ");
            tmp6 = getVarScalar(interp, "jstr2", compiledLocals, 4);
            sbtmp7.append(tmp6.toString());
            sbtmp7.append(", ");
            tmp6 = getVarScalar(interp, "localIndex", compiledLocals, 2);
            sbtmp7.append(tmp6.toString());
            sbtmp7.append(")");
            sbtmp7.append(";");
            sbtmp7.append("\n");
            tmp6 = TclString.newInstance(sbtmp7);
            interp.resetResult();
            interp.setResult(tmp6);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "emitter_make_global_link_var");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("emitter_double_quote_tcl_string");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("emitter_indent");
        const1.preserve(); const1.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "emitter_double_quote_tcl_string";
                break;
            }
            case 2: {
                cmdName = "emitter_indent";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "varname",
        "tail",
        "localIndex",
        "jstr1",
        "jstr2"
    };
} // end class EmitterMakeGlobalLinkVarCmd

