// TJC implementation of procedure emitter_package_name
package tjc;
import tcl.lang.*;

public class EmitterPackageNameCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 1, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "package");
        }
        setVarScalar(interp, "package", objv[1], compiledLocals, 0);
        { // Invoke: if ... ... else ...
            // Binary operator: $package == "default"
            TclObject tmp0 = getVarScalar(interp, "package", compiledLocals, 0);
            boolean tmp1 = tmp0.toString().equals("default");
            ExprValue tmp2 = evs0;
            tmp2.setIntValue(tmp1);
            // End Binary operator: ==
            boolean tmp3 = ( tmp2.getIntValue() != 0 );
            if ( tmp3 ) {
                { // Invoke: return ""
                    interp.resetResult();
                    interp.setResult(const0);
                    if ( true ) { return; }
                } // End Invoke: return
            } else {
                { // Invoke: return "..."
                    TclObject tmp4;
                    StringBuffer sbtmp5 = new StringBuffer(64);
                    sbtmp5.append("package ");
                    tmp4 = getVarScalar(interp, "package", compiledLocals, 0);
                    sbtmp5.append(tmp4.toString());
                    sbtmp5.append(";");
                    sbtmp5.append("\n");
                    tmp4 = TclString.newInstance(sbtmp5);
                    interp.resetResult();
                    interp.setResult(tmp4);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "emitter_package_name");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
    }

    String[] compiledLocalsNames = {
        "package"
    };
} // end class EmitterPackageNameCmd

