// TJC implementation of procedure emitter_tclobject_to_boolean
package tjc;
import tcl.lang.*;

public class EmitterTclobjectToBooleanCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 1, compiledLocalsNames);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "identifier");
        }
        setVarScalar(interp, "identifier", objv[1], compiledLocals, 0);
        { // Invoke: return "..."
            TclObject tmp0;
            StringBuffer sbtmp1 = new StringBuffer(64);
            sbtmp1.append("TJC.getBoolean(interp, ");
            tmp0 = getVarScalar(interp, "identifier", compiledLocals, 0);
            sbtmp1.append(tmp0.toString());
            sbtmp1.append(")");
            tmp0 = TclString.newInstance(sbtmp1);
            interp.resetResult();
            interp.setResult(tmp0);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "emitter_tclobject_to_boolean");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    String[] compiledLocalsNames = {
        "identifier"
    };
} // end class EmitterTclobjectToBooleanCmd

