// TJC implementation of procedure initJavaCompiler
package tjc;
import tcl.lang.*;

public class InitJavaCompilerCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 19, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 1) {
            throw new TclNumArgsException(interp, 1, objv, "");
        }
        { // Invoke: global _tjcthread
            TJC.makeGlobalLinkVar(interp, "_tjcthread", "_tjcthread", 0);
        } // End Invoke: global
        { // Invoke: global env
            TJC.makeGlobalLinkVar(interp, "env", "env", 1);
        } // End Invoke: global
        { // Invoke: global JAVA_INIT JAVA_CMD JAVA_DRIVER JAVA_HOLD_REF
            TJC.makeGlobalLinkVar(interp, "JAVA_INIT", "JAVA_INIT", 2);
            TJC.makeGlobalLinkVar(interp, "JAVA_CMD", "JAVA_CMD", 3);
            TJC.makeGlobalLinkVar(interp, "JAVA_DRIVER", "JAVA_DRIVER", 4);
            TJC.makeGlobalLinkVar(interp, "JAVA_HOLD_REF", "JAVA_HOLD_REF", 5);
        } // End Invoke: global
        { // Invoke: set drivers {}
            setVarScalar(interp, "drivers", const0, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set jar_file ""
            setVarScalar(interp, "jar_file", const0, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: if {$JAVA_DRIVER == ""} ... elseif ... ... elseif ... ...
            // Binary operator: $JAVA_DRIVER == ""
            TclObject tmp0 = getVarScalar(interp, "JAVA_DRIVER", compiledLocals, 4);
            ExprValue tmp1 = evs0;
            TJC.exprEqualsEmptyString(tmp1, tmp0, false);
            // End Binary operator: ==
            boolean tmp2 = ( tmp1.getIntValue() != 0 );
            if ( tmp2 ) {
                { // Invoke: lappend drivers janino pizza
                    TclObject[] objv3 = TJC.grabObjv(interp, 2);
                    TclObject tmp4;
                    try {
                        // Arg 2 constant: janino
                        objv3[0] = const1;
                        // Arg 3 constant: pizza
                        objv3[1] = const2;
                        interp.resetResult();
                        lappendVarScalar(interp, "drivers", objv3, compiledLocals, 6);
                    } finally {
                        TJC.releaseObjv(interp, objv3, 2);
                    }
                } // End Invoke: lappend
            } else {
                // Binary operator: $JAVA_DRIVER == "pizza"
                TclObject tmp5 = getVarScalar(interp, "JAVA_DRIVER", compiledLocals, 4);
                boolean tmp6 = tmp5.toString().equals("pizza");
                ExprValue tmp7 = evs0;
                tmp7.setIntValue(tmp6);
                // End Binary operator: ==
                boolean tmp8 = ( tmp7.getIntValue() != 0 );
                if ( tmp8 ) {
                    { // Invoke: lappend drivers pizza
                        TclObject[] objv9 = TJC.grabObjv(interp, 1);
                        TclObject tmp10;
                        try {
                            // Arg 2 constant: pizza
                            objv9[0] = const2;
                            interp.resetResult();
                            lappendVarScalar(interp, "drivers", objv9, compiledLocals, 6);
                        } finally {
                            TJC.releaseObjv(interp, objv9, 1);
                        }
                    } // End Invoke: lappend
                } else {
                    // Binary operator: $JAVA_DRIVER == "janino"
                    TclObject tmp11 = getVarScalar(interp, "JAVA_DRIVER", compiledLocals, 4);
                    boolean tmp12 = tmp11.toString().equals("janino");
                    ExprValue tmp13 = evs0;
                    tmp13.setIntValue(tmp12);
                    // End Binary operator: ==
                    boolean tmp14 = ( tmp13.getIntValue() != 0 );
                    if ( tmp14 ) {
                        { // Invoke: lappend drivers janino
                            TclObject[] objv15 = TJC.grabObjv(interp, 1);
                            TclObject tmp16;
                            try {
                                // Arg 2 constant: janino
                                objv15[0] = const1;
                                interp.resetResult();
                                lappendVarScalar(interp, "drivers", objv15, compiledLocals, 6);
                            } finally {
                                TJC.releaseObjv(interp, objv15, 1);
                            }
                        } // End Invoke: lappend
                    }
                }
            }
        } // End Invoke: if
        { // Invoke: if ... ... else ...
            // Binary operator: $::tcl_platform(...) == "windows"
            initVarScoped(interp, "::tcl_platform", compiledLocals, 8);
            TclObject tmp17 = getVarArray(interp, "::tcl_platform", "host_platform", compiledLocals, 8);
            boolean tmp18 = tmp17.toString().equals("windows");
            ExprValue tmp19 = evs0;
            tmp19.setIntValue(tmp18);
            // End Binary operator: ==
            boolean tmp20 = ( tmp19.getIntValue() != 0 );
            if ( tmp20 ) {
                { // Invoke: set sep ...
                    setVarScalar(interp, "sep", const3, compiledLocals, 9);
                } // End Invoke: set
            } else {
                { // Invoke: set sep :
                    setVarScalar(interp, "sep", const4, compiledLocals, 9);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: set jardir ""
            setVarScalar(interp, "jardir", const0, compiledLocals, 10);
        } // End Invoke: set
        { // Invoke: foreach path [...] ...
            TclObject tmp21 = null;
            try {
                { // Invoke: split $::env(CLASSPATH) $sep
                    TclObject[] objv22 = TJC.grabObjv(interp, 3);
                    TclObject tmp23;
                    try {
                        // Arg 0 constant: split
                        objv22[0] = const5;
                        // Arg 1 variable: $::env(CLASSPATH)
                        initVarScoped(interp, "::env", compiledLocals, 11);
                        tmp23 = getVarArray(interp, "::env", "CLASSPATH", compiledLocals, 11);
                        tmp23.preserve();
                        objv22[1] = tmp23;
                        // Arg 2 variable: $sep
                        tmp23 = getVarScalar(interp, "sep", compiledLocals, 9);
                        tmp23.preserve();
                        objv22[2] = tmp23;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv22, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp23 = objv22[1];
                        if ( tmp23 != null ) {
                            tmp23.release();
                        }
                        tmp23 = objv22[2];
                        if ( tmp23 != null ) {
                            tmp23.release();
                        }
                        TJC.releaseObjv(interp, objv22, 3);
                    }
                } // End Invoke: split
                tmp21 = interp.getResult();
                tmp21.preserve();
                final int tmp21_length = TclList.getLength(interp, tmp21);

                for ( int index24 = 0 ; index24 < tmp21_length ; index24++ ) {
                    TclObject tmp25 = TclList.index(interp, tmp21, index24);
                    try {
                        setVarScalar(interp, "path", tmp25, compiledLocals, 12);
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "path");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: if {$path == {}} ...
                        // Binary operator: $path == ""
                        TclObject tmp26 = getVarScalar(interp, "path", compiledLocals, 12);
                        ExprValue tmp27 = evs0;
                        TJC.exprEqualsEmptyString(tmp27, tmp26, false);
                        // End Binary operator: ==
                        boolean tmp28 = ( tmp27.getIntValue() != 0 );
                        if ( tmp28 ) {
                            { // Invoke: continue
                                if ( true ) { continue; }
                            } // End Invoke: continue
                        }
                    } // End Invoke: if
                    { // Invoke: if ... ...
                        // Binary operator: [...] == "tcljava.jar"
                        { // Invoke: file tail $path
                            TclObject[] objv29 = TJC.grabObjv(interp, 3);
                            TclObject tmp30;
                            try {
                                // Arg 0 constant: file
                                objv29[0] = const6;
                                // Arg 1 constant: tail
                                objv29[1] = const7;
                                // Arg 2 variable: $path
                                tmp30 = getVarScalar(interp, "path", compiledLocals, 12);
                                tmp30.preserve();
                                objv29[2] = tmp30;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                    ? cmdcache2.cmd : null), objv29, 0);
                                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                    updateCmdCache(interp, 2);
                                }
                            } finally {
                                tmp30 = objv29[2];
                                if ( tmp30 != null ) {
                                    tmp30.release();
                                }
                                TJC.releaseObjv(interp, objv29, 3);
                            }
                        } // End Invoke: file
                        TclObject tmp31 = interp.getResult();
                        boolean tmp32 = tmp31.toString().equals("tcljava.jar");
                        ExprValue tmp33 = evs0;
                        tmp33.setIntValue(tmp32);
                        // End Binary operator: ==
                        boolean tmp34 = ( tmp33.getIntValue() != 0 );
                        if ( tmp34 ) {
                            { // Invoke: set jardir [...]
                                TclObject tmp35;
                                { // Invoke: file dirname $path
                                    TclObject[] objv36 = TJC.grabObjv(interp, 3);
                                    TclObject tmp37;
                                    try {
                                        // Arg 0 constant: file
                                        objv36[0] = const6;
                                        // Arg 1 constant: dirname
                                        objv36[1] = const8;
                                        // Arg 2 variable: $path
                                        tmp37 = getVarScalar(interp, "path", compiledLocals, 12);
                                        tmp37.preserve();
                                        objv36[2] = tmp37;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                            ? cmdcache2.cmd : null), objv36, 0);
                                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                            updateCmdCache(interp, 2);
                                        }
                                    } finally {
                                        tmp37 = objv36[2];
                                        if ( tmp37 != null ) {
                                            tmp37.release();
                                        }
                                        TJC.releaseObjv(interp, objv36, 3);
                                    }
                                } // End Invoke: file
                                tmp35 = interp.getResult();
                                setVarScalar(interp, "jardir", tmp35, compiledLocals, 10);
                            } // End Invoke: set
                        }
                    } // End Invoke: if
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp21 != null ) {
                    tmp21.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: if {$jardir == ""} ...
            // Binary operator: $jardir == ""
            TclObject tmp38 = getVarScalar(interp, "jardir", compiledLocals, 10);
            ExprValue tmp39 = evs0;
            TJC.exprEqualsEmptyString(tmp39, tmp38, false);
            // End Binary operator: ==
            boolean tmp40 = ( tmp39.getIntValue() != 0 );
            if ( tmp40 ) {
                { // Invoke: error "..."
                    TclObject[] objv41 = TJC.grabObjv(interp, 2);
                    TclObject tmp42;
                    try {
                        // Arg 0 constant: error
                        objv41[0] = const9;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp43 = new StringBuffer(64);
                        sbtmp43.append("could not locate tcljava.jar on CLASSPATH ");
                        sbtmp43.append("\"");
                        tmp42 = getVarArray(interp, "env", "CLASSPATH", compiledLocals, 1);
                        sbtmp43.append(tmp42.toString());
                        sbtmp43.append("\"");
                        tmp42 = TclString.newInstance(sbtmp43);
                        tmp42.preserve();
                        objv41[1] = tmp42;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv41, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        tmp42 = objv41[1];
                        if ( tmp42 != null ) {
                            tmp42.release();
                        }
                        TJC.releaseObjv(interp, objv41, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: foreach driver $drivers ...
            TclObject tmp44 = null;
            try {
                tmp44 = getVarScalar(interp, "drivers", compiledLocals, 6);
                tmp44.preserve();
                final int tmp44_length = TclList.getLength(interp, tmp44);

                for ( int index45 = 0 ; index45 < tmp44_length ; index45++ ) {
                    TclObject tmp46 = TclList.index(interp, tmp44, index45);
                    try {
                        setVarScalar(interp, "driver", tmp46, compiledLocals, 13);
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "driver");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: if {$driver == "pizza"} ... elseif ... ...
                        // Binary operator: $driver == "pizza"
                        TclObject tmp47 = getVarScalar(interp, "driver", compiledLocals, 13);
                        boolean tmp48 = tmp47.toString().equals("pizza");
                        ExprValue tmp49 = evs0;
                        tmp49.setIntValue(tmp48);
                        // End Binary operator: ==
                        boolean tmp50 = ( tmp49.getIntValue() != 0 );
                        if ( tmp50 ) {
                            { // Invoke: set file [...]
                                TclObject tmp51;
                                { // Invoke: file join $jardir "pizza-1.1.jar"
                                    TclObject[] objv52 = TJC.grabObjv(interp, 4);
                                    TclObject tmp53;
                                    try {
                                        // Arg 0 constant: file
                                        objv52[0] = const6;
                                        // Arg 1 constant: join
                                        objv52[1] = const10;
                                        // Arg 2 variable: $jardir
                                        tmp53 = getVarScalar(interp, "jardir", compiledLocals, 10);
                                        tmp53.preserve();
                                        objv52[2] = tmp53;
                                        // Arg 3 constant: "pizza-1.1.jar"
                                        objv52[3] = const11;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                            ? cmdcache2.cmd : null), objv52, 0);
                                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                            updateCmdCache(interp, 2);
                                        }
                                    } finally {
                                        tmp53 = objv52[2];
                                        if ( tmp53 != null ) {
                                            tmp53.release();
                                        }
                                        TJC.releaseObjv(interp, objv52, 4);
                                    }
                                } // End Invoke: file
                                tmp51 = interp.getResult();
                                setVarScalar(interp, "file", tmp51, compiledLocals, 14);
                            } // End Invoke: set
                            { // Invoke: if ... ...
                                { // Invoke: file exists $file
                                    TclObject[] objv54 = TJC.grabObjv(interp, 3);
                                    TclObject tmp55;
                                    try {
                                        // Arg 0 constant: file
                                        objv54[0] = const6;
                                        // Arg 1 constant: exists
                                        objv54[1] = const12;
                                        // Arg 2 variable: $file
                                        tmp55 = getVarScalar(interp, "file", compiledLocals, 14);
                                        tmp55.preserve();
                                        objv54[2] = tmp55;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                            ? cmdcache2.cmd : null), objv54, 0);
                                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                            updateCmdCache(interp, 2);
                                        }
                                    } finally {
                                        tmp55 = objv54[2];
                                        if ( tmp55 != null ) {
                                            tmp55.release();
                                        }
                                        TJC.releaseObjv(interp, objv54, 3);
                                    }
                                } // End Invoke: file
                                TclObject tmp56 = interp.getResult();
                                ExprValue tmp57 = evs0;
                                TJC.exprInitValue(interp, tmp57, tmp56);
                                boolean tmp58 = tmp57.getBooleanValue(interp);
                                if ( tmp58 ) {
                                    { // Invoke: set jar_file $file
                                        TclObject tmp59;
                                        tmp59 = getVarScalar(interp, "file", compiledLocals, 14);
                                        setVarScalar(interp, "jar_file", tmp59, compiledLocals, 7);
                                    } // End Invoke: set
                                    { // Invoke: set test_class ...
                                        setVarScalar(interp, "test_class", const13, compiledLocals, 15);
                                    } // End Invoke: set
                                    { // Invoke: set test_ctor ...
                                        setVarScalar(interp, "test_ctor", const13, compiledLocals, 16);
                                    } // End Invoke: set
                                    { // Invoke: set java_cmd pizzaCompile
                                        setVarScalar(interp, "java_cmd", const14, compiledLocals, 17);
                                    } // End Invoke: set
                                    { // Invoke: break
                                        if ( true ) { break; }
                                    } // End Invoke: break
                                }
                            } // End Invoke: if
                        } else {
                            // Binary operator: $driver == "janino"
                            TclObject tmp60 = getVarScalar(interp, "driver", compiledLocals, 13);
                            boolean tmp61 = tmp60.toString().equals("janino");
                            ExprValue tmp62 = evs0;
                            tmp62.setIntValue(tmp61);
                            // End Binary operator: ==
                            boolean tmp63 = ( tmp62.getIntValue() != 0 );
                            if ( tmp63 ) {
                                { // Invoke: set file [...]
                                    TclObject tmp64;
                                    { // Invoke: file join $jardir "janino.jar"
                                        TclObject[] objv65 = TJC.grabObjv(interp, 4);
                                        TclObject tmp66;
                                        try {
                                            // Arg 0 constant: file
                                            objv65[0] = const6;
                                            // Arg 1 constant: join
                                            objv65[1] = const10;
                                            // Arg 2 variable: $jardir
                                            tmp66 = getVarScalar(interp, "jardir", compiledLocals, 10);
                                            tmp66.preserve();
                                            objv65[2] = tmp66;
                                            // Arg 3 constant: "janino.jar"
                                            objv65[3] = const15;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                                ? cmdcache2.cmd : null), objv65, 0);
                                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                                updateCmdCache(interp, 2);
                                            }
                                        } finally {
                                            tmp66 = objv65[2];
                                            if ( tmp66 != null ) {
                                                tmp66.release();
                                            }
                                            TJC.releaseObjv(interp, objv65, 4);
                                        }
                                    } // End Invoke: file
                                    tmp64 = interp.getResult();
                                    setVarScalar(interp, "file", tmp64, compiledLocals, 14);
                                } // End Invoke: set
                                { // Invoke: if ... ...
                                    { // Invoke: file exists $file
                                        TclObject[] objv67 = TJC.grabObjv(interp, 3);
                                        TclObject tmp68;
                                        try {
                                            // Arg 0 constant: file
                                            objv67[0] = const6;
                                            // Arg 1 constant: exists
                                            objv67[1] = const12;
                                            // Arg 2 variable: $file
                                            tmp68 = getVarScalar(interp, "file", compiledLocals, 14);
                                            tmp68.preserve();
                                            objv67[2] = tmp68;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                                ? cmdcache2.cmd : null), objv67, 0);
                                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                                updateCmdCache(interp, 2);
                                            }
                                        } finally {
                                            tmp68 = objv67[2];
                                            if ( tmp68 != null ) {
                                                tmp68.release();
                                            }
                                            TJC.releaseObjv(interp, objv67, 3);
                                        }
                                    } // End Invoke: file
                                    TclObject tmp69 = interp.getResult();
                                    ExprValue tmp70 = evs0;
                                    TJC.exprInitValue(interp, tmp70, tmp69);
                                    boolean tmp71 = tmp70.getBooleanValue(interp);
                                    if ( tmp71 ) {
                                        { // Invoke: set jar_file $file
                                            TclObject tmp72;
                                            tmp72 = getVarScalar(interp, "file", compiledLocals, 14);
                                            setVarScalar(interp, "jar_file", tmp72, compiledLocals, 7);
                                        } // End Invoke: set
                                        { // Invoke: set test_class ...
                                            setVarScalar(interp, "test_class", const16, compiledLocals, 15);
                                        } // End Invoke: set
                                        { // Invoke: set test_ctor ...
                                            setVarScalar(interp, "test_ctor", const17, compiledLocals, 16);
                                        } // End Invoke: set
                                        { // Invoke: set java_cmd janinoCompile
                                            setVarScalar(interp, "java_cmd", const18, compiledLocals, 17);
                                        } // End Invoke: set
                                        { // Invoke: break
                                            if ( true ) { break; }
                                        } // End Invoke: break
                                    }
                                } // End Invoke: if
                            }
                        }
                    } // End Invoke: if
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp44 != null ) {
                    tmp44.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: if {$jar_file == ""} ...
            // Binary operator: $jar_file == ""
            TclObject tmp73 = getVarScalar(interp, "jar_file", compiledLocals, 7);
            ExprValue tmp74 = evs0;
            TJC.exprEqualsEmptyString(tmp74, tmp73, false);
            // End Binary operator: ==
            boolean tmp75 = ( tmp74.getIntValue() != 0 );
            if ( tmp75 ) {
                { // Invoke: error ...
                    TclObject[] objv76 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: error
                        objv76[0] = const9;
                        // Arg 1 constant: ...
                        objv76[1] = const19;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv76, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv76, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set env(TCL_CLASSPATH) $jar_file
            TclObject tmp77;
            tmp77 = getVarScalar(interp, "jar_file", compiledLocals, 7);
            setVarArray(interp, "env", "TCL_CLASSPATH", tmp77, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: if ... ...
            { // Invoke: catch ... err
                int code78 = TCL.OK;
                try {
                if ( false ) { throw (TclException) null; }
                { // Invoke: java::field $test_class class
                    TclObject[] objv79 = TJC.grabObjv(interp, 3);
                    TclObject tmp80;
                    try {
                        // Arg 0 constant: java::field
                        objv79[0] = const20;
                        // Arg 1 variable: $test_class
                        tmp80 = getVarScalar(interp, "test_class", compiledLocals, 15);
                        tmp80.preserve();
                        objv79[1] = tmp80;
                        // Arg 2 constant: class
                        objv79[2] = const21;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                            ? cmdcache4.cmd : null), objv79, 0);
                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                            updateCmdCache(interp, 4);
                        }
                    } finally {
                        tmp80 = objv79[1];
                        if ( tmp80 != null ) {
                            tmp80.release();
                        }
                        TJC.releaseObjv(interp, objv79, 3);
                    }
                } // End Invoke: java::field
                } catch (TclException ex) {
                    code78 = ex.getCompletionCode();
                }
                TclObject result = interp.getResult();
                try {
                    setVarScalar(interp, "err", result, compiledLocals, 18);
                } catch (TclException ex) {
                    TJC.catchVarErr(interp);
                }
                interp.resetResult();
                interp.setResult(code78);
            } // End Invoke: catch
            TclObject tmp81 = interp.getResult();
            ExprValue tmp82 = evs0;
            TJC.exprInitValue(interp, tmp82, tmp81);
            boolean tmp83 = tmp82.getBooleanValue(interp);
            if ( tmp83 ) {
                { // Invoke: error "..."
                    TclObject[] objv84 = TJC.grabObjv(interp, 2);
                    TclObject tmp85;
                    try {
                        // Arg 0 constant: error
                        objv84[0] = const9;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp86 = new StringBuffer(64);
                        sbtmp86.append("could not load compiler driver test class ");
                        sbtmp86.append("\"");
                        tmp85 = getVarScalar(interp, "test_class", compiledLocals, 15);
                        sbtmp86.append(tmp85.toString());
                        sbtmp86.append("\"");
                        sbtmp86.append(", problem with TCL_CLASSPATH ?");
                        tmp85 = TclString.newInstance(sbtmp86);
                        tmp85.preserve();
                        objv84[1] = tmp85;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv84, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        tmp85 = objv84[1];
                        if ( tmp85 != null ) {
                            tmp85.release();
                        }
                        TJC.releaseObjv(interp, objv84, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: if ... ... else ...
            // Binary operator: $driver == "janino"
            TclObject tmp87 = getVarScalar(interp, "driver", compiledLocals, 13);
            boolean tmp88 = tmp87.toString().equals("janino");
            ExprValue tmp89 = evs0;
            tmp89.setIntValue(tmp88);
            // End Binary operator: ==
            boolean tmp90 = ( tmp89.getIntValue() != 0 );
            if ( tmp90 ) {
                { // Invoke: set JAVA_HOLD_REF [...]
                    TclObject tmp91;
                    { // Invoke: java::new $test_ctor 1
                        TclObject[] objv92 = TJC.grabObjv(interp, 3);
                        TclObject tmp93;
                        try {
                            // Arg 0 constant: java::new
                            objv92[0] = const22;
                            // Arg 1 variable: $test_ctor
                            tmp93 = getVarScalar(interp, "test_ctor", compiledLocals, 16);
                            tmp93.preserve();
                            objv92[1] = tmp93;
                            // Arg 2 constant: 1
                            objv92[2] = const23;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                ? cmdcache5.cmd : null), objv92, 0);
                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                updateCmdCache(interp, 5);
                            }
                        } finally {
                            tmp93 = objv92[1];
                            if ( tmp93 != null ) {
                                tmp93.release();
                            }
                            TJC.releaseObjv(interp, objv92, 3);
                        }
                    } // End Invoke: java::new
                    tmp91 = interp.getResult();
                    setVarScalar(interp, "JAVA_HOLD_REF", tmp91, compiledLocals, 5);
                } // End Invoke: set
            } else {
                { // Invoke: set JAVA_HOLD_REF $err
                    TclObject tmp94;
                    tmp94 = getVarScalar(interp, "err", compiledLocals, 18);
                    setVarScalar(interp, "JAVA_HOLD_REF", tmp94, compiledLocals, 5);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: set JAVA_INIT 1
            setVarScalar(interp, "JAVA_INIT", const23, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set JAVA_CMD $java_cmd
            TclObject tmp95;
            tmp95 = getVarScalar(interp, "java_cmd", compiledLocals, 17);
            setVarScalar(interp, "JAVA_CMD", tmp95, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: return
            interp.resetResult();
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "initJavaCompiler");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;
    TclObject const19;
    TclObject const20;
    TclObject const21;
    TclObject const22;
    TclObject const23;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("janino");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("pizza");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance(";");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance(":");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("split");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("file");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("tail");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("dirname");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("error");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("join");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("pizza-1.1.jar");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("exists");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("net.sf.pizzacompiler.compiler.Main");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("pizzaCompile");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("janino.jar");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("org.codehaus.janino.SimpleCompiler");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("org.codehaus.janino.SimpleCompiler boolean");
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance("janinoCompile");
        const18.preserve(); const18.preserve();
        const19 = TclString.newInstance("no working compiler driver found");
        const19.preserve(); const19.preserve();
        const20 = TclString.newInstance("java::field");
        const20.preserve(); const20.preserve();
        const21 = TclString.newInstance("class");
        const21.preserve(); const21.preserve();
        const22 = TclString.newInstance("java::new");
        const22.preserve(); const22.preserve();
        const23 = TclInteger.newInstance(1);
        const23.preserve(); const23.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "split";
                break;
            }
            case 2: {
                cmdName = "file";
                break;
            }
            case 3: {
                cmdName = "error";
                break;
            }
            case 4: {
                cmdName = "java::field";
                break;
            }
            case 5: {
                cmdName = "java::new";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "_tjcthread",
        "env",
        "JAVA_INIT",
        "JAVA_CMD",
        "JAVA_DRIVER",
        "JAVA_HOLD_REF",
        "drivers",
        "jar_file",
        "::tcl_platform",
        "sep",
        "jardir",
        "::env",
        "path",
        "driver",
        "file",
        "test_class",
        "test_ctor",
        "java_cmd",
        "err"
    };
} // end class InitJavaCompilerCmd

