// TJC implementation of procedure janinoCompile
package tjc;
import tcl.lang.*;

public class JaninoCompileCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 16, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 3) {
            throw new TclNumArgsException(interp, 1, objv, "filename srccode");
        }
        setVarScalar(interp, "filename", objv[1], compiledLocals, 0);
        setVarScalar(interp, "srccode", objv[2], compiledLocals, 1);
        { // Invoke: global JAVA_INIT
            TJC.makeGlobalLinkVar(interp, "JAVA_INIT", "JAVA_INIT", 2);
        } // End Invoke: global
        { // Invoke: global JAVA_HOLD_REF
            TJC.makeGlobalLinkVar(interp, "JAVA_HOLD_REF", "JAVA_HOLD_REF", 3);
        } // End Invoke: global
        { // Invoke: if {!$JAVA_INIT} ...
            // Unary operator: ! $JAVA_INIT
            TclObject tmp0 = getVarScalar(interp, "JAVA_INIT", compiledLocals, 2);
            ExprValue tmp1 = evs0;
            if ( tmp0.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp1, tmp0);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp1, tmp0);
            }
            // End Unary operator: !
            boolean tmp2 = ( tmp1.getIntValue() != 0 );
            if ( tmp2 ) {
                { // Invoke: error ...
                    TclObject[] objv3 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: error
                        objv3[0] = const0;
                        // Arg 1 constant: ...
                        objv3[1] = const1;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv3, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv3, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: if {$filename == ""} ...
            // Binary operator: $filename == ""
            TclObject tmp4 = getVarScalar(interp, "filename", compiledLocals, 0);
            ExprValue tmp5 = evs0;
            TJC.exprEqualsEmptyString(tmp5, tmp4, false);
            // End Binary operator: ==
            boolean tmp6 = ( tmp5.getIntValue() != 0 );
            if ( tmp6 ) {
                { // Invoke: error ...
                    TclObject[] objv7 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: error
                        objv7[0] = const0;
                        // Arg 1 constant: ...
                        objv7[1] = const2;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv7, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv7, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set cfiles [...]
            TclObject tmp8;
            { // Invoke: $JAVA_HOLD_REF compile $srccode
                TclObject[] objv9 = TJC.grabObjv(interp, 3);
                TclObject tmp10;
                try {
                    // Arg 0 variable: $JAVA_HOLD_REF
                    tmp10 = getVarScalar(interp, "JAVA_HOLD_REF", compiledLocals, 3);
                    tmp10.preserve();
                    objv9[0] = tmp10;
                    // Arg 1 constant: compile
                    objv9[1] = const3;
                    // Arg 2 variable: $srccode
                    tmp10 = getVarScalar(interp, "srccode", compiledLocals, 1);
                    tmp10.preserve();
                    objv9[2] = tmp10;
                    TJC.invoke(interp, null, objv9, 0);
                } finally {
                    tmp10 = objv9[0];
                    if ( tmp10 != null ) {
                        tmp10.release();
                    }
                    tmp10 = objv9[2];
                    if ( tmp10 != null ) {
                        tmp10.release();
                    }
                    TJC.releaseObjv(interp, objv9, 3);
                }
            } // End Invoke: ...
            tmp8 = interp.getResult();
            setVarScalar(interp, "cfiles", tmp8, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set results [...]
            TclObject tmp11;
            { // Invoke: list
                TclObject tmp12 = TclList.newInstance();
                interp.setResult(tmp12);
            } // End Invoke: list
            tmp11 = interp.getResult();
            setVarScalar(interp, "results", tmp11, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set inner [...]
            TclObject tmp13;
            { // Invoke: list
                TclObject tmp14 = TclList.newInstance();
                interp.setResult(tmp14);
            } // End Invoke: list
            tmp13 = interp.getResult();
            setVarScalar(interp, "inner", tmp13, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set len [...]
            TclObject tmp15;
            { // Invoke: $cfiles length
                TclObject[] objv16 = TJC.grabObjv(interp, 2);
                TclObject tmp17;
                try {
                    // Arg 0 variable: $cfiles
                    tmp17 = getVarScalar(interp, "cfiles", compiledLocals, 4);
                    tmp17.preserve();
                    objv16[0] = tmp17;
                    // Arg 1 constant: length
                    objv16[1] = const4;
                    TJC.invoke(interp, null, objv16, 0);
                } finally {
                    tmp17 = objv16[0];
                    if ( tmp17 != null ) {
                        tmp17.release();
                    }
                    TJC.releaseObjv(interp, objv16, 2);
                }
            } // End Invoke: ...
            tmp15 = interp.getResult();
            setVarScalar(interp, "len", tmp15, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: for {set i 0} {$i < $len} {incr i} ...
            { // Invoke: set i 0
                setVarScalar(interp, "i", const5, compiledLocals, 8);
            } // End Invoke: set
            for ( boolean skip23 = true ; true ; ) {
                if ( skip23 ) {
                    skip23 = false;
                } else {
                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: incr i
                        interp.resetResult();
                        incrVarScalar(interp, "i", 1, compiledLocals, 8);
                    } // End Invoke: incr
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else {
                            throw ex;
                        }
                    }
                }

                // Binary operator: $i < $len
                TclObject tmp18 = getVarScalar(interp, "i", compiledLocals, 8);
                ExprValue tmp19 = evs0;
                TJC.exprInitValue(interp, tmp19, tmp18);
                TclObject tmp20 = getVarScalar(interp, "len", compiledLocals, 7);
                ExprValue tmp21 = evs1;
                TJC.exprInitValue(interp, tmp21, tmp20);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp19, tmp21);
                // End Binary operator: <
                boolean tmp22 = ( tmp19.getIntValue() != 0 );
                if ( ! tmp22 ) { break; }

                try {
                if ( false ) { throw (TclException) null; }
                { // Invoke: set cfile [...]
                    TclObject tmp24;
                    { // Invoke: $cfiles get $i
                        TclObject[] objv25 = TJC.grabObjv(interp, 3);
                        TclObject tmp26;
                        try {
                            // Arg 0 variable: $cfiles
                            tmp26 = getVarScalar(interp, "cfiles", compiledLocals, 4);
                            tmp26.preserve();
                            objv25[0] = tmp26;
                            // Arg 1 constant: get
                            objv25[1] = const6;
                            // Arg 2 variable: $i
                            tmp26 = getVarScalar(interp, "i", compiledLocals, 8);
                            tmp26.preserve();
                            objv25[2] = tmp26;
                            TJC.invoke(interp, null, objv25, 0);
                        } finally {
                            tmp26 = objv25[0];
                            if ( tmp26 != null ) {
                                tmp26.release();
                            }
                            tmp26 = objv25[2];
                            if ( tmp26 != null ) {
                                tmp26.release();
                            }
                            TJC.releaseObjv(interp, objv25, 3);
                        }
                    } // End Invoke: ...
                    tmp24 = interp.getResult();
                    setVarScalar(interp, "cfile", tmp24, compiledLocals, 9);
                } // End Invoke: set
                { // Invoke: set class_name [...]
                    TclObject tmp27;
                    { // Invoke: $cfile getThisClassName
                        TclObject[] objv28 = TJC.grabObjv(interp, 2);
                        TclObject tmp29;
                        try {
                            // Arg 0 variable: $cfile
                            tmp29 = getVarScalar(interp, "cfile", compiledLocals, 9);
                            tmp29.preserve();
                            objv28[0] = tmp29;
                            // Arg 1 constant: getThisClassName
                            objv28[1] = const7;
                            TJC.invoke(interp, null, objv28, 0);
                        } finally {
                            tmp29 = objv28[0];
                            if ( tmp29 != null ) {
                                tmp29.release();
                            }
                            TJC.releaseObjv(interp, objv28, 2);
                        }
                    } // End Invoke: ...
                    tmp27 = interp.getResult();
                    setVarScalar(interp, "class_name", tmp27, compiledLocals, 10);
                } // End Invoke: set
                { // Invoke: set class_bytes [...]
                    TclObject tmp30;
                    { // Invoke: $cfile toByteArray
                        TclObject[] objv31 = TJC.grabObjv(interp, 2);
                        TclObject tmp32;
                        try {
                            // Arg 0 variable: $cfile
                            tmp32 = getVarScalar(interp, "cfile", compiledLocals, 9);
                            tmp32.preserve();
                            objv31[0] = tmp32;
                            // Arg 1 constant: toByteArray
                            objv31[1] = const8;
                            TJC.invoke(interp, null, objv31, 0);
                        } finally {
                            tmp32 = objv31[0];
                            if ( tmp32 != null ) {
                                tmp32.release();
                            }
                            TJC.releaseObjv(interp, objv31, 2);
                        }
                    } // End Invoke: ...
                    tmp30 = interp.getResult();
                    setVarScalar(interp, "class_bytes", tmp30, compiledLocals, 11);
                } // End Invoke: set
                { // Invoke: if ... ... else ...
                    // Binary operator: [...] == ()
                    { // Invoke: string first ... $class_name
                        char tmp33 = '$';
                        TclObject tmp34 = getVarScalar(interp, "class_name", compiledLocals, 10);
                        String tmp35 = tmp34.toString();
                        int tmp36 = tmp35.indexOf(tmp33);
                        interp.setResult(tmp36);
                    } // End Invoke: string
                    TclObject tmp37 = interp.getResult();
                    ExprValue tmp38 = evs0;
                    TJC.exprInitValue(interp, tmp38, tmp37);
                    // Unary operator: - 1
                    ExprValue tmp39 = evs1;
                    tmp39.setIntValue(-1);
                    // End Unary operator: -
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp38, tmp39);
                    // End Binary operator: ==
                    boolean tmp40 = ( tmp38.getIntValue() != 0 );
                    if ( tmp40 ) {
                        { // Invoke: lappend results $class_name $class_bytes
                            TclObject[] objv41 = TJC.grabObjv(interp, 2);
                            TclObject tmp42;
                            try {
                                // Arg 2 variable: $class_name
                                tmp42 = getVarScalar(interp, "class_name", compiledLocals, 10);
                                tmp42.preserve();
                                objv41[0] = tmp42;
                                // Arg 3 variable: $class_bytes
                                tmp42 = getVarScalar(interp, "class_bytes", compiledLocals, 11);
                                tmp42.preserve();
                                objv41[1] = tmp42;
                                interp.resetResult();
                                lappendVarScalar(interp, "results", objv41, compiledLocals, 5);
                            } finally {
                                TJC.releaseObjvElems(interp, objv41, 2);
                            }
                        } // End Invoke: lappend
                    } else {
                        { // Invoke: lappend inner $class_name $class_bytes
                            TclObject[] objv43 = TJC.grabObjv(interp, 2);
                            TclObject tmp44;
                            try {
                                // Arg 2 variable: $class_name
                                tmp44 = getVarScalar(interp, "class_name", compiledLocals, 10);
                                tmp44.preserve();
                                objv43[0] = tmp44;
                                // Arg 3 variable: $class_bytes
                                tmp44 = getVarScalar(interp, "class_bytes", compiledLocals, 11);
                                tmp44.preserve();
                                objv43[1] = tmp44;
                                interp.resetResult();
                                lappendVarScalar(interp, "inner", objv43, compiledLocals, 6);
                            } finally {
                                TJC.releaseObjvElems(interp, objv43, 2);
                            }
                        } // End Invoke: lappend
                    }
                } // End Invoke: if
                } catch (TclException ex) {
                    int type = ex.getCompletionCode();
                    if (type == TCL.BREAK) {
                        break;
                    } else if (type == TCL.CONTINUE) {
                        continue;
                    } else {
                        throw ex;
                    }
                }
            }
        } // End Invoke: for
        { // Invoke: if {$inner != {}} ...
            // Binary operator: $inner != ""
            TclObject tmp45 = getVarScalar(interp, "inner", compiledLocals, 6);
            ExprValue tmp46 = evs0;
            TJC.exprEqualsEmptyString(tmp46, tmp45, true);
            // End Binary operator: !=
            boolean tmp47 = ( tmp46.getIntValue() != 0 );
            if ( tmp47 ) {
                { // Invoke: foreach {cname cdata} $inner ...
                    TclObject tmp48 = null;
                    try {
                        tmp48 = getVarScalar(interp, "inner", compiledLocals, 6);
                        tmp48.preserve();
                        final int tmp48_length = TclList.getLength(interp, tmp48);

                        for ( int index49 = 0 ; index49 < tmp48_length ; index49 += 2 ) {
                            TclObject tmp50 = null;
                            if ( index49 < tmp48_length ) {
                                tmp50 = TclList.index(interp, tmp48, index49);
                            }
                            TclObject tmp51 = null;
                            if ( index49 + 1 < tmp48_length ) {
                                tmp51 = TclList.index(interp, tmp48, index49 + 1);
                            }
                            try {
                                if ( tmp50 == null ) {
                                    setVarScalar(interp, "cname", "", compiledLocals, 12);
                                } else {
                                    setVarScalar(interp, "cname", tmp50, compiledLocals, 12);
                                }
                            } catch (TclException ex) {
                                TJC.foreachVarErr(interp, "cname");
                            }
                            try {
                                if ( tmp51 == null ) {
                                    setVarScalar(interp, "cdata", "", compiledLocals, 13);
                                } else {
                                    setVarScalar(interp, "cdata", tmp51, compiledLocals, 13);
                                }
                            } catch (TclException ex) {
                                TJC.foreachVarErr(interp, "cdata");
                            }

                            try {
                            if ( false ) { throw (TclException) null; }
                            { // Invoke: set cnames($cname) $cdata
                                TclObject tmp52;
                                tmp52 = getVarScalar(interp, "cname", compiledLocals, 12);
                                String tmp53 = tmp52.toString();
                                tmp52 = getVarScalar(interp, "cdata", compiledLocals, 13);
                                tmp52 = setVarArray(interp, "cnames", tmp53, tmp52, compiledLocals, 14);
                            } // End Invoke: set
                            } catch (TclException ex) {
                                int type = ex.getCompletionCode();
                                if (type == TCL.BREAK) {
                                    break;
                                } else if (type == TCL.CONTINUE) {
                                    continue;
                                } else {
                                    throw ex;
                                }
                            }
                        }
                    } finally {
                        if ( tmp48 != null ) {
                            tmp48.release();
                        }
                    }
                } // End Invoke: foreach
                { // Invoke: set sorted_cnames [...]
                    TclObject tmp54;
                    { // Invoke: lsort -dictionary [...]
                        TclObject[] objv55 = TJC.grabObjv(interp, 3);
                        TclObject tmp56;
                        try {
                            // Arg 0 constant: lsort
                            objv55[0] = const9;
                            // Arg 1 constant: -dictionary
                            objv55[1] = const10;
                            // Arg 2 command: [...]
                            { // Invoke: array names cnames
                                TclObject[] objv57 = TJC.grabObjv(interp, 3);
                                try {
                                    // Arg 0 constant: array
                                    objv57[0] = const11;
                                    // Arg 1 constant: names
                                    objv57[1] = const12;
                                    // Arg 2 constant: cnames
                                    objv57[2] = const13;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                        ? cmdcache2.cmd : null), objv57, 0);
                                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                        updateCmdCache(interp, 2);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv57, 3);
                                }
                            } // End Invoke: array
                            tmp56 = interp.getResult();
                            tmp56.preserve();
                            objv55[2] = tmp56;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv55, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            tmp56 = objv55[2];
                            if ( tmp56 != null ) {
                                tmp56.release();
                            }
                            TJC.releaseObjv(interp, objv55, 3);
                        }
                    } // End Invoke: lsort
                    tmp54 = interp.getResult();
                    setVarScalar(interp, "sorted_cnames", tmp54, compiledLocals, 15);
                } // End Invoke: set
                { // Invoke: foreach cname $sorted_cnames ...
                    TclObject tmp58 = null;
                    try {
                        tmp58 = getVarScalar(interp, "sorted_cnames", compiledLocals, 15);
                        tmp58.preserve();
                        final int tmp58_length = TclList.getLength(interp, tmp58);

                        for ( int index59 = 0 ; index59 < tmp58_length ; index59++ ) {
                            TclObject tmp60 = TclList.index(interp, tmp58, index59);
                            try {
                                setVarScalar(interp, "cname", tmp60, compiledLocals, 12);
                            } catch (TclException ex) {
                                TJC.foreachVarErr(interp, "cname");
                            }

                            try {
                            if ( false ) { throw (TclException) null; }
                            { // Invoke: lappend results $cname $cnames($cname)
                                TclObject[] objv61 = TJC.grabObjv(interp, 2);
                                TclObject tmp62;
                                try {
                                    // Arg 2 variable: $cname
                                    tmp62 = getVarScalar(interp, "cname", compiledLocals, 12);
                                    tmp62.preserve();
                                    objv61[0] = tmp62;
                                    // Arg 3 variable: $cnames($cname)
                                    tmp62 = getVarScalar(interp, "cname", compiledLocals, 12);
                                    tmp62 = getVarArray(interp, "cnames", tmp62.toString(), compiledLocals, 14);
                                    tmp62.preserve();
                                    objv61[1] = tmp62;
                                    interp.resetResult();
                                    lappendVarScalar(interp, "results", objv61, compiledLocals, 5);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv61, 2);
                                }
                            } // End Invoke: lappend
                            } catch (TclException ex) {
                                int type = ex.getCompletionCode();
                                if (type == TCL.BREAK) {
                                    break;
                                } else if (type == TCL.CONTINUE) {
                                    continue;
                                } else {
                                    throw ex;
                                }
                            }
                        }
                    } finally {
                        if ( tmp58 != null ) {
                            tmp58.release();
                        }
                    }
                } // End Invoke: foreach
            }
        } // End Invoke: if
        { // Invoke: return $results
            TclObject tmp63 = getVarScalar(interp, "results", compiledLocals, 5);
            interp.resetResult();
            interp.setResult(tmp63);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "janinoCompile");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("error");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("JAVA_INIT not set, initJavaCompiler must have been invoked");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("empty string passed as filename");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("compile");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("length");
        const4.preserve(); const4.preserve();
        const5 = TclInteger.newInstance(0);
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("get");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("getThisClassName");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("toByteArray");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("lsort");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("-dictionary");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("array");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("names");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("cnames");
        const13.preserve(); const13.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "error";
                break;
            }
            case 2: {
                cmdName = "array";
                break;
            }
            case 3: {
                cmdName = "lsort";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "filename",
        "srccode",
        "JAVA_INIT",
        "JAVA_HOLD_REF",
        "cfiles",
        "results",
        "inner",
        "len",
        "i",
        "cfile",
        "class_name",
        "class_bytes",
        "cname",
        "cdata",
        "cnames",
        "sorted_cnames"
    };
} // end class JaninoCompileCmd

