// TJC implementation of procedure main
package tjc;
import tcl.lang.*;

public class MainCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 8, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        ExprValue evs2 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "argv");
        }
        setVarScalar(interp, "argv", objv[1], compiledLocals, 0);
        { // Invoke: global argv0 _cmdline _tjc
            TJC.makeGlobalLinkVar(interp, "argv0", "argv0", 1);
            TJC.makeGlobalLinkVar(interp, "_cmdline", "_cmdline", 2);
            TJC.makeGlobalLinkVar(interp, "_tjc", "_tjc", 3);
        } // End Invoke: global
        { // Invoke: set debug 0
            setVarScalar(interp, "debug", const0, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: if {$debug} ...
            TclObject tmp0 = getVarScalar(interp, "debug", compiledLocals, 4);
            boolean tmp1 = TJC.getBoolean(interp, tmp0);
            if ( tmp1 ) {
                { // Invoke: puts ...
                    TclObject[] objv2 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: puts
                        objv2[0] = const1;
                        // Arg 1 constant: ...
                        objv2[1] = const2;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv2, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv2, 2);
                    }
                } // End Invoke: puts
                { // Invoke: puts "..."
                    TclObject[] objv3 = TJC.grabObjv(interp, 2);
                    TclObject tmp4;
                    try {
                        // Arg 0 constant: puts
                        objv3[0] = const1;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp5 = new StringBuffer(64);
                        sbtmp5.append("tjc_root is ");
                        sbtmp5.append("\"");
                        tmp4 = getVarArray(interp, "_tjc", "root", compiledLocals, 3);
                        sbtmp5.append(tmp4.toString());
                        sbtmp5.append("\"");
                        tmp4 = TclString.newInstance(sbtmp5);
                        tmp4.preserve();
                        objv3[1] = tmp4;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv3, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp4 = objv3[1];
                        if ( tmp4 != null ) {
                            tmp4.release();
                        }
                        TJC.releaseObjv(interp, objv3, 2);
                    }
                } // End Invoke: puts
                { // Invoke: puts "cwd is [pwd]"
                    TclObject[] objv6 = TJC.grabObjv(interp, 2);
                    TclObject tmp7;
                    try {
                        // Arg 0 constant: puts
                        objv6[0] = const1;
                        // Arg 1 word: "cwd is [pwd]"
                        StringBuffer sbtmp8 = new StringBuffer(64);
                        sbtmp8.append("cwd is ");
                        { // Invoke: pwd
                            TclObject[] objv9 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: pwd
                                objv9[0] = const3;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                    ? cmdcache2.cmd : null), objv9, 0);
                                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                    updateCmdCache(interp, 2);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv9, 1);
                            }
                        } // End Invoke: pwd
                        tmp7 = interp.getResult();
                        sbtmp8.append(tmp7.toString());
                        tmp7 = TclString.newInstance(sbtmp8);
                        tmp7.preserve();
                        objv6[1] = tmp7;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv6, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp7 = objv6[1];
                        if ( tmp7 != null ) {
                            tmp7.release();
                        }
                        TJC.releaseObjv(interp, objv6, 2);
                    }
                } // End Invoke: puts
                { // Invoke: puts ...
                    TclObject[] objv10 = TJC.grabObjv(interp, 2);
                    TclObject tmp11;
                    try {
                        // Arg 0 constant: puts
                        objv10[0] = const1;
                        // Arg 1 word: ...
                        StringBuffer sbtmp12 = new StringBuffer(64);
                        sbtmp12.append("argv is ");
                        sbtmp12.append("{");
                        tmp11 = getVarScalar(interp, "argv", compiledLocals, 0);
                        sbtmp12.append(tmp11.toString());
                        sbtmp12.append("}");
                        tmp11 = TclString.newInstance(sbtmp12);
                        tmp11.preserve();
                        objv10[1] = tmp11;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv10, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp11 = objv10[1];
                        if ( tmp11 != null ) {
                            tmp11.release();
                        }
                        TJC.releaseObjv(interp, objv10, 2);
                    }
                } // End Invoke: puts
                { // Invoke: puts "..."
                    TclObject[] objv13 = TJC.grabObjv(interp, 2);
                    TclObject tmp14;
                    try {
                        // Arg 0 constant: puts
                        objv13[0] = const1;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp15 = new StringBuffer(64);
                        sbtmp15.append("argv0 is ");
                        sbtmp15.append("{");
                        tmp14 = getVarScalar(interp, "argv0", compiledLocals, 1);
                        sbtmp15.append(tmp14.toString());
                        sbtmp15.append("}");
                        tmp14 = TclString.newInstance(sbtmp15);
                        tmp14.preserve();
                        objv13[1] = tmp14;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv13, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp14 = objv13[1];
                        if ( tmp14 != null ) {
                            tmp14.release();
                        }
                        TJC.releaseObjv(interp, objv13, 2);
                    }
                } // End Invoke: puts
            }
        } // End Invoke: if
        { // Invoke: process_cmdline $argv
            TclObject[] objv16 = TJC.grabObjv(interp, 2);
            TclObject tmp17;
            try {
                // Arg 0 constant: process_cmdline
                objv16[0] = const4;
                // Arg 1 variable: $argv
                tmp17 = getVarScalar(interp, "argv", compiledLocals, 0);
                tmp17.preserve();
                objv16[1] = tmp17;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                    ? cmdcache3.cmd : null), objv16, 0);
                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                    updateCmdCache(interp, 3);
                }
            } finally {
                tmp17 = objv16[1];
                if ( tmp17 != null ) {
                    tmp17.release();
                }
                TJC.releaseObjv(interp, objv16, 2);
            }
        } // End Invoke: process_cmdline
        { // Invoke: if ... ...
            { // Invoke: catch {validate_options} err
                int code18 = TCL.OK;
                try {
                if ( false ) { throw (TclException) null; }
                { // Invoke: validate_options
                    TclObject[] objv19 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: validate_options
                        objv19[0] = const5;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                            ? cmdcache4.cmd : null), objv19, 0);
                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                            updateCmdCache(interp, 4);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv19, 1);
                    }
                } // End Invoke: validate_options
                } catch (TclException ex) {
                    code18 = ex.getCompletionCode();
                }
                TclObject result = interp.getResult();
                try {
                    setVarScalar(interp, "err", result, compiledLocals, 5);
                } catch (TclException ex) {
                    TJC.catchVarErr(interp);
                }
                interp.resetResult();
                interp.setResult(code18);
            } // End Invoke: catch
            TclObject tmp20 = interp.getResult();
            ExprValue tmp21 = evs0;
            TJC.exprInitValue(interp, tmp21, tmp20);
            boolean tmp22 = tmp21.getBooleanValue(interp);
            if ( tmp22 ) {
                { // Invoke: puts stderr $err
                    TclObject[] objv23 = TJC.grabObjv(interp, 3);
                    TclObject tmp24;
                    try {
                        // Arg 0 constant: puts
                        objv23[0] = const1;
                        // Arg 1 constant: stderr
                        objv23[1] = const6;
                        // Arg 2 variable: $err
                        tmp24 = getVarScalar(interp, "err", compiledLocals, 5);
                        tmp24.preserve();
                        objv23[2] = tmp24;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv23, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp24 = objv23[2];
                        if ( tmp24 != null ) {
                            tmp24.release();
                        }
                        TJC.releaseObjv(interp, objv23, 3);
                    }
                } // End Invoke: puts
                { // Invoke: return 1
                    interp.resetResult();
                    interp.setResult(const7);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            // Binary operator: () && ()
            // Unary operator: ! $debug
            TclObject tmp25 = getVarScalar(interp, "debug", compiledLocals, 4);
            ExprValue tmp26 = evs0;
            if ( tmp25.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp26, tmp25);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp26, tmp25);
            }
            // End Unary operator: !
            if (tmp26.getBooleanValue(interp)) {
            // Binary operator: [...] == 0
            { // Invoke: llength $_cmdline(files)
                TclObject tmp27 = getVarArray(interp, "_cmdline", "files", compiledLocals, 2);
                int tmp28 = TclList.getLength(interp, tmp27);
                interp.setResult(tmp28);
            } // End Invoke: llength
            TclObject tmp29 = interp.getResult();
            ExprValue tmp30 = evs1;
            TJC.exprInitValue(interp, tmp30, tmp29);
            ExprValue tmp31 = evs2;
            tmp31.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp30, tmp31);
            // End Binary operator: ==
            tmp26.setIntValue(tmp30.getBooleanValue(interp));
            } else {
            tmp26.setIntValue(0);
            } // End if: ()
            // End Binary operator: &&
            boolean tmp32 = ( tmp26.getIntValue() != 0 );
            if ( tmp32 ) {
                { // Invoke: puts ...
                    TclObject[] objv33 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: puts
                        objv33[0] = const1;
                        // Arg 1 constant: ...
                        objv33[1] = const8;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv33, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv33, 2);
                    }
                } // End Invoke: puts
                { // Invoke: return 1
                    interp.resetResult();
                    interp.setResult(const7);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set ret [...]
            TclObject tmp34;
            { // Invoke: process_jdk_config
                TclObject[] objv35 = TJC.grabObjv(interp, 1);
                try {
                    // Arg 0 constant: process_jdk_config
                    objv35[0] = const9;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                        ? cmdcache5.cmd : null), objv35, 0);
                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                        updateCmdCache(interp, 5);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv35, 1);
                }
            } // End Invoke: process_jdk_config
            tmp34 = interp.getResult();
            setVarScalar(interp, "ret", tmp34, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: if {$ret != 0} ...
            // Binary operator: $ret != 0
            TclObject tmp36 = getVarScalar(interp, "ret", compiledLocals, 6);
            ExprValue tmp37 = evs0;
            TJC.exprInitValue(interp, tmp37, tmp36);
            ExprValue tmp38 = evs1;
            tmp38.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp37, tmp38);
            // End Binary operator: !=
            boolean tmp39 = ( tmp37.getIntValue() != 0 );
            if ( tmp39 ) {
                { // Invoke: return $ret
                    TclObject tmp40 = getVarScalar(interp, "ret", compiledLocals, 6);
                    interp.resetResult();
                    interp.setResult(tmp40);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set ret [...]
            TclObject tmp41;
            { // Invoke: check_jdk_config
                TclObject[] objv42 = TJC.grabObjv(interp, 1);
                try {
                    // Arg 0 constant: check_jdk_config
                    objv42[0] = const10;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                        ? cmdcache6.cmd : null), objv42, 0);
                    if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                        updateCmdCache(interp, 6);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv42, 1);
                }
            } // End Invoke: check_jdk_config
            tmp41 = interp.getResult();
            setVarScalar(interp, "ret", tmp41, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: if {$ret != 0} ...
            // Binary operator: $ret != 0
            TclObject tmp43 = getVarScalar(interp, "ret", compiledLocals, 6);
            ExprValue tmp44 = evs0;
            TJC.exprInitValue(interp, tmp44, tmp43);
            ExprValue tmp45 = evs1;
            tmp45.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp44, tmp45);
            // End Binary operator: !=
            boolean tmp46 = ( tmp44.getIntValue() != 0 );
            if ( tmp46 ) {
                { // Invoke: jdk_tool_cleanup
                    TclObject[] objv47 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: jdk_tool_cleanup
                        objv47[0] = const11;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                            ? cmdcache7.cmd : null), objv47, 0);
                        if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                            updateCmdCache(interp, 7);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv47, 1);
                    }
                } // End Invoke: jdk_tool_cleanup
                { // Invoke: return $ret
                    TclObject tmp48 = getVarScalar(interp, "ret", compiledLocals, 6);
                    interp.resetResult();
                    interp.setResult(tmp48);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: jdk_tool_cleanup
            TclObject[] objv49 = TJC.grabObjv(interp, 1);
            try {
                // Arg 0 constant: jdk_tool_cleanup
                objv49[0] = const11;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                    ? cmdcache7.cmd : null), objv49, 0);
                if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                    updateCmdCache(interp, 7);
                }
            } finally {
                TJC.releaseObjv(interp, objv49, 1);
            }
        } // End Invoke: jdk_tool_cleanup
        { // Invoke: foreach file $_cmdline(files) ...
            TclObject tmp50 = null;
            try {
                tmp50 = getVarArray(interp, "_cmdline", "files", compiledLocals, 2);
                tmp50.preserve();
                final int tmp50_length = TclList.getLength(interp, tmp50);

                for ( int index51 = 0 ; index51 < tmp50_length ; index51++ ) {
                    TclObject tmp52 = TclList.index(interp, tmp50, index51);
                    try {
                        setVarScalar(interp, "file", tmp52, compiledLocals, 7);
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "file");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: set ret [...]
                        TclObject tmp53;
                        { // Invoke: process_module_file $file
                            TclObject[] objv54 = TJC.grabObjv(interp, 2);
                            TclObject tmp55;
                            try {
                                // Arg 0 constant: process_module_file
                                objv54[0] = const12;
                                // Arg 1 variable: $file
                                tmp55 = getVarScalar(interp, "file", compiledLocals, 7);
                                tmp55.preserve();
                                objv54[1] = tmp55;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                    ? cmdcache8.cmd : null), objv54, 0);
                                if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                    updateCmdCache(interp, 8);
                                }
                            } finally {
                                tmp55 = objv54[1];
                                if ( tmp55 != null ) {
                                    tmp55.release();
                                }
                                TJC.releaseObjv(interp, objv54, 2);
                            }
                        } // End Invoke: process_module_file
                        tmp53 = interp.getResult();
                        setVarScalar(interp, "ret", tmp53, compiledLocals, 6);
                    } // End Invoke: set
                    { // Invoke: if {$ret != 0} ...
                        // Binary operator: $ret != 0
                        TclObject tmp56 = getVarScalar(interp, "ret", compiledLocals, 6);
                        ExprValue tmp57 = evs0;
                        TJC.exprInitValue(interp, tmp57, tmp56);
                        ExprValue tmp58 = evs1;
                        tmp58.setIntValue(0);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp57, tmp58);
                        // End Binary operator: !=
                        boolean tmp59 = ( tmp57.getIntValue() != 0 );
                        if ( tmp59 ) {
                            { // Invoke: return $ret
                                TclObject tmp60 = getVarScalar(interp, "ret", compiledLocals, 6);
                                interp.resetResult();
                                interp.setResult(tmp60);
                                if ( true ) { return; }
                            } // End Invoke: return
                        }
                    } // End Invoke: if
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp50 != null ) {
                    tmp50.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: jdk_tool_cleanup
            TclObject[] objv61 = TJC.grabObjv(interp, 1);
            try {
                // Arg 0 constant: jdk_tool_cleanup
                objv61[0] = const11;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                    ? cmdcache7.cmd : null), objv61, 0);
                if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                    updateCmdCache(interp, 7);
                }
            } finally {
                TJC.releaseObjv(interp, objv61, 1);
            }
        } // End Invoke: jdk_tool_cleanup
        { // Invoke: return 0
            interp.resetResult();
            interp.setResult(const0);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "main");
        } finally {
            TJC.exprReleaseValue(interp, evs2);
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclInteger.newInstance(0);
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("puts");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("tjc compiler loaded ...");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("pwd");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("process_cmdline");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("validate_options");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("stderr");
        const6.preserve(); const6.preserve();
        const7 = TclInteger.newInstance(1);
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("usage: tjc module.tjc ...");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("process_jdk_config");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("check_jdk_config");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("jdk_tool_cleanup");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("process_module_file");
        const12.preserve(); const12.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "puts";
                break;
            }
            case 2: {
                cmdName = "pwd";
                break;
            }
            case 3: {
                cmdName = "process_cmdline";
                break;
            }
            case 4: {
                cmdName = "validate_options";
                break;
            }
            case 5: {
                cmdName = "process_jdk_config";
                break;
            }
            case 6: {
                cmdName = "check_jdk_config";
                break;
            }
            case 7: {
                cmdName = "jdk_tool_cleanup";
                break;
            }
            case 8: {
                cmdName = "process_module_file";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "argv",
        "argv0",
        "_cmdline",
        "_tjc",
        "debug",
        "err",
        "ret",
        "file"
    };
} // end class MainCmd

