// TJC implementation of procedure module_looks_like_glob
package tjc;
import tcl.lang.*;

public class ModuleLooksLikeGlobCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 1, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "pat");
        }
        setVarScalar(interp, "pat", objv[1], compiledLocals, 0);
        { // Invoke: if ... ... elseif ... ... elseif ... ... elseif ... ... else ...
            // Binary operator: [...] != ()
            { // Invoke: string first "?" $pat
                char tmp0 = '?';
                TclObject tmp1 = getVarScalar(interp, "pat", compiledLocals, 0);
                String tmp2 = tmp1.toString();
                int tmp3 = tmp2.indexOf(tmp0);
                interp.setResult(tmp3);
            } // End Invoke: string
            TclObject tmp4 = interp.getResult();
            ExprValue tmp5 = evs0;
            TJC.exprInitValue(interp, tmp5, tmp4);
            // Unary operator: - 1
            ExprValue tmp6 = evs1;
            tmp6.setIntValue(-1);
            // End Unary operator: -
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp5, tmp6);
            // End Binary operator: !=
            boolean tmp7 = ( tmp5.getIntValue() != 0 );
            if ( tmp7 ) {
                { // Invoke: return 1
                    interp.resetResult();
                    interp.setResult(const0);
                    if ( true ) { return; }
                } // End Invoke: return
            } else {
                // Binary operator: [...] != ()
                { // Invoke: string first "*" $pat
                    char tmp8 = '*';
                    TclObject tmp9 = getVarScalar(interp, "pat", compiledLocals, 0);
                    String tmp10 = tmp9.toString();
                    int tmp11 = tmp10.indexOf(tmp8);
                    interp.setResult(tmp11);
                } // End Invoke: string
                TclObject tmp12 = interp.getResult();
                ExprValue tmp13 = evs0;
                TJC.exprInitValue(interp, tmp13, tmp12);
                // Unary operator: - 1
                ExprValue tmp14 = evs1;
                tmp14.setIntValue(-1);
                // End Unary operator: -
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp13, tmp14);
                // End Binary operator: !=
                boolean tmp15 = ( tmp13.getIntValue() != 0 );
                if ( tmp15 ) {
                    { // Invoke: return 1
                        interp.resetResult();
                        interp.setResult(const0);
                        if ( true ) { return; }
                    } // End Invoke: return
                } else {
                    // Binary operator: [...] > 0
                    { // Invoke: regexp ... $pat
                        TclObject[] objv16 = TJC.grabObjv(interp, 3);
                        TclObject tmp17;
                        try {
                            // Arg 0 constant: regexp
                            objv16[0] = const1;
                            // Arg 1 constant: ...
                            objv16[1] = const2;
                            // Arg 2 variable: $pat
                            tmp17 = getVarScalar(interp, "pat", compiledLocals, 0);
                            tmp17.preserve();
                            objv16[2] = tmp17;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv16, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            tmp17 = objv16[2];
                            if ( tmp17 != null ) {
                                tmp17.release();
                            }
                            TJC.releaseObjv(interp, objv16, 3);
                        }
                    } // End Invoke: regexp
                    TclObject tmp18 = interp.getResult();
                    ExprValue tmp19 = evs0;
                    TJC.exprInitValue(interp, tmp19, tmp18);
                    ExprValue tmp20 = evs1;
                    tmp20.setIntValue(0);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GREATER, tmp19, tmp20);
                    // End Binary operator: >
                    boolean tmp21 = ( tmp19.getIntValue() != 0 );
                    if ( tmp21 ) {
                        { // Invoke: return 1
                            interp.resetResult();
                            interp.setResult(const0);
                            if ( true ) { return; }
                        } // End Invoke: return
                    } else {
                        // Binary operator: [...] > 0
                        { // Invoke: regexp ... $pat
                            TclObject[] objv22 = TJC.grabObjv(interp, 3);
                            TclObject tmp23;
                            try {
                                // Arg 0 constant: regexp
                                objv22[0] = const1;
                                // Arg 1 constant: ...
                                objv22[1] = const3;
                                // Arg 2 variable: $pat
                                tmp23 = getVarScalar(interp, "pat", compiledLocals, 0);
                                tmp23.preserve();
                                objv22[2] = tmp23;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv22, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                tmp23 = objv22[2];
                                if ( tmp23 != null ) {
                                    tmp23.release();
                                }
                                TJC.releaseObjv(interp, objv22, 3);
                            }
                        } // End Invoke: regexp
                        TclObject tmp24 = interp.getResult();
                        ExprValue tmp25 = evs0;
                        TJC.exprInitValue(interp, tmp25, tmp24);
                        ExprValue tmp26 = evs1;
                        tmp26.setIntValue(0);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GREATER, tmp25, tmp26);
                        // End Binary operator: >
                        boolean tmp27 = ( tmp25.getIntValue() != 0 );
                        if ( tmp27 ) {
                            { // Invoke: return 1
                                interp.resetResult();
                                interp.setResult(const0);
                                if ( true ) { return; }
                            } // End Invoke: return
                        } else {
                            { // Invoke: return 0
                                interp.resetResult();
                                interp.setResult(const4);
                                if ( true ) { return; }
                            } // End Invoke: return
                        }
                    }
                }
            }
        } // End Invoke: if
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "module_looks_like_glob");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclInteger.newInstance(1);
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("regexp");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("\\[.*\\]");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("\\{.*\\}");
        const3.preserve(); const3.preserve();
        const4 = TclInteger.newInstance(0);
        const4.preserve(); const4.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "regexp";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "pat"
    };
} // end class ModuleLooksLikeGlobCmd

