// TJC implementation of procedure parse_is_braced
package tjc;
import tcl.lang.*;

public class ParseIsBracedCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 5, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 3) {
            throw new TclNumArgsException(interp, 1, objv, "script range");
        }
        setVarScalar(interp, "script", objv[1], compiledLocals, 0);
        setVarScalar(interp, "range", objv[2], compiledLocals, 1);
        { // Invoke: set range_text [...]
            TclObject tmp0;
            { // Invoke: parse getstring $script $range
                TclObject[] objv1 = TJC.grabObjv(interp, 4);
                TclObject tmp2;
                try {
                    // Arg 0 constant: parse
                    objv1[0] = const0;
                    // Arg 1 constant: getstring
                    objv1[1] = const1;
                    // Arg 2 variable: $script
                    tmp2 = getVarScalar(interp, "script", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[2] = tmp2;
                    // Arg 3 variable: $range
                    tmp2 = getVarScalar(interp, "range", compiledLocals, 1);
                    tmp2.preserve();
                    objv1[3] = tmp2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[2];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    tmp2 = objv1[3];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 4);
                }
            } // End Invoke: parse
            tmp0 = interp.getResult();
            setVarScalar(interp, "range_text", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set first [...]
            TclObject tmp3;
            { // Invoke: string index $range_text 0
                TclObject tmp4 = getVarScalar(interp, "range_text", compiledLocals, 2);
                String tmp5 = tmp4.toString();
                TclObject tmp6 = TJC.stringIndex(interp, tmp5, const2);
                interp.setResult(tmp6);
            } // End Invoke: string
            tmp3 = interp.getResult();
            setVarScalar(interp, "first", tmp3, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set last [...]
            TclObject tmp7;
            { // Invoke: string index $range_text end
                TclObject tmp8 = getVarScalar(interp, "range_text", compiledLocals, 2);
                String tmp9 = tmp8.toString();
                TclObject tmp10 = TJC.stringIndex(interp, tmp9, const3);
                interp.setResult(tmp10);
            } // End Invoke: string
            tmp7 = interp.getResult();
            setVarScalar(interp, "last", tmp7, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: $first == "{"
            TclObject tmp11 = getVarScalar(interp, "first", compiledLocals, 3);
            boolean tmp12 = tmp11.toString().equals("{");
            ExprValue tmp13 = evs0;
            tmp13.setIntValue(tmp12);
            // End Binary operator: ==
            boolean tmp14 = ( tmp13.getIntValue() != 0 );
            if ( tmp14 ) {
                { // Invoke: if ... ... else ...
                    // Binary operator: $last == "}"
                    TclObject tmp15 = getVarScalar(interp, "last", compiledLocals, 4);
                    boolean tmp16 = tmp15.toString().equals("}");
                    ExprValue tmp17 = evs0;
                    tmp17.setIntValue(tmp16);
                    // End Binary operator: ==
                    boolean tmp18 = ( tmp17.getIntValue() != 0 );
                    if ( tmp18 ) {
                        { // Invoke: return 1
                            interp.resetResult();
                            interp.setResult(const4);
                            if ( true ) { return; }
                        } // End Invoke: return
                    } else {
                        { // Invoke: return 0
                            interp.resetResult();
                            interp.setResult(const2);
                            if ( true ) { return; }
                        } // End Invoke: return
                    }
                } // End Invoke: if
            }
        } // End Invoke: if
        { // Invoke: return 0
            interp.resetResult();
            interp.setResult(const2);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "parse_is_braced");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("parse");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("getstring");
        const1.preserve(); const1.preserve();
        const2 = TclInteger.newInstance(0);
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("end");
        const3.preserve(); const3.preserve();
        const4 = TclInteger.newInstance(1);
        const4.preserve(); const4.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "parse";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "script",
        "range",
        "range_text",
        "first",
        "last"
    };
} // end class ParseIsBracedCmd

