// TJC implementation of procedure parse_is_constant
package tjc;
import tcl.lang.*;

public class ParseIsConstantCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 3, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 3) {
            throw new TclNumArgsException(interp, 1, objv, "script stree");
        }
        setVarScalar(interp, "script", objv[1], compiledLocals, 0);
        setVarScalar(interp, "stree", objv[2], compiledLocals, 1);
        { // Invoke: if ... ...
            { // Invoke: parse_is_simple_text $stree
                TclObject[] objv0 = TJC.grabObjv(interp, 2);
                TclObject tmp1;
                try {
                    // Arg 0 constant: parse_is_simple_text
                    objv0[0] = const0;
                    // Arg 1 variable: $stree
                    tmp1 = getVarScalar(interp, "stree", compiledLocals, 1);
                    tmp1.preserve();
                    objv0[1] = tmp1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv0, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp1 = objv0[1];
                    if ( tmp1 != null ) {
                        tmp1.release();
                    }
                    TJC.releaseObjv(interp, objv0, 2);
                }
            } // End Invoke: parse_is_simple_text
            TclObject tmp2 = interp.getResult();
            ExprValue tmp3 = evs0;
            TJC.exprInitValue(interp, tmp3, tmp2);
            boolean tmp4 = tmp3.getBooleanValue(interp);
            if ( tmp4 ) {
                { // Invoke: return 1
                    interp.resetResult();
                    interp.setResult(const1);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            // Unary operator: ! [...]
            { // Invoke: parse_is_word $stree
                TclObject[] objv5 = TJC.grabObjv(interp, 2);
                TclObject tmp6;
                try {
                    // Arg 0 constant: parse_is_word
                    objv5[0] = const2;
                    // Arg 1 variable: $stree
                    tmp6 = getVarScalar(interp, "stree", compiledLocals, 1);
                    tmp6.preserve();
                    objv5[1] = tmp6;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv5, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp6 = objv5[1];
                    if ( tmp6 != null ) {
                        tmp6.release();
                    }
                    TJC.releaseObjv(interp, objv5, 2);
                }
            } // End Invoke: parse_is_word
            TclObject tmp7 = interp.getResult();
            ExprValue tmp8 = evs0;
            if ( tmp7.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp8, tmp7);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp8, tmp7);
            }
            // End Unary operator: !
            boolean tmp9 = ( tmp8.getIntValue() != 0 );
            if ( tmp9 ) {
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const3);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set result [...]
            TclObject tmp10;
            { // Invoke: parse_word_iterate $script $stree ...
                TclObject[] objv11 = TJC.grabObjv(interp, 4);
                TclObject tmp12;
                try {
                    // Arg 0 constant: parse_word_iterate
                    objv11[0] = const4;
                    // Arg 1 variable: $script
                    tmp12 = getVarScalar(interp, "script", compiledLocals, 0);
                    tmp12.preserve();
                    objv11[1] = tmp12;
                    // Arg 2 variable: $stree
                    tmp12 = getVarScalar(interp, "stree", compiledLocals, 1);
                    tmp12.preserve();
                    objv11[2] = tmp12;
                    // Arg 3 constant: ...
                    objv11[3] = const5;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv11, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp12 = objv11[1];
                    if ( tmp12 != null ) {
                        tmp12.release();
                    }
                    tmp12 = objv11[2];
                    if ( tmp12 != null ) {
                        tmp12.release();
                    }
                    TJC.releaseObjv(interp, objv11, 4);
                }
            } // End Invoke: parse_word_iterate
            tmp10 = interp.getResult();
            setVarScalar(interp, "result", tmp10, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: if ... ... else ...
            // Binary operator: $result == "NONCONSTANT"
            TclObject tmp13 = getVarScalar(interp, "result", compiledLocals, 2);
            boolean tmp14 = tmp13.toString().equals("NONCONSTANT");
            ExprValue tmp15 = evs0;
            tmp15.setIntValue(tmp14);
            // End Binary operator: ==
            boolean tmp16 = ( tmp15.getIntValue() != 0 );
            if ( tmp16 ) {
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const3);
                    if ( true ) { return; }
                } // End Invoke: return
            } else {
                { // Invoke: return 1
                    interp.resetResult();
                    interp.setResult(const1);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "parse_is_constant");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("parse_is_simple_text");
        const0.preserve(); const0.preserve();
        const1 = TclInteger.newInstance(1);
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("parse_is_word");
        const2.preserve(); const2.preserve();
        const3 = TclInteger.newInstance(0);
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("parse_word_iterate");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("_parse_is_constant_word_iterate");
        const5.preserve(); const5.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "parse_is_simple_text";
                break;
            }
            case 2: {
                cmdName = "parse_is_word";
                break;
            }
            case 3: {
                cmdName = "parse_word_iterate";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "script",
        "stree",
        "result"
    };
} // end class ParseIsConstantCmd

