// TJC implementation of procedure parse_is_simple_text
package tjc;
import tcl.lang.*;

public class ParseIsSimpleTextCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 2, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "stree");
        }
        setVarScalar(interp, "stree", objv[1], compiledLocals, 0);
        { // Invoke: if ... ...
            // Binary operator: [...] ne "simple"
            { // Invoke: lindex $stree 0
                TclObject tmp0 = getVarScalar(interp, "stree", compiledLocals, 0);
                tmp0 = TclList.index(interp, tmp0, 0);
                if ( tmp0 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp0);
                }
            } // End Invoke: lindex
            TclObject tmp1 = interp.getResult();
            boolean tmp2 = ! tmp1.toString().equals("simple");
            ExprValue tmp3 = evs0;
            tmp3.setIntValue(tmp2);
            // End Binary operator: ne
            boolean tmp4 = ( tmp3.getIntValue() != 0 );
            if ( tmp4 ) {
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const0);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set range [...]
            TclObject tmp5;
            { // Invoke: lindex $stree 1
                TclObject tmp6 = getVarScalar(interp, "stree", compiledLocals, 0);
                tmp6 = TclList.index(interp, tmp6, 1);
                if ( tmp6 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp6);
                }
            } // End Invoke: lindex
            tmp5 = interp.getResult();
            setVarScalar(interp, "range", tmp5, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: set stree [...]
            TclObject tmp7;
            { // Invoke: lindex $stree 2
                TclObject tmp8 = getVarScalar(interp, "stree", compiledLocals, 0);
                tmp8 = TclList.index(interp, tmp8, 2);
                if ( tmp8 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp8);
                }
            } // End Invoke: lindex
            tmp7 = interp.getResult();
            setVarScalar(interp, "stree", tmp7, compiledLocals, 0);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: [...] != 1
            { // Invoke: llength $stree
                TclObject tmp9 = getVarScalar(interp, "stree", compiledLocals, 0);
                int tmp10 = TclList.getLength(interp, tmp9);
                interp.setResult(tmp10);
            } // End Invoke: llength
            TclObject tmp11 = interp.getResult();
            ExprValue tmp12 = evs0;
            TJC.exprInitValue(interp, tmp12, tmp11);
            ExprValue tmp13 = evs1;
            tmp13.setIntValue(1);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp12, tmp13);
            // End Binary operator: !=
            boolean tmp14 = ( tmp12.getIntValue() != 0 );
            if ( tmp14 ) {
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const0);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set stree [...]
            TclObject tmp15;
            { // Invoke: lindex $stree 0
                TclObject tmp16 = getVarScalar(interp, "stree", compiledLocals, 0);
                tmp16 = TclList.index(interp, tmp16, 0);
                if ( tmp16 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp16);
                }
            } // End Invoke: lindex
            tmp15 = interp.getResult();
            setVarScalar(interp, "stree", tmp15, compiledLocals, 0);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: [...] ne "text"
            { // Invoke: lindex $stree 0
                TclObject tmp17 = getVarScalar(interp, "stree", compiledLocals, 0);
                tmp17 = TclList.index(interp, tmp17, 0);
                if ( tmp17 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp17);
                }
            } // End Invoke: lindex
            TclObject tmp18 = interp.getResult();
            boolean tmp19 = ! tmp18.toString().equals("text");
            ExprValue tmp20 = evs0;
            tmp20.setIntValue(tmp19);
            // End Binary operator: ne
            boolean tmp21 = ( tmp20.getIntValue() != 0 );
            if ( tmp21 ) {
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const0);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            // Binary operator: $range ne [...]
            TclObject tmp22 = getVarScalar(interp, "range", compiledLocals, 1);
            String tmp23 = tmp22.toString();
            { // Invoke: lindex $stree 1
                TclObject tmp24 = getVarScalar(interp, "stree", compiledLocals, 0);
                tmp24 = TclList.index(interp, tmp24, 1);
                if ( tmp24 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp24);
                }
            } // End Invoke: lindex
            TclObject tmp25 = interp.getResult();
            String tmp26 = tmp25.toString();
            boolean tmp27 = ! tmp23.equals(tmp26);
            ExprValue tmp28 = evs0;
            tmp28.setIntValue(tmp27);
            // End Binary operator: ne
            boolean tmp29 = ( tmp28.getIntValue() != 0 );
            if ( tmp29 ) {
                { // Invoke: if ... ...
                    // Unary operator: ! [...]
                    { // Invoke: parse_is_subrange $range [...]
                        TclObject[] objv30 = TJC.grabObjv(interp, 3);
                        TclObject tmp31;
                        try {
                            // Arg 0 constant: parse_is_subrange
                            objv30[0] = const1;
                            // Arg 1 variable: $range
                            tmp31 = getVarScalar(interp, "range", compiledLocals, 1);
                            tmp31.preserve();
                            objv30[1] = tmp31;
                            // Arg 2 command: [...]
                            { // Invoke: lindex $stree 1
                                TclObject tmp32 = getVarScalar(interp, "stree", compiledLocals, 0);
                                tmp32 = TclList.index(interp, tmp32, 1);
                                if ( tmp32 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp32);
                                }
                            } // End Invoke: lindex
                            tmp31 = interp.getResult();
                            tmp31.preserve();
                            objv30[2] = tmp31;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv30, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            tmp31 = objv30[1];
                            if ( tmp31 != null ) {
                                tmp31.release();
                            }
                            tmp31 = objv30[2];
                            if ( tmp31 != null ) {
                                tmp31.release();
                            }
                            TJC.releaseObjv(interp, objv30, 3);
                        }
                    } // End Invoke: parse_is_subrange
                    TclObject tmp33 = interp.getResult();
                    ExprValue tmp34 = evs0;
                    if ( tmp33.isIntType() ) {
                        TJC.exprUnaryNotOperatorKnownInt(tmp34, tmp33);
                    } else {
                        TJC.exprUnaryNotOperator(interp, tmp34, tmp33);
                    }
                    // End Unary operator: !
                    boolean tmp35 = ( tmp34.getIntValue() != 0 );
                    if ( tmp35 ) {
                        { // Invoke: return 0
                            interp.resetResult();
                            interp.setResult(const0);
                            if ( true ) { return; }
                        } // End Invoke: return
                    }
                } // End Invoke: if
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            // Binary operator: [...] ne ""
            { // Invoke: lindex $stree 2
                TclObject tmp36 = getVarScalar(interp, "stree", compiledLocals, 0);
                tmp36 = TclList.index(interp, tmp36, 2);
                if ( tmp36 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp36);
                }
            } // End Invoke: lindex
            TclObject tmp37 = interp.getResult();
            ExprValue tmp38 = evs0;
            TJC.exprEqualsEmptyString(tmp38, tmp37, true);
            // End Binary operator: ne
            boolean tmp39 = ( tmp38.getIntValue() != 0 );
            if ( tmp39 ) {
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const0);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: return 1
            interp.resetResult();
            interp.setResult(const2);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "parse_is_simple_text");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclInteger.newInstance(0);
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("parse_is_subrange");
        const1.preserve(); const1.preserve();
        const2 = TclInteger.newInstance(1);
        const2.preserve(); const2.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "parse_is_subrange";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "stree",
        "range"
    };
} // end class ParseIsSimpleTextCmd

