// TJC implementation of procedure parse_is_word
package tjc;
import tcl.lang.*;

public class ParseIsWordCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 1, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "stree");
        }
        setVarScalar(interp, "stree", objv[1], compiledLocals, 0);
        { // Invoke: if ... ...
            // Unary operator: ! [...]
            { // Invoke: string equal "word" [...]
                String tmp0 = const0.toString();
                { // Invoke: lindex $stree 0
                    TclObject tmp2 = getVarScalar(interp, "stree", compiledLocals, 0);
                    tmp2 = TclList.index(interp, tmp2, 0);
                    if ( tmp2 == null ) {
                        interp.resetResult();
                    } else {
                        interp.setResult(tmp2);
                    }
                } // End Invoke: lindex
                TclObject tmp1 = interp.getResult();
                String tmp3 = tmp1.toString();
                boolean tmp4 = tmp0.equals(tmp3);
                interp.setResult(tmp4);
            } // End Invoke: string
            TclObject tmp5 = interp.getResult();
            ExprValue tmp6 = evs0;
            if ( tmp5.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp6, tmp5);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp6, tmp5);
            }
            // End Unary operator: !
            boolean tmp7 = ( tmp6.getIntValue() != 0 );
            if ( tmp7 ) {
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const1);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: return 1
            interp.resetResult();
            interp.setResult(const2);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "parse_is_word");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("word");
        const0.preserve(); const0.preserve();
        const1 = TclInteger.newInstance(0);
        const1.preserve(); const1.preserve();
        const2 = TclInteger.newInstance(1);
        const2.preserve(); const2.preserve();
    }

    String[] compiledLocalsNames = {
        "stree"
    };
} // end class ParseIsWordCmd

