// TJC implementation of procedure parse_is_word_variable
package tjc;
import tcl.lang.*;

public class ParseIsWordVariableCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 7, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "stree");
        }
        setVarScalar(interp, "stree", objv[1], compiledLocals, 0);
        { // Invoke: set word [...]
            TclObject tmp0;
            { // Invoke: lindex $stree 0
                TclObject tmp1 = getVarScalar(interp, "stree", compiledLocals, 0);
                tmp1 = TclList.index(interp, tmp1, 0);
                if ( tmp1 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp1);
                }
            } // End Invoke: lindex
            tmp0 = interp.getResult();
            setVarScalar(interp, "word", tmp0, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Unary operator: ! [...]
            { // Invoke: string equal "word" $word
                String tmp2 = const0.toString();
                TclObject tmp3 = getVarScalar(interp, "word", compiledLocals, 1);
                String tmp4 = tmp3.toString();
                boolean tmp5 = tmp2.equals(tmp4);
                interp.setResult(tmp5);
            } // End Invoke: string
            TclObject tmp6 = interp.getResult();
            ExprValue tmp7 = evs0;
            if ( tmp6.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp7, tmp6);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp7, tmp6);
            }
            // End Unary operator: !
            boolean tmp8 = ( tmp7.getIntValue() != 0 );
            if ( tmp8 ) {
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const1);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set word_range [...]
            TclObject tmp9;
            { // Invoke: lindex $stree 1
                TclObject tmp10 = getVarScalar(interp, "stree", compiledLocals, 0);
                tmp10 = TclList.index(interp, tmp10, 1);
                if ( tmp10 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp10);
                }
            } // End Invoke: lindex
            tmp9 = interp.getResult();
            setVarScalar(interp, "word_range", tmp9, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set subtree [...]
            TclObject tmp11;
            { // Invoke: lindex $stree 2
                TclObject tmp12 = getVarScalar(interp, "stree", compiledLocals, 0);
                tmp12 = TclList.index(interp, tmp12, 2);
                if ( tmp12 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp12);
                }
            } // End Invoke: lindex
            tmp11 = interp.getResult();
            setVarScalar(interp, "subtree", tmp11, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: [...] != 1
            { // Invoke: llength $subtree
                TclObject tmp13 = getVarScalar(interp, "subtree", compiledLocals, 3);
                int tmp14 = TclList.getLength(interp, tmp13);
                interp.setResult(tmp14);
            } // End Invoke: llength
            TclObject tmp15 = interp.getResult();
            ExprValue tmp16 = evs0;
            TJC.exprInitValue(interp, tmp16, tmp15);
            ExprValue tmp17 = evs1;
            tmp17.setIntValue(1);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp16, tmp17);
            // End Binary operator: !=
            boolean tmp18 = ( tmp16.getIntValue() != 0 );
            if ( tmp18 ) {
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const1);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set variable_tuple [...]
            TclObject tmp19;
            { // Invoke: lindex $subtree 0
                TclObject tmp20 = getVarScalar(interp, "subtree", compiledLocals, 3);
                tmp20 = TclList.index(interp, tmp20, 0);
                if ( tmp20 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp20);
                }
            } // End Invoke: lindex
            tmp19 = interp.getResult();
            setVarScalar(interp, "variable_tuple", tmp19, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set is_variable [...]
            TclObject tmp21;
            { // Invoke: parse_is_variable $variable_tuple
                TclObject[] objv22 = TJC.grabObjv(interp, 2);
                TclObject tmp23;
                try {
                    // Arg 0 constant: parse_is_variable
                    objv22[0] = const2;
                    // Arg 1 variable: $variable_tuple
                    tmp23 = getVarScalar(interp, "variable_tuple", compiledLocals, 4);
                    tmp23.preserve();
                    objv22[1] = tmp23;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv22, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp23 = objv22[1];
                    if ( tmp23 != null ) {
                        tmp23.release();
                    }
                    TJC.releaseObjv(interp, objv22, 2);
                }
            } // End Invoke: parse_is_variable
            tmp21 = interp.getResult();
            setVarScalar(interp, "is_variable", tmp21, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: if {!$is_variable} ...
            // Unary operator: ! $is_variable
            TclObject tmp24 = getVarScalar(interp, "is_variable", compiledLocals, 5);
            ExprValue tmp25 = evs0;
            if ( tmp24.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp25, tmp24);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp25, tmp24);
            }
            // End Unary operator: !
            boolean tmp26 = ( tmp25.getIntValue() != 0 );
            if ( tmp26 ) {
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const1);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set variable_range [...]
            TclObject tmp27;
            { // Invoke: lindex $variable_tuple 1
                TclObject tmp28 = getVarScalar(interp, "variable_tuple", compiledLocals, 4);
                tmp28 = TclList.index(interp, tmp28, 1);
                if ( tmp28 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp28);
                }
            } // End Invoke: lindex
            tmp27 = interp.getResult();
            setVarScalar(interp, "variable_range", tmp27, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: $word_range != $variable_range
            TclObject tmp29 = getVarScalar(interp, "word_range", compiledLocals, 2);
            ExprValue tmp30 = evs0;
            TJC.exprInitValue(interp, tmp30, tmp29);
            TclObject tmp31 = getVarScalar(interp, "variable_range", compiledLocals, 6);
            ExprValue tmp32 = evs1;
            TJC.exprInitValue(interp, tmp32, tmp31);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp30, tmp32);
            // End Binary operator: !=
            boolean tmp33 = ( tmp30.getIntValue() != 0 );
            if ( tmp33 ) {
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const1);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: return 1
            interp.resetResult();
            interp.setResult(const3);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "parse_is_word_variable");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("word");
        const0.preserve(); const0.preserve();
        const1 = TclInteger.newInstance(0);
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("parse_is_variable");
        const2.preserve(); const2.preserve();
        const3 = TclInteger.newInstance(1);
        const3.preserve(); const3.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "parse_is_variable";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "stree",
        "word",
        "word_range",
        "subtree",
        "variable_tuple",
        "is_variable",
        "variable_range"
    };
} // end class ParseIsWordVariableCmd

