// TJC implementation of procedure parseproc_command_finish_callback
package tjc;
import tcl.lang.*;

public class ParseprocCommandFinishCallbackCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 10, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: set debug 0
            setVarScalar(interp, "debug", const0, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: if {$debug} ...
            TclObject tmp0 = getVarScalar(interp, "debug", compiledLocals, 1);
            boolean tmp1 = TJC.getBoolean(interp, tmp0);
            if ( tmp1 ) {
                { // Invoke: puts "..."
                    TclObject[] objv2 = TJC.grabObjv(interp, 2);
                    TclObject tmp3;
                    try {
                        // Arg 0 constant: puts
                        objv2[0] = const1;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp4 = new StringBuffer(64);
                        sbtmp4.append("parseproc_command_finish_callback ");
                        tmp3 = getVarScalar(interp, "key", compiledLocals, 0);
                        sbtmp4.append(tmp3.toString());
                        tmp3 = TclString.newInstance(sbtmp4);
                        tmp3.preserve();
                        objv2[1] = tmp3;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv2, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp3 = objv2[1];
                        if ( tmp3 != null ) {
                            tmp3.release();
                        }
                        TJC.releaseObjv(interp, objv2, 2);
                    }
                } // End Invoke: puts
            }
        } // End Invoke: if
        { // Invoke: set result [...]
            TclObject tmp5;
            { // Invoke: ... $key
                TclObject[] objv6 = TJC.grabObjv(interp, 2);
                TclObject tmp7;
                try {
                    // Arg 0 constant: ...
                    objv6[0] = const2;
                    // Arg 1 variable: $key
                    tmp7 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp7.preserve();
                    objv6[1] = tmp7;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv6, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp7 = objv6[1];
                    if ( tmp7 != null ) {
                        tmp7.release();
                    }
                    TJC.releaseObjv(interp, objv6, 2);
                }
            } // End Invoke: ...
            tmp5 = interp.getResult();
            setVarScalar(interp, "result", tmp5, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set undetermined [...]
            TclObject tmp8;
            { // Invoke: ... $key
                TclObject[] objv9 = TJC.grabObjv(interp, 2);
                TclObject tmp10;
                try {
                    // Arg 0 constant: ...
                    objv9[0] = const3;
                    // Arg 1 variable: $key
                    tmp10 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp10.preserve();
                    objv9[1] = tmp10;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv9, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp10 = objv9[1];
                    if ( tmp10 != null ) {
                        tmp10.release();
                    }
                    TJC.releaseObjv(interp, objv9, 2);
                }
            } // End Invoke: ...
            tmp8 = interp.getResult();
            setVarScalar(interp, "undetermined", tmp8, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: [...] && ()
            { // Invoke: lindex $result 0
                TclObject tmp11 = getVarScalar(interp, "result", compiledLocals, 2);
                tmp11 = TclList.index(interp, tmp11, 0);
                if ( tmp11 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp11);
                }
            } // End Invoke: lindex
            TclObject tmp12 = interp.getResult();
            ExprValue tmp13 = evs0;
            TJC.exprInitValue(interp, tmp13, tmp12);
            if (tmp13.getBooleanValue(interp)) {
            // Unary operator: ! $undetermined
            TclObject tmp14 = getVarScalar(interp, "undetermined", compiledLocals, 3);
            ExprValue tmp15 = evs1;
            if ( tmp14.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp15, tmp14);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp15, tmp14);
            }
            // End Unary operator: !
            tmp13.setIntValue(tmp15.getBooleanValue(interp));
            } else {
            tmp13.setIntValue(0);
            } // End if: [...]
            // End Binary operator: &&
            boolean tmp16 = ( tmp13.getIntValue() != 0 );
            if ( tmp16 ) {
                { // Invoke: set cmdname [...]
                    TclObject tmp17;
                    { // Invoke: lindex $result 1
                        TclObject tmp18 = getVarScalar(interp, "result", compiledLocals, 2);
                        tmp18 = TclList.index(interp, tmp18, 1);
                        if ( tmp18 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp18);
                        }
                    } // End Invoke: lindex
                    tmp17 = interp.getResult();
                    setVarScalar(interp, "cmdname", tmp17, compiledLocals, 4);
                } // End Invoke: set
                { // Invoke: if ... ...
                    // Binary operator: $cmdname == "switch"
                    TclObject tmp19 = getVarScalar(interp, "cmdname", compiledLocals, 4);
                    boolean tmp20 = tmp19.toString().equals("switch");
                    ExprValue tmp21 = evs0;
                    tmp21.setIntValue(tmp20);
                    // End Binary operator: ==
                    boolean tmp22 = ( tmp21.getIntValue() != 0 );
                    if ( tmp22 ) {
                        { // Invoke: if {$debug} ...
                            TclObject tmp23 = getVarScalar(interp, "debug", compiledLocals, 1);
                            boolean tmp24 = TJC.getBoolean(interp, tmp23);
                            if ( tmp24 ) {
                                { // Invoke: puts ...
                                    TclObject[] objv25 = TJC.grabObjv(interp, 2);
                                    try {
                                        // Arg 0 constant: puts
                                        objv25[0] = const1;
                                        // Arg 1 constant: ...
                                        objv25[1] = const4;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                            ? cmdcache1.cmd : null), objv25, 0);
                                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                            updateCmdCache(interp, 1);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv25, 2);
                                    }
                                } // End Invoke: puts
                            }
                        } // End Invoke: if
                        { // Invoke: set script [...]
                            TclObject tmp26;
                            { // Invoke: descend_get_data $key script
                                TclObject[] objv27 = TJC.grabObjv(interp, 3);
                                TclObject tmp28;
                                try {
                                    // Arg 0 constant: descend_get_data
                                    objv27[0] = const5;
                                    // Arg 1 variable: $key
                                    tmp28 = getVarScalar(interp, "key", compiledLocals, 0);
                                    tmp28.preserve();
                                    objv27[1] = tmp28;
                                    // Arg 2 constant: script
                                    objv27[2] = const6;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                        ? cmdcache4.cmd : null), objv27, 0);
                                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                        updateCmdCache(interp, 4);
                                    }
                                } finally {
                                    tmp28 = objv27[1];
                                    if ( tmp28 != null ) {
                                        tmp28.release();
                                    }
                                    TJC.releaseObjv(interp, objv27, 3);
                                }
                            } // End Invoke: descend_get_data
                            tmp26 = interp.getResult();
                            setVarScalar(interp, "script", tmp26, compiledLocals, 5);
                        } // End Invoke: set
                        { // Invoke: set command [...]
                            TclObject tmp29;
                            { // Invoke: descend_get_data $key command
                                TclObject[] objv30 = TJC.grabObjv(interp, 3);
                                TclObject tmp31;
                                try {
                                    // Arg 0 constant: descend_get_data
                                    objv30[0] = const5;
                                    // Arg 1 variable: $key
                                    tmp31 = getVarScalar(interp, "key", compiledLocals, 0);
                                    tmp31.preserve();
                                    objv30[1] = tmp31;
                                    // Arg 2 constant: command
                                    objv30[2] = const7;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                        ? cmdcache4.cmd : null), objv30, 0);
                                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                        updateCmdCache(interp, 4);
                                    }
                                } finally {
                                    tmp31 = objv30[1];
                                    if ( tmp31 != null ) {
                                        tmp31.release();
                                    }
                                    TJC.releaseObjv(interp, objv30, 3);
                                }
                            } // End Invoke: descend_get_data
                            tmp29 = interp.getResult();
                            setVarScalar(interp, "command", tmp29, compiledLocals, 6);
                        } // End Invoke: set
                        { // Invoke: if {$debug} ...
                            TclObject tmp32 = getVarScalar(interp, "debug", compiledLocals, 1);
                            boolean tmp33 = TJC.getBoolean(interp, tmp32);
                            if ( tmp33 ) {
                                { // Invoke: puts ...
                                    TclObject[] objv34 = TJC.grabObjv(interp, 2);
                                    try {
                                        // Arg 0 constant: puts
                                        objv34[0] = const1;
                                        // Arg 1 constant: ...
                                        objv34[1] = const8;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                            ? cmdcache1.cmd : null), objv34, 0);
                                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                            updateCmdCache(interp, 1);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv34, 2);
                                    }
                                } // End Invoke: puts
                                { // Invoke: puts "..."
                                    TclObject[] objv35 = TJC.grabObjv(interp, 2);
                                    TclObject tmp36;
                                    try {
                                        // Arg 0 constant: puts
                                        objv35[0] = const1;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp37 = new StringBuffer(64);
                                        sbtmp37.append("script is ");
                                        sbtmp37.append("\"");
                                        tmp36 = getVarScalar(interp, "script", compiledLocals, 5);
                                        sbtmp37.append(tmp36.toString());
                                        sbtmp37.append("\"");
                                        tmp36 = TclString.newInstance(sbtmp37);
                                        tmp36.preserve();
                                        objv35[1] = tmp36;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                            ? cmdcache1.cmd : null), objv35, 0);
                                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                            updateCmdCache(interp, 1);
                                        }
                                    } finally {
                                        tmp36 = objv35[1];
                                        if ( tmp36 != null ) {
                                            tmp36.release();
                                        }
                                        TJC.releaseObjv(interp, objv35, 2);
                                    }
                                } // End Invoke: puts
                                { // Invoke: puts "..."
                                    TclObject[] objv38 = TJC.grabObjv(interp, 2);
                                    TclObject tmp39;
                                    try {
                                        // Arg 0 constant: puts
                                        objv38[0] = const1;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp40 = new StringBuffer(64);
                                        sbtmp40.append("command range is ");
                                        sbtmp40.append("{");
                                        tmp39 = getVarScalar(interp, "command", compiledLocals, 6);
                                        sbtmp40.append(tmp39.toString());
                                        sbtmp40.append("}");
                                        tmp39 = TclString.newInstance(sbtmp40);
                                        tmp39.preserve();
                                        objv38[1] = tmp39;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                            ? cmdcache1.cmd : null), objv38, 0);
                                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                            updateCmdCache(interp, 1);
                                        }
                                    } finally {
                                        tmp39 = objv38[1];
                                        if ( tmp39 != null ) {
                                            tmp39.release();
                                        }
                                        TJC.releaseObjv(interp, objv38, 2);
                                    }
                                } // End Invoke: puts
                                { // Invoke: puts "..."
                                    TclObject[] objv41 = TJC.grabObjv(interp, 2);
                                    TclObject tmp42;
                                    try {
                                        // Arg 0 constant: puts
                                        objv41[0] = const1;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp43 = new StringBuffer(64);
                                        sbtmp43.append("command text is ");
                                        sbtmp43.append("\"");
                                        { // Invoke: parse getstring $script $command
                                            TclObject[] objv44 = TJC.grabObjv(interp, 4);
                                            TclObject tmp45;
                                            try {
                                                // Arg 0 constant: parse
                                                objv44[0] = const9;
                                                // Arg 1 constant: getstring
                                                objv44[1] = const10;
                                                // Arg 2 variable: $script
                                                tmp45 = getVarScalar(interp, "script", compiledLocals, 5);
                                                tmp45.preserve();
                                                objv44[2] = tmp45;
                                                // Arg 3 variable: $command
                                                tmp45 = getVarScalar(interp, "command", compiledLocals, 6);
                                                tmp45.preserve();
                                                objv44[3] = tmp45;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                                    ? cmdcache5.cmd : null), objv44, 0);
                                                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                                    updateCmdCache(interp, 5);
                                                }
                                            } finally {
                                                tmp45 = objv44[2];
                                                if ( tmp45 != null ) {
                                                    tmp45.release();
                                                }
                                                tmp45 = objv44[3];
                                                if ( tmp45 != null ) {
                                                    tmp45.release();
                                                }
                                                TJC.releaseObjv(interp, objv44, 4);
                                            }
                                        } // End Invoke: parse
                                        tmp42 = interp.getResult();
                                        sbtmp43.append(tmp42.toString());
                                        sbtmp43.append("\"");
                                        tmp42 = TclString.newInstance(sbtmp43);
                                        tmp42.preserve();
                                        objv41[1] = tmp42;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                            ? cmdcache1.cmd : null), objv41, 0);
                                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                            updateCmdCache(interp, 1);
                                        }
                                    } finally {
                                        tmp42 = objv41[1];
                                        if ( tmp42 != null ) {
                                            tmp42.release();
                                        }
                                        TJC.releaseObjv(interp, objv41, 2);
                                    }
                                } // End Invoke: puts
                            }
                        } // End Invoke: if
                        { // Invoke: ... $script $command
                            TclObject[] objv46 = TJC.grabObjv(interp, 3);
                            TclObject tmp47;
                            try {
                                // Arg 0 constant: ...
                                objv46[0] = const11;
                                // Arg 1 variable: $script
                                tmp47 = getVarScalar(interp, "script", compiledLocals, 5);
                                tmp47.preserve();
                                objv46[1] = tmp47;
                                // Arg 2 variable: $command
                                tmp47 = getVarScalar(interp, "command", compiledLocals, 6);
                                tmp47.preserve();
                                objv46[2] = tmp47;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                    ? cmdcache6.cmd : null), objv46, 0);
                                if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                    updateCmdCache(interp, 6);
                                }
                            } finally {
                                tmp47 = objv46[1];
                                if ( tmp47 != null ) {
                                    tmp47.release();
                                }
                                tmp47 = objv46[2];
                                if ( tmp47 != null ) {
                                    tmp47.release();
                                }
                                TJC.releaseObjv(interp, objv46, 3);
                            }
                        } // End Invoke: ...
                        { // Invoke: if {$debug} ...
                            TclObject tmp48 = getVarScalar(interp, "debug", compiledLocals, 1);
                            boolean tmp49 = TJC.getBoolean(interp, tmp48);
                            if ( tmp49 ) {
                                { // Invoke: puts ...
                                    TclObject[] objv50 = TJC.grabObjv(interp, 2);
                                    try {
                                        // Arg 0 constant: puts
                                        objv50[0] = const1;
                                        // Arg 1 constant: ...
                                        objv50[1] = const12;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                            ? cmdcache1.cmd : null), objv50, 0);
                                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                            updateCmdCache(interp, 1);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv50, 2);
                                    }
                                } // End Invoke: puts
                            }
                        } // End Invoke: if
                        { // Invoke: set original_command [...]
                            TclObject tmp51;
                            { // Invoke: descend_get_data $key original_command
                                TclObject[] objv52 = TJC.grabObjv(interp, 3);
                                TclObject tmp53;
                                try {
                                    // Arg 0 constant: descend_get_data
                                    objv52[0] = const5;
                                    // Arg 1 variable: $key
                                    tmp53 = getVarScalar(interp, "key", compiledLocals, 0);
                                    tmp53.preserve();
                                    objv52[1] = tmp53;
                                    // Arg 2 constant: original_command
                                    objv52[2] = const13;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                        ? cmdcache4.cmd : null), objv52, 0);
                                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                        updateCmdCache(interp, 4);
                                    }
                                } finally {
                                    tmp53 = objv52[1];
                                    if ( tmp53 != null ) {
                                        tmp53.release();
                                    }
                                    TJC.releaseObjv(interp, objv52, 3);
                                }
                            } // End Invoke: descend_get_data
                            tmp51 = interp.getResult();
                            setVarScalar(interp, "original_command", tmp51, compiledLocals, 7);
                        } // End Invoke: set
                        { // Invoke: if {$debug} ...
                            TclObject tmp54 = getVarScalar(interp, "debug", compiledLocals, 1);
                            boolean tmp55 = TJC.getBoolean(interp, tmp54);
                            if ( tmp55 ) {
                                { // Invoke: puts "..."
                                    TclObject[] objv56 = TJC.grabObjv(interp, 2);
                                    TclObject tmp57;
                                    try {
                                        // Arg 0 constant: puts
                                        objv56[0] = const1;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp58 = new StringBuffer(64);
                                        sbtmp58.append("resetting processed script range with original command range ");
                                        sbtmp58.append("{");
                                        tmp57 = getVarScalar(interp, "original_command", compiledLocals, 7);
                                        sbtmp58.append(tmp57.toString());
                                        sbtmp58.append("}");
                                        tmp57 = TclString.newInstance(sbtmp58);
                                        tmp57.preserve();
                                        objv56[1] = tmp57;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                            ? cmdcache1.cmd : null), objv56, 0);
                                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                            updateCmdCache(interp, 1);
                                        }
                                    } finally {
                                        tmp57 = objv56[1];
                                        if ( tmp57 != null ) {
                                            tmp57.release();
                                        }
                                        TJC.releaseObjv(interp, objv56, 2);
                                    }
                                } // End Invoke: puts
                            }
                        } // End Invoke: if
                        { // Invoke: set end [...]
                            TclObject tmp59;
                            { // Invoke: expr ...
                                // Binary operator: [...] + [...]
                                { // Invoke: lindex $original_command 0
                                    TclObject tmp60 = getVarScalar(interp, "original_command", compiledLocals, 7);
                                    tmp60 = TclList.index(interp, tmp60, 0);
                                    if ( tmp60 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp60);
                                    }
                                } // End Invoke: lindex
                                TclObject tmp61 = interp.getResult();
                                ExprValue tmp62 = evs0;
                                TJC.exprInitValue(interp, tmp62, tmp61);
                                { // Invoke: lindex $original_command 1
                                    TclObject tmp63 = getVarScalar(interp, "original_command", compiledLocals, 7);
                                    tmp63 = TclList.index(interp, tmp63, 1);
                                    if ( tmp63 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp63);
                                    }
                                } // End Invoke: lindex
                                TclObject tmp64 = interp.getResult();
                                ExprValue tmp65 = evs1;
                                TJC.exprInitValue(interp, tmp65, tmp64);
                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_PLUS, tmp62, tmp65);
                                // End Binary operator: +
                                TJC.exprSetResult(interp, tmp62);
                            } // End Invoke: expr
                            tmp59 = interp.getResult();
                            setVarScalar(interp, "end", tmp59, compiledLocals, 8);
                        } // End Invoke: set
                        { // Invoke: set ... [...]
                            TclObject tmp66;
                            { // Invoke: list 0 $end
                                TclObject tmp67 = TclList.newInstance();
                                TclObject tmp68;
                                try {
                                    TclList.append(interp, tmp67, const0);
                                    tmp68 = getVarScalar(interp, "end", compiledLocals, 8);
                                    TclList.append(interp, tmp67, tmp68);
                                } catch (TclException ex) {
                                    tmp67.release();
                                    throw ex;
                                }
                                interp.setResult(tmp67);
                            } // End Invoke: list
                            tmp66 = interp.getResult();
                            initVarScoped(interp, "::_parseproc", compiledLocals, 9);
                            setVarArray(interp, "::_parseproc", "inscript_range", tmp66, compiledLocals, 9);
                        } // End Invoke: set
                        { // Invoke: if {$debug} ...
                            TclObject tmp69 = getVarScalar(interp, "debug", compiledLocals, 1);
                            boolean tmp70 = TJC.getBoolean(interp, tmp69);
                            if ( tmp70 ) {
                                { // Invoke: puts "..."
                                    TclObject[] objv71 = TJC.grabObjv(interp, 2);
                                    TclObject tmp72;
                                    try {
                                        // Arg 0 constant: puts
                                        objv71[0] = const1;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp73 = new StringBuffer(64);
                                        sbtmp73.append("resetting inscript_range is ");
                                        sbtmp73.append("{");
                                        initVarScoped(interp, "::_parseproc", compiledLocals, 9);
                                        tmp72 = getVarArray(interp, "::_parseproc", "inscript_range", compiledLocals, 9);
                                        sbtmp73.append(tmp72.toString());
                                        sbtmp73.append("}");
                                        tmp72 = TclString.newInstance(sbtmp73);
                                        tmp72.preserve();
                                        objv71[1] = tmp72;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                            ? cmdcache1.cmd : null), objv71, 0);
                                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                            updateCmdCache(interp, 1);
                                        }
                                    } finally {
                                        tmp72 = objv71[1];
                                        if ( tmp72 != null ) {
                                            tmp72.release();
                                        }
                                        TJC.releaseObjv(interp, objv71, 2);
                                    }
                                } // End Invoke: puts
                            } else {
                                interp.resetResult();
                            }
                        } // End Invoke: if
                    } else {
                        interp.resetResult();
                    }
                } // End Invoke: if
            } else {
                interp.resetResult();
            }
        } // End Invoke: if
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "parseproc_command_finish_callback");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclInteger.newInstance(0);
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("puts");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("descend_get_command_name");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("descend_arguments_undetermined");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("finished parsing switch command in parseproc_command_finish_callback");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("descend_get_data");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("script");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("command");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("appending final text for possibly modified switch command");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("parse");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("getstring");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("_parseproc_append_outscript_including");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("done appending final text for possibly modified switch command");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("original_command");
        const13.preserve(); const13.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "puts";
                break;
            }
            case 2: {
                cmdName = "descend_get_command_name";
                break;
            }
            case 3: {
                cmdName = "descend_arguments_undetermined";
                break;
            }
            case 4: {
                cmdName = "descend_get_data";
                break;
            }
            case 5: {
                cmdName = "parse";
                break;
            }
            case 6: {
                cmdName = "_parseproc_append_outscript_including";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "debug",
        "result",
        "undetermined",
        "cmdname",
        "script",
        "command",
        "original_command",
        "end",
        "::_parseproc"
    };
} // end class ParseprocCommandFinishCallbackCmd

