// TJC implementation of procedure parseproc_command_proc
package tjc;
import tcl.lang.*;

public class ParseprocCommandProcCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 44, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 3) {
            throw new TclNumArgsException(interp, 1, objv, "key cmdname");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        setVarScalar(interp, "cmdname", objv[2], compiledLocals, 1);
        { // Invoke: global _parseproc
            TJC.makeGlobalLinkVar(interp, "_parseproc", "_parseproc", 2);
        } // End Invoke: global
        { // Invoke: set debug 0
            setVarScalar(interp, "debug", const0, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: if {$debug} ...
            TclObject tmp0 = getVarScalar(interp, "debug", compiledLocals, 3);
            boolean tmp1 = TJC.getBoolean(interp, tmp0);
            if ( tmp1 ) {
                { // Invoke: puts "..."
                    TclObject[] objv2 = TJC.grabObjv(interp, 2);
                    TclObject tmp3;
                    try {
                        // Arg 0 constant: puts
                        objv2[0] = const1;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp4 = new StringBuffer(64);
                        sbtmp4.append("parseproc_command_proc ");
                        tmp3 = getVarScalar(interp, "key", compiledLocals, 0);
                        sbtmp4.append(tmp3.toString());
                        sbtmp4.append(" ");
                        tmp3 = getVarScalar(interp, "cmdname", compiledLocals, 1);
                        sbtmp4.append(tmp3.toString());
                        tmp3 = TclString.newInstance(sbtmp4);
                        tmp3.preserve();
                        objv2[1] = tmp3;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv2, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp3 = objv2[1];
                        if ( tmp3 != null ) {
                            tmp3.release();
                        }
                        TJC.releaseObjv(interp, objv2, 2);
                    }
                } // End Invoke: puts
            }
        } // End Invoke: if
        { // Invoke: if {$cmdname == "proc"} ...
            // Binary operator: $cmdname == "proc"
            TclObject tmp5 = getVarScalar(interp, "cmdname", compiledLocals, 1);
            boolean tmp6 = tmp5.toString().equals("proc");
            ExprValue tmp7 = evs0;
            tmp7.setIntValue(tmp6);
            // End Binary operator: ==
            boolean tmp8 = ( tmp7.getIntValue() != 0 );
            if ( tmp8 ) {
                { // Invoke: if {$debug} ...
                    TclObject tmp9 = getVarScalar(interp, "debug", compiledLocals, 3);
                    boolean tmp10 = TJC.getBoolean(interp, tmp9);
                    if ( tmp10 ) {
                        { // Invoke: puts ...
                            TclObject[] objv11 = TJC.grabObjv(interp, 2);
                            try {
                                // Arg 0 constant: puts
                                objv11[0] = const1;
                                // Arg 1 constant: ...
                                objv11[1] = const2;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv11, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv11, 2);
                            }
                        } // End Invoke: puts
                    }
                } // End Invoke: if
                { // Invoke: set script [...]
                    TclObject tmp12;
                    { // Invoke: descend_get_data $key script
                        TclObject[] objv13 = TJC.grabObjv(interp, 3);
                        TclObject tmp14;
                        try {
                            // Arg 0 constant: descend_get_data
                            objv13[0] = const3;
                            // Arg 1 variable: $key
                            tmp14 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp14.preserve();
                            objv13[1] = tmp14;
                            // Arg 2 constant: script
                            objv13[2] = const4;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv13, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp14 = objv13[1];
                            if ( tmp14 != null ) {
                                tmp14.release();
                            }
                            TJC.releaseObjv(interp, objv13, 3);
                        }
                    } // End Invoke: descend_get_data
                    tmp12 = interp.getResult();
                    setVarScalar(interp, "script", tmp12, compiledLocals, 4);
                } // End Invoke: set
                { // Invoke: set command_range [...]
                    TclObject tmp15;
                    { // Invoke: descend_get_data $key command
                        TclObject[] objv16 = TJC.grabObjv(interp, 3);
                        TclObject tmp17;
                        try {
                            // Arg 0 constant: descend_get_data
                            objv16[0] = const3;
                            // Arg 1 variable: $key
                            tmp17 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp17.preserve();
                            objv16[1] = tmp17;
                            // Arg 2 constant: command
                            objv16[2] = const5;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv16, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp17 = objv16[1];
                            if ( tmp17 != null ) {
                                tmp17.release();
                            }
                            TJC.releaseObjv(interp, objv16, 3);
                        }
                    } // End Invoke: descend_get_data
                    tmp15 = interp.getResult();
                    setVarScalar(interp, "command_range", tmp15, compiledLocals, 5);
                } // End Invoke: set
                { // Invoke: set tree [...]
                    TclObject tmp18;
                    { // Invoke: descend_get_data $key tree
                        TclObject[] objv19 = TJC.grabObjv(interp, 3);
                        TclObject tmp20;
                        try {
                            // Arg 0 constant: descend_get_data
                            objv19[0] = const3;
                            // Arg 1 variable: $key
                            tmp20 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp20.preserve();
                            objv19[1] = tmp20;
                            // Arg 2 constant: tree
                            objv19[2] = const6;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv19, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp20 = objv19[1];
                            if ( tmp20 != null ) {
                                tmp20.release();
                            }
                            TJC.releaseObjv(interp, objv19, 3);
                        }
                    } // End Invoke: descend_get_data
                    tmp18 = interp.getResult();
                    setVarScalar(interp, "tree", tmp18, compiledLocals, 6);
                } // End Invoke: set
                { // Invoke: set nested [...]
                    TclObject tmp21;
                    { // Invoke: descend_get_data $key nested
                        TclObject[] objv22 = TJC.grabObjv(interp, 3);
                        TclObject tmp23;
                        try {
                            // Arg 0 constant: descend_get_data
                            objv22[0] = const3;
                            // Arg 1 variable: $key
                            tmp23 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp23.preserve();
                            objv22[1] = tmp23;
                            // Arg 2 constant: nested
                            objv22[2] = const7;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv22, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp23 = objv22[1];
                            if ( tmp23 != null ) {
                                tmp23.release();
                            }
                            TJC.releaseObjv(interp, objv22, 3);
                        }
                    } // End Invoke: descend_get_data
                    tmp21 = interp.getResult();
                    setVarScalar(interp, "nested", tmp21, compiledLocals, 7);
                } // End Invoke: set
                { // Invoke: set num_args [...]
                    TclObject tmp24;
                    { // Invoke: llength $tree
                        TclObject tmp25 = getVarScalar(interp, "tree", compiledLocals, 6);
                        int tmp26 = TclList.getLength(interp, tmp25);
                        interp.setResult(tmp26);
                    } // End Invoke: llength
                    tmp24 = interp.getResult();
                    setVarScalar(interp, "num_args", tmp24, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: if {$debug} ...
                    TclObject tmp27 = getVarScalar(interp, "debug", compiledLocals, 3);
                    boolean tmp28 = TJC.getBoolean(interp, tmp27);
                    if ( tmp28 ) {
                        { // Invoke: puts "..."
                            TclObject[] objv29 = TJC.grabObjv(interp, 2);
                            TclObject tmp30;
                            try {
                                // Arg 0 constant: puts
                                objv29[0] = const1;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp31 = new StringBuffer(64);
                                sbtmp31.append("parseproc_command_proc found ");
                                tmp30 = getVarScalar(interp, "num_args", compiledLocals, 8);
                                sbtmp31.append(tmp30.toString());
                                sbtmp31.append(" args to proc command");
                                tmp30 = TclString.newInstance(sbtmp31);
                                tmp30.preserve();
                                objv29[1] = tmp30;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv29, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                tmp30 = objv29[1];
                                if ( tmp30 != null ) {
                                    tmp30.release();
                                }
                                TJC.releaseObjv(interp, objv29, 2);
                            }
                        } // End Invoke: puts
                    }
                } // End Invoke: if
                { // Invoke: set stree [...]
                    TclObject tmp32;
                    { // Invoke: lindex $tree 1
                        TclObject tmp33 = getVarScalar(interp, "tree", compiledLocals, 6);
                        tmp33 = TclList.index(interp, tmp33, 1);
                        if ( tmp33 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp33);
                        }
                    } // End Invoke: lindex
                    tmp32 = interp.getResult();
                    setVarScalar(interp, "stree", tmp32, compiledLocals, 9);
                } // End Invoke: set
                { // Invoke: if ... ... else ...
                    { // Invoke: parse_is_simple_text $stree
                        TclObject[] objv34 = TJC.grabObjv(interp, 2);
                        TclObject tmp35;
                        try {
                            // Arg 0 constant: parse_is_simple_text
                            objv34[0] = const8;
                            // Arg 1 variable: $stree
                            tmp35 = getVarScalar(interp, "stree", compiledLocals, 9);
                            tmp35.preserve();
                            objv34[1] = tmp35;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv34, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            tmp35 = objv34[1];
                            if ( tmp35 != null ) {
                                tmp35.release();
                            }
                            TJC.releaseObjv(interp, objv34, 2);
                        }
                    } // End Invoke: parse_is_simple_text
                    TclObject tmp36 = interp.getResult();
                    ExprValue tmp37 = evs0;
                    TJC.exprInitValue(interp, tmp37, tmp36);
                    boolean tmp38 = tmp37.getBooleanValue(interp);
                    if ( tmp38 ) {
                        { // Invoke: set name_result 1
                            setVarScalar(interp, "name_result", const9, compiledLocals, 10);
                        } // End Invoke: set
                        { // Invoke: set name [...]
                            TclObject tmp39;
                            { // Invoke: ... $script $stree "text"
                                TclObject[] objv40 = TJC.grabObjv(interp, 4);
                                TclObject tmp41;
                                try {
                                    // Arg 0 constant: ...
                                    objv40[0] = const10;
                                    // Arg 1 variable: $script
                                    tmp41 = getVarScalar(interp, "script", compiledLocals, 4);
                                    tmp41.preserve();
                                    objv40[1] = tmp41;
                                    // Arg 2 variable: $stree
                                    tmp41 = getVarScalar(interp, "stree", compiledLocals, 9);
                                    tmp41.preserve();
                                    objv40[2] = tmp41;
                                    // Arg 3 constant: "text"
                                    objv40[3] = const11;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                        ? cmdcache4.cmd : null), objv40, 0);
                                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                        updateCmdCache(interp, 4);
                                    }
                                } finally {
                                    tmp41 = objv40[1];
                                    if ( tmp41 != null ) {
                                        tmp41.release();
                                    }
                                    tmp41 = objv40[2];
                                    if ( tmp41 != null ) {
                                        tmp41.release();
                                    }
                                    TJC.releaseObjv(interp, objv40, 4);
                                }
                            } // End Invoke: ...
                            tmp39 = interp.getResult();
                            setVarScalar(interp, "name", tmp39, compiledLocals, 11);
                        } // End Invoke: set
                    } else {
                        { // Invoke: set name_result 0
                            setVarScalar(interp, "name_result", const0, compiledLocals, 10);
                        } // End Invoke: set
                        { // Invoke: set name ""
                            setVarScalar(interp, "name", const12, compiledLocals, 11);
                        } // End Invoke: set
                    }
                } // End Invoke: if
                { // Invoke: if {$debug} ...
                    TclObject tmp42 = getVarScalar(interp, "debug", compiledLocals, 3);
                    boolean tmp43 = TJC.getBoolean(interp, tmp42);
                    if ( tmp43 ) {
                        { // Invoke: puts "..."
                            TclObject[] objv44 = TJC.grabObjv(interp, 2);
                            TclObject tmp45;
                            try {
                                // Arg 0 constant: puts
                                objv44[0] = const1;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp46 = new StringBuffer(64);
                                sbtmp46.append("name_result is ");
                                tmp45 = getVarScalar(interp, "name_result", compiledLocals, 10);
                                sbtmp46.append(tmp45.toString());
                                sbtmp46.append(", name is ->");
                                tmp45 = getVarScalar(interp, "name", compiledLocals, 11);
                                sbtmp46.append(tmp45.toString());
                                sbtmp46.append("<-");
                                tmp45 = TclString.newInstance(sbtmp46);
                                tmp45.preserve();
                                objv44[1] = tmp45;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv44, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                tmp45 = objv44[1];
                                if ( tmp45 != null ) {
                                    tmp45.release();
                                }
                                TJC.releaseObjv(interp, objv44, 2);
                            }
                        } // End Invoke: puts
                    }
                } // End Invoke: if
                { // Invoke: set stree [...]
                    TclObject tmp47;
                    { // Invoke: lindex $tree 2
                        TclObject tmp48 = getVarScalar(interp, "tree", compiledLocals, 6);
                        tmp48 = TclList.index(interp, tmp48, 2);
                        if ( tmp48 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp48);
                        }
                    } // End Invoke: lindex
                    tmp47 = interp.getResult();
                    setVarScalar(interp, "stree", tmp47, compiledLocals, 9);
                } // End Invoke: set
                { // Invoke: if ... ... else ...
                    { // Invoke: parse_is_constant $script $stree
                        TclObject[] objv49 = TJC.grabObjv(interp, 3);
                        TclObject tmp50;
                        try {
                            // Arg 0 constant: parse_is_constant
                            objv49[0] = const13;
                            // Arg 1 variable: $script
                            tmp50 = getVarScalar(interp, "script", compiledLocals, 4);
                            tmp50.preserve();
                            objv49[1] = tmp50;
                            // Arg 2 variable: $stree
                            tmp50 = getVarScalar(interp, "stree", compiledLocals, 9);
                            tmp50.preserve();
                            objv49[2] = tmp50;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                ? cmdcache5.cmd : null), objv49, 0);
                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                updateCmdCache(interp, 5);
                            }
                        } finally {
                            tmp50 = objv49[1];
                            if ( tmp50 != null ) {
                                tmp50.release();
                            }
                            tmp50 = objv49[2];
                            if ( tmp50 != null ) {
                                tmp50.release();
                            }
                            TJC.releaseObjv(interp, objv49, 3);
                        }
                    } // End Invoke: parse_is_constant
                    TclObject tmp51 = interp.getResult();
                    ExprValue tmp52 = evs0;
                    TJC.exprInitValue(interp, tmp52, tmp51);
                    boolean tmp53 = tmp52.getBooleanValue(interp);
                    if ( tmp53 ) {
                        { // Invoke: set tuple [...]
                            TclObject tmp54;
                            { // Invoke: ... $script $stree
                                TclObject[] objv55 = TJC.grabObjv(interp, 3);
                                TclObject tmp56;
                                try {
                                    // Arg 0 constant: ...
                                    objv55[0] = const14;
                                    // Arg 1 variable: $script
                                    tmp56 = getVarScalar(interp, "script", compiledLocals, 4);
                                    tmp56.preserve();
                                    objv55[1] = tmp56;
                                    // Arg 2 variable: $stree
                                    tmp56 = getVarScalar(interp, "stree", compiledLocals, 9);
                                    tmp56.preserve();
                                    objv55[2] = tmp56;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                        ? cmdcache6.cmd : null), objv55, 0);
                                    if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                        updateCmdCache(interp, 6);
                                    }
                                } finally {
                                    tmp56 = objv55[1];
                                    if ( tmp56 != null ) {
                                        tmp56.release();
                                    }
                                    tmp56 = objv55[2];
                                    if ( tmp56 != null ) {
                                        tmp56.release();
                                    }
                                    TJC.releaseObjv(interp, objv55, 3);
                                }
                            } // End Invoke: ...
                            tmp54 = interp.getResult();
                            setVarScalar(interp, "tuple", tmp54, compiledLocals, 12);
                        } // End Invoke: set
                        { // Invoke: set args [...]
                            TclObject tmp57;
                            { // Invoke: lindex $tuple 0
                                TclObject tmp58 = getVarScalar(interp, "tuple", compiledLocals, 12);
                                tmp58 = TclList.index(interp, tmp58, 0);
                                if ( tmp58 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp58);
                                }
                            } // End Invoke: lindex
                            tmp57 = interp.getResult();
                            setVarScalar(interp, "args", tmp57, compiledLocals, 13);
                        } // End Invoke: set
                        { // Invoke: set args_text [...]
                            TclObject tmp59;
                            { // Invoke: lindex $tuple 2
                                TclObject tmp60 = getVarScalar(interp, "tuple", compiledLocals, 12);
                                tmp60 = TclList.index(interp, tmp60, 2);
                                if ( tmp60 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp60);
                                }
                            } // End Invoke: lindex
                            tmp59 = interp.getResult();
                            setVarScalar(interp, "args_text", tmp59, compiledLocals, 14);
                        } // End Invoke: set
                        { // Invoke: if ... ... else ...
                            // Unary operator: ! [...]
                            { // Invoke: parseproc_args_ok $args
                                TclObject[] objv61 = TJC.grabObjv(interp, 2);
                                TclObject tmp62;
                                try {
                                    // Arg 0 constant: parseproc_args_ok
                                    objv61[0] = const15;
                                    // Arg 1 variable: $args
                                    tmp62 = getVarScalar(interp, "args", compiledLocals, 13);
                                    tmp62.preserve();
                                    objv61[1] = tmp62;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                        ? cmdcache7.cmd : null), objv61, 0);
                                    if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                        updateCmdCache(interp, 7);
                                    }
                                } finally {
                                    tmp62 = objv61[1];
                                    if ( tmp62 != null ) {
                                        tmp62.release();
                                    }
                                    TJC.releaseObjv(interp, objv61, 2);
                                }
                            } // End Invoke: parseproc_args_ok
                            TclObject tmp63 = interp.getResult();
                            ExprValue tmp64 = evs0;
                            if ( tmp63.isIntType() ) {
                                TJC.exprUnaryNotOperatorKnownInt(tmp64, tmp63);
                            } else {
                                TJC.exprUnaryNotOperator(interp, tmp64, tmp63);
                            }
                            // End Unary operator: !
                            boolean tmp65 = ( tmp64.getIntValue() != 0 );
                            if ( tmp65 ) {
                                { // Invoke: set args_result 0
                                    setVarScalar(interp, "args_result", const0, compiledLocals, 15);
                                } // End Invoke: set
                            } else {
                                { // Invoke: set args_result 1
                                    setVarScalar(interp, "args_result", const9, compiledLocals, 15);
                                } // End Invoke: set
                            }
                        } // End Invoke: if
                    } else {
                        { // Invoke: set args_result 0
                            setVarScalar(interp, "args_result", const0, compiledLocals, 15);
                        } // End Invoke: set
                        { // Invoke: set args ""
                            setVarScalar(interp, "args", const12, compiledLocals, 13);
                        } // End Invoke: set
                    }
                } // End Invoke: if
                { // Invoke: if {$debug} ...
                    TclObject tmp66 = getVarScalar(interp, "debug", compiledLocals, 3);
                    boolean tmp67 = TJC.getBoolean(interp, tmp66);
                    if ( tmp67 ) {
                        { // Invoke: puts "..."
                            TclObject[] objv68 = TJC.grabObjv(interp, 2);
                            TclObject tmp69;
                            try {
                                // Arg 0 constant: puts
                                objv68[0] = const1;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp70 = new StringBuffer(64);
                                sbtmp70.append("args_result is ");
                                tmp69 = getVarScalar(interp, "args_result", compiledLocals, 15);
                                sbtmp70.append(tmp69.toString());
                                sbtmp70.append(", args is ->");
                                tmp69 = getVarScalar(interp, "args", compiledLocals, 13);
                                sbtmp70.append(tmp69.toString());
                                sbtmp70.append("<-");
                                tmp69 = TclString.newInstance(sbtmp70);
                                tmp69.preserve();
                                objv68[1] = tmp69;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv68, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                tmp69 = objv68[1];
                                if ( tmp69 != null ) {
                                    tmp69.release();
                                }
                                TJC.releaseObjv(interp, objv68, 2);
                            }
                        } // End Invoke: puts
                    }
                } // End Invoke: if
                { // Invoke: set stree [...]
                    TclObject tmp71;
                    { // Invoke: lindex $tree 3
                        TclObject tmp72 = getVarScalar(interp, "tree", compiledLocals, 6);
                        tmp72 = TclList.index(interp, tmp72, 3);
                        if ( tmp72 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp72);
                        }
                    } // End Invoke: lindex
                    tmp71 = interp.getResult();
                    setVarScalar(interp, "stree", tmp71, compiledLocals, 9);
                } // End Invoke: set
                { // Invoke: if ... ... else ...
                    { // Invoke: parse_is_constant $script $stree
                        TclObject[] objv73 = TJC.grabObjv(interp, 3);
                        TclObject tmp74;
                        try {
                            // Arg 0 constant: parse_is_constant
                            objv73[0] = const13;
                            // Arg 1 variable: $script
                            tmp74 = getVarScalar(interp, "script", compiledLocals, 4);
                            tmp74.preserve();
                            objv73[1] = tmp74;
                            // Arg 2 variable: $stree
                            tmp74 = getVarScalar(interp, "stree", compiledLocals, 9);
                            tmp74.preserve();
                            objv73[2] = tmp74;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                ? cmdcache5.cmd : null), objv73, 0);
                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                updateCmdCache(interp, 5);
                            }
                        } finally {
                            tmp74 = objv73[1];
                            if ( tmp74 != null ) {
                                tmp74.release();
                            }
                            tmp74 = objv73[2];
                            if ( tmp74 != null ) {
                                tmp74.release();
                            }
                            TJC.releaseObjv(interp, objv73, 3);
                        }
                    } // End Invoke: parse_is_constant
                    TclObject tmp75 = interp.getResult();
                    ExprValue tmp76 = evs0;
                    TJC.exprInitValue(interp, tmp76, tmp75);
                    boolean tmp77 = tmp76.getBooleanValue(interp);
                    if ( tmp77 ) {
                        { // Invoke: set tuple [...]
                            TclObject tmp78;
                            { // Invoke: ... $script $stree
                                TclObject[] objv79 = TJC.grabObjv(interp, 3);
                                TclObject tmp80;
                                try {
                                    // Arg 0 constant: ...
                                    objv79[0] = const14;
                                    // Arg 1 variable: $script
                                    tmp80 = getVarScalar(interp, "script", compiledLocals, 4);
                                    tmp80.preserve();
                                    objv79[1] = tmp80;
                                    // Arg 2 variable: $stree
                                    tmp80 = getVarScalar(interp, "stree", compiledLocals, 9);
                                    tmp80.preserve();
                                    objv79[2] = tmp80;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                        ? cmdcache6.cmd : null), objv79, 0);
                                    if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                        updateCmdCache(interp, 6);
                                    }
                                } finally {
                                    tmp80 = objv79[1];
                                    if ( tmp80 != null ) {
                                        tmp80.release();
                                    }
                                    tmp80 = objv79[2];
                                    if ( tmp80 != null ) {
                                        tmp80.release();
                                    }
                                    TJC.releaseObjv(interp, objv79, 3);
                                }
                            } // End Invoke: ...
                            tmp78 = interp.getResult();
                            setVarScalar(interp, "tuple", tmp78, compiledLocals, 12);
                        } // End Invoke: set
                        { // Invoke: set body [...]
                            TclObject tmp81;
                            { // Invoke: lindex $tuple 0
                                TclObject tmp82 = getVarScalar(interp, "tuple", compiledLocals, 12);
                                tmp82 = TclList.index(interp, tmp82, 0);
                                if ( tmp82 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp82);
                                }
                            } // End Invoke: lindex
                            tmp81 = interp.getResult();
                            setVarScalar(interp, "body", tmp81, compiledLocals, 16);
                        } // End Invoke: set
                        { // Invoke: set body_quotes [...]
                            TclObject tmp83;
                            { // Invoke: lindex $tuple 1
                                TclObject tmp84 = getVarScalar(interp, "tuple", compiledLocals, 12);
                                tmp84 = TclList.index(interp, tmp84, 1);
                                if ( tmp84 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp84);
                                }
                            } // End Invoke: lindex
                            tmp83 = interp.getResult();
                            setVarScalar(interp, "body_quotes", tmp83, compiledLocals, 17);
                        } // End Invoke: set
                        { // Invoke: set body_text [...]
                            TclObject tmp85;
                            { // Invoke: lindex $tuple 2
                                TclObject tmp86 = getVarScalar(interp, "tuple", compiledLocals, 12);
                                tmp86 = TclList.index(interp, tmp86, 2);
                                if ( tmp86 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp86);
                                }
                            } // End Invoke: lindex
                            tmp85 = interp.getResult();
                            setVarScalar(interp, "body_text", tmp85, compiledLocals, 18);
                        } // End Invoke: set
                        { // Invoke: if ... ... else ...
                            // Binary operator: $body_quotes == "{}"
                            TclObject tmp87 = getVarScalar(interp, "body_quotes", compiledLocals, 17);
                            boolean tmp88 = tmp87.toString().equals("{}");
                            ExprValue tmp89 = evs0;
                            tmp89.setIntValue(tmp88);
                            // End Binary operator: ==
                            boolean tmp90 = ( tmp89.getIntValue() != 0 );
                            if ( tmp90 ) {
                                { // Invoke: set body_result 1
                                    setVarScalar(interp, "body_result", const9, compiledLocals, 19);
                                } // End Invoke: set
                            } else {
                                { // Invoke: set body_result 0
                                    setVarScalar(interp, "body_result", const0, compiledLocals, 19);
                                } // End Invoke: set
                            }
                        } // End Invoke: if
                    } else {
                        { // Invoke: set body_result 0
                            setVarScalar(interp, "body_result", const0, compiledLocals, 19);
                        } // End Invoke: set
                    }
                } // End Invoke: if
                { // Invoke: if {$debug} ...
                    TclObject tmp91 = getVarScalar(interp, "debug", compiledLocals, 3);
                    boolean tmp92 = TJC.getBoolean(interp, tmp91);
                    if ( tmp92 ) {
                        { // Invoke: puts "..."
                            TclObject[] objv93 = TJC.grabObjv(interp, 2);
                            TclObject tmp94;
                            try {
                                // Arg 0 constant: puts
                                objv93[0] = const1;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp95 = new StringBuffer(64);
                                sbtmp95.append("body_result is ");
                                tmp94 = getVarScalar(interp, "body_result", compiledLocals, 19);
                                sbtmp95.append(tmp94.toString());
                                sbtmp95.append(", body is ->");
                                tmp94 = getVarScalar(interp, "body", compiledLocals, 16);
                                sbtmp95.append(tmp94.toString());
                                sbtmp95.append("<-");
                                tmp94 = TclString.newInstance(sbtmp95);
                                tmp94.preserve();
                                objv93[1] = tmp94;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv93, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                tmp94 = objv93[1];
                                if ( tmp94 != null ) {
                                    tmp94.release();
                                }
                                TJC.releaseObjv(interp, objv93, 2);
                            }
                        } // End Invoke: puts
                    }
                } // End Invoke: if
                { // Invoke: set closing_brace_range [...]
                    TclObject tmp96;
                    { // Invoke: lindex $tree 3 1
                        TclObject[] objv97 = TJC.grabObjv(interp, 4);
                        TclObject tmp98;
                        try {
                            // Arg 0 constant: lindex
                            objv97[0] = const16;
                            // Arg 1 variable: $tree
                            tmp98 = getVarScalar(interp, "tree", compiledLocals, 6);
                            tmp98.preserve();
                            objv97[1] = tmp98;
                            // Arg 2 constant: 3
                            objv97[2] = const17;
                            // Arg 3 constant: 1
                            objv97[3] = const9;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                ? cmdcache8.cmd : null), objv97, 0);
                            if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                updateCmdCache(interp, 8);
                            }
                        } finally {
                            tmp98 = objv97[1];
                            if ( tmp98 != null ) {
                                tmp98.release();
                            }
                            TJC.releaseObjv(interp, objv97, 4);
                        }
                    } // End Invoke: lindex
                    tmp96 = interp.getResult();
                    setVarScalar(interp, "closing_brace_range", tmp96, compiledLocals, 20);
                } // End Invoke: set
                { // Invoke: if ... ... else ...
                    // Binary operator: () && $body_result
                    // Binary operator: () && $args_result
                    // Binary operator: () && $name_result
                    // Binary operator: $num_args == 4
                    TclObject tmp99 = getVarScalar(interp, "num_args", compiledLocals, 8);
                    ExprValue tmp100 = evs0;
                    TJC.exprInitValue(interp, tmp100, tmp99);
                    ExprValue tmp101 = evs1;
                    tmp101.setIntValue(4);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp100, tmp101);
                    // End Binary operator: ==
                    if (tmp100.getBooleanValue(interp)) {
                    TclObject tmp102 = getVarScalar(interp, "name_result", compiledLocals, 10);
                    ExprValue tmp103 = evs1;
                    TJC.exprInitValue(interp, tmp103, tmp102);
                    tmp100.setIntValue(tmp103.getBooleanValue(interp));
                    } else {
                    tmp100.setIntValue(0);
                    } // End if: ()
                    // End Binary operator: &&
                    if (tmp100.getBooleanValue(interp)) {
                    TclObject tmp104 = getVarScalar(interp, "args_result", compiledLocals, 15);
                    ExprValue tmp105 = evs1;
                    TJC.exprInitValue(interp, tmp105, tmp104);
                    tmp100.setIntValue(tmp105.getBooleanValue(interp));
                    } else {
                    tmp100.setIntValue(0);
                    } // End if: ()
                    // End Binary operator: &&
                    if (tmp100.getBooleanValue(interp)) {
                    TclObject tmp106 = getVarScalar(interp, "body_result", compiledLocals, 19);
                    ExprValue tmp107 = evs1;
                    TJC.exprInitValue(interp, tmp107, tmp106);
                    tmp100.setIntValue(tmp107.getBooleanValue(interp));
                    } else {
                    tmp100.setIntValue(0);
                    } // End if: ()
                    // End Binary operator: &&
                    boolean tmp108 = ( tmp100.getIntValue() != 0 );
                    if ( tmp108 ) {
                        { // Invoke: if {$_parseproc(debug)} ...
                            TclObject tmp109 = getVarArray(interp, "_parseproc", "debug", compiledLocals, 2);
                            ExprValue tmp110 = evs0;
                            TJC.exprInitValue(interp, tmp110, tmp109);
                            boolean tmp111 = tmp110.getBooleanValue(interp);
                            if ( tmp111 ) {
                                { // Invoke: if ... ... else ...
                                    // Binary operator: $_parseproc(...) != ""
                                    TclObject tmp112 = getVarArray(interp, "_parseproc", "filename", compiledLocals, 2);
                                    ExprValue tmp113 = evs0;
                                    TJC.exprEqualsEmptyString(tmp113, tmp112, true);
                                    // End Binary operator: !=
                                    boolean tmp114 = ( tmp113.getIntValue() != 0 );
                                    if ( tmp114 ) {
                                        { // Invoke: set fsig "..."
                                            TclObject tmp115;
                                            StringBuffer sbtmp116 = new StringBuffer(64);
                                            tmp115 = getVarArray(interp, "_parseproc", "filename", compiledLocals, 2);
                                            sbtmp116.append(tmp115.toString());
                                            sbtmp116.append(": ");
                                            tmp115 = TclString.newInstance(sbtmp116);
                                            setVarScalar(interp, "fsig", tmp115, compiledLocals, 21);
                                        } // End Invoke: set
                                    } else {
                                        { // Invoke: set fsig ""
                                            setVarScalar(interp, "fsig", const12, compiledLocals, 21);
                                        } // End Invoke: set
                                    }
                                } // End Invoke: if
                                { // Invoke: puts stderr "..."
                                    TclObject[] objv117 = TJC.grabObjv(interp, 3);
                                    TclObject tmp118;
                                    try {
                                        // Arg 0 constant: puts
                                        objv117[0] = const1;
                                        // Arg 1 constant: stderr
                                        objv117[1] = const18;
                                        // Arg 2 word: "..."
                                        StringBuffer sbtmp119 = new StringBuffer(64);
                                        tmp118 = getVarScalar(interp, "fsig", compiledLocals, 21);
                                        sbtmp119.append(tmp118.toString());
                                        sbtmp119.append("parsing proc ");
                                        tmp118 = getVarScalar(interp, "name", compiledLocals, 11);
                                        sbtmp119.append(tmp118.toString());
                                        tmp118 = TclString.newInstance(sbtmp119);
                                        tmp118.preserve();
                                        objv117[2] = tmp118;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                            ? cmdcache1.cmd : null), objv117, 0);
                                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                            updateCmdCache(interp, 1);
                                        }
                                    } finally {
                                        tmp118 = objv117[2];
                                        if ( tmp118 != null ) {
                                            tmp118.release();
                                        }
                                        TJC.releaseObjv(interp, objv117, 3);
                                    }
                                } // End Invoke: puts
                            }
                        } // End Invoke: if
                        { // Invoke: set inscript_start [...]
                            TclObject tmp120;
                            { // Invoke: lindex $... 0
                                TclObject tmp121 = getVarArray(interp, "_parseproc", "inscript_range", compiledLocals, 2);
                                tmp121 = TclList.index(interp, tmp121, 0);
                                if ( tmp121 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp121);
                                }
                            } // End Invoke: lindex
                            tmp120 = interp.getResult();
                            setVarScalar(interp, "inscript_start", tmp120, compiledLocals, 22);
                        } // End Invoke: set
                        { // Invoke: if ... ...
                            // Binary operator: $inscript_start != 0
                            TclObject tmp122 = getVarScalar(interp, "inscript_start", compiledLocals, 22);
                            ExprValue tmp123 = evs0;
                            TJC.exprInitValue(interp, tmp123, tmp122);
                            ExprValue tmp124 = evs1;
                            tmp124.setIntValue(0);
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp123, tmp124);
                            // End Binary operator: !=
                            boolean tmp125 = ( tmp123.getIntValue() != 0 );
                            if ( tmp125 ) {
                                { // Invoke: error "..."
                                    TclObject[] objv126 = TJC.grabObjv(interp, 2);
                                    TclObject tmp127;
                                    try {
                                        // Arg 0 constant: error
                                        objv126[0] = const19;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp128 = new StringBuffer(64);
                                        sbtmp128.append("expected inscript_start to be 0, got ");
                                        tmp127 = getVarScalar(interp, "inscript_start", compiledLocals, 22);
                                        sbtmp128.append(tmp127.toString());
                                        tmp127 = TclString.newInstance(sbtmp128);
                                        tmp127.preserve();
                                        objv126[1] = tmp127;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                                            ? cmdcache9.cmd : null), objv126, 0);
                                        if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                                            updateCmdCache(interp, 9);
                                        }
                                    } finally {
                                        tmp127 = objv126[1];
                                        if ( tmp127 != null ) {
                                            tmp127.release();
                                        }
                                        TJC.releaseObjv(interp, objv126, 2);
                                    }
                                } // End Invoke: error
                            }
                        } // End Invoke: if
                        { // Invoke: set inscript_len [...]
                            TclObject tmp129;
                            { // Invoke: lindex $... 1
                                TclObject tmp130 = getVarArray(interp, "_parseproc", "inscript_range", compiledLocals, 2);
                                tmp130 = TclList.index(interp, tmp130, 1);
                                if ( tmp130 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp130);
                                }
                            } // End Invoke: lindex
                            tmp129 = interp.getResult();
                            setVarScalar(interp, "inscript_len", tmp129, compiledLocals, 23);
                        } // End Invoke: set
                        { // Invoke: set range_start [...]
                            TclObject tmp131;
                            { // Invoke: lindex $command_range 0
                                TclObject tmp132 = getVarScalar(interp, "command_range", compiledLocals, 5);
                                tmp132 = TclList.index(interp, tmp132, 0);
                                if ( tmp132 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp132);
                                }
                            } // End Invoke: lindex
                            tmp131 = interp.getResult();
                            setVarScalar(interp, "range_start", tmp131, compiledLocals, 24);
                        } // End Invoke: set
                        { // Invoke: set range_len [...]
                            TclObject tmp133;
                            { // Invoke: lindex $command_range 1
                                TclObject tmp134 = getVarScalar(interp, "command_range", compiledLocals, 5);
                                tmp134 = TclList.index(interp, tmp134, 1);
                                if ( tmp134 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp134);
                                }
                            } // End Invoke: lindex
                            tmp133 = interp.getResult();
                            setVarScalar(interp, "range_len", tmp133, compiledLocals, 25);
                        } // End Invoke: set
                        { // Invoke: set before_len [...]
                            TclObject tmp135;
                            { // Invoke: expr ...
                                // Binary operator: $range_start - $inscript_len
                                TclObject tmp136 = getVarScalar(interp, "range_start", compiledLocals, 24);
                                ExprValue tmp137 = evs0;
                                TJC.exprInitValue(interp, tmp137, tmp136);
                                TclObject tmp138 = getVarScalar(interp, "inscript_len", compiledLocals, 23);
                                ExprValue tmp139 = evs1;
                                TJC.exprInitValue(interp, tmp139, tmp138);
                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MINUS, tmp137, tmp139);
                                // End Binary operator: -
                                TJC.exprSetResult(interp, tmp137);
                            } // End Invoke: expr
                            tmp135 = interp.getResult();
                            setVarScalar(interp, "before_len", tmp135, compiledLocals, 26);
                        } // End Invoke: set
                        { // Invoke: if {$before_len > 0} ...
                            // Binary operator: $before_len > 0
                            TclObject tmp140 = getVarScalar(interp, "before_len", compiledLocals, 26);
                            ExprValue tmp141 = evs0;
                            TJC.exprInitValue(interp, tmp141, tmp140);
                            ExprValue tmp142 = evs1;
                            tmp142.setIntValue(0);
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GREATER, tmp141, tmp142);
                            // End Binary operator: >
                            boolean tmp143 = ( tmp141.getIntValue() != 0 );
                            if ( tmp143 ) {
                                { // Invoke: set range_before [...]
                                    TclObject tmp144;
                                    { // Invoke: list $inscript_len $before_len
                                        TclObject tmp145 = TclList.newInstance();
                                        TclObject tmp146;
                                        try {
                                            tmp146 = getVarScalar(interp, "inscript_len", compiledLocals, 23);
                                            TclList.append(interp, tmp145, tmp146);
                                            tmp146 = getVarScalar(interp, "before_len", compiledLocals, 26);
                                            TclList.append(interp, tmp145, tmp146);
                                        } catch (TclException ex) {
                                            tmp145.release();
                                            throw ex;
                                        }
                                        interp.setResult(tmp145);
                                    } // End Invoke: list
                                    tmp144 = interp.getResult();
                                    setVarScalar(interp, "range_before", tmp144, compiledLocals, 27);
                                } // End Invoke: set
                                { // Invoke: set range_before_string [...]
                                    TclObject tmp147;
                                    { // Invoke: parse getstring $script $range_before
                                        TclObject[] objv148 = TJC.grabObjv(interp, 4);
                                        TclObject tmp149;
                                        try {
                                            // Arg 0 constant: parse
                                            objv148[0] = const20;
                                            // Arg 1 constant: getstring
                                            objv148[1] = const21;
                                            // Arg 2 variable: $script
                                            tmp149 = getVarScalar(interp, "script", compiledLocals, 4);
                                            tmp149.preserve();
                                            objv148[2] = tmp149;
                                            // Arg 3 variable: $range_before
                                            tmp149 = getVarScalar(interp, "range_before", compiledLocals, 27);
                                            tmp149.preserve();
                                            objv148[3] = tmp149;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                                ? cmdcache10.cmd : null), objv148, 0);
                                            if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                                updateCmdCache(interp, 10);
                                            }
                                        } finally {
                                            tmp149 = objv148[2];
                                            if ( tmp149 != null ) {
                                                tmp149.release();
                                            }
                                            tmp149 = objv148[3];
                                            if ( tmp149 != null ) {
                                                tmp149.release();
                                            }
                                            TJC.releaseObjv(interp, objv148, 4);
                                        }
                                    } // End Invoke: parse
                                    tmp147 = interp.getResult();
                                    setVarScalar(interp, "range_before_string", tmp147, compiledLocals, 28);
                                } // End Invoke: set
                                { // Invoke: append ... $range_before_string
                                    TclObject[] objv150 = TJC.grabObjv(interp, 1);
                                    TclObject tmp151;
                                    try {
                                        // Arg 2 variable: $range_before_string
                                        tmp151 = getVarScalar(interp, "range_before_string", compiledLocals, 28);
                                        tmp151.preserve();
                                        objv150[0] = tmp151;
                                        interp.resetResult();
                                        appendVarArray(interp, "_parseproc", "outscript", objv150, compiledLocals, 2);
                                    } finally {
                                        TJC.releaseObjvElems(interp, objv150, 1);
                                    }
                                } // End Invoke: append
                                { // Invoke: if {$debug} ...
                                    TclObject tmp152 = getVarScalar(interp, "debug", compiledLocals, 3);
                                    boolean tmp153 = TJC.getBoolean(interp, tmp152);
                                    if ( tmp153 ) {
                                        { // Invoke: puts "..."
                                            TclObject[] objv154 = TJC.grabObjv(interp, 2);
                                            TclObject tmp155;
                                            try {
                                                // Arg 0 constant: puts
                                                objv154[0] = const1;
                                                // Arg 1 word: "..."
                                                StringBuffer sbtmp156 = new StringBuffer(64);
                                                sbtmp156.append("range_before is ");
                                                sbtmp156.append("{");
                                                tmp155 = getVarScalar(interp, "range_before", compiledLocals, 27);
                                                sbtmp156.append(tmp155.toString());
                                                sbtmp156.append("}");
                                                tmp155 = TclString.newInstance(sbtmp156);
                                                tmp155.preserve();
                                                objv154[1] = tmp155;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                                    ? cmdcache1.cmd : null), objv154, 0);
                                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                                    updateCmdCache(interp, 1);
                                                }
                                            } finally {
                                                tmp155 = objv154[1];
                                                if ( tmp155 != null ) {
                                                    tmp155.release();
                                                }
                                                TJC.releaseObjv(interp, objv154, 2);
                                            }
                                        } // End Invoke: puts
                                        { // Invoke: puts "..."
                                            TclObject[] objv157 = TJC.grabObjv(interp, 2);
                                            TclObject tmp158;
                                            try {
                                                // Arg 0 constant: puts
                                                objv157[0] = const1;
                                                // Arg 1 word: "..."
                                                StringBuffer sbtmp159 = new StringBuffer(64);
                                                sbtmp159.append("range_before_string is ");
                                                sbtmp159.append("\"");
                                                tmp158 = getVarScalar(interp, "range_before_string", compiledLocals, 28);
                                                sbtmp159.append(tmp158.toString());
                                                sbtmp159.append("\"");
                                                tmp158 = TclString.newInstance(sbtmp159);
                                                tmp158.preserve();
                                                objv157[1] = tmp158;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                                    ? cmdcache1.cmd : null), objv157, 0);
                                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                                    updateCmdCache(interp, 1);
                                                }
                                            } finally {
                                                tmp158 = objv157[1];
                                                if ( tmp158 != null ) {
                                                    tmp158.release();
                                                }
                                                TJC.releaseObjv(interp, objv157, 2);
                                            }
                                        } // End Invoke: puts
                                    }
                                } // End Invoke: if
                            }
                        } // End Invoke: if
                        { // Invoke: set ... [...]
                            TclObject tmp160;
                            { // Invoke: list $inscript_start [...]
                                TclObject tmp161 = TclList.newInstance();
                                TclObject tmp162;
                                try {
                                    tmp162 = getVarScalar(interp, "inscript_start", compiledLocals, 22);
                                    TclList.append(interp, tmp161, tmp162);
                                    { // Invoke: expr ...
                                        // Binary operator: $range_start + $range_len
                                        TclObject tmp163 = getVarScalar(interp, "range_start", compiledLocals, 24);
                                        ExprValue tmp164 = evs0;
                                        TJC.exprInitValue(interp, tmp164, tmp163);
                                        TclObject tmp165 = getVarScalar(interp, "range_len", compiledLocals, 25);
                                        ExprValue tmp166 = evs1;
                                        TJC.exprInitValue(interp, tmp166, tmp165);
                                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_PLUS, tmp164, tmp166);
                                        // End Binary operator: +
                                        TJC.exprSetResult(interp, tmp164);
                                    } // End Invoke: expr
                                    tmp162 = interp.getResult();
                                    TclList.append(interp, tmp161, tmp162);
                                } catch (TclException ex) {
                                    tmp161.release();
                                    throw ex;
                                }
                                interp.setResult(tmp161);
                            } // End Invoke: list
                            tmp160 = interp.getResult();
                            setVarArray(interp, "_parseproc", "inscript_range", tmp160, compiledLocals, 2);
                        } // End Invoke: set
                        { // Invoke: if {$debug} ...
                            TclObject tmp167 = getVarScalar(interp, "debug", compiledLocals, 3);
                            boolean tmp168 = TJC.getBoolean(interp, tmp167);
                            if ( tmp168 ) {
                                { // Invoke: puts "..."
                                    TclObject[] objv169 = TJC.grabObjv(interp, 2);
                                    TclObject tmp170;
                                    try {
                                        // Arg 0 constant: puts
                                        objv169[0] = const1;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp171 = new StringBuffer(64);
                                        sbtmp171.append("prev inscript_range is ");
                                        sbtmp171.append("{");
                                        tmp170 = getVarScalar(interp, "inscript_start", compiledLocals, 22);
                                        sbtmp171.append(tmp170.toString());
                                        sbtmp171.append(" ");
                                        tmp170 = getVarScalar(interp, "inscript_len", compiledLocals, 23);
                                        sbtmp171.append(tmp170.toString());
                                        sbtmp171.append("}");
                                        tmp170 = TclString.newInstance(sbtmp171);
                                        tmp170.preserve();
                                        objv169[1] = tmp170;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                            ? cmdcache1.cmd : null), objv169, 0);
                                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                            updateCmdCache(interp, 1);
                                        }
                                    } finally {
                                        tmp170 = objv169[1];
                                        if ( tmp170 != null ) {
                                            tmp170.release();
                                        }
                                        TJC.releaseObjv(interp, objv169, 2);
                                    }
                                } // End Invoke: puts
                                { // Invoke: puts "..."
                                    TclObject[] objv172 = TJC.grabObjv(interp, 2);
                                    TclObject tmp173;
                                    try {
                                        // Arg 0 constant: puts
                                        objv172[0] = const1;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp174 = new StringBuffer(64);
                                        sbtmp174.append("command range is ");
                                        sbtmp174.append("{");
                                        tmp173 = getVarScalar(interp, "range_start", compiledLocals, 24);
                                        sbtmp174.append(tmp173.toString());
                                        sbtmp174.append(" ");
                                        tmp173 = getVarScalar(interp, "range_len", compiledLocals, 25);
                                        sbtmp174.append(tmp173.toString());
                                        sbtmp174.append("}");
                                        tmp173 = TclString.newInstance(sbtmp174);
                                        tmp173.preserve();
                                        objv172[1] = tmp173;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                            ? cmdcache1.cmd : null), objv172, 0);
                                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                            updateCmdCache(interp, 1);
                                        }
                                    } finally {
                                        tmp173 = objv172[1];
                                        if ( tmp173 != null ) {
                                            tmp173.release();
                                        }
                                        TJC.releaseObjv(interp, objv172, 2);
                                    }
                                } // End Invoke: puts
                                { // Invoke: puts "..."
                                    TclObject[] objv175 = TJC.grabObjv(interp, 2);
                                    TclObject tmp176;
                                    try {
                                        // Arg 0 constant: puts
                                        objv175[0] = const1;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp177 = new StringBuffer(64);
                                        sbtmp177.append("command string is ");
                                        sbtmp177.append("\"");
                                        { // Invoke: parse getstring $script [...]
                                            TclObject[] objv178 = TJC.grabObjv(interp, 4);
                                            TclObject tmp179;
                                            try {
                                                // Arg 0 constant: parse
                                                objv178[0] = const20;
                                                // Arg 1 constant: getstring
                                                objv178[1] = const21;
                                                // Arg 2 variable: $script
                                                tmp179 = getVarScalar(interp, "script", compiledLocals, 4);
                                                tmp179.preserve();
                                                objv178[2] = tmp179;
                                                // Arg 3 command: [...]
                                                { // Invoke: list $range_start $range_len
                                                    TclObject tmp180 = TclList.newInstance();
                                                    TclObject tmp181;
                                                    try {
                                                        tmp181 = getVarScalar(interp, "range_start", compiledLocals, 24);
                                                        TclList.append(interp, tmp180, tmp181);
                                                        tmp181 = getVarScalar(interp, "range_len", compiledLocals, 25);
                                                        TclList.append(interp, tmp180, tmp181);
                                                    } catch (TclException ex) {
                                                        tmp180.release();
                                                        throw ex;
                                                    }
                                                    interp.setResult(tmp180);
                                                } // End Invoke: list
                                                tmp179 = interp.getResult();
                                                tmp179.preserve();
                                                objv178[3] = tmp179;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                                    ? cmdcache10.cmd : null), objv178, 0);
                                                if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                                    updateCmdCache(interp, 10);
                                                }
                                            } finally {
                                                tmp179 = objv178[2];
                                                if ( tmp179 != null ) {
                                                    tmp179.release();
                                                }
                                                tmp179 = objv178[3];
                                                if ( tmp179 != null ) {
                                                    tmp179.release();
                                                }
                                                TJC.releaseObjv(interp, objv178, 4);
                                            }
                                        } // End Invoke: parse
                                        tmp176 = interp.getResult();
                                        sbtmp177.append(tmp176.toString());
                                        sbtmp177.append("\"");
                                        tmp176 = TclString.newInstance(sbtmp177);
                                        tmp176.preserve();
                                        objv175[1] = tmp176;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                            ? cmdcache1.cmd : null), objv175, 0);
                                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                            updateCmdCache(interp, 1);
                                        }
                                    } finally {
                                        tmp176 = objv175[1];
                                        if ( tmp176 != null ) {
                                            tmp176.release();
                                        }
                                        TJC.releaseObjv(interp, objv175, 2);
                                    }
                                } // End Invoke: puts
                                { // Invoke: puts "..."
                                    TclObject[] objv182 = TJC.grabObjv(interp, 2);
                                    TclObject tmp183;
                                    try {
                                        // Arg 0 constant: puts
                                        objv182[0] = const1;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp184 = new StringBuffer(64);
                                        sbtmp184.append("new outscript is ");
                                        sbtmp184.append("\"");
                                        tmp183 = getVarArray(interp, "_parseproc", "outscript", compiledLocals, 2);
                                        sbtmp184.append(tmp183.toString());
                                        sbtmp184.append("\"");
                                        tmp183 = TclString.newInstance(sbtmp184);
                                        tmp183.preserve();
                                        objv182[1] = tmp183;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                            ? cmdcache1.cmd : null), objv182, 0);
                                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                            updateCmdCache(interp, 1);
                                        }
                                    } finally {
                                        tmp183 = objv182[1];
                                        if ( tmp183 != null ) {
                                            tmp183.release();
                                        }
                                        TJC.releaseObjv(interp, objv182, 2);
                                    }
                                } // End Invoke: puts
                                { // Invoke: puts "..."
                                    TclObject[] objv185 = TJC.grabObjv(interp, 2);
                                    TclObject tmp186;
                                    try {
                                        // Arg 0 constant: puts
                                        objv185[0] = const1;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp187 = new StringBuffer(64);
                                        sbtmp187.append("new inscript_range is ");
                                        sbtmp187.append("{");
                                        tmp186 = getVarArray(interp, "_parseproc", "inscript_range", compiledLocals, 2);
                                        sbtmp187.append(tmp186.toString());
                                        sbtmp187.append("}");
                                        tmp186 = TclString.newInstance(sbtmp187);
                                        tmp186.preserve();
                                        objv185[1] = tmp186;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                            ? cmdcache1.cmd : null), objv185, 0);
                                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                            updateCmdCache(interp, 1);
                                        }
                                    } finally {
                                        tmp186 = objv185[1];
                                        if ( tmp186 != null ) {
                                            tmp186.release();
                                        }
                                        TJC.releaseObjv(interp, objv185, 2);
                                    }
                                } // End Invoke: puts
                            }
                        } // End Invoke: if
                        { // Invoke: set procname $name
                            TclObject tmp188;
                            tmp188 = getVarScalar(interp, "name", compiledLocals, 11);
                            setVarScalar(interp, "procname", tmp188, compiledLocals, 29);
                        } // End Invoke: set
                        { // Invoke: set classname [...]
                            TclObject tmp189;
                            { // Invoke: nameproc_generate $name
                                TclObject[] objv190 = TJC.grabObjv(interp, 2);
                                TclObject tmp191;
                                try {
                                    // Arg 0 constant: nameproc_generate
                                    objv190[0] = const22;
                                    // Arg 1 variable: $name
                                    tmp191 = getVarScalar(interp, "name", compiledLocals, 11);
                                    tmp191.preserve();
                                    objv190[1] = tmp191;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache11_cmdEpoch == cmdcache11.cmdEpoch)
                                        ? cmdcache11.cmd : null), objv190, 0);
                                    if ( cmdcache11_cmdEpoch != cmdcache11.cmdEpoch ) {
                                        updateCmdCache(interp, 11);
                                    }
                                } finally {
                                    tmp191 = objv190[1];
                                    if ( tmp191 != null ) {
                                        tmp191.release();
                                    }
                                    TJC.releaseObjv(interp, objv190, 2);
                                }
                            } // End Invoke: nameproc_generate
                            tmp189 = interp.getResult();
                            setVarScalar(interp, "classname", tmp189, compiledLocals, 30);
                        } // End Invoke: set
                        { // Invoke: append ... [...]
                            TclObject[] objv192 = TJC.grabObjv(interp, 1);
                            TclObject tmp193;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: list TJC::command $procname $classname
                                    TclObject tmp194 = TclList.newInstance();
                                    TclObject tmp195;
                                    try {
                                        TclList.append(interp, tmp194, const23);
                                        tmp195 = getVarScalar(interp, "procname", compiledLocals, 29);
                                        TclList.append(interp, tmp194, tmp195);
                                        tmp195 = getVarScalar(interp, "classname", compiledLocals, 30);
                                        TclList.append(interp, tmp194, tmp195);
                                    } catch (TclException ex) {
                                        tmp194.release();
                                        throw ex;
                                    }
                                    interp.setResult(tmp194);
                                } // End Invoke: list
                                tmp193 = interp.getResult();
                                tmp193.preserve();
                                objv192[0] = tmp193;
                                interp.resetResult();
                                appendVarArray(interp, "_parseproc", "outscript", objv192, compiledLocals, 2);
                            } finally {
                                TJC.releaseObjvElems(interp, objv192, 1);
                            }
                        } // End Invoke: append
                        { // Invoke: if {$debug} ...
                            TclObject tmp196 = getVarScalar(interp, "debug", compiledLocals, 3);
                            boolean tmp197 = TJC.getBoolean(interp, tmp196);
                            if ( tmp197 ) {
                                { // Invoke: puts "..."
                                    TclObject[] objv198 = TJC.grabObjv(interp, 2);
                                    TclObject tmp199;
                                    try {
                                        // Arg 0 constant: puts
                                        objv198[0] = const1;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp200 = new StringBuffer(64);
                                        sbtmp200.append("post command create outscript is ");
                                        sbtmp200.append("\"");
                                        tmp199 = getVarArray(interp, "_parseproc", "outscript", compiledLocals, 2);
                                        sbtmp200.append(tmp199.toString());
                                        sbtmp200.append("\"");
                                        tmp199 = TclString.newInstance(sbtmp200);
                                        tmp199.preserve();
                                        objv198[1] = tmp199;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                            ? cmdcache1.cmd : null), objv198, 0);
                                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                            updateCmdCache(interp, 1);
                                        }
                                    } finally {
                                        tmp199 = objv198[1];
                                        if ( tmp199 != null ) {
                                            tmp199.release();
                                        }
                                        TJC.releaseObjv(interp, objv198, 2);
                                    }
                                } // End Invoke: puts
                            }
                        } // End Invoke: if
                        { // Invoke: set last_char_index [...]
                            TclObject tmp201;
                            { // Invoke: expr ...
                                // Binary operator: () - 1
                                // Binary operator: $range_start + $range_len
                                TclObject tmp202 = getVarScalar(interp, "range_start", compiledLocals, 24);
                                ExprValue tmp203 = evs0;
                                TJC.exprInitValue(interp, tmp203, tmp202);
                                TclObject tmp204 = getVarScalar(interp, "range_len", compiledLocals, 25);
                                ExprValue tmp205 = evs1;
                                TJC.exprInitValue(interp, tmp205, tmp204);
                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_PLUS, tmp203, tmp205);
                                // End Binary operator: +
                                ExprValue tmp206 = evs1;
                                tmp206.setIntValue(1);
                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MINUS, tmp203, tmp206);
                                // End Binary operator: -
                                TJC.exprSetResult(interp, tmp203);
                            } // End Invoke: expr
                            tmp201 = interp.getResult();
                            setVarScalar(interp, "last_char_index", tmp201, compiledLocals, 31);
                        } // End Invoke: set
                        { // Invoke: set ... [...]
                            TclObject tmp207;
                            { // Invoke: expr ...
                                // Binary operator: [...] + [...]
                                { // Invoke: lindex $closing_brace_range 0
                                    TclObject tmp208 = getVarScalar(interp, "closing_brace_range", compiledLocals, 20);
                                    tmp208 = TclList.index(interp, tmp208, 0);
                                    if ( tmp208 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp208);
                                    }
                                } // End Invoke: lindex
                                TclObject tmp209 = interp.getResult();
                                ExprValue tmp210 = evs0;
                                TJC.exprInitValue(interp, tmp210, tmp209);
                                { // Invoke: lindex $closing_brace_range 1
                                    TclObject tmp211 = getVarScalar(interp, "closing_brace_range", compiledLocals, 20);
                                    tmp211 = TclList.index(interp, tmp211, 1);
                                    if ( tmp211 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp211);
                                    }
                                } // End Invoke: lindex
                                TclObject tmp212 = interp.getResult();
                                ExprValue tmp213 = evs1;
                                TJC.exprInitValue(interp, tmp213, tmp212);
                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_PLUS, tmp210, tmp213);
                                // End Binary operator: +
                                TJC.exprSetResult(interp, tmp210);
                            } // End Invoke: expr
                            tmp207 = interp.getResult();
                            setVarScalar(interp, "after_closing_brace_index", tmp207, compiledLocals, 32);
                        } // End Invoke: set
                        { // Invoke: if {$debug} ...
                            TclObject tmp214 = getVarScalar(interp, "debug", compiledLocals, 3);
                            boolean tmp215 = TJC.getBoolean(interp, tmp214);
                            if ( tmp215 ) {
                                { // Invoke: puts "..."
                                    TclObject[] objv216 = TJC.grabObjv(interp, 2);
                                    TclObject tmp217;
                                    try {
                                        // Arg 0 constant: puts
                                        objv216[0] = const1;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp218 = new StringBuffer(64);
                                        sbtmp218.append("last_char_index is ");
                                        tmp217 = getVarScalar(interp, "last_char_index", compiledLocals, 31);
                                        sbtmp218.append(tmp217.toString());
                                        tmp217 = TclString.newInstance(sbtmp218);
                                        tmp217.preserve();
                                        objv216[1] = tmp217;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                            ? cmdcache1.cmd : null), objv216, 0);
                                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                            updateCmdCache(interp, 1);
                                        }
                                    } finally {
                                        tmp217 = objv216[1];
                                        if ( tmp217 != null ) {
                                            tmp217.release();
                                        }
                                        TJC.releaseObjv(interp, objv216, 2);
                                    }
                                } // End Invoke: puts
                                { // Invoke: puts "..."
                                    TclObject[] objv219 = TJC.grabObjv(interp, 2);
                                    TclObject tmp220;
                                    try {
                                        // Arg 0 constant: puts
                                        objv219[0] = const1;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp221 = new StringBuffer(64);
                                        sbtmp221.append("after_closing_brace_index is ");
                                        tmp220 = getVarScalar(interp, "after_closing_brace_index", compiledLocals, 32);
                                        sbtmp221.append(tmp220.toString());
                                        tmp220 = TclString.newInstance(sbtmp221);
                                        tmp220.preserve();
                                        objv219[1] = tmp220;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                            ? cmdcache1.cmd : null), objv219, 0);
                                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                            updateCmdCache(interp, 1);
                                        }
                                    } finally {
                                        tmp220 = objv219[1];
                                        if ( tmp220 != null ) {
                                            tmp220.release();
                                        }
                                        TJC.releaseObjv(interp, objv219, 2);
                                    }
                                } // End Invoke: puts
                            }
                        } // End Invoke: if
                        { // Invoke: set post_str ""
                            setVarScalar(interp, "post_str", const12, compiledLocals, 33);
                        } // End Invoke: set
                        { // Invoke: if ... ...
                            // Binary operator: $after_closing_brace_index <= $last_char_index
                            TclObject tmp222 = getVarScalar(interp, "after_closing_brace_index", compiledLocals, 32);
                            ExprValue tmp223 = evs0;
                            TJC.exprInitValue(interp, tmp223, tmp222);
                            TclObject tmp224 = getVarScalar(interp, "last_char_index", compiledLocals, 31);
                            ExprValue tmp225 = evs1;
                            TJC.exprInitValue(interp, tmp225, tmp224);
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LEQ, tmp223, tmp225);
                            // End Binary operator: <=
                            boolean tmp226 = ( tmp223.getIntValue() != 0 );
                            if ( tmp226 ) {
                                { // Invoke: set len [...]
                                    TclObject tmp227;
                                    { // Invoke: expr ...
                                        // Binary operator: () - $after_closing_brace_index
                                        // Binary operator: $last_char_index + 1
                                        TclObject tmp228 = getVarScalar(interp, "last_char_index", compiledLocals, 31);
                                        ExprValue tmp229 = evs0;
                                        TJC.exprInitValue(interp, tmp229, tmp228);
                                        ExprValue tmp230 = evs1;
                                        tmp230.setIntValue(1);
                                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_PLUS, tmp229, tmp230);
                                        // End Binary operator: +
                                        TclObject tmp231 = getVarScalar(interp, "after_closing_brace_index", compiledLocals, 32);
                                        ExprValue tmp232 = evs1;
                                        TJC.exprInitValue(interp, tmp232, tmp231);
                                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MINUS, tmp229, tmp232);
                                        // End Binary operator: -
                                        TJC.exprSetResult(interp, tmp229);
                                    } // End Invoke: expr
                                    tmp227 = interp.getResult();
                                    setVarScalar(interp, "len", tmp227, compiledLocals, 34);
                                } // End Invoke: set
                                { // Invoke: set post_range [...]
                                    TclObject tmp233;
                                    { // Invoke: list $... $len
                                        TclObject tmp234 = TclList.newInstance();
                                        TclObject tmp235;
                                        try {
                                            tmp235 = getVarScalar(interp, "after_closing_brace_index", compiledLocals, 32);
                                            TclList.append(interp, tmp234, tmp235);
                                            tmp235 = getVarScalar(interp, "len", compiledLocals, 34);
                                            TclList.append(interp, tmp234, tmp235);
                                        } catch (TclException ex) {
                                            tmp234.release();
                                            throw ex;
                                        }
                                        interp.setResult(tmp234);
                                    } // End Invoke: list
                                    tmp233 = interp.getResult();
                                    setVarScalar(interp, "post_range", tmp233, compiledLocals, 35);
                                } // End Invoke: set
                                { // Invoke: set post_str [...]
                                    TclObject tmp236;
                                    { // Invoke: parse getstring $script $post_range
                                        TclObject[] objv237 = TJC.grabObjv(interp, 4);
                                        TclObject tmp238;
                                        try {
                                            // Arg 0 constant: parse
                                            objv237[0] = const20;
                                            // Arg 1 constant: getstring
                                            objv237[1] = const21;
                                            // Arg 2 variable: $script
                                            tmp238 = getVarScalar(interp, "script", compiledLocals, 4);
                                            tmp238.preserve();
                                            objv237[2] = tmp238;
                                            // Arg 3 variable: $post_range
                                            tmp238 = getVarScalar(interp, "post_range", compiledLocals, 35);
                                            tmp238.preserve();
                                            objv237[3] = tmp238;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                                ? cmdcache10.cmd : null), objv237, 0);
                                            if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                                updateCmdCache(interp, 10);
                                            }
                                        } finally {
                                            tmp238 = objv237[2];
                                            if ( tmp238 != null ) {
                                                tmp238.release();
                                            }
                                            tmp238 = objv237[3];
                                            if ( tmp238 != null ) {
                                                tmp238.release();
                                            }
                                            TJC.releaseObjv(interp, objv237, 4);
                                        }
                                    } // End Invoke: parse
                                    tmp236 = interp.getResult();
                                    setVarScalar(interp, "post_str", tmp236, compiledLocals, 33);
                                } // End Invoke: set
                                { // Invoke: if {$debug} ...
                                    TclObject tmp239 = getVarScalar(interp, "debug", compiledLocals, 3);
                                    boolean tmp240 = TJC.getBoolean(interp, tmp239);
                                    if ( tmp240 ) {
                                        { // Invoke: puts "..."
                                            TclObject[] objv241 = TJC.grabObjv(interp, 2);
                                            TclObject tmp242;
                                            try {
                                                // Arg 0 constant: puts
                                                objv241[0] = const1;
                                                // Arg 1 word: "..."
                                                StringBuffer sbtmp243 = new StringBuffer(64);
                                                sbtmp243.append("post_range is ");
                                                sbtmp243.append("{");
                                                tmp242 = getVarScalar(interp, "post_range", compiledLocals, 35);
                                                sbtmp243.append(tmp242.toString());
                                                sbtmp243.append("}");
                                                tmp242 = TclString.newInstance(sbtmp243);
                                                tmp242.preserve();
                                                objv241[1] = tmp242;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                                    ? cmdcache1.cmd : null), objv241, 0);
                                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                                    updateCmdCache(interp, 1);
                                                }
                                            } finally {
                                                tmp242 = objv241[1];
                                                if ( tmp242 != null ) {
                                                    tmp242.release();
                                                }
                                                TJC.releaseObjv(interp, objv241, 2);
                                            }
                                        } // End Invoke: puts
                                        { // Invoke: puts "..."
                                            TclObject[] objv244 = TJC.grabObjv(interp, 2);
                                            TclObject tmp245;
                                            try {
                                                // Arg 0 constant: puts
                                                objv244[0] = const1;
                                                // Arg 1 word: "..."
                                                StringBuffer sbtmp246 = new StringBuffer(64);
                                                sbtmp246.append("post_str is ");
                                                sbtmp246.append("\"");
                                                tmp245 = getVarScalar(interp, "post_str", compiledLocals, 33);
                                                sbtmp246.append(tmp245.toString());
                                                sbtmp246.append("\"");
                                                tmp245 = TclString.newInstance(sbtmp246);
                                                tmp245.preserve();
                                                objv244[1] = tmp245;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                                    ? cmdcache1.cmd : null), objv244, 0);
                                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                                    updateCmdCache(interp, 1);
                                                }
                                            } finally {
                                                tmp245 = objv244[1];
                                                if ( tmp245 != null ) {
                                                    tmp245.release();
                                                }
                                                TJC.releaseObjv(interp, objv244, 2);
                                            }
                                        } // End Invoke: puts
                                    }
                                } // End Invoke: if
                            }
                        } // End Invoke: if
                        { // Invoke: set last_char_range [...]
                            TclObject tmp247;
                            { // Invoke: list $last_char_index 1
                                TclObject tmp248 = TclList.newInstance();
                                TclObject tmp249;
                                try {
                                    tmp249 = getVarScalar(interp, "last_char_index", compiledLocals, 31);
                                    TclList.append(interp, tmp248, tmp249);
                                    TclList.append(interp, tmp248, const9);
                                } catch (TclException ex) {
                                    tmp248.release();
                                    throw ex;
                                }
                                interp.setResult(tmp248);
                            } // End Invoke: list
                            tmp247 = interp.getResult();
                            setVarScalar(interp, "last_char_range", tmp247, compiledLocals, 36);
                        } // End Invoke: set
                        { // Invoke: set last_char_string [...]
                            TclObject tmp250;
                            { // Invoke: parse getstring $script $last_char_range
                                TclObject[] objv251 = TJC.grabObjv(interp, 4);
                                TclObject tmp252;
                                try {
                                    // Arg 0 constant: parse
                                    objv251[0] = const20;
                                    // Arg 1 constant: getstring
                                    objv251[1] = const21;
                                    // Arg 2 variable: $script
                                    tmp252 = getVarScalar(interp, "script", compiledLocals, 4);
                                    tmp252.preserve();
                                    objv251[2] = tmp252;
                                    // Arg 3 variable: $last_char_range
                                    tmp252 = getVarScalar(interp, "last_char_range", compiledLocals, 36);
                                    tmp252.preserve();
                                    objv251[3] = tmp252;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                        ? cmdcache10.cmd : null), objv251, 0);
                                    if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                        updateCmdCache(interp, 10);
                                    }
                                } finally {
                                    tmp252 = objv251[2];
                                    if ( tmp252 != null ) {
                                        tmp252.release();
                                    }
                                    tmp252 = objv251[3];
                                    if ( tmp252 != null ) {
                                        tmp252.release();
                                    }
                                    TJC.releaseObjv(interp, objv251, 4);
                                }
                            } // End Invoke: parse
                            tmp250 = interp.getResult();
                            setVarScalar(interp, "last_char_string", tmp250, compiledLocals, 37);
                        } // End Invoke: set
                        { // Invoke: if ... ... else ...
                            // Binary operator: $last_char_string == "\n"
                            TclObject tmp253 = getVarScalar(interp, "last_char_string", compiledLocals, 37);
                            boolean tmp254 = tmp253.toString().equals("\n");
                            ExprValue tmp255 = evs0;
                            tmp255.setIntValue(tmp254);
                            // End Binary operator: ==
                            boolean tmp256 = ( tmp255.getIntValue() != 0 );
                            if ( tmp256 ) {
                                { // Invoke: set last_char_is_newline 1
                                    setVarScalar(interp, "last_char_is_newline", const9, compiledLocals, 38);
                                } // End Invoke: set
                            } else {
                                { // Invoke: set last_char_is_newline 0
                                    setVarScalar(interp, "last_char_is_newline", const0, compiledLocals, 38);
                                } // End Invoke: set
                            }
                        } // End Invoke: if
                        { // Invoke: if ... ... else ...
                            // Binary operator: $last_char_string == ";"
                            TclObject tmp257 = getVarScalar(interp, "last_char_string", compiledLocals, 37);
                            boolean tmp258 = tmp257.toString().equals(";");
                            ExprValue tmp259 = evs0;
                            tmp259.setIntValue(tmp258);
                            // End Binary operator: ==
                            boolean tmp260 = ( tmp259.getIntValue() != 0 );
                            if ( tmp260 ) {
                                { // Invoke: set ... 1
                                    setVarScalar(interp, "last_char_is_semicolon", const9, compiledLocals, 39);
                                } // End Invoke: set
                            } else {
                                { // Invoke: set ... 0
                                    setVarScalar(interp, "last_char_is_semicolon", const0, compiledLocals, 39);
                                } // End Invoke: set
                            }
                        } // End Invoke: if
                        { // Invoke: set r [...]
                            TclObject tmp261;
                            { // Invoke: list $range_start 1
                                TclObject tmp262 = TclList.newInstance();
                                TclObject tmp263;
                                try {
                                    tmp263 = getVarScalar(interp, "range_start", compiledLocals, 24);
                                    TclList.append(interp, tmp262, tmp263);
                                    TclList.append(interp, tmp262, const9);
                                } catch (TclException ex) {
                                    tmp262.release();
                                    throw ex;
                                }
                                interp.setResult(tmp262);
                            } // End Invoke: list
                            tmp261 = interp.getResult();
                            setVarScalar(interp, "r", tmp261, compiledLocals, 40);
                        } // End Invoke: set
                        { // Invoke: if ... ...
                            // Binary operator: [...] != "p"
                            { // Invoke: parse getstring $script $r
                                TclObject[] objv264 = TJC.grabObjv(interp, 4);
                                TclObject tmp265;
                                try {
                                    // Arg 0 constant: parse
                                    objv264[0] = const20;
                                    // Arg 1 constant: getstring
                                    objv264[1] = const21;
                                    // Arg 2 variable: $script
                                    tmp265 = getVarScalar(interp, "script", compiledLocals, 4);
                                    tmp265.preserve();
                                    objv264[2] = tmp265;
                                    // Arg 3 variable: $r
                                    tmp265 = getVarScalar(interp, "r", compiledLocals, 40);
                                    tmp265.preserve();
                                    objv264[3] = tmp265;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                        ? cmdcache10.cmd : null), objv264, 0);
                                    if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                        updateCmdCache(interp, 10);
                                    }
                                } finally {
                                    tmp265 = objv264[2];
                                    if ( tmp265 != null ) {
                                        tmp265.release();
                                    }
                                    tmp265 = objv264[3];
                                    if ( tmp265 != null ) {
                                        tmp265.release();
                                    }
                                    TJC.releaseObjv(interp, objv264, 4);
                                }
                            } // End Invoke: parse
                            TclObject tmp266 = interp.getResult();
                            boolean tmp267 = ! tmp266.toString().equals("p");
                            ExprValue tmp268 = evs0;
                            tmp268.setIntValue(tmp267);
                            // End Binary operator: !=
                            boolean tmp269 = ( tmp268.getIntValue() != 0 );
                            if ( tmp269 ) {
                                { // Invoke: error "..."
                                    TclObject[] objv270 = TJC.grabObjv(interp, 2);
                                    TclObject tmp271;
                                    try {
                                        // Arg 0 constant: error
                                        objv270[0] = const19;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp272 = new StringBuffer(64);
                                        sbtmp272.append("expected proc declaration ");
                                        tmp271 = getVarScalar(interp, "key", compiledLocals, 0);
                                        sbtmp272.append(tmp271.toString());
                                        sbtmp272.append(" to begin at range ");
                                        sbtmp272.append("{");
                                        tmp271 = getVarScalar(interp, "r", compiledLocals, 40);
                                        sbtmp272.append(tmp271.toString());
                                        sbtmp272.append("}");
                                        tmp271 = TclString.newInstance(sbtmp272);
                                        tmp271.preserve();
                                        objv270[1] = tmp271;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                                            ? cmdcache9.cmd : null), objv270, 0);
                                        if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                                            updateCmdCache(interp, 9);
                                        }
                                    } finally {
                                        tmp271 = objv270[1];
                                        if ( tmp271 != null ) {
                                            tmp271.release();
                                        }
                                        TJC.releaseObjv(interp, objv270, 2);
                                    }
                                } // End Invoke: error
                            }
                        } // End Invoke: if
                        { // Invoke: set r [...]
                            TclObject tmp273;
                            { // Invoke: list [...] 1
                                TclObject tmp274 = TclList.newInstance();
                                TclObject tmp275;
                                try {
                                    { // Invoke: expr ...
                                        // Binary operator: $after_closing_brace_index - 1
                                        TclObject tmp276 = getVarScalar(interp, "after_closing_brace_index", compiledLocals, 32);
                                        ExprValue tmp277 = evs0;
                                        TJC.exprInitValue(interp, tmp277, tmp276);
                                        ExprValue tmp278 = evs1;
                                        tmp278.setIntValue(1);
                                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MINUS, tmp277, tmp278);
                                        // End Binary operator: -
                                        TJC.exprSetResult(interp, tmp277);
                                    } // End Invoke: expr
                                    tmp275 = interp.getResult();
                                    TclList.append(interp, tmp274, tmp275);
                                    TclList.append(interp, tmp274, const9);
                                } catch (TclException ex) {
                                    tmp274.release();
                                    throw ex;
                                }
                                interp.setResult(tmp274);
                            } // End Invoke: list
                            tmp273 = interp.getResult();
                            setVarScalar(interp, "r", tmp273, compiledLocals, 40);
                        } // End Invoke: set
                        { // Invoke: if ... ...
                            // Binary operator: [...] != "}"
                            { // Invoke: parse getstring $script $r
                                TclObject[] objv279 = TJC.grabObjv(interp, 4);
                                TclObject tmp280;
                                try {
                                    // Arg 0 constant: parse
                                    objv279[0] = const20;
                                    // Arg 1 constant: getstring
                                    objv279[1] = const21;
                                    // Arg 2 variable: $script
                                    tmp280 = getVarScalar(interp, "script", compiledLocals, 4);
                                    tmp280.preserve();
                                    objv279[2] = tmp280;
                                    // Arg 3 variable: $r
                                    tmp280 = getVarScalar(interp, "r", compiledLocals, 40);
                                    tmp280.preserve();
                                    objv279[3] = tmp280;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                        ? cmdcache10.cmd : null), objv279, 0);
                                    if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                        updateCmdCache(interp, 10);
                                    }
                                } finally {
                                    tmp280 = objv279[2];
                                    if ( tmp280 != null ) {
                                        tmp280.release();
                                    }
                                    tmp280 = objv279[3];
                                    if ( tmp280 != null ) {
                                        tmp280.release();
                                    }
                                    TJC.releaseObjv(interp, objv279, 4);
                                }
                            } // End Invoke: parse
                            TclObject tmp281 = interp.getResult();
                            boolean tmp282 = ! tmp281.toString().equals("}");
                            ExprValue tmp283 = evs0;
                            tmp283.setIntValue(tmp282);
                            // End Binary operator: !=
                            boolean tmp284 = ( tmp283.getIntValue() != 0 );
                            if ( tmp284 ) {
                                { // Invoke: error "..."
                                    TclObject[] objv285 = TJC.grabObjv(interp, 2);
                                    TclObject tmp286;
                                    try {
                                        // Arg 0 constant: error
                                        objv285[0] = const19;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp287 = new StringBuffer(64);
                                        sbtmp287.append("expected proc declaration ");
                                        tmp286 = getVarScalar(interp, "key", compiledLocals, 0);
                                        sbtmp287.append(tmp286.toString());
                                        sbtmp287.append(" to end at range ");
                                        sbtmp287.append("{");
                                        tmp286 = getVarScalar(interp, "r", compiledLocals, 40);
                                        sbtmp287.append(tmp286.toString());
                                        sbtmp287.append("}");
                                        tmp286 = TclString.newInstance(sbtmp287);
                                        tmp286.preserve();
                                        objv285[1] = tmp286;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                                            ? cmdcache9.cmd : null), objv285, 0);
                                        if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                                            updateCmdCache(interp, 9);
                                        }
                                    } finally {
                                        tmp286 = objv285[1];
                                        if ( tmp286 != null ) {
                                            tmp286.release();
                                        }
                                        TJC.releaseObjv(interp, objv285, 2);
                                    }
                                } // End Invoke: error
                            }
                        } // End Invoke: if
                        { // Invoke: set decl_range [...]
                            TclObject tmp288;
                            { // Invoke: list $range_start [...]
                                TclObject tmp289 = TclList.newInstance();
                                TclObject tmp290;
                                try {
                                    tmp290 = getVarScalar(interp, "range_start", compiledLocals, 24);
                                    TclList.append(interp, tmp289, tmp290);
                                    { // Invoke: expr ...
                                        // Binary operator: $after_closing_brace_index - $range_start
                                        TclObject tmp291 = getVarScalar(interp, "after_closing_brace_index", compiledLocals, 32);
                                        ExprValue tmp292 = evs0;
                                        TJC.exprInitValue(interp, tmp292, tmp291);
                                        TclObject tmp293 = getVarScalar(interp, "range_start", compiledLocals, 24);
                                        ExprValue tmp294 = evs1;
                                        TJC.exprInitValue(interp, tmp294, tmp293);
                                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MINUS, tmp292, tmp294);
                                        // End Binary operator: -
                                        TJC.exprSetResult(interp, tmp292);
                                    } // End Invoke: expr
                                    tmp290 = interp.getResult();
                                    TclList.append(interp, tmp289, tmp290);
                                } catch (TclException ex) {
                                    tmp289.release();
                                    throw ex;
                                }
                                interp.setResult(tmp289);
                            } // End Invoke: list
                            tmp288 = interp.getResult();
                            setVarScalar(interp, "decl_range", tmp288, compiledLocals, 41);
                        } // End Invoke: set
                        { // Invoke: set decl_newlines [...]
                            TclObject tmp295;
                            { // Invoke: parse countnewline $script $decl_range
                                TclObject[] objv296 = TJC.grabObjv(interp, 4);
                                TclObject tmp297;
                                try {
                                    // Arg 0 constant: parse
                                    objv296[0] = const20;
                                    // Arg 1 constant: countnewline
                                    objv296[1] = const24;
                                    // Arg 2 variable: $script
                                    tmp297 = getVarScalar(interp, "script", compiledLocals, 4);
                                    tmp297.preserve();
                                    objv296[2] = tmp297;
                                    // Arg 3 variable: $decl_range
                                    tmp297 = getVarScalar(interp, "decl_range", compiledLocals, 41);
                                    tmp297.preserve();
                                    objv296[3] = tmp297;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                        ? cmdcache10.cmd : null), objv296, 0);
                                    if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                        updateCmdCache(interp, 10);
                                    }
                                } finally {
                                    tmp297 = objv296[2];
                                    if ( tmp297 != null ) {
                                        tmp297.release();
                                    }
                                    tmp297 = objv296[3];
                                    if ( tmp297 != null ) {
                                        tmp297.release();
                                    }
                                    TJC.releaseObjv(interp, objv296, 4);
                                }
                            } // End Invoke: parse
                            tmp295 = interp.getResult();
                            setVarScalar(interp, "decl_newlines", tmp295, compiledLocals, 42);
                        } // End Invoke: set
                        { // Invoke: if {$debug} ...
                            TclObject tmp298 = getVarScalar(interp, "debug", compiledLocals, 3);
                            boolean tmp299 = TJC.getBoolean(interp, tmp298);
                            if ( tmp299 ) {
                                { // Invoke: puts "..."
                                    TclObject[] objv300 = TJC.grabObjv(interp, 2);
                                    TclObject tmp301;
                                    try {
                                        // Arg 0 constant: puts
                                        objv300[0] = const1;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp302 = new StringBuffer(64);
                                        sbtmp302.append("command string is ");
                                        sbtmp302.append("\"");
                                        { // Invoke: parse getstring $script $command_range
                                            TclObject[] objv303 = TJC.grabObjv(interp, 4);
                                            TclObject tmp304;
                                            try {
                                                // Arg 0 constant: parse
                                                objv303[0] = const20;
                                                // Arg 1 constant: getstring
                                                objv303[1] = const21;
                                                // Arg 2 variable: $script
                                                tmp304 = getVarScalar(interp, "script", compiledLocals, 4);
                                                tmp304.preserve();
                                                objv303[2] = tmp304;
                                                // Arg 3 variable: $command_range
                                                tmp304 = getVarScalar(interp, "command_range", compiledLocals, 5);
                                                tmp304.preserve();
                                                objv303[3] = tmp304;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                                    ? cmdcache10.cmd : null), objv303, 0);
                                                if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                                    updateCmdCache(interp, 10);
                                                }
                                            } finally {
                                                tmp304 = objv303[2];
                                                if ( tmp304 != null ) {
                                                    tmp304.release();
                                                }
                                                tmp304 = objv303[3];
                                                if ( tmp304 != null ) {
                                                    tmp304.release();
                                                }
                                                TJC.releaseObjv(interp, objv303, 4);
                                            }
                                        } // End Invoke: parse
                                        tmp301 = interp.getResult();
                                        sbtmp302.append(tmp301.toString());
                                        sbtmp302.append("\"");
                                        tmp301 = TclString.newInstance(sbtmp302);
                                        tmp301.preserve();
                                        objv300[1] = tmp301;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                            ? cmdcache1.cmd : null), objv300, 0);
                                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                            updateCmdCache(interp, 1);
                                        }
                                    } finally {
                                        tmp301 = objv300[1];
                                        if ( tmp301 != null ) {
                                            tmp301.release();
                                        }
                                        TJC.releaseObjv(interp, objv300, 2);
                                    }
                                } // End Invoke: puts
                                { // Invoke: puts "..."
                                    TclObject[] objv305 = TJC.grabObjv(interp, 2);
                                    TclObject tmp306;
                                    try {
                                        // Arg 0 constant: puts
                                        objv305[0] = const1;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp307 = new StringBuffer(64);
                                        sbtmp307.append("proc string is ");
                                        sbtmp307.append("\"");
                                        { // Invoke: parse getstring $script $decl_range
                                            TclObject[] objv308 = TJC.grabObjv(interp, 4);
                                            TclObject tmp309;
                                            try {
                                                // Arg 0 constant: parse
                                                objv308[0] = const20;
                                                // Arg 1 constant: getstring
                                                objv308[1] = const21;
                                                // Arg 2 variable: $script
                                                tmp309 = getVarScalar(interp, "script", compiledLocals, 4);
                                                tmp309.preserve();
                                                objv308[2] = tmp309;
                                                // Arg 3 variable: $decl_range
                                                tmp309 = getVarScalar(interp, "decl_range", compiledLocals, 41);
                                                tmp309.preserve();
                                                objv308[3] = tmp309;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                                    ? cmdcache10.cmd : null), objv308, 0);
                                                if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                                    updateCmdCache(interp, 10);
                                                }
                                            } finally {
                                                tmp309 = objv308[2];
                                                if ( tmp309 != null ) {
                                                    tmp309.release();
                                                }
                                                tmp309 = objv308[3];
                                                if ( tmp309 != null ) {
                                                    tmp309.release();
                                                }
                                                TJC.releaseObjv(interp, objv308, 4);
                                            }
                                        } // End Invoke: parse
                                        tmp306 = interp.getResult();
                                        sbtmp307.append(tmp306.toString());
                                        sbtmp307.append("\"");
                                        tmp306 = TclString.newInstance(sbtmp307);
                                        tmp306.preserve();
                                        objv305[1] = tmp306;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                            ? cmdcache1.cmd : null), objv305, 0);
                                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                            updateCmdCache(interp, 1);
                                        }
                                    } finally {
                                        tmp306 = objv305[1];
                                        if ( tmp306 != null ) {
                                            tmp306.release();
                                        }
                                        TJC.releaseObjv(interp, objv305, 2);
                                    }
                                } // End Invoke: puts
                                { // Invoke: puts "..."
                                    TclObject[] objv310 = TJC.grabObjv(interp, 2);
                                    TclObject tmp311;
                                    try {
                                        // Arg 0 constant: puts
                                        objv310[0] = const1;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp312 = new StringBuffer(64);
                                        sbtmp312.append("decl_newlines is ");
                                        tmp311 = getVarScalar(interp, "decl_newlines", compiledLocals, 42);
                                        sbtmp312.append(tmp311.toString());
                                        tmp311 = TclString.newInstance(sbtmp312);
                                        tmp311.preserve();
                                        objv310[1] = tmp311;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                            ? cmdcache1.cmd : null), objv310, 0);
                                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                            updateCmdCache(interp, 1);
                                        }
                                    } finally {
                                        tmp311 = objv310[1];
                                        if ( tmp311 != null ) {
                                            tmp311.release();
                                        }
                                        TJC.releaseObjv(interp, objv310, 2);
                                    }
                                } // End Invoke: puts
                                { // Invoke: puts "..."
                                    TclObject[] objv313 = TJC.grabObjv(interp, 2);
                                    TclObject tmp314;
                                    try {
                                        // Arg 0 constant: puts
                                        objv313[0] = const1;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp315 = new StringBuffer(64);
                                        sbtmp315.append("last_char_is_newline is ");
                                        tmp314 = getVarScalar(interp, "last_char_is_newline", compiledLocals, 38);
                                        sbtmp315.append(tmp314.toString());
                                        tmp314 = TclString.newInstance(sbtmp315);
                                        tmp314.preserve();
                                        objv313[1] = tmp314;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                            ? cmdcache1.cmd : null), objv313, 0);
                                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                            updateCmdCache(interp, 1);
                                        }
                                    } finally {
                                        tmp314 = objv313[1];
                                        if ( tmp314 != null ) {
                                            tmp314.release();
                                        }
                                        TJC.releaseObjv(interp, objv313, 2);
                                    }
                                } // End Invoke: puts
                                { // Invoke: puts "..."
                                    TclObject[] objv316 = TJC.grabObjv(interp, 2);
                                    TclObject tmp317;
                                    try {
                                        // Arg 0 constant: puts
                                        objv316[0] = const1;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp318 = new StringBuffer(64);
                                        sbtmp318.append("last_char_is_semicolon is ");
                                        tmp317 = getVarScalar(interp, "last_char_is_semicolon", compiledLocals, 39);
                                        sbtmp318.append(tmp317.toString());
                                        tmp317 = TclString.newInstance(sbtmp318);
                                        tmp317.preserve();
                                        objv316[1] = tmp317;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                            ? cmdcache1.cmd : null), objv316, 0);
                                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                            updateCmdCache(interp, 1);
                                        }
                                    } finally {
                                        tmp317 = objv316[1];
                                        if ( tmp317 != null ) {
                                            tmp317.release();
                                        }
                                        TJC.releaseObjv(interp, objv316, 2);
                                    }
                                } // End Invoke: puts
                                { // Invoke: puts "nested is $nested"
                                    TclObject[] objv319 = TJC.grabObjv(interp, 2);
                                    TclObject tmp320;
                                    try {
                                        // Arg 0 constant: puts
                                        objv319[0] = const1;
                                        // Arg 1 word: "nested is $nested"
                                        StringBuffer sbtmp321 = new StringBuffer(64);
                                        sbtmp321.append("nested is ");
                                        tmp320 = getVarScalar(interp, "nested", compiledLocals, 7);
                                        sbtmp321.append(tmp320.toString());
                                        tmp320 = TclString.newInstance(sbtmp321);
                                        tmp320.preserve();
                                        objv319[1] = tmp320;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                            ? cmdcache1.cmd : null), objv319, 0);
                                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                            updateCmdCache(interp, 1);
                                        }
                                    } finally {
                                        tmp320 = objv319[1];
                                        if ( tmp320 != null ) {
                                            tmp320.release();
                                        }
                                        TJC.releaseObjv(interp, objv319, 2);
                                    }
                                } // End Invoke: puts
                            }
                        } // End Invoke: if
                        { // Invoke: if {$decl_newlines > 0} ...
                            // Binary operator: $decl_newlines > 0
                            TclObject tmp322 = getVarScalar(interp, "decl_newlines", compiledLocals, 42);
                            ExprValue tmp323 = evs0;
                            TJC.exprInitValue(interp, tmp323, tmp322);
                            ExprValue tmp324 = evs1;
                            tmp324.setIntValue(0);
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GREATER, tmp323, tmp324);
                            // End Binary operator: >
                            boolean tmp325 = ( tmp323.getIntValue() != 0 );
                            if ( tmp325 ) {
                                { // Invoke: if {$nested} ... else ...
                                    TclObject tmp326 = getVarScalar(interp, "nested", compiledLocals, 7);
                                    boolean tmp327 = TJC.getBoolean(interp, tmp326);
                                    if ( tmp327 ) {
                                        { // Invoke: for {set i 0} ... {incr i} ...
                                            { // Invoke: set i 0
                                                setVarScalar(interp, "i", const0, compiledLocals, 43);
                                            } // End Invoke: set
                                            for ( boolean skip333 = true ; true ; ) {
                                                if ( skip333 ) {
                                                    skip333 = false;
                                                } else {
                                                    try {
                                                    if ( false ) { throw (TclException) null; }
                                                    { // Invoke: incr i
                                                        interp.resetResult();
                                                        incrVarScalar(interp, "i", 1, compiledLocals, 43);
                                                    } // End Invoke: incr
                                                    } catch (TclException ex) {
                                                        int type = ex.getCompletionCode();
                                                        if (type == TCL.BREAK) {
                                                            break;
                                                        } else {
                                                            throw ex;
                                                        }
                                                    }
                                                }

                                                // Binary operator: $i < $decl_newlines
                                                TclObject tmp328 = getVarScalar(interp, "i", compiledLocals, 43);
                                                ExprValue tmp329 = evs0;
                                                TJC.exprInitValue(interp, tmp329, tmp328);
                                                TclObject tmp330 = getVarScalar(interp, "decl_newlines", compiledLocals, 42);
                                                ExprValue tmp331 = evs1;
                                                TJC.exprInitValue(interp, tmp331, tmp330);
                                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp329, tmp331);
                                                // End Binary operator: <
                                                boolean tmp332 = ( tmp329.getIntValue() != 0 );
                                                if ( ! tmp332 ) { break; }

                                                try {
                                                if ( false ) { throw (TclException) null; }
                                                { // Invoke: append ... ...
                                                    TclObject[] objv334 = TJC.grabObjv(interp, 1);
                                                    TclObject tmp335;
                                                    try {
                                                        // Arg 2 constant: ...
                                                        objv334[0] = const25;
                                                        interp.resetResult();
                                                        appendVarArray(interp, "_parseproc", "outscript", objv334, compiledLocals, 2);
                                                    } finally {
                                                        TJC.releaseObjv(interp, objv334, 1);
                                                    }
                                                } // End Invoke: append
                                                } catch (TclException ex) {
                                                    int type = ex.getCompletionCode();
                                                    if (type == TCL.BREAK) {
                                                        break;
                                                    } else if (type == TCL.CONTINUE) {
                                                        continue;
                                                    } else {
                                                        throw ex;
                                                    }
                                                }
                                            }
                                        } // End Invoke: for
                                    } else {
                                        { // Invoke: for {set i 0} ... {incr i} ...
                                            { // Invoke: set i 0
                                                setVarScalar(interp, "i", const0, compiledLocals, 43);
                                            } // End Invoke: set
                                            for ( boolean skip341 = true ; true ; ) {
                                                if ( skip341 ) {
                                                    skip341 = false;
                                                } else {
                                                    try {
                                                    if ( false ) { throw (TclException) null; }
                                                    { // Invoke: incr i
                                                        interp.resetResult();
                                                        incrVarScalar(interp, "i", 1, compiledLocals, 43);
                                                    } // End Invoke: incr
                                                    } catch (TclException ex) {
                                                        int type = ex.getCompletionCode();
                                                        if (type == TCL.BREAK) {
                                                            break;
                                                        } else {
                                                            throw ex;
                                                        }
                                                    }
                                                }

                                                // Binary operator: $i < $decl_newlines
                                                TclObject tmp336 = getVarScalar(interp, "i", compiledLocals, 43);
                                                ExprValue tmp337 = evs0;
                                                TJC.exprInitValue(interp, tmp337, tmp336);
                                                TclObject tmp338 = getVarScalar(interp, "decl_newlines", compiledLocals, 42);
                                                ExprValue tmp339 = evs1;
                                                TJC.exprInitValue(interp, tmp339, tmp338);
                                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp337, tmp339);
                                                // End Binary operator: <
                                                boolean tmp340 = ( tmp337.getIntValue() != 0 );
                                                if ( ! tmp340 ) { break; }

                                                try {
                                                if ( false ) { throw (TclException) null; }
                                                { // Invoke: append ... ...
                                                    TclObject[] objv342 = TJC.grabObjv(interp, 1);
                                                    TclObject tmp343;
                                                    try {
                                                        // Arg 2 constant: ...
                                                        objv342[0] = const26;
                                                        interp.resetResult();
                                                        appendVarArray(interp, "_parseproc", "outscript", objv342, compiledLocals, 2);
                                                    } finally {
                                                        TJC.releaseObjv(interp, objv342, 1);
                                                    }
                                                } // End Invoke: append
                                                } catch (TclException ex) {
                                                    int type = ex.getCompletionCode();
                                                    if (type == TCL.BREAK) {
                                                        break;
                                                    } else if (type == TCL.CONTINUE) {
                                                        continue;
                                                    } else {
                                                        throw ex;
                                                    }
                                                }
                                            }
                                        } // End Invoke: for
                                    }
                                } // End Invoke: if
                            }
                        } // End Invoke: if
                        { // Invoke: if {$post_str != ""} ...
                            // Binary operator: $post_str != ""
                            TclObject tmp344 = getVarScalar(interp, "post_str", compiledLocals, 33);
                            ExprValue tmp345 = evs0;
                            TJC.exprEqualsEmptyString(tmp345, tmp344, true);
                            // End Binary operator: !=
                            boolean tmp346 = ( tmp345.getIntValue() != 0 );
                            if ( tmp346 ) {
                                { // Invoke: append ... $post_str
                                    TclObject[] objv347 = TJC.grabObjv(interp, 1);
                                    TclObject tmp348;
                                    try {
                                        // Arg 2 variable: $post_str
                                        tmp348 = getVarScalar(interp, "post_str", compiledLocals, 33);
                                        tmp348.preserve();
                                        objv347[0] = tmp348;
                                        interp.resetResult();
                                        appendVarArray(interp, "_parseproc", "outscript", objv347, compiledLocals, 2);
                                    } finally {
                                        TJC.releaseObjvElems(interp, objv347, 1);
                                    }
                                } // End Invoke: append
                                { // Invoke: if {$debug} ...
                                    TclObject tmp349 = getVarScalar(interp, "debug", compiledLocals, 3);
                                    boolean tmp350 = TJC.getBoolean(interp, tmp349);
                                    if ( tmp350 ) {
                                        { // Invoke: puts "..."
                                            TclObject[] objv351 = TJC.grabObjv(interp, 2);
                                            TclObject tmp352;
                                            try {
                                                // Arg 0 constant: puts
                                                objv351[0] = const1;
                                                // Arg 1 word: "..."
                                                StringBuffer sbtmp353 = new StringBuffer(64);
                                                sbtmp353.append("post_str is ");
                                                sbtmp353.append("\"");
                                                tmp352 = getVarScalar(interp, "post_str", compiledLocals, 33);
                                                sbtmp353.append(tmp352.toString());
                                                sbtmp353.append("\"");
                                                tmp352 = TclString.newInstance(sbtmp353);
                                                tmp352.preserve();
                                                objv351[1] = tmp352;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                                    ? cmdcache1.cmd : null), objv351, 0);
                                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                                    updateCmdCache(interp, 1);
                                                }
                                            } finally {
                                                tmp352 = objv351[1];
                                                if ( tmp352 != null ) {
                                                    tmp352.release();
                                                }
                                                TJC.releaseObjv(interp, objv351, 2);
                                            }
                                        } // End Invoke: puts
                                        { // Invoke: puts "..."
                                            TclObject[] objv354 = TJC.grabObjv(interp, 2);
                                            TclObject tmp355;
                                            try {
                                                // Arg 0 constant: puts
                                                objv354[0] = const1;
                                                // Arg 1 word: "..."
                                                StringBuffer sbtmp356 = new StringBuffer(64);
                                                sbtmp356.append("post post_range outscript is ");
                                                sbtmp356.append("\"");
                                                tmp355 = getVarArray(interp, "_parseproc", "outscript", compiledLocals, 2);
                                                sbtmp356.append(tmp355.toString());
                                                sbtmp356.append("\"");
                                                tmp355 = TclString.newInstance(sbtmp356);
                                                tmp355.preserve();
                                                objv354[1] = tmp355;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                                    ? cmdcache1.cmd : null), objv354, 0);
                                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                                    updateCmdCache(interp, 1);
                                                }
                                            } finally {
                                                tmp355 = objv354[1];
                                                if ( tmp355 != null ) {
                                                    tmp355.release();
                                                }
                                                TJC.releaseObjv(interp, objv354, 2);
                                            }
                                        } // End Invoke: puts
                                    }
                                } // End Invoke: if
                            }
                        } // End Invoke: if
                        { // Invoke: if {$debug} ...
                            TclObject tmp357 = getVarScalar(interp, "debug", compiledLocals, 3);
                            boolean tmp358 = TJC.getBoolean(interp, tmp357);
                            if ( tmp358 ) {
                                { // Invoke: puts "..."
                                    TclObject[] objv359 = TJC.grabObjv(interp, 2);
                                    TclObject tmp360;
                                    try {
                                        // Arg 0 constant: puts
                                        objv359[0] = const1;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp361 = new StringBuffer(64);
                                        sbtmp361.append("new outscript is ");
                                        sbtmp361.append("\"");
                                        tmp360 = getVarArray(interp, "_parseproc", "outscript", compiledLocals, 2);
                                        sbtmp361.append(tmp360.toString());
                                        sbtmp361.append("\"");
                                        tmp360 = TclString.newInstance(sbtmp361);
                                        tmp360.preserve();
                                        objv359[1] = tmp360;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                            ? cmdcache1.cmd : null), objv359, 0);
                                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                            updateCmdCache(interp, 1);
                                        }
                                    } finally {
                                        tmp360 = objv359[1];
                                        if ( tmp360 != null ) {
                                            tmp360.release();
                                        }
                                        TJC.releaseObjv(interp, objv359, 2);
                                    }
                                } // End Invoke: puts
                            }
                        } // End Invoke: if
                        { // Invoke: set tuple [...]
                            TclObject tmp362;
                            { // Invoke: list $name $classname [...]
                                TclObject tmp363 = TclList.newInstance();
                                TclObject tmp364;
                                try {
                                    tmp364 = getVarScalar(interp, "name", compiledLocals, 11);
                                    TclList.append(interp, tmp363, tmp364);
                                    tmp364 = getVarScalar(interp, "classname", compiledLocals, 30);
                                    TclList.append(interp, tmp363, tmp364);
                                    { // Invoke: list proc $name $args_text $body_text
                                        TclObject tmp365 = TclList.newInstance();
                                        TclObject tmp366;
                                        try {
                                            TclList.append(interp, tmp365, const27);
                                            tmp366 = getVarScalar(interp, "name", compiledLocals, 11);
                                            TclList.append(interp, tmp365, tmp366);
                                            tmp366 = getVarScalar(interp, "args_text", compiledLocals, 14);
                                            TclList.append(interp, tmp365, tmp366);
                                            tmp366 = getVarScalar(interp, "body_text", compiledLocals, 18);
                                            TclList.append(interp, tmp365, tmp366);
                                        } catch (TclException ex) {
                                            tmp365.release();
                                            throw ex;
                                        }
                                        interp.setResult(tmp365);
                                    } // End Invoke: list
                                    tmp364 = interp.getResult();
                                    TclList.append(interp, tmp363, tmp364);
                                } catch (TclException ex) {
                                    tmp363.release();
                                    throw ex;
                                }
                                interp.setResult(tmp363);
                            } // End Invoke: list
                            tmp362 = interp.getResult();
                            setVarScalar(interp, "tuple", tmp362, compiledLocals, 12);
                        } // End Invoke: set
                        { // Invoke: lappend _parseproc(proclist) $tuple
                            TclObject[] objv367 = TJC.grabObjv(interp, 1);
                            TclObject tmp368;
                            try {
                                // Arg 2 variable: $tuple
                                tmp368 = getVarScalar(interp, "tuple", compiledLocals, 12);
                                tmp368.preserve();
                                objv367[0] = tmp368;
                                interp.resetResult();
                                lappendVarArray(interp, "_parseproc", "proclist", objv367, compiledLocals, 2);
                            } finally {
                                TJC.releaseObjvElems(interp, objv367, 1);
                            }
                        } // End Invoke: lappend
                        { // Invoke: incr ...
                            interp.resetResult();
                            incrVarArray(interp, "_parseproc", "procs_parsed", 1, compiledLocals, 2);
                        } // End Invoke: incr
                        { // Invoke: if {$_parseproc(debug)} ...
                            TclObject tmp369 = getVarArray(interp, "_parseproc", "debug", compiledLocals, 2);
                            ExprValue tmp370 = evs0;
                            TJC.exprInitValue(interp, tmp370, tmp369);
                            boolean tmp371 = tmp370.getBooleanValue(interp);
                            if ( tmp371 ) {
                                { // Invoke: if ... ... else ...
                                    // Binary operator: $_parseproc(...) != ""
                                    TclObject tmp372 = getVarArray(interp, "_parseproc", "filename", compiledLocals, 2);
                                    ExprValue tmp373 = evs0;
                                    TJC.exprEqualsEmptyString(tmp373, tmp372, true);
                                    // End Binary operator: !=
                                    boolean tmp374 = ( tmp373.getIntValue() != 0 );
                                    if ( tmp374 ) {
                                        { // Invoke: set fsig "..."
                                            TclObject tmp375;
                                            StringBuffer sbtmp376 = new StringBuffer(64);
                                            tmp375 = getVarArray(interp, "_parseproc", "filename", compiledLocals, 2);
                                            sbtmp376.append(tmp375.toString());
                                            sbtmp376.append(": ");
                                            tmp375 = TclString.newInstance(sbtmp376);
                                            setVarScalar(interp, "fsig", tmp375, compiledLocals, 21);
                                        } // End Invoke: set
                                    } else {
                                        { // Invoke: set fsig ""
                                            setVarScalar(interp, "fsig", const12, compiledLocals, 21);
                                        } // End Invoke: set
                                    }
                                } // End Invoke: if
                                { // Invoke: puts stderr "..."
                                    TclObject[] objv377 = TJC.grabObjv(interp, 3);
                                    TclObject tmp378;
                                    try {
                                        // Arg 0 constant: puts
                                        objv377[0] = const1;
                                        // Arg 1 constant: stderr
                                        objv377[1] = const18;
                                        // Arg 2 word: "..."
                                        StringBuffer sbtmp379 = new StringBuffer(64);
                                        tmp378 = getVarScalar(interp, "fsig", compiledLocals, 21);
                                        sbtmp379.append(tmp378.toString());
                                        sbtmp379.append("parsed proc ");
                                        tmp378 = getVarScalar(interp, "name", compiledLocals, 11);
                                        sbtmp379.append(tmp378.toString());
                                        tmp378 = TclString.newInstance(sbtmp379);
                                        tmp378.preserve();
                                        objv377[2] = tmp378;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                            ? cmdcache1.cmd : null), objv377, 0);
                                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                            updateCmdCache(interp, 1);
                                        }
                                    } finally {
                                        tmp378 = objv377[2];
                                        if ( tmp378 != null ) {
                                            tmp378.release();
                                        }
                                        TJC.releaseObjv(interp, objv377, 3);
                                    }
                                } // End Invoke: puts
                            } else {
                                interp.resetResult();
                            }
                        } // End Invoke: if
                    } else {
                        { // Invoke: if {$_parseproc(debug)} ...
                            TclObject tmp380 = getVarArray(interp, "_parseproc", "debug", compiledLocals, 2);
                            ExprValue tmp381 = evs0;
                            TJC.exprInitValue(interp, tmp381, tmp380);
                            boolean tmp382 = tmp381.getBooleanValue(interp);
                            if ( tmp382 ) {
                                { // Invoke: if ... ... else ...
                                    // Binary operator: $_parseproc(...) != ""
                                    TclObject tmp383 = getVarArray(interp, "_parseproc", "filename", compiledLocals, 2);
                                    ExprValue tmp384 = evs0;
                                    TJC.exprEqualsEmptyString(tmp384, tmp383, true);
                                    // End Binary operator: !=
                                    boolean tmp385 = ( tmp384.getIntValue() != 0 );
                                    if ( tmp385 ) {
                                        { // Invoke: set fsig "..."
                                            TclObject tmp386;
                                            StringBuffer sbtmp387 = new StringBuffer(64);
                                            tmp386 = getVarArray(interp, "_parseproc", "filename", compiledLocals, 2);
                                            sbtmp387.append(tmp386.toString());
                                            sbtmp387.append(": ");
                                            tmp386 = TclString.newInstance(sbtmp387);
                                            setVarScalar(interp, "fsig", tmp386, compiledLocals, 21);
                                        } // End Invoke: set
                                    } else {
                                        { // Invoke: set fsig ""
                                            setVarScalar(interp, "fsig", const12, compiledLocals, 21);
                                        } // End Invoke: set
                                    }
                                } // End Invoke: if
                                { // Invoke: puts stderr "..."
                                    TclObject[] objv388 = TJC.grabObjv(interp, 3);
                                    TclObject tmp389;
                                    try {
                                        // Arg 0 constant: puts
                                        objv388[0] = const1;
                                        // Arg 1 constant: stderr
                                        objv388[1] = const18;
                                        // Arg 2 word: "..."
                                        StringBuffer sbtmp390 = new StringBuffer(64);
                                        tmp389 = getVarScalar(interp, "fsig", compiledLocals, 21);
                                        sbtmp390.append(tmp389.toString());
                                        sbtmp390.append("could not parse ");
                                        tmp389 = getVarScalar(interp, "name", compiledLocals, 11);
                                        sbtmp390.append(tmp389.toString());
                                        tmp389 = TclString.newInstance(sbtmp390);
                                        tmp389.preserve();
                                        objv388[2] = tmp389;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                            ? cmdcache1.cmd : null), objv388, 0);
                                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                            updateCmdCache(interp, 1);
                                        }
                                    } finally {
                                        tmp389 = objv388[2];
                                        if ( tmp389 != null ) {
                                            tmp389.release();
                                        }
                                        TJC.releaseObjv(interp, objv388, 3);
                                    }
                                } // End Invoke: puts
                            } else {
                                interp.resetResult();
                            }
                        } // End Invoke: if
                    }
                } // End Invoke: if
            } else {
                interp.resetResult();
            }
        } // End Invoke: if
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "parseproc_command_proc");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;
    TclObject const19;
    TclObject const20;
    TclObject const21;
    TclObject const22;
    TclObject const23;
    TclObject const24;
    TclObject const25;
    TclObject const26;
    TclObject const27;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclInteger.newInstance(0);
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("puts");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("parseproc_command_proc found proc definiton");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("descend_get_data");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("script");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("command");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("tree");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("nested");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("parse_is_simple_text");
        const8.preserve(); const8.preserve();
        const9 = TclInteger.newInstance(1);
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("parse_get_simple_text");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("text");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("parse_is_constant");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("parse_get_constant_text");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("parseproc_args_ok");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("lindex");
        const16.preserve(); const16.preserve();
        const17 = TclInteger.newInstance(3);
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance("stderr");
        const18.preserve(); const18.preserve();
        const19 = TclString.newInstance("error");
        const19.preserve(); const19.preserve();
        const20 = TclString.newInstance("parse");
        const20.preserve(); const20.preserve();
        const21 = TclString.newInstance("getstring");
        const21.preserve(); const21.preserve();
        const22 = TclString.newInstance("nameproc_generate");
        const22.preserve(); const22.preserve();
        const23 = TclString.newInstance("TJC::command");
        const23.preserve(); const23.preserve();
        const24 = TclString.newInstance("countnewline");
        const24.preserve(); const24.preserve();
        const25 = TclString.newInstance("\\\n");
        const25.preserve(); const25.preserve();
        const26 = TclString.newInstance("\n#");
        const26.preserve(); const26.preserve();
        const27 = TclString.newInstance("proc");
        const27.preserve(); const27.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;
    WrappedCommand cmdcache9;
    int cmdcache9_cmdEpoch;
    WrappedCommand cmdcache10;
    int cmdcache10_cmdEpoch;
    WrappedCommand cmdcache11;
    int cmdcache11_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                cmdcache9 = TJC.INVALID_COMMAND_CACHE;
                cmdcache9_cmdEpoch = 0;
                cmdcache10 = TJC.INVALID_COMMAND_CACHE;
                cmdcache10_cmdEpoch = 0;
                cmdcache11 = TJC.INVALID_COMMAND_CACHE;
                cmdcache11_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "puts";
                break;
            }
            case 2: {
                cmdName = "descend_get_data";
                break;
            }
            case 3: {
                cmdName = "parse_is_simple_text";
                break;
            }
            case 4: {
                cmdName = "parse_get_simple_text";
                break;
            }
            case 5: {
                cmdName = "parse_is_constant";
                break;
            }
            case 6: {
                cmdName = "parse_get_constant_text";
                break;
            }
            case 7: {
                cmdName = "parseproc_args_ok";
                break;
            }
            case 8: {
                cmdName = "lindex";
                break;
            }
            case 9: {
                cmdName = "error";
                break;
            }
            case 10: {
                cmdName = "parse";
                break;
            }
            case 11: {
                cmdName = "nameproc_generate";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
            case 9: {
                cmdcache9 = lwcmd;
                cmdcache9_cmdEpoch = cmdEpoch;
                break;
            }
            case 10: {
                cmdcache10 = lwcmd;
                cmdcache10_cmdEpoch = cmdEpoch;
                break;
            }
            case 11: {
                cmdcache11 = lwcmd;
                cmdcache11_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "cmdname",
        "_parseproc",
        "debug",
        "script",
        "command_range",
        "tree",
        "nested",
        "num_args",
        "stree",
        "name_result",
        "name",
        "tuple",
        "args",
        "args_text",
        "args_result",
        "body",
        "body_quotes",
        "body_text",
        "body_result",
        "closing_brace_range",
        "fsig",
        "inscript_start",
        "inscript_len",
        "range_start",
        "range_len",
        "before_len",
        "range_before",
        "range_before_string",
        "procname",
        "classname",
        "last_char_index",
        "after_closing_brace_index",
        "post_str",
        "len",
        "post_range",
        "last_char_range",
        "last_char_string",
        "last_char_is_newline",
        "last_char_is_semicolon",
        "r",
        "decl_range",
        "decl_newlines",
        "i"
    };
} // end class ParseprocCommandProcCmd

