// TJC implementation of procedure process_jdk_config
package tjc;
import tcl.lang.*;

public class ProcessJdkConfigCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 5, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 1) {
            throw new TclNumArgsException(interp, 1, objv, "");
        }
        { // Invoke: global _tjc env
            TJC.makeGlobalLinkVar(interp, "_tjc", "_tjc", 0);
            TJC.makeGlobalLinkVar(interp, "env", "env", 1);
        } // End Invoke: global
        { // Invoke: set debug 0
            setVarScalar(interp, "debug", const0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: if {$_tjc(debug)} ...
            TclObject tmp0 = getVarArray(interp, "_tjc", "debug", compiledLocals, 0);
            ExprValue tmp1 = evs0;
            TJC.exprInitValue(interp, tmp1, tmp0);
            boolean tmp2 = tmp1.getBooleanValue(interp);
            if ( tmp2 ) {
                { // Invoke: set debug 1
                    setVarScalar(interp, "debug", const1, compiledLocals, 2);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: if ... ... else ...
            // Binary operator: [...] && [...]
            { // Invoke: info exists env(TJC_LIBRARY)
                TclObject[] objv3 = TJC.grabObjv(interp, 3);
                try {
                    // Arg 0 constant: info
                    objv3[0] = const2;
                    // Arg 1 constant: exists
                    objv3[1] = const3;
                    // Arg 2 constant: env(TJC_LIBRARY)
                    objv3[2] = const4;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv3, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv3, 3);
                }
            } // End Invoke: info
            TclObject tmp4 = interp.getResult();
            ExprValue tmp5 = evs0;
            TJC.exprInitValue(interp, tmp5, tmp4);
            if (tmp5.getBooleanValue(interp)) {
            { // Invoke: info exists env(TJC_BUILD_DIR)
                TclObject[] objv6 = TJC.grabObjv(interp, 3);
                try {
                    // Arg 0 constant: info
                    objv6[0] = const2;
                    // Arg 1 constant: exists
                    objv6[1] = const3;
                    // Arg 2 constant: env(TJC_BUILD_DIR)
                    objv6[2] = const5;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv6, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv6, 3);
                }
            } // End Invoke: info
            TclObject tmp7 = interp.getResult();
            ExprValue tmp8 = evs1;
            TJC.exprInitValue(interp, tmp8, tmp7);
            tmp5.setIntValue(tmp8.getBooleanValue(interp));
            } else {
            tmp5.setIntValue(0);
            } // End if: [...]
            // End Binary operator: &&
            boolean tmp9 = ( tmp5.getIntValue() != 0 );
            if ( tmp9 ) {
                { // Invoke: set jdk_cfg "..."
                    TclObject tmp10;
                    StringBuffer sbtmp11 = new StringBuffer(64);
                    tmp10 = getVarArray(interp, "env", "TJC_BUILD_DIR", compiledLocals, 1);
                    sbtmp11.append(tmp10.toString());
                    sbtmp11.append("/jdk.cfg");
                    tmp10 = TclString.newInstance(sbtmp11);
                    setVarScalar(interp, "jdk_cfg", tmp10, compiledLocals, 3);
                } // End Invoke: set
            } else {
                { // Invoke: set jdk_cfg [...]
                    TclObject tmp12;
                    { // Invoke: file join $_tjc(root) bin jdk.cfg
                        TclObject[] objv13 = TJC.grabObjv(interp, 5);
                        TclObject tmp14;
                        try {
                            // Arg 0 constant: file
                            objv13[0] = const6;
                            // Arg 1 constant: join
                            objv13[1] = const7;
                            // Arg 2 variable: $_tjc(root)
                            tmp14 = getVarArray(interp, "_tjc", "root", compiledLocals, 0);
                            tmp14.preserve();
                            objv13[2] = tmp14;
                            // Arg 3 constant: bin
                            objv13[3] = const8;
                            // Arg 4 constant: jdk.cfg
                            objv13[4] = const9;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv13, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp14 = objv13[2];
                            if ( tmp14 != null ) {
                                tmp14.release();
                            }
                            TJC.releaseObjv(interp, objv13, 5);
                        }
                    } // End Invoke: file
                    tmp12 = interp.getResult();
                    setVarScalar(interp, "jdk_cfg", tmp12, compiledLocals, 3);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            // Binary operator: $debug || $_tjc(...)
            TclObject tmp15 = getVarScalar(interp, "debug", compiledLocals, 2);
            ExprValue tmp16 = evs0;
            TJC.exprInitValue(interp, tmp16, tmp15);
            if (!tmp16.getBooleanValue(interp)) {
            TclObject tmp17 = getVarArray(interp, "_tjc", "progress", compiledLocals, 0);
            ExprValue tmp18 = evs1;
            TJC.exprInitValue(interp, tmp18, tmp17);
            tmp16.setIntValue(tmp18.getBooleanValue(interp));
            } else {
            tmp16.setIntValue(1);
            } // End if: !$debug
            // End Binary operator: ||
            boolean tmp19 = ( tmp16.getIntValue() != 0 );
            if ( tmp19 ) {
                { // Invoke: puts "loading $jdk_cfg"
                    TclObject[] objv20 = TJC.grabObjv(interp, 2);
                    TclObject tmp21;
                    try {
                        // Arg 0 constant: puts
                        objv20[0] = const10;
                        // Arg 1 word: "loading $jdk_cfg"
                        StringBuffer sbtmp22 = new StringBuffer(64);
                        sbtmp22.append("loading ");
                        tmp21 = getVarScalar(interp, "jdk_cfg", compiledLocals, 3);
                        sbtmp22.append(tmp21.toString());
                        tmp21 = TclString.newInstance(sbtmp22);
                        tmp21.preserve();
                        objv20[1] = tmp21;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv20, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        tmp21 = objv20[1];
                        if ( tmp21 != null ) {
                            tmp21.release();
                        }
                        TJC.releaseObjv(interp, objv20, 2);
                    }
                } // End Invoke: puts
            }
        } // End Invoke: if
        { // Invoke: set res [...]
            TclObject tmp23;
            { // Invoke: ... $jdk_cfg
                TclObject[] objv24 = TJC.grabObjv(interp, 2);
                TclObject tmp25;
                try {
                    // Arg 0 constant: ...
                    objv24[0] = const11;
                    // Arg 1 variable: $jdk_cfg
                    tmp25 = getVarScalar(interp, "jdk_cfg", compiledLocals, 3);
                    tmp25.preserve();
                    objv24[1] = tmp25;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                        ? cmdcache4.cmd : null), objv24, 0);
                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                        updateCmdCache(interp, 4);
                    }
                } finally {
                    tmp25 = objv24[1];
                    if ( tmp25 != null ) {
                        tmp25.release();
                    }
                    TJC.releaseObjv(interp, objv24, 2);
                }
            } // End Invoke: ...
            tmp23 = interp.getResult();
            setVarScalar(interp, "res", tmp23, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: [...] == 0
            { // Invoke: lindex $res 0
                TclObject tmp26 = getVarScalar(interp, "res", compiledLocals, 4);
                tmp26 = TclList.index(interp, tmp26, 0);
                if ( tmp26 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp26);
                }
            } // End Invoke: lindex
            TclObject tmp27 = interp.getResult();
            ExprValue tmp28 = evs0;
            TJC.exprInitValue(interp, tmp28, tmp27);
            ExprValue tmp29 = evs1;
            tmp29.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp28, tmp29);
            // End Binary operator: ==
            boolean tmp30 = ( tmp28.getIntValue() != 0 );
            if ( tmp30 ) {
                { // Invoke: puts stderr "..."
                    TclObject[] objv31 = TJC.grabObjv(interp, 3);
                    TclObject tmp32;
                    try {
                        // Arg 0 constant: puts
                        objv31[0] = const10;
                        // Arg 1 constant: stderr
                        objv31[1] = const12;
                        // Arg 2 word: "..."
                        StringBuffer sbtmp33 = new StringBuffer(64);
                        sbtmp33.append("Error loading ");
                        tmp32 = getVarScalar(interp, "jdk_cfg", compiledLocals, 3);
                        sbtmp33.append(tmp32.toString());
                        sbtmp33.append(" : ");
                        { // Invoke: lindex $res 1
                            TclObject tmp34 = getVarScalar(interp, "res", compiledLocals, 4);
                            tmp34 = TclList.index(interp, tmp34, 1);
                            if ( tmp34 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp34);
                            }
                        } // End Invoke: lindex
                        tmp32 = interp.getResult();
                        sbtmp33.append(tmp32.toString());
                        tmp32 = TclString.newInstance(sbtmp33);
                        tmp32.preserve();
                        objv31[2] = tmp32;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv31, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        tmp32 = objv31[2];
                        if ( tmp32 != null ) {
                            tmp32.release();
                        }
                        TJC.releaseObjv(interp, objv31, 3);
                    }
                } // End Invoke: puts
                { // Invoke: return -1
                    interp.resetResult();
                    interp.setResult(const13);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: return 0
            interp.resetResult();
            interp.setResult(const0);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "process_jdk_config");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclInteger.newInstance(0);
        const0.preserve(); const0.preserve();
        const1 = TclInteger.newInstance(1);
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("info");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("exists");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("env(TJC_LIBRARY)");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("env(TJC_BUILD_DIR)");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("file");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("join");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("bin");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("jdk.cfg");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("puts");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("jdk_config_parse_file");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("stderr");
        const12.preserve(); const12.preserve();
        const13 = TclInteger.newInstance(-1);
        const13.preserve(); const13.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "info";
                break;
            }
            case 2: {
                cmdName = "file";
                break;
            }
            case 3: {
                cmdName = "puts";
                break;
            }
            case 4: {
                cmdName = "jdk_config_parse_file";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "_tjc",
        "env",
        "debug",
        "jdk_cfg",
        "res"
    };
} // end class ProcessJdkConfigCmd

